//============================================================================
// J[l
//
// (c)2023 Maikon-Giken
//============================================================================
#include "kernel.h"

//============================================================================
// `.
//============================================================================
// XPW[̑NAۗ.
#define wakeup_schedule()	(NVIC_set_irq(SCHEDULE_IRQ),\
							 NVIC_enable_irq(SCHEDULE_IRQ))
#define reserve_schedule()	(NVIC_enable_irq(SCHEDULE_IRQ))
#define sleep_schedule()	(NVIC_disable_irq(SCHEDULE_IRQ))
#define reffer_schedule()	(!NVIC_enable_check(SCHEDULE_IRQ))
#define SYSTIME_CLOCKED		(1)						// .
#define SYSTIME_CLEARED		(0)						// 񏄉.
#define SYSTIME_ADDVALUE	(TASK_PERIOD * 1000)	// oߎԂsPʂŉZ.

#if BASE_FREQUENCY == 1000000
#define SYSTIME_RATIO		(0)
#elif BASE_FREQUENCY == 2000000
#define SYSTIME_RATIO		(1)
#elif BASE_FREQUENCY == 4000000
#define SYSTIME_RATIO		(2)
#elif BASE_FREQUENCY == 8000000
#define SYSTIME_RATIO		(3)
#elif BASE_FREQUENCY == 16000000
#define SYSTIME_RATIO		(4)
#endif

//============================================================================
// vg^Cv.
//============================================================================
void kernel_schedule(void);
void kernel_timer(void);
void kernel_window_timer(void);

//============================================================================
// f[^.
//============================================================================
TASK_TCB volatile TASK_tcb[TASK_NUMBER_MAX];//^XN(^XNւ̃|C^Cs).
TASK_TCB volatile *TASK_pt;					// s^XN̐ւ̃|C^.
TASK_FLAG volatile TASK_flag;				// ^XNǗtO.
ulonglong volatile systime;					// vZbT.

//============================================================================
// API֐.
//============================================================================
// J[l(J[l^C}N).
void KERNEL_init(void) {

	// ^C}ݒ
	BTIMER_PERI_CMOR = 	(3 << 14) |		// CK3I
						(1 << 11) |		// }X^@\
						(1)		  ;		// JnɊݔ
	BTIMER_WIND_CMOR = 	(3 << 14) |		// CK3I
						(4 << 8)  |		// X[ugK
						(4 << 1)  |		// JEg[hݒ
						(1)		  ;		// 쒆gKL
	
	BTIMER_PERI_CDR = BTIMER_PERIOD;	//ݒ.
	BTIMER_WIND_CDR = BTIMER_WINDOW;	//EChEݒ.
								  
	//^C}̊ݓo^AvCIeBݒ肨ъ݋
	NVIC_set_vector(BTIMER_IRQ, BTIMER_ICH, kernel_timer);
	NVIC_set_priority(BTIMER_IRQ, BTIMER_IPR);			//Dxݒ.
	NVIC_clr_irq(BTIMER_IRQ);							//NVICݗvNA.
	NVIC_enable_irq(BTIMER_IRQ);						//NVIC݋.

	//Window^C}̊ݓo^AvCIeBݒ肨ъ݋
	NVIC_set_vector(BTIMER_WINDOW_IRQ, BTIMER_WINDOW_ICH, kernel_window_timer);
	NVIC_set_priority(BTIMER_WINDOW_IRQ, BTIMER_WINDOW_IPR);	//Dxݒ.
	NVIC_clr_irq(BTIMER_WINDOW_IRQ);							//NVICݗvNA.
	NVIC_enable_irq(BTIMER_WINDOW_IRQ);							//NVIC݋.

	//XPW[̊ݓo^AvCIeBݒ肨ъ݋
	NVIC_set_vector(SCHEDULE_IRQ, SCHEDULE_ICH, kernel_schedule);
	NVIC_set_priority(SCHEDULE_IRQ, SCHEDULE_IPR);		//Dxݒ.
	NVIC_clr_irq(SCHEDULE_IRQ);							//NVICݗvNA.
	NVIC_enable_irq(SCHEDULE_IRQ);						//NVIC݋.

	//^C}Jn
	BTIMER_START_ST |= (1 << BTIMER_PERI_CH) |
					   (1 << BTIMER_WIND_CH) ;

	//CPU݋.
	__EI();
}

//----------------------------------------------------------------------------
// I[o[E^XNID擾.
int refer_error_task(void) {
	int c;
	c = TASK_flag.log - 1;
	TASK_flag.log = 0;
	return c;
}

//---------------------------------------------------------------------
// ԊǗAPI.
//---------------------------------------------------------------------
// oߎԂ̎擾 (58N).
ulonglong KERNEL_time_ll(void) {
	ushort i;
	ulonglong j;
	
	do {
		j = systime;
		i = BTIMER_PERI_CNT;
	} while (j != systime);
	return j + ((BTIMER_PERIOD - i) >> SYSTIME_RATIO);
}
//---------------------------------------------------------------------
// oߎԂ̎擾@(71).
ulong KERNEL_time(void) {
	ushort i;
	ulong j;
	
	do {
		j = systime;
		i = BTIMER_PERI_CNT;
	} while (j != (ulong)systime);
	return j + ((BTIMER_PERIOD - i) >> SYSTIME_RATIO);
}

//---------------------------------------------------------------------
// main֐Ŏ̏҂.
void KERNEL_wait_next_period(void) {
	uint i;
	i = systime;
	while (i == (uint)systime) {
		__halt();
	}
}

//============================================================================
// 又.
//============================================================================
// J[l(񐧌).
#pragma interrupt kernel_schedule(enable=true, channel=49, fpu=true, callt=false)
void kernel_schedule(void) {

	__EI();			// d荞݋.

	//-----------------------------------------------------------------
	// ҂ԊǗ.
	//-----------------------------------------------------------------
	if (TASK_flag.period == SYSTIME_CLOCKED) {
		TASK_flag.period = SYSTIME_CLEARED;
		systime += SYSTIME_ADDVALUE;			// oߎԂ̃JEg.
		
		for (TASK_pt = TASK_tcb; TASK_pt < TASK_tcb + TASK_NUMBER_MAX; TASK_pt++) {
//			__DI();	// D抄荞݂wakeupƂ̊h~ dldelay_task^XNnhwakeup邱Ƃ֎~ƋL.
			if(TASK_pt->flags > TASK_DELAY) TASK_pt->flags--;
//			__EI();
		}
		//-----------------------------------------------------------------
		// EIb`hbOENA.
		//-----------------------------------------------------------------
		WDT_RESTART();
	}
	
	//-----------------------------------------------------------------
	// ^XŇĂяo.
	//-----------------------------------------------------------------
	for (TASK_pt = TASK_tcb; TASK_pt < TASK_tcb + TASK_NUMBER_MAX; TASK_pt++) {
		if (!reffer_schedule()) return;
		if (TASK_pt->flags == TASK_ACTIVE) {
			(TASK_pt->addr)();
		}
		if (TASK_flag.period) {
			TASK_flag.log = (((char*) TASK_pt - (char*) TASK_tcb) >> 3) + 1;
			//I[o[^XN\-P邱.
			return;
		}
	}
}
//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================
// ^C}.
#pragma interrupt kernel_timer(enable=false, channel=15, fpu=false, callt=false)
void kernel_timer(void) {
		TASK_flag.period = SYSTIME_CLOCKED;
		wakeup_schedule();
}

#pragma interrupt kernel_window_timer(enable=false, channel=55, fpu=false, callt=false)
void kernel_window_timer(void) {
		sleep_schedule();
}

//============================================================================
