//============================================================================
// Wo.
//
// (c)2023 Maikon-Giken
//============================================================================
#ifndef STDIO_H
#define	STDIO_H

#define STDIO_VERSION			1	// obt@TCYEt[AI[o[e

//============================================================================
#include <stdarg.h>
#include "common.h"

//============================================================================
// `.
//============================================================================
#define STDIO_USE_PRINTF		// printf, fpritfgpɒ`.
//#define STDIO_USE_SCANF		// scanf, fscanfgpɒ`  sscanfgȂ
#define STDIO_FILES_MAX	  4		// FILE^hCogݐ.
#define STDIO_FNAME_MAX	  8		// FILE^hCu(:܂)̒{P.
#if   STDIO_VERSION == 1
#define STDIO_BUFFER_MAX  256	// to͗pobt@TCYB̃TCYX^bNȂ.
#endif

typedef int (*STDIO_CLOSE_FUNCTION)(void* fp);		// fclose֐p.
typedef void (*STDIO_WAKE_FUNCTION)(void);			// MJnp.

#if   STDIO_VERSION == 1
typedef struct {			// FILE\.
	uchar	*begin;			// OEobt@̈擪ւ̃|C^.
	uchar	*wp;			// ݗp|C^.
	uchar	*rp;			// Ǐop|C^.
	uchar	*cp;			// \nop|C^(gets,fgetsp).
	uchar	*end;			// OEobt@̈I[.
	uchar	rw_mode;		// I[vE[h('\0','r','w').
	uchar	binary;			// oCiE[h('\0','b').
	uchar	code;			// LCDȂp.
	uchar	type;			// LCDȂp.
	STDIO_WAKE_FUNCTION		wake;	// MJn֐ւ̃|C^.
	STDIO_CLOSE_FUNCTION	close;	// N[Y֐ւ̃|C^.
} FILE;
#endif

typedef FILE* (*STDIO_OPEN_FUNCTION)
				(const char *name, const char *mode);	// fopen֐p.

extern FILE *stdin, *stdout;							// Wo.

//============================================================================
// API֐.
//============================================================================
 // hCo(fopenŌĂяo֐)o^.
int		STDIO_set_driver(const char *name,
					STDIO_OPEN_FUNCTION func);

//----------------------------------------------------------------------------
// FILE^Xg[oepn/close
#define fopen			STDIO_fopen
FILE*	STDIO_fopen(const char *name, const char *mode);
#define fclose			STDIO_fclose
int		STDIO_fclose(FILE *fp);

//----------------------------------------------------------------------------
// 1oCgo
#define putchar(c)		STDIO_fputc(c, stdout)
#define getchar()		STDIO_fgetc(stdin)
#define putc(c, fp)		STDIO_fputc(c, fp)
#define getc(fp)		STDIO_fgetc(fp)
#define fputc(c, fp)	STDIO_fputc(c, fp)
#define fgetc(fp)		STDIO_fgetc(fp)
int		STDIO_fputc(int c, FILE *fp);
int		STDIO_fgetc(FILE *fp);

//----------------------------------------------------------------------------
// o.
#define puts(s)			STDIO_puts(s)
#define gets(s)			STDIO_gets(s)	// i[悪stdinobt@TCYȏmۂĂ邱ƁBłȂꍇfgetsgp邱ƁB
int		STDIO_puts(const char *s);
char*	STDIO_gets(char *s);
#define fputs STDIO_fputs
#define fgets STDIO_fgets
int		STDIO_fputs(const char *s, FILE *fp);
char*	STDIO_fgets(char *s, int n, FILE *fp);

//----------------------------------------------------------------------------
// to.
#ifdef	STDIO_USE_PRINTF
#define printf			STDIO_printf
#define fprintf			STDIO_fprintf
#define sprintf			STDIO_sprintf
int		STDIO_printf(const char *s, ...);
int		STDIO_fprintf(FILE *fp, const char *s, ...);
int		STDIO_sprintf(char *wk, const char *s, ...);
int		vsprintf(char *, const char *, va_list);
#else
int		sprintf(char *__restrict, const char *__restrict, ...);
#endif

#ifdef	STDIO_USE_SCANF
#define scanf			STDIO_scanf
#define fscanf			STDIO_fscanf
#define sscanf			STDIO_sscanf
int		STDIO_scanf(const char *s, ...);
int		STDIO_fscanf(FILE *fp, const char *s, ...);
int		STDIO_sscanf(char *wk, const char *s, ...);
int		vsscanf(const char *, const char *, va_list);
#else
int		sscanf(const char *s, const char *format, ...);
#endif

//============================================================================
#endif		/* STDIO_H */
