//============================================================================
// uU[i`gójAfBt^XN
//
// (c)2023 Maikon-Giken
//============================================================================
#include "kernel.h"
#include "task_beep.h"

//============================================================================
// `.
//============================================================================
#define BEEP_ONKAI_MIN	42
#define BEEP_ONKAI_MAX	127

//============================================================================
// vg^Cv.
//============================================================================
void BEEP_main(void);						// BEEP^XN(又).
void BEEP_set(void);						// fB.
void BEEP_timer_start(ushort c);			// `go͂̊Jn/ĊJ.
void BEEP_timer_pause(void);				// `go͂̈ꎞ~.
void BEEP_timer_stop(void);					// `go͂̒~.

//============================================================================
// f[^.
//============================================================================
static struct {
	int status;					// Xe[^X.
	int count;					// ԃJEg.
	int period;					// .
} BEEP_ctrl;
#define BEEP_status BEEP_ctrl.status
#define BEEP_count	BEEP_ctrl.count
#define BEEP_period BEEP_ctrl.period

#define nHYOSHI	9
int				BEEP_hyoshi[nHYOSHI];
ONPU			*BEEP_base;
int				BEEP_rp;
int				BEEP_ichou;
int				BEEP_quiet = 4;
uint			BEEP_time;			// Jn.
uint			BEEP_time_note;		// .
uint			BEEP_time_quiet;	// .
int				BEEP_repcnt[4];		// s[gJE^.
#define BEEP_ADDR(x)	(( *(ushort*)&x >> 1) & 0x7ff)
#define BEEP_RESTART	(mREPLAY_CMD)
#define BEEP_FINISH		(mFINISH_CMD)

const ushort BEEP_onkai[] = {
	                                                               54054, 51020, 48156,
	45454, 42902, 40494, 38222, 36076, 34051, 32140, 30336, 28634, 27026, 25510, 24078,
	22726, 21451, 20247, 19110, 18038, 17025, 16070, 15168, 14316, 13513, 12754, 12038,
	11363, 10725, 10123,  9555,  9018,  8512,  8034,  7583,  7158,  6756,  6377,  6019,
	 5681,  5362,  5061,  4777,  4509,  4256,  4017,  3791,  3578,  3377,  3188,  3009,
	 2840,  2680,  2530,  2388,  2254,  2127,  2008,  1895,  1789,  1688,  1593,  1504,
	 1419,  1340,  1264,  1193,  1126,  1063,  1003,   947,   894,   844,   796,   751,
	  709,   669,   632,   596,   563,   531,   501,   473,   446,   421,   398
};

//============================================================================
// API֐.
//============================================================================
// hCo[`
void BEEP_init(void) {

	//|[gݒ(͓dȂ)
	BEEP_PIN = 0;
	BEEP_PIN_PM = 0;

	//^C}{ݒ
	BEEP_TIMER_CMOR = (2 << 14) ;		//CK2 = 20MHz

	start_task(BEEP_taskid, BEEP_main);
}

//---------------------------------------------------------------------
// BEEPw.
void BEEP_out(int freq, int time) {
	BEEP_period = BEEP_FREQUENCY / freq / 2;	//Zo
	BEEP_count	= time;							//󂯎Ԃ
	BEEP_status = BEEP_REQUEST;					//N
	wakeup_task(BEEP_taskid);
}

//---------------------------------------------------------------------
// tv.
int	BEEP_play(ONPU *p, int offset, int tempo, int ichou) {

	if (BEEP_status) return EOF;
	BEEP_base = p;
	BEEP_rp = offset;
	BEEP_ichou = ichou;
	BEEP_hyoshi[T3L] = (4000 / tempo + 1) * 10000 / 2;		// 3A̒(sP).
	BEEP_hyoshi[T16] = (3000 / tempo + 1) * 10000 / 2;		// 16̒(sP).
	BEEP_hyoshi[T8]	 = BEEP_hyoshi[T16] + BEEP_hyoshi[T16];
	BEEP_hyoshi[T8T] = BEEP_hyoshi[T8]	+ BEEP_hyoshi[T16];
	BEEP_hyoshi[T4]	 = BEEP_hyoshi[T8T] + BEEP_hyoshi[T16];
	BEEP_hyoshi[T4T] = BEEP_hyoshi[T4]	+ BEEP_hyoshi[T8];
	BEEP_hyoshi[T2]	 = BEEP_hyoshi[T4T] + BEEP_hyoshi[T8];
	BEEP_hyoshi[T2T] = BEEP_hyoshi[T2]	+ BEEP_hyoshi[T4];
	BEEP_hyoshi[T1]	 = BEEP_hyoshi[T2T] + BEEP_hyoshi[T4];

	BEEP_status = BEEP_START;
	wakeup_task(BEEP_taskid);
	return 0;
}

//---------------------------------------------------------------------
// t~.
int	BEEP_stop(void) {
	if (!BEEP_status) return EOF;
	BEEP_status = BEEP_STOP;
	wakeup_task(BEEP_taskid);
	return BEEP_rp;
}

//---------------------------------------------------------------------
// Xe[^X擾.
int BEEP_refer(void) {
	return BEEP_status;
}

//============================================================================
// ^XNA又.
//============================================================================
// BEEP^XN(又).
void BEEP_main(void) {
	
	if (BEEP_status == BEEP_REQUEST && BEEP_count > 0) {
		BEEP_TIMER_CDR = BEEP_period - 1;			//CC0ɑ
		BEEP_TIMER_TOE = 1;
		BEEP_PIN_PMC = 1;
		BEEP_TIMER_ST = 1;
		BEEP_status = BEEP_ONGOING;
	}
	else if (BEEP_status == BEEP_ONGOING) {
		if (BEEP_count <= 0) {
			BEEP_status = BEEP_IDLE;
			BEEP_TIMER_TT = 1;
			BEEP_PIN_PMC = 0;
			BEEP_TIMER_TOE = 0;
		}
		else BEEP_count--;
	}
	else if (BEEP_status == BEEP_IDLE) {
		sleep_task();
	}
	else if (BEEP_status == BEEP_START) {
		BEEP_time = KERNEL_time();					// Jnݒ.
		BEEP_set();
	}
	else if (BEEP_status == BEEP_NOTE) {
		// ԊĎ.
		if ( KERNEL_time() - BEEP_time >= BEEP_time_note) {
			BEEP_time += BEEP_time_note;
			if (BEEP_time_quiet) {
				BEEP_timer_pause();
				BEEP_status = BEEP_QUIET;
			}
			else {
				BEEP_rp++;
				BEEP_set();
			}
		}
	}
	else if (BEEP_status == BEEP_QUIET) {
		// ԊĎ.
		if ( KERNEL_time() - BEEP_time >= BEEP_time_quiet) {
			BEEP_time += BEEP_time_quiet;
			BEEP_rp++;
			BEEP_set();
		}
	}
	else if (BEEP_status == BEEP_STOP) {
		BEEP_timer_stop();
		BEEP_status = BEEP_IDLE;
	}
	
	delay_task(10);
}

//============================================================================
// [J֐.
//============================================================================
// fB.
void BEEP_set(void) {
	uint i, j;
	
	while (1) {
		i = BEEP_base[BEEP_rp].cut;

		if (!BEEP_base[BEEP_rp].sys) {	/************* KR[h ***********/
			if (i == QFF) {
				BEEP_timer_pause();
				BEEP_time_quiet = BEEP_hyoshi[ BEEP_base[BEEP_rp].time ];
				BEEP_status = BEEP_QUIET;
			}
			else {
				// ^C}ݒlvZA
				j = BEEP_base[BEEP_rp].note + BEEP_ichou;
				if (j < BEEP_ONKAI_MIN) j = BEEP_ONKAI_MIN;
				else if (j > BEEP_ONKAI_MAX) j = BEEP_ONKAI_MAX;
				j -= BEEP_ONKAI_MIN;
				BEEP_timer_start( BEEP_onkai[j]);

				// ,ԌvZ
				BEEP_time_note = BEEP_hyoshi[ BEEP_base[BEEP_rp].time ];
				if		(i == 0) BEEP_time_quiet = BEEP_quiet;
				else if (i < 5 ) BEEP_time_quiet = (i - 1) * 2;
				else			 BEEP_time_quiet = (i - 4) * (BEEP_time_note / 10);
				BEEP_time_note -= BEEP_time_quiet;
				BEEP_status = BEEP_NOTE;
			}
			return;
		}
		else {	/************************* R[h ***********************/
			if (i == BEEP_RESTART ) {		// X^[g.
				BEEP_rp = 0;
			}
			else if (i == BEEP_FINISH ) {	// I.
				BEEP_timer_stop();
				BEEP_status = BEEP_IDLE;
				return;
			}
			else if (i < 4) {						// JE^Zbg.
				BEEP_repcnt[i] = BEEP_base[BEEP_rp++].note;
			}
			else if ((i -= 4) < 4) {				// ߂萧.
				if (BEEP_repcnt[i]) {
					BEEP_repcnt[i]--;
					BEEP_rp = BEEP_ADDR( BEEP_base[BEEP_rp] );
				}
				else BEEP_rp++;
			}
			else if ((i -= 4) < 4) {				// iݐ.
				if (BEEP_repcnt[i]) {
					BEEP_repcnt[i]--;
					BEEP_rp++;
				}
				else BEEP_rp = BEEP_ADDR( BEEP_base[BEEP_rp] );
			}
		}
	}
}
// `go͂̊Jn/ĊJ.
void BEEP_timer_start(ushort c) {
	BEEP_TIMER_CDR = c;
	BEEP_TIMER_TOE = 1;
	BEEP_PIN_PMC = 1;
	BEEP_TIMER_ST = 1;
}

// `go͂̈ꎞ~.
void BEEP_timer_pause(void) {
	BEEP_TIMER_TT = 1;
	BEEP_PIN_PMC = 0;
	BEEP_TIMER_TOE = 0;
}

// `go͂̒~.
void BEEP_timer_stop(void) {
	BEEP_TIMER_TT = 1;
	BEEP_PIN_PMC = 0;
	BEEP_TIMER_TOE = 0;
}

//============================================================================
// nh.
//============================================================================

//============================================================================
