//============================================================================
// p[^Ǘ^XN(I2C)
//
// (c)2023 Maikon-Giken
//============================================================================
#include "kernel.h"
#include "task_eep_i2c.h"
#include "task_i2c.h"

//============================================================================
// `.
//============================================================================
#define EEP_START_NUM			0x69A5		// .indexl

//============================================================================
// vg^Cv.
//============================================================================
void EEP_main(void);						// ^XN(v҂).
void EEP_load_task(void);					// ^XN(load).
void EEP_load2_task(void);					// ^XN(load҂)
void EEP_save_task(void);					// ^XN(save).
void EEP_save2_task(void);					// ^XN(save҂)

//============================================================================
// f[^.
//============================================================================
EEP_DATA		eep_data;
static uchar	status;			//ݏ.
static schar	flag;			//EEPROMANZX

static const EEP_DATA init_data = {
	EEP_START_NUM, ~EEP_START_NUM,
	{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 

	{0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0}
};

//============================================================================
// API֐.
//============================================================================
// hCo[`
void EEP_init(void) {
	if (EEP_BLOCK_SIZE == sizeof eep_data) {
		status = EEP_STATUS_LOAD;
		start_task(EEP_taskid, EEP_main);
	}
	else while(1);
}

//---------------------------------------------------------------------
int EEP_load(void) {			// p[^ǂݍ.
	if (status != EEP_STATUS_READY)	return status;
	status = EEP_STATUS_LOAD;
	wakeup_task(EEP_taskid);
	return EEP_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int EEP_save(void) {			// p[^ۑ.
	if (status != EEP_STATUS_READY &&
		status != EEP_STATUS_WERROR)	return status;
	status = EEP_STATUS_SAVE;
	wakeup_task(EEP_taskid);
	return EEP_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int EEP_status(void) {			// p[^^ۑ̊mF.
	return status;
}

//============================================================================
// ^XNA又.
//============================================================================
// EEP^XN(又).
void EEP_main(void) {
	
	switch(status) {
		case EEP_STATUS_LOAD:
			set_retry_task();
			next_task(EEP_load_task);
		case EEP_STATUS_SAVE:
			set_retry_task();
			next_task(EEP_save_task);
	}
	sleep_task();
}

//---------------------------------------------------------------------
// ^XN(load).
void EEP_load_task(void) {
	if (I2C_EEP_read(EEP_BLOCK_START, (char*)&eep_data, EEP_BLOCK_SIZE, &flag) != I2C_STATUS_ACCEPT) { retry_task(); }
	
	break_retry_task(EEP_load2_task);
//--------------
//EEP_load2_task
	if (flag != EOF) { retry_task(); }
	
	if (eep_data.index != EEP_START_NUM || 
		eep_data.index != ~eep_data.index_v) {
		eep_data = init_data;
	}

	status = EEP_STATUS_READY;
	next_task(EEP_main);
}

//---------------------------------------------------------------------
// ^XN(save)
void EEP_save_task(void) {
	if (I2C_EEP_write(EEP_BLOCK_START, (char*)&eep_data, EEP_BLOCK_SIZE, &flag) != I2C_STATUS_ACCEPT) { retry_task(); }
	
	break_task(EEP_save2_task);
//--------------
//EEP_save2_task
	if (flag != EOF) { retry_task(); }
	status = EEP_STATUS_READY;
	next_task(EEP_main);
}

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
