//============================================================================
// I2C^XN(EEPANZXt)
//
// (c)2023 Maikon-Giken
//============================================================================
#include "kernel.h"
#include "task_i2c.h"

//============================================================================
// `.
//============================================================================
//#define I2C_MIN_tRISE			70		// ŏオ莞(vAbv+eʂɈˑ) [ns].
//#define I2C_MAX_FREQUENCY		400000	// őNbNg [Hz].
//#define I2C_tHIGH_RATIO			1		// NbNHigh Ԕ䗦(KiKl).
//#define I2C_tLOW_RATIO			2		// NbNLow Ԕ䗦(KiKl).
//#define I2C_CLK_ADD				5		// SAML̃{[[gZl.

//============================================================================
// vg^Cv.
//============================================================================
void I2C_main(void);						// ^XN(R}h҂).
void I2C_init2(void);						// ^XN(Jn).
#if (TARGET_BOARD & RH850KM_CAN5)
void I2C_init3(void);						// ^XN(Jn).
#endif
void I2C_stop_task(void);					//I2C XgbvRfBV쐬.
void I2C_stop2_task(void);                  //I2C Xgbv҂.
void I2C_finish_task(void);
void I2C_EEP_write_task(void);
void I2C_EEP_write2_task(void);
void I2C_EEP_read_task(void);
void I2C_EEP_read2_task(void);
void I2C_EEP_addr_task(void);
void I2C_EEP_addr2_task(void);

void I2C_int_error(void);
void I2C_int_recend0(void);
void I2C_int_recend1(void);
void I2C_int_recend2(void);
void I2C_int_recend3(void);
void I2C_int_sendend(void);
void I2C_int_empty(void);
void I2C_int_empty1(void);
void I2C_int_empty2(void);

//============================================================================
// f[^.
//============================================================================
static uchar	status;						//ݏ.
static char	 I2C_EEP_addr_buff[2];			// EEPROMAhX(Mp).
set_stack_task(1);							// Tu[`pX^bN.
static int   I2C_num;						// f[^].
static int	 I2C_cnt;						// f[^]JEg.
static int   I2C_addr;						// I2CAhX.
static char* I2C_buff;						// f[^Eobt@̃|C^.
static int   I2C_EEP_num;					// EEPROMf[^JEg.
static int   I2C_EEP_addr;					// EEPROMAhX.
static char* I2C_EEP_buff;					// EEPROMf[^Eobt@̃|C^.
static schar* I2C_flag;						// 󋵒ʒmtOւ̃|C^i[.

//============================================================================
// API֐.
//============================================================================
// hCo[`
void I2C_init(void) {
	start_task(I2C_taskid, I2C_init2);
}

//---------------------------------------------------------------------
int I2C_write(int addr, char *buff, int num, schar* flag) {			// f[^݊Jn.
	__DI();
	if (status != I2C_STATUS_READY &&
		status != I2C_STATUS_WERROR)	return status;
	I2C_addr = addr;
	I2C_buff = buff;
	I2C_num = num;
	status = I2C_STATUS_WRITE;
	I2C_flag = flag;
	if (flag != NULL) *I2C_flag = 0;
	__EI();
	wakeup_task(I2C_taskid);
	return I2C_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int I2C_read(int addr, char *buff, int num, schar* flag) {			// f[^ǏoJn.
	__DI();
	if (status != I2C_STATUS_READY)	return status;
	I2C_addr = addr;
	I2C_buff = buff;
	I2C_num = num;
	status = I2C_STATUS_READ;
	I2C_flag = flag;
	if (flag != NULL) *I2C_flag = 0;
	__EI();
	wakeup_task(I2C_taskid);
	return I2C_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int I2C_status(void) {			// R}h̊mF.
	return status;
}

//---------------------------------------------------------------------
int I2C_EEP_write(int addr, char *buff, int num, schar* flag) {			// f[^݊Jn.
	__DI();
	if (status != I2C_STATUS_READY &&
		status != I2C_STATUS_WERROR)	return status;
	I2C_EEP_addr = addr;
	I2C_EEP_buff = buff;
	I2C_EEP_num = num;
	status = I2C_EEP_WRITE;
	I2C_flag = flag;
	if (flag != NULL) *I2C_flag = 0;
	__EI();
	wakeup_task(I2C_taskid);
	return I2C_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int I2C_EEP_read(int addr, char *buff, int num, schar* flag) {			// f[^ǏoJn.
	__DI();
	if (status != I2C_STATUS_READY)	return status;
	I2C_EEP_addr = addr;
	I2C_EEP_buff = buff;
	I2C_EEP_num = num;
	status = I2C_EEP_READ;
	I2C_flag = flag;
	if (flag != NULL) *I2C_flag = 0;
	__EI();
	wakeup_task(I2C_taskid);
	return I2C_STATUS_ACCEPT;
}

//============================================================================
// ^XNA又.
//============================================================================
// ^XN.
void I2C_init2(void) {
	
#if (TARGET_BOARD & RH850KM_CAN5)
	break_delay_task(I2C_init3, 500);
#endif
	int z;

	//I2Cݒ
	//I2C_CR1_ICE = 0;		//ftHg
	I2C_CR1_IICRST = 1;
	I2C_CR1_ICE = 1;
	I2C_MR1 = 1 << 4;		//PCLK/2I
	I2C_BRL = 0xe0 + 31;	//SCL Low
	I2C_BRH = 0xe0 +  2;	//SCL High
	I2C_FER = (1<<6) | (1<<5) | (1<<4);
	I2C_IER = 0xfc;
	I2C_CR1_IICRST = 0;		//Zbg
	
	//|[gݒ.
	z = I2C_PORT_PODC | I2C_PIN_BIT;
	_PROTECT_WRITE(I2C_PORT_PPCMD, I2C_PORT_PODC, z);
	I2C_PORT_PBDC |= I2C_PIN_BIT;
	I2C_PORT_PFC  |= I2C_PIN_BIT;
	I2C_PORT_PMC  |= I2C_PIN_BIT;
	I2C_PORT_PM   &= ~I2C_PIN_BIT;

	//ʐMG[̊ݓo^AvCIeBݒ肨ъ݋
	NVIC_set_vector(I2C_ERR_IRQ, I2C_ERR_ICH, I2C_int_error);
	NVIC_set_priority(I2C_ERR_IRQ, I2C_ERR_IPR);		//Dxݒ.
	NVIC_clr_irq(I2C_ERR_IRQ);							//NVICݗvNA.
	NVIC_disable_irq(I2C_ERR_IRQ);						//NVICݕs.

	//MI̊ݓo^AvCIeBݒ肨ъ݋
	NVIC_set_vector(I2C_REC_IRQ, I2C_REC_ICH, I2C_int_recend0);
	NVIC_set_priority(I2C_REC_IRQ, I2C_REC_IPR);		//Dxݒ.
	NVIC_clr_irq(I2C_REC_IRQ);							//NVICݗvNA.
	NVIC_disable_irq(I2C_REC_IRQ);						//NVICݕs.

	//MI̊ݓo^AvCIeBݒ肨ъ݋
	NVIC_set_vector(I2C_SEND_IRQ, I2C_SEND_ICH, I2C_int_sendend);
	NVIC_set_priority(I2C_SEND_IRQ, I2C_SEND_IPR);		//Dxݒ.
	NVIC_clr_irq(I2C_SEND_IRQ);							//NVICݗvNA.
	NVIC_disable_irq(I2C_SEND_IRQ);						//NVICݕs.

	//obt@󂫂̊ݓo^AvCIeBݒ肨ъ݋
	NVIC_set_vector(I2C_EMPT_IRQ, I2C_EMPT_ICH, I2C_int_empty);
	NVIC_set_priority(I2C_EMPT_IRQ, I2C_EMPT_IPR);		//Dxݒ.
	NVIC_clr_irq(I2C_EMPT_IRQ);							//NVICݗvNA.
	NVIC_disable_irq(I2C_EMPT_IRQ);						//NVICݕs.

	//ÔSTOPJn(WDTZbgȂǂLɗ܂܂̏ꍇl)
//	I2C_CR2_SP = 1;
//	call_task(I2C_stop_task, I2C_finish_task);
	status = I2C_STATUS_READY;
	next_task(I2C_main);
}

//---------------------------------------------------------------------
// ^XN(R}h).
void I2C_main(void) {
	
	set_sleep_task();
	switch(status) {
		case I2C_STATUS_WRITE:
			I2C_SR2_NACKF = 0;
			if (I2C_CR2_BBSY) { retry_task(); }
			NVIC_chg_vector(I2C_EMPT_ICH, I2C_int_empty);
			I2C_cnt = 0;
			I2C_CR2_ST = 1;
			I2C_SEND_REG = I2C_addr << 1;
			NVIC_enable_irq(I2C_EMPT_IRQ);					//M݂̒Ńf[^M{
			call_task(I2C_stop_task, I2C_finish_task);
		case I2C_STATUS_READ:
			NVIC_clr_irq(I2C_REC_IRQ);
			if (I2C_CR2_BBSY) { retry_task(); }
			I2C_MR3_RDRFS = 0;
			I2C_CR2_ST = 1;
			NVIC_chg_vector(I2C_REC_ICH, I2C_int_recend0);
			I2C_cnt = 0;
			I2C_SEND_REG = (I2C_addr << 1) + 1;
			NVIC_enable_irq(I2C_REC_IRQ);					//M݂̒Ńf[^M{
			call_task(I2C_stop_task, I2C_finish_task);
		case I2C_EEP_WRITE:
			set_retry_task();
			next_task(I2C_EEP_write_task);
		case I2C_EEP_READ:
			set_retry_task();
			next_task(I2C_EEP_read_task);
	}
}

//---------------------------------------------------------------------
//IIC XgbvRfBVmF
void I2C_stop_task(void) {
	if (!I2C_SR2_STOP) { retry_task(); }
	I2C_SR2_NACKF = 0;
	I2C_SR2_STOP = 0;
	set_delay_task(5);
	return_task();
}

// R}hI.
void I2C_finish_task(void) {
	status = I2C_STATUS_READY;
	if (I2C_flag != NULL) *I2C_flag = EOF;
	I2C_flag = NULL;
	next_task(I2C_main);
}

//---------------------------------------------------------------------
// EEP AhXݒ^XN.
void I2C_EEP_addr_task(void) {

	set_sleep_task();
    I2C_addr = I2C_ADDR_EEPROM << 1;
	if (I2C_EEP_addr & (1 << 16)) I2C_addr += 2;
	if (I2C_EEP_addr & (1 << 17)) I2C_addr += 4;
	if (I2C_EEP_addr & (1 << 18)) I2C_addr += 8;
	
	NVIC_chg_vector(I2C_EMPT_ICH, I2C_int_empty1);
	I2C_EEP_addr_buff[0] = I2C_EEP_addr >> 8;
	I2C_EEP_addr_buff[1] = I2C_EEP_addr;
	I2C_buff = I2C_EEP_addr_buff;
	I2C_num = 2;
	I2C_cnt = 0;
	I2C_CR2_ST = 1;
	while (!I2C_SR2_START);
//	I2C_SEND_REG = I2C_addr;					//AhX̓Vtgς
	NVIC_set_irq(I2C_EMPT_IRQ);	
	NVIC_enable_irq(I2C_EMPT_IRQ);				//EEPAhX2oCgM
	
	break_task(I2C_EEP_addr2_task);
//------------------
//I2C_EEP_addr2_task
    I2C_buff = I2C_EEP_buff;
    if (status == I2C_EEP_WRITE)
        	I2C_num = I2C_PAGE_SIZE - (I2C_EEP_addr & (I2C_PAGE_SIZE - 1));
    else    I2C_num = I2C_EEP_num;
    
    if (I2C_num > I2C_EEP_num) I2C_num = I2C_EEP_num;
    I2C_EEP_num -= I2C_num;
    I2C_EEP_addr += I2C_num;
    I2C_EEP_buff += I2C_num;
	I2C_cnt = 0;

	set_retry_task();
	return_task();				//߂ŏ݂ǂݏôǂ炩s
}

//---------------------------------------------------------------------
// ^XN(EEPROMCg).
void I2C_EEP_write_task(void) {
	
	set_retry_task();
	if (I2C_EEP_num <= 0) {
		next_task(I2C_finish_task);
	}
	
	break_call_task(I2C_EEP_addr_task, I2C_EEP_write2_task);
//-------------------
//I2C_EEP_write2_task
	set_sleep_task();
	NVIC_chg_vector(I2C_EMPT_ICH, I2C_int_empty);
	I2C_cnt++;
	I2C_SEND_REG = *I2C_buff++;
	NVIC_enable_irq(I2C_EMPT_IRQ);					//M݂̒Ńf[^M{
	call_task(I2C_stop_task, I2C_EEP_write_task);
}

//---------------------------------------------------------------------
// ^XN(EEPROM[h).
void I2C_EEP_read_task(void) {
	
	set_retry_task();
	if (I2C_EEP_num <= 0) {
		next_task(I2C_finish_task);
	}
	
	break_call_task(I2C_EEP_addr_task, I2C_EEP_read2_task);
//------------------
//I2C_EEP_read2_task
	if (!I2C_SR2_TEND){ retry_task(); }
	set_sleep_task();
	NVIC_clr_irq(I2C_REC_IRQ);
	I2C_SR2_START = 0;
	I2C_MR3_RDRFS = 0;
	I2C_CR2_RS = 1;
	while (!I2C_SR2_START);
	NVIC_chg_vector(I2C_REC_ICH, I2C_int_recend0);
	I2C_cnt = 0;
	I2C_SEND_REG = I2C_addr + 1;					//AhX̓Vtgς
//	while(!I2C_SR2_RDRF);
	NVIC_enable_irq(I2C_REC_IRQ);					//M݂̒Ńf[^M{
	call_task(I2C_stop_task, I2C_EEP_read_task);
}


//============================================================================
// [J֐.
//============================================================================


//============================================================================
// nh.
//============================================================================
#pragma interrupt I2C_int_recend0(enable=true, channel=78, fpu=false, callt=false)
void I2C_int_recend0(void) {		// [hR}hM̃_~[[h

	if (I2C_num > 2) {
		NVIC_chg_vector(I2C_REC_ICH, I2C_int_recend1);
	}
	else {
		I2C_MR3_WAIT = 1;
		if (I2C_num == 2) {
			NVIC_chg_vector(I2C_REC_ICH, I2C_int_recend2);
		}
		else {
			I2C_MR3_RDRFS = 1;
			I2C_MR3_ACKWP = 1;
			I2C_MR3_ACKBT = 1;
			NVIC_chg_vector(I2C_REC_ICH, I2C_int_recend3);
		}
	}
	*I2C_buff = I2C_RECV_REG;
}

#pragma interrupt I2C_int_recend1(enable=true, channel=78, fpu=false, callt=false)
void I2C_int_recend1(void) {		//ŏIoCg2O[hł΁ANACKݒł悤WAITݒ
	if (I2C_cnt == I2C_num - 2) {
		I2C_MR3_WAIT = 1;
		NVIC_chg_vector(I2C_REC_ICH, I2C_int_recend2);
	}
	*I2C_buff++ = I2C_RECV_REG;
	I2C_cnt++;
}

#pragma interrupt I2C_int_recend2(enable=true, channel=78, fpu=false, callt=false)
void I2C_int_recend2(void) {		//ŏIoCg1O[h(NACK悤ɐݒ)
	I2C_MR3_RDRFS = 1;
	I2C_MR3_ACKWP = 1;
	I2C_MR3_ACKBT = 1;
	NVIC_chg_vector(I2C_REC_ICH, I2C_int_recend3);
	*I2C_buff++ = I2C_RECV_REG;
	I2C_cnt++;
}

#pragma interrupt I2C_int_recend3(enable=true, channel=78, fpu=false, callt=false)
void I2C_int_recend3(void) {		//ŏIoCg[h(NACK)
	I2C_SR2_STOP = 0;
	I2C_CR2_SP   = 1;
	*I2C_buff++ = I2C_RECV_REG;
	I2C_cnt++;
	I2C_MR3_WAIT = 0;
	NVIC_disable_irq(I2C_REC_IRQ);
	wakeup_task(I2C_taskid);
}

#pragma interrupt I2C_int_empty(enable=false, channel=76, fpu=false, callt=false)
void I2C_int_empty(void) {		//obt@ɋ󂫂΃f[^M(ŏIf[^݌͑MmFs)
	
	if (I2C_cnt < I2C_num) { 
		I2C_SEND_REG = *I2C_buff++;
		I2C_cnt++;
	}
	else {
		NVIC_disable_irq(I2C_EMPT_IRQ);
		NVIC_enable_irq(I2C_SEND_IRQ);
	}
}

#pragma interrupt I2C_int_empty1(enable=false, channel=76, fpu=false, callt=false)
void I2C_int_empty1(void) {		//EEPROM̃AhXMp(f[^M܂͎MR}hp)
	
	NVIC_chg_vector(I2C_EMPT_ICH, I2C_int_empty2);
	I2C_SEND_REG = I2C_addr;			// Vtgς݂̃AhX
}

#pragma interrupt I2C_int_empty2(enable=false, channel=76, fpu=false, callt=false)
void I2C_int_empty2(void) {		//EEPROM̃AhXMp(f[^M܂͎MR}hp)
	
	if (I2C_cnt < I2C_num) { 
//		I2C_SR2_TEND = 0;
		I2C_SEND_REG = *I2C_buff++;
		I2C_cnt++;
	}
	else {
		NVIC_disable_irq(I2C_EMPT_IRQ);
		wakeup_task(I2C_taskid);
	}
}

#pragma interrupt I2C_int_sendend(enable=false, channel=79, fpu=false, callt=false)
void I2C_int_sendend(void) {	//ŏIoCg̓]mF
	
	I2C_SEND_TEND = 0;
	I2C_SR2_STOP = 0;
	I2C_CR2_SP = 1;
	NVIC_disable_irq(I2C_SEND_IRQ);
	wakeup_task(I2C_taskid);
}

#pragma interrupt I2C_int_error(enable=true, channel=77, fpu=false, callt=false)
void I2C_int_error(void) {	//ŏIoCg̓]mF
	status = I2C_STATUS_ERROR;
}
//============================================================================
