//============================================================================
// LED_Ń^XN
//
// (c)2023 Maikon-Giken
//============================================================================
#include "kernel.h"
#include "task_led.h"

//============================================================================
// `.
//============================================================================
#ifndef LED0_ON_LEVEL
#define LED0_ON_LEVEL	0
#define LED0_OFF_LEVEL	1
#endif
#ifndef LED1_ON_LEVEL
#define LED1_ON_LEVEL	0
#define LED1_OFF_LEVEL	1
#endif
#ifndef LED2_ON_LEVEL
#define LED2_ON_LEVEL	0
#define LED2_OFF_LEVEL	1
#endif
#ifndef LED3_ON_LEVEL
#define LED3_ON_LEVEL	0
#define LED3_OFF_LEVEL	1
#endif
enum LED_API {
	LED_API_OFF,
	LED_API_ON
};

//============================================================================
// vg^Cv.
//============================================================================
void LED_main(void);						// _Ń^XN(又).
void LED_set_on(int ch);					// LED_.
void LED_set_off(int ch);					// LED.

//============================================================================
// f[^.
//============================================================================
static uchar LED_mode[LED_NUMBER];					// 샂[h.
static uchar LED_ontime[LED_NUMBER];				// _.
static uchar LED_offtime[LED_NUMBER];				// .
static uchar LED_count[LED_NUMBER];					// ԃJEg.
static uchar LED_request[LED_NUMBER];				// vtO.

//============================================================================
// API֐.
//============================================================================
// LED_Ŏw.
void LED_blink(int ch, int mode, int ontime, int offtime) {
	if (ch < LED_NUMBER) {
		LED_request[ch] = LED_API_ON;
		LED_mode[ch] = mode;
		LED_ontime[ch] = ontime - 1;
		LED_offtime[ch] = offtime - 1;
	}	
}

//---------------------------------------------------------------------
// LED_ŏԎ擾.
int LED_blink_status(int ch) {
	if (ch < LED_NUMBER) return LED_mode[ch];
	return 0;
}

//---------------------------------------------------------------------
// LEDԎ擾.
int LED_status(int ch) {
	switch (ch)	{
		case LED_CH0:
			return (LED0_PIN == LED0_ON_LEVEL);
		case LED_CH1:
			return (LED1_PIN == LED1_ON_LEVEL);
		case LED_CH2:
			return (LED2_PIN == LED2_ON_LEVEL);
		case LED_CH3:
			return (LED3_PIN == LED3_ON_LEVEL);
	}
	return 0;
}

//---------------------------------------------------------------------
// hCo[`.
void LED_init(void) {
	//o͏lݒ
	LED0_PIN = LED0_OFF_LEVEL;
	LED1_PIN = LED0_OFF_LEVEL;
	LED2_PIN = LED0_OFF_LEVEL;
	LED3_PIN = LED0_OFF_LEVEL;

	//o͕ݒ
	LED0_PM = PORT_MODE_OUT;
	LED1_PM = PORT_MODE_OUT;
	LED2_PM = PORT_MODE_OUT;
	LED3_PM = PORT_MODE_OUT;

	//^XNN
	start_task(LED_taskid, LED_main);
}

//============================================================================
// ^XNA又.
//============================================================================
// _Ń^XN(又).
void LED_main(void) {
	uchar ch;

	for (ch = 0; ch < LED_NUMBER; ch++) {
		if (LED_request[ch] == LED_API_ON) {
			LED_set_off(ch);
			LED_count[ch] = 0;
			LED_request[ch] = LED_API_OFF;
		}
		
		if (LED_status(ch))	{
			if (LED_mode[ch] == LED_MODE_OFF) LED_set_off(ch);
			else if (LED_mode[ch] < LED_MODE_ON) {
				if (LED_count[ch] > 0) LED_count[ch]--;
				else {
					LED_set_off(ch);
					if (LED_mode[ch] < LED_MODE_LOOP) LED_mode[ch]--;
					if (LED_mode[ch] > 0)  LED_count[ch] = LED_offtime[ch];
				}
			}
		}
		else {
			if (LED_mode[ch] == LED_MODE_ON) LED_set_on(ch);
			else if (LED_mode[ch] > LED_MODE_OFF) {
				if (LED_count[ch] > 0) LED_count[ch]--;
				else {
					LED_set_on(ch);
					LED_count[ch] = LED_ontime[ch];
				}
			}
		}
	}
	
	delay_task(10);
}

//============================================================================
// [J֐.
//============================================================================
// LED_.
void LED_set_on(int ch) {
	switch (ch)	{
		case LED_CH0:
			LED0_PIN = LED0_ON_LEVEL;
			return;
		case LED_CH1:
			LED1_PIN = LED0_ON_LEVEL;
			return;
		case LED_CH2:
			LED2_PIN = LED0_ON_LEVEL;
			return;
		case LED_CH3:
			LED3_PIN = LED0_ON_LEVEL;
			return;
	}
	return;
}

//---------------------------------------------------------------------
// LED.
void LED_set_off(int ch)	 {
	switch (ch) {
		case LED_CH0:
			LED0_PIN = LED0_OFF_LEVEL;
			return;
		case LED_CH1:
			LED1_PIN = LED0_OFF_LEVEL;
			return;
		case LED_CH2:
			LED2_PIN = LED0_OFF_LEVEL;
			return;
		case LED_CH3:
			LED3_PIN = LED0_OFF_LEVEL;
			return;
	}
	return;
}

//============================================================================
// nh.
//============================================================================

//============================================================================
