//============================================================================
// foCXiWX^ANbNj
//
// (c)2023 Maikon-Giken
//============================================================================
#include "common.h"
#include "device.h"

//============================================================================
// `.
//============================================================================
extern uint stackchk;						// bootup.asmŒ`
extern uint stacktop;						// bootup.asmŒ`
extern uint stackend;						// bootup.asmŒ`
#define DEVICE_EIINT_MAX	(384 & 0xff80)	// e[uQƊݐ(128P)
#define DEVICE_SYSCALL_MAX	(128 & 0xff80)	// VXeR[(128P,256max)
#define DEVICE_STACK_PATT	(0xa5693c1e)	// X^bNʒpp^[.

//============================================================================
// vg^Cv.
//============================================================================

//============================================================================
// f[^.
//============================================================================
static ulong DEVICE_reset_code;				// Zbgvۑp(Ô).

#pragma section r0_disp32 "EIINTTBL"
static void* DEVICE_int_vectors[DEVICE_EIINT_MAX];		// ݃xN^(e[uQƕ)
static void* DEVICE_call_vectors[DEVICE_SYSCALL_MAX];	// VXeR[ExN^
#pragma section default

//============================================================================
// API֐.
//============================================================================
//WX^ANbN.
void DEVICE_init(void) {
	volatile uint z;
	uint *p, *q;

	//------------------------------------------------------------------------
	// Zbgvۑ(Ô).
	//------------------------------------------------------------------------
	DEVICE_reset_code = RESCTL.RESF;

	//------------------------------------------------------------------------
	// xN^Ee[uo^ (CPUWX^ݒ)
	//------------------------------------------------------------------------
	__ldsr_rh(4, 1, (uint)DEVICE_int_vectors);		// INTBPWX^ݒ
	__ldsr_rh(11, 1, DEVICE_SYSCALL_MAX);			// SCCFGWX^ݒ
	__ldsr_rh(12, 1, (uint)DEVICE_call_vectors);	// SCBPWX^ݒ
	
	//------------------------------------------------------------------------
	// FPUݒAV850݊ݒ (CPUWX^ݒ)
	//------------------------------------------------------------------------
	// FPU
	#if 1
		z = __stsr_rh(6, 1);				// PIDWX^ǎ
		if (z & (1 << 9)) {					// FPUmF
			z = __stsr_rh(5, 0);			// PSWWX^ǎ
			z |= 1 << 16;
			__ldsr_rh(5, 0, z);				// PSWWX^
//			__ldsr_rh(6, 0, (1 << 17));		// FPSRWX^(Zbg1ɂȂ)
			__ldsr_rh(7, 0, 0);				// FPEPCWX^(Ô߃NA)
		}
		__syncp();
	#endif
	
	// V850݊ݒ
	#if 0
		__ldsr_rh(5, 1, 3);					// MCTLWX^
	#endif
	

	//------------------------------------------------------------------------
	// NbNݒ
	//------------------------------------------------------------------------

	//------------------------------------------------------------------------
	// Main OSCݒ 
#define MOSCM_MODE (0)						// 0:U[h(default), 1:O
#if MOSCM_MODE > 0
	CLKCTL.MOSCM = MOSCM_MODE;
#endif
#define MOSCC_MODE (2)						// 0:24MHz(default), 1:20MHz, 2:16MHz, 3:8MHz
#if MOSCC_MODE > 0
	CLKCTL.MOSCC |= MOSCC_MODE;
#endif
	#define MOSCST_TIME		2200			// U莞(usP),default=2200
#if MOSCST_TIME != 2200
	CLKCTL.MOSCST = MOSCST_TIME * 8;
#endif
#define MOSCSTPM_MODE	(1)					// 0:standby~(default), 1:p
#if MOSCSTPM_MODE > 0
	CLKCTL.MOSCSTPM |= MOSCSTPM_MODE;
#endif
	_PROTECT_WRITE(WPROTR.PROTCMD0,CLKCTL.MOSCE, 1);	// 1:Main OSCN
	while (!(CLKCTL.MOSCS & 4)) __nop();				// N҂
	
	//------------------------------------------------------------------------
	// HSintOSCݒ 
//	CLKCTL.ROSCSTPM |= 0;					// 0:standby~(default), 1:p

	//------------------------------------------------------------------------
	// PLL1ݒ
#define PLL1IS_CTL_MODE	(1)				// 1:MainOSCgp(default), 2: HSinOSCgp
#if PLL1IS_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_PLL1IS_CTL, PLL1IS_CTL_MODE);	// ݒ
	while ((CLKCTL.CKSC_PLL1IS_ACT & 3) != PLL1IS_CTL_MODE) __nop();	// ؑւ҂
#endif
#define PLL1C_PARA		((1 << 11) | 59)								// 16MHz120MHz
	CLKCTL.PLL1C = (CLKCTL.PLL1C & ~((3 << 11)|(0x3f))) | PLL1C_PARA;	// ݒ
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.PLL1E ,1);					// 1:PLL1N
	while (!(CLKCTL.PLL1S & 4)) __nop();								// N҂
	
	//------------------------------------------------------------------------
	// PPLLCLKݒ
#define	PPLLCLKS_CTL_MODE	(3)						// 1:EMCLK(default), 2:MainOSC, 3:PLL1
#if PPLLCLKS_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_PPLLCLKS_CTL, PPLLCLKS_CTL_MODE);	// ݒ
	while ((CLKCTL.CKSC_PPLLCLKS_ACT & 3) != PPLLCLKS_CTL_MODE) __nop();	// ؑւ҂
#endif

	//------------------------------------------------------------------------
	// CPUNbNݒ
#define	CPUCLKS_CTL_MODE	(3)				// 1:EMCLK(default), 2:MainOSC, 3:PLL1
#if CPUCLKS_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_CPUCLKS_CTL, CPUCLKS_CTL_MODE);	// ݒ
	while ((CLKCTL.CKSC_CPUCLKS_ACT & 3) != CPUCLKS_CTL_MODE) __nop();	// ؑւ҂
#endif
#define	CPUCLKD_CTL_MODE	((2 << 3)|(1 << 0))							// 120MHzݒ, 1:80MHz(default)
#if CPUCLKD_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_CPUCLKD_CTL, CPUCLKD_CTL_MODE);	// ݒ
	while (CLKCTL.CKSC_CPUCLKD_ACT != CPUCLKD_CTL_MODE) __nop();		// ؑւ҂
#endif

	//------------------------------------------------------------------------
	// EIb`hbNA0ݒ
	// LSintOSC(240kHz)128(default)̂܂
	// standby~(default)̂܂
	
	//------------------------------------------------------------------------
	// TAUJNbNݒ
	// gp(default̂܂)
	
	//------------------------------------------------------------------------
	// RTCANbNݒ
	// gp(default̂܂)
	
	//------------------------------------------------------------------------
	// ADCNbNݒ
#define	AADCAS_CTL_MODE	(3)					// 1:HSintOSC(default), 2:MainOSC, 3:PPLLCLK2
#if AADCAS_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD0, CLKCTL.CKSC_AADCAS_CTL, AADCAS_CTL_MODE);	// ݒ
	while (CLKCTL.CKSC_AADCAS_ACT != AADCAS_CTL_MODE) __nop();		// ؑւ҂
#endif
#define	AADCAD_CTL_MODE	(1)											// 1:1/1(default), 2:1/2
#if AADCAD_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD0, CLKCTL.CKSC_AADCAD_CTL, AADCAD_CTL_MODE);	// ݒ
	while (CLKCTL.CKSC_AADCAD_ACT != AADCAD_CTL_MODE) __nop();		// ؑւ҂
#endif
//	CLKCTL.CKSC_AADCAD_STPM |= 0;			// 0:standby~(default), 1:p
	
	//------------------------------------------------------------------------
	// UART,LINNbNݒ
#define	ILINS_CTL_MODE	(1)					// 1:PPLLCLK2(default), 2:MainOSC, 3:PPLLCLK2, 4:HSintOSC
#if ILINS_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_ILINS_CTL, ILINS_CTL_MODE);	// ݒ
	while (CLKCTL.CKSC_ILINS_ACT != ILINS_CTL_MODE) __nop();		// ؑւ҂
#endif
#define	ILIND_CTL_MODE	(1)											// 1:1/1(default), 2:1/4, 3:1/8
#if ILIND_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_ILIND_CTL, ILIND_CTL_MODE);	// ݒ
	while (CLKCTL.CKSC_ILIND_ACT != ILIND_CTL_MODE) __nop();		// ؑւ҂
#endif
//	CLKCTL.CKSC_ILIND_STPM |= 0;			// 0:standby~(default), 1:p
	
	//------------------------------------------------------------------------
	// CANNbNݒ
#define	ICANS_CTL_MODE	(3)					// 1:MainOSC, 2:PPLLCLK, 3:PPLLCLK(default)
#if ICANS_CTL_MODE != 3
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_ICANS_CTL, ICANS_CTL_MODE);	// ݒ
	while (CLKCTL.CKSC_ICANS_ACT != ICANS_CTL_MODE) __nop();		// ؑւ҂
#endif
//	CLKCTL.CKSC_ICANS_STPM |= 0;			// 0:standby~(default), 1:p
#define	ICANOSCD_CTL_MODE	(1)				// 0:(default), 1:MainOSC, 2:MainOSC/2
#if ICANOSCD_CTL_MODE > 0
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_ICANOSCD_CTL, ICANOSCD_CTL_MODE);	// ݒ
	while (CLKCTL.CKSC_ICANOSCD_ACT != ICANOSCD_CTL_MODE) __nop();		// ؑւ҂
#endif
	
	//------------------------------------------------------------------------
	// CSINbNݒ
#define	ICSIS_CTL_MODE	(1)					// 0:, 1:PPLLCLK(default), 2:PPLLCLK, 3:MainOSC, 4:HSintOSC
#if ICSIS_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_ICSIS_CTL, ICSIS_CTL_MODE);	// ݒ
	while (CLKCTL.CKSC_ICSIS_ACT != ICSIS_CTL_MODE) __nop();		// ؑւ҂
#endif

	//------------------------------------------------------------------------
	// I2CNbNݒ
#define	IIICS_CTL_MODE	(1)					// 0:, 1:PPLLCLK2(default), 2:PPLLCLK2
#if IIICS_CTL_MODE != 1
	_PROTECT_WRITE(WPROTR.PROTCMD1, CLKCTL.CKSC_IIICS_CTL, IIICS_CTL_MODE);	// ݒ
	while (CLKCTL.CKSC_IIICS_ACT != IIICS_CTL_MODE) __nop();		// ؑւ҂
#endif

	//------------------------------------------------------------------------
	// 
    z = CLKCTL.CKSC_CPUCLKS_CTL;
    __syncp();

	//------------------------------------------------------------------------
	// |[gݒ()
	//------------------------------------------------------------------------
	//
	// JP0_3, JP0_4Lɂɂ́AIvVoCgOPJTAG[1:0]=01ݒ̂
	
	
	//------------------------------------------------------------------------
	// ^C}ݒ()
	//------------------------------------------------------------------------
	// TAUD0ʐݒ@(CK0=default, CK1=default, CK2=20MHz, CK3=1MHz)
	TAUD0.TPS = (0x0f)      |		// CK0 sgp
				(0x0f << 4) |		// CK1 sgp
				(0x02 << 8) |		// CK2 4  20MHz
				(0x03 << 12);		// CK3_PRE 8  10MHz
	TAUD0.BRS = 9;					// CK3 10  1MHz
	
	//------------------------------------------------------------------------
	// X[vE[hݒ.
	//------------------------------------------------------------------------

	//------------------------------------------------------------------------
	// EIb`hbOJn.
	//------------------------------------------------------------------------
	// IvVoCg WDT0_0=1(L), WDT_[2:0]=2(1b)ɐݒ̂
	WDT_RESTART();
	
	//------------------------------------------------------------------------
	// X^bN̈揉(ʒp, 64byte min.).
	//------------------------------------------------------------------------
#if DEVICE_STACK_PATT > 0
	p = &stackend;
	q = &stackchk;
	while (p < q) *p++ = DEVICE_STACK_PATT;
#endif
}

//----------------------------------------------------------------------------
// X^bNʎ擾(64byte min.).
#if DEVICE_STACK_PATT > 0
int	 DEVICE_stack(void) {
	uint *p, *q;
	p = &stackend;
	q = &stackchk;
	while (*p == DEVICE_STACK_PATT && p++ < q);
	return (char*)&stacktop - (char*)p;
}
#endif

//----------------------------------------------------------------------------
// EIb`hbOEZbgo(EOF:o).
int	 DEVICE_det_wdt(void){
	if (DEVICE_reset_code & WDT_RESETFLAG) return EOF;
	return 0;
}

//----------------------------------------------------------------------------
// ݃xN^o^ (EOF:o^ł)
int DEVICE_set_vector(__ICREG* irq, int ch, void* p) {
	if (ch < DEVICE_EIINT_MAX) {
		DEVICE_int_vectors[ch] = p;
		irq->TB = 1;
	}
	else return EOF;
	return 0;
}

//----------------------------------------------------------------------------
// ݃xN^ύX (EOF:o^ł)
int DEVICE_chg_vector(int ch, void* p) {
	if (ch < DEVICE_EIINT_MAX) {
		DEVICE_int_vectors[ch] = p;
	}
	else return EOF;
	return 0;
}

//----------------------------------------------------------------------------
// SYSCALL֐o^ (EOF:ݒł)
int DEVICE_set_syscall(int ch, void* p) {
	if (ch < DEVICE_SYSCALL_MAX) 	DEVICE_call_vectors[ch] = p;
	else return EOF;
	return 0;
}
//============================================================================
// ^XNA又.
//============================================================================

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
