//============================================================================
// foCXi|[gAӁjt`pwb_.
//
// (c)2023 Maikon-Giken
//============================================================================
#ifndef DEVICE_H
#define	DEVICE_H

#include "iodefine.h"

//============================================================================
// LCDI.
//============================================================================
#include "board.h"
#define TARGET_BOARD	RH850KM_CAN5
#define TARGET_LCD		LCD_TYPE_SG12864
//#define TARGET_LCD		LCD_TYPE_AQM1248

//============================================================================
// ^C~O{`.
//============================================================================
#define PPLLCLK_FREQ	(80000000)			// ӃNbN
#define PPLLCLK2_FREQ	(PPLLCLK_FREQ/2)	// ӃNbN(2)
#define BASE_FREQUENCY	(1000000)			// ^C}̃JEgNbN
#define PWM_FREQUENCY	(20000000)			// PWM̓NbN
#define BEEP_FREQUENCY	(20000000)			// uU[p̓NbN
#define ADC_FREQUENCY	(PPLLCLK2_FREQ)		// ADCpNbN
#define TASK_PERIOD		(5)					// ^XNpBmsPʁB1, 2, 5, 10̂ꂩ.
#define TASK_WINDOW		(80)				// ^XNĎԁBɑ΂1%PʂŎwB1-100̂ꂩ.
#define CLOCKS_PER_SEC	(1000/TASK_PERIOD)

//============================================================================
// \[X蓖.
//============================================================================
/*
 * TAUD0ch0		sgp
 * TAUD0ch1		sgp
 * TAUD0ch2		NbNo(JP11oR)		(CK2=20MHz܂CK3=1MHz)
 * TAUD0ch3		XPW[Ŏgp
 * TAUD0ch4		sgp(CN2RlN^ڑ)
 * TAUD0ch5		sgp
 * TAUD0ch6		sgp(CN2RlN^ڑ)
 * TAUD0ch7		sgp
 * TAUD0ch8		uU[pɗ\
 * TAUD0ch9		uU[p(fBo)			(CK2=20MHz)
 * TAUD0ch10	PWMiLED, JP11oR)		(CK2=20MHz)
 * TAUD0ch11	PWMiLED, JP11oR)		(CK2=20MHz)
 * TAUD0ch12	sgp
 * TAUD0ch13	sgp
 * TAUD0ch14	^C}p					(CK3=1MHz)
 * TAUD0ch15	^C}p					(CK3=1MHz)
 * 
 * TAUJnchm		sgp(ꕔCN2RlN^ڑ)
 * 
 * RLIN30		UART(USB-VAϊ)p
 * RLIN31		RS-485p
 * 
 * CSIH			SPIڑLCDIɎgp(CN2RlN^ڑ)
 * CSIG			sgp
 * 
 * I2C0			EEPROMڑ(JP11oR)
 * I2C1			sgp(CN2RlN^ڑ)
 * 
 * CAN0			gp(ch0)
 * CAN1			gp(ch1)
 * CAN2			sgp(CN2RlN^ڑ)
 * 
 */

//============================================================================
// ݗD揇
//============================================================================
/*
 * 00
 * 01
 * 02
 * 03
 * 04
 * 05
 * 06
 * 07
 * 08	UARTM
 * 09
 * 10	IICM
 * 11
 * 12	ʂ̊(ʂ̃^C}݁AMI)
 * 13
 * 14	XPW[(=e^XN)
 * 15	(IDLE^XN)
 */
 
//============================================================================
// J[l^C}ix[XE^C}j.
//============================================================================
#define BTIMER_IRQ			(INTC1.ICTAUD0I14)		// ݃WX^
#define BTIMER_ICH			(15)					// ݃`lԍ
#define BTIMER_IPR			(12)					// ݗDx
#define BTIMER_WINDOW_IRQ	(INTC2.ICTAUD0I15)		// f[eB݃WX^
#define BTIMER_WINDOW_ICH	(55)					// f[eB݃`lԍ
#define BTIMER_WINDOW_IPR	(12)					// f[eBݗDx
#define BTIMER_PERIOD		(BASE_FREQUENCY / CLOCKS_PER_SEC - 1)
#define BTIMER_WINDOW		(((BASE_FREQUENCY / CLOCKS_PER_SEC) * TASK_WINDOW) / 100)

#define BTIMER_PERI_CMOR	(TAUD0.CMOR14)			// @\ݒ
#define BTIMER_WIND_CMOR	(TAUD0.CMOR15)			// f[eB@\ݒ
#define BTIMER_PERI_CDR		(TAUD0.CDR14)			// ݒ
#define BTIMER_WIND_CDR		(TAUD0.CDR15)			// f[eBݒ
#define BTIMER_PERI_CNT		(TAUD0.CNT14)			// JE^ǎ

#define BTIMER_START_ST		(TAUD0.TS)				// JnWX^
#define BTIMER_PERI_CH		(14)					// `lԍ
#define BTIMER_WIND_CH		(15)					// f[eB`lԍ

//============================================================================
// 񊄍.
//============================================================================
#define SCHEDULE_IRQ		(INTC2.ICTAUD0I3)		// XPW[݃WX^
#define SCHEDULE_ICH		(49)					// XPW[݃`lԍ
#define SCHEDULE_IPR		(14)					// XPW[ݗDx

//============================================================================
// NbNEj^.
//============================================================================
//
#define CLOCK_PIN_PM		(_PIN(PORT.PM0, b00))	//|[g[h
#define CLOCK_PIN_PMC		(_PIN(PORT.PMC0, b00))
#define CLOCK_PIN_PFC		(_PIN(PORT.PFC0, b00))
#define CLOCK_PIN_PFCE		(_PIN(PORT.PFCE0, b00))
#define CLOCK_PIN_PFCAE		(_PIN(PORT.PFCAE0, b00))

#define CLOCK_TIMER_CMOR	(TAUD0.CMOR2)			// @\ݒ
#define CLOCK_TIMER_CDR		(TAUD0.CDR2)			// ݒ
#define CLOCK_TIMER_ST		(_REG(TAUD0.TS, b02))	// JnWX^
#define CLOCK_TIMER_TT		(_REG(TAUD0.TT, b02))	// IWX^
#define CLOCK_TIMER_TOE		(_REG(TAUD0.TOE, b02))	// o̓Cl[uWX^

//============================================================================
// EIb`hbO.
//============================================================================
//
#define WDT_RESETFLAG	(1 << 1 | 1 << 2)		// WDTɂ郊Zbgv
#define WDT_RESTART()	(WDTA0.WDTE = 0x0AC)	// WDTX^[g

//============================================================================
// LED\
//============================================================================
//o̓s
#define LED0_PIN		(_PIN(PORT.P9, b00))
#define LED1_PIN		(_PIN(PORT.P9, b01))
#define LED2_PIN		(_PIN(PORT.P9, b02))
#define LED3_PIN		(_PIN(PORT.P9, b03))

//o̓[h
#define LED0_PM			(_PIN(PORT.PM9, b00))
#define LED1_PM			(_PIN(PORT.PM9, b01))
#define LED2_PM			(_PIN(PORT.PM9, b02))
#define LED3_PM			(_PIN(PORT.PM9, b03))

//============================================================================
// XCb`
//============================================================================
//̓s
#define PUSH1_PIN		(_PIN(PORT.PPR10, b13))
#define PUSH2_PIN		(_PIN(PORT.PPR10, b14))
#define PUSH3_PIN		(_PIN(JTAG.JPPR0, b03))
#define PUSH4_PIN		(_PIN(JTAG.JPPR0, b04))

#define DIPSW1_PIN		(_PIN(PORT.APPR0, b06))
#define DIPSW2_PIN		(_PIN(PORT.APPR0, b07))
#define DIPSW3_PIN		(_PIN(PORT.APPR0, b08))
#define DIPSW4_PIN		(_PIN(PORT.APPR0, b09))

//̓obt@
#define PUSH1_IBC		(_PIN(PORT.PIBC10, b13))
#define PUSH2_IBC		(_PIN(PORT.PIBC10, b14))
#define PUSH3_IBC		(_PIN(JTAG.JPIBC0, b03))
#define PUSH4_IBC		(_PIN(JTAG.JPIBC0, b04))

#define DIPSW1_IBC		(_PIN(PORT.APIBC0, b06))
#define DIPSW2_IBC		(_PIN(PORT.APIBC0, b07))
#define DIPSW3_IBC		(_PIN(PORT.APIBC0, b08))
#define DIPSW4_IBC		(_PIN(PORT.APIBC0, b09))

//vAbv
#define PUSH1_PU		(_PIN(PORT.PU10, b13))
#define PUSH2_PU		(_PIN(PORT.PU10, b14))
#define PUSH3_PU		(_PIN(JTAG.JPU0, b03))
#define PUSH4_PU		(_PIN(JTAG.JPU0, b04))

#define DIPSW1_PU		(_PIN(JTAG.JPU0, b05))		// APɂPÛŃ_~[蓖
#define DIPSW2_PU		(_PIN(JTAG.JPU0, b05))		// APɂPÛŃ_~[蓖
#define DIPSW3_PU		(_PIN(JTAG.JPU0, b05))		// APɂPÛŃ_~[蓖
#define DIPSW4_PU		(_PIN(JTAG.JPU0, b05))		// APɂPÛŃ_~[蓖

//============================================================================
// uU[AfBo.
//============================================================================
#define BEEP_PIN			(_PIN(PORT.P10, b04))	//o̓WX^
#define BEEP_PIN_PM			(_PIN(PORT.PM10, b04))	//|[g[h
#define BEEP_PIN_PMC		(_PIN(PORT.PMC10, b04))
#define BEEP_PIN_PFC		(_PIN(PORT.PFC10, b04))
#define BEEP_PIN_PFCE		(_PIN(PORT.PFCE10, b04))
#define BEEP_PIN_PFCAE		(_PIN(PORT.PFCAE10, b04))

#define BEEP_TIMER_CMOR		(TAUD0.CMOR9)			// @\ݒ
#define BEEP_TIMER_CDR		(TAUD0.CDR9)			// ݒ
#define BEEP_TIMER_ST		(_REG(TAUD0.TS, b09))	// JnWX^
#define BEEP_TIMER_TT		(_REG(TAUD0.TT, b09))	// IWX^
#define BEEP_TIMER_TOE		(_REG(TAUD0.TOE, b09))	// o̓Cl[uWX^

//============================================================================
// PWMo.
//============================================================================
#define PWM_PIN_PM			(_PIN(PORT.PM10, b05))	//|[g[h
#define PWM_PIN_PMC			(_PIN(PORT.PMC10, b05))
#define PWM_PIN_PFC			(_PIN(PORT.PFC10, b05))
#define PWM_PIN_PFCE		(_PIN(PORT.PFCE10, b05))
#define PWM_PIN_PFCAE		(_PIN(PORT.PFCAE10, b05))

#define PWM_MAST_CMOR		(TAUD0.CMOR10)			// @\ݒ
#define PWM_MAST_CDR		(TAUD0.CDR10)			// ݒ
#define PWM_SLAV_CMOR		(TAUD0.CMOR11)			// f[eB@\ݒ
#define PWM_SLAV_CDR		(TAUD0.CDR11)			// f[eBݒ
#define PWM_MAST_ST			(TAUD0.TS)				// JnWX^
#define PWM_MAST_TT			(TAUD0.TT)				// IWX^
#define PWM_MAST_CH_BIT		((1<<10) | (1<<11))		// `lrbg
#define PWM_SLAV_TOE		(_REG(TAUD0.TOE, b11))	// o̓Cl[uWX^
#define PWM_SLAV_TOM		(_REG(TAUD0.TOM, b11))	// o̓[hWX^
#define PWM_SLAV_TOL		(_REG(TAUD0.TOL, b11))	// o̓xWX^

//============================================================================
// AiOM.
//============================================================================
#define AD_PERIOD		(10)			//ϊ[ms].
#define AD_AVENUM		(10)			//ړω.

//_`l`
enum AD_CHANNEL_INDEX{
	AD_VOLM1,
	AD_VOLM2,
	AD_AUX1,
	AD_AUX2,
	AD_AUX3,
	AD_AUX4,
	AD_NUMBER			//ADϊ.
};
//`l`
enum AD_CHANNEL_FC{
	AD_FC_VOLM1 = 4,
	AD_FC_VOLM2,
	AD_FC_AUX1 = 0,
	AD_FC_AUX2,
	AD_FC_AUX3,
	AD_FC_AUX4
};

#define AD_APB_EN()			 _set(MCLK, APBCMASK, ADC0, 1)
#define AD_PCH				(33)
#define AD_GCLK				(2)
#define AD_AD				ADC0_REGS
#if 0
#define AD1_APB_EN()		_set(MCLK, APBCMASK, ADC1, 1)
#define AD1_PCH				(34)
#define AD1_GCLK			(2)
#define AD1_AD				ADC1_REGS
#endif

#define AD_RESRDY_INT		_valAD(AD_AD, INTFLAG, RESRDY, 1)

//============================================================================
// UARTʐM.
//============================================================================
#define UART_TX_IRQ			(INTC2.ICRLIN30UR0)		// M݃WX^
#define UART_TX_ICH			(34)					// M݃`lԍ
#define UART_TX_IPR			(12)					// MݗDx
#define UART_RX_IRQ			(INTC2.ICRLIN30UR1)		// M݃WX^
#define UART_RX_ICH			(35)					// M݃`lԍ
#define UART_RX_IPR			(8)						// MݗDx
#define UART_ER_IRQ			(INTC2.ICRLIN30UR2)		// G[݃WX^
#define UART_ER_ICH			(36)					// G[݃`lԍ
#define UART_ER_IPR			(12)					// G[ݗDx

#define UART_TX_PIN_PFC		(_PIN(PORT.PFC10, b10))
#define UART_TX_PIN_PMC		(_PIN(PORT.PMC10, b10))
#define UART_TX_PIN_PM		(_PIN(PORT.PM10, b10))

#define UART_RX_PIN_PFCE	(_PIN(PORT.PFCE10, b09))
#define UART_RX_PIN_PFCAE	(_PIN(PORT.PFCAE10, b09))
#define UART_RX_PIN_PMC		(_PIN(PORT.PMC10, b09))
#define UART_RX_PIN_IBC		(_PIN(PORT.PIBC10, b09))
#define UART_RX_PIN			(_PIN(PORT.PPR10, b09))
#define UART_RX_PIN_PU		(_PIN(PORT.PU10, b09))

#define UART_TXD			(RLN30.LUTDR.UINT8[L])	//Mf[^
#define UART_RXD			(RLN30.LURDR.UINT8[L])	//Mf[^
#define UART_ERROR			(RLN30.LEST)			//G[

#define UART_LWBR			(RLN30.LWBR)
#define UART_LBRP01			(RLN30.LBRP01.UINT16)
#define UART_LMD			(RLN30.LMD)
#define UART_LEDE			(RLN30.LEDE)
#define UART_LBFC			(RLN30.LBFC)
#define UART_LCUC			(RLN30.LCUC)	
#define UART_LMST			(RLN30.LMST)	
#define UART_LUOER			(RLN30.LUOER)

//============================================================================
// RS485ʐM.
//============================================================================
#define RS485_TX_IRQ			(INTC2.ICRLIN31UR0)		// M݃WX^
#define RS485_TX_ICH			(121)					// M݃`lԍ
#define RS485_TX_IPR			(12)					// MݗDx
#define RS485_RX_IRQ			(INTC2.ICRLIN31UR1)		// M݃WX^
#define RS485_RX_ICH			(122)					// M݃`lԍ
#define RS485_RX_IPR			(8)						// MݗDx
#define RS485_ER_IRQ			(INTC2.ICRLIN31UR2)		// G[݃WX^
#define RS485_ER_ICH			(123)					// G[݃`lԍ
#define RS485_ER_IPR			(12)					// G[ݗDx

#define RS485_TE_PIN			(_PIN(PORT.P10, b08))	
#define RS485_TE_PIN_PM			(_PIN(PORT.PM10, b08))

#define RS485_TX_PIN_PFC		(_PIN(PORT.PFC10, b12))
#define RS485_TX_PIN_PMC		(_PIN(PORT.PMC10, b12))
#define RS485_TX_PIN_PM			(_PIN(PORT.PM10, b12))

#define RS485_RX_PIN_PFCE		(_PIN(PORT.PFCE10, b11))
#define RS485_RX_PIN_PFCAE		(_PIN(PORT.PFCAE10, b11))
#define RS485_RX_PIN_PMC		(_PIN(PORT.PMC10, b11))
#define RS485_RX_PIN_PU			(_PIN(PORT.PU10, b11))

#define RS485_TXD			(RLN31.LUTDR.UINT8[L])	//Mf[^
#define RS485_RXD			(RLN31.LURDR.UINT8[L])	//Mf[^
#define RS485_ERROR			(RLN31.LEST)			//G[

#define RS485_LWBR			(RLN31.LWBR)
#define RS485_LBRP01		(RLN31.LBRP01.UINT16)
#define RS485_LMD			(RLN31.LMD)
#define RS485_LEDE			(RLN31.LEDE)
#define RS485_LBFC			(RLN31.LBFC)
#define RS485_LCUC			(RLN31.LCUC)	
#define RS485_LMST			(RLN31.LMST)	
#define RS485_LUOER			(RLN31.LUOER)
#define RS485_LST_RECV		(_REG(RLN31.LST, b05))
#define RS485_LST_SEND		(_REG(RLN31.LST, b04))

//============================================================================
// I2CʐM(EEP܂).
//============================================================================
#define I2C_ERR_IRQ			(INTC2.ICRIIC0EE)		// G[݃WX^
#define I2C_ERR_ICH			(77)					// G[݃`lԍ
#define I2C_ERR_IPR			(12)					// G[ݗDx
#define I2C_REC_IRQ			(INTC2.ICRIIC0RI)		// M݃WX^
#define I2C_REC_ICH			(78)					// M݃`lԍ
#define I2C_REC_IPR			(10)					// MݗDx
#define I2C_SEND_IRQ		(INTC2.ICRIIC0TEI)		// M݃WX^
#define I2C_SEND_ICH		(79)					// M݃`lԍ
#define I2C_SEND_IPR		(12)					// MݗDx
#define I2C_SEND_TEND		(_REG(RIIC0.SR2.UINT32, b07))		
#define I2C_EMPT_IRQ		(INTC2.ICRIIC0TI)		// obt@󂫊݃WX^
#define I2C_EMPT_ICH		(76)					// obt@󂫊݃`lԍ
#define I2C_EMPT_IPR		(12)					// obt@󂫊ݗDx

#define I2C_CR1_ICE			(_REG(RIIC0.CR1.UINT32, b07))
#define I2C_CR1_IICRST		(_REG(RIIC0.CR1.UINT32, b06))
#define I2C_CR2_BBSY		(_REG(RIIC0.CR2.UINT32, b07))
#define I2C_CR2_ST			(_REG(RIIC0.CR2.UINT32, b01))
#define I2C_CR2_RS			(_REG(RIIC0.CR2.UINT32, b02))
#define I2C_CR2_SP			(_REG(RIIC0.CR2.UINT32, b03))
#define I2C_SR2_TEND		(_REG(RIIC0.SR2.UINT32, b06))
#define I2C_SR2_RDRF		(_REG(RIIC0.SR2.UINT32, b05))
#define I2C_SR2_NACKF		(_REG(RIIC0.SR2.UINT32, b04))
#define I2C_SR2_STOP		(_REG(RIIC0.SR2.UINT32, b03))
#define I2C_SR2_START		(_REG(RIIC0.SR2.UINT32, b02))
#define I2C_MR3_WAIT		(_REG(RIIC0.MR3.UINT32, b06))
#define I2C_MR3_RDRFS		(_REG(RIIC0.MR3.UINT32, b05))
#define I2C_MR3_ACKWP		(_REG(RIIC0.MR3.UINT32, b04))
#define I2C_MR3_ACKBT		(_REG(RIIC0.MR3.UINT32, b03))
#define I2C_MR1				(RIIC0.MR1.UINT32)
#define I2C_BRH				(RIIC0.BRH.UINT32)
#define I2C_BRL				(RIIC0.BRL.UINT32)
#define I2C_FER				(RIIC0.FER.UINT32)
#define I2C_IER				(RIIC0.IER.UINT32)
#define I2C_SEND_REG		(RIIC0.DRT.UINT32)		//MWX^
#define I2C_RECV_REG		(RIIC0.DRR.UINT32)		//MWX^

#define I2C_PIN_BIT			((1<<2)|(1<<3))
#define I2C_PORT_PM			(PORT.PM10)
#define I2C_PORT_PMC		(PORT.PMC10)
#define I2C_PORT_PFC		(PORT.PFC10)
#define I2C_PORT_PBDC		(PORT.PBDC10)
#define I2C_PORT_PODC		(PORT.PODC10)
#define I2C_PORT_PPCMD		(PORT.PPCMD10)

#define I2C_ADDR_EEPROM	(0x50)		// EEPROMI2CAhX(7bit).
#define I2C_PAGE_SIZE	256			// EEPROMy[WTCY.

//============================================================================
// p[^Ǘ
//============================================================================
//
#define EEP_BLOCK_START		(768)			//p[^̈JnAhX
#define EEP_BLOCK_SIZE		(256)		//p[^̈TCY = 4 + EEP_PARA_SHORT*2 + EEP_PARA_LONG*4
#define EEP_PARA_SHORT		(78)		//shortp[^
#define EEP_PARA_LONG		(24)		//longp[^

//============================================================================
// CANʐM.
//============================================================================
//
#define CAN0_RX_PIN_PFCE		(_PIN(PORT.PFCE10, b00))
#define CAN0_RX_PIN_PFCAE		(_PIN(PORT.PFCAE10, b00))
#define CAN0_RX_PIN_PMC			(_PIN(PORT.PMC10, b00))

#define CAN0_TX_PIN_PFCAE		(_PIN(PORT.PFCAE10, b01))
#define CAN0_TX_PIN_PFCE		(_PIN(PORT.PFCE10, b01))
#define CAN0_TX_PIN_PFC			(_PIN(PORT.PFC10, b01))
#define CAN0_TX_PIN_PMC			(_PIN(PORT.PMC10, b01))
#define CAN0_TX_PIN_PM			(_PIN(PORT.PM10, b01))
#define CAN0_TX_PIN				(_PIN(PORT.P10, b01))

#define CAN1_RX_PIN_PFCE		(_PIN(PORT.PFCE10, b06))
#define CAN1_RX_PIN_PFCAE		(_PIN(PORT.PFCAE10, b06))
#define CAN1_RX_PIN_PMC			(_PIN(PORT.PMC10, b06))

#define CAN1_TX_PIN_PFCAE		(_PIN(PORT.PFCAE10, b07))
#define CAN1_TX_PIN_PFCE		(_PIN(PORT.PFCE10, b07))
#define CAN1_TX_PIN_PFC			(_PIN(PORT.PFC10, b07))
#define CAN1_TX_PIN_PMC			(_PIN(PORT.PMC10, b07))
#define CAN1_TX_PIN_PM			(_PIN(PORT.PM10, b07))
#define CAN1_TX_PIN				(_PIN(PORT.P10, b07))

#define CAN_GSTS_GRAMINIT		(_REG(RCFDC0.CFDGSTS, b03))
#define CAN_GSTS_GSLPSTS		(_REG(RCFDC0.CFDGSTS, b02))
#define CAN_GCTR_GSLPR			(_REG(RCFDC0.CFDGCTR, b02))
#define CAN0_CTR_CSLPR			(_REG(RCFDC0.CFDC0CTR, b02))
#define CAN1_CTR_CSLPR			(_REG(RCFDC0.CFDC1CTR, b02))
#define CAN0_STS_CSLPSTS		(_REG(RCFDC0.CFDC0STS, b02))
#define CAN1_STS_CSLPSTS		(_REG(RCFDC0.CFDC1STS, b02))
#define CAN_GCFG				(RCFDC0.CFDGCFG.UINT32)
#define CAN0_NCFG				(RCFDC0.CFDC0NCFG.UINT32)
#define CAN0_DCFG				(RCFDC0.CFDC0DCFG.UINT32)
#define CAN1_NCFG				(RCFDC0.CFDC1NCFG.UINT32)
#define CAN1_DCFG				(RCFDC0.CFDC1DCFG.UINT32)

#define CAN_GAFLCFG				(RCFDC0.CFDGAFLCFG0.UINT32)
#define CAN_GAFLECTR_AFLDAE		(_REG(RCFDC0.CFDGAFLECTR, b08))
#define CAN0_GAFLID				(RCFDC0.CFDGAFLID0.UINT32)
#define CAN1_GAFLID				(RCFDC0.CFDGAFLID1.UINT32)
#define CAN0_GAFLM				(RCFDC0.CFDGAFLM0.UINT32)
#define CAN1_GAFLM				(RCFDC0.CFDGAFLM1.UINT32)
#define CAN0_GAFLP0				(RCFDC0.CFDGAFLP0_0.UINT32)
#define CAN1_GAFLP0				(RCFDC0.CFDGAFLP0_1.UINT32)
#define CAN0_GAFLP1				(RCFDC0.CFDGAFLP1_0.UINT32)
#define CAN1_GAFLP1				(RCFDC0.CFDGAFLP1_1.UINT32)

#define CAN_RMNB				(RCFDC0.CFDRMNB.UINT32)
#define CAN0_RFCC				(RCFDC0.CFDRFCC0.UINT32)
#define CAN1_RFCC				(RCFDC0.CFDRFCC1.UINT32)
#define CAN0_RFSTS_RFMC			(RCFDC0.CFDRFSTS0.UINT8[LH])
#define CAN1_RFSTS_RFMC			(RCFDC0.CFDRFSTS1.UINT8[LH])
#define CAN0_RFSTS_RFEMP		(_REG(RCFDC0.CFDRFSTS0, b00))
#define CAN1_RFSTS_RFEMP		(_REG(RCFDC0.CFDRFSTS1, b00))
#define CAN0_RFID				(RCFDC0.CFDRFID0.UINT16[L])
#define CAN1_RFID				(RCFDC0.CFDRFID1.UINT16[L])
#define CAN0_RFDLC				(RCFDC0.CFDRFPTR0.UINT8[HH]>>4)
#define CAN1_RFDLC				(RCFDC0.CFDRFPTR1.UINT8[HH]>>4)
#define CAN0_RFDF0(i)			(RCFDC0.CFDRFDF0_0.UINT8[i])
#define CAN0_RFDF1(i)			(RCFDC0.CFDRFDF1_0.UINT8[i])
#define CAN1_RFDF0(i)			(RCFDC0.CFDRFDF0_1.UINT8[i])
#define CAN1_RFDF1(i)			(RCFDC0.CFDRFDF1_1.UINT8[i])
#define CAN0_RFPCTR				(RCFDC0.CFDRFPCTR0.UINT8[LL])
#define CAN1_RFPCTR				(RCFDC0.CFDRFPCTR1.UINT8[LL])

#define CAN0_CFCC				(RCFDC0.CFDCFCC0.UINT32)
#define CAN1_CFCC				(RCFDC0.CFDCFCC3.UINT32)
#define CAN0_CFSTS_CFFLL		(_REG(RCFDC0.CFDCFSTS0, b01))
#define CAN1_CFSTS_CFFLL		(_REG(RCFDC0.CFDCFSTS3, b01))
#define CAN0_CFSTS_CFMC			(RCFDC0.CFDCFSTS0.UINT8[LH])
#define CAN1_CFSTS_CFMC			(RCFDC0.CFDCFSTS3.UINT8[LH])

#define CAN0_CFID				(RCFDC0.CFDCFID0.UINT32)
#define CAN1_CFID				(RCFDC0.CFDCFID3.UINT32)
#define CAN0_CFPTR				(RCFDC0.CFDCFPTR0.UINT32)
#define CAN1_CFPTR				(RCFDC0.CFDCFPTR3.UINT32)
#define CAN0_CFFDC				(RCFDC0.CFDCFFDCSTS0.UINT32)
#define CAN1_CFFDC				(RCFDC0.CFDCFFDCSTS3.UINT32)
#define CAN0_CFDF0(i)			(RCFDC0.CFDCFDF0_0.UINT8[i])
#define CAN0_CFDF1(i)			(RCFDC0.CFDCFDF1_0.UINT8[i])
#define CAN1_CFDF0(i)			(RCFDC0.CFDCFDF0_3.UINT8[i])
#define CAN1_CFDF1(i)			(RCFDC0.CFDCFDF1_3.UINT8[i])
#define CAN0_CFPCTR				(RCFDC0.CFDCFPCTR0.UINT8[LL])
#define CAN1_CFPCTR				(RCFDC0.CFDCFPCTR3.UINT8[LL])

#define CAN_GCTR				(RCFDC0.CFDGCTR.UINT32)
#define CAN0_CTR				(RCFDC0.CFDC0CTR.UINT32)
#define CAN1_CTR				(RCFDC0.CFDC1CTR.UINT32)

#define CAN_GINT_ERR			(INTC1.ICRCANGERR0)
#define CAN0_INT_ERR			(INTC1.ICRCAN0ERR)
#define CAN1_INT_ERR			(INTC2.ICRCAN1ERR)

#define CAN_GSTS_GRSTSTS		(_REG(RCFDC0.CFDGSTS, b00))
#define CAN0_STS_CRSTSTS		(_REG(RCFDC0.CFDC0STS, b00))
#define CAN1_STS_CRSTSTS		(_REG(RCFDC0.CFDC1STS, b00))

#define CAN0_TMSTS				(RCFDC0.CFDTMSTS0)
#define CAN0_TMID				(RCFDC0.CFDTMID0.UINT32)
#define CAN0_TMPTR				(RCFDC0.CFDTMPTR0.UINT32)
#define CAN0_TMFDCTR			(RCFDC0.CFDTMFDCTR0.UINT32)
#define CAN0_TMDF0(i)			(RCFDC0.CFDTMDF0_0.UINT8[i])
#define CAN0_TMDF1(i)			(RCFDC0.CFDTMDF1_0.UINT8[i])
#define CAN0_TMC				(RCFDC0.CFDTMC0)

#define CAN1_TMSTS				(RCFDC0.CFDTMSTS32)
#define CAN1_TMID				(RCFDC0.CFDTMID32.UINT32)
#define CAN1_TMPTR				(RCFDC0.CFDTMPTR32.UINT32)
#define CAN1_TMFDCTR			(RCFDC0.CFDTMFDCTR32.UINT32)
#define CAN1_TMDF0(i)			(RCFDC0.CFDTMDF0_32.UINT8[i])
#define CAN1_TMDF1(i)			(RCFDC0.CFDTMDF1_32.UINT8[i])
#define CAN1_TMC				(RCFDC0.CFDTMC32)

//============================================================================
// LCD\.
//============================================================================
#if TARGET_LCD == LCD_TYPE_SG12864
#define LCD_RST			(_PIN(PORT.P8, b06))
#define LCD_CS2			(_PIN(PORT.P8, b05))
#define LCD_CS1			(_PIN(PORT.P8, b04))
#define LCD_D7			(_PIN(PORT.P8, b03))
#define LCD_D6			(_PIN(PORT.P8, b01))
#define LCD_D5			(_PIN(PORT.P8, b00))
#define LCD_D4			(_PIN(PORT.P8, b02))
#define LCD_D3			(_PIN(PORT.P0, b06))
#define LCD_D2			(_PIN(PORT.P0, b05))
#define LCD_D1			(_PIN(PORT.P0, b04))
#define LCD_D0			(_PIN(PORT.P0, b01))
#define LCD_E			(_PIN(PORT.P0, b02))
#define LCD_DI			(_PIN(PORT.P0, b03))

#define LCD_RST_PM		(_PIN(PORT.PM8, b06))
#define LCD_CS2_PM		(_PIN(PORT.PM8, b05))
#define LCD_CS1_PM		(_PIN(PORT.PM8, b04))
#define LCD_D7_PM		(_PIN(PORT.PM8, b03))
#define LCD_D6_PM		(_PIN(PORT.PM8, b01))
#define LCD_D5_PM		(_PIN(PORT.PM8, b00))
#define LCD_D4_PM		(_PIN(PORT.PM8, b02))
#define LCD_D3_PM		(_PIN(PORT.PM0, b06))
#define LCD_D2_PM		(_PIN(PORT.PM0, b05))
#define LCD_D1_PM		(_PIN(PORT.PM0, b04))
#define LCD_D0_PM		(_PIN(PORT.PM0, b01))
#define LCD_E_PM		(_PIN(PORT.PM0, b02))
#define LCD_DI_PM		(_PIN(PORT.PM0, b03))
#endif

#if TARGET_LCD == LCD_TYPE_AQM1248
#define LCD_TX_IRQ		(INTC1.ICCSIH0IC)		// ʐM݃WX^
#define LCD_TX_ICH		(29)					// ʐM݃`lԍ

#define LCD_DO			(_PIN(PORT.P0, b03))
#define LCD_DO_PM		(_PIN(PORT.PM0, b03))
#define LCD_DO_PMC		(_PIN(PORT.PMC0, b03))
#define LCD_DO_PFC		(_PIN(PORT.PFC0, b03))
#define LCD_DO_PFCE		(_PIN(PORT.PFCE0, b03))
#define LCD_DO_PIPC		(_PIN(PORT.PIPC0, b03))

#define LCD_SCK			(_PIN(PORT.P0, b02))
#define LCD_SCK_PM		(_PIN(PORT.PM0, b02))
#define LCD_SCK_PMC		(_PIN(PORT.PMC0, b02))
#define LCD_SCK_PFC		(_PIN(PORT.PFC0, b02))
#define LCD_SCK_PFCE	(_PIN(PORT.PFCE0, b02))
#define LCD_SCK_PIPC	(_PIN(PORT.PIPC0, b02))

#define LCD_DO_SCK_PDSC (PORT.PDSC0)
#define LCD_DO_SCK_PIN	((1 << 2) | (1 <<3))

#define LCD_RS			(_PIN(PORT.P8, b03))
#define LCD_RS_PM		(_PIN(PORT.PM8, b03))
#define LCD_CS			(_PIN(PORT.P8, b04))
#define LCD_CS_PM		(_PIN(PORT.PM8, b04))
#define LCD_CSS0		(_PIN(PORT.P8, b02))
#define LCD_CSS0_PM		(_PIN(PORT.PM8, b02))
#define LCD_CSS0_PMC	(_PIN(PORT.PMC8, b02))
#define LCD_CSS0_PFC	(_PIN(PORT.PFC8, b02))

#define LCD_CTL0		(CSIH0.CTL0)
#define LCD_CTL1		(CSIH0.CTL1)
#define LCD_CTL2		(CSIH0.CTL2)
#define LCD_BRS0		(CSIH0.BRS0)
#define LCD_BRS1		(CSIH0.BRS1)
#define LCD_BRS2		(CSIH0.BRS2)
#define LCD_BRS3		(CSIH0.BRS3)
#define LCD_CFG0		(CSIH0.CFG0)
#define LCD_TX0W		(CSIH0.TX0W)
#define LCD_TX0H		(CSIH0.TX0H)
#define LCD_STR0_TSF	(_REG(CSIH0.STR0, b07))

#endif

//============================================================================
// API֐.
//============================================================================
void	DEVICE_init(void);		// WX^ANbN.
int		DEVICE_stack(void);	// X^bNʎ擾 (߂l:oCgP(ŏl256)).
int		DEVICE_det_wdt(void);	// EIb`hbOEZbgo(߂lEOFȂ猟o).
int 	DEVICE_set_vector(__ICREG* irq, int ch, void* p);	// ݃xN^o^ (߂lEOFȂo^ł)
int 	DEVICE_chg_vector(int ch, void* p);					// ݃xN^ύX (߂lEOFȂo^ł)
int 	DEVICE_set_syscall(int ch, void* p); 				// SYSCALL֐o^ (߂lEOFȂݒł)

//============================================================================
#endif	/* DEVICE_H */
