//============================================================================
// eXgC.
//
// (c)2023 Maikon-Giken
//============================================================================
#include "kernel.h"
#include "task_clock.h"
#include "task_lcd.h"
#include "task_led.h"
#include "task_beep.h"
#include "task_sw.h"
#include "task_uart.h"
#include "task_rs485.h"
#include "task_can.h"
#include "task_ad.h"
#include "task_eep_i2c.h"
#include "task_pwm.h"
#include "task_i2c.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

//============================================================================
// `.
//============================================================================

//============================================================================
// vg^Cv.
//============================================================================

//============================================================================
// f[^.
//============================================================================
static int	z, x, y, vol;
#ifdef	STDIO_USE_SCANF
static int	data[2];
#endif
static char packet[260];
static FILE *fsend, *frec, *flcd;
static char *p;
static struct {
	int		id:16;
	int		port:8;
	int		dlc:8;
	short	val1;
	char	moji[7];
} can_data;

#include "melody_polka.inc"

static int pwm_peri = 2000, pwm_center = 50, pwm_level = 50, pwm_wk;
static float pwm_gamma = 2.5;
static char eep_buff[256];
static schar flag;

//============================================================================
// API֐.
//============================================================================

//============================================================================
// ^XNA又.
//============================================================================
void main (void) {
  int i = 0, j, lim, n, c;

  // gxmFi100kHzój.
  CLOCK_output(CLOCK_OUT_ENABLE, CLOCK_INPUT_20MHz, 100000);

  // ZbgvmF.
  if (DEVICE_det_wdt() == EOF)	puts("WDT timeout.");
  else							puts("RESET start.");
  
  // LCDRS485I[v.
  flcd  = fopen("LCD:", "w");
  fsend = fopen("COM3:", "w");
  frec	= fopen("COM3:", "r");
  #ifdef LCD_TYPE_SG12864
  fprintf(flcd, "ԍڗp{[h");
  #endif
  fprintf(flcd, "ADC x6(VR x2)\nCAN x2, UART,\nRS-485, 5V\n");
  
  //PWMX^[g.
  PWM_start(24000, -1);
  
  // 又[v
  while(1) {
	i++;	// ȈՓIȎԒp

	//------------------------------------------------------------------------
	// DIPXCb`A^NgXCb`ɂLED, uU[AADeXg.
	//------------------------------------------------------------------------
	if (SW_value() & DIPSW1_MASK) {
		x = SW_geton(PUSH1_MASK);
		if (x) {
			z ^= x;
			if (z & x)	 LED_blink(LED_CH0, LED_MODE_LOOP, 12, 13);
			else		 LED_blink(LED_CH0, LED_MODE_ON, 12, 13);
			BEEP_out(500,10);
			fprintf(flcd, "XCb`P\n");
			vol ^= 1;
		}
	}
	if (SW_value() & DIPSW2_MASK) {
		x = SW_geton(PUSH2_MASK);
		if (x) {
			z ^= x;
			if (z & x)	 LED_blink(LED_CH1, LED_MODE_LOOP, 70, 30);
			else		 LED_blink(LED_CH1, LED_MODE_ON, 12, 13);
			BEEP_out(1000,20);
			fprintf(flcd, "XCb`Q\n");
		}
	}
	if (SW_value() & DIPSW3_MASK) {
		x = SW_geton(PUSH3_MASK);
		if (x) {
			z ^= x;
			if (z & x)	 LED_blink(LED_CH2, LED_MODE_LOOP, 20, 180);
			else		 LED_blink(LED_CH2, LED_MODE_ON, 12, 13);
			BEEP_out(1500,40);
			fprintf(flcd, "XCb`R\n");
		}
	}
	if (SW_value() & DIPSW4_MASK) {
		x = SW_geton(PUSH4_MASK);
		if (x) {
			z ^= x;
			if (z & x)	 LED_blink(LED_CH3, LED_MODE_LOOP, 180, 20);
			else		 LED_blink(LED_CH3, LED_MODE_ON, 12, 13);
			BEEP_out(2000,80);
			fprintf(flcd, "XCb`S\n");
		}
	}
	else {
		if (SW_geton(PUSH4_MASK)) {
			fprintf(flcd, "\x18\x01\x01");
			fprintf(flcd, "YƗp{[hADC x8(DAC x1)CAN x2, UART,\nRS-485, 5V\n");
		}
	}
	   
	//------------------------------------------------------------------------
	// zXgR}hɂLED, uU[AfBAADAEIb`hbOÃeXg.
	//------------------------------------------------------------------------
	if (y == 0) {
		if ((c = getchar()) != EOF) {
			switch (c) {
				case '\\': y = 1; break;	//getseXg.
				case '^' : y = 2; break;	//fgetseXg.
				case '-' : y = 3; break;	//scanf & pwmeXg.
#ifdef STDIO_USE_SCANF
				case '@' : y = 4; break;	//fscanfeXg.
#endif
				case '[' : y = 5; break;	//RS485eXg.
				case ']' : y = 6; break;	//LCDeXg.
				case 'p' : y = 7; break;	//p[^֘AeXg.
				case 'i' : y = 8; break;	//i2c EEPROMeXg.
				case 'h' : y = 20; break;	//wv\.
				case 'a':					//ADϊJn.
					LED_blink(LED_CH0, LED_MODE_LOOP, 12, 13);
					BEEP_out(500,10);
					vol |= 1;
					puts("d test start:");				//putseXg.
					break;
				case 'q':					//ADϊ~.
					LED_blink(LED_CH0, LED_MODE_ON, 0, 0);
					BEEP_out(300,10);
					vol &= ~1;
					fputs("uit ad test\n", stdout);		//fputseXg.
					break;
				case 'c':					//CANeXgJn.
					LED_blink(LED_CH1, LED_MODE_LOOP, 12, 13);
					BEEP_out(1000,10);
					vol |= 2;
					puts("an test start:");
					break;
				case 'd':					//CANeXg.
					LED_blink(LED_CH1, LED_MODE_ON, 0, 0);
					BEEP_out(2000,10);
					vol &= ~2;
					puts("isable can test:");
					break;
				case 's':						//X^bNʕ\.
					printf("tack consumption = %d bytes.\n", DEVICE_stack());
					break;
				case 'o':
					c = refer_error_task();
					printf("ver run task = ");
					if (c == EOF)	printf("NONE\n");
					else			printf("%d\n", c);
					break;
				case 'm':						//fBtJn.
					printf("elody start\n");
					BEEP_play((ONPU*)whistle_polka, 0, 100, -6);
					break;
				case 'b':						//fBt~.
					printf("reak melody\n");
					BEEP_stop();
					break;
				case 'w':				//EIb`hbOEZbg̃eXg.
					__DI();
					while(1);
					//break;
				default	 : putchar('?');
			}
		}
	}
	else if (y == 1) {										//getseXg.
		if (gets(packet) != NULL) {
			if ((uchar)packet[0] >= ' ') {
				printf("#gets test:%s\n", packet);
			}
			else {
				printf("#ERROR\n");
			}
			y = 0;
		}
	}
	else if (y == 2) {										//fgetseXg.
		if (fgets(packet, sizeof packet, stdin) != NULL) {
			if ((uchar)packet[0] >= ' ') {
				fprintf(stdout, "#fgets test:%s", packet);
			}
			else {
				puts("#ERROR");
			}
			y = 0;
		}
	}
	else if (y == 3) {								//scanf & pwmeXg.
#ifndef	STDIO_USE_SCANF
		if (gets(packet) != NULL) {
			pwm_wk = -1;
			if ((c = sscanf(packet, "%d,%d,%d,%d\n", &pwm_peri, &pwm_center, &pwm_level, &pwm_wk /*gamma*/)) != EOF) {
				if (pwm_wk > 0) pwm_gamma = pwm_wk / 1000.0;
				printf("PWM para =%d,%d,%d,%f\n", pwm_peri, pwm_center, pwm_level, pwm_gamma);
				y = 0;
			}
		}
#elif 1
		pwm_wk = -1;
		if ((c = scanf("%d,%d,%d,%d\n", &pwm_peri, &pwm_center, &pwm_level, &pwm_wk /*gamma*/)) != EOF) {
			if (pwm_wk > 0) pwm_gamma = pwm_wk / 1000.0;
			printf("PWM para =%d,%d,%d,%f\n", pwm_peri, pwm_center, pwm_level, pwm_gamma);
			y = 0;
		}
#else
		if ((c = scanf("%d,%d,%s\n", data, data+1, packet)) != EOF) {
			printf("scanf n=%d", c);
			if (c > 0) printf(",%d", data[0]);
			if (c > 1) printf(",%d", data[1]);
			if (c > 2) printf(",s=\"%s\"", packet);
			puts(" :end");
			y = 0;
		}
#endif
	}
#ifdef	STDIO_USE_SCANF
	else if (y == 4) {										//fscanfeXg.
		if ((c = fscanf(stdin, "%d,%d,%s\n",data, data+1, packet)) != EOF) {
			printf("fscanf n=%d", c);
			if (c > 0) printf(",%d", data[0]);
			if (c > 1) printf(",%d", data[1]);
			if (c > 2) printf(",s=\"%s\"", packet);
			puts(" :end");
			y = 0;
		}
	}
#endif
	else if (y == 5) {					//RS485MeXg.
		if (gets(packet) != NULL) {
			if ((uchar)packet[0] >= ' ') {
				fprintf(fsend, "$RS485test:%s\n", packet);
			}
			else {
				fprintf(fsend, "$RS485test:EOF\n");
//				fputs("$RS485test:EOF\n", fsend);
			}
			y = 0;
		}
	}
	else if (y == 6) {										//LCDeXg.
		if (gets(packet) != NULL) {
			if ((uchar)packet[0] >= ' ') {
				fprintf(stdout, "#LCD test:%s\n", packet);
				j = strlen(packet);
				if (packet[j - 2] == '\\' && packet[j - 1] == 'n') {
					packet[j - 2] = '\n';
					packet[j - 1] = '\0';
				}
				fprintf(flcd, "%s", packet);
			}
			else {
				puts("#ERROR");
			}
			y = 0;
		}
	}
	else if (y == 7) {										//p[^֘AeXg.
		if (gets(packet) != NULL) {
			if ((uchar)packet[0] == '2') {
				//2byte
				p = &packet[2];
				j = strtol(p, &p, 0);
				if (j < 0 || j >= EEP_PARA_SHORT) printf("#p2 position error\n");
				else {
					lim = j + 16;
					if (lim > EEP_PARA_SHORT) lim = EEP_PARA_SHORT;
					//p[^
					n = j;
					while(*p == ',' && n < lim) {
						eep_data.para2[n++] = (short)strtol(++p, &p, 0);
					}
					//p[^\
					printf("#p2 %d=", j);
					while(j < lim) {
						printf(",%d", eep_data.para2[j++]);
					}
					printf("\n");
				}
			}
			else if (packet[0] == '4') {
				//4byte
				p = &packet[2];
				j = strtol(p, &p, 0);
				if (j < 0 || j >= EEP_PARA_LONG) printf("#p4 position error\n");
				else {
					lim = j + 8;
					if (lim > EEP_PARA_LONG) lim = EEP_PARA_LONG;
					//p[^
					n = j;
					while(*p == ',' && n < lim) {
						eep_data.para4[n++] = strtol(++p, &p, 0);
					}
					//p[^\
					printf("#p4 %d=", j);
					while(j < lim) {
						printf(",%d", eep_data.para4[j++]);
					}
					printf("\n");
				}
			}
			else if (packet[0] == 's') {
				while(EEP_save() != EEP_STATUS_ACCEPT);
				while((c = EEP_status()) != EEP_STATUS_READY) {
					if (c == EEP_STATUS_WERROR) break;
				}
				if (c == EEP_STATUS_WERROR) printf("#psave NG\n");
				else						printf("#psave ok\n");
			}
			else if (packet[0] == 'l') {
				while(EEP_load() != EEP_STATUS_ACCEPT);
				while(EEP_status() != EEP_STATUS_READY);
				printf("#pload ok\n");
			}
			y = 0;
		}
	}
	else if (y == 8) {										//i2c EEPROMeXg.
		if (gets(packet) != NULL) {
			y = 0;
			if (packet[0] == 'w') {
				p = &packet[2];
				j = strtol(p, &p, 0);
				if (j >= EEP_BLOCK_START && j < EEP_BLOCK_START + EEP_BLOCK_SIZE) printf("#iw position error\n");
				else {
					if (*p != ',' || j > 0x1ff00 || j < 0) printf("#iw parameter error\n");
					else {
						n = 0;
						p++;
						while (*p != 0 && n < 240) eep_buff[n++] = *p++;
						eep_buff[n++] = '\0';
						if (j < EEP_BLOCK_START && j + n >= EEP_BLOCK_START) {
							n = EEP_BLOCK_START - j;
							eep_buff[n - 1] = '\0';
						}
						if (I2C_EEP_write(j, eep_buff, n, &flag) == I2C_STATUS_ACCEPT)	y = 9;
						else printf("#iw bussy!\n");
					}
				}
			}
			else if (packet[0] == 'r') {
				p = &packet[2];
				j = strtol(p, &p, 0);
				if (j >= EEP_BLOCK_START && j < EEP_BLOCK_START + EEP_BLOCK_SIZE) printf("#iw position error\n");
				else {
					if (j > 0x1ff00 || j < 0) printf("#ir parameter error\n");
					else {
						if (I2C_EEP_read(j, eep_buff, 241, &flag) == I2C_STATUS_ACCEPT) y = 10;
						else printf("#ir bussy!\n");
					}
				}
			}
		}
	}
	else if (y == 9) {									//iw eXg.
		if (I2C_status() == I2C_STATUS_READY) {
			y = 0;
			printf("#iw complete\n");
		}
		else if ((c = getchar()) != EOF) {
			y = 0;
			printf("#iw cancel\n");
		}
	}
	else if (y == 10) {									//ir eXg.
		if (I2C_status() == I2C_STATUS_READY) {
			y = 0;
			for (n = 0; n < 255; n++) {
				j = eep_buff[n] & 0x7f;
				if (eep_buff[n] < 0x20 || j == 0x7f) break;
			}
			eep_buff[n] = 0;
			printf("#ir %s\n", eep_buff);
		}
		else if ((c = getchar()) != EOF) {
			y = 0;
			printf("#ir cancel\n");
		}
	}
	else if (y == 20) {									//wv\.
		printf("elp.\n");
		printf("y1R}hzs:X^bNgp, a/q:AiOϊJn/~,\n@m/b:fBtJn/~, c/d:CANʐMJn/~, w:WDT^CAEg\n");
		y = 23;
	}	
	else if (y == 21) {									//wv\.
		printf("ysR}hz[:RS485ʐM, ]:LCD\, ps/pl:p[^ۑ/,\n@p2,ʒu,l:2oCgp[^ύX,");
		printf(" p4,ʒu,l:4oCgp[^ύX,\n@- ,S,U,:PWM, iw,ʒu,:I2C, ir,ʒu:I2CǍ\n");
		y = 26;
	}
	else if (y > 22) {
		if 		(y == 25) y = 21;
		else if (y == 29) y = 0;
		else			  y++;
	}
	
	//------------------------------------------------------------------------
	// RS485MeXg.
	//------------------------------------------------------------------------
	if (fgets(packet, sizeof packet, frec) != NULL) {
		x = PUSH4_MASK;
		z ^= x;
		if (z & x)	 LED_blink(LED_CH3, LED_MODE_LOOP, 70, 30);
		else		 LED_blink(LED_CH3, LED_MODE_ON, 12, 13);
		
		fputs(packet, stdout);
		if (SW_value() & DIPSW4_MASK) {
			 BEEP_out(2000,40);
			 packet[0] = '%';
			 fputs(packet, fsend);
		}
	}
	
	//------------------------------------------------------------------------
	// PWMeXg.
	//------------------------------------------------------------------------
	if (pwm_peri == 0) PWM_out(0);
	else
	PWM_ratio( pow(
			(pwm_center + 
			 pwm_level * sin( 
			( (KERNEL_time() / 1000 % pwm_peri) * 2 * 3.14) / pwm_peri))/100, pwm_gamma));
	
	//------------------------------------------------------------------------
	// 1.28biADǎ茋ʕ\ACANMeXgj.
	//------------------------------------------------------------------------
	if ((i & 0x0ff) == 0x0ff) {
		if (vol & 1) {
			//ADǎ茋ʕ\
			printf("AD test %10u,%10u,%10u,%10u,%10u,%10u\n", 
					AD_value(AD_VOLM1),AD_value(AD_VOLM2),
					AD_value(AD_AUX1), AD_value(AD_AUX2), AD_value(AD_AUX3), AD_value(AD_AUX4));
		}
		if (vol & 2) {
			//CANMeXg
			puts("send can data from CAN0");
			can_data.port = 0;
			can_data.id = 0x010;
			can_data.dlc = 2;
			can_data.val1 = i;
			strcpy(can_data.moji, "ABCDEF");

			for (j = 0; j < 3; j++) {
				can_data.dlc++;
				c = CAN_send((CAN_PACKET*)&can_data);
				if (c == EOF) printf("CAN send buff full.\n");
				can_data.id += 0x010;
			}
		}
	}
	else if ((i & 0x0ff) == 0x07f) {
		if (vol & 2) {
			//CANMeXg
			puts("send can data from CAN1");
			can_data.port = 1;
			can_data.id = 0x040;
			can_data.dlc = 5;
			can_data.val1 = i;
			strcpy(can_data.moji, "ABCDEF");

			for (j = 0; j < 3; j++) {
				can_data.dlc++;
				CAN_send((CAN_PACKET*)&can_data);
				can_data.id += 0x010;
			}
		}
	}

	//------------------------------------------------------------------------
	// CANMeXg.
	//------------------------------------------------------------------------
	do {
		j = CAN_receive((CAN_PACKET*)&can_data);
		if (j != EOF) {
			printf("CAN%d:%3X:%d:%d,%s\n", can_data.port, can_data.id, can_data.dlc, can_data.val1, can_data.moji);
		}
	} while (j > 0);
	
	//------------------------------------------------------------------------
	// ̎Jn܂łx({łł5msBdevice.h->TASK_PERIODQ).
	// @@Fd͉ړIŁAԒ͊ȈՓIB
	// @@@@K؂ȎԊǗKvȗprł́AKERNEL_time()gp邱.
	//------------------------------------------------------------------------
	KERNEL_wait_next_period();
  }
}

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
