/******************************************************************************/
/* DISCLAIMER                                                                 */
/* This software is supplied by Renesas Electronics Corporation and is only   */
/* intended for use with Renesas products. No other uses are authorized.This  */
/* software is owned by Renesas Electronics Corporation and is protected      */
/* under all applicable laws, including copyright laws.                       */
/* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES          */
/* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING  */
/* BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR */
/* PURPOSE AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY           */
/* DISCLAIMED.                                                                */
/* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS     */
/* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE       */
/* LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL      */
/* DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS    */
/* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.           */
/* Renesas reserves the right, without notice, to make changes to this        */
/* software and to discontinue the availability of this software.             */
/* By using this software, you agree to the additional terms and conditions   */
/* found by accessing the following link:                                     */
/* www.renesas.com/disclaimer                                                 */
/*                                                                            */
/* Device     : RH/RH850G3KH/R7F701690                                        */
/* File Name  : iodefine.h                                                    */
/* Abstract   : Definition of I/O Register                                    */
/* History    : V1.40  [Device File version]                                  */
/* Options    : -df=C:\Program Files (x86)\Renesas Electronics\CS+\CC\Device\ */
/*              RH850\Devicefile\DR7F701690.DVF -o=E:\SRC\RH850_MG\RH850_can5 */
/*              _tp\iodefine.h -def=off -f                                    */
/* Date       : 2023/11/22                                                    */
/* Version    : V1.18.00.03  [df2iodef.exe version]                           */
/* This is a typical example.                                                 */
/*                                                                            */
/******************************************************************************/
#ifndef __R7F701690IODEFINE_HEADER__
#define __R7F701690IODEFINE_HEADER__

typedef struct
{
    unsigned char bit00:1;
    unsigned char bit01:1;
    unsigned char bit02:1;
    unsigned char bit03:1;
    unsigned char bit04:1;
    unsigned char bit05:1;
    unsigned char bit06:1;
    unsigned char bit07:1;
} __bitf_T;

#define  L 0
#define  H 1
#define LL 0
#define LH 1
#define HL 2
#define HH 3

struct __tag0
{                                                          /* Bit Access       */
    unsigned char  ATAUD0IENH0:1;                          /* ATAUD0IENH0      */
    unsigned char  ATAUD0IENH1:1;                          /* ATAUD0IENH1      */
    unsigned char  ATAUD0IENH2:1;                          /* ATAUD0IENH2      */
    unsigned char  ATAUD0IENH3:1;                          /* ATAUD0IENH3      */
    unsigned char  ATAUD0IENH4:1;                          /* ATAUD0IENH4      */
    unsigned char  ATAUD0IENH5:1;                          /* ATAUD0IENH5      */
    unsigned char  ATAUD0IENH6:1;                          /* ATAUD0IENH6      */
    unsigned char  ATAUD0IENH7:1;                          /* ATAUD0IENH7      */
};
struct __tag1
{                                                          /* Bit Access       */
    unsigned char  ATAUD0IENL0:1;                          /* ATAUD0IENL0      */
    unsigned char  ATAUD0IENL1:1;                          /* ATAUD0IENL1      */
    unsigned char  ATAUD0IENL2:1;                          /* ATAUD0IENL2      */
    unsigned char  ATAUD0IENL3:1;                          /* ATAUD0IENL3      */
    unsigned char  ATAUD0IENL4:1;                          /* ATAUD0IENL4      */
    unsigned char  ATAUD0IENL5:1;                          /* ATAUD0IENL5      */
    unsigned char  ATAUD0IENL6:1;                          /* ATAUD0IENL6      */
    unsigned char  ATAUD0IENL7:1;                          /* ATAUD0IENL7      */
};
struct __tag2
{                                                          /* Bit Access       */
    unsigned char  AENCA0IENL0:1;                          /* AENCA0IENL0      */
    unsigned char  AENCA0IENL1:1;                          /* AENCA0IENL1      */
    unsigned char  AENCA0IENL2:1;                          /* AENCA0IENL2      */
    unsigned char  AENCA0IENL3:1;                          /* AENCA0IENL3      */
    unsigned char  AENCA0IENL4:1;                          /* AENCA0IENL4      */
    unsigned char  :3;                                     /* Reserved Bits    */
};
struct __tag3
{                                                          /* Bit Access       */
    unsigned char  AADCTL0ENL0:1;                          /* AADCTL0ENL0      */
    unsigned char  AADCTL0ENL1:1;                          /* AADCTL0ENL1      */
    unsigned char  AADCTL0ENL2:1;                          /* AADCTL0ENL2      */
    unsigned char  :5;                                     /* Reserved Bits    */
};
struct __tag4
{                                                          /* Bit Access       */
    unsigned char  ASENTIENL0:1;                           /* ASENTIENL0       */
    unsigned char  ASENTIENL1:1;                           /* ASENTIENL1       */
    unsigned char  :6;                                     /* Reserved Bits    */
};
struct __tag5
{                                                          /* Bit Access       */
    unsigned char  :7;                                     /* Reserved Bits    */
    unsigned char  SVSDIS:1;                               /* SVSDIS           */
};
struct __tag6
{                                                          /* Bit Access       */
    unsigned char  SCE:1;                                  /* SCE              */
    unsigned char  :7;                                     /* Reserved Bits    */
};
struct __tag7
{                                                          /* Bit Access       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  SLSB:1;                                 /* SLSB             */
    unsigned char  AMPM:1;                                 /* AMPM             */
    unsigned char  CEST:1;                                 /* CEST             */
    unsigned char  CE:1;                                   /* CE               */
};
struct __tag8
{                                                          /* Bit Access       */
    unsigned char  CT0:1;                                  /* CT0              */
    unsigned char  CT1:1;                                  /* CT1              */
    unsigned char  CT2:1;                                  /* CT2              */
    unsigned char  EN1S:1;                                 /* EN1S             */
    unsigned char  ENALM:1;                                /* ENALM            */
    unsigned char  EN1HZ:1;                                /* EN1HZ            */
    unsigned char  :2;                                     /* Reserved Bits    */
};
struct __tag9
{                                                          /* Bit Access       */
    unsigned char  WAIT:1;                                 /* WAIT             */
    unsigned char  WST:1;                                  /* WST              */
    unsigned char  RSUB:1;                                 /* RSUB             */
    unsigned char  RSST:1;                                 /* RSST             */
    unsigned char  WSST:1;                                 /* WSST             */
    unsigned char  WUST:1;                                 /* WUST             */
    unsigned char  :2;                                     /* Reserved Bits    */
};
struct __tag10
{                                                          /* Bit Access       */
    unsigned char  KRM0:1;                                 /* KRM0             */
    unsigned char  KRM1:1;                                 /* KRM1             */
    unsigned char  KRM2:1;                                 /* KRM2             */
    unsigned char  KRM3:1;                                 /* KRM3             */
    unsigned char  KRM4:1;                                 /* KRM4             */
    unsigned char  KRM5:1;                                 /* KRM5             */
    unsigned char  KRM6:1;                                 /* KRM6             */
    unsigned char  KRM7:1;                                 /* KRM7             */
};
struct __tag11
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I0:1;                            /* P0TAUD0I0        */
    unsigned char  P1TAUD0I0:1;                            /* P1TAUD0I0        */
    unsigned char  P2TAUD0I0:1;                            /* P2TAUD0I0        */
    unsigned char  P3TAUD0I0:1;                            /* P3TAUD0I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I0:1;                            /* TBTAUD0I0        */
    unsigned char  MKTAUD0I0:1;                            /* MKTAUD0I0        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I0:1;                            /* RFTAUD0I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I0:1;                            /* CTTAUD0I0        */
};
struct __tag12
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I2:1;                            /* P0TAUD0I2        */
    unsigned char  P1TAUD0I2:1;                            /* P1TAUD0I2        */
    unsigned char  P2TAUD0I2:1;                            /* P2TAUD0I2        */
    unsigned char  P3TAUD0I2:1;                            /* P3TAUD0I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I2:1;                            /* TBTAUD0I2        */
    unsigned char  MKTAUD0I2:1;                            /* MKTAUD0I2        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I2:1;                            /* RFTAUD0I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I2:1;                            /* CTTAUD0I2        */
};
struct __tag13
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I4:1;                            /* P0TAUD0I4        */
    unsigned char  P1TAUD0I4:1;                            /* P1TAUD0I4        */
    unsigned char  P2TAUD0I4:1;                            /* P2TAUD0I4        */
    unsigned char  P3TAUD0I4:1;                            /* P3TAUD0I4        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I4:1;                            /* TBTAUD0I4        */
    unsigned char  MKTAUD0I4:1;                            /* MKTAUD0I4        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I4:1;                            /* RFTAUD0I4        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I4:1;                            /* CTTAUD0I4        */
};
struct __tag14
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I6:1;                            /* P0TAUD0I6        */
    unsigned char  P1TAUD0I6:1;                            /* P1TAUD0I6        */
    unsigned char  P2TAUD0I6:1;                            /* P2TAUD0I6        */
    unsigned char  P3TAUD0I6:1;                            /* P3TAUD0I6        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I6:1;                            /* TBTAUD0I6        */
    unsigned char  MKTAUD0I6:1;                            /* MKTAUD0I6        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I6:1;                            /* RFTAUD0I6        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I6:1;                            /* CTTAUD0I6        */
};
struct __tag15
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I8:1;                            /* P0TAUD0I8        */
    unsigned char  P1TAUD0I8:1;                            /* P1TAUD0I8        */
    unsigned char  P2TAUD0I8:1;                            /* P2TAUD0I8        */
    unsigned char  P3TAUD0I8:1;                            /* P3TAUD0I8        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I8:1;                            /* TBTAUD0I8        */
    unsigned char  MKTAUD0I8:1;                            /* MKTAUD0I8        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I8:1;                            /* RFTAUD0I8        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I8:1;                            /* CTTAUD0I8        */
};
struct __tag16
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I10:1;                           /* P0TAUD0I10       */
    unsigned char  P1TAUD0I10:1;                           /* P1TAUD0I10       */
    unsigned char  P2TAUD0I10:1;                           /* P2TAUD0I10       */
    unsigned char  P3TAUD0I10:1;                           /* P3TAUD0I10       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I10:1;                           /* TBTAUD0I10       */
    unsigned char  MKTAUD0I10:1;                           /* MKTAUD0I10       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I10:1;                           /* RFTAUD0I10       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I10:1;                           /* CTTAUD0I10       */
};
struct __tag17
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I12:1;                           /* P0TAUD0I12       */
    unsigned char  P1TAUD0I12:1;                           /* P1TAUD0I12       */
    unsigned char  P2TAUD0I12:1;                           /* P2TAUD0I12       */
    unsigned char  P3TAUD0I12:1;                           /* P3TAUD0I12       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I12:1;                           /* TBTAUD0I12       */
    unsigned char  MKTAUD0I12:1;                           /* MKTAUD0I12       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I12:1;                           /* RFTAUD0I12       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I12:1;                           /* CTTAUD0I12       */
};
struct __tag18
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I14:1;                           /* P0TAUD0I14       */
    unsigned char  P1TAUD0I14:1;                           /* P1TAUD0I14       */
    unsigned char  P2TAUD0I14:1;                           /* P2TAUD0I14       */
    unsigned char  P3TAUD0I14:1;                           /* P3TAUD0I14       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I14:1;                           /* TBTAUD0I14       */
    unsigned char  MKTAUD0I14:1;                           /* MKTAUD0I14       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I14:1;                           /* RFTAUD0I14       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I14:1;                           /* CTTAUD0I14       */
};
struct __tag19
{                                                          /* Bit Access       */
    unsigned char  P0TAPA0IPEK0:1;                         /* P0TAPA0IPEK0     */
    unsigned char  P1TAPA0IPEK0:1;                         /* P1TAPA0IPEK0     */
    unsigned char  P2TAPA0IPEK0:1;                         /* P2TAPA0IPEK0     */
    unsigned char  P3TAPA0IPEK0:1;                         /* P3TAPA0IPEK0     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAPA0IPEK0:1;                         /* TBTAPA0IPEK0     */
    unsigned char  MKTAPA0IPEK0:1;                         /* MKTAPA0IPEK0     */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAPA0IPEK0:1;                         /* RFTAPA0IPEK0     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAPA0IPEK0:1;                         /* CTTAPA0IPEK0     */
};
struct __tag20
{                                                          /* Bit Access       */
    unsigned char  P0TAPA0IVLY0:1;                         /* P0TAPA0IVLY0     */
    unsigned char  P1TAPA0IVLY0:1;                         /* P1TAPA0IVLY0     */
    unsigned char  P2TAPA0IVLY0:1;                         /* P2TAPA0IVLY0     */
    unsigned char  P3TAPA0IVLY0:1;                         /* P3TAPA0IVLY0     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAPA0IVLY0:1;                         /* TBTAPA0IVLY0     */
    unsigned char  MKTAPA0IVLY0:1;                         /* MKTAPA0IVLY0     */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAPA0IVLY0:1;                         /* RFTAPA0IVLY0     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAPA0IVLY0:1;                         /* CTTAPA0IVLY0     */
};
struct __tag21
{                                                          /* Bit Access       */
    unsigned char  P0ADCA0I0:1;                            /* P0ADCA0I0        */
    unsigned char  P1ADCA0I0:1;                            /* P1ADCA0I0        */
    unsigned char  P2ADCA0I0:1;                            /* P2ADCA0I0        */
    unsigned char  P3ADCA0I0:1;                            /* P3ADCA0I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBADCA0I0:1;                            /* TBADCA0I0        */
    unsigned char  MKADCA0I0:1;                            /* MKADCA0I0        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFADCA0I0:1;                            /* RFADCA0I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTADCA0I0:1;                            /* CTADCA0I0        */
};
struct __tag22
{                                                          /* Bit Access       */
    unsigned char  P0ADCA0I1:1;                            /* P0ADCA0I1        */
    unsigned char  P1ADCA0I1:1;                            /* P1ADCA0I1        */
    unsigned char  P2ADCA0I1:1;                            /* P2ADCA0I1        */
    unsigned char  P3ADCA0I1:1;                            /* P3ADCA0I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBADCA0I1:1;                            /* TBADCA0I1        */
    unsigned char  MKADCA0I1:1;                            /* MKADCA0I1        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFADCA0I1:1;                            /* RFADCA0I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTADCA0I1:1;                            /* CTADCA0I1        */
};
struct __tag23
{                                                          /* Bit Access       */
    unsigned char  P0ADCA0I2:1;                            /* P0ADCA0I2        */
    unsigned char  P1ADCA0I2:1;                            /* P1ADCA0I2        */
    unsigned char  P2ADCA0I2:1;                            /* P2ADCA0I2        */
    unsigned char  P3ADCA0I2:1;                            /* P3ADCA0I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBADCA0I2:1;                            /* TBADCA0I2        */
    unsigned char  MKADCA0I2:1;                            /* MKADCA0I2        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFADCA0I2:1;                            /* RFADCA0I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTADCA0I2:1;                            /* CTADCA0I2        */
};
struct __tag24
{                                                          /* Bit Access       */
    unsigned char  P0DCUTDI:1;                             /* P0DCUTDI         */
    unsigned char  P1DCUTDI:1;                             /* P1DCUTDI         */
    unsigned char  P2DCUTDI:1;                             /* P2DCUTDI         */
    unsigned char  P3DCUTDI:1;                             /* P3DCUTDI         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDCUTDI:1;                             /* TBDCUTDI         */
    unsigned char  MKDCUTDI:1;                             /* MKDCUTDI         */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDCUTDI:1;                             /* RFDCUTDI         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDCUTDI:1;                             /* CTDCUTDI         */
};
struct __tag25
{                                                          /* Bit Access       */
    unsigned char  P0RCANGERR0:1;                          /* P0RCANGERR0      */
    unsigned char  P1RCANGERR0:1;                          /* P1RCANGERR0      */
    unsigned char  P2RCANGERR0:1;                          /* P2RCANGERR0      */
    unsigned char  P3RCANGERR0:1;                          /* P3RCANGERR0      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCANGERR0:1;                          /* TBRCANGERR0      */
    unsigned char  MKRCANGERR0:1;                          /* MKRCANGERR0      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCANGERR0:1;                          /* RFRCANGERR0      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCANGERR0:1;                          /* CTRCANGERR0      */
};
struct __tag26
{                                                          /* Bit Access       */
    unsigned char  P0RCANGRECC0:1;                         /* P0RCANGRECC0     */
    unsigned char  P1RCANGRECC0:1;                         /* P1RCANGRECC0     */
    unsigned char  P2RCANGRECC0:1;                         /* P2RCANGRECC0     */
    unsigned char  P3RCANGRECC0:1;                         /* P3RCANGRECC0     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCANGRECC0:1;                         /* TBRCANGRECC0     */
    unsigned char  MKRCANGRECC0:1;                         /* MKRCANGRECC0     */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCANGRECC0:1;                         /* RFRCANGRECC0     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCANGRECC0:1;                         /* CTRCANGRECC0     */
};
struct __tag27
{                                                          /* Bit Access       */
    unsigned char  P0RCAN0ERR:1;                           /* P0RCAN0ERR       */
    unsigned char  P1RCAN0ERR:1;                           /* P1RCAN0ERR       */
    unsigned char  P2RCAN0ERR:1;                           /* P2RCAN0ERR       */
    unsigned char  P3RCAN0ERR:1;                           /* P3RCAN0ERR       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCAN0ERR:1;                           /* TBRCAN0ERR       */
    unsigned char  MKRCAN0ERR:1;                           /* MKRCAN0ERR       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCAN0ERR:1;                           /* RFRCAN0ERR       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCAN0ERR:1;                           /* CTRCAN0ERR       */
};
struct __tag28
{                                                          /* Bit Access       */
    unsigned char  P0RCAN0REC:1;                           /* P0RCAN0REC       */
    unsigned char  P1RCAN0REC:1;                           /* P1RCAN0REC       */
    unsigned char  P2RCAN0REC:1;                           /* P2RCAN0REC       */
    unsigned char  P3RCAN0REC:1;                           /* P3RCAN0REC       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCAN0REC:1;                           /* TBRCAN0REC       */
    unsigned char  MKRCAN0REC:1;                           /* MKRCAN0REC       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCAN0REC:1;                           /* RFRCAN0REC       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCAN0REC:1;                           /* CTRCAN0REC       */
};
struct __tag29
{                                                          /* Bit Access       */
    unsigned char  P0RCAN0TRX:1;                           /* P0RCAN0TRX       */
    unsigned char  P1RCAN0TRX:1;                           /* P1RCAN0TRX       */
    unsigned char  P2RCAN0TRX:1;                           /* P2RCAN0TRX       */
    unsigned char  P3RCAN0TRX:1;                           /* P3RCAN0TRX       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCAN0TRX:1;                           /* TBRCAN0TRX       */
    unsigned char  MKRCAN0TRX:1;                           /* MKRCAN0TRX       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCAN0TRX:1;                           /* RFRCAN0TRX       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCAN0TRX:1;                           /* CTRCAN0TRX       */
};
struct __tag30
{                                                          /* Bit Access       */
    unsigned char  P0CSIG0IC:1;                            /* P0CSIG0IC        */
    unsigned char  P1CSIG0IC:1;                            /* P1CSIG0IC        */
    unsigned char  P2CSIG0IC:1;                            /* P2CSIG0IC        */
    unsigned char  P3CSIG0IC:1;                            /* P3CSIG0IC        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBCSIG0IC:1;                            /* TBCSIG0IC        */
    unsigned char  MKCSIG0IC:1;                            /* MKCSIG0IC        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFCSIG0IC:1;                            /* RFCSIG0IC        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTCSIG0IC:1;                            /* CTCSIG0IC        */
};
struct __tag31
{                                                          /* Bit Access       */
    unsigned char  P0CSIG0IR:1;                            /* P0CSIG0IR        */
    unsigned char  P1CSIG0IR:1;                            /* P1CSIG0IR        */
    unsigned char  P2CSIG0IR:1;                            /* P2CSIG0IR        */
    unsigned char  P3CSIG0IR:1;                            /* P3CSIG0IR        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBCSIG0IR:1;                            /* TBCSIG0IR        */
    unsigned char  MKCSIG0IR:1;                            /* MKCSIG0IR        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFCSIG0IR:1;                            /* RFCSIG0IR        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTCSIG0IR:1;                            /* CTCSIG0IR        */
};
struct __tag32
{                                                          /* Bit Access       */
    unsigned char  P0CSIH0IC:1;                            /* P0CSIH0IC        */
    unsigned char  P1CSIH0IC:1;                            /* P1CSIH0IC        */
    unsigned char  P2CSIH0IC:1;                            /* P2CSIH0IC        */
    unsigned char  P3CSIH0IC:1;                            /* P3CSIH0IC        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBCSIH0IC:1;                            /* TBCSIH0IC        */
    unsigned char  MKCSIH0IC:1;                            /* MKCSIH0IC        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFCSIH0IC:1;                            /* RFCSIH0IC        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTCSIH0IC:1;                            /* CTCSIH0IC        */
};
struct __tag33
{                                                          /* Bit Access       */
    unsigned char  P0CSIH0IR:1;                            /* P0CSIH0IR        */
    unsigned char  P1CSIH0IR:1;                            /* P1CSIH0IR        */
    unsigned char  P2CSIH0IR:1;                            /* P2CSIH0IR        */
    unsigned char  P3CSIH0IR:1;                            /* P3CSIH0IR        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBCSIH0IR:1;                            /* TBCSIH0IR        */
    unsigned char  MKCSIH0IR:1;                            /* MKCSIH0IR        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFCSIH0IR:1;                            /* RFCSIH0IR        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTCSIH0IR:1;                            /* CTCSIH0IR        */
};
struct __tag34
{                                                          /* Bit Access       */
    unsigned char  P0CSIH0IRE:1;                           /* P0CSIH0IRE       */
    unsigned char  P1CSIH0IRE:1;                           /* P1CSIH0IRE       */
    unsigned char  P2CSIH0IRE:1;                           /* P2CSIH0IRE       */
    unsigned char  P3CSIH0IRE:1;                           /* P3CSIH0IRE       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBCSIH0IRE:1;                           /* TBCSIH0IRE       */
    unsigned char  MKCSIH0IRE:1;                           /* MKCSIH0IRE       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFCSIH0IRE:1;                           /* RFCSIH0IRE       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTCSIH0IRE:1;                           /* CTCSIH0IRE       */
};
struct __tag35
{                                                          /* Bit Access       */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  FNRF:1;                                 /* FNRF             */
    unsigned char  :3;                                     /* Reserved Bits    */
};
struct __tag36
{                                                          /* Bit Access       */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  FIRF:1;                                 /* FIRF             */
    unsigned char  :3;                                     /* Reserved Bits    */
};
struct __tag37
{                                                          /* Bit Access       */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  IMR0EIMK8:1;                            /* IMR0EIMK8        */
    unsigned char  IMR0EIMK9:1;                            /* IMR0EIMK9        */
    unsigned char  IMR0EIMK10:1;                           /* IMR0EIMK10       */
    unsigned char  IMR0EIMK11:1;                           /* IMR0EIMK11       */
    unsigned char  IMR0EIMK12:1;                           /* IMR0EIMK12       */
    unsigned char  IMR0EIMK13:1;                           /* IMR0EIMK13       */
    unsigned char  IMR0EIMK14:1;                           /* IMR0EIMK14       */
    unsigned char  IMR0EIMK15:1;                           /* IMR0EIMK15       */
    unsigned char  IMR0EIMK16:1;                           /* IMR0EIMK16       */
    unsigned char  IMR0EIMK17:1;                           /* IMR0EIMK17       */
    unsigned char  IMR0EIMK18:1;                           /* IMR0EIMK18       */
    unsigned char  IMR0EIMK19:1;                           /* IMR0EIMK19       */
    unsigned char  IMR0EIMK20:1;                           /* IMR0EIMK20       */
    unsigned char  IMR0EIMK21:1;                           /* IMR0EIMK21       */
    unsigned char  IMR0EIMK22:1;                           /* IMR0EIMK22       */
    unsigned char  IMR0EIMK23:1;                           /* IMR0EIMK23       */
    unsigned char  IMR0EIMK24:1;                           /* IMR0EIMK24       */
    unsigned char  IMR0EIMK25:1;                           /* IMR0EIMK25       */
    unsigned char  IMR0EIMK26:1;                           /* IMR0EIMK26       */
    unsigned char  IMR0EIMK27:1;                           /* IMR0EIMK27       */
    unsigned char  IMR0EIMK28:1;                           /* IMR0EIMK28       */
    unsigned char  IMR0EIMK29:1;                           /* IMR0EIMK29       */
    unsigned char  IMR0EIMK30:1;                           /* IMR0EIMK30       */
    unsigned char  IMR0EIMK31:1;                           /* IMR0EIMK31       */
};
struct __tag38
{                                                          /* Bit Access       */
    unsigned char  P0ADCA0I2_2:1;                          /* P0ADCA0I2_2      */
    unsigned char  P1ADCA0I2_2:1;                          /* P1ADCA0I2_2      */
    unsigned char  P2ADCA0I2_2:1;                          /* P2ADCA0I2_2      */
    unsigned char  P3ADCA0I2_2:1;                          /* P3ADCA0I2_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBADCA0I2_2:1;                          /* TBADCA0I2_2      */
    unsigned char  MKADCA0I2_2:1;                          /* MKADCA0I2_2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFADCA0I2_2:1;                          /* RFADCA0I2_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTADCA0I2_2:1;                          /* CTADCA0I2_2      */
};
struct __tag39
{                                                          /* Bit Access       */
    unsigned char  P0RLIN30:1;                             /* P0RLIN30         */
    unsigned char  P1RLIN30:1;                             /* P1RLIN30         */
    unsigned char  P2RLIN30:1;                             /* P2RLIN30         */
    unsigned char  P3RLIN30:1;                             /* P3RLIN30         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN30:1;                             /* TBRLIN30         */
    unsigned char  MKRLIN30:1;                             /* MKRLIN30         */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN30:1;                             /* RFRLIN30         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN30:1;                             /* CTRLIN30         */
};
struct __tag40
{                                                          /* Bit Access       */
    unsigned char  P0RLIN30UR0:1;                          /* P0RLIN30UR0      */
    unsigned char  P1RLIN30UR0:1;                          /* P1RLIN30UR0      */
    unsigned char  P2RLIN30UR0:1;                          /* P2RLIN30UR0      */
    unsigned char  P3RLIN30UR0:1;                          /* P3RLIN30UR0      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN30UR0:1;                          /* TBRLIN30UR0      */
    unsigned char  MKRLIN30UR0:1;                          /* MKRLIN30UR0      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN30UR0:1;                          /* RFRLIN30UR0      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN30UR0:1;                          /* CTRLIN30UR0      */
};
struct __tag41
{                                                          /* Bit Access       */
    unsigned char  P0RLIN30UR1:1;                          /* P0RLIN30UR1      */
    unsigned char  P1RLIN30UR1:1;                          /* P1RLIN30UR1      */
    unsigned char  P2RLIN30UR1:1;                          /* P2RLIN30UR1      */
    unsigned char  P3RLIN30UR1:1;                          /* P3RLIN30UR1      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN30UR1:1;                          /* TBRLIN30UR1      */
    unsigned char  MKRLIN30UR1:1;                          /* MKRLIN30UR1      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN30UR1:1;                          /* RFRLIN30UR1      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN30UR1:1;                          /* CTRLIN30UR1      */
};
struct __tag42
{                                                          /* Bit Access       */
    unsigned char  P0RLIN30UR2:1;                          /* P0RLIN30UR2      */
    unsigned char  P1RLIN30UR2:1;                          /* P1RLIN30UR2      */
    unsigned char  P2RLIN30UR2:1;                          /* P2RLIN30UR2      */
    unsigned char  P3RLIN30UR2:1;                          /* P3RLIN30UR2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN30UR2:1;                          /* TBRLIN30UR2      */
    unsigned char  MKRLIN30UR2:1;                          /* MKRLIN30UR2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN30UR2:1;                          /* RFRLIN30UR2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN30UR2:1;                          /* CTRLIN30UR2      */
};
struct __tag43
{                                                          /* Bit Access       */
    unsigned char  P0P0:1;                                 /* P0P0             */
    unsigned char  P1P0:1;                                 /* P1P0             */
    unsigned char  P2P0:1;                                 /* P2P0             */
    unsigned char  P3P0:1;                                 /* P3P0             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBP0:1;                                 /* TBP0             */
    unsigned char  MKP0:1;                                 /* MKP0             */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFP0:1;                                 /* RFP0             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTP0:1;                                 /* CTP0             */
};
struct __tag44
{                                                          /* Bit Access       */
    unsigned char  P0P1:1;                                 /* P0P1             */
    unsigned char  P1P1:1;                                 /* P1P1             */
    unsigned char  P2P1:1;                                 /* P2P1             */
    unsigned char  P3P1:1;                                 /* P3P1             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBP1:1;                                 /* TBP1             */
    unsigned char  MKP1:1;                                 /* MKP1             */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFP1:1;                                 /* RFP1             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTP1:1;                                 /* CTP1             */
};
struct __tag45
{                                                          /* Bit Access       */
    unsigned char  P0P2:1;                                 /* P0P2             */
    unsigned char  P1P2:1;                                 /* P1P2             */
    unsigned char  P2P2:1;                                 /* P2P2             */
    unsigned char  P3P2:1;                                 /* P3P2             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBP2:1;                                 /* TBP2             */
    unsigned char  MKP2:1;                                 /* MKP2             */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFP2:1;                                 /* RFP2             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTP2:1;                                 /* CTP2             */
};
struct __tag46
{                                                          /* Bit Access       */
    unsigned char  P0WDTA0:1;                              /* P0WDTA0          */
    unsigned char  P1WDTA0:1;                              /* P1WDTA0          */
    unsigned char  P2WDTA0:1;                              /* P2WDTA0          */
    unsigned char  P3WDTA0:1;                              /* P3WDTA0          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBWDTA0:1;                              /* TBWDTA0          */
    unsigned char  MKWDTA0:1;                              /* MKWDTA0          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFWDTA0:1;                              /* RFWDTA0          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTWDTA0:1;                              /* CTWDTA0          */
};
struct __tag47
{                                                          /* Bit Access       */
    unsigned char  P0WDTA1:1;                              /* P0WDTA1          */
    unsigned char  P1WDTA1:1;                              /* P1WDTA1          */
    unsigned char  P2WDTA1:1;                              /* P2WDTA1          */
    unsigned char  P3WDTA1:1;                              /* P3WDTA1          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBWDTA1:1;                              /* TBWDTA1          */
    unsigned char  MKWDTA1:1;                              /* MKWDTA1          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFWDTA1:1;                              /* RFWDTA1          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTWDTA1:1;                              /* CTWDTA1          */
};
struct __tag48
{                                                          /* Bit Access       */
    unsigned char  P0P3:1;                                 /* P0P3             */
    unsigned char  P1P3:1;                                 /* P1P3             */
    unsigned char  P2P3:1;                                 /* P2P3             */
    unsigned char  P3P3:1;                                 /* P3P3             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBP3:1;                                 /* TBP3             */
    unsigned char  MKP3:1;                                 /* MKP3             */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFP3:1;                                 /* RFP3             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTP3:1;                                 /* CTP3             */
};
struct __tag49
{                                                          /* Bit Access       */
    unsigned char  P0P4:1;                                 /* P0P4             */
    unsigned char  P1P4:1;                                 /* P1P4             */
    unsigned char  P2P4:1;                                 /* P2P4             */
    unsigned char  P3P4:1;                                 /* P3P4             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBP4:1;                                 /* TBP4             */
    unsigned char  MKP4:1;                                 /* MKP4             */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFP4:1;                                 /* RFP4             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTP4:1;                                 /* CTP4             */
};
struct __tag50
{                                                          /* Bit Access       */
    unsigned char  P0P5:1;                                 /* P0P5             */
    unsigned char  P1P5:1;                                 /* P1P5             */
    unsigned char  P2P5:1;                                 /* P2P5             */
    unsigned char  P3P5:1;                                 /* P3P5             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBP5:1;                                 /* TBP5             */
    unsigned char  MKP5:1;                                 /* MKP5             */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFP5:1;                                 /* RFP5             */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTP5:1;                                 /* CTP5             */
};
struct __tag51
{                                                          /* Bit Access       */
    unsigned char  P0P10:1;                                /* P0P10            */
    unsigned char  P1P10:1;                                /* P1P10            */
    unsigned char  P2P10:1;                                /* P2P10            */
    unsigned char  P3P10:1;                                /* P3P10            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBP10:1;                                /* TBP10            */
    unsigned char  MKP10:1;                                /* MKP10            */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFP10:1;                                /* RFP10            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTP10:1;                                /* CTP10            */
};
struct __tag52
{                                                          /* Bit Access       */
    unsigned char  P0P11:1;                                /* P0P11            */
    unsigned char  P1P11:1;                                /* P1P11            */
    unsigned char  P2P11:1;                                /* P2P11            */
    unsigned char  P3P11:1;                                /* P3P11            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBP11:1;                                /* TBP11            */
    unsigned char  MKP11:1;                                /* MKP11            */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFP11:1;                                /* RFP11            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTP11:1;                                /* CTP11            */
};
struct __tag53
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I1:1;                            /* P0TAUD0I1        */
    unsigned char  P1TAUD0I1:1;                            /* P1TAUD0I1        */
    unsigned char  P2TAUD0I1:1;                            /* P2TAUD0I1        */
    unsigned char  P3TAUD0I1:1;                            /* P3TAUD0I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I1:1;                            /* TBTAUD0I1        */
    unsigned char  MKTAUD0I1:1;                            /* MKTAUD0I1        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I1:1;                            /* RFTAUD0I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I1:1;                            /* CTTAUD0I1        */
};
struct __tag54
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I3:1;                            /* P0TAUD0I3        */
    unsigned char  P1TAUD0I3:1;                            /* P1TAUD0I3        */
    unsigned char  P2TAUD0I3:1;                            /* P2TAUD0I3        */
    unsigned char  P3TAUD0I3:1;                            /* P3TAUD0I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I3:1;                            /* TBTAUD0I3        */
    unsigned char  MKTAUD0I3:1;                            /* MKTAUD0I3        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I3:1;                            /* RFTAUD0I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I3:1;                            /* CTTAUD0I3        */
};
struct __tag55
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I5:1;                            /* P0TAUD0I5        */
    unsigned char  P1TAUD0I5:1;                            /* P1TAUD0I5        */
    unsigned char  P2TAUD0I5:1;                            /* P2TAUD0I5        */
    unsigned char  P3TAUD0I5:1;                            /* P3TAUD0I5        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I5:1;                            /* TBTAUD0I5        */
    unsigned char  MKTAUD0I5:1;                            /* MKTAUD0I5        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I5:1;                            /* RFTAUD0I5        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I5:1;                            /* CTTAUD0I5        */
};
struct __tag56
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I7:1;                            /* P0TAUD0I7        */
    unsigned char  P1TAUD0I7:1;                            /* P1TAUD0I7        */
    unsigned char  P2TAUD0I7:1;                            /* P2TAUD0I7        */
    unsigned char  P3TAUD0I7:1;                            /* P3TAUD0I7        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I7:1;                            /* TBTAUD0I7        */
    unsigned char  MKTAUD0I7:1;                            /* MKTAUD0I7        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I7:1;                            /* RFTAUD0I7        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I7:1;                            /* CTTAUD0I7        */
};
struct __tag57
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I9:1;                            /* P0TAUD0I9        */
    unsigned char  P1TAUD0I9:1;                            /* P1TAUD0I9        */
    unsigned char  P2TAUD0I9:1;                            /* P2TAUD0I9        */
    unsigned char  P3TAUD0I9:1;                            /* P3TAUD0I9        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I9:1;                            /* TBTAUD0I9        */
    unsigned char  MKTAUD0I9:1;                            /* MKTAUD0I9        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I9:1;                            /* RFTAUD0I9        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I9:1;                            /* CTTAUD0I9        */
};
struct __tag58
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I11:1;                           /* P0TAUD0I11       */
    unsigned char  P1TAUD0I11:1;                           /* P1TAUD0I11       */
    unsigned char  P2TAUD0I11:1;                           /* P2TAUD0I11       */
    unsigned char  P3TAUD0I11:1;                           /* P3TAUD0I11       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I11:1;                           /* TBTAUD0I11       */
    unsigned char  MKTAUD0I11:1;                           /* MKTAUD0I11       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I11:1;                           /* RFTAUD0I11       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I11:1;                           /* CTTAUD0I11       */
};
struct __tag59
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I13:1;                           /* P0TAUD0I13       */
    unsigned char  P1TAUD0I13:1;                           /* P1TAUD0I13       */
    unsigned char  P2TAUD0I13:1;                           /* P2TAUD0I13       */
    unsigned char  P3TAUD0I13:1;                           /* P3TAUD0I13       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I13:1;                           /* TBTAUD0I13       */
    unsigned char  MKTAUD0I13:1;                           /* MKTAUD0I13       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I13:1;                           /* RFTAUD0I13       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I13:1;                           /* CTTAUD0I13       */
};
struct __tag60
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I15:1;                           /* P0TAUD0I15       */
    unsigned char  P1TAUD0I15:1;                           /* P1TAUD0I15       */
    unsigned char  P2TAUD0I15:1;                           /* P2TAUD0I15       */
    unsigned char  P3TAUD0I15:1;                           /* P3TAUD0I15       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I15:1;                           /* TBTAUD0I15       */
    unsigned char  MKTAUD0I15:1;                           /* MKTAUD0I15       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I15:1;                           /* RFTAUD0I15       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I15:1;                           /* CTTAUD0I15       */
};
struct __tag61
{                                                          /* Bit Access       */
    unsigned char  P0ADCA0ERR:1;                           /* P0ADCA0ERR       */
    unsigned char  P1ADCA0ERR:1;                           /* P1ADCA0ERR       */
    unsigned char  P2ADCA0ERR:1;                           /* P2ADCA0ERR       */
    unsigned char  P3ADCA0ERR:1;                           /* P3ADCA0ERR       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBADCA0ERR:1;                           /* TBADCA0ERR       */
    unsigned char  MKADCA0ERR:1;                           /* MKADCA0ERR       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFADCA0ERR:1;                           /* RFADCA0ERR       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTADCA0ERR:1;                           /* CTADCA0ERR       */
};
struct __tag62
{                                                          /* Bit Access       */
    unsigned char  P0CSIG0IRE:1;                           /* P0CSIG0IRE       */
    unsigned char  P1CSIG0IRE:1;                           /* P1CSIG0IRE       */
    unsigned char  P2CSIG0IRE:1;                           /* P2CSIG0IRE       */
    unsigned char  P3CSIG0IRE:1;                           /* P3CSIG0IRE       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBCSIG0IRE:1;                           /* TBCSIG0IRE       */
    unsigned char  MKCSIG0IRE:1;                           /* MKCSIG0IRE       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFCSIG0IRE:1;                           /* RFCSIG0IRE       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTCSIG0IRE:1;                           /* CTCSIG0IRE       */
};
struct __tag63
{                                                          /* Bit Access       */
    unsigned char  P0RLIN20:1;                             /* P0RLIN20         */
    unsigned char  P1RLIN20:1;                             /* P1RLIN20         */
    unsigned char  P2RLIN20:1;                             /* P2RLIN20         */
    unsigned char  P3RLIN20:1;                             /* P3RLIN20         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN20:1;                             /* TBRLIN20         */
    unsigned char  MKRLIN20:1;                             /* MKRLIN20         */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN20:1;                             /* RFRLIN20         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN20:1;                             /* CTRLIN20         */
};
struct __tag64
{                                                          /* Bit Access       */
    unsigned char  P0RLIN21:1;                             /* P0RLIN21         */
    unsigned char  P1RLIN21:1;                             /* P1RLIN21         */
    unsigned char  P2RLIN21:1;                             /* P2RLIN21         */
    unsigned char  P3RLIN21:1;                             /* P3RLIN21         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN21:1;                             /* TBRLIN21         */
    unsigned char  MKRLIN21:1;                             /* MKRLIN21         */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN21:1;                             /* RFRLIN21         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN21:1;                             /* CTRLIN21         */
};
struct __tag65
{                                                          /* Bit Access       */
    unsigned char  P0DMA0:1;                               /* P0DMA0           */
    unsigned char  P1DMA0:1;                               /* P1DMA0           */
    unsigned char  P2DMA0:1;                               /* P2DMA0           */
    unsigned char  P3DMA0:1;                               /* P3DMA0           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA0:1;                               /* TBDMA0           */
    unsigned char  MKDMA0:1;                               /* MKDMA0           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA0:1;                               /* RFDMA0           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA0:1;                               /* CTDMA0           */
};
struct __tag66
{                                                          /* Bit Access       */
    unsigned char  P0DMA1:1;                               /* P0DMA1           */
    unsigned char  P1DMA1:1;                               /* P1DMA1           */
    unsigned char  P2DMA1:1;                               /* P2DMA1           */
    unsigned char  P3DMA1:1;                               /* P3DMA1           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA1:1;                               /* TBDMA1           */
    unsigned char  MKDMA1:1;                               /* MKDMA1           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA1:1;                               /* RFDMA1           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA1:1;                               /* CTDMA1           */
};
struct __tag67
{                                                          /* Bit Access       */
    unsigned char  P0DMA2:1;                               /* P0DMA2           */
    unsigned char  P1DMA2:1;                               /* P1DMA2           */
    unsigned char  P2DMA2:1;                               /* P2DMA2           */
    unsigned char  P3DMA2:1;                               /* P3DMA2           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA2:1;                               /* TBDMA2           */
    unsigned char  MKDMA2:1;                               /* MKDMA2           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA2:1;                               /* RFDMA2           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA2:1;                               /* CTDMA2           */
};
struct __tag68
{                                                          /* Bit Access       */
    unsigned char  P0DMA3:1;                               /* P0DMA3           */
    unsigned char  P1DMA3:1;                               /* P1DMA3           */
    unsigned char  P2DMA3:1;                               /* P2DMA3           */
    unsigned char  P3DMA3:1;                               /* P3DMA3           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA3:1;                               /* TBDMA3           */
    unsigned char  MKDMA3:1;                               /* MKDMA3           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA3:1;                               /* RFDMA3           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA3:1;                               /* CTDMA3           */
};
struct __tag69
{                                                          /* Bit Access       */
    unsigned char  P0DMA4:1;                               /* P0DMA4           */
    unsigned char  P1DMA4:1;                               /* P1DMA4           */
    unsigned char  P2DMA4:1;                               /* P2DMA4           */
    unsigned char  P3DMA4:1;                               /* P3DMA4           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA4:1;                               /* TBDMA4           */
    unsigned char  MKDMA4:1;                               /* MKDMA4           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA4:1;                               /* RFDMA4           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA4:1;                               /* CTDMA4           */
};
struct __tag70
{                                                          /* Bit Access       */
    unsigned char  P0DMA5:1;                               /* P0DMA5           */
    unsigned char  P1DMA5:1;                               /* P1DMA5           */
    unsigned char  P2DMA5:1;                               /* P2DMA5           */
    unsigned char  P3DMA5:1;                               /* P3DMA5           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA5:1;                               /* TBDMA5           */
    unsigned char  MKDMA5:1;                               /* MKDMA5           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA5:1;                               /* RFDMA5           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA5:1;                               /* CTDMA5           */
};
struct __tag71
{                                                          /* Bit Access       */
    unsigned char  P0DMA6:1;                               /* P0DMA6           */
    unsigned char  P1DMA6:1;                               /* P1DMA6           */
    unsigned char  P2DMA6:1;                               /* P2DMA6           */
    unsigned char  P3DMA6:1;                               /* P3DMA6           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA6:1;                               /* TBDMA6           */
    unsigned char  MKDMA6:1;                               /* MKDMA6           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA6:1;                               /* RFDMA6           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA6:1;                               /* CTDMA6           */
};
struct __tag72
{                                                          /* Bit Access       */
    unsigned char  P0DMA7:1;                               /* P0DMA7           */
    unsigned char  P1DMA7:1;                               /* P1DMA7           */
    unsigned char  P2DMA7:1;                               /* P2DMA7           */
    unsigned char  P3DMA7:1;                               /* P3DMA7           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA7:1;                               /* TBDMA7           */
    unsigned char  MKDMA7:1;                               /* MKDMA7           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA7:1;                               /* RFDMA7           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA7:1;                               /* CTDMA7           */
};
struct __tag73
{                                                          /* Bit Access       */
    unsigned char  P0DMA8:1;                               /* P0DMA8           */
    unsigned char  P1DMA8:1;                               /* P1DMA8           */
    unsigned char  P2DMA8:1;                               /* P2DMA8           */
    unsigned char  P3DMA8:1;                               /* P3DMA8           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA8:1;                               /* TBDMA8           */
    unsigned char  MKDMA8:1;                               /* MKDMA8           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA8:1;                               /* RFDMA8           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA8:1;                               /* CTDMA8           */
};
struct __tag74
{                                                          /* Bit Access       */
    unsigned char  P0DMA9:1;                               /* P0DMA9           */
    unsigned char  P1DMA9:1;                               /* P1DMA9           */
    unsigned char  P2DMA9:1;                               /* P2DMA9           */
    unsigned char  P3DMA9:1;                               /* P3DMA9           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA9:1;                               /* TBDMA9           */
    unsigned char  MKDMA9:1;                               /* MKDMA9           */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA9:1;                               /* RFDMA9           */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA9:1;                               /* CTDMA9           */
};
struct __tag75
{                                                          /* Bit Access       */
    unsigned char  P0DMA10:1;                              /* P0DMA10          */
    unsigned char  P1DMA10:1;                              /* P1DMA10          */
    unsigned char  P2DMA10:1;                              /* P2DMA10          */
    unsigned char  P3DMA10:1;                              /* P3DMA10          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA10:1;                              /* TBDMA10          */
    unsigned char  MKDMA10:1;                              /* MKDMA10          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA10:1;                              /* RFDMA10          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA10:1;                              /* CTDMA10          */
};
struct __tag76
{                                                          /* Bit Access       */
    unsigned char  P0DMA11:1;                              /* P0DMA11          */
    unsigned char  P1DMA11:1;                              /* P1DMA11          */
    unsigned char  P2DMA11:1;                              /* P2DMA11          */
    unsigned char  P3DMA11:1;                              /* P3DMA11          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA11:1;                              /* TBDMA11          */
    unsigned char  MKDMA11:1;                              /* MKDMA11          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA11:1;                              /* RFDMA11          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA11:1;                              /* CTDMA11          */
};
struct __tag77
{                                                          /* Bit Access       */
    unsigned char  P0DMA12:1;                              /* P0DMA12          */
    unsigned char  P1DMA12:1;                              /* P1DMA12          */
    unsigned char  P2DMA12:1;                              /* P2DMA12          */
    unsigned char  P3DMA12:1;                              /* P3DMA12          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA12:1;                              /* TBDMA12          */
    unsigned char  MKDMA12:1;                              /* MKDMA12          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA12:1;                              /* RFDMA12          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA12:1;                              /* CTDMA12          */
};
struct __tag78
{                                                          /* Bit Access       */
    unsigned char  P0DMA13:1;                              /* P0DMA13          */
    unsigned char  P1DMA13:1;                              /* P1DMA13          */
    unsigned char  P2DMA13:1;                              /* P2DMA13          */
    unsigned char  P3DMA13:1;                              /* P3DMA13          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA13:1;                              /* TBDMA13          */
    unsigned char  MKDMA13:1;                              /* MKDMA13          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA13:1;                              /* RFDMA13          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA13:1;                              /* CTDMA13          */
};
struct __tag79
{                                                          /* Bit Access       */
    unsigned char  P0DMA14:1;                              /* P0DMA14          */
    unsigned char  P1DMA14:1;                              /* P1DMA14          */
    unsigned char  P2DMA14:1;                              /* P2DMA14          */
    unsigned char  P3DMA14:1;                              /* P3DMA14          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA14:1;                              /* TBDMA14          */
    unsigned char  MKDMA14:1;                              /* MKDMA14          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA14:1;                              /* RFDMA14          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA14:1;                              /* CTDMA14          */
};
struct __tag80
{                                                          /* Bit Access       */
    unsigned char  P0DMA15:1;                              /* P0DMA15          */
    unsigned char  P1DMA15:1;                              /* P1DMA15          */
    unsigned char  P2DMA15:1;                              /* P2DMA15          */
    unsigned char  P3DMA15:1;                              /* P3DMA15          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDMA15:1;                              /* TBDMA15          */
    unsigned char  MKDMA15:1;                              /* MKDMA15          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDMA15:1;                              /* RFDMA15          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDMA15:1;                              /* CTDMA15          */
};
struct __tag81
{                                                          /* Bit Access       */
    unsigned char  P0RIIC0TI:1;                            /* P0RIIC0TI        */
    unsigned char  P1RIIC0TI:1;                            /* P1RIIC0TI        */
    unsigned char  P2RIIC0TI:1;                            /* P2RIIC0TI        */
    unsigned char  P3RIIC0TI:1;                            /* P3RIIC0TI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRIIC0TI:1;                            /* TBRIIC0TI        */
    unsigned char  MKRIIC0TI:1;                            /* MKRIIC0TI        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRIIC0TI:1;                            /* RFRIIC0TI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRIIC0TI:1;                            /* CTRIIC0TI        */
};
struct __tag82
{                                                          /* Bit Access       */
    unsigned char  P0RIIC0EE:1;                            /* P0RIIC0EE        */
    unsigned char  P1RIIC0EE:1;                            /* P1RIIC0EE        */
    unsigned char  P2RIIC0EE:1;                            /* P2RIIC0EE        */
    unsigned char  P3RIIC0EE:1;                            /* P3RIIC0EE        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRIIC0EE:1;                            /* TBRIIC0EE        */
    unsigned char  MKRIIC0EE:1;                            /* MKRIIC0EE        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRIIC0EE:1;                            /* RFRIIC0EE        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRIIC0EE:1;                            /* CTRIIC0EE        */
};
struct __tag83
{                                                          /* Bit Access       */
    unsigned char  P0RIIC0RI:1;                            /* P0RIIC0RI        */
    unsigned char  P1RIIC0RI:1;                            /* P1RIIC0RI        */
    unsigned char  P2RIIC0RI:1;                            /* P2RIIC0RI        */
    unsigned char  P3RIIC0RI:1;                            /* P3RIIC0RI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRIIC0RI:1;                            /* TBRIIC0RI        */
    unsigned char  MKRIIC0RI:1;                            /* MKRIIC0RI        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRIIC0RI:1;                            /* RFRIIC0RI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRIIC0RI:1;                            /* CTRIIC0RI        */
};
struct __tag84
{                                                          /* Bit Access       */
    unsigned char  P0RIIC0TEI:1;                           /* P0RIIC0TEI       */
    unsigned char  P1RIIC0TEI:1;                           /* P1RIIC0TEI       */
    unsigned char  P2RIIC0TEI:1;                           /* P2RIIC0TEI       */
    unsigned char  P3RIIC0TEI:1;                           /* P3RIIC0TEI       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRIIC0TEI:1;                           /* TBRIIC0TEI       */
    unsigned char  MKRIIC0TEI:1;                           /* MKRIIC0TEI       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRIIC0TEI:1;                           /* RFRIIC0TEI       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRIIC0TEI:1;                           /* CTRIIC0TEI       */
};
struct __tag85
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ0I0:1;                            /* P0TAUJ0I0        */
    unsigned char  P1TAUJ0I0:1;                            /* P1TAUJ0I0        */
    unsigned char  P2TAUJ0I0:1;                            /* P2TAUJ0I0        */
    unsigned char  P3TAUJ0I0:1;                            /* P3TAUJ0I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ0I0:1;                            /* TBTAUJ0I0        */
    unsigned char  MKTAUJ0I0:1;                            /* MKTAUJ0I0        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ0I0:1;                            /* RFTAUJ0I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ0I0:1;                            /* CTTAUJ0I0        */
};
struct __tag86
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ0I1:1;                            /* P0TAUJ0I1        */
    unsigned char  P1TAUJ0I1:1;                            /* P1TAUJ0I1        */
    unsigned char  P2TAUJ0I1:1;                            /* P2TAUJ0I1        */
    unsigned char  P3TAUJ0I1:1;                            /* P3TAUJ0I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ0I1:1;                            /* TBTAUJ0I1        */
    unsigned char  MKTAUJ0I1:1;                            /* MKTAUJ0I1        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ0I1:1;                            /* RFTAUJ0I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ0I1:1;                            /* CTTAUJ0I1        */
};
struct __tag87
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ0I2:1;                            /* P0TAUJ0I2        */
    unsigned char  P1TAUJ0I2:1;                            /* P1TAUJ0I2        */
    unsigned char  P2TAUJ0I2:1;                            /* P2TAUJ0I2        */
    unsigned char  P3TAUJ0I2:1;                            /* P3TAUJ0I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ0I2:1;                            /* TBTAUJ0I2        */
    unsigned char  MKTAUJ0I2:1;                            /* MKTAUJ0I2        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ0I2:1;                            /* RFTAUJ0I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ0I2:1;                            /* CTTAUJ0I2        */
};
struct __tag88
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ0I3:1;                            /* P0TAUJ0I3        */
    unsigned char  P1TAUJ0I3:1;                            /* P1TAUJ0I3        */
    unsigned char  P2TAUJ0I3:1;                            /* P2TAUJ0I3        */
    unsigned char  P3TAUJ0I3:1;                            /* P3TAUJ0I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ0I3:1;                            /* TBTAUJ0I3        */
    unsigned char  MKTAUJ0I3:1;                            /* MKTAUJ0I3        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ0I3:1;                            /* RFTAUJ0I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ0I3:1;                            /* CTTAUJ0I3        */
};
struct __tag89
{                                                          /* Bit Access       */
    unsigned char  P0OSTM0:1;                              /* P0OSTM0          */
    unsigned char  P1OSTM0:1;                              /* P1OSTM0          */
    unsigned char  P2OSTM0:1;                              /* P2OSTM0          */
    unsigned char  P3OSTM0:1;                              /* P3OSTM0          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBOSTM0:1;                              /* TBOSTM0          */
    unsigned char  MKOSTM0:1;                              /* MKOSTM0          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFOSTM0:1;                              /* RFOSTM0          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTOSTM0:1;                              /* CTOSTM0          */
};
struct __tag90
{                                                          /* Bit Access       */
    unsigned char  P0ENCA0IOV:1;                           /* P0ENCA0IOV       */
    unsigned char  P1ENCA0IOV:1;                           /* P1ENCA0IOV       */
    unsigned char  P2ENCA0IOV:1;                           /* P2ENCA0IOV       */
    unsigned char  P3ENCA0IOV:1;                           /* P3ENCA0IOV       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBENCA0IOV:1;                           /* TBENCA0IOV       */
    unsigned char  MKENCA0IOV:1;                           /* MKENCA0IOV       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFENCA0IOV:1;                           /* RFENCA0IOV       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTENCA0IOV:1;                           /* CTENCA0IOV       */
};
struct __tag91
{                                                          /* Bit Access       */
    unsigned char  P0ENCA0IUD:1;                           /* P0ENCA0IUD       */
    unsigned char  P1ENCA0IUD:1;                           /* P1ENCA0IUD       */
    unsigned char  P2ENCA0IUD:1;                           /* P2ENCA0IUD       */
    unsigned char  P3ENCA0IUD:1;                           /* P3ENCA0IUD       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBENCA0IUD:1;                           /* TBENCA0IUD       */
    unsigned char  MKENCA0IUD:1;                           /* MKENCA0IUD       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFENCA0IUD:1;                           /* RFENCA0IUD       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTENCA0IUD:1;                           /* CTENCA0IUD       */
};
struct __tag92
{                                                          /* Bit Access       */
    unsigned char  P0ENCA0I0:1;                            /* P0ENCA0I0        */
    unsigned char  P1ENCA0I0:1;                            /* P1ENCA0I0        */
    unsigned char  P2ENCA0I0:1;                            /* P2ENCA0I0        */
    unsigned char  P3ENCA0I0:1;                            /* P3ENCA0I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBENCA0I0:1;                            /* TBENCA0I0        */
    unsigned char  MKENCA0I0:1;                            /* MKENCA0I0        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFENCA0I0:1;                            /* RFENCA0I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTENCA0I0:1;                            /* CTENCA0I0        */
};
struct __tag93
{                                                          /* Bit Access       */
    unsigned char  P0ENCA0I1:1;                            /* P0ENCA0I1        */
    unsigned char  P1ENCA0I1:1;                            /* P1ENCA0I1        */
    unsigned char  P2ENCA0I1:1;                            /* P2ENCA0I1        */
    unsigned char  P3ENCA0I1:1;                            /* P3ENCA0I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBENCA0I1:1;                            /* TBENCA0I1        */
    unsigned char  MKENCA0I1:1;                            /* MKENCA0I1        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFENCA0I1:1;                            /* RFENCA0I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTENCA0I1:1;                            /* CTENCA0I1        */
};
struct __tag94
{                                                          /* Bit Access       */
    unsigned char  P0ENCA0IEC:1;                           /* P0ENCA0IEC       */
    unsigned char  P1ENCA0IEC:1;                           /* P1ENCA0IEC       */
    unsigned char  P2ENCA0IEC:1;                           /* P2ENCA0IEC       */
    unsigned char  P3ENCA0IEC:1;                           /* P3ENCA0IEC       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBENCA0IEC:1;                           /* TBENCA0IEC       */
    unsigned char  MKENCA0IEC:1;                           /* MKENCA0IEC       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFENCA0IEC:1;                           /* RFENCA0IEC       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTENCA0IEC:1;                           /* CTENCA0IEC       */
};
struct __tag95
{                                                          /* Bit Access       */
    unsigned char  P0KR0:1;                                /* P0KR0            */
    unsigned char  P1KR0:1;                                /* P1KR0            */
    unsigned char  P2KR0:1;                                /* P2KR0            */
    unsigned char  P3KR0:1;                                /* P3KR0            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBKR0:1;                                /* TBKR0            */
    unsigned char  MKKR0:1;                                /* MKKR0            */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFKR0:1;                                /* RFKR0            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTKR0:1;                                /* CTKR0            */
};
struct __tag96
{                                                          /* Bit Access       */
    unsigned char  P0QFULL:1;                              /* P0QFULL          */
    unsigned char  P1QFULL:1;                              /* P1QFULL          */
    unsigned char  P2QFULL:1;                              /* P2QFULL          */
    unsigned char  P3QFULL:1;                              /* P3QFULL          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBQFULL:1;                              /* TBQFULL          */
    unsigned char  MKQFULL:1;                              /* MKQFULL          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFQFULL:1;                              /* RFQFULL          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTQFULL:1;                              /* CTQFULL          */
};
struct __tag97
{                                                          /* Bit Access       */
    unsigned char  P0PWGAG00:1;                            /* P0PWGAG00        */
    unsigned char  P1PWGAG00:1;                            /* P1PWGAG00        */
    unsigned char  P2PWGAG00:1;                            /* P2PWGAG00        */
    unsigned char  P3PWGAG00:1;                            /* P3PWGAG00        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBPWGAG00:1;                            /* TBPWGAG00        */
    unsigned char  MKPWGAG00:1;                            /* MKPWGAG00        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFPWGAG00:1;                            /* RFPWGAG00        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTPWGAG00:1;                            /* CTPWGAG00        */
};
struct __tag98
{                                                          /* Bit Access       */
    unsigned char  P0FLERR:1;                              /* P0FLERR          */
    unsigned char  P1FLERR:1;                              /* P1FLERR          */
    unsigned char  P2FLERR:1;                              /* P2FLERR          */
    unsigned char  P3FLERR:1;                              /* P3FLERR          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBFLERR:1;                              /* TBFLERR          */
    unsigned char  MKFLERR:1;                              /* MKFLERR          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFFLERR:1;                              /* RFFLERR          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTFLERR:1;                              /* CTFLERR          */
};
struct __tag99
{                                                          /* Bit Access       */
    unsigned char  P0FLENDNM:1;                            /* P0FLENDNM        */
    unsigned char  P1FLENDNM:1;                            /* P1FLENDNM        */
    unsigned char  P2FLENDNM:1;                            /* P2FLENDNM        */
    unsigned char  P3FLENDNM:1;                            /* P3FLENDNM        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBFLENDNM:1;                            /* TBFLENDNM        */
    unsigned char  MKFLENDNM:1;                            /* MKFLENDNM        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFFLENDNM:1;                            /* RFFLENDNM        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTFLENDNM:1;                            /* CTFLENDNM        */
};
struct __tag100
{                                                          /* Bit Access       */
    unsigned char  P0CWEND:1;                              /* P0CWEND          */
    unsigned char  P1CWEND:1;                              /* P1CWEND          */
    unsigned char  P2CWEND:1;                              /* P2CWEND          */
    unsigned char  P3CWEND:1;                              /* P3CWEND          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBCWEND:1;                              /* TBCWEND          */
    unsigned char  MKCWEND:1;                              /* MKCWEND          */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFCWEND:1;                              /* RFCWEND          */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTCWEND:1;                              /* CTCWEND          */
};
struct __tag101
{                                                          /* Bit Access       */
    unsigned char  P0RCAN1ERR:1;                           /* P0RCAN1ERR       */
    unsigned char  P1RCAN1ERR:1;                           /* P1RCAN1ERR       */
    unsigned char  P2RCAN1ERR:1;                           /* P2RCAN1ERR       */
    unsigned char  P3RCAN1ERR:1;                           /* P3RCAN1ERR       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCAN1ERR:1;                           /* TBRCAN1ERR       */
    unsigned char  MKRCAN1ERR:1;                           /* MKRCAN1ERR       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCAN1ERR:1;                           /* RFRCAN1ERR       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCAN1ERR:1;                           /* CTRCAN1ERR       */
};
struct __tag102
{                                                          /* Bit Access       */
    unsigned char  P0RCAN1REC:1;                           /* P0RCAN1REC       */
    unsigned char  P1RCAN1REC:1;                           /* P1RCAN1REC       */
    unsigned char  P2RCAN1REC:1;                           /* P2RCAN1REC       */
    unsigned char  P3RCAN1REC:1;                           /* P3RCAN1REC       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCAN1REC:1;                           /* TBRCAN1REC       */
    unsigned char  MKRCAN1REC:1;                           /* MKRCAN1REC       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCAN1REC:1;                           /* RFRCAN1REC       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCAN1REC:1;                           /* CTRCAN1REC       */
};
struct __tag103
{                                                          /* Bit Access       */
    unsigned char  P0RCAN1TRX:1;                           /* P0RCAN1TRX       */
    unsigned char  P1RCAN1TRX:1;                           /* P1RCAN1TRX       */
    unsigned char  P2RCAN1TRX:1;                           /* P2RCAN1TRX       */
    unsigned char  P3RCAN1TRX:1;                           /* P3RCAN1TRX       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCAN1TRX:1;                           /* TBRCAN1TRX       */
    unsigned char  MKRCAN1TRX:1;                           /* MKRCAN1TRX       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCAN1TRX:1;                           /* RFRCAN1TRX       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCAN1TRX:1;                           /* CTRCAN1TRX       */
};
struct __tag104
{                                                          /* Bit Access       */
    unsigned char  P0TAPA0IPEK0_2:1;                       /* P0TAPA0IPEK0_2   */
    unsigned char  P1TAPA0IPEK0_2:1;                       /* P1TAPA0IPEK0_2   */
    unsigned char  P2TAPA0IPEK0_2:1;                       /* P2TAPA0IPEK0_2   */
    unsigned char  P3TAPA0IPEK0_2:1;                       /* P3TAPA0IPEK0_2   */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAPA0IPEK0_2:1;                       /* TBTAPA0IPEK0_2   */
    unsigned char  MKTAPA0IPEK0_2:1;                       /* MKTAPA0IPEK0_2   */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAPA0IPEK0_2:1;                       /* RFTAPA0IPEK0_2   */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAPA0IPEK0_2:1;                       /* CTTAPA0IPEK0_2   */
};
struct __tag105
{                                                          /* Bit Access       */
    unsigned char  P0TAPA0IVLY0_2:1;                       /* P0TAPA0IVLY0_2   */
    unsigned char  P1TAPA0IVLY0_2:1;                       /* P1TAPA0IVLY0_2   */
    unsigned char  P2TAPA0IVLY0_2:1;                       /* P2TAPA0IVLY0_2   */
    unsigned char  P3TAPA0IVLY0_2:1;                       /* P3TAPA0IVLY0_2   */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAPA0IVLY0_2:1;                       /* TBTAPA0IVLY0_2   */
    unsigned char  MKTAPA0IVLY0_2:1;                       /* MKTAPA0IVLY0_2   */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAPA0IVLY0_2:1;                       /* RFTAPA0IVLY0_2   */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAPA0IVLY0_2:1;                       /* CTTAPA0IVLY0_2   */
};
struct __tag106
{                                                          /* Bit Access       */
    unsigned char  P0CSIG0IC_2:1;                          /* P0CSIG0IC_2      */
    unsigned char  P1CSIG0IC_2:1;                          /* P1CSIG0IC_2      */
    unsigned char  P2CSIG0IC_2:1;                          /* P2CSIG0IC_2      */
    unsigned char  P3CSIG0IC_2:1;                          /* P3CSIG0IC_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBCSIG0IC_2:1;                          /* TBCSIG0IC_2      */
    unsigned char  MKCSIG0IC_2:1;                          /* MKCSIG0IC_2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFCSIG0IC_2:1;                          /* RFCSIG0IC_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTCSIG0IC_2:1;                          /* CTCSIG0IC_2      */
};
struct __tag107
{                                                          /* Bit Access       */
    unsigned char  P0CSIG0IR_2:1;                          /* P0CSIG0IR_2      */
    unsigned char  P1CSIG0IR_2:1;                          /* P1CSIG0IR_2      */
    unsigned char  P2CSIG0IR_2:1;                          /* P2CSIG0IR_2      */
    unsigned char  P3CSIG0IR_2:1;                          /* P3CSIG0IR_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBCSIG0IR_2:1;                          /* TBCSIG0IR_2      */
    unsigned char  MKCSIG0IR_2:1;                          /* MKCSIG0IR_2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFCSIG0IR_2:1;                          /* RFCSIG0IR_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTCSIG0IR_2:1;                          /* CTCSIG0IR_2      */
};
struct __tag108
{                                                          /* Bit Access       */
    unsigned char  P0RLIN31:1;                             /* P0RLIN31         */
    unsigned char  P1RLIN31:1;                             /* P1RLIN31         */
    unsigned char  P2RLIN31:1;                             /* P2RLIN31         */
    unsigned char  P3RLIN31:1;                             /* P3RLIN31         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN31:1;                             /* TBRLIN31         */
    unsigned char  MKRLIN31:1;                             /* MKRLIN31         */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN31:1;                             /* RFRLIN31         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN31:1;                             /* CTRLIN31         */
};
struct __tag109
{                                                          /* Bit Access       */
    unsigned char  P0RLIN31UR0:1;                          /* P0RLIN31UR0      */
    unsigned char  P1RLIN31UR0:1;                          /* P1RLIN31UR0      */
    unsigned char  P2RLIN31UR0:1;                          /* P2RLIN31UR0      */
    unsigned char  P3RLIN31UR0:1;                          /* P3RLIN31UR0      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN31UR0:1;                          /* TBRLIN31UR0      */
    unsigned char  MKRLIN31UR0:1;                          /* MKRLIN31UR0      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN31UR0:1;                          /* RFRLIN31UR0      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN31UR0:1;                          /* CTRLIN31UR0      */
};
struct __tag110
{                                                          /* Bit Access       */
    unsigned char  P0RLIN31UR1:1;                          /* P0RLIN31UR1      */
    unsigned char  P1RLIN31UR1:1;                          /* P1RLIN31UR1      */
    unsigned char  P2RLIN31UR1:1;                          /* P2RLIN31UR1      */
    unsigned char  P3RLIN31UR1:1;                          /* P3RLIN31UR1      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN31UR1:1;                          /* TBRLIN31UR1      */
    unsigned char  MKRLIN31UR1:1;                          /* MKRLIN31UR1      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN31UR1:1;                          /* RFRLIN31UR1      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN31UR1:1;                          /* CTRLIN31UR1      */
};
struct __tag111
{                                                          /* Bit Access       */
    unsigned char  P0RLIN31UR2:1;                          /* P0RLIN31UR2      */
    unsigned char  P1RLIN31UR2:1;                          /* P1RLIN31UR2      */
    unsigned char  P2RLIN31UR2:1;                          /* P2RLIN31UR2      */
    unsigned char  P3RLIN31UR2:1;                          /* P3RLIN31UR2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRLIN31UR2:1;                          /* TBRLIN31UR2      */
    unsigned char  MKRLIN31UR2:1;                          /* MKRLIN31UR2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRLIN31UR2:1;                          /* RFRLIN31UR2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRLIN31UR2:1;                          /* CTRLIN31UR2      */
};
struct __tag112
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I0_2:1;                          /* P0TAUD0I0_2      */
    unsigned char  P1TAUD0I0_2:1;                          /* P1TAUD0I0_2      */
    unsigned char  P2TAUD0I0_2:1;                          /* P2TAUD0I0_2      */
    unsigned char  P3TAUD0I0_2:1;                          /* P3TAUD0I0_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I0_2:1;                          /* TBTAUD0I0_2      */
    unsigned char  MKTAUD0I0_2:1;                          /* MKTAUD0I0_2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I0_2:1;                          /* RFTAUD0I0_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I0_2:1;                          /* CTTAUD0I0_2      */
};
struct __tag113
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I4_2:1;                          /* P0TAUD0I4_2      */
    unsigned char  P1TAUD0I4_2:1;                          /* P1TAUD0I4_2      */
    unsigned char  P2TAUD0I4_2:1;                          /* P2TAUD0I4_2      */
    unsigned char  P3TAUD0I4_2:1;                          /* P3TAUD0I4_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I4_2:1;                          /* TBTAUD0I4_2      */
    unsigned char  MKTAUD0I4_2:1;                          /* MKTAUD0I4_2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I4_2:1;                          /* RFTAUD0I4_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I4_2:1;                          /* CTTAUD0I4_2      */
};
struct __tag114
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I6_2:1;                          /* P0TAUD0I6_2      */
    unsigned char  P1TAUD0I6_2:1;                          /* P1TAUD0I6_2      */
    unsigned char  P2TAUD0I6_2:1;                          /* P2TAUD0I6_2      */
    unsigned char  P3TAUD0I6_2:1;                          /* P3TAUD0I6_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I6_2:1;                          /* TBTAUD0I6_2      */
    unsigned char  MKTAUD0I6_2:1;                          /* MKTAUD0I6_2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I6_2:1;                          /* RFTAUD0I6_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I6_2:1;                          /* CTTAUD0I6_2      */
};
struct __tag115
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I8_2:1;                          /* P0TAUD0I8_2      */
    unsigned char  P1TAUD0I8_2:1;                          /* P1TAUD0I8_2      */
    unsigned char  P2TAUD0I8_2:1;                          /* P2TAUD0I8_2      */
    unsigned char  P3TAUD0I8_2:1;                          /* P3TAUD0I8_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I8_2:1;                          /* TBTAUD0I8_2      */
    unsigned char  MKTAUD0I8_2:1;                          /* MKTAUD0I8_2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I8_2:1;                          /* RFTAUD0I8_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I8_2:1;                          /* CTTAUD0I8_2      */
};
struct __tag116
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I2_2:1;                          /* P0TAUD0I2_2      */
    unsigned char  P1TAUD0I2_2:1;                          /* P1TAUD0I2_2      */
    unsigned char  P2TAUD0I2_2:1;                          /* P2TAUD0I2_2      */
    unsigned char  P3TAUD0I2_2:1;                          /* P3TAUD0I2_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I2_2:1;                          /* TBTAUD0I2_2      */
    unsigned char  MKTAUD0I2_2:1;                          /* MKTAUD0I2_2      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I2_2:1;                          /* RFTAUD0I2_2      */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I2_2:1;                          /* CTTAUD0I2_2      */
};
struct __tag117
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I10_2:1;                         /* P0TAUD0I10_2     */
    unsigned char  P1TAUD0I10_2:1;                         /* P1TAUD0I10_2     */
    unsigned char  P2TAUD0I10_2:1;                         /* P2TAUD0I10_2     */
    unsigned char  P3TAUD0I10_2:1;                         /* P3TAUD0I10_2     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I10_2:1;                         /* TBTAUD0I10_2     */
    unsigned char  MKTAUD0I10_2:1;                         /* MKTAUD0I10_2     */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I10_2:1;                         /* RFTAUD0I10_2     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I10_2:1;                         /* CTTAUD0I10_2     */
};
struct __tag118
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I12_2:1;                         /* P0TAUD0I12_2     */
    unsigned char  P1TAUD0I12_2:1;                         /* P1TAUD0I12_2     */
    unsigned char  P2TAUD0I12_2:1;                         /* P2TAUD0I12_2     */
    unsigned char  P3TAUD0I12_2:1;                         /* P3TAUD0I12_2     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I12_2:1;                         /* TBTAUD0I12_2     */
    unsigned char  MKTAUD0I12_2:1;                         /* MKTAUD0I12_2     */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I12_2:1;                         /* RFTAUD0I12_2     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I12_2:1;                         /* CTTAUD0I12_2     */
};
struct __tag119
{                                                          /* Bit Access       */
    unsigned char  P0TAUD0I14_2:1;                         /* P0TAUD0I14_2     */
    unsigned char  P1TAUD0I14_2:1;                         /* P1TAUD0I14_2     */
    unsigned char  P2TAUD0I14_2:1;                         /* P2TAUD0I14_2     */
    unsigned char  P3TAUD0I14_2:1;                         /* P3TAUD0I14_2     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUD0I14_2:1;                         /* TBTAUD0I14_2     */
    unsigned char  MKTAUD0I14_2:1;                         /* MKTAUD0I14_2     */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUD0I14_2:1;                         /* RFTAUD0I14_2     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUD0I14_2:1;                         /* CTTAUD0I14_2     */
};
struct __tag120
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ1I0:1;                            /* P0TAUJ1I0        */
    unsigned char  P1TAUJ1I0:1;                            /* P1TAUJ1I0        */
    unsigned char  P2TAUJ1I0:1;                            /* P2TAUJ1I0        */
    unsigned char  P3TAUJ1I0:1;                            /* P3TAUJ1I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ1I0:1;                            /* TBTAUJ1I0        */
    unsigned char  MKTAUJ1I0:1;                            /* MKTAUJ1I0        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ1I0:1;                            /* RFTAUJ1I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ1I0:1;                            /* CTTAUJ1I0        */
};
struct __tag121
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ1I1:1;                            /* P0TAUJ1I1        */
    unsigned char  P1TAUJ1I1:1;                            /* P1TAUJ1I1        */
    unsigned char  P2TAUJ1I1:1;                            /* P2TAUJ1I1        */
    unsigned char  P3TAUJ1I1:1;                            /* P3TAUJ1I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ1I1:1;                            /* TBTAUJ1I1        */
    unsigned char  MKTAUJ1I1:1;                            /* MKTAUJ1I1        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ1I1:1;                            /* RFTAUJ1I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ1I1:1;                            /* CTTAUJ1I1        */
};
struct __tag122
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ1I2:1;                            /* P0TAUJ1I2        */
    unsigned char  P1TAUJ1I2:1;                            /* P1TAUJ1I2        */
    unsigned char  P2TAUJ1I2:1;                            /* P2TAUJ1I2        */
    unsigned char  P3TAUJ1I2:1;                            /* P3TAUJ1I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ1I2:1;                            /* TBTAUJ1I2        */
    unsigned char  MKTAUJ1I2:1;                            /* MKTAUJ1I2        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ1I2:1;                            /* RFTAUJ1I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ1I2:1;                            /* CTTAUJ1I2        */
};
struct __tag123
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ1I3:1;                            /* P0TAUJ1I3        */
    unsigned char  P1TAUJ1I3:1;                            /* P1TAUJ1I3        */
    unsigned char  P2TAUJ1I3:1;                            /* P2TAUJ1I3        */
    unsigned char  P3TAUJ1I3:1;                            /* P3TAUJ1I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ1I3:1;                            /* TBTAUJ1I3        */
    unsigned char  MKTAUJ1I3:1;                            /* MKTAUJ1I3        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ1I3:1;                            /* RFTAUJ1I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ1I3:1;                            /* CTTAUJ1I3        */
};
struct __tag124
{                                                          /* Bit Access       */
    unsigned char  P0RTCA01S:1;                            /* P0RTCA01S        */
    unsigned char  P1RTCA01S:1;                            /* P1RTCA01S        */
    unsigned char  P2RTCA01S:1;                            /* P2RTCA01S        */
    unsigned char  P3RTCA01S:1;                            /* P3RTCA01S        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRTCA01S:1;                            /* TBRTCA01S        */
    unsigned char  MKRTCA01S:1;                            /* MKRTCA01S        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRTCA01S:1;                            /* RFRTCA01S        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRTCA01S:1;                            /* CTRTCA01S        */
};
struct __tag125
{                                                          /* Bit Access       */
    unsigned char  P0RTCA0AL:1;                            /* P0RTCA0AL        */
    unsigned char  P1RTCA0AL:1;                            /* P1RTCA0AL        */
    unsigned char  P2RTCA0AL:1;                            /* P2RTCA0AL        */
    unsigned char  P3RTCA0AL:1;                            /* P3RTCA0AL        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRTCA0AL:1;                            /* TBRTCA0AL        */
    unsigned char  MKRTCA0AL:1;                            /* MKRTCA0AL        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRTCA0AL:1;                            /* RFRTCA0AL        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRTCA0AL:1;                            /* CTRTCA0AL        */
};
struct __tag126
{                                                          /* Bit Access       */
    unsigned char  P0RTCA0R:1;                             /* P0RTCA0R         */
    unsigned char  P1RTCA0R:1;                             /* P1RTCA0R         */
    unsigned char  P2RTCA0R:1;                             /* P2RTCA0R         */
    unsigned char  P3RTCA0R:1;                             /* P3RTCA0R         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRTCA0R:1;                             /* TBRTCA0R         */
    unsigned char  MKRTCA0R:1;                             /* MKRTCA0R         */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRTCA0R:1;                             /* RFRTCA0R         */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRTCA0R:1;                             /* CTRTCA0R         */
};
struct __tag127
{                                                          /* Bit Access       */
    unsigned char  P0RCAN2ERR:1;                           /* P0RCAN2ERR       */
    unsigned char  P1RCAN2ERR:1;                           /* P1RCAN2ERR       */
    unsigned char  P2RCAN2ERR:1;                           /* P2RCAN2ERR       */
    unsigned char  P3RCAN2ERR:1;                           /* P3RCAN2ERR       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCAN2ERR:1;                           /* TBRCAN2ERR       */
    unsigned char  MKRCAN2ERR:1;                           /* MKRCAN2ERR       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCAN2ERR:1;                           /* RFRCAN2ERR       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCAN2ERR:1;                           /* CTRCAN2ERR       */
};
struct __tag128
{                                                          /* Bit Access       */
    unsigned char  P0RCAN2REC:1;                           /* P0RCAN2REC       */
    unsigned char  P1RCAN2REC:1;                           /* P1RCAN2REC       */
    unsigned char  P2RCAN2REC:1;                           /* P2RCAN2REC       */
    unsigned char  P3RCAN2REC:1;                           /* P3RCAN2REC       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCAN2REC:1;                           /* TBRCAN2REC       */
    unsigned char  MKRCAN2REC:1;                           /* MKRCAN2REC       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCAN2REC:1;                           /* RFRCAN2REC       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCAN2REC:1;                           /* CTRCAN2REC       */
};
struct __tag129
{                                                          /* Bit Access       */
    unsigned char  P0RCAN2TRX:1;                           /* P0RCAN2TRX       */
    unsigned char  P1RCAN2TRX:1;                           /* P1RCAN2TRX       */
    unsigned char  P2RCAN2TRX:1;                           /* P2RCAN2TRX       */
    unsigned char  P3RCAN2TRX:1;                           /* P3RCAN2TRX       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRCAN2TRX:1;                           /* TBRCAN2TRX       */
    unsigned char  MKRCAN2TRX:1;                           /* MKRCAN2TRX       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRCAN2TRX:1;                           /* RFRCAN2TRX       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRCAN2TRX:1;                           /* CTRCAN2TRX       */
};
struct __tag130
{                                                          /* Bit Access       */
    unsigned char  P0RIIC1TI:1;                            /* P0RIIC1TI        */
    unsigned char  P1RIIC1TI:1;                            /* P1RIIC1TI        */
    unsigned char  P2RIIC1TI:1;                            /* P2RIIC1TI        */
    unsigned char  P3RIIC1TI:1;                            /* P3RIIC1TI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRIIC1TI:1;                            /* TBRIIC1TI        */
    unsigned char  MKRIIC1TI:1;                            /* MKRIIC1TI        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRIIC1TI:1;                            /* RFRIIC1TI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRIIC1TI:1;                            /* CTRIIC1TI        */
};
struct __tag131
{                                                          /* Bit Access       */
    unsigned char  P0RIIC1EE:1;                            /* P0RIIC1EE        */
    unsigned char  P1RIIC1EE:1;                            /* P1RIIC1EE        */
    unsigned char  P2RIIC1EE:1;                            /* P2RIIC1EE        */
    unsigned char  P3RIIC1EE:1;                            /* P3RIIC1EE        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRIIC1EE:1;                            /* TBRIIC1EE        */
    unsigned char  MKRIIC1EE:1;                            /* MKRIIC1EE        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRIIC1EE:1;                            /* RFRIIC1EE        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRIIC1EE:1;                            /* CTRIIC1EE        */
};
struct __tag132
{                                                          /* Bit Access       */
    unsigned char  P0RIIC1RI:1;                            /* P0RIIC1RI        */
    unsigned char  P1RIIC1RI:1;                            /* P1RIIC1RI        */
    unsigned char  P2RIIC1RI:1;                            /* P2RIIC1RI        */
    unsigned char  P3RIIC1RI:1;                            /* P3RIIC1RI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRIIC1RI:1;                            /* TBRIIC1RI        */
    unsigned char  MKRIIC1RI:1;                            /* MKRIIC1RI        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRIIC1RI:1;                            /* RFRIIC1RI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRIIC1RI:1;                            /* CTRIIC1RI        */
};
struct __tag133
{                                                          /* Bit Access       */
    unsigned char  P0RIIC1TEI:1;                           /* P0RIIC1TEI       */
    unsigned char  P1RIIC1TEI:1;                           /* P1RIIC1TEI       */
    unsigned char  P2RIIC1TEI:1;                           /* P2RIIC1TEI       */
    unsigned char  P3RIIC1TEI:1;                           /* P3RIIC1TEI       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBRIIC1TEI:1;                           /* TBRIIC1TEI       */
    unsigned char  MKRIIC1TEI:1;                           /* MKRIIC1TEI       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFRIIC1TEI:1;                           /* RFRIIC1TEI       */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTRIIC1TEI:1;                           /* CTRIIC1TEI       */
};
struct __tag134
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ2I0:1;                            /* P0TAUJ2I0        */
    unsigned char  P1TAUJ2I0:1;                            /* P1TAUJ2I0        */
    unsigned char  P2TAUJ2I0:1;                            /* P2TAUJ2I0        */
    unsigned char  P3TAUJ2I0:1;                            /* P3TAUJ2I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ2I0:1;                            /* TBTAUJ2I0        */
    unsigned char  MKTAUJ2I0:1;                            /* MKTAUJ2I0        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ2I0:1;                            /* RFTAUJ2I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ2I0:1;                            /* CTTAUJ2I0        */
};
struct __tag135
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ2I1:1;                            /* P0TAUJ2I1        */
    unsigned char  P1TAUJ2I1:1;                            /* P1TAUJ2I1        */
    unsigned char  P2TAUJ2I1:1;                            /* P2TAUJ2I1        */
    unsigned char  P3TAUJ2I1:1;                            /* P3TAUJ2I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ2I1:1;                            /* TBTAUJ2I1        */
    unsigned char  MKTAUJ2I1:1;                            /* MKTAUJ2I1        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ2I1:1;                            /* RFTAUJ2I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ2I1:1;                            /* CTTAUJ2I1        */
};
struct __tag136
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ2I2:1;                            /* P0TAUJ2I2        */
    unsigned char  P1TAUJ2I2:1;                            /* P1TAUJ2I2        */
    unsigned char  P2TAUJ2I2:1;                            /* P2TAUJ2I2        */
    unsigned char  P3TAUJ2I2:1;                            /* P3TAUJ2I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ2I2:1;                            /* TBTAUJ2I2        */
    unsigned char  MKTAUJ2I2:1;                            /* MKTAUJ2I2        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ2I2:1;                            /* RFTAUJ2I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ2I2:1;                            /* CTTAUJ2I2        */
};
struct __tag137
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ2I3:1;                            /* P0TAUJ2I3        */
    unsigned char  P1TAUJ2I3:1;                            /* P1TAUJ2I3        */
    unsigned char  P2TAUJ2I3:1;                            /* P2TAUJ2I3        */
    unsigned char  P3TAUJ2I3:1;                            /* P3TAUJ2I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ2I3:1;                            /* TBTAUJ2I3        */
    unsigned char  MKTAUJ2I3:1;                            /* MKTAUJ2I3        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ2I3:1;                            /* RFTAUJ2I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ2I3:1;                            /* CTTAUJ2I3        */
};
struct __tag138
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ3I0:1;                            /* P0TAUJ3I0        */
    unsigned char  P1TAUJ3I0:1;                            /* P1TAUJ3I0        */
    unsigned char  P2TAUJ3I0:1;                            /* P2TAUJ3I0        */
    unsigned char  P3TAUJ3I0:1;                            /* P3TAUJ3I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ3I0:1;                            /* TBTAUJ3I0        */
    unsigned char  MKTAUJ3I0:1;                            /* MKTAUJ3I0        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ3I0:1;                            /* RFTAUJ3I0        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ3I0:1;                            /* CTTAUJ3I0        */
};
struct __tag139
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ3I1:1;                            /* P0TAUJ3I1        */
    unsigned char  P1TAUJ3I1:1;                            /* P1TAUJ3I1        */
    unsigned char  P2TAUJ3I1:1;                            /* P2TAUJ3I1        */
    unsigned char  P3TAUJ3I1:1;                            /* P3TAUJ3I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ3I1:1;                            /* TBTAUJ3I1        */
    unsigned char  MKTAUJ3I1:1;                            /* MKTAUJ3I1        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ3I1:1;                            /* RFTAUJ3I1        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ3I1:1;                            /* CTTAUJ3I1        */
};
struct __tag140
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ3I2:1;                            /* P0TAUJ3I2        */
    unsigned char  P1TAUJ3I2:1;                            /* P1TAUJ3I2        */
    unsigned char  P2TAUJ3I2:1;                            /* P2TAUJ3I2        */
    unsigned char  P3TAUJ3I2:1;                            /* P3TAUJ3I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ3I2:1;                            /* TBTAUJ3I2        */
    unsigned char  MKTAUJ3I2:1;                            /* MKTAUJ3I2        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ3I2:1;                            /* RFTAUJ3I2        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ3I2:1;                            /* CTTAUJ3I2        */
};
struct __tag141
{                                                          /* Bit Access       */
    unsigned char  P0TAUJ3I3:1;                            /* P0TAUJ3I3        */
    unsigned char  P1TAUJ3I3:1;                            /* P1TAUJ3I3        */
    unsigned char  P2TAUJ3I3:1;                            /* P2TAUJ3I3        */
    unsigned char  P3TAUJ3I3:1;                            /* P3TAUJ3I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBTAUJ3I3:1;                            /* TBTAUJ3I3        */
    unsigned char  MKTAUJ3I3:1;                            /* MKTAUJ3I3        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFTAUJ3I3:1;                            /* RFTAUJ3I3        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTTAUJ3I3:1;                            /* CTTAUJ3I3        */
};
struct __tag142
{                                                          /* Bit Access       */
    unsigned char  P0SENT0SI:1;                            /* P0SENT0SI        */
    unsigned char  P1SENT0SI:1;                            /* P1SENT0SI        */
    unsigned char  P2SENT0SI:1;                            /* P2SENT0SI        */
    unsigned char  P3SENT0SI:1;                            /* P3SENT0SI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBSENT0SI:1;                            /* TBSENT0SI        */
    unsigned char  MKSENT0SI:1;                            /* MKSENT0SI        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFSENT0SI:1;                            /* RFSENT0SI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTSENT0SI:1;                            /* CTSENT0SI        */
};
struct __tag143
{                                                          /* Bit Access       */
    unsigned char  P0SENT0RI:1;                            /* P0SENT0RI        */
    unsigned char  P1SENT0RI:1;                            /* P1SENT0RI        */
    unsigned char  P2SENT0RI:1;                            /* P2SENT0RI        */
    unsigned char  P3SENT0RI:1;                            /* P3SENT0RI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBSENT0RI:1;                            /* TBSENT0RI        */
    unsigned char  MKSENT0RI:1;                            /* MKSENT0RI        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFSENT0RI:1;                            /* RFSENT0RI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTSENT0RI:1;                            /* CTSENT0RI        */
};
struct __tag144
{                                                          /* Bit Access       */
    unsigned char  P0SENT1SI:1;                            /* P0SENT1SI        */
    unsigned char  P1SENT1SI:1;                            /* P1SENT1SI        */
    unsigned char  P2SENT1SI:1;                            /* P2SENT1SI        */
    unsigned char  P3SENT1SI:1;                            /* P3SENT1SI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBSENT1SI:1;                            /* TBSENT1SI        */
    unsigned char  MKSENT1SI:1;                            /* MKSENT1SI        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFSENT1SI:1;                            /* RFSENT1SI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTSENT1SI:1;                            /* CTSENT1SI        */
};
struct __tag145
{                                                          /* Bit Access       */
    unsigned char  P0SENT1RI:1;                            /* P0SENT1RI        */
    unsigned char  P1SENT1RI:1;                            /* P1SENT1RI        */
    unsigned char  P2SENT1RI:1;                            /* P2SENT1RI        */
    unsigned char  P3SENT1RI:1;                            /* P3SENT1RI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBSENT1RI:1;                            /* TBSENT1RI        */
    unsigned char  MKSENT1RI:1;                            /* MKSENT1RI        */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFSENT1RI:1;                            /* RFSENT1RI        */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTSENT1RI:1;                            /* CTSENT1RI        */
};
struct __tag146
{                                                          /* Bit Access       */
    unsigned char  P0DPE:1;                                /* P0DPE            */
    unsigned char  P1DPE:1;                                /* P1DPE            */
    unsigned char  P2DPE:1;                                /* P2DPE            */
    unsigned char  P3DPE:1;                                /* P3DPE            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBDPE:1;                                /* TBDPE            */
    unsigned char  MKDPE:1;                                /* MKDPE            */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFDPE:1;                                /* RFDPE            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTDPE:1;                                /* CTDPE            */
};
struct __tag147
{                                                          /* Bit Access       */
    unsigned char  P0APE:1;                                /* P0APE            */
    unsigned char  P1APE:1;                                /* P1APE            */
    unsigned char  P2APE:1;                                /* P2APE            */
    unsigned char  P3APE:1;                                /* P3APE            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  TBAPE:1;                                /* TBAPE            */
    unsigned char  MKAPE:1;                                /* MKAPE            */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  RFAPE:1;                                /* RFAPE            */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  CTAPE:1;                                /* CTAPE            */
};
struct __tag148
{                                                          /* Bit Access       */
    unsigned char  IMR1EIMK32:1;                           /* IMR1EIMK32       */
    unsigned char  IMR1EIMK33:1;                           /* IMR1EIMK33       */
    unsigned char  IMR1EIMK34:1;                           /* IMR1EIMK34       */
    unsigned char  IMR1EIMK35:1;                           /* IMR1EIMK35       */
    unsigned char  IMR1EIMK36:1;                           /* IMR1EIMK36       */
    unsigned char  IMR1EIMK37:1;                           /* IMR1EIMK37       */
    unsigned char  IMR1EIMK38:1;                           /* IMR1EIMK38       */
    unsigned char  IMR1EIMK39:1;                           /* IMR1EIMK39       */
    unsigned char  IMR1EIMK40:1;                           /* IMR1EIMK40       */
    unsigned char  IMR1EIMK41:1;                           /* IMR1EIMK41       */
    unsigned char  :1;                                     /* Reserved Bits    */
    unsigned char  IMR1EIMK43:1;                           /* IMR1EIMK43       */
    unsigned char  IMR1EIMK44:1;                           /* IMR1EIMK44       */
    unsigned char  IMR1EIMK45:1;                           /* IMR1EIMK45       */
    unsigned char  IMR1EIMK46:1;                           /* IMR1EIMK46       */
    unsigned char  IMR1EIMK47:1;                           /* IMR1EIMK47       */
    unsigned char  IMR1EIMK48:1;                           /* IMR1EIMK48       */
    unsigned char  IMR1EIMK49:1;                           /* IMR1EIMK49       */
    unsigned char  IMR1EIMK50:1;                           /* IMR1EIMK50       */
    unsigned char  IMR1EIMK51:1;                           /* IMR1EIMK51       */
    unsigned char  IMR1EIMK52:1;                           /* IMR1EIMK52       */
    unsigned char  IMR1EIMK53:1;                           /* IMR1EIMK53       */
    unsigned char  IMR1EIMK54:1;                           /* IMR1EIMK54       */
    unsigned char  IMR1EIMK55:1;                           /* IMR1EIMK55       */
    unsigned char  IMR1EIMK56:1;                           /* IMR1EIMK56       */
    unsigned char  IMR1EIMK57:1;                           /* IMR1EIMK57       */
    unsigned char  IMR1EIMK58:1;                           /* IMR1EIMK58       */
    unsigned char  IMR1EIMK59:1;                           /* IMR1EIMK59       */
    unsigned char  IMR1EIMK60:1;                           /* IMR1EIMK60       */
    unsigned char  IMR1EIMK61:1;                           /* IMR1EIMK61       */
    unsigned char  IMR1EIMK62:1;                           /* IMR1EIMK62       */
    unsigned char  IMR1EIMK63:1;                           /* IMR1EIMK63       */
};
struct __tag149
{                                                          /* Bit Access       */
    unsigned char  IMR2EIMK64:1;                           /* IMR2EIMK64       */
    unsigned char  IMR2EIMK65:1;                           /* IMR2EIMK65       */
    unsigned char  IMR2EIMK66:1;                           /* IMR2EIMK66       */
    unsigned char  IMR2EIMK67:1;                           /* IMR2EIMK67       */
    unsigned char  IMR2EIMK68:1;                           /* IMR2EIMK68       */
    unsigned char  IMR2EIMK69:1;                           /* IMR2EIMK69       */
    unsigned char  IMR2EIMK70:1;                           /* IMR2EIMK70       */
    unsigned char  IMR2EIMK71:1;                           /* IMR2EIMK71       */
    unsigned char  IMR2EIMK72:1;                           /* IMR2EIMK72       */
    unsigned char  IMR2EIMK73:1;                           /* IMR2EIMK73       */
    unsigned char  IMR2EIMK74:1;                           /* IMR2EIMK74       */
    unsigned char  IMR2EIMK75:1;                           /* IMR2EIMK75       */
    unsigned char  IMR2EIMK76:1;                           /* IMR2EIMK76       */
    unsigned char  IMR2EIMK77:1;                           /* IMR2EIMK77       */
    unsigned char  IMR2EIMK78:1;                           /* IMR2EIMK78       */
    unsigned char  IMR2EIMK79:1;                           /* IMR2EIMK79       */
    unsigned char  IMR2EIMK80:1;                           /* IMR2EIMK80       */
    unsigned char  IMR2EIMK81:1;                           /* IMR2EIMK81       */
    unsigned char  IMR2EIMK82:1;                           /* IMR2EIMK82       */
    unsigned char  IMR2EIMK83:1;                           /* IMR2EIMK83       */
    unsigned char  IMR2EIMK84:1;                           /* IMR2EIMK84       */
    unsigned char  IMR2EIMK85:1;                           /* IMR2EIMK85       */
    unsigned char  IMR2EIMK86:1;                           /* IMR2EIMK86       */
    unsigned char  IMR2EIMK87:1;                           /* IMR2EIMK87       */
    unsigned char  IMR2EIMK88:1;                           /* IMR2EIMK88       */
    unsigned char  IMR2EIMK89:1;                           /* IMR2EIMK89       */
    unsigned char  IMR2EIMK90:1;                           /* IMR2EIMK90       */
    unsigned char  IMR2EIMK91:1;                           /* IMR2EIMK91       */
    unsigned char  IMR2EIMK92:1;                           /* IMR2EIMK92       */
    unsigned char  :3;                                     /* Reserved Bits    */
};
struct __tag150
{                                                          /* Bit Access       */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :6;                                     /* Reserved Bits    */
    unsigned char  IMR3EIMK110:1;                          /* IMR3EIMK110      */
    unsigned char  IMR3EIMK111:1;                          /* IMR3EIMK111      */
    unsigned char  IMR3EIMK112:1;                          /* IMR3EIMK112      */
    unsigned char  IMR3EIMK113:1;                          /* IMR3EIMK113      */
    unsigned char  IMR3EIMK114:1;                          /* IMR3EIMK114      */
    unsigned char  IMR3EIMK115:1;                          /* IMR3EIMK115      */
    unsigned char  IMR3EIMK116:1;                          /* IMR3EIMK116      */
    unsigned char  IMR3EIMK117:1;                          /* IMR3EIMK117      */
    unsigned char  IMR3EIMK118:1;                          /* IMR3EIMK118      */
    unsigned char  IMR3EIMK119:1;                          /* IMR3EIMK119      */
    unsigned char  IMR3EIMK120:1;                          /* IMR3EIMK120      */
    unsigned char  IMR3EIMK121:1;                          /* IMR3EIMK121      */
    unsigned char  IMR3EIMK122:1;                          /* IMR3EIMK122      */
    unsigned char  IMR3EIMK123:1;                          /* IMR3EIMK123      */
    unsigned char  :4;                                     /* Reserved Bits    */
};
struct __tag151
{                                                          /* Bit Access       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  IMR4EIMK132:1;                          /* IMR4EIMK132      */
    unsigned char  IMR4EIMK133:1;                          /* IMR4EIMK133      */
    unsigned char  IMR4EIMK134:1;                          /* IMR4EIMK134      */
    unsigned char  IMR4EIMK135:1;                          /* IMR4EIMK135      */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :6;                                     /* Reserved Bits    */
    unsigned char  IMR4EIMK158:1;                          /* IMR4EIMK158      */
    unsigned char  IMR4EIMK159:1;                          /* IMR4EIMK159      */
};
struct __tag152
{                                                          /* Bit Access       */
    unsigned char  IMR5EIMK160:1;                          /* IMR5EIMK160      */
    unsigned char  IMR5EIMK161:1;                          /* IMR5EIMK161      */
    unsigned char  :6;                                     /* Reserved Bits    */
    unsigned char  IMR5EIMK168:1;                          /* IMR5EIMK168      */
    unsigned char  IMR5EIMK169:1;                          /* IMR5EIMK169      */
    unsigned char  IMR5EIMK170:1;                          /* IMR5EIMK170      */
    unsigned char  IMR5EIMK171:1;                          /* IMR5EIMK171      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
};
struct __tag153
{                                                          /* Bit Access       */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :1;                                     /* Reserved Bits    */
    unsigned char  IMR6EIMK209:1;                          /* IMR6EIMK209      */
    unsigned char  IMR6EIMK210:1;                          /* IMR6EIMK210      */
    unsigned char  IMR6EIMK211:1;                          /* IMR6EIMK211      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  :1;                                     /* Reserved Bits    */
    unsigned char  IMR6EIMK217:1;                          /* IMR6EIMK217      */
    unsigned char  IMR6EIMK218:1;                          /* IMR6EIMK218      */
    unsigned char  IMR6EIMK219:1;                          /* IMR6EIMK219      */
    unsigned char  :4;                                     /* Reserved Bits    */
};
struct __tag154
{                                                          /* Bit Access       */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  IMR7EIMK240:1;                          /* IMR7EIMK240      */
    unsigned char  IMR7EIMK241:1;                          /* IMR7EIMK241      */
    unsigned char  IMR7EIMK242:1;                          /* IMR7EIMK242      */
    unsigned char  IMR7EIMK243:1;                          /* IMR7EIMK243      */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
};
struct __tag155
{                                                          /* Bit Access       */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :5;                                     /* Reserved Bits    */
    unsigned char  IMR8EIMK277:1;                          /* IMR8EIMK277      */
    unsigned char  IMR8EIMK278:1;                          /* IMR8EIMK278      */
    unsigned char  IMR8EIMK279:1;                          /* IMR8EIMK279      */
    unsigned char  IMR8EIMK280:1;                          /* IMR8EIMK280      */
    unsigned char  IMR8EIMK281:1;                          /* IMR8EIMK281      */
    unsigned char  IMR8EIMK282:1;                          /* IMR8EIMK282      */
    unsigned char  IMR8EIMK283:1;                          /* IMR8EIMK283      */
    unsigned char  IMR8EIMK284:1;                          /* IMR8EIMK284      */
    unsigned char  :3;                                     /* Reserved Bits    */
};
struct __tag156
{                                                          /* Bit Access       */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :3;                                     /* Reserved Bits    */
    unsigned char  IMR10EIMK347:1;                         /* IMR10EIMK347     */
    unsigned char  IMR10EIMK348:1;                         /* IMR10EIMK348     */
    unsigned char  IMR10EIMK349:1;                         /* IMR10EIMK349     */
    unsigned char  IMR10EIMK350:1;                         /* IMR10EIMK350     */
    unsigned char  :1;                                     /* Reserved Bits    */
};
struct __tag157
{                                                          /* Bit Access       */
    unsigned char  :4;                                     /* Reserved Bits    */
    unsigned char  IMR11EIMK356:1;                         /* IMR11EIMK356     */
    unsigned char  IMR11EIMK357:1;                         /* IMR11EIMK357     */
    unsigned char  :2;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
    unsigned char  :8;                                     /* Reserved Bits    */
};
union __tag158
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
};
union __tag159
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag0 BIT;                                     /* Bit Access       */
};
union __tag160
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag1 BIT;                                     /* Bit Access       */
};
union __tag161
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag2 BIT;                                     /* Bit Access       */
};
union __tag162
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag3 BIT;                                     /* Bit Access       */
};
union __tag163
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag4 BIT;                                     /* Bit Access       */
};
union __tag164
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
};
union __tag165
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct 
    {
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } ERDB;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } ECRD;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } HORD;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } SYND;
    } REGS8;
};
union __tag166
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct 
    {
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /*  8-bit Access    */
        } LBRP0;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /*  8-bit Access    */
        } LBRP1;
    } REGS8;
};
union __tag167
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
};
union __tag168
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag5 BIT;                                     /* Bit Access       */
};
union __tag169
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag6 BIT;                                     /* Bit Access       */
};
union __tag170
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag7 BIT;                                     /* Bit Access       */
};
union __tag171
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag8 BIT;                                     /* Bit Access       */
};
union __tag172
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag9 BIT;                                     /* Bit Access       */
};
union __tag173
{                                                          /* IOR              */
    unsigned char  UINT8;                                  /* 8-bit Access     */
    struct __tag10 BIT;                                    /* Bit Access       */
};
union __tag174
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct 
    {
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPSELR1;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPSELR2;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPSELR3;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPSELR4;
    } REGS8;
};
union __tag175
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct 
    {
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPSELR5;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPSELR6;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPSELR7;
        unsigned char  dummy0[1];                          /* Reserved         */
    } REGS8;
};
union __tag176
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct 
    {
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPDSR1;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPDSR2;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPDSR3;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPDSR4;
    } REGS8;
};
union __tag177
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct 
    {
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPDSR5;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPDSR6;
        union
        {                                                  /* IOR              */
            unsigned char  UINT8;                          /* 8-bit Access     */
        } DPDSR7;
        unsigned char  dummy1[1];                          /* Reserved         */
    } REGS8;
};
union __tag178
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag11 BIT;                                    /* Bit Access       */
};
union __tag179
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag12 BIT;                                    /* Bit Access       */
};
union __tag180
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag13 BIT;                                    /* Bit Access       */
};
union __tag181
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag14 BIT;                                    /* Bit Access       */
};
union __tag182
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag15 BIT;                                    /* Bit Access       */
};
union __tag183
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag16 BIT;                                    /* Bit Access       */
};
union __tag184
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag17 BIT;                                    /* Bit Access       */
};
union __tag185
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag18 BIT;                                    /* Bit Access       */
};
union __tag186
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag19 BIT;                                    /* Bit Access       */
};
union __tag187
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag20 BIT;                                    /* Bit Access       */
};
union __tag188
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag21 BIT;                                    /* Bit Access       */
};
union __tag189
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag22 BIT;                                    /* Bit Access       */
};
union __tag190
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag23 BIT;                                    /* Bit Access       */
};
union __tag191
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag24 BIT;                                    /* Bit Access       */
};
union __tag192
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag25 BIT;                                    /* Bit Access       */
};
union __tag193
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag26 BIT;                                    /* Bit Access       */
};
union __tag194
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag27 BIT;                                    /* Bit Access       */
};
union __tag195
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag28 BIT;                                    /* Bit Access       */
};
union __tag196
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag29 BIT;                                    /* Bit Access       */
};
union __tag197
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag30 BIT;                                    /* Bit Access       */
};
union __tag198
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag31 BIT;                                    /* Bit Access       */
};
union __tag199
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag32 BIT;                                    /* Bit Access       */
};
union __tag200
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag33 BIT;                                    /* Bit Access       */
};
union __tag201
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag34 BIT;                                    /* Bit Access       */
};
union __tag202
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag35 BIT;                                    /* Bit Access       */
};
union __tag203
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag36 BIT;                                    /* Bit Access       */
};
union __tag204
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag37 BIT;                                    /* Bit Access       */
};
union __tag205
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag38 BIT;                                    /* Bit Access       */
};
union __tag206
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag39 BIT;                                    /* Bit Access       */
};
union __tag207
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag40 BIT;                                    /* Bit Access       */
};
union __tag208
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag41 BIT;                                    /* Bit Access       */
};
union __tag209
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag42 BIT;                                    /* Bit Access       */
};
union __tag210
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag43 BIT;                                    /* Bit Access       */
};
union __tag211
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag44 BIT;                                    /* Bit Access       */
};
union __tag212
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag45 BIT;                                    /* Bit Access       */
};
union __tag213
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag46 BIT;                                    /* Bit Access       */
};
union __tag214
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag47 BIT;                                    /* Bit Access       */
};
union __tag215
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag48 BIT;                                    /* Bit Access       */
};
union __tag216
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag49 BIT;                                    /* Bit Access       */
};
union __tag217
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag50 BIT;                                    /* Bit Access       */
};
union __tag218
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag51 BIT;                                    /* Bit Access       */
};
union __tag219
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag52 BIT;                                    /* Bit Access       */
};
union __tag220
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag53 BIT;                                    /* Bit Access       */
};
union __tag221
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag54 BIT;                                    /* Bit Access       */
};
union __tag222
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag55 BIT;                                    /* Bit Access       */
};
union __tag223
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag56 BIT;                                    /* Bit Access       */
};
union __tag224
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag57 BIT;                                    /* Bit Access       */
};
union __tag225
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag58 BIT;                                    /* Bit Access       */
};
union __tag226
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag59 BIT;                                    /* Bit Access       */
};
union __tag227
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag60 BIT;                                    /* Bit Access       */
};
union __tag228
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag61 BIT;                                    /* Bit Access       */
};
union __tag229
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag62 BIT;                                    /* Bit Access       */
};
union __tag230
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag63 BIT;                                    /* Bit Access       */
};
union __tag231
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag64 BIT;                                    /* Bit Access       */
};
union __tag232
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag65 BIT;                                    /* Bit Access       */
};
union __tag233
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag66 BIT;                                    /* Bit Access       */
};
union __tag234
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag67 BIT;                                    /* Bit Access       */
};
union __tag235
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag68 BIT;                                    /* Bit Access       */
};
union __tag236
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag69 BIT;                                    /* Bit Access       */
};
union __tag237
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag70 BIT;                                    /* Bit Access       */
};
union __tag238
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag71 BIT;                                    /* Bit Access       */
};
union __tag239
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag72 BIT;                                    /* Bit Access       */
};
union __tag240
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag73 BIT;                                    /* Bit Access       */
};
union __tag241
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag74 BIT;                                    /* Bit Access       */
};
union __tag242
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag75 BIT;                                    /* Bit Access       */
};
union __tag243
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag76 BIT;                                    /* Bit Access       */
};
union __tag244
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag77 BIT;                                    /* Bit Access       */
};
union __tag245
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag78 BIT;                                    /* Bit Access       */
};
union __tag246
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag79 BIT;                                    /* Bit Access       */
};
union __tag247
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag80 BIT;                                    /* Bit Access       */
};
union __tag248
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag81 BIT;                                    /* Bit Access       */
};
union __tag249
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag82 BIT;                                    /* Bit Access       */
};
union __tag250
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag83 BIT;                                    /* Bit Access       */
};
union __tag251
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag84 BIT;                                    /* Bit Access       */
};
union __tag252
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag85 BIT;                                    /* Bit Access       */
};
union __tag253
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag86 BIT;                                    /* Bit Access       */
};
union __tag254
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag87 BIT;                                    /* Bit Access       */
};
union __tag255
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag88 BIT;                                    /* Bit Access       */
};
union __tag256
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag89 BIT;                                    /* Bit Access       */
};
union __tag257
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag90 BIT;                                    /* Bit Access       */
};
union __tag258
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag91 BIT;                                    /* Bit Access       */
};
union __tag259
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag92 BIT;                                    /* Bit Access       */
};
union __tag260
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag93 BIT;                                    /* Bit Access       */
};
union __tag261
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag94 BIT;                                    /* Bit Access       */
};
union __tag262
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag95 BIT;                                    /* Bit Access       */
};
union __tag263
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag96 BIT;                                    /* Bit Access       */
};
union __tag264
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag97 BIT;                                    /* Bit Access       */
};
union __tag265
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag98 BIT;                                    /* Bit Access       */
};
union __tag266
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag99 BIT;                                    /* Bit Access       */
};
union __tag267
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag100 BIT;                                   /* Bit Access       */
};
union __tag268
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag101 BIT;                                   /* Bit Access       */
};
union __tag269
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag102 BIT;                                   /* Bit Access       */
};
union __tag270
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag103 BIT;                                   /* Bit Access       */
};
union __tag271
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag104 BIT;                                   /* Bit Access       */
};
union __tag272
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag105 BIT;                                   /* Bit Access       */
};
union __tag273
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag106 BIT;                                   /* Bit Access       */
};
union __tag274
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag107 BIT;                                   /* Bit Access       */
};
union __tag275
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag108 BIT;                                   /* Bit Access       */
};
union __tag276
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag109 BIT;                                   /* Bit Access       */
};
union __tag277
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag110 BIT;                                   /* Bit Access       */
};
union __tag278
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag111 BIT;                                   /* Bit Access       */
};
union __tag279
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag112 BIT;                                   /* Bit Access       */
};
union __tag280
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag113 BIT;                                   /* Bit Access       */
};
union __tag281
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag114 BIT;                                   /* Bit Access       */
};
union __tag282
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag115 BIT;                                   /* Bit Access       */
};
union __tag283
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag116 BIT;                                   /* Bit Access       */
};
union __tag284
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag117 BIT;                                   /* Bit Access       */
};
union __tag285
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag118 BIT;                                   /* Bit Access       */
};
union __tag286
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag119 BIT;                                   /* Bit Access       */
};
union __tag287
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag120 BIT;                                   /* Bit Access       */
};
union __tag288
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag121 BIT;                                   /* Bit Access       */
};
union __tag289
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag122 BIT;                                   /* Bit Access       */
};
union __tag290
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag123 BIT;                                   /* Bit Access       */
};
union __tag291
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag124 BIT;                                   /* Bit Access       */
};
union __tag292
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag125 BIT;                                   /* Bit Access       */
};
union __tag293
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag126 BIT;                                   /* Bit Access       */
};
union __tag294
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag127 BIT;                                   /* Bit Access       */
};
union __tag295
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag128 BIT;                                   /* Bit Access       */
};
union __tag296
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag129 BIT;                                   /* Bit Access       */
};
union __tag297
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag130 BIT;                                   /* Bit Access       */
};
union __tag298
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag131 BIT;                                   /* Bit Access       */
};
union __tag299
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag132 BIT;                                   /* Bit Access       */
};
union __tag300
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag133 BIT;                                   /* Bit Access       */
};
union __tag301
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag134 BIT;                                   /* Bit Access       */
};
union __tag302
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag135 BIT;                                   /* Bit Access       */
};
union __tag303
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag136 BIT;                                   /* Bit Access       */
};
union __tag304
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag137 BIT;                                   /* Bit Access       */
};
union __tag305
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag138 BIT;                                   /* Bit Access       */
};
union __tag306
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag139 BIT;                                   /* Bit Access       */
};
union __tag307
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag140 BIT;                                   /* Bit Access       */
};
union __tag308
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag141 BIT;                                   /* Bit Access       */
};
union __tag309
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag142 BIT;                                   /* Bit Access       */
};
union __tag310
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag143 BIT;                                   /* Bit Access       */
};
union __tag311
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag144 BIT;                                   /* Bit Access       */
};
union __tag312
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag145 BIT;                                   /* Bit Access       */
};
union __tag313
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag146 BIT;                                   /* Bit Access       */
};
union __tag314
{                                                          /* IOR              */
    unsigned short UINT16;                                 /* 16-bit Access    */
    unsigned char  UINT8[2];                               /* 8-bit Access     */
    struct __tag147 BIT;                                   /* Bit Access       */
};
union __tag315
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag148 BIT;                                   /* Bit Access       */
};
union __tag316
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag149 BIT;                                   /* Bit Access       */
};
union __tag317
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag150 BIT;                                   /* Bit Access       */
};
union __tag318
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag151 BIT;                                   /* Bit Access       */
};
union __tag319
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag152 BIT;                                   /* Bit Access       */
};
union __tag320
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag153 BIT;                                   /* Bit Access       */
};
union __tag321
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag154 BIT;                                   /* Bit Access       */
};
union __tag322
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag155 BIT;                                   /* Bit Access       */
};
union __tag323
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag156 BIT;                                   /* Bit Access       */
};
union __tag324
{                                                          /* IOR              */
    unsigned long  UINT32;                                 /* 32-bit Access    */
    unsigned short UINT16[2];                              /* 16-bit Access    */
    unsigned char  UINT8[4];                               /* 8-bit Access     */
    struct __tag157 BIT;                                   /* Bit Access       */
};

struct __tag325
{                                                          /* Module           */
    unsigned long  CNT;                                    /* CNT              */
    unsigned long  PCMD;                                   /* PCMD             */
    unsigned long  PS;                                     /* PS               */
};
struct __tag326
{                                                          /* Module           */
    unsigned long  ID0;                                    /* ID0              */
    unsigned long  ID1;                                    /* ID1              */
    unsigned long  ID2;                                    /* ID2              */
    unsigned long  ID3;                                    /* ID3              */
    union __tag158 IDST;                                   /* IDST             */
};
struct __tag327
{                                                          /* Module           */
    unsigned char  FPMON;                                  /* FPMON            */
    unsigned char  dummy0[15];                             /* Reserved         */
    unsigned char  FASTAT;                                 /* FASTAT           */
    unsigned char  dummy1[3];                              /* Reserved         */
    unsigned char  FAEINT;                                 /* FAEINT           */
    unsigned char  dummy2[11];                             /* Reserved         */
    unsigned short FAREASELC;                              /* FAREASELC        */
    unsigned char  dummy3[14];                             /* Reserved         */
    unsigned long  FSADDR;                                 /* FSADDR           */
    unsigned long  FEADDR;                                 /* FEADDR           */
    unsigned char  dummy4[72];                             /* Reserved         */
    union __tag158 FSTATR;                                 /* FSTATR           */
    unsigned short FENTRYR;                                /* FENTRYR          */
    unsigned char  dummy5[2];                              /* Reserved         */
    unsigned short FPROTR;                                 /* FPROTR           */
    unsigned char  dummy6[2];                              /* Reserved         */
    unsigned short FSUINITR;                               /* FSUINITR         */
    unsigned char  dummy7[2];                              /* Reserved         */
    unsigned char  FLKSTAT;                                /* FLKSTAT          */
    unsigned char  dummy8[7];                              /* Reserved         */
    unsigned char  FRTSTAT;                                /* FRTSTAT          */
    unsigned char  dummy9[7];                              /* Reserved         */
    unsigned short FCMDR;                                  /* FCMDR            */
    unsigned char  dummy10[30];                            /* Reserved         */
    unsigned short FPESTAT;                                /* FPESTAT          */
    unsigned char  dummy11[14];                            /* Reserved         */
    unsigned char  FBCCNT;                                 /* FBCCNT           */
    unsigned char  dummy12[3];                             /* Reserved         */
    unsigned char  FBCSTAT;                                /* FBCSTAT          */
    unsigned char  dummy13[3];                             /* Reserved         */
    unsigned long  FPSADDR;                                /* FPSADDR          */
    unsigned char  dummy14[4];                             /* Reserved         */
    unsigned short FCPSR;                                  /* FCPSR            */
    unsigned char  dummy15[2];                             /* Reserved         */
    unsigned short FPCKAR;                                 /* FPCKAR           */
    unsigned char  dummy16[26];                            /* Reserved         */
    unsigned short FECCEMON;                               /* FECCEMON         */
    unsigned char  dummy17[2];                             /* Reserved         */
    unsigned short FECCTMD;                                /* FECCTMD          */
    unsigned char  dummy18[2];                             /* Reserved         */
    unsigned short FDMYECC;                                /* FDMYECC          */
    unsigned char  dummy19[2395902];                       /* Reserved         */
    unsigned char  BFASELR;                                /* BFASELR          */
};
struct __tag328
{                                                          /* Module           */
    unsigned long  WDTNMIF;                                /* WDTNMIF          */
    unsigned char  dummy20[4];                             /* Reserved         */
    unsigned long  WDTNMIFC;                               /* WDTNMIFC         */
};
struct __tag329
{                                                          /* Module           */
    unsigned long  FEINTF;                                 /* FEINTF           */
    unsigned long  FEINTFMSK;                              /* FEINTFMSK        */
    unsigned long  FEINTFC;                                /* FEINTFC          */
};
struct __tag330
{                                                          /* Module           */
    unsigned short SELB_INTC1;                             /* SELB_INTC1       */
};
struct __tag331
{                                                          /* Module           */
    unsigned long  DTFSEL_TAUD0;                           /* DTFSEL_TAUD0     */
};
struct __tag332
{                                                          /* Module           */
    unsigned short P0;                                     /* P0               */
    unsigned char  dummy21[30];                            /* Reserved         */
    unsigned short P8;                                     /* P8               */
    unsigned char  dummy22[2];                             /* Reserved         */
    unsigned short P9;                                     /* P9               */
    unsigned char  dummy23[2];                             /* Reserved         */
    unsigned short P10;                                    /* P10              */
    unsigned char  dummy24[158];                           /* Reserved         */
    unsigned short AP0;                                    /* AP0              */
    unsigned char  dummy25[54];                            /* Reserved         */
    unsigned long  PSR0;                                   /* PSR0             */
    unsigned char  dummy26[28];                            /* Reserved         */
    unsigned long  PSR8;                                   /* PSR8             */
    unsigned long  PSR9;                                   /* PSR9             */
    unsigned long  PSR10;                                  /* PSR10            */
    unsigned char  dummy27[156];                           /* Reserved         */
    unsigned long  APSR0;                                  /* APSR0            */
    unsigned char  dummy28[52];                            /* Reserved         */
    unsigned short PPR0;                                   /* PPR0             */
    unsigned char  dummy29[30];                            /* Reserved         */
    unsigned short PPR8;                                   /* PPR8             */
    unsigned char  dummy30[2];                             /* Reserved         */
    unsigned short PPR9;                                   /* PPR9             */
    unsigned char  dummy31[2];                             /* Reserved         */
    unsigned short PPR10;                                  /* PPR10            */
    unsigned char  dummy32[158];                           /* Reserved         */
    unsigned short APPR0;                                  /* APPR0            */
    unsigned char  dummy33[54];                            /* Reserved         */
    unsigned short PM0;                                    /* PM0              */
    unsigned char  dummy34[30];                            /* Reserved         */
    unsigned short PM8;                                    /* PM8              */
    unsigned char  dummy35[2];                             /* Reserved         */
    unsigned short PM9;                                    /* PM9              */
    unsigned char  dummy36[2];                             /* Reserved         */
    unsigned short PM10;                                   /* PM10             */
    unsigned char  dummy37[158];                           /* Reserved         */
    unsigned short APM0;                                   /* APM0             */
    unsigned char  dummy38[54];                            /* Reserved         */
    unsigned short PMC0;                                   /* PMC0             */
    unsigned char  dummy39[30];                            /* Reserved         */
    unsigned short PMC8;                                   /* PMC8             */
    unsigned char  dummy40[2];                             /* Reserved         */
    unsigned short PMC9;                                   /* PMC9             */
    unsigned char  dummy41[2];                             /* Reserved         */
    unsigned short PMC10;                                  /* PMC10            */
    unsigned char  dummy42[214];                           /* Reserved         */
    unsigned short PFC0;                                   /* PFC0             */
    unsigned char  dummy43[30];                            /* Reserved         */
    unsigned short PFC8;                                   /* PFC8             */
    unsigned char  dummy44[2];                             /* Reserved         */
    unsigned short PFC9;                                   /* PFC9             */
    unsigned char  dummy45[2];                             /* Reserved         */
    unsigned short PFC10;                                  /* PFC10            */
    unsigned char  dummy46[214];                           /* Reserved         */
    unsigned short PFCE0;                                  /* PFCE0            */
    unsigned char  dummy47[30];                            /* Reserved         */
    unsigned short PFCE8;                                  /* PFCE8            */
    unsigned char  dummy48[2];                             /* Reserved         */
    unsigned short PFCE9;                                  /* PFCE9            */
    unsigned char  dummy49[2];                             /* Reserved         */
    unsigned short PFCE10;                                 /* PFCE10           */
    unsigned char  dummy50[214];                           /* Reserved         */
    unsigned short PNOT0;                                  /* PNOT0            */
    unsigned char  dummy51[30];                            /* Reserved         */
    unsigned short PNOT8;                                  /* PNOT8            */
    unsigned char  dummy52[2];                             /* Reserved         */
    unsigned short PNOT9;                                  /* PNOT9            */
    unsigned char  dummy53[2];                             /* Reserved         */
    unsigned short PNOT10;                                 /* PNOT10           */
    unsigned char  dummy54[158];                           /* Reserved         */
    unsigned short APNOT0;                                 /* APNOT0           */
    unsigned char  dummy55[54];                            /* Reserved         */
    unsigned long  PMSR0;                                  /* PMSR0            */
    unsigned char  dummy56[28];                            /* Reserved         */
    unsigned long  PMSR8;                                  /* PMSR8            */
    unsigned long  PMSR9;                                  /* PMSR9            */
    unsigned long  PMSR10;                                 /* PMSR10           */
    unsigned char  dummy57[156];                           /* Reserved         */
    unsigned long  APMSR0;                                 /* APMSR0           */
    unsigned char  dummy58[52];                            /* Reserved         */
    unsigned long  PMCSR0;                                 /* PMCSR0           */
    unsigned char  dummy59[28];                            /* Reserved         */
    unsigned long  PMCSR8;                                 /* PMCSR8           */
    unsigned long  PMCSR9;                                 /* PMCSR9           */
    unsigned long  PMCSR10;                                /* PMCSR10          */
    unsigned char  dummy60[212];                           /* Reserved         */
    unsigned short PFCAE0;                                 /* PFCAE0           */
    unsigned char  dummy61[30];                            /* Reserved         */
    unsigned short PFCAE8;                                 /* PFCAE8           */
    unsigned char  dummy62[2];                             /* Reserved         */
    unsigned short PFCAE9;                                 /* PFCAE9           */
    unsigned char  dummy63[2];                             /* Reserved         */
    unsigned short PFCAE10;                                /* PFCAE10          */
    unsigned char  dummy64[13782];                         /* Reserved         */
    unsigned short PIBC0;                                  /* PIBC0            */
    unsigned char  dummy65[30];                            /* Reserved         */
    unsigned short PIBC8;                                  /* PIBC8            */
    unsigned char  dummy66[2];                             /* Reserved         */
    unsigned short PIBC9;                                  /* PIBC9            */
    unsigned char  dummy67[2];                             /* Reserved         */
    unsigned short PIBC10;                                 /* PIBC10           */
    unsigned char  dummy68[158];                           /* Reserved         */
    unsigned short APIBC0;                                 /* APIBC0           */
    unsigned char  dummy69[54];                            /* Reserved         */
    unsigned short PBDC0;                                  /* PBDC0            */
    unsigned char  dummy70[30];                            /* Reserved         */
    unsigned short PBDC8;                                  /* PBDC8            */
    unsigned char  dummy71[2];                             /* Reserved         */
    unsigned short PBDC9;                                  /* PBDC9            */
    unsigned char  dummy72[2];                             /* Reserved         */
    unsigned short PBDC10;                                 /* PBDC10           */
    unsigned char  dummy73[158];                           /* Reserved         */
    unsigned short APBDC0;                                 /* APBDC0           */
    unsigned char  dummy74[54];                            /* Reserved         */
    unsigned short PIPC0;                                  /* PIPC0            */
    unsigned char  dummy75[38];                            /* Reserved         */
    unsigned short PIPC10;                                 /* PIPC10           */
    unsigned char  dummy76[214];                           /* Reserved         */
    unsigned short PU0;                                    /* PU0              */
    unsigned char  dummy77[30];                            /* Reserved         */
    unsigned short PU8;                                    /* PU8              */
    unsigned char  dummy78[2];                             /* Reserved         */
    unsigned short PU9;                                    /* PU9              */
    unsigned char  dummy79[2];                             /* Reserved         */
    unsigned short PU10;                                   /* PU10             */
    unsigned char  dummy80[214];                           /* Reserved         */
    unsigned short PD0;                                    /* PD0              */
    unsigned char  dummy81[30];                            /* Reserved         */
    unsigned short PD8;                                    /* PD8              */
    unsigned char  dummy82[2];                             /* Reserved         */
    unsigned short PD9;                                    /* PD9              */
    unsigned char  dummy83[2];                             /* Reserved         */
    unsigned short PD10;                                   /* PD10             */
    unsigned char  dummy84[214];                           /* Reserved         */
    unsigned long  PODC0;                                  /* PODC0            */
    unsigned char  dummy85[28];                            /* Reserved         */
    unsigned long  PODC8;                                  /* PODC8            */
    unsigned long  PODC9;                                  /* PODC9            */
    unsigned long  PODC10;                                 /* PODC10           */
    unsigned char  dummy86[212];                           /* Reserved         */
    unsigned long  PDSC0;                                  /* PDSC0            */
    unsigned char  dummy87[36];                            /* Reserved         */
    unsigned long  PDSC10;                                 /* PDSC10           */
    unsigned char  dummy88[212];                           /* Reserved         */
    unsigned short PIS0;                                   /* PIS0             */
    unsigned char  dummy89[30];                            /* Reserved         */
    unsigned short PIS8;                                   /* PIS8             */
    unsigned char  dummy90[2];                             /* Reserved         */
    unsigned short PIS9;                                   /* PIS9             */
    unsigned char  dummy91[2];                             /* Reserved         */
    unsigned short PIS10;                                  /* PIS10            */
    unsigned char  dummy92[982];                           /* Reserved         */
    unsigned long  PPROTS0;                                /* PPROTS0          */
    unsigned char  dummy93[28];                            /* Reserved         */
    unsigned long  PPROTS8;                                /* PPROTS8          */
    unsigned long  PPROTS9;                                /* PPROTS9          */
    unsigned long  PPROTS10;                               /* PPROTS10         */
    unsigned char  dummy94[212];                           /* Reserved         */
    unsigned long  PPCMD0;                                 /* PPCMD0           */
    unsigned char  dummy95[28];                            /* Reserved         */
    unsigned long  PPCMD8;                                 /* PPCMD8           */
    unsigned long  PPCMD9;                                 /* PPCMD9           */
    unsigned long  PPCMD10;                                /* PPCMD10          */
};
struct __tag333
{                                                          /* Module           */
    unsigned char  JP0;                                    /* JP0              */
    unsigned char  dummy96[15];                            /* Reserved         */
    unsigned long  JPSR0;                                  /* JPSR0            */
    unsigned char  dummy97[12];                            /* Reserved         */
    unsigned char  JPPR0;                                  /* JPPR0            */
    unsigned char  dummy98[15];                            /* Reserved         */
    unsigned char  JPM0;                                   /* JPM0             */
    unsigned char  dummy99[15];                            /* Reserved         */
    unsigned char  JPMC0;                                  /* JPMC0            */
    unsigned char  dummy100[15];                           /* Reserved         */
    unsigned char  JPFC0;                                  /* JPFC0            */
    unsigned char  dummy101[15];                           /* Reserved         */
    unsigned char  JPFCE0;                                 /* JPFCE0           */
    unsigned char  dummy102[15];                           /* Reserved         */
    unsigned char  JPNOT0;                                 /* JPNOT0           */
    unsigned char  dummy103[15];                           /* Reserved         */
    unsigned long  JPMSR0;                                 /* JPMSR0           */
    unsigned char  dummy104[12];                           /* Reserved         */
    unsigned long  JPMCSR0;                                /* JPMCSR0          */
    unsigned char  dummy105[876];                          /* Reserved         */
    unsigned char  JPIBC0;                                 /* JPIBC0           */
    unsigned char  dummy106[15];                           /* Reserved         */
    unsigned char  JPBDC0;                                 /* JPBDC0           */
    unsigned char  dummy107[31];                           /* Reserved         */
    unsigned char  JPU0;                                   /* JPU0             */
    unsigned char  dummy108[15];                           /* Reserved         */
    unsigned char  JPD0;                                   /* JPD0             */
    unsigned char  dummy109[15];                           /* Reserved         */
    unsigned long  JPODC0;                                 /* JPODC0           */
    unsigned char  dummy110[12];                           /* Reserved         */
    unsigned long  JPDSC0;                                 /* JPDSC0           */
    unsigned char  dummy111[12];                           /* Reserved         */
    unsigned char  JPIS0;                                  /* JPIS0            */
    unsigned char  dummy112[47];                           /* Reserved         */
    unsigned char  JPISA0;                                 /* JPISA0           */
    unsigned char  dummy113[15];                           /* Reserved         */
    unsigned long  JPPROTS0;                               /* JPPROTS0         */
    unsigned char  dummy114[12];                           /* Reserved         */
    unsigned long  JPPCMD0;                                /* JPPCMD0          */
};
struct __tag334
{                                                          /* Module           */
    unsigned char  ATAUD0ICTL;                             /* ATAUD0ICTL       */
    unsigned char  dummy115[3];                            /* Reserved         */
    unsigned short ATAUD0IEN;                              /* ATAUD0IEN        */
    unsigned char  dummy116[2];                            /* Reserved         */
    union __tag159 ATAUD0IENH;                             /* ATAUD0IENH       */
    unsigned char  dummy117[3];                            /* Reserved         */
    union __tag160 ATAUD0IENL;                             /* ATAUD0IENL       */
    unsigned char  dummy118[83];                           /* Reserved         */
    unsigned char  AENCA0ICTL;                             /* AENCA0ICTL       */
    unsigned char  dummy119[3];                            /* Reserved         */
    unsigned short AENCA0IEN;                              /* AENCA0IEN        */
    unsigned char  dummy120[6];                            /* Reserved         */
    union __tag161 AENCA0IENL;                             /* AENCA0IENL       */
    unsigned char  dummy121[51];                           /* Reserved         */
    unsigned char  AADCTL0CTL;                             /* AADCTL0CTL       */
    unsigned char  dummy122[3];                            /* Reserved         */
    unsigned short AADCTL0EN;                              /* AADCTL0EN        */
    unsigned char  dummy123[6];                            /* Reserved         */
    union __tag162 AADCTL0ENL;                             /* AADCTL0ENL       */
    unsigned char  dummy124[51];                           /* Reserved         */
    unsigned char  ASENTICTL;                              /* ASENTICTL        */
    unsigned char  dummy125[3];                            /* Reserved         */
    unsigned short ASENTIEN;                               /* ASENTIEN         */
    unsigned char  dummy126[6];                            /* Reserved         */
    union __tag163 ASENTIENL;                              /* ASENTIENL        */
};
struct __tag335
{                                                          /* Module           */
    unsigned char  CTL0_NMI;                               /* CTL0_NMI         */
    unsigned char  dummy127[31];                           /* Reserved         */
    unsigned char  CTL0_INTPL;                             /* CTL0_INTPL       */
    unsigned char  dummy128[3];                            /* Reserved         */
    unsigned char  CTL1_INTPL;                             /* CTL1_INTPL       */
    unsigned char  dummy129[3];                            /* Reserved         */
    unsigned char  CTL2_INTPL;                             /* CTL2_INTPL       */
    unsigned char  dummy130[3];                            /* Reserved         */
    unsigned char  CTL3_INTPL;                             /* CTL3_INTPL       */
    unsigned char  dummy131[3];                            /* Reserved         */
    unsigned char  CTL4_INTPL;                             /* CTL4_INTPL       */
    unsigned char  dummy132[3];                            /* Reserved         */
    unsigned char  CTL5_INTPL;                             /* CTL5_INTPL       */
    unsigned char  dummy133[19];                           /* Reserved         */
    unsigned char  CTL2_INTPH;                             /* CTL2_INTPH       */
    unsigned char  dummy134[3];                            /* Reserved         */
    unsigned char  CTL3_INTPH;                             /* CTL3_INTPH       */
    unsigned char  dummy135[19];                           /* Reserved         */
    unsigned char  CTL0_ADC0;                              /* CTL0_ADC0        */
    unsigned char  dummy136[3];                            /* Reserved         */
    unsigned char  CTL1_ADC0;                              /* CTL1_ADC0        */
    unsigned char  dummy137[3];                            /* Reserved         */
    unsigned char  CTL2_ADC0;                              /* CTL2_ADC0        */
};
struct __tag336
{                                                          /* Module           */
    union __tag158 FSGD00PROT0;                            /* FSGD00PROT0      */
    union __tag158 FSGD00PROT1;                            /* FSGD00PROT1      */
    union __tag158 FSGD00PROT2;                            /* FSGD00PROT2      */
    union __tag158 FSGD00PROT3;                            /* FSGD00PROT3      */
    union __tag158 FSGD00PROT4;                            /* FSGD00PROT4      */
    union __tag158 FSGD00PROT5;                            /* FSGD00PROT5      */
    union __tag158 FSGD00PROT6;                            /* FSGD00PROT6      */
    union __tag158 FSGD00PROT7;                            /* FSGD00PROT7      */
    union __tag158 FSGD00PROT8;                            /* FSGD00PROT8      */
    union __tag158 FSGD00PROT9;                            /* FSGD00PROT9      */
    unsigned char  dummy138[24];                           /* Reserved         */
    union __tag158 ERRSLV00CTL;                            /* ERRSLV00CTL      */
    union __tag158 ERRSLV00STAT;                           /* ERRSLV00STAT     */
    unsigned long  ERRSLV00ADDR;                           /* ERRSLV00ADDR     */
    union __tag164 ERRSLV00TYPE;                           /* ERRSLV00TYPE     */
};
struct __tag337
{                                                          /* Module           */
    union __tag158 FSGD01PROT0;                            /* FSGD01PROT0      */
    union __tag158 FSGD01PROT1;                            /* FSGD01PROT1      */
    union __tag158 FSGD01PROT2;                            /* FSGD01PROT2      */
    union __tag158 FSGD01PROT3;                            /* FSGD01PROT3      */
    union __tag158 FSGD01PROT4;                            /* FSGD01PROT4      */
    union __tag158 FSGD01PROT5;                            /* FSGD01PROT5      */
    union __tag158 FSGD01PROT6;                            /* FSGD01PROT6      */
    unsigned char  dummy139[20];                           /* Reserved         */
    union __tag158 FSGD01PROT12;                           /* FSGD01PROT12     */
    union __tag158 FSGD01PROT13;                           /* FSGD01PROT13     */
    union __tag158 FSGD01PROT14;                           /* FSGD01PROT14     */
    unsigned char  dummy140[4];                            /* Reserved         */
    union __tag158 ERRSLV01CTL;                            /* ERRSLV01CTL      */
    union __tag158 ERRSLV01STAT;                           /* ERRSLV01STAT     */
    unsigned long  ERRSLV01ADDR;                           /* ERRSLV01ADDR     */
    union __tag164 ERRSLV01TYPE;                           /* ERRSLV01TYPE     */
};
struct __tag338
{                                                          /* Module           */
    union __tag158 FSGD07PROT0;                            /* FSGD07PROT0      */
    union __tag158 FSGD07PROT1;                            /* FSGD07PROT1      */
    union __tag158 FSGD07PROT2;                            /* FSGD07PROT2      */
    unsigned char  dummy141[48];                           /* Reserved         */
    union __tag158 FSGD07PROT15;                           /* FSGD07PROT15     */
    union __tag158 ERRSLV07CTL;                            /* ERRSLV07CTL      */
    union __tag158 ERRSLV07STAT;                           /* ERRSLV07STAT     */
    unsigned long  ERRSLV07ADDR;                           /* ERRSLV07ADDR     */
    union __tag164 ERRSLV07TYPE;                           /* ERRSLV07TYPE     */
};
struct __tag339
{                                                          /* Module           */
    union __tag158 FSGD08PROT0;                            /* FSGD08PROT0      */
    unsigned char  dummy142[12];                           /* Reserved         */
    union __tag158 FSGD08PROT4;                            /* FSGD08PROT4      */
    union __tag158 FSGD08PROT5;                            /* FSGD08PROT5      */
    union __tag158 FSGD08PROT6;                            /* FSGD08PROT6      */
    unsigned char  dummy143[4];                            /* Reserved         */
    union __tag158 FSGD08PROT8;                            /* FSGD08PROT8      */
    unsigned char  dummy144[16];                           /* Reserved         */
    union __tag158 FSGD08PROT13;                           /* FSGD08PROT13     */
    union __tag158 FSGD08PROT14;                           /* FSGD08PROT14     */
    unsigned char  dummy145[4];                            /* Reserved         */
    union __tag158 ERRSLV08CTL;                            /* ERRSLV08CTL      */
    union __tag158 ERRSLV08STAT;                           /* ERRSLV08STAT     */
    unsigned long  ERRSLV08ADDR;                           /* ERRSLV08ADDR     */
    union __tag164 ERRSLV08TYPE;                           /* ERRSLV08TYPE     */
};
struct __tag340
{                                                          /* Module           */
    union __tag158 FSGDC0PROT0;                            /* FSGDC0PROT0      */
    union __tag158 FSGDC0PROT1;                            /* FSGDC0PROT1      */
    unsigned char  dummy146[2040];                         /* Reserved         */
    union __tag158 ERRSLVC0CTL;                            /* ERRSLVC0CTL      */
    union __tag158 ERRSLVC0STAT;                           /* ERRSLVC0STAT     */
    unsigned long  ERRSLVC0ADDR;                           /* ERRSLVC0ADDR     */
    union __tag164 ERRSLVC0TYPE;                           /* ERRSLVC0TYPE     */
};
struct __tag341
{                                                          /* Module           */
    union __tag158 FSGDC1PROT0;                            /* FSGDC1PROT0      */
    union __tag158 FSGDC1PROT1;                            /* FSGDC1PROT1      */
    union __tag158 FSGDC1PROT2;                            /* FSGDC1PROT2      */
    union __tag158 FSGDC1PROT3;                            /* FSGDC1PROT3      */
    union __tag158 FSGDC1PROT4;                            /* FSGDC1PROT4      */
    union __tag158 FSGDC1PROT5;                            /* FSGDC1PROT5      */
    unsigned char  dummy147[1992];                         /* Reserved         */
    union __tag158 ERRSLVC1CTL;                            /* ERRSLVC1CTL      */
    union __tag158 ERRSLVC1STAT;                           /* ERRSLVC1STAT     */
    unsigned long  ERRSLVC1ADDR;                           /* ERRSLVC1ADDR     */
    union __tag164 ERRSLVC1TYPE;                           /* ERRSLVC1TYPE     */
};
struct __tag342
{                                                          /* Module           */
    unsigned char  EEPRDCYCL;                              /* EEPRDCYCL        */
};
struct __tag343
{                                                          /* Module           */
    union __tag158 FBUFCCTL;                               /* FBUFCCTL         */
};
struct __tag344
{                                                          /* Module           */
    union __tag164 CFECCCTL_VCI;                           /* CFECCCTL_VCI     */
    union __tag158 CFERRINT_VCI;                           /* CFERRINT_VCI     */
    union __tag158 CFSTCLR_VCI;                            /* CFSTCLR_VCI      */
    union __tag158 CFOVFSTR_VCI;                           /* CFOVFSTR_VCI     */
    union __tag158 CF1STERSTR_VCI;                         /* CF1STERSTR_VCI   */
    unsigned char  dummy148[60];                           /* Reserved         */
    union __tag158 CF1STEADR0_VCI;                         /* CF1STEADR0_VCI   */
    unsigned char  dummy149[252];                          /* Reserved         */
    union __tag164 CFSTSTCTL_VCI;                          /* CFSTSTCTL_VCI    */
};
struct __tag345
{                                                          /* Module           */
    union __tag164 CFECCCTL_PE1;                           /* CFECCCTL_PE1     */
    union __tag158 CFERRINT_PE1;                           /* CFERRINT_PE1     */
    union __tag158 CFSTCLR_PE1;                            /* CFSTCLR_PE1      */
    union __tag158 CFOVFSTR_PE1;                           /* CFOVFSTR_PE1     */
    union __tag158 CF1STERSTR_PE1;                         /* CF1STERSTR_PE1   */
    unsigned char  dummy150[60];                           /* Reserved         */
    union __tag158 CF1STEADR0_PE1;                         /* CF1STEADR0_PE1   */
};
struct __tag346
{                                                          /* Module           */
    unsigned short CTL;                                    /* CTL              */
    unsigned char  dummy151[2];                            /* Reserved         */
    unsigned char  DFERSTR;                                /* DFERSTR          */
    unsigned char  dummy152[3];                            /* Reserved         */
    unsigned char  DFERSTC;                                /* DFERSTC          */
    unsigned char  dummy153[3];                            /* Reserved         */
    unsigned char  DFOVFSTR;                               /* DFOVFSTR         */
    unsigned char  dummy154[3];                            /* Reserved         */
    unsigned char  DFOVFSTC;                               /* DFOVFSTC         */
    unsigned char  dummy155[3];                            /* Reserved         */
    unsigned char  DFERRINT;                               /* DFERRINT         */
    unsigned char  dummy156[3];                            /* Reserved         */
    unsigned long  DFEADR;                                 /* DFEADR           */
    unsigned short DFTSTCTL;                               /* DFTSTCTL         */
};
struct __tag347
{                                                          /* Module           */
    union __tag164 CTL_PE1;                                /* CTL_PE1          */
    unsigned long  LRTDATBF0_PE1;                          /* LRTDATBF0_PE1    */
};
struct __tag348
{                                                          /* Module           */
    union __tag164 CTL_PE1;                                /* CTL_PE1          */
    union __tag158 LRERRINT_PE1;                           /* LRERRINT_PE1     */
    union __tag158 LRSTCLR_PE1;                            /* LRSTCLR_PE1      */
    union __tag158 LROVFSTR_PE1;                           /* LROVFSTR_PE1     */
    union __tag158 LR1STERSTR_PE1;                         /* LR1STERSTR_PE1   */
    unsigned char  dummy157[60];                           /* Reserved         */
    union __tag158 LR1STEADR0_PE1;                         /* LR1STEADR0_PE1   */
};
struct __tag349
{                                                          /* Module           */
    unsigned short CTL;                                    /* CTL              */
    unsigned char  dummy158[2];                            /* Reserved         */
    unsigned short TMC;                                    /* TMC              */
    unsigned char  dummy159[2];                            /* Reserved         */
    union __tag165 TRC;                                    /* TRC              */
    unsigned long  TED;                                    /* TED              */
    unsigned long  AD0;                                    /* AD0              */
};
struct __tag350
{                                                          /* Module           */
    unsigned short SELB_READTEST;                          /* SELB_READTEST    */
};
struct __tag351
{                                                          /* Module           */
    union __tag158 CR1;                                    /* CR1              */
    union __tag158 CR2;                                    /* CR2              */
    union __tag158 MR1;                                    /* MR1              */
    union __tag158 MR2;                                    /* MR2              */
    union __tag158 MR3;                                    /* MR3              */
    union __tag158 FER;                                    /* FER              */
    union __tag158 SER;                                    /* SER              */
    union __tag158 IER;                                    /* IER              */
    union __tag158 SR1;                                    /* SR1              */
    union __tag158 SR2;                                    /* SR2              */
    union __tag158 SAR0;                                   /* SAR0             */
    union __tag158 SAR1;                                   /* SAR1             */
    union __tag158 SAR2;                                   /* SAR2             */
    union __tag158 BRL;                                    /* BRL              */
    union __tag158 BRH;                                    /* BRH              */
    union __tag158 DRT;                                    /* DRT              */
    union __tag158 DRR;                                    /* DRR              */
};
struct __tag352
{                                                          /* Module           */
    unsigned long  PRDNAME1;                               /* PRDNAME1         */
    unsigned long  PRDNAME2;                               /* PRDNAME2         */
    unsigned long  PRDNAME3;                               /* PRDNAME3         */
    unsigned char  dummy160[4];                            /* Reserved         */
    unsigned long  CHIPID1LL;                              /* CHIPID1LL        */
    unsigned long  CHIPID1LH;                              /* CHIPID1LH        */
    unsigned long  CHIPID1HL;                              /* CHIPID1HL        */
    unsigned long  CHIPID1HH;                              /* CHIPID1HH        */
    unsigned long  CHIPID2LL;                              /* CHIPID2LL        */
    unsigned long  CHIPID2LH;                              /* CHIPID2LH        */
    unsigned long  CHIPID2HL;                              /* CHIPID2HL        */
    unsigned long  CHIPID2HH;                              /* CHIPID2HH        */
};
struct __tag353
{                                                          /* Module           */
    unsigned char  dummy161[1];                            /* Reserved         */
    unsigned char  GLWBR;                                  /* GLWBR            */
    unsigned char  GLBRP0;                                 /* GLBRP0           */
    unsigned char  GLBRP1;                                 /* GLBRP1           */
    unsigned char  GLSTC;                                  /* GLSTC            */
};
struct __tag354
{                                                          /* Module           */
    unsigned char  L0MD;                                   /* L0MD             */
    unsigned char  L0BFC;                                  /* L0BFC            */
    unsigned char  L0SC;                                   /* L0SC             */
    unsigned char  L0WUP;                                  /* L0WUP            */
    unsigned char  L0IE;                                   /* L0IE             */
    unsigned char  L0EDE;                                  /* L0EDE            */
    unsigned char  L0CUC;                                  /* L0CUC            */
    unsigned char  dummy162[1];                            /* Reserved         */
    unsigned char  L0TRC;                                  /* L0TRC            */
    unsigned char  L0MST;                                  /* L0MST            */
    unsigned char  L0ST;                                   /* L0ST             */
    unsigned char  L0EST;                                  /* L0EST            */
    unsigned char  L0DFC;                                  /* L0DFC            */
    unsigned char  L0IDB;                                  /* L0IDB            */
    unsigned char  L0CBR;                                  /* L0CBR            */
    unsigned char  dummy163[1];                            /* Reserved         */
    unsigned char  L0DBR1;                                 /* L0DBR1           */
    unsigned char  L0DBR2;                                 /* L0DBR2           */
    unsigned char  L0DBR3;                                 /* L0DBR3           */
    unsigned char  L0DBR4;                                 /* L0DBR4           */
    unsigned char  L0DBR5;                                 /* L0DBR5           */
    unsigned char  L0DBR6;                                 /* L0DBR6           */
    unsigned char  L0DBR7;                                 /* L0DBR7           */
    unsigned char  L0DBR8;                                 /* L0DBR8           */
};
struct __tag355
{                                                          /* Module           */
    unsigned char  L1MD;                                   /* L1MD             */
    unsigned char  L1BFC;                                  /* L1BFC            */
    unsigned char  L1SC;                                   /* L1SC             */
    unsigned char  L1WUP;                                  /* L1WUP            */
    unsigned char  L1IE;                                   /* L1IE             */
    unsigned char  L1EDE;                                  /* L1EDE            */
    unsigned char  L1CUC;                                  /* L1CUC            */
    unsigned char  dummy164[1];                            /* Reserved         */
    unsigned char  L1TRC;                                  /* L1TRC            */
    unsigned char  L1MST;                                  /* L1MST            */
    unsigned char  L1ST;                                   /* L1ST             */
    unsigned char  L1EST;                                  /* L1EST            */
    unsigned char  L1DFC;                                  /* L1DFC            */
    unsigned char  L1IDB;                                  /* L1IDB            */
    unsigned char  L1CBR;                                  /* L1CBR            */
    unsigned char  dummy165[1];                            /* Reserved         */
    unsigned char  L1DBR1;                                 /* L1DBR1           */
    unsigned char  L1DBR2;                                 /* L1DBR2           */
    unsigned char  L1DBR3;                                 /* L1DBR3           */
    unsigned char  L1DBR4;                                 /* L1DBR4           */
    unsigned char  L1DBR5;                                 /* L1DBR5           */
    unsigned char  L1DBR6;                                 /* L1DBR6           */
    unsigned char  L1DBR7;                                 /* L1DBR7           */
    unsigned char  L1DBR8;                                 /* L1DBR8           */
};
struct __tag356
{                                                          /* Module           */
    unsigned char  dummy166[1];                            /* Reserved         */
    unsigned char  LWBR;                                   /* LWBR             */
    union __tag166 LBRP01;                                 /* LBRP01           */
    unsigned char  LSTC;                                   /* LSTC             */
    unsigned char  dummy167[3];                            /* Reserved         */
    unsigned char  LMD;                                    /* LMD              */
    unsigned char  LBFC;                                   /* LBFC             */
    unsigned char  LSC;                                    /* LSC              */
    unsigned char  LWUP;                                   /* LWUP             */
    unsigned char  LIE;                                    /* LIE              */
    unsigned char  LEDE;                                   /* LEDE             */
    unsigned char  LCUC;                                   /* LCUC             */
    unsigned char  dummy168[1];                            /* Reserved         */
    unsigned char  LTRC;                                   /* LTRC             */
    unsigned char  LMST;                                   /* LMST             */
    unsigned char  LST;                                    /* LST              */
    unsigned char  LEST;                                   /* LEST             */
    unsigned char  LDFC;                                   /* LDFC             */
    unsigned char  LIDB;                                   /* LIDB             */
    unsigned char  LCBR;                                   /* LCBR             */
    unsigned char  LUDB0;                                  /* LUDB0            */
    unsigned char  LDBR1;                                  /* LDBR1            */
    unsigned char  LDBR2;                                  /* LDBR2            */
    unsigned char  LDBR3;                                  /* LDBR3            */
    unsigned char  LDBR4;                                  /* LDBR4            */
    unsigned char  LDBR5;                                  /* LDBR5            */
    unsigned char  LDBR6;                                  /* LDBR6            */
    unsigned char  LDBR7;                                  /* LDBR7            */
    unsigned char  LDBR8;                                  /* LDBR8            */
    unsigned char  LUOER;                                  /* LUOER            */
    unsigned char  LUOR1;                                  /* LUOR1            */
    unsigned char  dummy169[2];                            /* Reserved         */
    union __tag167 LUTDR;                                  /* LUTDR            */
    union __tag167 LURDR;                                  /* LURDR            */
    union __tag167 LUWTDR;                                 /* LUWTDR           */
};
struct __tag357
{                                                          /* Module           */
    unsigned long  TSPC;                                   /* TSPC             */
    unsigned long  TSC;                                    /* TSC              */
    unsigned char  dummy170[8];                            /* Reserved         */
    unsigned long  CC;                                     /* CC               */
    unsigned long  BRP;                                    /* BRP              */
    unsigned long  IDE;                                    /* IDE              */
    unsigned long  MDC;                                    /* MDC              */
    unsigned long  SPCT;                                   /* SPCT             */
    unsigned long  MST;                                    /* MST              */
    unsigned long  CS;                                     /* CS               */
    unsigned long  CSC;                                    /* CSC              */
    unsigned long  SRTS;                                   /* SRTS             */
    unsigned long  SRXD;                                   /* SRXD             */
    unsigned long  CPL;                                    /* CPL              */
    unsigned long  ML;                                     /* ML               */
    unsigned long  FRTS;                                   /* FRTS             */
    unsigned long  FRXD;                                   /* FRXD             */
    unsigned char  dummy171[8];                            /* Reserved         */
    unsigned long  CPLM;                                   /* CPLM             */
    unsigned long  MLM;                                    /* MLM              */
    unsigned long  FRTSM;                                  /* FRTSM            */
    unsigned long  EFRD0;                                  /* EFRD0            */
    unsigned long  EFRD1;                                  /* EFRD1            */
};
struct __tag358
{                                                          /* Module           */
    union __tag158 CFDC0NCFG;                              /* CFDC0NCFG        */
    union __tag158 CFDC0CTR;                               /* CFDC0CTR         */
    union __tag158 CFDC0STS;                               /* CFDC0STS         */
    union __tag158 CFDC0ERFL;                              /* CFDC0ERFL        */
    union __tag158 CFDC1NCFG;                              /* CFDC1NCFG        */
    union __tag158 CFDC1CTR;                               /* CFDC1CTR         */
    union __tag158 CFDC1STS;                               /* CFDC1STS         */
    union __tag158 CFDC1ERFL;                              /* CFDC1ERFL        */
    union __tag158 CFDC2NCFG;                              /* CFDC2NCFG        */
    union __tag158 CFDC2CTR;                               /* CFDC2CTR         */
    union __tag158 CFDC2STS;                               /* CFDC2STS         */
    union __tag158 CFDC2ERFL;                              /* CFDC2ERFL        */
    unsigned char  dummy172[84];                           /* Reserved         */
    union __tag158 CFDGCFG;                                /* CFDGCFG          */
    union __tag158 CFDGCTR;                                /* CFDGCTR          */
    union __tag158 CFDGSTS;                                /* CFDGSTS          */
    union __tag158 CFDGERFL;                               /* CFDGERFL         */
    union __tag164 CFDGTSC;                                /* CFDGTSC          */
    union __tag158 CFDGAFLECTR;                            /* CFDGAFLECTR      */
    union __tag158 CFDGAFLCFG0;                            /* CFDGAFLCFG0      */
    unsigned char  dummy173[4];                            /* Reserved         */
    union __tag158 CFDRMNB;                                /* CFDRMNB          */
    union __tag158 CFDRMND0;                               /* CFDRMND0         */
    union __tag158 CFDRMND1;                               /* CFDRMND1         */
    unsigned char  dummy174[8];                            /* Reserved         */
    union __tag158 CFDRFCC0;                               /* CFDRFCC0         */
    union __tag158 CFDRFCC1;                               /* CFDRFCC1         */
    union __tag158 CFDRFCC2;                               /* CFDRFCC2         */
    union __tag158 CFDRFCC3;                               /* CFDRFCC3         */
    union __tag158 CFDRFCC4;                               /* CFDRFCC4         */
    union __tag158 CFDRFCC5;                               /* CFDRFCC5         */
    union __tag158 CFDRFCC6;                               /* CFDRFCC6         */
    union __tag158 CFDRFCC7;                               /* CFDRFCC7         */
    union __tag158 CFDRFSTS0;                              /* CFDRFSTS0        */
    union __tag158 CFDRFSTS1;                              /* CFDRFSTS1        */
    union __tag158 CFDRFSTS2;                              /* CFDRFSTS2        */
    union __tag158 CFDRFSTS3;                              /* CFDRFSTS3        */
    union __tag158 CFDRFSTS4;                              /* CFDRFSTS4        */
    union __tag158 CFDRFSTS5;                              /* CFDRFSTS5        */
    union __tag158 CFDRFSTS6;                              /* CFDRFSTS6        */
    union __tag158 CFDRFSTS7;                              /* CFDRFSTS7        */
    union __tag158 CFDRFPCTR0;                             /* CFDRFPCTR0       */
    union __tag158 CFDRFPCTR1;                             /* CFDRFPCTR1       */
    union __tag158 CFDRFPCTR2;                             /* CFDRFPCTR2       */
    union __tag158 CFDRFPCTR3;                             /* CFDRFPCTR3       */
    union __tag158 CFDRFPCTR4;                             /* CFDRFPCTR4       */
    union __tag158 CFDRFPCTR5;                             /* CFDRFPCTR5       */
    union __tag158 CFDRFPCTR6;                             /* CFDRFPCTR6       */
    union __tag158 CFDRFPCTR7;                             /* CFDRFPCTR7       */
    union __tag158 CFDCFCC0;                               /* CFDCFCC0         */
    union __tag158 CFDCFCC1;                               /* CFDCFCC1         */
    union __tag158 CFDCFCC2;                               /* CFDCFCC2         */
    union __tag158 CFDCFCC3;                               /* CFDCFCC3         */
    union __tag158 CFDCFCC4;                               /* CFDCFCC4         */
    union __tag158 CFDCFCC5;                               /* CFDCFCC5         */
    union __tag158 CFDCFCC6;                               /* CFDCFCC6         */
    union __tag158 CFDCFCC7;                               /* CFDCFCC7         */
    union __tag158 CFDCFCC8;                               /* CFDCFCC8         */
    unsigned char  dummy175[60];                           /* Reserved         */
    union __tag158 CFDCFSTS0;                              /* CFDCFSTS0        */
    union __tag158 CFDCFSTS1;                              /* CFDCFSTS1        */
    union __tag158 CFDCFSTS2;                              /* CFDCFSTS2        */
    union __tag158 CFDCFSTS3;                              /* CFDCFSTS3        */
    union __tag158 CFDCFSTS4;                              /* CFDCFSTS4        */
    union __tag158 CFDCFSTS5;                              /* CFDCFSTS5        */
    union __tag158 CFDCFSTS6;                              /* CFDCFSTS6        */
    union __tag158 CFDCFSTS7;                              /* CFDCFSTS7        */
    union __tag158 CFDCFSTS8;                              /* CFDCFSTS8        */
    unsigned char  dummy176[60];                           /* Reserved         */
    union __tag158 CFDCFPCTR0;                             /* CFDCFPCTR0       */
    union __tag158 CFDCFPCTR1;                             /* CFDCFPCTR1       */
    union __tag158 CFDCFPCTR2;                             /* CFDCFPCTR2       */
    union __tag158 CFDCFPCTR3;                             /* CFDCFPCTR3       */
    union __tag158 CFDCFPCTR4;                             /* CFDCFPCTR4       */
    union __tag158 CFDCFPCTR5;                             /* CFDCFPCTR5       */
    union __tag158 CFDCFPCTR6;                             /* CFDCFPCTR6       */
    union __tag158 CFDCFPCTR7;                             /* CFDCFPCTR7       */
    union __tag158 CFDCFPCTR8;                             /* CFDCFPCTR8       */
    unsigned char  dummy177[60];                           /* Reserved         */
    union __tag158 CFDFESTS;                               /* CFDFESTS         */
    union __tag158 CFDFFSTS;                               /* CFDFFSTS         */
    union __tag158 CFDFMSTS;                               /* CFDFMSTS         */
    union __tag158 CFDRFISTS;                              /* CFDRFISTS        */
    union __tag158 CFDCFRISTS;                             /* CFDCFRISTS       */
    union __tag158 CFDCFTISTS;                             /* CFDCFTISTS       */
    unsigned char  CFDTMC0;                                /* CFDTMC0          */
    unsigned char  CFDTMC1;                                /* CFDTMC1          */
    unsigned char  CFDTMC2;                                /* CFDTMC2          */
    unsigned char  CFDTMC3;                                /* CFDTMC3          */
    unsigned char  CFDTMC4;                                /* CFDTMC4          */
    unsigned char  CFDTMC5;                                /* CFDTMC5          */
    unsigned char  CFDTMC6;                                /* CFDTMC6          */
    unsigned char  CFDTMC7;                                /* CFDTMC7          */
    unsigned char  CFDTMC8;                                /* CFDTMC8          */
    unsigned char  CFDTMC9;                                /* CFDTMC9          */
    unsigned char  CFDTMC10;                               /* CFDTMC10         */
    unsigned char  CFDTMC11;                               /* CFDTMC11         */
    unsigned char  CFDTMC12;                               /* CFDTMC12         */
    unsigned char  CFDTMC13;                               /* CFDTMC13         */
    unsigned char  CFDTMC14;                               /* CFDTMC14         */
    unsigned char  CFDTMC15;                               /* CFDTMC15         */
    unsigned char  CFDTMC16;                               /* CFDTMC16         */
    unsigned char  CFDTMC17;                               /* CFDTMC17         */
    unsigned char  CFDTMC18;                               /* CFDTMC18         */
    unsigned char  CFDTMC19;                               /* CFDTMC19         */
    unsigned char  CFDTMC20;                               /* CFDTMC20         */
    unsigned char  CFDTMC21;                               /* CFDTMC21         */
    unsigned char  CFDTMC22;                               /* CFDTMC22         */
    unsigned char  CFDTMC23;                               /* CFDTMC23         */
    unsigned char  CFDTMC24;                               /* CFDTMC24         */
    unsigned char  CFDTMC25;                               /* CFDTMC25         */
    unsigned char  CFDTMC26;                               /* CFDTMC26         */
    unsigned char  CFDTMC27;                               /* CFDTMC27         */
    unsigned char  CFDTMC28;                               /* CFDTMC28         */
    unsigned char  CFDTMC29;                               /* CFDTMC29         */
    unsigned char  CFDTMC30;                               /* CFDTMC30         */
    unsigned char  CFDTMC31;                               /* CFDTMC31         */
    unsigned char  CFDTMC32;                               /* CFDTMC32         */
    unsigned char  CFDTMC33;                               /* CFDTMC33         */
    unsigned char  CFDTMC34;                               /* CFDTMC34         */
    unsigned char  CFDTMC35;                               /* CFDTMC35         */
    unsigned char  CFDTMC36;                               /* CFDTMC36         */
    unsigned char  CFDTMC37;                               /* CFDTMC37         */
    unsigned char  CFDTMC38;                               /* CFDTMC38         */
    unsigned char  CFDTMC39;                               /* CFDTMC39         */
    unsigned char  CFDTMC40;                               /* CFDTMC40         */
    unsigned char  CFDTMC41;                               /* CFDTMC41         */
    unsigned char  CFDTMC42;                               /* CFDTMC42         */
    unsigned char  CFDTMC43;                               /* CFDTMC43         */
    unsigned char  CFDTMC44;                               /* CFDTMC44         */
    unsigned char  CFDTMC45;                               /* CFDTMC45         */
    unsigned char  CFDTMC46;                               /* CFDTMC46         */
    unsigned char  CFDTMC47;                               /* CFDTMC47         */
    unsigned char  CFDTMC48;                               /* CFDTMC48         */
    unsigned char  CFDTMC49;                               /* CFDTMC49         */
    unsigned char  CFDTMC50;                               /* CFDTMC50         */
    unsigned char  CFDTMC51;                               /* CFDTMC51         */
    unsigned char  CFDTMC52;                               /* CFDTMC52         */
    unsigned char  CFDTMC53;                               /* CFDTMC53         */
    unsigned char  CFDTMC54;                               /* CFDTMC54         */
    unsigned char  CFDTMC55;                               /* CFDTMC55         */
    unsigned char  CFDTMC56;                               /* CFDTMC56         */
    unsigned char  CFDTMC57;                               /* CFDTMC57         */
    unsigned char  CFDTMC58;                               /* CFDTMC58         */
    unsigned char  CFDTMC59;                               /* CFDTMC59         */
    unsigned char  CFDTMC60;                               /* CFDTMC60         */
    unsigned char  CFDTMC61;                               /* CFDTMC61         */
    unsigned char  CFDTMC62;                               /* CFDTMC62         */
    unsigned char  CFDTMC63;                               /* CFDTMC63         */
    unsigned char  CFDTMC64;                               /* CFDTMC64         */
    unsigned char  CFDTMC65;                               /* CFDTMC65         */
    unsigned char  CFDTMC66;                               /* CFDTMC66         */
    unsigned char  CFDTMC67;                               /* CFDTMC67         */
    unsigned char  CFDTMC68;                               /* CFDTMC68         */
    unsigned char  CFDTMC69;                               /* CFDTMC69         */
    unsigned char  CFDTMC70;                               /* CFDTMC70         */
    unsigned char  CFDTMC71;                               /* CFDTMC71         */
    unsigned char  CFDTMC72;                               /* CFDTMC72         */
    unsigned char  CFDTMC73;                               /* CFDTMC73         */
    unsigned char  CFDTMC74;                               /* CFDTMC74         */
    unsigned char  CFDTMC75;                               /* CFDTMC75         */
    unsigned char  CFDTMC76;                               /* CFDTMC76         */
    unsigned char  CFDTMC77;                               /* CFDTMC77         */
    unsigned char  CFDTMC78;                               /* CFDTMC78         */
    unsigned char  CFDTMC79;                               /* CFDTMC79         */
    unsigned char  CFDTMC80;                               /* CFDTMC80         */
    unsigned char  CFDTMC81;                               /* CFDTMC81         */
    unsigned char  CFDTMC82;                               /* CFDTMC82         */
    unsigned char  CFDTMC83;                               /* CFDTMC83         */
    unsigned char  CFDTMC84;                               /* CFDTMC84         */
    unsigned char  CFDTMC85;                               /* CFDTMC85         */
    unsigned char  CFDTMC86;                               /* CFDTMC86         */
    unsigned char  CFDTMC87;                               /* CFDTMC87         */
    unsigned char  CFDTMC88;                               /* CFDTMC88         */
    unsigned char  CFDTMC89;                               /* CFDTMC89         */
    unsigned char  CFDTMC90;                               /* CFDTMC90         */
    unsigned char  CFDTMC91;                               /* CFDTMC91         */
    unsigned char  CFDTMC92;                               /* CFDTMC92         */
    unsigned char  CFDTMC93;                               /* CFDTMC93         */
    unsigned char  CFDTMC94;                               /* CFDTMC94         */
    unsigned char  CFDTMC95;                               /* CFDTMC95         */
    unsigned char  dummy178[160];                          /* Reserved         */
    unsigned char  CFDTMSTS0;                              /* CFDTMSTS0        */
    unsigned char  CFDTMSTS1;                              /* CFDTMSTS1        */
    unsigned char  CFDTMSTS2;                              /* CFDTMSTS2        */
    unsigned char  CFDTMSTS3;                              /* CFDTMSTS3        */
    unsigned char  CFDTMSTS4;                              /* CFDTMSTS4        */
    unsigned char  CFDTMSTS5;                              /* CFDTMSTS5        */
    unsigned char  CFDTMSTS6;                              /* CFDTMSTS6        */
    unsigned char  CFDTMSTS7;                              /* CFDTMSTS7        */
    unsigned char  CFDTMSTS8;                              /* CFDTMSTS8        */
    unsigned char  CFDTMSTS9;                              /* CFDTMSTS9        */
    unsigned char  CFDTMSTS10;                             /* CFDTMSTS10       */
    unsigned char  CFDTMSTS11;                             /* CFDTMSTS11       */
    unsigned char  CFDTMSTS12;                             /* CFDTMSTS12       */
    unsigned char  CFDTMSTS13;                             /* CFDTMSTS13       */
    unsigned char  CFDTMSTS14;                             /* CFDTMSTS14       */
    unsigned char  CFDTMSTS15;                             /* CFDTMSTS15       */
    unsigned char  CFDTMSTS16;                             /* CFDTMSTS16       */
    unsigned char  CFDTMSTS17;                             /* CFDTMSTS17       */
    unsigned char  CFDTMSTS18;                             /* CFDTMSTS18       */
    unsigned char  CFDTMSTS19;                             /* CFDTMSTS19       */
    unsigned char  CFDTMSTS20;                             /* CFDTMSTS20       */
    unsigned char  CFDTMSTS21;                             /* CFDTMSTS21       */
    unsigned char  CFDTMSTS22;                             /* CFDTMSTS22       */
    unsigned char  CFDTMSTS23;                             /* CFDTMSTS23       */
    unsigned char  CFDTMSTS24;                             /* CFDTMSTS24       */
    unsigned char  CFDTMSTS25;                             /* CFDTMSTS25       */
    unsigned char  CFDTMSTS26;                             /* CFDTMSTS26       */
    unsigned char  CFDTMSTS27;                             /* CFDTMSTS27       */
    unsigned char  CFDTMSTS28;                             /* CFDTMSTS28       */
    unsigned char  CFDTMSTS29;                             /* CFDTMSTS29       */
    unsigned char  CFDTMSTS30;                             /* CFDTMSTS30       */
    unsigned char  CFDTMSTS31;                             /* CFDTMSTS31       */
    unsigned char  CFDTMSTS32;                             /* CFDTMSTS32       */
    unsigned char  CFDTMSTS33;                             /* CFDTMSTS33       */
    unsigned char  CFDTMSTS34;                             /* CFDTMSTS34       */
    unsigned char  CFDTMSTS35;                             /* CFDTMSTS35       */
    unsigned char  CFDTMSTS36;                             /* CFDTMSTS36       */
    unsigned char  CFDTMSTS37;                             /* CFDTMSTS37       */
    unsigned char  CFDTMSTS38;                             /* CFDTMSTS38       */
    unsigned char  CFDTMSTS39;                             /* CFDTMSTS39       */
    unsigned char  CFDTMSTS40;                             /* CFDTMSTS40       */
    unsigned char  CFDTMSTS41;                             /* CFDTMSTS41       */
    unsigned char  CFDTMSTS42;                             /* CFDTMSTS42       */
    unsigned char  CFDTMSTS43;                             /* CFDTMSTS43       */
    unsigned char  CFDTMSTS44;                             /* CFDTMSTS44       */
    unsigned char  CFDTMSTS45;                             /* CFDTMSTS45       */
    unsigned char  CFDTMSTS46;                             /* CFDTMSTS46       */
    unsigned char  CFDTMSTS47;                             /* CFDTMSTS47       */
    unsigned char  CFDTMSTS48;                             /* CFDTMSTS48       */
    unsigned char  CFDTMSTS49;                             /* CFDTMSTS49       */
    unsigned char  CFDTMSTS50;                             /* CFDTMSTS50       */
    unsigned char  CFDTMSTS51;                             /* CFDTMSTS51       */
    unsigned char  CFDTMSTS52;                             /* CFDTMSTS52       */
    unsigned char  CFDTMSTS53;                             /* CFDTMSTS53       */
    unsigned char  CFDTMSTS54;                             /* CFDTMSTS54       */
    unsigned char  CFDTMSTS55;                             /* CFDTMSTS55       */
    unsigned char  CFDTMSTS56;                             /* CFDTMSTS56       */
    unsigned char  CFDTMSTS57;                             /* CFDTMSTS57       */
    unsigned char  CFDTMSTS58;                             /* CFDTMSTS58       */
    unsigned char  CFDTMSTS59;                             /* CFDTMSTS59       */
    unsigned char  CFDTMSTS60;                             /* CFDTMSTS60       */
    unsigned char  CFDTMSTS61;                             /* CFDTMSTS61       */
    unsigned char  CFDTMSTS62;                             /* CFDTMSTS62       */
    unsigned char  CFDTMSTS63;                             /* CFDTMSTS63       */
    unsigned char  CFDTMSTS64;                             /* CFDTMSTS64       */
    unsigned char  CFDTMSTS65;                             /* CFDTMSTS65       */
    unsigned char  CFDTMSTS66;                             /* CFDTMSTS66       */
    unsigned char  CFDTMSTS67;                             /* CFDTMSTS67       */
    unsigned char  CFDTMSTS68;                             /* CFDTMSTS68       */
    unsigned char  CFDTMSTS69;                             /* CFDTMSTS69       */
    unsigned char  CFDTMSTS70;                             /* CFDTMSTS70       */
    unsigned char  CFDTMSTS71;                             /* CFDTMSTS71       */
    unsigned char  CFDTMSTS72;                             /* CFDTMSTS72       */
    unsigned char  CFDTMSTS73;                             /* CFDTMSTS73       */
    unsigned char  CFDTMSTS74;                             /* CFDTMSTS74       */
    unsigned char  CFDTMSTS75;                             /* CFDTMSTS75       */
    unsigned char  CFDTMSTS76;                             /* CFDTMSTS76       */
    unsigned char  CFDTMSTS77;                             /* CFDTMSTS77       */
    unsigned char  CFDTMSTS78;                             /* CFDTMSTS78       */
    unsigned char  CFDTMSTS79;                             /* CFDTMSTS79       */
    unsigned char  CFDTMSTS80;                             /* CFDTMSTS80       */
    unsigned char  CFDTMSTS81;                             /* CFDTMSTS81       */
    unsigned char  CFDTMSTS82;                             /* CFDTMSTS82       */
    unsigned char  CFDTMSTS83;                             /* CFDTMSTS83       */
    unsigned char  CFDTMSTS84;                             /* CFDTMSTS84       */
    unsigned char  CFDTMSTS85;                             /* CFDTMSTS85       */
    unsigned char  CFDTMSTS86;                             /* CFDTMSTS86       */
    unsigned char  CFDTMSTS87;                             /* CFDTMSTS87       */
    unsigned char  CFDTMSTS88;                             /* CFDTMSTS88       */
    unsigned char  CFDTMSTS89;                             /* CFDTMSTS89       */
    unsigned char  CFDTMSTS90;                             /* CFDTMSTS90       */
    unsigned char  CFDTMSTS91;                             /* CFDTMSTS91       */
    unsigned char  CFDTMSTS92;                             /* CFDTMSTS92       */
    unsigned char  CFDTMSTS93;                             /* CFDTMSTS93       */
    unsigned char  CFDTMSTS94;                             /* CFDTMSTS94       */
    unsigned char  CFDTMSTS95;                             /* CFDTMSTS95       */
    unsigned char  dummy179[160];                          /* Reserved         */
    union __tag158 CFDTMTRSTS0;                            /* CFDTMTRSTS0      */
    union __tag158 CFDTMTRSTS1;                            /* CFDTMTRSTS1      */
    union __tag158 CFDTMTRSTS2;                            /* CFDTMTRSTS2      */
    unsigned char  dummy180[20];                           /* Reserved         */
    union __tag158 CFDTMTARSTS0;                           /* CFDTMTARSTS0     */
    union __tag158 CFDTMTARSTS1;                           /* CFDTMTARSTS1     */
    union __tag158 CFDTMTARSTS2;                           /* CFDTMTARSTS2     */
    unsigned char  dummy181[20];                           /* Reserved         */
    union __tag158 CFDTMTCSTS0;                            /* CFDTMTCSTS0      */
    union __tag158 CFDTMTCSTS1;                            /* CFDTMTCSTS1      */
    union __tag158 CFDTMTCSTS2;                            /* CFDTMTCSTS2      */
    unsigned char  dummy182[20];                           /* Reserved         */
    union __tag158 CFDTMTASTS0;                            /* CFDTMTASTS0      */
    union __tag158 CFDTMTASTS1;                            /* CFDTMTASTS1      */
    union __tag158 CFDTMTASTS2;                            /* CFDTMTASTS2      */
    unsigned char  dummy183[20];                           /* Reserved         */
    union __tag158 CFDTMIEC0;                              /* CFDTMIEC0        */
    union __tag158 CFDTMIEC1;                              /* CFDTMIEC1        */
    union __tag158 CFDTMIEC2;                              /* CFDTMIEC2        */
    unsigned char  dummy184[116];                          /* Reserved         */
    union __tag158 CFDTXQCC0;                              /* CFDTXQCC0        */
    union __tag158 CFDTXQCC1;                              /* CFDTXQCC1        */
    union __tag158 CFDTXQCC2;                              /* CFDTXQCC2        */
    unsigned char  dummy185[20];                           /* Reserved         */
    union __tag158 CFDTXQSTS0;                             /* CFDTXQSTS0       */
    union __tag158 CFDTXQSTS1;                             /* CFDTXQSTS1       */
    union __tag158 CFDTXQSTS2;                             /* CFDTXQSTS2       */
    unsigned char  dummy186[20];                           /* Reserved         */
    union __tag158 CFDTXQPCTR0;                            /* CFDTXQPCTR0      */
    union __tag158 CFDTXQPCTR1;                            /* CFDTXQPCTR1      */
    union __tag158 CFDTXQPCTR2;                            /* CFDTXQPCTR2      */
    unsigned char  dummy187[20];                           /* Reserved         */
    union __tag158 CFDTHLCC0;                              /* CFDTHLCC0        */
    union __tag158 CFDTHLCC1;                              /* CFDTHLCC1        */
    union __tag158 CFDTHLCC2;                              /* CFDTHLCC2        */
    unsigned char  dummy188[20];                           /* Reserved         */
    union __tag158 CFDTHLSTS0;                             /* CFDTHLSTS0       */
    union __tag158 CFDTHLSTS1;                             /* CFDTHLSTS1       */
    union __tag158 CFDTHLSTS2;                             /* CFDTHLSTS2       */
    unsigned char  dummy189[20];                           /* Reserved         */
    union __tag158 CFDTHLPCTR0;                            /* CFDTHLPCTR0      */
    union __tag158 CFDTHLPCTR1;                            /* CFDTHLPCTR1      */
    union __tag158 CFDTHLPCTR2;                            /* CFDTHLPCTR2      */
    unsigned char  dummy190[20];                           /* Reserved         */
    union __tag158 CFDGTINTSTS0;                           /* CFDGTINTSTS0     */
    unsigned char  dummy191[4];                            /* Reserved         */
    union __tag158 CFDGTSTCFG;                             /* CFDGTSTCFG       */
    union __tag158 CFDGTSTCTR;                             /* CFDGTSTCTR       */
    unsigned char  dummy192[4];                            /* Reserved         */
    union __tag158 CFDGFDCFG;                              /* CFDGFDCFG        */
    unsigned char  dummy193[4];                            /* Reserved         */
    union __tag164 CFDGLOCKK;                              /* CFDGLOCKK        */
    unsigned char  dummy194[16];                           /* Reserved         */
    union __tag158 CFDCDTCT;                               /* CFDCDTCT         */
    union __tag158 CFDCDTSTS;                              /* CFDCDTSTS        */
    unsigned char  dummy195[184];                          /* Reserved         */
    union __tag158 CFDC0DCFG;                              /* CFDC0DCFG        */
    union __tag158 CFDC0FDCFG;                             /* CFDC0FDCFG       */
    union __tag158 CFDC0FDCTR;                             /* CFDC0FDCTR       */
    union __tag158 CFDC0FDSTS;                             /* CFDC0FDSTS       */
    union __tag158 CFDC0FDCRC;                             /* CFDC0FDCRC       */
    unsigned char  dummy196[12];                           /* Reserved         */
    union __tag158 CFDC1DCFG;                              /* CFDC1DCFG        */
    union __tag158 CFDC1FDCFG;                             /* CFDC1FDCFG       */
    union __tag158 CFDC1FDCTR;                             /* CFDC1FDCTR       */
    union __tag158 CFDC1FDSTS;                             /* CFDC1FDSTS       */
    union __tag158 CFDC1FDCRC;                             /* CFDC1FDCRC       */
    unsigned char  dummy197[12];                           /* Reserved         */
    union __tag158 CFDC2DCFG;                              /* CFDC2DCFG        */
    union __tag158 CFDC2FDCFG;                             /* CFDC2FDCFG       */
    union __tag158 CFDC2FDCTR;                             /* CFDC2FDCTR       */
    union __tag158 CFDC2FDSTS;                             /* CFDC2FDSTS       */
    union __tag158 CFDC2FDCRC;                             /* CFDC2FDCRC       */
    unsigned char  dummy198[2220];                         /* Reserved         */
    union __tag158 CFDGAFLID0;                             /* CFDGAFLID0       */
    union __tag158 CFDGAFLM0;                              /* CFDGAFLM0        */
    union __tag158 CFDGAFLP0_0;                            /* CFDGAFLP0_0      */
    union __tag158 CFDGAFLP1_0;                            /* CFDGAFLP1_0      */
    union __tag158 CFDGAFLID1;                             /* CFDGAFLID1       */
    union __tag158 CFDGAFLM1;                              /* CFDGAFLM1        */
    union __tag158 CFDGAFLP0_1;                            /* CFDGAFLP0_1      */
    union __tag158 CFDGAFLP1_1;                            /* CFDGAFLP1_1      */
    union __tag158 CFDGAFLID2;                             /* CFDGAFLID2       */
    union __tag158 CFDGAFLM2;                              /* CFDGAFLM2        */
    union __tag158 CFDGAFLP0_2;                            /* CFDGAFLP0_2      */
    union __tag158 CFDGAFLP1_2;                            /* CFDGAFLP1_2      */
    union __tag158 CFDGAFLID3;                             /* CFDGAFLID3       */
    union __tag158 CFDGAFLM3;                              /* CFDGAFLM3        */
    union __tag158 CFDGAFLP0_3;                            /* CFDGAFLP0_3      */
    union __tag158 CFDGAFLP1_3;                            /* CFDGAFLP1_3      */
    union __tag158 CFDGAFLID4;                             /* CFDGAFLID4       */
    union __tag158 CFDGAFLM4;                              /* CFDGAFLM4        */
    union __tag158 CFDGAFLP0_4;                            /* CFDGAFLP0_4      */
    union __tag158 CFDGAFLP1_4;                            /* CFDGAFLP1_4      */
    union __tag158 CFDGAFLID5;                             /* CFDGAFLID5       */
    union __tag158 CFDGAFLM5;                              /* CFDGAFLM5        */
    union __tag158 CFDGAFLP0_5;                            /* CFDGAFLP0_5      */
    union __tag158 CFDGAFLP1_5;                            /* CFDGAFLP1_5      */
    union __tag158 CFDGAFLID6;                             /* CFDGAFLID6       */
    union __tag158 CFDGAFLM6;                              /* CFDGAFLM6        */
    union __tag158 CFDGAFLP0_6;                            /* CFDGAFLP0_6      */
    union __tag158 CFDGAFLP1_6;                            /* CFDGAFLP1_6      */
    union __tag158 CFDGAFLID7;                             /* CFDGAFLID7       */
    union __tag158 CFDGAFLM7;                              /* CFDGAFLM7        */
    union __tag158 CFDGAFLP0_7;                            /* CFDGAFLP0_7      */
    union __tag158 CFDGAFLP1_7;                            /* CFDGAFLP1_7      */
    union __tag158 CFDGAFLID8;                             /* CFDGAFLID8       */
    union __tag158 CFDGAFLM8;                              /* CFDGAFLM8        */
    union __tag158 CFDGAFLP0_8;                            /* CFDGAFLP0_8      */
    union __tag158 CFDGAFLP1_8;                            /* CFDGAFLP1_8      */
    union __tag158 CFDGAFLID9;                             /* CFDGAFLID9       */
    union __tag158 CFDGAFLM9;                              /* CFDGAFLM9        */
    union __tag158 CFDGAFLP0_9;                            /* CFDGAFLP0_9      */
    union __tag158 CFDGAFLP1_9;                            /* CFDGAFLP1_9      */
    union __tag158 CFDGAFLID10;                            /* CFDGAFLID10      */
    union __tag158 CFDGAFLM10;                             /* CFDGAFLM10       */
    union __tag158 CFDGAFLP0_10;                           /* CFDGAFLP0_10     */
    union __tag158 CFDGAFLP1_10;                           /* CFDGAFLP1_10     */
    union __tag158 CFDGAFLID11;                            /* CFDGAFLID11      */
    union __tag158 CFDGAFLM11;                             /* CFDGAFLM11       */
    union __tag158 CFDGAFLP0_11;                           /* CFDGAFLP0_11     */
    union __tag158 CFDGAFLP1_11;                           /* CFDGAFLP1_11     */
    union __tag158 CFDGAFLID12;                            /* CFDGAFLID12      */
    union __tag158 CFDGAFLM12;                             /* CFDGAFLM12       */
    union __tag158 CFDGAFLP0_12;                           /* CFDGAFLP0_12     */
    union __tag158 CFDGAFLP1_12;                           /* CFDGAFLP1_12     */
    union __tag158 CFDGAFLID13;                            /* CFDGAFLID13      */
    union __tag158 CFDGAFLM13;                             /* CFDGAFLM13       */
    union __tag158 CFDGAFLP0_13;                           /* CFDGAFLP0_13     */
    union __tag158 CFDGAFLP1_13;                           /* CFDGAFLP1_13     */
    union __tag158 CFDGAFLID14;                            /* CFDGAFLID14      */
    union __tag158 CFDGAFLM14;                             /* CFDGAFLM14       */
    union __tag158 CFDGAFLP0_14;                           /* CFDGAFLP0_14     */
    union __tag158 CFDGAFLP1_14;                           /* CFDGAFLP1_14     */
    union __tag158 CFDGAFLID15;                            /* CFDGAFLID15      */
    union __tag158 CFDGAFLM15;                             /* CFDGAFLM15       */
    union __tag158 CFDGAFLP0_15;                           /* CFDGAFLP0_15     */
    union __tag158 CFDGAFLP1_15;                           /* CFDGAFLP1_15     */
    unsigned char  dummy199[3840];                         /* Reserved         */
    union __tag158 CFDRMID0;                               /* CFDRMID0         */
    union __tag158 CFDRMPTR0;                              /* CFDRMPTR0        */
    union __tag158 CFDRMFDSTS0;                            /* CFDRMFDSTS0      */
    union __tag158 CFDRMDF0_0;                             /* CFDRMDF0_0       */
    union __tag158 CFDRMDF1_0;                             /* CFDRMDF1_0       */
    union __tag158 CFDRMDF2_0;                             /* CFDRMDF2_0       */
    union __tag158 CFDRMDF3_0;                             /* CFDRMDF3_0       */
    union __tag158 CFDRMDF4_0;                             /* CFDRMDF4_0       */
    union __tag158 CFDRMDF5_0;                             /* CFDRMDF5_0       */
    union __tag158 CFDRMDF6_0;                             /* CFDRMDF6_0       */
    union __tag158 CFDRMDF7_0;                             /* CFDRMDF7_0       */
    union __tag158 CFDRMDF8_0;                             /* CFDRMDF8_0       */
    union __tag158 CFDRMDF9_0;                             /* CFDRMDF9_0       */
    union __tag158 CFDRMDF10_0;                            /* CFDRMDF10_0      */
    union __tag158 CFDRMDF11_0;                            /* CFDRMDF11_0      */
    union __tag158 CFDRMDF12_0;                            /* CFDRMDF12_0      */
    union __tag158 CFDRMDF13_0;                            /* CFDRMDF13_0      */
    union __tag158 CFDRMDF14_0;                            /* CFDRMDF14_0      */
    union __tag158 CFDRMDF15_0;                            /* CFDRMDF15_0      */
    unsigned char  dummy200[52];                           /* Reserved         */
    union __tag158 CFDRMID1;                               /* CFDRMID1         */
    union __tag158 CFDRMPTR1;                              /* CFDRMPTR1        */
    union __tag158 CFDRMFDSTS1;                            /* CFDRMFDSTS1      */
    union __tag158 CFDRMDF0_1;                             /* CFDRMDF0_1       */
    union __tag158 CFDRMDF1_1;                             /* CFDRMDF1_1       */
    union __tag158 CFDRMDF2_1;                             /* CFDRMDF2_1       */
    union __tag158 CFDRMDF3_1;                             /* CFDRMDF3_1       */
    union __tag158 CFDRMDF4_1;                             /* CFDRMDF4_1       */
    union __tag158 CFDRMDF5_1;                             /* CFDRMDF5_1       */
    union __tag158 CFDRMDF6_1;                             /* CFDRMDF6_1       */
    union __tag158 CFDRMDF7_1;                             /* CFDRMDF7_1       */
    union __tag158 CFDRMDF8_1;                             /* CFDRMDF8_1       */
    union __tag158 CFDRMDF9_1;                             /* CFDRMDF9_1       */
    union __tag158 CFDRMDF10_1;                            /* CFDRMDF10_1      */
    union __tag158 CFDRMDF11_1;                            /* CFDRMDF11_1      */
    union __tag158 CFDRMDF12_1;                            /* CFDRMDF12_1      */
    union __tag158 CFDRMDF13_1;                            /* CFDRMDF13_1      */
    union __tag158 CFDRMDF14_1;                            /* CFDRMDF14_1      */
    union __tag158 CFDRMDF15_1;                            /* CFDRMDF15_1      */
    unsigned char  dummy201[52];                           /* Reserved         */
    union __tag158 CFDRMID2;                               /* CFDRMID2         */
    union __tag158 CFDRMPTR2;                              /* CFDRMPTR2        */
    union __tag158 CFDRMFDSTS2;                            /* CFDRMFDSTS2      */
    union __tag158 CFDRMDF0_2;                             /* CFDRMDF0_2       */
    union __tag158 CFDRMDF1_2;                             /* CFDRMDF1_2       */
    union __tag158 CFDRMDF2_2;                             /* CFDRMDF2_2       */
    union __tag158 CFDRMDF3_2;                             /* CFDRMDF3_2       */
    union __tag158 CFDRMDF4_2;                             /* CFDRMDF4_2       */
    union __tag158 CFDRMDF5_2;                             /* CFDRMDF5_2       */
    union __tag158 CFDRMDF6_2;                             /* CFDRMDF6_2       */
    union __tag158 CFDRMDF7_2;                             /* CFDRMDF7_2       */
    union __tag158 CFDRMDF8_2;                             /* CFDRMDF8_2       */
    union __tag158 CFDRMDF9_2;                             /* CFDRMDF9_2       */
    union __tag158 CFDRMDF10_2;                            /* CFDRMDF10_2      */
    union __tag158 CFDRMDF11_2;                            /* CFDRMDF11_2      */
    union __tag158 CFDRMDF12_2;                            /* CFDRMDF12_2      */
    union __tag158 CFDRMDF13_2;                            /* CFDRMDF13_2      */
    union __tag158 CFDRMDF14_2;                            /* CFDRMDF14_2      */
    union __tag158 CFDRMDF15_2;                            /* CFDRMDF15_2      */
    unsigned char  dummy202[52];                           /* Reserved         */
    union __tag158 CFDRMID3;                               /* CFDRMID3         */
    union __tag158 CFDRMPTR3;                              /* CFDRMPTR3        */
    union __tag158 CFDRMFDSTS3;                            /* CFDRMFDSTS3      */
    union __tag158 CFDRMDF0_3;                             /* CFDRMDF0_3       */
    union __tag158 CFDRMDF1_3;                             /* CFDRMDF1_3       */
    union __tag158 CFDRMDF2_3;                             /* CFDRMDF2_3       */
    union __tag158 CFDRMDF3_3;                             /* CFDRMDF3_3       */
    union __tag158 CFDRMDF4_3;                             /* CFDRMDF4_3       */
    union __tag158 CFDRMDF5_3;                             /* CFDRMDF5_3       */
    union __tag158 CFDRMDF6_3;                             /* CFDRMDF6_3       */
    union __tag158 CFDRMDF7_3;                             /* CFDRMDF7_3       */
    union __tag158 CFDRMDF8_3;                             /* CFDRMDF8_3       */
    union __tag158 CFDRMDF9_3;                             /* CFDRMDF9_3       */
    union __tag158 CFDRMDF10_3;                            /* CFDRMDF10_3      */
    union __tag158 CFDRMDF11_3;                            /* CFDRMDF11_3      */
    union __tag158 CFDRMDF12_3;                            /* CFDRMDF12_3      */
    union __tag158 CFDRMDF13_3;                            /* CFDRMDF13_3      */
    union __tag158 CFDRMDF14_3;                            /* CFDRMDF14_3      */
    union __tag158 CFDRMDF15_3;                            /* CFDRMDF15_3      */
    unsigned char  dummy203[52];                           /* Reserved         */
    union __tag158 CFDRMID4;                               /* CFDRMID4         */
    union __tag158 CFDRMPTR4;                              /* CFDRMPTR4        */
    union __tag158 CFDRMFDSTS4;                            /* CFDRMFDSTS4      */
    union __tag158 CFDRMDF0_4;                             /* CFDRMDF0_4       */
    union __tag158 CFDRMDF1_4;                             /* CFDRMDF1_4       */
    union __tag158 CFDRMDF2_4;                             /* CFDRMDF2_4       */
    union __tag158 CFDRMDF3_4;                             /* CFDRMDF3_4       */
    union __tag158 CFDRMDF4_4;                             /* CFDRMDF4_4       */
    union __tag158 CFDRMDF5_4;                             /* CFDRMDF5_4       */
    union __tag158 CFDRMDF6_4;                             /* CFDRMDF6_4       */
    union __tag158 CFDRMDF7_4;                             /* CFDRMDF7_4       */
    union __tag158 CFDRMDF8_4;                             /* CFDRMDF8_4       */
    union __tag158 CFDRMDF9_4;                             /* CFDRMDF9_4       */
    union __tag158 CFDRMDF10_4;                            /* CFDRMDF10_4      */
    union __tag158 CFDRMDF11_4;                            /* CFDRMDF11_4      */
    union __tag158 CFDRMDF12_4;                            /* CFDRMDF12_4      */
    union __tag158 CFDRMDF13_4;                            /* CFDRMDF13_4      */
    union __tag158 CFDRMDF14_4;                            /* CFDRMDF14_4      */
    union __tag158 CFDRMDF15_4;                            /* CFDRMDF15_4      */
    unsigned char  dummy204[52];                           /* Reserved         */
    union __tag158 CFDRMID5;                               /* CFDRMID5         */
    union __tag158 CFDRMPTR5;                              /* CFDRMPTR5        */
    union __tag158 CFDRMFDSTS5;                            /* CFDRMFDSTS5      */
    union __tag158 CFDRMDF0_5;                             /* CFDRMDF0_5       */
    union __tag158 CFDRMDF1_5;                             /* CFDRMDF1_5       */
    union __tag158 CFDRMDF2_5;                             /* CFDRMDF2_5       */
    union __tag158 CFDRMDF3_5;                             /* CFDRMDF3_5       */
    union __tag158 CFDRMDF4_5;                             /* CFDRMDF4_5       */
    union __tag158 CFDRMDF5_5;                             /* CFDRMDF5_5       */
    union __tag158 CFDRMDF6_5;                             /* CFDRMDF6_5       */
    union __tag158 CFDRMDF7_5;                             /* CFDRMDF7_5       */
    union __tag158 CFDRMDF8_5;                             /* CFDRMDF8_5       */
    union __tag158 CFDRMDF9_5;                             /* CFDRMDF9_5       */
    union __tag158 CFDRMDF10_5;                            /* CFDRMDF10_5      */
    union __tag158 CFDRMDF11_5;                            /* CFDRMDF11_5      */
    union __tag158 CFDRMDF12_5;                            /* CFDRMDF12_5      */
    union __tag158 CFDRMDF13_5;                            /* CFDRMDF13_5      */
    union __tag158 CFDRMDF14_5;                            /* CFDRMDF14_5      */
    union __tag158 CFDRMDF15_5;                            /* CFDRMDF15_5      */
    unsigned char  dummy205[52];                           /* Reserved         */
    union __tag158 CFDRMID6;                               /* CFDRMID6         */
    union __tag158 CFDRMPTR6;                              /* CFDRMPTR6        */
    union __tag158 CFDRMFDSTS6;                            /* CFDRMFDSTS6      */
    union __tag158 CFDRMDF0_6;                             /* CFDRMDF0_6       */
    union __tag158 CFDRMDF1_6;                             /* CFDRMDF1_6       */
    union __tag158 CFDRMDF2_6;                             /* CFDRMDF2_6       */
    union __tag158 CFDRMDF3_6;                             /* CFDRMDF3_6       */
    union __tag158 CFDRMDF4_6;                             /* CFDRMDF4_6       */
    union __tag158 CFDRMDF5_6;                             /* CFDRMDF5_6       */
    union __tag158 CFDRMDF6_6;                             /* CFDRMDF6_6       */
    union __tag158 CFDRMDF7_6;                             /* CFDRMDF7_6       */
    union __tag158 CFDRMDF8_6;                             /* CFDRMDF8_6       */
    union __tag158 CFDRMDF9_6;                             /* CFDRMDF9_6       */
    union __tag158 CFDRMDF10_6;                            /* CFDRMDF10_6      */
    union __tag158 CFDRMDF11_6;                            /* CFDRMDF11_6      */
    union __tag158 CFDRMDF12_6;                            /* CFDRMDF12_6      */
    union __tag158 CFDRMDF13_6;                            /* CFDRMDF13_6      */
    union __tag158 CFDRMDF14_6;                            /* CFDRMDF14_6      */
    union __tag158 CFDRMDF15_6;                            /* CFDRMDF15_6      */
    unsigned char  dummy206[52];                           /* Reserved         */
    union __tag158 CFDRMID7;                               /* CFDRMID7         */
    union __tag158 CFDRMPTR7;                              /* CFDRMPTR7        */
    union __tag158 CFDRMFDSTS7;                            /* CFDRMFDSTS7      */
    union __tag158 CFDRMDF0_7;                             /* CFDRMDF0_7       */
    union __tag158 CFDRMDF1_7;                             /* CFDRMDF1_7       */
    union __tag158 CFDRMDF2_7;                             /* CFDRMDF2_7       */
    union __tag158 CFDRMDF3_7;                             /* CFDRMDF3_7       */
    union __tag158 CFDRMDF4_7;                             /* CFDRMDF4_7       */
    union __tag158 CFDRMDF5_7;                             /* CFDRMDF5_7       */
    union __tag158 CFDRMDF6_7;                             /* CFDRMDF6_7       */
    union __tag158 CFDRMDF7_7;                             /* CFDRMDF7_7       */
    union __tag158 CFDRMDF8_7;                             /* CFDRMDF8_7       */
    union __tag158 CFDRMDF9_7;                             /* CFDRMDF9_7       */
    union __tag158 CFDRMDF10_7;                            /* CFDRMDF10_7      */
    union __tag158 CFDRMDF11_7;                            /* CFDRMDF11_7      */
    union __tag158 CFDRMDF12_7;                            /* CFDRMDF12_7      */
    union __tag158 CFDRMDF13_7;                            /* CFDRMDF13_7      */
    union __tag158 CFDRMDF14_7;                            /* CFDRMDF14_7      */
    union __tag158 CFDRMDF15_7;                            /* CFDRMDF15_7      */
    unsigned char  dummy207[52];                           /* Reserved         */
    union __tag158 CFDRMID8;                               /* CFDRMID8         */
    union __tag158 CFDRMPTR8;                              /* CFDRMPTR8        */
    union __tag158 CFDRMFDSTS8;                            /* CFDRMFDSTS8      */
    union __tag158 CFDRMDF0_8;                             /* CFDRMDF0_8       */
    union __tag158 CFDRMDF1_8;                             /* CFDRMDF1_8       */
    union __tag158 CFDRMDF2_8;                             /* CFDRMDF2_8       */
    union __tag158 CFDRMDF3_8;                             /* CFDRMDF3_8       */
    union __tag158 CFDRMDF4_8;                             /* CFDRMDF4_8       */
    union __tag158 CFDRMDF5_8;                             /* CFDRMDF5_8       */
    union __tag158 CFDRMDF6_8;                             /* CFDRMDF6_8       */
    union __tag158 CFDRMDF7_8;                             /* CFDRMDF7_8       */
    union __tag158 CFDRMDF8_8;                             /* CFDRMDF8_8       */
    union __tag158 CFDRMDF9_8;                             /* CFDRMDF9_8       */
    union __tag158 CFDRMDF10_8;                            /* CFDRMDF10_8      */
    union __tag158 CFDRMDF11_8;                            /* CFDRMDF11_8      */
    union __tag158 CFDRMDF12_8;                            /* CFDRMDF12_8      */
    union __tag158 CFDRMDF13_8;                            /* CFDRMDF13_8      */
    union __tag158 CFDRMDF14_8;                            /* CFDRMDF14_8      */
    union __tag158 CFDRMDF15_8;                            /* CFDRMDF15_8      */
    unsigned char  dummy208[52];                           /* Reserved         */
    union __tag158 CFDRMID9;                               /* CFDRMID9         */
    union __tag158 CFDRMPTR9;                              /* CFDRMPTR9        */
    union __tag158 CFDRMFDSTS9;                            /* CFDRMFDSTS9      */
    union __tag158 CFDRMDF0_9;                             /* CFDRMDF0_9       */
    union __tag158 CFDRMDF1_9;                             /* CFDRMDF1_9       */
    union __tag158 CFDRMDF2_9;                             /* CFDRMDF2_9       */
    union __tag158 CFDRMDF3_9;                             /* CFDRMDF3_9       */
    union __tag158 CFDRMDF4_9;                             /* CFDRMDF4_9       */
    union __tag158 CFDRMDF5_9;                             /* CFDRMDF5_9       */
    union __tag158 CFDRMDF6_9;                             /* CFDRMDF6_9       */
    union __tag158 CFDRMDF7_9;                             /* CFDRMDF7_9       */
    union __tag158 CFDRMDF8_9;                             /* CFDRMDF8_9       */
    union __tag158 CFDRMDF9_9;                             /* CFDRMDF9_9       */
    union __tag158 CFDRMDF10_9;                            /* CFDRMDF10_9      */
    union __tag158 CFDRMDF11_9;                            /* CFDRMDF11_9      */
    union __tag158 CFDRMDF12_9;                            /* CFDRMDF12_9      */
    union __tag158 CFDRMDF13_9;                            /* CFDRMDF13_9      */
    union __tag158 CFDRMDF14_9;                            /* CFDRMDF14_9      */
    union __tag158 CFDRMDF15_9;                            /* CFDRMDF15_9      */
    unsigned char  dummy209[52];                           /* Reserved         */
    union __tag158 CFDRMID10;                              /* CFDRMID10        */
    union __tag158 CFDRMPTR10;                             /* CFDRMPTR10       */
    union __tag158 CFDRMFDSTS10;                           /* CFDRMFDSTS10     */
    union __tag158 CFDRMDF0_10;                            /* CFDRMDF0_10      */
    union __tag158 CFDRMDF1_10;                            /* CFDRMDF1_10      */
    union __tag158 CFDRMDF2_10;                            /* CFDRMDF2_10      */
    union __tag158 CFDRMDF3_10;                            /* CFDRMDF3_10      */
    union __tag158 CFDRMDF4_10;                            /* CFDRMDF4_10      */
    union __tag158 CFDRMDF5_10;                            /* CFDRMDF5_10      */
    union __tag158 CFDRMDF6_10;                            /* CFDRMDF6_10      */
    union __tag158 CFDRMDF7_10;                            /* CFDRMDF7_10      */
    union __tag158 CFDRMDF8_10;                            /* CFDRMDF8_10      */
    union __tag158 CFDRMDF9_10;                            /* CFDRMDF9_10      */
    union __tag158 CFDRMDF10_10;                           /* CFDRMDF10_10     */
    union __tag158 CFDRMDF11_10;                           /* CFDRMDF11_10     */
    union __tag158 CFDRMDF12_10;                           /* CFDRMDF12_10     */
    union __tag158 CFDRMDF13_10;                           /* CFDRMDF13_10     */
    union __tag158 CFDRMDF14_10;                           /* CFDRMDF14_10     */
    union __tag158 CFDRMDF15_10;                           /* CFDRMDF15_10     */
    unsigned char  dummy210[52];                           /* Reserved         */
    union __tag158 CFDRMID11;                              /* CFDRMID11        */
    union __tag158 CFDRMPTR11;                             /* CFDRMPTR11       */
    union __tag158 CFDRMFDSTS11;                           /* CFDRMFDSTS11     */
    union __tag158 CFDRMDF0_11;                            /* CFDRMDF0_11      */
    union __tag158 CFDRMDF1_11;                            /* CFDRMDF1_11      */
    union __tag158 CFDRMDF2_11;                            /* CFDRMDF2_11      */
    union __tag158 CFDRMDF3_11;                            /* CFDRMDF3_11      */
    union __tag158 CFDRMDF4_11;                            /* CFDRMDF4_11      */
    union __tag158 CFDRMDF5_11;                            /* CFDRMDF5_11      */
    union __tag158 CFDRMDF6_11;                            /* CFDRMDF6_11      */
    union __tag158 CFDRMDF7_11;                            /* CFDRMDF7_11      */
    union __tag158 CFDRMDF8_11;                            /* CFDRMDF8_11      */
    union __tag158 CFDRMDF9_11;                            /* CFDRMDF9_11      */
    union __tag158 CFDRMDF10_11;                           /* CFDRMDF10_11     */
    union __tag158 CFDRMDF11_11;                           /* CFDRMDF11_11     */
    union __tag158 CFDRMDF12_11;                           /* CFDRMDF12_11     */
    union __tag158 CFDRMDF13_11;                           /* CFDRMDF13_11     */
    union __tag158 CFDRMDF14_11;                           /* CFDRMDF14_11     */
    union __tag158 CFDRMDF15_11;                           /* CFDRMDF15_11     */
    unsigned char  dummy211[52];                           /* Reserved         */
    union __tag158 CFDRMID12;                              /* CFDRMID12        */
    union __tag158 CFDRMPTR12;                             /* CFDRMPTR12       */
    union __tag158 CFDRMFDSTS12;                           /* CFDRMFDSTS12     */
    union __tag158 CFDRMDF0_12;                            /* CFDRMDF0_12      */
    union __tag158 CFDRMDF1_12;                            /* CFDRMDF1_12      */
    union __tag158 CFDRMDF2_12;                            /* CFDRMDF2_12      */
    union __tag158 CFDRMDF3_12;                            /* CFDRMDF3_12      */
    union __tag158 CFDRMDF4_12;                            /* CFDRMDF4_12      */
    union __tag158 CFDRMDF5_12;                            /* CFDRMDF5_12      */
    union __tag158 CFDRMDF6_12;                            /* CFDRMDF6_12      */
    union __tag158 CFDRMDF7_12;                            /* CFDRMDF7_12      */
    union __tag158 CFDRMDF8_12;                            /* CFDRMDF8_12      */
    union __tag158 CFDRMDF9_12;                            /* CFDRMDF9_12      */
    union __tag158 CFDRMDF10_12;                           /* CFDRMDF10_12     */
    union __tag158 CFDRMDF11_12;                           /* CFDRMDF11_12     */
    union __tag158 CFDRMDF12_12;                           /* CFDRMDF12_12     */
    union __tag158 CFDRMDF13_12;                           /* CFDRMDF13_12     */
    union __tag158 CFDRMDF14_12;                           /* CFDRMDF14_12     */
    union __tag158 CFDRMDF15_12;                           /* CFDRMDF15_12     */
    unsigned char  dummy212[52];                           /* Reserved         */
    union __tag158 CFDRMID13;                              /* CFDRMID13        */
    union __tag158 CFDRMPTR13;                             /* CFDRMPTR13       */
    union __tag158 CFDRMFDSTS13;                           /* CFDRMFDSTS13     */
    union __tag158 CFDRMDF0_13;                            /* CFDRMDF0_13      */
    union __tag158 CFDRMDF1_13;                            /* CFDRMDF1_13      */
    union __tag158 CFDRMDF2_13;                            /* CFDRMDF2_13      */
    union __tag158 CFDRMDF3_13;                            /* CFDRMDF3_13      */
    union __tag158 CFDRMDF4_13;                            /* CFDRMDF4_13      */
    union __tag158 CFDRMDF5_13;                            /* CFDRMDF5_13      */
    union __tag158 CFDRMDF6_13;                            /* CFDRMDF6_13      */
    union __tag158 CFDRMDF7_13;                            /* CFDRMDF7_13      */
    union __tag158 CFDRMDF8_13;                            /* CFDRMDF8_13      */
    union __tag158 CFDRMDF9_13;                            /* CFDRMDF9_13      */
    union __tag158 CFDRMDF10_13;                           /* CFDRMDF10_13     */
    union __tag158 CFDRMDF11_13;                           /* CFDRMDF11_13     */
    union __tag158 CFDRMDF12_13;                           /* CFDRMDF12_13     */
    union __tag158 CFDRMDF13_13;                           /* CFDRMDF13_13     */
    union __tag158 CFDRMDF14_13;                           /* CFDRMDF14_13     */
    union __tag158 CFDRMDF15_13;                           /* CFDRMDF15_13     */
    unsigned char  dummy213[52];                           /* Reserved         */
    union __tag158 CFDRMID14;                              /* CFDRMID14        */
    union __tag158 CFDRMPTR14;                             /* CFDRMPTR14       */
    union __tag158 CFDRMFDSTS14;                           /* CFDRMFDSTS14     */
    union __tag158 CFDRMDF0_14;                            /* CFDRMDF0_14      */
    union __tag158 CFDRMDF1_14;                            /* CFDRMDF1_14      */
    union __tag158 CFDRMDF2_14;                            /* CFDRMDF2_14      */
    union __tag158 CFDRMDF3_14;                            /* CFDRMDF3_14      */
    union __tag158 CFDRMDF4_14;                            /* CFDRMDF4_14      */
    union __tag158 CFDRMDF5_14;                            /* CFDRMDF5_14      */
    union __tag158 CFDRMDF6_14;                            /* CFDRMDF6_14      */
    union __tag158 CFDRMDF7_14;                            /* CFDRMDF7_14      */
    union __tag158 CFDRMDF8_14;                            /* CFDRMDF8_14      */
    union __tag158 CFDRMDF9_14;                            /* CFDRMDF9_14      */
    union __tag158 CFDRMDF10_14;                           /* CFDRMDF10_14     */
    union __tag158 CFDRMDF11_14;                           /* CFDRMDF11_14     */
    union __tag158 CFDRMDF12_14;                           /* CFDRMDF12_14     */
    union __tag158 CFDRMDF13_14;                           /* CFDRMDF13_14     */
    union __tag158 CFDRMDF14_14;                           /* CFDRMDF14_14     */
    union __tag158 CFDRMDF15_14;                           /* CFDRMDF15_14     */
    unsigned char  dummy214[52];                           /* Reserved         */
    union __tag158 CFDRMID15;                              /* CFDRMID15        */
    union __tag158 CFDRMPTR15;                             /* CFDRMPTR15       */
    union __tag158 CFDRMFDSTS15;                           /* CFDRMFDSTS15     */
    union __tag158 CFDRMDF0_15;                            /* CFDRMDF0_15      */
    union __tag158 CFDRMDF1_15;                            /* CFDRMDF1_15      */
    union __tag158 CFDRMDF2_15;                            /* CFDRMDF2_15      */
    union __tag158 CFDRMDF3_15;                            /* CFDRMDF3_15      */
    union __tag158 CFDRMDF4_15;                            /* CFDRMDF4_15      */
    union __tag158 CFDRMDF5_15;                            /* CFDRMDF5_15      */
    union __tag158 CFDRMDF6_15;                            /* CFDRMDF6_15      */
    union __tag158 CFDRMDF7_15;                            /* CFDRMDF7_15      */
    union __tag158 CFDRMDF8_15;                            /* CFDRMDF8_15      */
    union __tag158 CFDRMDF9_15;                            /* CFDRMDF9_15      */
    union __tag158 CFDRMDF10_15;                           /* CFDRMDF10_15     */
    union __tag158 CFDRMDF11_15;                           /* CFDRMDF11_15     */
    union __tag158 CFDRMDF12_15;                           /* CFDRMDF12_15     */
    union __tag158 CFDRMDF13_15;                           /* CFDRMDF13_15     */
    union __tag158 CFDRMDF14_15;                           /* CFDRMDF14_15     */
    union __tag158 CFDRMDF15_15;                           /* CFDRMDF15_15     */
    unsigned char  dummy215[52];                           /* Reserved         */
    union __tag158 CFDRMID16;                              /* CFDRMID16        */
    union __tag158 CFDRMPTR16;                             /* CFDRMPTR16       */
    union __tag158 CFDRMFDSTS16;                           /* CFDRMFDSTS16     */
    union __tag158 CFDRMDF0_16;                            /* CFDRMDF0_16      */
    union __tag158 CFDRMDF1_16;                            /* CFDRMDF1_16      */
    union __tag158 CFDRMDF2_16;                            /* CFDRMDF2_16      */
    union __tag158 CFDRMDF3_16;                            /* CFDRMDF3_16      */
    union __tag158 CFDRMDF4_16;                            /* CFDRMDF4_16      */
    union __tag158 CFDRMDF5_16;                            /* CFDRMDF5_16      */
    union __tag158 CFDRMDF6_16;                            /* CFDRMDF6_16      */
    union __tag158 CFDRMDF7_16;                            /* CFDRMDF7_16      */
    union __tag158 CFDRMDF8_16;                            /* CFDRMDF8_16      */
    union __tag158 CFDRMDF9_16;                            /* CFDRMDF9_16      */
    union __tag158 CFDRMDF10_16;                           /* CFDRMDF10_16     */
    union __tag158 CFDRMDF11_16;                           /* CFDRMDF11_16     */
    union __tag158 CFDRMDF12_16;                           /* CFDRMDF12_16     */
    union __tag158 CFDRMDF13_16;                           /* CFDRMDF13_16     */
    union __tag158 CFDRMDF14_16;                           /* CFDRMDF14_16     */
    union __tag158 CFDRMDF15_16;                           /* CFDRMDF15_16     */
    unsigned char  dummy216[52];                           /* Reserved         */
    union __tag158 CFDRMID17;                              /* CFDRMID17        */
    union __tag158 CFDRMPTR17;                             /* CFDRMPTR17       */
    union __tag158 CFDRMFDSTS17;                           /* CFDRMFDSTS17     */
    union __tag158 CFDRMDF0_17;                            /* CFDRMDF0_17      */
    union __tag158 CFDRMDF1_17;                            /* CFDRMDF1_17      */
    union __tag158 CFDRMDF2_17;                            /* CFDRMDF2_17      */
    union __tag158 CFDRMDF3_17;                            /* CFDRMDF3_17      */
    union __tag158 CFDRMDF4_17;                            /* CFDRMDF4_17      */
    union __tag158 CFDRMDF5_17;                            /* CFDRMDF5_17      */
    union __tag158 CFDRMDF6_17;                            /* CFDRMDF6_17      */
    union __tag158 CFDRMDF7_17;                            /* CFDRMDF7_17      */
    union __tag158 CFDRMDF8_17;                            /* CFDRMDF8_17      */
    union __tag158 CFDRMDF9_17;                            /* CFDRMDF9_17      */
    union __tag158 CFDRMDF10_17;                           /* CFDRMDF10_17     */
    union __tag158 CFDRMDF11_17;                           /* CFDRMDF11_17     */
    union __tag158 CFDRMDF12_17;                           /* CFDRMDF12_17     */
    union __tag158 CFDRMDF13_17;                           /* CFDRMDF13_17     */
    union __tag158 CFDRMDF14_17;                           /* CFDRMDF14_17     */
    union __tag158 CFDRMDF15_17;                           /* CFDRMDF15_17     */
    unsigned char  dummy217[52];                           /* Reserved         */
    union __tag158 CFDRMID18;                              /* CFDRMID18        */
    union __tag158 CFDRMPTR18;                             /* CFDRMPTR18       */
    union __tag158 CFDRMFDSTS18;                           /* CFDRMFDSTS18     */
    union __tag158 CFDRMDF0_18;                            /* CFDRMDF0_18      */
    union __tag158 CFDRMDF1_18;                            /* CFDRMDF1_18      */
    union __tag158 CFDRMDF2_18;                            /* CFDRMDF2_18      */
    union __tag158 CFDRMDF3_18;                            /* CFDRMDF3_18      */
    union __tag158 CFDRMDF4_18;                            /* CFDRMDF4_18      */
    union __tag158 CFDRMDF5_18;                            /* CFDRMDF5_18      */
    union __tag158 CFDRMDF6_18;                            /* CFDRMDF6_18      */
    union __tag158 CFDRMDF7_18;                            /* CFDRMDF7_18      */
    union __tag158 CFDRMDF8_18;                            /* CFDRMDF8_18      */
    union __tag158 CFDRMDF9_18;                            /* CFDRMDF9_18      */
    union __tag158 CFDRMDF10_18;                           /* CFDRMDF10_18     */
    union __tag158 CFDRMDF11_18;                           /* CFDRMDF11_18     */
    union __tag158 CFDRMDF12_18;                           /* CFDRMDF12_18     */
    union __tag158 CFDRMDF13_18;                           /* CFDRMDF13_18     */
    union __tag158 CFDRMDF14_18;                           /* CFDRMDF14_18     */
    union __tag158 CFDRMDF15_18;                           /* CFDRMDF15_18     */
    unsigned char  dummy218[52];                           /* Reserved         */
    union __tag158 CFDRMID19;                              /* CFDRMID19        */
    union __tag158 CFDRMPTR19;                             /* CFDRMPTR19       */
    union __tag158 CFDRMFDSTS19;                           /* CFDRMFDSTS19     */
    union __tag158 CFDRMDF0_19;                            /* CFDRMDF0_19      */
    union __tag158 CFDRMDF1_19;                            /* CFDRMDF1_19      */
    union __tag158 CFDRMDF2_19;                            /* CFDRMDF2_19      */
    union __tag158 CFDRMDF3_19;                            /* CFDRMDF3_19      */
    union __tag158 CFDRMDF4_19;                            /* CFDRMDF4_19      */
    union __tag158 CFDRMDF5_19;                            /* CFDRMDF5_19      */
    union __tag158 CFDRMDF6_19;                            /* CFDRMDF6_19      */
    union __tag158 CFDRMDF7_19;                            /* CFDRMDF7_19      */
    union __tag158 CFDRMDF8_19;                            /* CFDRMDF8_19      */
    union __tag158 CFDRMDF9_19;                            /* CFDRMDF9_19      */
    union __tag158 CFDRMDF10_19;                           /* CFDRMDF10_19     */
    union __tag158 CFDRMDF11_19;                           /* CFDRMDF11_19     */
    union __tag158 CFDRMDF12_19;                           /* CFDRMDF12_19     */
    union __tag158 CFDRMDF13_19;                           /* CFDRMDF13_19     */
    union __tag158 CFDRMDF14_19;                           /* CFDRMDF14_19     */
    union __tag158 CFDRMDF15_19;                           /* CFDRMDF15_19     */
    unsigned char  dummy219[52];                           /* Reserved         */
    union __tag158 CFDRMID20;                              /* CFDRMID20        */
    union __tag158 CFDRMPTR20;                             /* CFDRMPTR20       */
    union __tag158 CFDRMFDSTS20;                           /* CFDRMFDSTS20     */
    union __tag158 CFDRMDF0_20;                            /* CFDRMDF0_20      */
    union __tag158 CFDRMDF1_20;                            /* CFDRMDF1_20      */
    union __tag158 CFDRMDF2_20;                            /* CFDRMDF2_20      */
    union __tag158 CFDRMDF3_20;                            /* CFDRMDF3_20      */
    union __tag158 CFDRMDF4_20;                            /* CFDRMDF4_20      */
    union __tag158 CFDRMDF5_20;                            /* CFDRMDF5_20      */
    union __tag158 CFDRMDF6_20;                            /* CFDRMDF6_20      */
    union __tag158 CFDRMDF7_20;                            /* CFDRMDF7_20      */
    union __tag158 CFDRMDF8_20;                            /* CFDRMDF8_20      */
    union __tag158 CFDRMDF9_20;                            /* CFDRMDF9_20      */
    union __tag158 CFDRMDF10_20;                           /* CFDRMDF10_20     */
    union __tag158 CFDRMDF11_20;                           /* CFDRMDF11_20     */
    union __tag158 CFDRMDF12_20;                           /* CFDRMDF12_20     */
    union __tag158 CFDRMDF13_20;                           /* CFDRMDF13_20     */
    union __tag158 CFDRMDF14_20;                           /* CFDRMDF14_20     */
    union __tag158 CFDRMDF15_20;                           /* CFDRMDF15_20     */
    unsigned char  dummy220[52];                           /* Reserved         */
    union __tag158 CFDRMID21;                              /* CFDRMID21        */
    union __tag158 CFDRMPTR21;                             /* CFDRMPTR21       */
    union __tag158 CFDRMFDSTS21;                           /* CFDRMFDSTS21     */
    union __tag158 CFDRMDF0_21;                            /* CFDRMDF0_21      */
    union __tag158 CFDRMDF1_21;                            /* CFDRMDF1_21      */
    union __tag158 CFDRMDF2_21;                            /* CFDRMDF2_21      */
    union __tag158 CFDRMDF3_21;                            /* CFDRMDF3_21      */
    union __tag158 CFDRMDF4_21;                            /* CFDRMDF4_21      */
    union __tag158 CFDRMDF5_21;                            /* CFDRMDF5_21      */
    union __tag158 CFDRMDF6_21;                            /* CFDRMDF6_21      */
    union __tag158 CFDRMDF7_21;                            /* CFDRMDF7_21      */
    union __tag158 CFDRMDF8_21;                            /* CFDRMDF8_21      */
    union __tag158 CFDRMDF9_21;                            /* CFDRMDF9_21      */
    union __tag158 CFDRMDF10_21;                           /* CFDRMDF10_21     */
    union __tag158 CFDRMDF11_21;                           /* CFDRMDF11_21     */
    union __tag158 CFDRMDF12_21;                           /* CFDRMDF12_21     */
    union __tag158 CFDRMDF13_21;                           /* CFDRMDF13_21     */
    union __tag158 CFDRMDF14_21;                           /* CFDRMDF14_21     */
    union __tag158 CFDRMDF15_21;                           /* CFDRMDF15_21     */
    unsigned char  dummy221[52];                           /* Reserved         */
    union __tag158 CFDRMID22;                              /* CFDRMID22        */
    union __tag158 CFDRMPTR22;                             /* CFDRMPTR22       */
    union __tag158 CFDRMFDSTS22;                           /* CFDRMFDSTS22     */
    union __tag158 CFDRMDF0_22;                            /* CFDRMDF0_22      */
    union __tag158 CFDRMDF1_22;                            /* CFDRMDF1_22      */
    union __tag158 CFDRMDF2_22;                            /* CFDRMDF2_22      */
    union __tag158 CFDRMDF3_22;                            /* CFDRMDF3_22      */
    union __tag158 CFDRMDF4_22;                            /* CFDRMDF4_22      */
    union __tag158 CFDRMDF5_22;                            /* CFDRMDF5_22      */
    union __tag158 CFDRMDF6_22;                            /* CFDRMDF6_22      */
    union __tag158 CFDRMDF7_22;                            /* CFDRMDF7_22      */
    union __tag158 CFDRMDF8_22;                            /* CFDRMDF8_22      */
    union __tag158 CFDRMDF9_22;                            /* CFDRMDF9_22      */
    union __tag158 CFDRMDF10_22;                           /* CFDRMDF10_22     */
    union __tag158 CFDRMDF11_22;                           /* CFDRMDF11_22     */
    union __tag158 CFDRMDF12_22;                           /* CFDRMDF12_22     */
    union __tag158 CFDRMDF13_22;                           /* CFDRMDF13_22     */
    union __tag158 CFDRMDF14_22;                           /* CFDRMDF14_22     */
    union __tag158 CFDRMDF15_22;                           /* CFDRMDF15_22     */
    unsigned char  dummy222[52];                           /* Reserved         */
    union __tag158 CFDRMID23;                              /* CFDRMID23        */
    union __tag158 CFDRMPTR23;                             /* CFDRMPTR23       */
    union __tag158 CFDRMFDSTS23;                           /* CFDRMFDSTS23     */
    union __tag158 CFDRMDF0_23;                            /* CFDRMDF0_23      */
    union __tag158 CFDRMDF1_23;                            /* CFDRMDF1_23      */
    union __tag158 CFDRMDF2_23;                            /* CFDRMDF2_23      */
    union __tag158 CFDRMDF3_23;                            /* CFDRMDF3_23      */
    union __tag158 CFDRMDF4_23;                            /* CFDRMDF4_23      */
    union __tag158 CFDRMDF5_23;                            /* CFDRMDF5_23      */
    union __tag158 CFDRMDF6_23;                            /* CFDRMDF6_23      */
    union __tag158 CFDRMDF7_23;                            /* CFDRMDF7_23      */
    union __tag158 CFDRMDF8_23;                            /* CFDRMDF8_23      */
    union __tag158 CFDRMDF9_23;                            /* CFDRMDF9_23      */
    union __tag158 CFDRMDF10_23;                           /* CFDRMDF10_23     */
    union __tag158 CFDRMDF11_23;                           /* CFDRMDF11_23     */
    union __tag158 CFDRMDF12_23;                           /* CFDRMDF12_23     */
    union __tag158 CFDRMDF13_23;                           /* CFDRMDF13_23     */
    union __tag158 CFDRMDF14_23;                           /* CFDRMDF14_23     */
    union __tag158 CFDRMDF15_23;                           /* CFDRMDF15_23     */
    unsigned char  dummy223[52];                           /* Reserved         */
    union __tag158 CFDRMID24;                              /* CFDRMID24        */
    union __tag158 CFDRMPTR24;                             /* CFDRMPTR24       */
    union __tag158 CFDRMFDSTS24;                           /* CFDRMFDSTS24     */
    union __tag158 CFDRMDF0_24;                            /* CFDRMDF0_24      */
    union __tag158 CFDRMDF1_24;                            /* CFDRMDF1_24      */
    union __tag158 CFDRMDF2_24;                            /* CFDRMDF2_24      */
    union __tag158 CFDRMDF3_24;                            /* CFDRMDF3_24      */
    union __tag158 CFDRMDF4_24;                            /* CFDRMDF4_24      */
    union __tag158 CFDRMDF5_24;                            /* CFDRMDF5_24      */
    union __tag158 CFDRMDF6_24;                            /* CFDRMDF6_24      */
    union __tag158 CFDRMDF7_24;                            /* CFDRMDF7_24      */
    union __tag158 CFDRMDF8_24;                            /* CFDRMDF8_24      */
    union __tag158 CFDRMDF9_24;                            /* CFDRMDF9_24      */
    union __tag158 CFDRMDF10_24;                           /* CFDRMDF10_24     */
    union __tag158 CFDRMDF11_24;                           /* CFDRMDF11_24     */
    union __tag158 CFDRMDF12_24;                           /* CFDRMDF12_24     */
    union __tag158 CFDRMDF13_24;                           /* CFDRMDF13_24     */
    union __tag158 CFDRMDF14_24;                           /* CFDRMDF14_24     */
    union __tag158 CFDRMDF15_24;                           /* CFDRMDF15_24     */
    unsigned char  dummy224[52];                           /* Reserved         */
    union __tag158 CFDRMID25;                              /* CFDRMID25        */
    union __tag158 CFDRMPTR25;                             /* CFDRMPTR25       */
    union __tag158 CFDRMFDSTS25;                           /* CFDRMFDSTS25     */
    union __tag158 CFDRMDF0_25;                            /* CFDRMDF0_25      */
    union __tag158 CFDRMDF1_25;                            /* CFDRMDF1_25      */
    union __tag158 CFDRMDF2_25;                            /* CFDRMDF2_25      */
    union __tag158 CFDRMDF3_25;                            /* CFDRMDF3_25      */
    union __tag158 CFDRMDF4_25;                            /* CFDRMDF4_25      */
    union __tag158 CFDRMDF5_25;                            /* CFDRMDF5_25      */
    union __tag158 CFDRMDF6_25;                            /* CFDRMDF6_25      */
    union __tag158 CFDRMDF7_25;                            /* CFDRMDF7_25      */
    union __tag158 CFDRMDF8_25;                            /* CFDRMDF8_25      */
    union __tag158 CFDRMDF9_25;                            /* CFDRMDF9_25      */
    union __tag158 CFDRMDF10_25;                           /* CFDRMDF10_25     */
    union __tag158 CFDRMDF11_25;                           /* CFDRMDF11_25     */
    union __tag158 CFDRMDF12_25;                           /* CFDRMDF12_25     */
    union __tag158 CFDRMDF13_25;                           /* CFDRMDF13_25     */
    union __tag158 CFDRMDF14_25;                           /* CFDRMDF14_25     */
    union __tag158 CFDRMDF15_25;                           /* CFDRMDF15_25     */
    unsigned char  dummy225[52];                           /* Reserved         */
    union __tag158 CFDRMID26;                              /* CFDRMID26        */
    union __tag158 CFDRMPTR26;                             /* CFDRMPTR26       */
    union __tag158 CFDRMFDSTS26;                           /* CFDRMFDSTS26     */
    union __tag158 CFDRMDF0_26;                            /* CFDRMDF0_26      */
    union __tag158 CFDRMDF1_26;                            /* CFDRMDF1_26      */
    union __tag158 CFDRMDF2_26;                            /* CFDRMDF2_26      */
    union __tag158 CFDRMDF3_26;                            /* CFDRMDF3_26      */
    union __tag158 CFDRMDF4_26;                            /* CFDRMDF4_26      */
    union __tag158 CFDRMDF5_26;                            /* CFDRMDF5_26      */
    union __tag158 CFDRMDF6_26;                            /* CFDRMDF6_26      */
    union __tag158 CFDRMDF7_26;                            /* CFDRMDF7_26      */
    union __tag158 CFDRMDF8_26;                            /* CFDRMDF8_26      */
    union __tag158 CFDRMDF9_26;                            /* CFDRMDF9_26      */
    union __tag158 CFDRMDF10_26;                           /* CFDRMDF10_26     */
    union __tag158 CFDRMDF11_26;                           /* CFDRMDF11_26     */
    union __tag158 CFDRMDF12_26;                           /* CFDRMDF12_26     */
    union __tag158 CFDRMDF13_26;                           /* CFDRMDF13_26     */
    union __tag158 CFDRMDF14_26;                           /* CFDRMDF14_26     */
    union __tag158 CFDRMDF15_26;                           /* CFDRMDF15_26     */
    unsigned char  dummy226[52];                           /* Reserved         */
    union __tag158 CFDRMID27;                              /* CFDRMID27        */
    union __tag158 CFDRMPTR27;                             /* CFDRMPTR27       */
    union __tag158 CFDRMFDSTS27;                           /* CFDRMFDSTS27     */
    union __tag158 CFDRMDF0_27;                            /* CFDRMDF0_27      */
    union __tag158 CFDRMDF1_27;                            /* CFDRMDF1_27      */
    union __tag158 CFDRMDF2_27;                            /* CFDRMDF2_27      */
    union __tag158 CFDRMDF3_27;                            /* CFDRMDF3_27      */
    union __tag158 CFDRMDF4_27;                            /* CFDRMDF4_27      */
    union __tag158 CFDRMDF5_27;                            /* CFDRMDF5_27      */
    union __tag158 CFDRMDF6_27;                            /* CFDRMDF6_27      */
    union __tag158 CFDRMDF7_27;                            /* CFDRMDF7_27      */
    union __tag158 CFDRMDF8_27;                            /* CFDRMDF8_27      */
    union __tag158 CFDRMDF9_27;                            /* CFDRMDF9_27      */
    union __tag158 CFDRMDF10_27;                           /* CFDRMDF10_27     */
    union __tag158 CFDRMDF11_27;                           /* CFDRMDF11_27     */
    union __tag158 CFDRMDF12_27;                           /* CFDRMDF12_27     */
    union __tag158 CFDRMDF13_27;                           /* CFDRMDF13_27     */
    union __tag158 CFDRMDF14_27;                           /* CFDRMDF14_27     */
    union __tag158 CFDRMDF15_27;                           /* CFDRMDF15_27     */
    unsigned char  dummy227[52];                           /* Reserved         */
    union __tag158 CFDRMID28;                              /* CFDRMID28        */
    union __tag158 CFDRMPTR28;                             /* CFDRMPTR28       */
    union __tag158 CFDRMFDSTS28;                           /* CFDRMFDSTS28     */
    union __tag158 CFDRMDF0_28;                            /* CFDRMDF0_28      */
    union __tag158 CFDRMDF1_28;                            /* CFDRMDF1_28      */
    union __tag158 CFDRMDF2_28;                            /* CFDRMDF2_28      */
    union __tag158 CFDRMDF3_28;                            /* CFDRMDF3_28      */
    union __tag158 CFDRMDF4_28;                            /* CFDRMDF4_28      */
    union __tag158 CFDRMDF5_28;                            /* CFDRMDF5_28      */
    union __tag158 CFDRMDF6_28;                            /* CFDRMDF6_28      */
    union __tag158 CFDRMDF7_28;                            /* CFDRMDF7_28      */
    union __tag158 CFDRMDF8_28;                            /* CFDRMDF8_28      */
    union __tag158 CFDRMDF9_28;                            /* CFDRMDF9_28      */
    union __tag158 CFDRMDF10_28;                           /* CFDRMDF10_28     */
    union __tag158 CFDRMDF11_28;                           /* CFDRMDF11_28     */
    union __tag158 CFDRMDF12_28;                           /* CFDRMDF12_28     */
    union __tag158 CFDRMDF13_28;                           /* CFDRMDF13_28     */
    union __tag158 CFDRMDF14_28;                           /* CFDRMDF14_28     */
    union __tag158 CFDRMDF15_28;                           /* CFDRMDF15_28     */
    unsigned char  dummy228[52];                           /* Reserved         */
    union __tag158 CFDRMID29;                              /* CFDRMID29        */
    union __tag158 CFDRMPTR29;                             /* CFDRMPTR29       */
    union __tag158 CFDRMFDSTS29;                           /* CFDRMFDSTS29     */
    union __tag158 CFDRMDF0_29;                            /* CFDRMDF0_29      */
    union __tag158 CFDRMDF1_29;                            /* CFDRMDF1_29      */
    union __tag158 CFDRMDF2_29;                            /* CFDRMDF2_29      */
    union __tag158 CFDRMDF3_29;                            /* CFDRMDF3_29      */
    union __tag158 CFDRMDF4_29;                            /* CFDRMDF4_29      */
    union __tag158 CFDRMDF5_29;                            /* CFDRMDF5_29      */
    union __tag158 CFDRMDF6_29;                            /* CFDRMDF6_29      */
    union __tag158 CFDRMDF7_29;                            /* CFDRMDF7_29      */
    union __tag158 CFDRMDF8_29;                            /* CFDRMDF8_29      */
    union __tag158 CFDRMDF9_29;                            /* CFDRMDF9_29      */
    union __tag158 CFDRMDF10_29;                           /* CFDRMDF10_29     */
    union __tag158 CFDRMDF11_29;                           /* CFDRMDF11_29     */
    union __tag158 CFDRMDF12_29;                           /* CFDRMDF12_29     */
    union __tag158 CFDRMDF13_29;                           /* CFDRMDF13_29     */
    union __tag158 CFDRMDF14_29;                           /* CFDRMDF14_29     */
    union __tag158 CFDRMDF15_29;                           /* CFDRMDF15_29     */
    unsigned char  dummy229[52];                           /* Reserved         */
    union __tag158 CFDRMID30;                              /* CFDRMID30        */
    union __tag158 CFDRMPTR30;                             /* CFDRMPTR30       */
    union __tag158 CFDRMFDSTS30;                           /* CFDRMFDSTS30     */
    union __tag158 CFDRMDF0_30;                            /* CFDRMDF0_30      */
    union __tag158 CFDRMDF1_30;                            /* CFDRMDF1_30      */
    union __tag158 CFDRMDF2_30;                            /* CFDRMDF2_30      */
    union __tag158 CFDRMDF3_30;                            /* CFDRMDF3_30      */
    union __tag158 CFDRMDF4_30;                            /* CFDRMDF4_30      */
    union __tag158 CFDRMDF5_30;                            /* CFDRMDF5_30      */
    union __tag158 CFDRMDF6_30;                            /* CFDRMDF6_30      */
    union __tag158 CFDRMDF7_30;                            /* CFDRMDF7_30      */
    union __tag158 CFDRMDF8_30;                            /* CFDRMDF8_30      */
    union __tag158 CFDRMDF9_30;                            /* CFDRMDF9_30      */
    union __tag158 CFDRMDF10_30;                           /* CFDRMDF10_30     */
    union __tag158 CFDRMDF11_30;                           /* CFDRMDF11_30     */
    union __tag158 CFDRMDF12_30;                           /* CFDRMDF12_30     */
    union __tag158 CFDRMDF13_30;                           /* CFDRMDF13_30     */
    union __tag158 CFDRMDF14_30;                           /* CFDRMDF14_30     */
    union __tag158 CFDRMDF15_30;                           /* CFDRMDF15_30     */
    unsigned char  dummy230[52];                           /* Reserved         */
    union __tag158 CFDRMID31;                              /* CFDRMID31        */
    union __tag158 CFDRMPTR31;                             /* CFDRMPTR31       */
    union __tag158 CFDRMFDSTS31;                           /* CFDRMFDSTS31     */
    union __tag158 CFDRMDF0_31;                            /* CFDRMDF0_31      */
    union __tag158 CFDRMDF1_31;                            /* CFDRMDF1_31      */
    union __tag158 CFDRMDF2_31;                            /* CFDRMDF2_31      */
    union __tag158 CFDRMDF3_31;                            /* CFDRMDF3_31      */
    union __tag158 CFDRMDF4_31;                            /* CFDRMDF4_31      */
    union __tag158 CFDRMDF5_31;                            /* CFDRMDF5_31      */
    union __tag158 CFDRMDF6_31;                            /* CFDRMDF6_31      */
    union __tag158 CFDRMDF7_31;                            /* CFDRMDF7_31      */
    union __tag158 CFDRMDF8_31;                            /* CFDRMDF8_31      */
    union __tag158 CFDRMDF9_31;                            /* CFDRMDF9_31      */
    union __tag158 CFDRMDF10_31;                           /* CFDRMDF10_31     */
    union __tag158 CFDRMDF11_31;                           /* CFDRMDF11_31     */
    union __tag158 CFDRMDF12_31;                           /* CFDRMDF12_31     */
    union __tag158 CFDRMDF13_31;                           /* CFDRMDF13_31     */
    union __tag158 CFDRMDF14_31;                           /* CFDRMDF14_31     */
    union __tag158 CFDRMDF15_31;                           /* CFDRMDF15_31     */
    unsigned char  dummy231[52];                           /* Reserved         */
    union __tag158 CFDRMID32;                              /* CFDRMID32        */
    union __tag158 CFDRMPTR32;                             /* CFDRMPTR32       */
    union __tag158 CFDRMFDSTS32;                           /* CFDRMFDSTS32     */
    union __tag158 CFDRMDF0_32;                            /* CFDRMDF0_32      */
    union __tag158 CFDRMDF1_32;                            /* CFDRMDF1_32      */
    union __tag158 CFDRMDF2_32;                            /* CFDRMDF2_32      */
    union __tag158 CFDRMDF3_32;                            /* CFDRMDF3_32      */
    union __tag158 CFDRMDF4_32;                            /* CFDRMDF4_32      */
    union __tag158 CFDRMDF5_32;                            /* CFDRMDF5_32      */
    union __tag158 CFDRMDF6_32;                            /* CFDRMDF6_32      */
    union __tag158 CFDRMDF7_32;                            /* CFDRMDF7_32      */
    union __tag158 CFDRMDF8_32;                            /* CFDRMDF8_32      */
    union __tag158 CFDRMDF9_32;                            /* CFDRMDF9_32      */
    union __tag158 CFDRMDF10_32;                           /* CFDRMDF10_32     */
    union __tag158 CFDRMDF11_32;                           /* CFDRMDF11_32     */
    union __tag158 CFDRMDF12_32;                           /* CFDRMDF12_32     */
    union __tag158 CFDRMDF13_32;                           /* CFDRMDF13_32     */
    union __tag158 CFDRMDF14_32;                           /* CFDRMDF14_32     */
    union __tag158 CFDRMDF15_32;                           /* CFDRMDF15_32     */
    unsigned char  dummy232[52];                           /* Reserved         */
    union __tag158 CFDRMID33;                              /* CFDRMID33        */
    union __tag158 CFDRMPTR33;                             /* CFDRMPTR33       */
    union __tag158 CFDRMFDSTS33;                           /* CFDRMFDSTS33     */
    union __tag158 CFDRMDF0_33;                            /* CFDRMDF0_33      */
    union __tag158 CFDRMDF1_33;                            /* CFDRMDF1_33      */
    union __tag158 CFDRMDF2_33;                            /* CFDRMDF2_33      */
    union __tag158 CFDRMDF3_33;                            /* CFDRMDF3_33      */
    union __tag158 CFDRMDF4_33;                            /* CFDRMDF4_33      */
    union __tag158 CFDRMDF5_33;                            /* CFDRMDF5_33      */
    union __tag158 CFDRMDF6_33;                            /* CFDRMDF6_33      */
    union __tag158 CFDRMDF7_33;                            /* CFDRMDF7_33      */
    union __tag158 CFDRMDF8_33;                            /* CFDRMDF8_33      */
    union __tag158 CFDRMDF9_33;                            /* CFDRMDF9_33      */
    union __tag158 CFDRMDF10_33;                           /* CFDRMDF10_33     */
    union __tag158 CFDRMDF11_33;                           /* CFDRMDF11_33     */
    union __tag158 CFDRMDF12_33;                           /* CFDRMDF12_33     */
    union __tag158 CFDRMDF13_33;                           /* CFDRMDF13_33     */
    union __tag158 CFDRMDF14_33;                           /* CFDRMDF14_33     */
    union __tag158 CFDRMDF15_33;                           /* CFDRMDF15_33     */
    unsigned char  dummy233[52];                           /* Reserved         */
    union __tag158 CFDRMID34;                              /* CFDRMID34        */
    union __tag158 CFDRMPTR34;                             /* CFDRMPTR34       */
    union __tag158 CFDRMFDSTS34;                           /* CFDRMFDSTS34     */
    union __tag158 CFDRMDF0_34;                            /* CFDRMDF0_34      */
    union __tag158 CFDRMDF1_34;                            /* CFDRMDF1_34      */
    union __tag158 CFDRMDF2_34;                            /* CFDRMDF2_34      */
    union __tag158 CFDRMDF3_34;                            /* CFDRMDF3_34      */
    union __tag158 CFDRMDF4_34;                            /* CFDRMDF4_34      */
    union __tag158 CFDRMDF5_34;                            /* CFDRMDF5_34      */
    union __tag158 CFDRMDF6_34;                            /* CFDRMDF6_34      */
    union __tag158 CFDRMDF7_34;                            /* CFDRMDF7_34      */
    union __tag158 CFDRMDF8_34;                            /* CFDRMDF8_34      */
    union __tag158 CFDRMDF9_34;                            /* CFDRMDF9_34      */
    union __tag158 CFDRMDF10_34;                           /* CFDRMDF10_34     */
    union __tag158 CFDRMDF11_34;                           /* CFDRMDF11_34     */
    union __tag158 CFDRMDF12_34;                           /* CFDRMDF12_34     */
    union __tag158 CFDRMDF13_34;                           /* CFDRMDF13_34     */
    union __tag158 CFDRMDF14_34;                           /* CFDRMDF14_34     */
    union __tag158 CFDRMDF15_34;                           /* CFDRMDF15_34     */
    unsigned char  dummy234[52];                           /* Reserved         */
    union __tag158 CFDRMID35;                              /* CFDRMID35        */
    union __tag158 CFDRMPTR35;                             /* CFDRMPTR35       */
    union __tag158 CFDRMFDSTS35;                           /* CFDRMFDSTS35     */
    union __tag158 CFDRMDF0_35;                            /* CFDRMDF0_35      */
    union __tag158 CFDRMDF1_35;                            /* CFDRMDF1_35      */
    union __tag158 CFDRMDF2_35;                            /* CFDRMDF2_35      */
    union __tag158 CFDRMDF3_35;                            /* CFDRMDF3_35      */
    union __tag158 CFDRMDF4_35;                            /* CFDRMDF4_35      */
    union __tag158 CFDRMDF5_35;                            /* CFDRMDF5_35      */
    union __tag158 CFDRMDF6_35;                            /* CFDRMDF6_35      */
    union __tag158 CFDRMDF7_35;                            /* CFDRMDF7_35      */
    union __tag158 CFDRMDF8_35;                            /* CFDRMDF8_35      */
    union __tag158 CFDRMDF9_35;                            /* CFDRMDF9_35      */
    union __tag158 CFDRMDF10_35;                           /* CFDRMDF10_35     */
    union __tag158 CFDRMDF11_35;                           /* CFDRMDF11_35     */
    union __tag158 CFDRMDF12_35;                           /* CFDRMDF12_35     */
    union __tag158 CFDRMDF13_35;                           /* CFDRMDF13_35     */
    union __tag158 CFDRMDF14_35;                           /* CFDRMDF14_35     */
    union __tag158 CFDRMDF15_35;                           /* CFDRMDF15_35     */
    unsigned char  dummy235[52];                           /* Reserved         */
    union __tag158 CFDRMID36;                              /* CFDRMID36        */
    union __tag158 CFDRMPTR36;                             /* CFDRMPTR36       */
    union __tag158 CFDRMFDSTS36;                           /* CFDRMFDSTS36     */
    union __tag158 CFDRMDF0_36;                            /* CFDRMDF0_36      */
    union __tag158 CFDRMDF1_36;                            /* CFDRMDF1_36      */
    union __tag158 CFDRMDF2_36;                            /* CFDRMDF2_36      */
    union __tag158 CFDRMDF3_36;                            /* CFDRMDF3_36      */
    union __tag158 CFDRMDF4_36;                            /* CFDRMDF4_36      */
    union __tag158 CFDRMDF5_36;                            /* CFDRMDF5_36      */
    union __tag158 CFDRMDF6_36;                            /* CFDRMDF6_36      */
    union __tag158 CFDRMDF7_36;                            /* CFDRMDF7_36      */
    union __tag158 CFDRMDF8_36;                            /* CFDRMDF8_36      */
    union __tag158 CFDRMDF9_36;                            /* CFDRMDF9_36      */
    union __tag158 CFDRMDF10_36;                           /* CFDRMDF10_36     */
    union __tag158 CFDRMDF11_36;                           /* CFDRMDF11_36     */
    union __tag158 CFDRMDF12_36;                           /* CFDRMDF12_36     */
    union __tag158 CFDRMDF13_36;                           /* CFDRMDF13_36     */
    union __tag158 CFDRMDF14_36;                           /* CFDRMDF14_36     */
    union __tag158 CFDRMDF15_36;                           /* CFDRMDF15_36     */
    unsigned char  dummy236[52];                           /* Reserved         */
    union __tag158 CFDRMID37;                              /* CFDRMID37        */
    union __tag158 CFDRMPTR37;                             /* CFDRMPTR37       */
    union __tag158 CFDRMFDSTS37;                           /* CFDRMFDSTS37     */
    union __tag158 CFDRMDF0_37;                            /* CFDRMDF0_37      */
    union __tag158 CFDRMDF1_37;                            /* CFDRMDF1_37      */
    union __tag158 CFDRMDF2_37;                            /* CFDRMDF2_37      */
    union __tag158 CFDRMDF3_37;                            /* CFDRMDF3_37      */
    union __tag158 CFDRMDF4_37;                            /* CFDRMDF4_37      */
    union __tag158 CFDRMDF5_37;                            /* CFDRMDF5_37      */
    union __tag158 CFDRMDF6_37;                            /* CFDRMDF6_37      */
    union __tag158 CFDRMDF7_37;                            /* CFDRMDF7_37      */
    union __tag158 CFDRMDF8_37;                            /* CFDRMDF8_37      */
    union __tag158 CFDRMDF9_37;                            /* CFDRMDF9_37      */
    union __tag158 CFDRMDF10_37;                           /* CFDRMDF10_37     */
    union __tag158 CFDRMDF11_37;                           /* CFDRMDF11_37     */
    union __tag158 CFDRMDF12_37;                           /* CFDRMDF12_37     */
    union __tag158 CFDRMDF13_37;                           /* CFDRMDF13_37     */
    union __tag158 CFDRMDF14_37;                           /* CFDRMDF14_37     */
    union __tag158 CFDRMDF15_37;                           /* CFDRMDF15_37     */
    unsigned char  dummy237[52];                           /* Reserved         */
    union __tag158 CFDRMID38;                              /* CFDRMID38        */
    union __tag158 CFDRMPTR38;                             /* CFDRMPTR38       */
    union __tag158 CFDRMFDSTS38;                           /* CFDRMFDSTS38     */
    union __tag158 CFDRMDF0_38;                            /* CFDRMDF0_38      */
    union __tag158 CFDRMDF1_38;                            /* CFDRMDF1_38      */
    union __tag158 CFDRMDF2_38;                            /* CFDRMDF2_38      */
    union __tag158 CFDRMDF3_38;                            /* CFDRMDF3_38      */
    union __tag158 CFDRMDF4_38;                            /* CFDRMDF4_38      */
    union __tag158 CFDRMDF5_38;                            /* CFDRMDF5_38      */
    union __tag158 CFDRMDF6_38;                            /* CFDRMDF6_38      */
    union __tag158 CFDRMDF7_38;                            /* CFDRMDF7_38      */
    union __tag158 CFDRMDF8_38;                            /* CFDRMDF8_38      */
    union __tag158 CFDRMDF9_38;                            /* CFDRMDF9_38      */
    union __tag158 CFDRMDF10_38;                           /* CFDRMDF10_38     */
    union __tag158 CFDRMDF11_38;                           /* CFDRMDF11_38     */
    union __tag158 CFDRMDF12_38;                           /* CFDRMDF12_38     */
    union __tag158 CFDRMDF13_38;                           /* CFDRMDF13_38     */
    union __tag158 CFDRMDF14_38;                           /* CFDRMDF14_38     */
    union __tag158 CFDRMDF15_38;                           /* CFDRMDF15_38     */
    unsigned char  dummy238[52];                           /* Reserved         */
    union __tag158 CFDRMID39;                              /* CFDRMID39        */
    union __tag158 CFDRMPTR39;                             /* CFDRMPTR39       */
    union __tag158 CFDRMFDSTS39;                           /* CFDRMFDSTS39     */
    union __tag158 CFDRMDF0_39;                            /* CFDRMDF0_39      */
    union __tag158 CFDRMDF1_39;                            /* CFDRMDF1_39      */
    union __tag158 CFDRMDF2_39;                            /* CFDRMDF2_39      */
    union __tag158 CFDRMDF3_39;                            /* CFDRMDF3_39      */
    union __tag158 CFDRMDF4_39;                            /* CFDRMDF4_39      */
    union __tag158 CFDRMDF5_39;                            /* CFDRMDF5_39      */
    union __tag158 CFDRMDF6_39;                            /* CFDRMDF6_39      */
    union __tag158 CFDRMDF7_39;                            /* CFDRMDF7_39      */
    union __tag158 CFDRMDF8_39;                            /* CFDRMDF8_39      */
    union __tag158 CFDRMDF9_39;                            /* CFDRMDF9_39      */
    union __tag158 CFDRMDF10_39;                           /* CFDRMDF10_39     */
    union __tag158 CFDRMDF11_39;                           /* CFDRMDF11_39     */
    union __tag158 CFDRMDF12_39;                           /* CFDRMDF12_39     */
    union __tag158 CFDRMDF13_39;                           /* CFDRMDF13_39     */
    union __tag158 CFDRMDF14_39;                           /* CFDRMDF14_39     */
    union __tag158 CFDRMDF15_39;                           /* CFDRMDF15_39     */
    unsigned char  dummy239[52];                           /* Reserved         */
    union __tag158 CFDRMID40;                              /* CFDRMID40        */
    union __tag158 CFDRMPTR40;                             /* CFDRMPTR40       */
    union __tag158 CFDRMFDSTS40;                           /* CFDRMFDSTS40     */
    union __tag158 CFDRMDF0_40;                            /* CFDRMDF0_40      */
    union __tag158 CFDRMDF1_40;                            /* CFDRMDF1_40      */
    union __tag158 CFDRMDF2_40;                            /* CFDRMDF2_40      */
    union __tag158 CFDRMDF3_40;                            /* CFDRMDF3_40      */
    union __tag158 CFDRMDF4_40;                            /* CFDRMDF4_40      */
    union __tag158 CFDRMDF5_40;                            /* CFDRMDF5_40      */
    union __tag158 CFDRMDF6_40;                            /* CFDRMDF6_40      */
    union __tag158 CFDRMDF7_40;                            /* CFDRMDF7_40      */
    union __tag158 CFDRMDF8_40;                            /* CFDRMDF8_40      */
    union __tag158 CFDRMDF9_40;                            /* CFDRMDF9_40      */
    union __tag158 CFDRMDF10_40;                           /* CFDRMDF10_40     */
    union __tag158 CFDRMDF11_40;                           /* CFDRMDF11_40     */
    union __tag158 CFDRMDF12_40;                           /* CFDRMDF12_40     */
    union __tag158 CFDRMDF13_40;                           /* CFDRMDF13_40     */
    union __tag158 CFDRMDF14_40;                           /* CFDRMDF14_40     */
    union __tag158 CFDRMDF15_40;                           /* CFDRMDF15_40     */
    unsigned char  dummy240[52];                           /* Reserved         */
    union __tag158 CFDRMID41;                              /* CFDRMID41        */
    union __tag158 CFDRMPTR41;                             /* CFDRMPTR41       */
    union __tag158 CFDRMFDSTS41;                           /* CFDRMFDSTS41     */
    union __tag158 CFDRMDF0_41;                            /* CFDRMDF0_41      */
    union __tag158 CFDRMDF1_41;                            /* CFDRMDF1_41      */
    union __tag158 CFDRMDF2_41;                            /* CFDRMDF2_41      */
    union __tag158 CFDRMDF3_41;                            /* CFDRMDF3_41      */
    union __tag158 CFDRMDF4_41;                            /* CFDRMDF4_41      */
    union __tag158 CFDRMDF5_41;                            /* CFDRMDF5_41      */
    union __tag158 CFDRMDF6_41;                            /* CFDRMDF6_41      */
    union __tag158 CFDRMDF7_41;                            /* CFDRMDF7_41      */
    union __tag158 CFDRMDF8_41;                            /* CFDRMDF8_41      */
    union __tag158 CFDRMDF9_41;                            /* CFDRMDF9_41      */
    union __tag158 CFDRMDF10_41;                           /* CFDRMDF10_41     */
    union __tag158 CFDRMDF11_41;                           /* CFDRMDF11_41     */
    union __tag158 CFDRMDF12_41;                           /* CFDRMDF12_41     */
    union __tag158 CFDRMDF13_41;                           /* CFDRMDF13_41     */
    union __tag158 CFDRMDF14_41;                           /* CFDRMDF14_41     */
    union __tag158 CFDRMDF15_41;                           /* CFDRMDF15_41     */
    unsigned char  dummy241[52];                           /* Reserved         */
    union __tag158 CFDRMID42;                              /* CFDRMID42        */
    union __tag158 CFDRMPTR42;                             /* CFDRMPTR42       */
    union __tag158 CFDRMFDSTS42;                           /* CFDRMFDSTS42     */
    union __tag158 CFDRMDF0_42;                            /* CFDRMDF0_42      */
    union __tag158 CFDRMDF1_42;                            /* CFDRMDF1_42      */
    union __tag158 CFDRMDF2_42;                            /* CFDRMDF2_42      */
    union __tag158 CFDRMDF3_42;                            /* CFDRMDF3_42      */
    union __tag158 CFDRMDF4_42;                            /* CFDRMDF4_42      */
    union __tag158 CFDRMDF5_42;                            /* CFDRMDF5_42      */
    union __tag158 CFDRMDF6_42;                            /* CFDRMDF6_42      */
    union __tag158 CFDRMDF7_42;                            /* CFDRMDF7_42      */
    union __tag158 CFDRMDF8_42;                            /* CFDRMDF8_42      */
    union __tag158 CFDRMDF9_42;                            /* CFDRMDF9_42      */
    union __tag158 CFDRMDF10_42;                           /* CFDRMDF10_42     */
    union __tag158 CFDRMDF11_42;                           /* CFDRMDF11_42     */
    union __tag158 CFDRMDF12_42;                           /* CFDRMDF12_42     */
    union __tag158 CFDRMDF13_42;                           /* CFDRMDF13_42     */
    union __tag158 CFDRMDF14_42;                           /* CFDRMDF14_42     */
    union __tag158 CFDRMDF15_42;                           /* CFDRMDF15_42     */
    unsigned char  dummy242[52];                           /* Reserved         */
    union __tag158 CFDRMID43;                              /* CFDRMID43        */
    union __tag158 CFDRMPTR43;                             /* CFDRMPTR43       */
    union __tag158 CFDRMFDSTS43;                           /* CFDRMFDSTS43     */
    union __tag158 CFDRMDF0_43;                            /* CFDRMDF0_43      */
    union __tag158 CFDRMDF1_43;                            /* CFDRMDF1_43      */
    union __tag158 CFDRMDF2_43;                            /* CFDRMDF2_43      */
    union __tag158 CFDRMDF3_43;                            /* CFDRMDF3_43      */
    union __tag158 CFDRMDF4_43;                            /* CFDRMDF4_43      */
    union __tag158 CFDRMDF5_43;                            /* CFDRMDF5_43      */
    union __tag158 CFDRMDF6_43;                            /* CFDRMDF6_43      */
    union __tag158 CFDRMDF7_43;                            /* CFDRMDF7_43      */
    union __tag158 CFDRMDF8_43;                            /* CFDRMDF8_43      */
    union __tag158 CFDRMDF9_43;                            /* CFDRMDF9_43      */
    union __tag158 CFDRMDF10_43;                           /* CFDRMDF10_43     */
    union __tag158 CFDRMDF11_43;                           /* CFDRMDF11_43     */
    union __tag158 CFDRMDF12_43;                           /* CFDRMDF12_43     */
    union __tag158 CFDRMDF13_43;                           /* CFDRMDF13_43     */
    union __tag158 CFDRMDF14_43;                           /* CFDRMDF14_43     */
    union __tag158 CFDRMDF15_43;                           /* CFDRMDF15_43     */
    unsigned char  dummy243[52];                           /* Reserved         */
    union __tag158 CFDRMID44;                              /* CFDRMID44        */
    union __tag158 CFDRMPTR44;                             /* CFDRMPTR44       */
    union __tag158 CFDRMFDSTS44;                           /* CFDRMFDSTS44     */
    union __tag158 CFDRMDF0_44;                            /* CFDRMDF0_44      */
    union __tag158 CFDRMDF1_44;                            /* CFDRMDF1_44      */
    union __tag158 CFDRMDF2_44;                            /* CFDRMDF2_44      */
    union __tag158 CFDRMDF3_44;                            /* CFDRMDF3_44      */
    union __tag158 CFDRMDF4_44;                            /* CFDRMDF4_44      */
    union __tag158 CFDRMDF5_44;                            /* CFDRMDF5_44      */
    union __tag158 CFDRMDF6_44;                            /* CFDRMDF6_44      */
    union __tag158 CFDRMDF7_44;                            /* CFDRMDF7_44      */
    union __tag158 CFDRMDF8_44;                            /* CFDRMDF8_44      */
    union __tag158 CFDRMDF9_44;                            /* CFDRMDF9_44      */
    union __tag158 CFDRMDF10_44;                           /* CFDRMDF10_44     */
    union __tag158 CFDRMDF11_44;                           /* CFDRMDF11_44     */
    union __tag158 CFDRMDF12_44;                           /* CFDRMDF12_44     */
    union __tag158 CFDRMDF13_44;                           /* CFDRMDF13_44     */
    union __tag158 CFDRMDF14_44;                           /* CFDRMDF14_44     */
    union __tag158 CFDRMDF15_44;                           /* CFDRMDF15_44     */
    unsigned char  dummy244[52];                           /* Reserved         */
    union __tag158 CFDRMID45;                              /* CFDRMID45        */
    union __tag158 CFDRMPTR45;                             /* CFDRMPTR45       */
    union __tag158 CFDRMFDSTS45;                           /* CFDRMFDSTS45     */
    union __tag158 CFDRMDF0_45;                            /* CFDRMDF0_45      */
    union __tag158 CFDRMDF1_45;                            /* CFDRMDF1_45      */
    union __tag158 CFDRMDF2_45;                            /* CFDRMDF2_45      */
    union __tag158 CFDRMDF3_45;                            /* CFDRMDF3_45      */
    union __tag158 CFDRMDF4_45;                            /* CFDRMDF4_45      */
    union __tag158 CFDRMDF5_45;                            /* CFDRMDF5_45      */
    union __tag158 CFDRMDF6_45;                            /* CFDRMDF6_45      */
    union __tag158 CFDRMDF7_45;                            /* CFDRMDF7_45      */
    union __tag158 CFDRMDF8_45;                            /* CFDRMDF8_45      */
    union __tag158 CFDRMDF9_45;                            /* CFDRMDF9_45      */
    union __tag158 CFDRMDF10_45;                           /* CFDRMDF10_45     */
    union __tag158 CFDRMDF11_45;                           /* CFDRMDF11_45     */
    union __tag158 CFDRMDF12_45;                           /* CFDRMDF12_45     */
    union __tag158 CFDRMDF13_45;                           /* CFDRMDF13_45     */
    union __tag158 CFDRMDF14_45;                           /* CFDRMDF14_45     */
    union __tag158 CFDRMDF15_45;                           /* CFDRMDF15_45     */
    unsigned char  dummy245[52];                           /* Reserved         */
    union __tag158 CFDRMID46;                              /* CFDRMID46        */
    union __tag158 CFDRMPTR46;                             /* CFDRMPTR46       */
    union __tag158 CFDRMFDSTS46;                           /* CFDRMFDSTS46     */
    union __tag158 CFDRMDF0_46;                            /* CFDRMDF0_46      */
    union __tag158 CFDRMDF1_46;                            /* CFDRMDF1_46      */
    union __tag158 CFDRMDF2_46;                            /* CFDRMDF2_46      */
    union __tag158 CFDRMDF3_46;                            /* CFDRMDF3_46      */
    union __tag158 CFDRMDF4_46;                            /* CFDRMDF4_46      */
    union __tag158 CFDRMDF5_46;                            /* CFDRMDF5_46      */
    union __tag158 CFDRMDF6_46;                            /* CFDRMDF6_46      */
    union __tag158 CFDRMDF7_46;                            /* CFDRMDF7_46      */
    union __tag158 CFDRMDF8_46;                            /* CFDRMDF8_46      */
    union __tag158 CFDRMDF9_46;                            /* CFDRMDF9_46      */
    union __tag158 CFDRMDF10_46;                           /* CFDRMDF10_46     */
    union __tag158 CFDRMDF11_46;                           /* CFDRMDF11_46     */
    union __tag158 CFDRMDF12_46;                           /* CFDRMDF12_46     */
    union __tag158 CFDRMDF13_46;                           /* CFDRMDF13_46     */
    union __tag158 CFDRMDF14_46;                           /* CFDRMDF14_46     */
    union __tag158 CFDRMDF15_46;                           /* CFDRMDF15_46     */
    unsigned char  dummy246[52];                           /* Reserved         */
    union __tag158 CFDRMID47;                              /* CFDRMID47        */
    union __tag158 CFDRMPTR47;                             /* CFDRMPTR47       */
    union __tag158 CFDRMFDSTS47;                           /* CFDRMFDSTS47     */
    union __tag158 CFDRMDF0_47;                            /* CFDRMDF0_47      */
    union __tag158 CFDRMDF1_47;                            /* CFDRMDF1_47      */
    union __tag158 CFDRMDF2_47;                            /* CFDRMDF2_47      */
    union __tag158 CFDRMDF3_47;                            /* CFDRMDF3_47      */
    union __tag158 CFDRMDF4_47;                            /* CFDRMDF4_47      */
    union __tag158 CFDRMDF5_47;                            /* CFDRMDF5_47      */
    union __tag158 CFDRMDF6_47;                            /* CFDRMDF6_47      */
    union __tag158 CFDRMDF7_47;                            /* CFDRMDF7_47      */
    union __tag158 CFDRMDF8_47;                            /* CFDRMDF8_47      */
    union __tag158 CFDRMDF9_47;                            /* CFDRMDF9_47      */
    union __tag158 CFDRMDF10_47;                           /* CFDRMDF10_47     */
    union __tag158 CFDRMDF11_47;                           /* CFDRMDF11_47     */
    union __tag158 CFDRMDF12_47;                           /* CFDRMDF12_47     */
    union __tag158 CFDRMDF13_47;                           /* CFDRMDF13_47     */
    union __tag158 CFDRMDF14_47;                           /* CFDRMDF14_47     */
    union __tag158 CFDRMDF15_47;                           /* CFDRMDF15_47     */
    unsigned char  dummy247[10292];                        /* Reserved         */
    union __tag158 CFDRFID0;                               /* CFDRFID0         */
    union __tag158 CFDRFPTR0;                              /* CFDRFPTR0        */
    union __tag158 CFDRFFDSTS0;                            /* CFDRFFDSTS0      */
    union __tag158 CFDRFDF0_0;                             /* CFDRFDF0_0       */
    union __tag158 CFDRFDF1_0;                             /* CFDRFDF1_0       */
    union __tag158 CFDRFDF2_0;                             /* CFDRFDF2_0       */
    union __tag158 CFDRFDF3_0;                             /* CFDRFDF3_0       */
    union __tag158 CFDRFDF4_0;                             /* CFDRFDF4_0       */
    union __tag158 CFDRFDF5_0;                             /* CFDRFDF5_0       */
    union __tag158 CFDRFDF6_0;                             /* CFDRFDF6_0       */
    union __tag158 CFDRFDF7_0;                             /* CFDRFDF7_0       */
    union __tag158 CFDRFDF8_0;                             /* CFDRFDF8_0       */
    union __tag158 CFDRFDF9_0;                             /* CFDRFDF9_0       */
    union __tag158 CFDRFDF10_0;                            /* CFDRFDF10_0      */
    union __tag158 CFDRFDF11_0;                            /* CFDRFDF11_0      */
    union __tag158 CFDRFDF12_0;                            /* CFDRFDF12_0      */
    union __tag158 CFDRFDF13_0;                            /* CFDRFDF13_0      */
    union __tag158 CFDRFDF14_0;                            /* CFDRFDF14_0      */
    union __tag158 CFDRFDF15_0;                            /* CFDRFDF15_0      */
    unsigned char  dummy248[52];                           /* Reserved         */
    union __tag158 CFDRFID1;                               /* CFDRFID1         */
    union __tag158 CFDRFPTR1;                              /* CFDRFPTR1        */
    union __tag158 CFDRFFDSTS1;                            /* CFDRFFDSTS1      */
    union __tag158 CFDRFDF0_1;                             /* CFDRFDF0_1       */
    union __tag158 CFDRFDF1_1;                             /* CFDRFDF1_1       */
    union __tag158 CFDRFDF2_1;                             /* CFDRFDF2_1       */
    union __tag158 CFDRFDF3_1;                             /* CFDRFDF3_1       */
    union __tag158 CFDRFDF4_1;                             /* CFDRFDF4_1       */
    union __tag158 CFDRFDF5_1;                             /* CFDRFDF5_1       */
    union __tag158 CFDRFDF6_1;                             /* CFDRFDF6_1       */
    union __tag158 CFDRFDF7_1;                             /* CFDRFDF7_1       */
    union __tag158 CFDRFDF8_1;                             /* CFDRFDF8_1       */
    union __tag158 CFDRFDF9_1;                             /* CFDRFDF9_1       */
    union __tag158 CFDRFDF10_1;                            /* CFDRFDF10_1      */
    union __tag158 CFDRFDF11_1;                            /* CFDRFDF11_1      */
    union __tag158 CFDRFDF12_1;                            /* CFDRFDF12_1      */
    union __tag158 CFDRFDF13_1;                            /* CFDRFDF13_1      */
    union __tag158 CFDRFDF14_1;                            /* CFDRFDF14_1      */
    union __tag158 CFDRFDF15_1;                            /* CFDRFDF15_1      */
    unsigned char  dummy249[52];                           /* Reserved         */
    union __tag158 CFDRFID2;                               /* CFDRFID2         */
    union __tag158 CFDRFPTR2;                              /* CFDRFPTR2        */
    union __tag158 CFDRFFDSTS2;                            /* CFDRFFDSTS2      */
    union __tag158 CFDRFDF0_2;                             /* CFDRFDF0_2       */
    union __tag158 CFDRFDF1_2;                             /* CFDRFDF1_2       */
    union __tag158 CFDRFDF2_2;                             /* CFDRFDF2_2       */
    union __tag158 CFDRFDF3_2;                             /* CFDRFDF3_2       */
    union __tag158 CFDRFDF4_2;                             /* CFDRFDF4_2       */
    union __tag158 CFDRFDF5_2;                             /* CFDRFDF5_2       */
    union __tag158 CFDRFDF6_2;                             /* CFDRFDF6_2       */
    union __tag158 CFDRFDF7_2;                             /* CFDRFDF7_2       */
    union __tag158 CFDRFDF8_2;                             /* CFDRFDF8_2       */
    union __tag158 CFDRFDF9_2;                             /* CFDRFDF9_2       */
    union __tag158 CFDRFDF10_2;                            /* CFDRFDF10_2      */
    union __tag158 CFDRFDF11_2;                            /* CFDRFDF11_2      */
    union __tag158 CFDRFDF12_2;                            /* CFDRFDF12_2      */
    union __tag158 CFDRFDF13_2;                            /* CFDRFDF13_2      */
    union __tag158 CFDRFDF14_2;                            /* CFDRFDF14_2      */
    union __tag158 CFDRFDF15_2;                            /* CFDRFDF15_2      */
    unsigned char  dummy250[52];                           /* Reserved         */
    union __tag158 CFDRFID3;                               /* CFDRFID3         */
    union __tag158 CFDRFPTR3;                              /* CFDRFPTR3        */
    union __tag158 CFDRFFDSTS3;                            /* CFDRFFDSTS3      */
    union __tag158 CFDRFDF0_3;                             /* CFDRFDF0_3       */
    union __tag158 CFDRFDF1_3;                             /* CFDRFDF1_3       */
    union __tag158 CFDRFDF2_3;                             /* CFDRFDF2_3       */
    union __tag158 CFDRFDF3_3;                             /* CFDRFDF3_3       */
    union __tag158 CFDRFDF4_3;                             /* CFDRFDF4_3       */
    union __tag158 CFDRFDF5_3;                             /* CFDRFDF5_3       */
    union __tag158 CFDRFDF6_3;                             /* CFDRFDF6_3       */
    union __tag158 CFDRFDF7_3;                             /* CFDRFDF7_3       */
    union __tag158 CFDRFDF8_3;                             /* CFDRFDF8_3       */
    union __tag158 CFDRFDF9_3;                             /* CFDRFDF9_3       */
    union __tag158 CFDRFDF10_3;                            /* CFDRFDF10_3      */
    union __tag158 CFDRFDF11_3;                            /* CFDRFDF11_3      */
    union __tag158 CFDRFDF12_3;                            /* CFDRFDF12_3      */
    union __tag158 CFDRFDF13_3;                            /* CFDRFDF13_3      */
    union __tag158 CFDRFDF14_3;                            /* CFDRFDF14_3      */
    union __tag158 CFDRFDF15_3;                            /* CFDRFDF15_3      */
    unsigned char  dummy251[52];                           /* Reserved         */
    union __tag158 CFDRFID4;                               /* CFDRFID4         */
    union __tag158 CFDRFPTR4;                              /* CFDRFPTR4        */
    union __tag158 CFDRFFDSTS4;                            /* CFDRFFDSTS4      */
    union __tag158 CFDRFDF0_4;                             /* CFDRFDF0_4       */
    union __tag158 CFDRFDF1_4;                             /* CFDRFDF1_4       */
    union __tag158 CFDRFDF2_4;                             /* CFDRFDF2_4       */
    union __tag158 CFDRFDF3_4;                             /* CFDRFDF3_4       */
    union __tag158 CFDRFDF4_4;                             /* CFDRFDF4_4       */
    union __tag158 CFDRFDF5_4;                             /* CFDRFDF5_4       */
    union __tag158 CFDRFDF6_4;                             /* CFDRFDF6_4       */
    union __tag158 CFDRFDF7_4;                             /* CFDRFDF7_4       */
    union __tag158 CFDRFDF8_4;                             /* CFDRFDF8_4       */
    union __tag158 CFDRFDF9_4;                             /* CFDRFDF9_4       */
    union __tag158 CFDRFDF10_4;                            /* CFDRFDF10_4      */
    union __tag158 CFDRFDF11_4;                            /* CFDRFDF11_4      */
    union __tag158 CFDRFDF12_4;                            /* CFDRFDF12_4      */
    union __tag158 CFDRFDF13_4;                            /* CFDRFDF13_4      */
    union __tag158 CFDRFDF14_4;                            /* CFDRFDF14_4      */
    union __tag158 CFDRFDF15_4;                            /* CFDRFDF15_4      */
    unsigned char  dummy252[52];                           /* Reserved         */
    union __tag158 CFDRFID5;                               /* CFDRFID5         */
    union __tag158 CFDRFPTR5;                              /* CFDRFPTR5        */
    union __tag158 CFDRFFDSTS5;                            /* CFDRFFDSTS5      */
    union __tag158 CFDRFDF0_5;                             /* CFDRFDF0_5       */
    union __tag158 CFDRFDF1_5;                             /* CFDRFDF1_5       */
    union __tag158 CFDRFDF2_5;                             /* CFDRFDF2_5       */
    union __tag158 CFDRFDF3_5;                             /* CFDRFDF3_5       */
    union __tag158 CFDRFDF4_5;                             /* CFDRFDF4_5       */
    union __tag158 CFDRFDF5_5;                             /* CFDRFDF5_5       */
    union __tag158 CFDRFDF6_5;                             /* CFDRFDF6_5       */
    union __tag158 CFDRFDF7_5;                             /* CFDRFDF7_5       */
    union __tag158 CFDRFDF8_5;                             /* CFDRFDF8_5       */
    union __tag158 CFDRFDF9_5;                             /* CFDRFDF9_5       */
    union __tag158 CFDRFDF10_5;                            /* CFDRFDF10_5      */
    union __tag158 CFDRFDF11_5;                            /* CFDRFDF11_5      */
    union __tag158 CFDRFDF12_5;                            /* CFDRFDF12_5      */
    union __tag158 CFDRFDF13_5;                            /* CFDRFDF13_5      */
    union __tag158 CFDRFDF14_5;                            /* CFDRFDF14_5      */
    union __tag158 CFDRFDF15_5;                            /* CFDRFDF15_5      */
    unsigned char  dummy253[52];                           /* Reserved         */
    union __tag158 CFDRFID6;                               /* CFDRFID6         */
    union __tag158 CFDRFPTR6;                              /* CFDRFPTR6        */
    union __tag158 CFDRFFDSTS6;                            /* CFDRFFDSTS6      */
    union __tag158 CFDRFDF0_6;                             /* CFDRFDF0_6       */
    union __tag158 CFDRFDF1_6;                             /* CFDRFDF1_6       */
    union __tag158 CFDRFDF2_6;                             /* CFDRFDF2_6       */
    union __tag158 CFDRFDF3_6;                             /* CFDRFDF3_6       */
    union __tag158 CFDRFDF4_6;                             /* CFDRFDF4_6       */
    union __tag158 CFDRFDF5_6;                             /* CFDRFDF5_6       */
    union __tag158 CFDRFDF6_6;                             /* CFDRFDF6_6       */
    union __tag158 CFDRFDF7_6;                             /* CFDRFDF7_6       */
    union __tag158 CFDRFDF8_6;                             /* CFDRFDF8_6       */
    union __tag158 CFDRFDF9_6;                             /* CFDRFDF9_6       */
    union __tag158 CFDRFDF10_6;                            /* CFDRFDF10_6      */
    union __tag158 CFDRFDF11_6;                            /* CFDRFDF11_6      */
    union __tag158 CFDRFDF12_6;                            /* CFDRFDF12_6      */
    union __tag158 CFDRFDF13_6;                            /* CFDRFDF13_6      */
    union __tag158 CFDRFDF14_6;                            /* CFDRFDF14_6      */
    union __tag158 CFDRFDF15_6;                            /* CFDRFDF15_6      */
    unsigned char  dummy254[52];                           /* Reserved         */
    union __tag158 CFDRFID7;                               /* CFDRFID7         */
    union __tag158 CFDRFPTR7;                              /* CFDRFPTR7        */
    union __tag158 CFDRFFDSTS7;                            /* CFDRFFDSTS7      */
    union __tag158 CFDRFDF0_7;                             /* CFDRFDF0_7       */
    union __tag158 CFDRFDF1_7;                             /* CFDRFDF1_7       */
    union __tag158 CFDRFDF2_7;                             /* CFDRFDF2_7       */
    union __tag158 CFDRFDF3_7;                             /* CFDRFDF3_7       */
    union __tag158 CFDRFDF4_7;                             /* CFDRFDF4_7       */
    union __tag158 CFDRFDF5_7;                             /* CFDRFDF5_7       */
    union __tag158 CFDRFDF6_7;                             /* CFDRFDF6_7       */
    union __tag158 CFDRFDF7_7;                             /* CFDRFDF7_7       */
    union __tag158 CFDRFDF8_7;                             /* CFDRFDF8_7       */
    union __tag158 CFDRFDF9_7;                             /* CFDRFDF9_7       */
    union __tag158 CFDRFDF10_7;                            /* CFDRFDF10_7      */
    union __tag158 CFDRFDF11_7;                            /* CFDRFDF11_7      */
    union __tag158 CFDRFDF12_7;                            /* CFDRFDF12_7      */
    union __tag158 CFDRFDF13_7;                            /* CFDRFDF13_7      */
    union __tag158 CFDRFDF14_7;                            /* CFDRFDF14_7      */
    union __tag158 CFDRFDF15_7;                            /* CFDRFDF15_7      */
    unsigned char  dummy255[52];                           /* Reserved         */
    union __tag158 CFDCFID0;                               /* CFDCFID0         */
    union __tag158 CFDCFPTR0;                              /* CFDCFPTR0        */
    union __tag158 CFDCFFDCSTS0;                           /* CFDCFFDCSTS0     */
    union __tag158 CFDCFDF0_0;                             /* CFDCFDF0_0       */
    union __tag158 CFDCFDF1_0;                             /* CFDCFDF1_0       */
    union __tag158 CFDCFDF2_0;                             /* CFDCFDF2_0       */
    union __tag158 CFDCFDF3_0;                             /* CFDCFDF3_0       */
    union __tag158 CFDCFDF4_0;                             /* CFDCFDF4_0       */
    union __tag158 CFDCFDF5_0;                             /* CFDCFDF5_0       */
    union __tag158 CFDCFDF6_0;                             /* CFDCFDF6_0       */
    union __tag158 CFDCFDF7_0;                             /* CFDCFDF7_0       */
    union __tag158 CFDCFDF8_0;                             /* CFDCFDF8_0       */
    union __tag158 CFDCFDF9_0;                             /* CFDCFDF9_0       */
    union __tag158 CFDCFDF10_0;                            /* CFDCFDF10_0      */
    union __tag158 CFDCFDF11_0;                            /* CFDCFDF11_0      */
    union __tag158 CFDCFDF12_0;                            /* CFDCFDF12_0      */
    union __tag158 CFDCFDF13_0;                            /* CFDCFDF13_0      */
    union __tag158 CFDCFDF14_0;                            /* CFDCFDF14_0      */
    union __tag158 CFDCFDF15_0;                            /* CFDCFDF15_0      */
    unsigned char  dummy256[52];                           /* Reserved         */
    union __tag158 CFDCFID1;                               /* CFDCFID1         */
    union __tag158 CFDCFPTR1;                              /* CFDCFPTR1        */
    union __tag158 CFDCFFDCSTS1;                           /* CFDCFFDCSTS1     */
    union __tag158 CFDCFDF0_1;                             /* CFDCFDF0_1       */
    union __tag158 CFDCFDF1_1;                             /* CFDCFDF1_1       */
    union __tag158 CFDCFDF2_1;                             /* CFDCFDF2_1       */
    union __tag158 CFDCFDF3_1;                             /* CFDCFDF3_1       */
    union __tag158 CFDCFDF4_1;                             /* CFDCFDF4_1       */
    union __tag158 CFDCFDF5_1;                             /* CFDCFDF5_1       */
    union __tag158 CFDCFDF6_1;                             /* CFDCFDF6_1       */
    union __tag158 CFDCFDF7_1;                             /* CFDCFDF7_1       */
    union __tag158 CFDCFDF8_1;                             /* CFDCFDF8_1       */
    union __tag158 CFDCFDF9_1;                             /* CFDCFDF9_1       */
    union __tag158 CFDCFDF10_1;                            /* CFDCFDF10_1      */
    union __tag158 CFDCFDF11_1;                            /* CFDCFDF11_1      */
    union __tag158 CFDCFDF12_1;                            /* CFDCFDF12_1      */
    union __tag158 CFDCFDF13_1;                            /* CFDCFDF13_1      */
    union __tag158 CFDCFDF14_1;                            /* CFDCFDF14_1      */
    union __tag158 CFDCFDF15_1;                            /* CFDCFDF15_1      */
    unsigned char  dummy257[52];                           /* Reserved         */
    union __tag158 CFDCFID2;                               /* CFDCFID2         */
    union __tag158 CFDCFPTR2;                              /* CFDCFPTR2        */
    union __tag158 CFDCFFDCSTS2;                           /* CFDCFFDCSTS2     */
    union __tag158 CFDCFDF0_2;                             /* CFDCFDF0_2       */
    union __tag158 CFDCFDF1_2;                             /* CFDCFDF1_2       */
    union __tag158 CFDCFDF2_2;                             /* CFDCFDF2_2       */
    union __tag158 CFDCFDF3_2;                             /* CFDCFDF3_2       */
    union __tag158 CFDCFDF4_2;                             /* CFDCFDF4_2       */
    union __tag158 CFDCFDF5_2;                             /* CFDCFDF5_2       */
    union __tag158 CFDCFDF6_2;                             /* CFDCFDF6_2       */
    union __tag158 CFDCFDF7_2;                             /* CFDCFDF7_2       */
    union __tag158 CFDCFDF8_2;                             /* CFDCFDF8_2       */
    union __tag158 CFDCFDF9_2;                             /* CFDCFDF9_2       */
    union __tag158 CFDCFDF10_2;                            /* CFDCFDF10_2      */
    union __tag158 CFDCFDF11_2;                            /* CFDCFDF11_2      */
    union __tag158 CFDCFDF12_2;                            /* CFDCFDF12_2      */
    union __tag158 CFDCFDF13_2;                            /* CFDCFDF13_2      */
    union __tag158 CFDCFDF14_2;                            /* CFDCFDF14_2      */
    union __tag158 CFDCFDF15_2;                            /* CFDCFDF15_2      */
    unsigned char  dummy258[52];                           /* Reserved         */
    union __tag158 CFDCFID3;                               /* CFDCFID3         */
    union __tag158 CFDCFPTR3;                              /* CFDCFPTR3        */
    union __tag158 CFDCFFDCSTS3;                           /* CFDCFFDCSTS3     */
    union __tag158 CFDCFDF0_3;                             /* CFDCFDF0_3       */
    union __tag158 CFDCFDF1_3;                             /* CFDCFDF1_3       */
    union __tag158 CFDCFDF2_3;                             /* CFDCFDF2_3       */
    union __tag158 CFDCFDF3_3;                             /* CFDCFDF3_3       */
    union __tag158 CFDCFDF4_3;                             /* CFDCFDF4_3       */
    union __tag158 CFDCFDF5_3;                             /* CFDCFDF5_3       */
    union __tag158 CFDCFDF6_3;                             /* CFDCFDF6_3       */
    union __tag158 CFDCFDF7_3;                             /* CFDCFDF7_3       */
    union __tag158 CFDCFDF8_3;                             /* CFDCFDF8_3       */
    union __tag158 CFDCFDF9_3;                             /* CFDCFDF9_3       */
    union __tag158 CFDCFDF10_3;                            /* CFDCFDF10_3      */
    union __tag158 CFDCFDF11_3;                            /* CFDCFDF11_3      */
    union __tag158 CFDCFDF12_3;                            /* CFDCFDF12_3      */
    union __tag158 CFDCFDF13_3;                            /* CFDCFDF13_3      */
    union __tag158 CFDCFDF14_3;                            /* CFDCFDF14_3      */
    union __tag158 CFDCFDF15_3;                            /* CFDCFDF15_3      */
    unsigned char  dummy259[52];                           /* Reserved         */
    union __tag158 CFDCFID4;                               /* CFDCFID4         */
    union __tag158 CFDCFPTR4;                              /* CFDCFPTR4        */
    union __tag158 CFDCFFDCSTS4;                           /* CFDCFFDCSTS4     */
    union __tag158 CFDCFDF0_4;                             /* CFDCFDF0_4       */
    union __tag158 CFDCFDF1_4;                             /* CFDCFDF1_4       */
    union __tag158 CFDCFDF2_4;                             /* CFDCFDF2_4       */
    union __tag158 CFDCFDF3_4;                             /* CFDCFDF3_4       */
    union __tag158 CFDCFDF4_4;                             /* CFDCFDF4_4       */
    union __tag158 CFDCFDF5_4;                             /* CFDCFDF5_4       */
    union __tag158 CFDCFDF6_4;                             /* CFDCFDF6_4       */
    union __tag158 CFDCFDF7_4;                             /* CFDCFDF7_4       */
    union __tag158 CFDCFDF8_4;                             /* CFDCFDF8_4       */
    union __tag158 CFDCFDF9_4;                             /* CFDCFDF9_4       */
    union __tag158 CFDCFDF10_4;                            /* CFDCFDF10_4      */
    union __tag158 CFDCFDF11_4;                            /* CFDCFDF11_4      */
    union __tag158 CFDCFDF12_4;                            /* CFDCFDF12_4      */
    union __tag158 CFDCFDF13_4;                            /* CFDCFDF13_4      */
    union __tag158 CFDCFDF14_4;                            /* CFDCFDF14_4      */
    union __tag158 CFDCFDF15_4;                            /* CFDCFDF15_4      */
    unsigned char  dummy260[52];                           /* Reserved         */
    union __tag158 CFDCFID5;                               /* CFDCFID5         */
    union __tag158 CFDCFPTR5;                              /* CFDCFPTR5        */
    union __tag158 CFDCFFDCSTS5;                           /* CFDCFFDCSTS5     */
    union __tag158 CFDCFDF0_5;                             /* CFDCFDF0_5       */
    union __tag158 CFDCFDF1_5;                             /* CFDCFDF1_5       */
    union __tag158 CFDCFDF2_5;                             /* CFDCFDF2_5       */
    union __tag158 CFDCFDF3_5;                             /* CFDCFDF3_5       */
    union __tag158 CFDCFDF4_5;                             /* CFDCFDF4_5       */
    union __tag158 CFDCFDF5_5;                             /* CFDCFDF5_5       */
    union __tag158 CFDCFDF6_5;                             /* CFDCFDF6_5       */
    union __tag158 CFDCFDF7_5;                             /* CFDCFDF7_5       */
    union __tag158 CFDCFDF8_5;                             /* CFDCFDF8_5       */
    union __tag158 CFDCFDF9_5;                             /* CFDCFDF9_5       */
    union __tag158 CFDCFDF10_5;                            /* CFDCFDF10_5      */
    union __tag158 CFDCFDF11_5;                            /* CFDCFDF11_5      */
    union __tag158 CFDCFDF12_5;                            /* CFDCFDF12_5      */
    union __tag158 CFDCFDF13_5;                            /* CFDCFDF13_5      */
    union __tag158 CFDCFDF14_5;                            /* CFDCFDF14_5      */
    union __tag158 CFDCFDF15_5;                            /* CFDCFDF15_5      */
    unsigned char  dummy261[52];                           /* Reserved         */
    union __tag158 CFDCFID6;                               /* CFDCFID6         */
    union __tag158 CFDCFPTR6;                              /* CFDCFPTR6        */
    union __tag158 CFDCFFDCSTS6;                           /* CFDCFFDCSTS6     */
    union __tag158 CFDCFDF0_6;                             /* CFDCFDF0_6       */
    union __tag158 CFDCFDF1_6;                             /* CFDCFDF1_6       */
    union __tag158 CFDCFDF2_6;                             /* CFDCFDF2_6       */
    union __tag158 CFDCFDF3_6;                             /* CFDCFDF3_6       */
    union __tag158 CFDCFDF4_6;                             /* CFDCFDF4_6       */
    union __tag158 CFDCFDF5_6;                             /* CFDCFDF5_6       */
    union __tag158 CFDCFDF6_6;                             /* CFDCFDF6_6       */
    union __tag158 CFDCFDF7_6;                             /* CFDCFDF7_6       */
    union __tag158 CFDCFDF8_6;                             /* CFDCFDF8_6       */
    union __tag158 CFDCFDF9_6;                             /* CFDCFDF9_6       */
    union __tag158 CFDCFDF10_6;                            /* CFDCFDF10_6      */
    union __tag158 CFDCFDF11_6;                            /* CFDCFDF11_6      */
    union __tag158 CFDCFDF12_6;                            /* CFDCFDF12_6      */
    union __tag158 CFDCFDF13_6;                            /* CFDCFDF13_6      */
    union __tag158 CFDCFDF14_6;                            /* CFDCFDF14_6      */
    union __tag158 CFDCFDF15_6;                            /* CFDCFDF15_6      */
    unsigned char  dummy262[52];                           /* Reserved         */
    union __tag158 CFDCFID7;                               /* CFDCFID7         */
    union __tag158 CFDCFPTR7;                              /* CFDCFPTR7        */
    union __tag158 CFDCFFDCSTS7;                           /* CFDCFFDCSTS7     */
    union __tag158 CFDCFDF0_7;                             /* CFDCFDF0_7       */
    union __tag158 CFDCFDF1_7;                             /* CFDCFDF1_7       */
    union __tag158 CFDCFDF2_7;                             /* CFDCFDF2_7       */
    union __tag158 CFDCFDF3_7;                             /* CFDCFDF3_7       */
    union __tag158 CFDCFDF4_7;                             /* CFDCFDF4_7       */
    union __tag158 CFDCFDF5_7;                             /* CFDCFDF5_7       */
    union __tag158 CFDCFDF6_7;                             /* CFDCFDF6_7       */
    union __tag158 CFDCFDF7_7;                             /* CFDCFDF7_7       */
    union __tag158 CFDCFDF8_7;                             /* CFDCFDF8_7       */
    union __tag158 CFDCFDF9_7;                             /* CFDCFDF9_7       */
    union __tag158 CFDCFDF10_7;                            /* CFDCFDF10_7      */
    union __tag158 CFDCFDF11_7;                            /* CFDCFDF11_7      */
    union __tag158 CFDCFDF12_7;                            /* CFDCFDF12_7      */
    union __tag158 CFDCFDF13_7;                            /* CFDCFDF13_7      */
    union __tag158 CFDCFDF14_7;                            /* CFDCFDF14_7      */
    union __tag158 CFDCFDF15_7;                            /* CFDCFDF15_7      */
    unsigned char  dummy263[52];                           /* Reserved         */
    union __tag158 CFDCFID8;                               /* CFDCFID8         */
    union __tag158 CFDCFPTR8;                              /* CFDCFPTR8        */
    union __tag158 CFDCFFDCSTS8;                           /* CFDCFFDCSTS8     */
    union __tag158 CFDCFDF0_8;                             /* CFDCFDF0_8       */
    union __tag158 CFDCFDF1_8;                             /* CFDCFDF1_8       */
    union __tag158 CFDCFDF2_8;                             /* CFDCFDF2_8       */
    union __tag158 CFDCFDF3_8;                             /* CFDCFDF3_8       */
    union __tag158 CFDCFDF4_8;                             /* CFDCFDF4_8       */
    union __tag158 CFDCFDF5_8;                             /* CFDCFDF5_8       */
    union __tag158 CFDCFDF6_8;                             /* CFDCFDF6_8       */
    union __tag158 CFDCFDF7_8;                             /* CFDCFDF7_8       */
    union __tag158 CFDCFDF8_8;                             /* CFDCFDF8_8       */
    union __tag158 CFDCFDF9_8;                             /* CFDCFDF9_8       */
    union __tag158 CFDCFDF10_8;                            /* CFDCFDF10_8      */
    union __tag158 CFDCFDF11_8;                            /* CFDCFDF11_8      */
    union __tag158 CFDCFDF12_8;                            /* CFDCFDF12_8      */
    union __tag158 CFDCFDF13_8;                            /* CFDCFDF13_8      */
    union __tag158 CFDCFDF14_8;                            /* CFDCFDF14_8      */
    union __tag158 CFDCFDF15_8;                            /* CFDCFDF15_8      */
    unsigned char  dummy264[6068];                         /* Reserved         */
    union __tag158 CFDTMID0;                               /* CFDTMID0         */
    union __tag158 CFDTMPTR0;                              /* CFDTMPTR0        */
    union __tag158 CFDTMFDCTR0;                            /* CFDTMFDCTR0      */
    union __tag158 CFDTMDF0_0;                             /* CFDTMDF0_0       */
    union __tag158 CFDTMDF1_0;                             /* CFDTMDF1_0       */
    union __tag158 CFDTMDF2_0;                             /* CFDTMDF2_0       */
    union __tag158 CFDTMDF3_0;                             /* CFDTMDF3_0       */
    union __tag158 CFDTMDF4_0;                             /* CFDTMDF4_0       */
    union __tag158 CFDTMDF5_0;                             /* CFDTMDF5_0       */
    union __tag158 CFDTMDF6_0;                             /* CFDTMDF6_0       */
    union __tag158 CFDTMDF7_0;                             /* CFDTMDF7_0       */
    union __tag158 CFDTMDF8_0;                             /* CFDTMDF8_0       */
    union __tag158 CFDTMDF9_0;                             /* CFDTMDF9_0       */
    union __tag158 CFDTMDF10_0;                            /* CFDTMDF10_0      */
    union __tag158 CFDTMDF11_0;                            /* CFDTMDF11_0      */
    union __tag158 CFDTMDF12_0;                            /* CFDTMDF12_0      */
    union __tag158 CFDTMDF13_0;                            /* CFDTMDF13_0      */
    union __tag158 CFDTMDF14_0;                            /* CFDTMDF14_0      */
    union __tag158 CFDTMDF15_0;                            /* CFDTMDF15_0      */
    unsigned char  dummy265[52];                           /* Reserved         */
    union __tag158 CFDTMID1;                               /* CFDTMID1         */
    union __tag158 CFDTMPTR1;                              /* CFDTMPTR1        */
    union __tag158 CFDTMFDCTR1;                            /* CFDTMFDCTR1      */
    union __tag158 CFDTMDF0_1;                             /* CFDTMDF0_1       */
    union __tag158 CFDTMDF1_1;                             /* CFDTMDF1_1       */
    union __tag158 CFDTMDF2_1;                             /* CFDTMDF2_1       */
    union __tag158 CFDTMDF3_1;                             /* CFDTMDF3_1       */
    union __tag158 CFDTMDF4_1;                             /* CFDTMDF4_1       */
    union __tag158 CFDTMDF5_1;                             /* CFDTMDF5_1       */
    union __tag158 CFDTMDF6_1;                             /* CFDTMDF6_1       */
    union __tag158 CFDTMDF7_1;                             /* CFDTMDF7_1       */
    union __tag158 CFDTMDF8_1;                             /* CFDTMDF8_1       */
    union __tag158 CFDTMDF9_1;                             /* CFDTMDF9_1       */
    union __tag158 CFDTMDF10_1;                            /* CFDTMDF10_1      */
    union __tag158 CFDTMDF11_1;                            /* CFDTMDF11_1      */
    union __tag158 CFDTMDF12_1;                            /* CFDTMDF12_1      */
    union __tag158 CFDTMDF13_1;                            /* CFDTMDF13_1      */
    union __tag158 CFDTMDF14_1;                            /* CFDTMDF14_1      */
    union __tag158 CFDTMDF15_1;                            /* CFDTMDF15_1      */
    unsigned char  dummy266[52];                           /* Reserved         */
    union __tag158 CFDTMID2;                               /* CFDTMID2         */
    union __tag158 CFDTMPTR2;                              /* CFDTMPTR2        */
    union __tag158 CFDTMFDCTR2;                            /* CFDTMFDCTR2      */
    union __tag158 CFDTMDF0_2;                             /* CFDTMDF0_2       */
    union __tag158 CFDTMDF1_2;                             /* CFDTMDF1_2       */
    union __tag158 CFDTMDF2_2;                             /* CFDTMDF2_2       */
    union __tag158 CFDTMDF3_2;                             /* CFDTMDF3_2       */
    union __tag158 CFDTMDF4_2;                             /* CFDTMDF4_2       */
    union __tag158 CFDTMDF5_2;                             /* CFDTMDF5_2       */
    union __tag158 CFDTMDF6_2;                             /* CFDTMDF6_2       */
    union __tag158 CFDTMDF7_2;                             /* CFDTMDF7_2       */
    union __tag158 CFDTMDF8_2;                             /* CFDTMDF8_2       */
    union __tag158 CFDTMDF9_2;                             /* CFDTMDF9_2       */
    union __tag158 CFDTMDF10_2;                            /* CFDTMDF10_2      */
    union __tag158 CFDTMDF11_2;                            /* CFDTMDF11_2      */
    union __tag158 CFDTMDF12_2;                            /* CFDTMDF12_2      */
    union __tag158 CFDTMDF13_2;                            /* CFDTMDF13_2      */
    union __tag158 CFDTMDF14_2;                            /* CFDTMDF14_2      */
    union __tag158 CFDTMDF15_2;                            /* CFDTMDF15_2      */
    unsigned char  dummy267[52];                           /* Reserved         */
    union __tag158 CFDTMID3;                               /* CFDTMID3         */
    union __tag158 CFDTMPTR3;                              /* CFDTMPTR3        */
    union __tag158 CFDTMFDCTR3;                            /* CFDTMFDCTR3      */
    union __tag158 CFDTMDF0_3;                             /* CFDTMDF0_3       */
    union __tag158 CFDTMDF1_3;                             /* CFDTMDF1_3       */
    union __tag158 CFDTMDF2_3;                             /* CFDTMDF2_3       */
    union __tag158 CFDTMDF3_3;                             /* CFDTMDF3_3       */
    union __tag158 CFDTMDF4_3;                             /* CFDTMDF4_3       */
    union __tag158 CFDTMDF5_3;                             /* CFDTMDF5_3       */
    union __tag158 CFDTMDF6_3;                             /* CFDTMDF6_3       */
    union __tag158 CFDTMDF7_3;                             /* CFDTMDF7_3       */
    union __tag158 CFDTMDF8_3;                             /* CFDTMDF8_3       */
    union __tag158 CFDTMDF9_3;                             /* CFDTMDF9_3       */
    union __tag158 CFDTMDF10_3;                            /* CFDTMDF10_3      */
    union __tag158 CFDTMDF11_3;                            /* CFDTMDF11_3      */
    union __tag158 CFDTMDF12_3;                            /* CFDTMDF12_3      */
    union __tag158 CFDTMDF13_3;                            /* CFDTMDF13_3      */
    union __tag158 CFDTMDF14_3;                            /* CFDTMDF14_3      */
    union __tag158 CFDTMDF15_3;                            /* CFDTMDF15_3      */
    unsigned char  dummy268[52];                           /* Reserved         */
    union __tag158 CFDTMID4;                               /* CFDTMID4         */
    union __tag158 CFDTMPTR4;                              /* CFDTMPTR4        */
    union __tag158 CFDTMFDCTR4;                            /* CFDTMFDCTR4      */
    union __tag158 CFDTMDF0_4;                             /* CFDTMDF0_4       */
    union __tag158 CFDTMDF1_4;                             /* CFDTMDF1_4       */
    union __tag158 CFDTMDF2_4;                             /* CFDTMDF2_4       */
    union __tag158 CFDTMDF3_4;                             /* CFDTMDF3_4       */
    union __tag158 CFDTMDF4_4;                             /* CFDTMDF4_4       */
    union __tag158 CFDTMDF5_4;                             /* CFDTMDF5_4       */
    union __tag158 CFDTMDF6_4;                             /* CFDTMDF6_4       */
    union __tag158 CFDTMDF7_4;                             /* CFDTMDF7_4       */
    union __tag158 CFDTMDF8_4;                             /* CFDTMDF8_4       */
    union __tag158 CFDTMDF9_4;                             /* CFDTMDF9_4       */
    union __tag158 CFDTMDF10_4;                            /* CFDTMDF10_4      */
    union __tag158 CFDTMDF11_4;                            /* CFDTMDF11_4      */
    union __tag158 CFDTMDF12_4;                            /* CFDTMDF12_4      */
    union __tag158 CFDTMDF13_4;                            /* CFDTMDF13_4      */
    union __tag158 CFDTMDF14_4;                            /* CFDTMDF14_4      */
    union __tag158 CFDTMDF15_4;                            /* CFDTMDF15_4      */
    unsigned char  dummy269[52];                           /* Reserved         */
    union __tag158 CFDTMID5;                               /* CFDTMID5         */
    union __tag158 CFDTMPTR5;                              /* CFDTMPTR5        */
    union __tag158 CFDTMFDCTR5;                            /* CFDTMFDCTR5      */
    union __tag158 CFDTMDF0_5;                             /* CFDTMDF0_5       */
    union __tag158 CFDTMDF1_5;                             /* CFDTMDF1_5       */
    union __tag158 CFDTMDF2_5;                             /* CFDTMDF2_5       */
    union __tag158 CFDTMDF3_5;                             /* CFDTMDF3_5       */
    union __tag158 CFDTMDF4_5;                             /* CFDTMDF4_5       */
    union __tag158 CFDTMDF5_5;                             /* CFDTMDF5_5       */
    union __tag158 CFDTMDF6_5;                             /* CFDTMDF6_5       */
    union __tag158 CFDTMDF7_5;                             /* CFDTMDF7_5       */
    union __tag158 CFDTMDF8_5;                             /* CFDTMDF8_5       */
    union __tag158 CFDTMDF9_5;                             /* CFDTMDF9_5       */
    union __tag158 CFDTMDF10_5;                            /* CFDTMDF10_5      */
    union __tag158 CFDTMDF11_5;                            /* CFDTMDF11_5      */
    union __tag158 CFDTMDF12_5;                            /* CFDTMDF12_5      */
    union __tag158 CFDTMDF13_5;                            /* CFDTMDF13_5      */
    union __tag158 CFDTMDF14_5;                            /* CFDTMDF14_5      */
    union __tag158 CFDTMDF15_5;                            /* CFDTMDF15_5      */
    unsigned char  dummy270[52];                           /* Reserved         */
    union __tag158 CFDTMID6;                               /* CFDTMID6         */
    union __tag158 CFDTMPTR6;                              /* CFDTMPTR6        */
    union __tag158 CFDTMFDCTR6;                            /* CFDTMFDCTR6      */
    union __tag158 CFDTMDF0_6;                             /* CFDTMDF0_6       */
    union __tag158 CFDTMDF1_6;                             /* CFDTMDF1_6       */
    union __tag158 CFDTMDF2_6;                             /* CFDTMDF2_6       */
    union __tag158 CFDTMDF3_6;                             /* CFDTMDF3_6       */
    union __tag158 CFDTMDF4_6;                             /* CFDTMDF4_6       */
    union __tag158 CFDTMDF5_6;                             /* CFDTMDF5_6       */
    union __tag158 CFDTMDF6_6;                             /* CFDTMDF6_6       */
    union __tag158 CFDTMDF7_6;                             /* CFDTMDF7_6       */
    union __tag158 CFDTMDF8_6;                             /* CFDTMDF8_6       */
    union __tag158 CFDTMDF9_6;                             /* CFDTMDF9_6       */
    union __tag158 CFDTMDF10_6;                            /* CFDTMDF10_6      */
    union __tag158 CFDTMDF11_6;                            /* CFDTMDF11_6      */
    union __tag158 CFDTMDF12_6;                            /* CFDTMDF12_6      */
    union __tag158 CFDTMDF13_6;                            /* CFDTMDF13_6      */
    union __tag158 CFDTMDF14_6;                            /* CFDTMDF14_6      */
    union __tag158 CFDTMDF15_6;                            /* CFDTMDF15_6      */
    unsigned char  dummy271[52];                           /* Reserved         */
    union __tag158 CFDTMID7;                               /* CFDTMID7         */
    union __tag158 CFDTMPTR7;                              /* CFDTMPTR7        */
    union __tag158 CFDTMFDCTR7;                            /* CFDTMFDCTR7      */
    union __tag158 CFDTMDF0_7;                             /* CFDTMDF0_7       */
    union __tag158 CFDTMDF1_7;                             /* CFDTMDF1_7       */
    union __tag158 CFDTMDF2_7;                             /* CFDTMDF2_7       */
    union __tag158 CFDTMDF3_7;                             /* CFDTMDF3_7       */
    union __tag158 CFDTMDF4_7;                             /* CFDTMDF4_7       */
    union __tag158 CFDTMDF5_7;                             /* CFDTMDF5_7       */
    union __tag158 CFDTMDF6_7;                             /* CFDTMDF6_7       */
    union __tag158 CFDTMDF7_7;                             /* CFDTMDF7_7       */
    union __tag158 CFDTMDF8_7;                             /* CFDTMDF8_7       */
    union __tag158 CFDTMDF9_7;                             /* CFDTMDF9_7       */
    union __tag158 CFDTMDF10_7;                            /* CFDTMDF10_7      */
    union __tag158 CFDTMDF11_7;                            /* CFDTMDF11_7      */
    union __tag158 CFDTMDF12_7;                            /* CFDTMDF12_7      */
    union __tag158 CFDTMDF13_7;                            /* CFDTMDF13_7      */
    union __tag158 CFDTMDF14_7;                            /* CFDTMDF14_7      */
    union __tag158 CFDTMDF15_7;                            /* CFDTMDF15_7      */
    unsigned char  dummy272[52];                           /* Reserved         */
    union __tag158 CFDTMID8;                               /* CFDTMID8         */
    union __tag158 CFDTMPTR8;                              /* CFDTMPTR8        */
    union __tag158 CFDTMFDCTR8;                            /* CFDTMFDCTR8      */
    union __tag158 CFDTMDF0_8;                             /* CFDTMDF0_8       */
    union __tag158 CFDTMDF1_8;                             /* CFDTMDF1_8       */
    union __tag158 CFDTMDF2_8;                             /* CFDTMDF2_8       */
    union __tag158 CFDTMDF3_8;                             /* CFDTMDF3_8       */
    union __tag158 CFDTMDF4_8;                             /* CFDTMDF4_8       */
    union __tag158 CFDTMDF5_8;                             /* CFDTMDF5_8       */
    union __tag158 CFDTMDF6_8;                             /* CFDTMDF6_8       */
    union __tag158 CFDTMDF7_8;                             /* CFDTMDF7_8       */
    union __tag158 CFDTMDF8_8;                             /* CFDTMDF8_8       */
    union __tag158 CFDTMDF9_8;                             /* CFDTMDF9_8       */
    union __tag158 CFDTMDF10_8;                            /* CFDTMDF10_8      */
    union __tag158 CFDTMDF11_8;                            /* CFDTMDF11_8      */
    union __tag158 CFDTMDF12_8;                            /* CFDTMDF12_8      */
    union __tag158 CFDTMDF13_8;                            /* CFDTMDF13_8      */
    union __tag158 CFDTMDF14_8;                            /* CFDTMDF14_8      */
    union __tag158 CFDTMDF15_8;                            /* CFDTMDF15_8      */
    unsigned char  dummy273[52];                           /* Reserved         */
    union __tag158 CFDTMID9;                               /* CFDTMID9         */
    union __tag158 CFDTMPTR9;                              /* CFDTMPTR9        */
    union __tag158 CFDTMFDCTR9;                            /* CFDTMFDCTR9      */
    union __tag158 CFDTMDF0_9;                             /* CFDTMDF0_9       */
    union __tag158 CFDTMDF1_9;                             /* CFDTMDF1_9       */
    union __tag158 CFDTMDF2_9;                             /* CFDTMDF2_9       */
    union __tag158 CFDTMDF3_9;                             /* CFDTMDF3_9       */
    union __tag158 CFDTMDF4_9;                             /* CFDTMDF4_9       */
    union __tag158 CFDTMDF5_9;                             /* CFDTMDF5_9       */
    union __tag158 CFDTMDF6_9;                             /* CFDTMDF6_9       */
    union __tag158 CFDTMDF7_9;                             /* CFDTMDF7_9       */
    union __tag158 CFDTMDF8_9;                             /* CFDTMDF8_9       */
    union __tag158 CFDTMDF9_9;                             /* CFDTMDF9_9       */
    union __tag158 CFDTMDF10_9;                            /* CFDTMDF10_9      */
    union __tag158 CFDTMDF11_9;                            /* CFDTMDF11_9      */
    union __tag158 CFDTMDF12_9;                            /* CFDTMDF12_9      */
    union __tag158 CFDTMDF13_9;                            /* CFDTMDF13_9      */
    union __tag158 CFDTMDF14_9;                            /* CFDTMDF14_9      */
    union __tag158 CFDTMDF15_9;                            /* CFDTMDF15_9      */
    unsigned char  dummy274[52];                           /* Reserved         */
    union __tag158 CFDTMID10;                              /* CFDTMID10        */
    union __tag158 CFDTMPTR10;                             /* CFDTMPTR10       */
    union __tag158 CFDTMFDCTR10;                           /* CFDTMFDCTR10     */
    union __tag158 CFDTMDF0_10;                            /* CFDTMDF0_10      */
    union __tag158 CFDTMDF1_10;                            /* CFDTMDF1_10      */
    union __tag158 CFDTMDF2_10;                            /* CFDTMDF2_10      */
    union __tag158 CFDTMDF3_10;                            /* CFDTMDF3_10      */
    union __tag158 CFDTMDF4_10;                            /* CFDTMDF4_10      */
    union __tag158 CFDTMDF5_10;                            /* CFDTMDF5_10      */
    union __tag158 CFDTMDF6_10;                            /* CFDTMDF6_10      */
    union __tag158 CFDTMDF7_10;                            /* CFDTMDF7_10      */
    union __tag158 CFDTMDF8_10;                            /* CFDTMDF8_10      */
    union __tag158 CFDTMDF9_10;                            /* CFDTMDF9_10      */
    union __tag158 CFDTMDF10_10;                           /* CFDTMDF10_10     */
    union __tag158 CFDTMDF11_10;                           /* CFDTMDF11_10     */
    union __tag158 CFDTMDF12_10;                           /* CFDTMDF12_10     */
    union __tag158 CFDTMDF13_10;                           /* CFDTMDF13_10     */
    union __tag158 CFDTMDF14_10;                           /* CFDTMDF14_10     */
    union __tag158 CFDTMDF15_10;                           /* CFDTMDF15_10     */
    unsigned char  dummy275[52];                           /* Reserved         */
    union __tag158 CFDTMID11;                              /* CFDTMID11        */
    union __tag158 CFDTMPTR11;                             /* CFDTMPTR11       */
    union __tag158 CFDTMFDCTR11;                           /* CFDTMFDCTR11     */
    union __tag158 CFDTMDF0_11;                            /* CFDTMDF0_11      */
    union __tag158 CFDTMDF1_11;                            /* CFDTMDF1_11      */
    union __tag158 CFDTMDF2_11;                            /* CFDTMDF2_11      */
    union __tag158 CFDTMDF3_11;                            /* CFDTMDF3_11      */
    union __tag158 CFDTMDF4_11;                            /* CFDTMDF4_11      */
    union __tag158 CFDTMDF5_11;                            /* CFDTMDF5_11      */
    union __tag158 CFDTMDF6_11;                            /* CFDTMDF6_11      */
    union __tag158 CFDTMDF7_11;                            /* CFDTMDF7_11      */
    union __tag158 CFDTMDF8_11;                            /* CFDTMDF8_11      */
    union __tag158 CFDTMDF9_11;                            /* CFDTMDF9_11      */
    union __tag158 CFDTMDF10_11;                           /* CFDTMDF10_11     */
    union __tag158 CFDTMDF11_11;                           /* CFDTMDF11_11     */
    union __tag158 CFDTMDF12_11;                           /* CFDTMDF12_11     */
    union __tag158 CFDTMDF13_11;                           /* CFDTMDF13_11     */
    union __tag158 CFDTMDF14_11;                           /* CFDTMDF14_11     */
    union __tag158 CFDTMDF15_11;                           /* CFDTMDF15_11     */
    unsigned char  dummy276[52];                           /* Reserved         */
    union __tag158 CFDTMID12;                              /* CFDTMID12        */
    union __tag158 CFDTMPTR12;                             /* CFDTMPTR12       */
    union __tag158 CFDTMFDCTR12;                           /* CFDTMFDCTR12     */
    union __tag158 CFDTMDF0_12;                            /* CFDTMDF0_12      */
    union __tag158 CFDTMDF1_12;                            /* CFDTMDF1_12      */
    union __tag158 CFDTMDF2_12;                            /* CFDTMDF2_12      */
    union __tag158 CFDTMDF3_12;                            /* CFDTMDF3_12      */
    union __tag158 CFDTMDF4_12;                            /* CFDTMDF4_12      */
    union __tag158 CFDTMDF5_12;                            /* CFDTMDF5_12      */
    union __tag158 CFDTMDF6_12;                            /* CFDTMDF6_12      */
    union __tag158 CFDTMDF7_12;                            /* CFDTMDF7_12      */
    union __tag158 CFDTMDF8_12;                            /* CFDTMDF8_12      */
    union __tag158 CFDTMDF9_12;                            /* CFDTMDF9_12      */
    union __tag158 CFDTMDF10_12;                           /* CFDTMDF10_12     */
    union __tag158 CFDTMDF11_12;                           /* CFDTMDF11_12     */
    union __tag158 CFDTMDF12_12;                           /* CFDTMDF12_12     */
    union __tag158 CFDTMDF13_12;                           /* CFDTMDF13_12     */
    union __tag158 CFDTMDF14_12;                           /* CFDTMDF14_12     */
    union __tag158 CFDTMDF15_12;                           /* CFDTMDF15_12     */
    unsigned char  dummy277[52];                           /* Reserved         */
    union __tag158 CFDTMID13;                              /* CFDTMID13        */
    union __tag158 CFDTMPTR13;                             /* CFDTMPTR13       */
    union __tag158 CFDTMFDCTR13;                           /* CFDTMFDCTR13     */
    union __tag158 CFDTMDF0_13;                            /* CFDTMDF0_13      */
    union __tag158 CFDTMDF1_13;                            /* CFDTMDF1_13      */
    union __tag158 CFDTMDF2_13;                            /* CFDTMDF2_13      */
    union __tag158 CFDTMDF3_13;                            /* CFDTMDF3_13      */
    union __tag158 CFDTMDF4_13;                            /* CFDTMDF4_13      */
    union __tag158 CFDTMDF5_13;                            /* CFDTMDF5_13      */
    union __tag158 CFDTMDF6_13;                            /* CFDTMDF6_13      */
    union __tag158 CFDTMDF7_13;                            /* CFDTMDF7_13      */
    union __tag158 CFDTMDF8_13;                            /* CFDTMDF8_13      */
    union __tag158 CFDTMDF9_13;                            /* CFDTMDF9_13      */
    union __tag158 CFDTMDF10_13;                           /* CFDTMDF10_13     */
    union __tag158 CFDTMDF11_13;                           /* CFDTMDF11_13     */
    union __tag158 CFDTMDF12_13;                           /* CFDTMDF12_13     */
    union __tag158 CFDTMDF13_13;                           /* CFDTMDF13_13     */
    union __tag158 CFDTMDF14_13;                           /* CFDTMDF14_13     */
    union __tag158 CFDTMDF15_13;                           /* CFDTMDF15_13     */
    unsigned char  dummy278[52];                           /* Reserved         */
    union __tag158 CFDTMID14;                              /* CFDTMID14        */
    union __tag158 CFDTMPTR14;                             /* CFDTMPTR14       */
    union __tag158 CFDTMFDCTR14;                           /* CFDTMFDCTR14     */
    union __tag158 CFDTMDF0_14;                            /* CFDTMDF0_14      */
    union __tag158 CFDTMDF1_14;                            /* CFDTMDF1_14      */
    union __tag158 CFDTMDF2_14;                            /* CFDTMDF2_14      */
    union __tag158 CFDTMDF3_14;                            /* CFDTMDF3_14      */
    union __tag158 CFDTMDF4_14;                            /* CFDTMDF4_14      */
    union __tag158 CFDTMDF5_14;                            /* CFDTMDF5_14      */
    union __tag158 CFDTMDF6_14;                            /* CFDTMDF6_14      */
    union __tag158 CFDTMDF7_14;                            /* CFDTMDF7_14      */
    union __tag158 CFDTMDF8_14;                            /* CFDTMDF8_14      */
    union __tag158 CFDTMDF9_14;                            /* CFDTMDF9_14      */
    union __tag158 CFDTMDF10_14;                           /* CFDTMDF10_14     */
    union __tag158 CFDTMDF11_14;                           /* CFDTMDF11_14     */
    union __tag158 CFDTMDF12_14;                           /* CFDTMDF12_14     */
    union __tag158 CFDTMDF13_14;                           /* CFDTMDF13_14     */
    union __tag158 CFDTMDF14_14;                           /* CFDTMDF14_14     */
    union __tag158 CFDTMDF15_14;                           /* CFDTMDF15_14     */
    unsigned char  dummy279[52];                           /* Reserved         */
    union __tag158 CFDTMID15;                              /* CFDTMID15        */
    union __tag158 CFDTMPTR15;                             /* CFDTMPTR15       */
    union __tag158 CFDTMFDCTR15;                           /* CFDTMFDCTR15     */
    union __tag158 CFDTMDF0_15;                            /* CFDTMDF0_15      */
    union __tag158 CFDTMDF1_15;                            /* CFDTMDF1_15      */
    union __tag158 CFDTMDF2_15;                            /* CFDTMDF2_15      */
    union __tag158 CFDTMDF3_15;                            /* CFDTMDF3_15      */
    union __tag158 CFDTMDF4_15;                            /* CFDTMDF4_15      */
    union __tag158 CFDTMDF5_15;                            /* CFDTMDF5_15      */
    union __tag158 CFDTMDF6_15;                            /* CFDTMDF6_15      */
    union __tag158 CFDTMDF7_15;                            /* CFDTMDF7_15      */
    union __tag158 CFDTMDF8_15;                            /* CFDTMDF8_15      */
    union __tag158 CFDTMDF9_15;                            /* CFDTMDF9_15      */
    union __tag158 CFDTMDF10_15;                           /* CFDTMDF10_15     */
    union __tag158 CFDTMDF11_15;                           /* CFDTMDF11_15     */
    union __tag158 CFDTMDF12_15;                           /* CFDTMDF12_15     */
    union __tag158 CFDTMDF13_15;                           /* CFDTMDF13_15     */
    union __tag158 CFDTMDF14_15;                           /* CFDTMDF14_15     */
    union __tag158 CFDTMDF15_15;                           /* CFDTMDF15_15     */
    unsigned char  dummy280[52];                           /* Reserved         */
    union __tag158 CFDTMID16;                              /* CFDTMID16        */
    union __tag158 CFDTMPTR16;                             /* CFDTMPTR16       */
    union __tag158 CFDTMFDCTR16;                           /* CFDTMFDCTR16     */
    union __tag158 CFDTMDF0_16;                            /* CFDTMDF0_16      */
    union __tag158 CFDTMDF1_16;                            /* CFDTMDF1_16      */
    union __tag158 CFDTMDF2_16;                            /* CFDTMDF2_16      */
    union __tag158 CFDTMDF3_16;                            /* CFDTMDF3_16      */
    union __tag158 CFDTMDF4_16;                            /* CFDTMDF4_16      */
    union __tag158 CFDTMDF5_16;                            /* CFDTMDF5_16      */
    union __tag158 CFDTMDF6_16;                            /* CFDTMDF6_16      */
    union __tag158 CFDTMDF7_16;                            /* CFDTMDF7_16      */
    union __tag158 CFDTMDF8_16;                            /* CFDTMDF8_16      */
    union __tag158 CFDTMDF9_16;                            /* CFDTMDF9_16      */
    union __tag158 CFDTMDF10_16;                           /* CFDTMDF10_16     */
    union __tag158 CFDTMDF11_16;                           /* CFDTMDF11_16     */
    union __tag158 CFDTMDF12_16;                           /* CFDTMDF12_16     */
    union __tag158 CFDTMDF13_16;                           /* CFDTMDF13_16     */
    union __tag158 CFDTMDF14_16;                           /* CFDTMDF14_16     */
    union __tag158 CFDTMDF15_16;                           /* CFDTMDF15_16     */
    unsigned char  dummy281[52];                           /* Reserved         */
    union __tag158 CFDTMID17;                              /* CFDTMID17        */
    union __tag158 CFDTMPTR17;                             /* CFDTMPTR17       */
    union __tag158 CFDTMFDCTR17;                           /* CFDTMFDCTR17     */
    union __tag158 CFDTMDF0_17;                            /* CFDTMDF0_17      */
    union __tag158 CFDTMDF1_17;                            /* CFDTMDF1_17      */
    union __tag158 CFDTMDF2_17;                            /* CFDTMDF2_17      */
    union __tag158 CFDTMDF3_17;                            /* CFDTMDF3_17      */
    union __tag158 CFDTMDF4_17;                            /* CFDTMDF4_17      */
    union __tag158 CFDTMDF5_17;                            /* CFDTMDF5_17      */
    union __tag158 CFDTMDF6_17;                            /* CFDTMDF6_17      */
    union __tag158 CFDTMDF7_17;                            /* CFDTMDF7_17      */
    union __tag158 CFDTMDF8_17;                            /* CFDTMDF8_17      */
    union __tag158 CFDTMDF9_17;                            /* CFDTMDF9_17      */
    union __tag158 CFDTMDF10_17;                           /* CFDTMDF10_17     */
    union __tag158 CFDTMDF11_17;                           /* CFDTMDF11_17     */
    union __tag158 CFDTMDF12_17;                           /* CFDTMDF12_17     */
    union __tag158 CFDTMDF13_17;                           /* CFDTMDF13_17     */
    union __tag158 CFDTMDF14_17;                           /* CFDTMDF14_17     */
    union __tag158 CFDTMDF15_17;                           /* CFDTMDF15_17     */
    unsigned char  dummy282[52];                           /* Reserved         */
    union __tag158 CFDTMID18;                              /* CFDTMID18        */
    union __tag158 CFDTMPTR18;                             /* CFDTMPTR18       */
    union __tag158 CFDTMFDCTR18;                           /* CFDTMFDCTR18     */
    union __tag158 CFDTMDF0_18;                            /* CFDTMDF0_18      */
    union __tag158 CFDTMDF1_18;                            /* CFDTMDF1_18      */
    union __tag158 CFDTMDF2_18;                            /* CFDTMDF2_18      */
    union __tag158 CFDTMDF3_18;                            /* CFDTMDF3_18      */
    union __tag158 CFDTMDF4_18;                            /* CFDTMDF4_18      */
    union __tag158 CFDTMDF5_18;                            /* CFDTMDF5_18      */
    union __tag158 CFDTMDF6_18;                            /* CFDTMDF6_18      */
    union __tag158 CFDTMDF7_18;                            /* CFDTMDF7_18      */
    union __tag158 CFDTMDF8_18;                            /* CFDTMDF8_18      */
    union __tag158 CFDTMDF9_18;                            /* CFDTMDF9_18      */
    union __tag158 CFDTMDF10_18;                           /* CFDTMDF10_18     */
    union __tag158 CFDTMDF11_18;                           /* CFDTMDF11_18     */
    union __tag158 CFDTMDF12_18;                           /* CFDTMDF12_18     */
    union __tag158 CFDTMDF13_18;                           /* CFDTMDF13_18     */
    union __tag158 CFDTMDF14_18;                           /* CFDTMDF14_18     */
    union __tag158 CFDTMDF15_18;                           /* CFDTMDF15_18     */
    unsigned char  dummy283[52];                           /* Reserved         */
    union __tag158 CFDTMID19;                              /* CFDTMID19        */
    union __tag158 CFDTMPTR19;                             /* CFDTMPTR19       */
    union __tag158 CFDTMFDCTR19;                           /* CFDTMFDCTR19     */
    union __tag158 CFDTMDF0_19;                            /* CFDTMDF0_19      */
    union __tag158 CFDTMDF1_19;                            /* CFDTMDF1_19      */
    union __tag158 CFDTMDF2_19;                            /* CFDTMDF2_19      */
    union __tag158 CFDTMDF3_19;                            /* CFDTMDF3_19      */
    union __tag158 CFDTMDF4_19;                            /* CFDTMDF4_19      */
    union __tag158 CFDTMDF5_19;                            /* CFDTMDF5_19      */
    union __tag158 CFDTMDF6_19;                            /* CFDTMDF6_19      */
    union __tag158 CFDTMDF7_19;                            /* CFDTMDF7_19      */
    union __tag158 CFDTMDF8_19;                            /* CFDTMDF8_19      */
    union __tag158 CFDTMDF9_19;                            /* CFDTMDF9_19      */
    union __tag158 CFDTMDF10_19;                           /* CFDTMDF10_19     */
    union __tag158 CFDTMDF11_19;                           /* CFDTMDF11_19     */
    union __tag158 CFDTMDF12_19;                           /* CFDTMDF12_19     */
    union __tag158 CFDTMDF13_19;                           /* CFDTMDF13_19     */
    union __tag158 CFDTMDF14_19;                           /* CFDTMDF14_19     */
    union __tag158 CFDTMDF15_19;                           /* CFDTMDF15_19     */
    unsigned char  dummy284[52];                           /* Reserved         */
    union __tag158 CFDTMID20;                              /* CFDTMID20        */
    union __tag158 CFDTMPTR20;                             /* CFDTMPTR20       */
    union __tag158 CFDTMFDCTR20;                           /* CFDTMFDCTR20     */
    union __tag158 CFDTMDF0_20;                            /* CFDTMDF0_20      */
    union __tag158 CFDTMDF1_20;                            /* CFDTMDF1_20      */
    union __tag158 CFDTMDF2_20;                            /* CFDTMDF2_20      */
    union __tag158 CFDTMDF3_20;                            /* CFDTMDF3_20      */
    union __tag158 CFDTMDF4_20;                            /* CFDTMDF4_20      */
    union __tag158 CFDTMDF5_20;                            /* CFDTMDF5_20      */
    union __tag158 CFDTMDF6_20;                            /* CFDTMDF6_20      */
    union __tag158 CFDTMDF7_20;                            /* CFDTMDF7_20      */
    union __tag158 CFDTMDF8_20;                            /* CFDTMDF8_20      */
    union __tag158 CFDTMDF9_20;                            /* CFDTMDF9_20      */
    union __tag158 CFDTMDF10_20;                           /* CFDTMDF10_20     */
    union __tag158 CFDTMDF11_20;                           /* CFDTMDF11_20     */
    union __tag158 CFDTMDF12_20;                           /* CFDTMDF12_20     */
    union __tag158 CFDTMDF13_20;                           /* CFDTMDF13_20     */
    union __tag158 CFDTMDF14_20;                           /* CFDTMDF14_20     */
    union __tag158 CFDTMDF15_20;                           /* CFDTMDF15_20     */
    unsigned char  dummy285[52];                           /* Reserved         */
    union __tag158 CFDTMID21;                              /* CFDTMID21        */
    union __tag158 CFDTMPTR21;                             /* CFDTMPTR21       */
    union __tag158 CFDTMFDCTR21;                           /* CFDTMFDCTR21     */
    union __tag158 CFDTMDF0_21;                            /* CFDTMDF0_21      */
    union __tag158 CFDTMDF1_21;                            /* CFDTMDF1_21      */
    union __tag158 CFDTMDF2_21;                            /* CFDTMDF2_21      */
    union __tag158 CFDTMDF3_21;                            /* CFDTMDF3_21      */
    union __tag158 CFDTMDF4_21;                            /* CFDTMDF4_21      */
    union __tag158 CFDTMDF5_21;                            /* CFDTMDF5_21      */
    union __tag158 CFDTMDF6_21;                            /* CFDTMDF6_21      */
    union __tag158 CFDTMDF7_21;                            /* CFDTMDF7_21      */
    union __tag158 CFDTMDF8_21;                            /* CFDTMDF8_21      */
    union __tag158 CFDTMDF9_21;                            /* CFDTMDF9_21      */
    union __tag158 CFDTMDF10_21;                           /* CFDTMDF10_21     */
    union __tag158 CFDTMDF11_21;                           /* CFDTMDF11_21     */
    union __tag158 CFDTMDF12_21;                           /* CFDTMDF12_21     */
    union __tag158 CFDTMDF13_21;                           /* CFDTMDF13_21     */
    union __tag158 CFDTMDF14_21;                           /* CFDTMDF14_21     */
    union __tag158 CFDTMDF15_21;                           /* CFDTMDF15_21     */
    unsigned char  dummy286[52];                           /* Reserved         */
    union __tag158 CFDTMID22;                              /* CFDTMID22        */
    union __tag158 CFDTMPTR22;                             /* CFDTMPTR22       */
    union __tag158 CFDTMFDCTR22;                           /* CFDTMFDCTR22     */
    union __tag158 CFDTMDF0_22;                            /* CFDTMDF0_22      */
    union __tag158 CFDTMDF1_22;                            /* CFDTMDF1_22      */
    union __tag158 CFDTMDF2_22;                            /* CFDTMDF2_22      */
    union __tag158 CFDTMDF3_22;                            /* CFDTMDF3_22      */
    union __tag158 CFDTMDF4_22;                            /* CFDTMDF4_22      */
    union __tag158 CFDTMDF5_22;                            /* CFDTMDF5_22      */
    union __tag158 CFDTMDF6_22;                            /* CFDTMDF6_22      */
    union __tag158 CFDTMDF7_22;                            /* CFDTMDF7_22      */
    union __tag158 CFDTMDF8_22;                            /* CFDTMDF8_22      */
    union __tag158 CFDTMDF9_22;                            /* CFDTMDF9_22      */
    union __tag158 CFDTMDF10_22;                           /* CFDTMDF10_22     */
    union __tag158 CFDTMDF11_22;                           /* CFDTMDF11_22     */
    union __tag158 CFDTMDF12_22;                           /* CFDTMDF12_22     */
    union __tag158 CFDTMDF13_22;                           /* CFDTMDF13_22     */
    union __tag158 CFDTMDF14_22;                           /* CFDTMDF14_22     */
    union __tag158 CFDTMDF15_22;                           /* CFDTMDF15_22     */
    unsigned char  dummy287[52];                           /* Reserved         */
    union __tag158 CFDTMID23;                              /* CFDTMID23        */
    union __tag158 CFDTMPTR23;                             /* CFDTMPTR23       */
    union __tag158 CFDTMFDCTR23;                           /* CFDTMFDCTR23     */
    union __tag158 CFDTMDF0_23;                            /* CFDTMDF0_23      */
    union __tag158 CFDTMDF1_23;                            /* CFDTMDF1_23      */
    union __tag158 CFDTMDF2_23;                            /* CFDTMDF2_23      */
    union __tag158 CFDTMDF3_23;                            /* CFDTMDF3_23      */
    union __tag158 CFDTMDF4_23;                            /* CFDTMDF4_23      */
    union __tag158 CFDTMDF5_23;                            /* CFDTMDF5_23      */
    union __tag158 CFDTMDF6_23;                            /* CFDTMDF6_23      */
    union __tag158 CFDTMDF7_23;                            /* CFDTMDF7_23      */
    union __tag158 CFDTMDF8_23;                            /* CFDTMDF8_23      */
    union __tag158 CFDTMDF9_23;                            /* CFDTMDF9_23      */
    union __tag158 CFDTMDF10_23;                           /* CFDTMDF10_23     */
    union __tag158 CFDTMDF11_23;                           /* CFDTMDF11_23     */
    union __tag158 CFDTMDF12_23;                           /* CFDTMDF12_23     */
    union __tag158 CFDTMDF13_23;                           /* CFDTMDF13_23     */
    union __tag158 CFDTMDF14_23;                           /* CFDTMDF14_23     */
    union __tag158 CFDTMDF15_23;                           /* CFDTMDF15_23     */
    unsigned char  dummy288[52];                           /* Reserved         */
    union __tag158 CFDTMID24;                              /* CFDTMID24        */
    union __tag158 CFDTMPTR24;                             /* CFDTMPTR24       */
    union __tag158 CFDTMFDCTR24;                           /* CFDTMFDCTR24     */
    union __tag158 CFDTMDF0_24;                            /* CFDTMDF0_24      */
    union __tag158 CFDTMDF1_24;                            /* CFDTMDF1_24      */
    union __tag158 CFDTMDF2_24;                            /* CFDTMDF2_24      */
    union __tag158 CFDTMDF3_24;                            /* CFDTMDF3_24      */
    union __tag158 CFDTMDF4_24;                            /* CFDTMDF4_24      */
    union __tag158 CFDTMDF5_24;                            /* CFDTMDF5_24      */
    union __tag158 CFDTMDF6_24;                            /* CFDTMDF6_24      */
    union __tag158 CFDTMDF7_24;                            /* CFDTMDF7_24      */
    union __tag158 CFDTMDF8_24;                            /* CFDTMDF8_24      */
    union __tag158 CFDTMDF9_24;                            /* CFDTMDF9_24      */
    union __tag158 CFDTMDF10_24;                           /* CFDTMDF10_24     */
    union __tag158 CFDTMDF11_24;                           /* CFDTMDF11_24     */
    union __tag158 CFDTMDF12_24;                           /* CFDTMDF12_24     */
    union __tag158 CFDTMDF13_24;                           /* CFDTMDF13_24     */
    union __tag158 CFDTMDF14_24;                           /* CFDTMDF14_24     */
    union __tag158 CFDTMDF15_24;                           /* CFDTMDF15_24     */
    unsigned char  dummy289[52];                           /* Reserved         */
    union __tag158 CFDTMID25;                              /* CFDTMID25        */
    union __tag158 CFDTMPTR25;                             /* CFDTMPTR25       */
    union __tag158 CFDTMFDCTR25;                           /* CFDTMFDCTR25     */
    union __tag158 CFDTMDF0_25;                            /* CFDTMDF0_25      */
    union __tag158 CFDTMDF1_25;                            /* CFDTMDF1_25      */
    union __tag158 CFDTMDF2_25;                            /* CFDTMDF2_25      */
    union __tag158 CFDTMDF3_25;                            /* CFDTMDF3_25      */
    union __tag158 CFDTMDF4_25;                            /* CFDTMDF4_25      */
    union __tag158 CFDTMDF5_25;                            /* CFDTMDF5_25      */
    union __tag158 CFDTMDF6_25;                            /* CFDTMDF6_25      */
    union __tag158 CFDTMDF7_25;                            /* CFDTMDF7_25      */
    union __tag158 CFDTMDF8_25;                            /* CFDTMDF8_25      */
    union __tag158 CFDTMDF9_25;                            /* CFDTMDF9_25      */
    union __tag158 CFDTMDF10_25;                           /* CFDTMDF10_25     */
    union __tag158 CFDTMDF11_25;                           /* CFDTMDF11_25     */
    union __tag158 CFDTMDF12_25;                           /* CFDTMDF12_25     */
    union __tag158 CFDTMDF13_25;                           /* CFDTMDF13_25     */
    union __tag158 CFDTMDF14_25;                           /* CFDTMDF14_25     */
    union __tag158 CFDTMDF15_25;                           /* CFDTMDF15_25     */
    unsigned char  dummy290[52];                           /* Reserved         */
    union __tag158 CFDTMID26;                              /* CFDTMID26        */
    union __tag158 CFDTMPTR26;                             /* CFDTMPTR26       */
    union __tag158 CFDTMFDCTR26;                           /* CFDTMFDCTR26     */
    union __tag158 CFDTMDF0_26;                            /* CFDTMDF0_26      */
    union __tag158 CFDTMDF1_26;                            /* CFDTMDF1_26      */
    union __tag158 CFDTMDF2_26;                            /* CFDTMDF2_26      */
    union __tag158 CFDTMDF3_26;                            /* CFDTMDF3_26      */
    union __tag158 CFDTMDF4_26;                            /* CFDTMDF4_26      */
    union __tag158 CFDTMDF5_26;                            /* CFDTMDF5_26      */
    union __tag158 CFDTMDF6_26;                            /* CFDTMDF6_26      */
    union __tag158 CFDTMDF7_26;                            /* CFDTMDF7_26      */
    union __tag158 CFDTMDF8_26;                            /* CFDTMDF8_26      */
    union __tag158 CFDTMDF9_26;                            /* CFDTMDF9_26      */
    union __tag158 CFDTMDF10_26;                           /* CFDTMDF10_26     */
    union __tag158 CFDTMDF11_26;                           /* CFDTMDF11_26     */
    union __tag158 CFDTMDF12_26;                           /* CFDTMDF12_26     */
    union __tag158 CFDTMDF13_26;                           /* CFDTMDF13_26     */
    union __tag158 CFDTMDF14_26;                           /* CFDTMDF14_26     */
    union __tag158 CFDTMDF15_26;                           /* CFDTMDF15_26     */
    unsigned char  dummy291[52];                           /* Reserved         */
    union __tag158 CFDTMID27;                              /* CFDTMID27        */
    union __tag158 CFDTMPTR27;                             /* CFDTMPTR27       */
    union __tag158 CFDTMFDCTR27;                           /* CFDTMFDCTR27     */
    union __tag158 CFDTMDF0_27;                            /* CFDTMDF0_27      */
    union __tag158 CFDTMDF1_27;                            /* CFDTMDF1_27      */
    union __tag158 CFDTMDF2_27;                            /* CFDTMDF2_27      */
    union __tag158 CFDTMDF3_27;                            /* CFDTMDF3_27      */
    union __tag158 CFDTMDF4_27;                            /* CFDTMDF4_27      */
    union __tag158 CFDTMDF5_27;                            /* CFDTMDF5_27      */
    union __tag158 CFDTMDF6_27;                            /* CFDTMDF6_27      */
    union __tag158 CFDTMDF7_27;                            /* CFDTMDF7_27      */
    union __tag158 CFDTMDF8_27;                            /* CFDTMDF8_27      */
    union __tag158 CFDTMDF9_27;                            /* CFDTMDF9_27      */
    union __tag158 CFDTMDF10_27;                           /* CFDTMDF10_27     */
    union __tag158 CFDTMDF11_27;                           /* CFDTMDF11_27     */
    union __tag158 CFDTMDF12_27;                           /* CFDTMDF12_27     */
    union __tag158 CFDTMDF13_27;                           /* CFDTMDF13_27     */
    union __tag158 CFDTMDF14_27;                           /* CFDTMDF14_27     */
    union __tag158 CFDTMDF15_27;                           /* CFDTMDF15_27     */
    unsigned char  dummy292[52];                           /* Reserved         */
    union __tag158 CFDTMID28;                              /* CFDTMID28        */
    union __tag158 CFDTMPTR28;                             /* CFDTMPTR28       */
    union __tag158 CFDTMFDCTR28;                           /* CFDTMFDCTR28     */
    union __tag158 CFDTMDF0_28;                            /* CFDTMDF0_28      */
    union __tag158 CFDTMDF1_28;                            /* CFDTMDF1_28      */
    union __tag158 CFDTMDF2_28;                            /* CFDTMDF2_28      */
    union __tag158 CFDTMDF3_28;                            /* CFDTMDF3_28      */
    union __tag158 CFDTMDF4_28;                            /* CFDTMDF4_28      */
    union __tag158 CFDTMDF5_28;                            /* CFDTMDF5_28      */
    union __tag158 CFDTMDF6_28;                            /* CFDTMDF6_28      */
    union __tag158 CFDTMDF7_28;                            /* CFDTMDF7_28      */
    union __tag158 CFDTMDF8_28;                            /* CFDTMDF8_28      */
    union __tag158 CFDTMDF9_28;                            /* CFDTMDF9_28      */
    union __tag158 CFDTMDF10_28;                           /* CFDTMDF10_28     */
    union __tag158 CFDTMDF11_28;                           /* CFDTMDF11_28     */
    union __tag158 CFDTMDF12_28;                           /* CFDTMDF12_28     */
    union __tag158 CFDTMDF13_28;                           /* CFDTMDF13_28     */
    union __tag158 CFDTMDF14_28;                           /* CFDTMDF14_28     */
    union __tag158 CFDTMDF15_28;                           /* CFDTMDF15_28     */
    unsigned char  dummy293[52];                           /* Reserved         */
    union __tag158 CFDTMID29;                              /* CFDTMID29        */
    union __tag158 CFDTMPTR29;                             /* CFDTMPTR29       */
    union __tag158 CFDTMFDCTR29;                           /* CFDTMFDCTR29     */
    union __tag158 CFDTMDF0_29;                            /* CFDTMDF0_29      */
    union __tag158 CFDTMDF1_29;                            /* CFDTMDF1_29      */
    union __tag158 CFDTMDF2_29;                            /* CFDTMDF2_29      */
    union __tag158 CFDTMDF3_29;                            /* CFDTMDF3_29      */
    union __tag158 CFDTMDF4_29;                            /* CFDTMDF4_29      */
    union __tag158 CFDTMDF5_29;                            /* CFDTMDF5_29      */
    union __tag158 CFDTMDF6_29;                            /* CFDTMDF6_29      */
    union __tag158 CFDTMDF7_29;                            /* CFDTMDF7_29      */
    union __tag158 CFDTMDF8_29;                            /* CFDTMDF8_29      */
    union __tag158 CFDTMDF9_29;                            /* CFDTMDF9_29      */
    union __tag158 CFDTMDF10_29;                           /* CFDTMDF10_29     */
    union __tag158 CFDTMDF11_29;                           /* CFDTMDF11_29     */
    union __tag158 CFDTMDF12_29;                           /* CFDTMDF12_29     */
    union __tag158 CFDTMDF13_29;                           /* CFDTMDF13_29     */
    union __tag158 CFDTMDF14_29;                           /* CFDTMDF14_29     */
    union __tag158 CFDTMDF15_29;                           /* CFDTMDF15_29     */
    unsigned char  dummy294[52];                           /* Reserved         */
    union __tag158 CFDTMID30;                              /* CFDTMID30        */
    union __tag158 CFDTMPTR30;                             /* CFDTMPTR30       */
    union __tag158 CFDTMFDCTR30;                           /* CFDTMFDCTR30     */
    union __tag158 CFDTMDF0_30;                            /* CFDTMDF0_30      */
    union __tag158 CFDTMDF1_30;                            /* CFDTMDF1_30      */
    union __tag158 CFDTMDF2_30;                            /* CFDTMDF2_30      */
    union __tag158 CFDTMDF3_30;                            /* CFDTMDF3_30      */
    union __tag158 CFDTMDF4_30;                            /* CFDTMDF4_30      */
    union __tag158 CFDTMDF5_30;                            /* CFDTMDF5_30      */
    union __tag158 CFDTMDF6_30;                            /* CFDTMDF6_30      */
    union __tag158 CFDTMDF7_30;                            /* CFDTMDF7_30      */
    union __tag158 CFDTMDF8_30;                            /* CFDTMDF8_30      */
    union __tag158 CFDTMDF9_30;                            /* CFDTMDF9_30      */
    union __tag158 CFDTMDF10_30;                           /* CFDTMDF10_30     */
    union __tag158 CFDTMDF11_30;                           /* CFDTMDF11_30     */
    union __tag158 CFDTMDF12_30;                           /* CFDTMDF12_30     */
    union __tag158 CFDTMDF13_30;                           /* CFDTMDF13_30     */
    union __tag158 CFDTMDF14_30;                           /* CFDTMDF14_30     */
    union __tag158 CFDTMDF15_30;                           /* CFDTMDF15_30     */
    unsigned char  dummy295[52];                           /* Reserved         */
    union __tag158 CFDTMID31;                              /* CFDTMID31        */
    union __tag158 CFDTMPTR31;                             /* CFDTMPTR31       */
    union __tag158 CFDTMFDCTR31;                           /* CFDTMFDCTR31     */
    union __tag158 CFDTMDF0_31;                            /* CFDTMDF0_31      */
    union __tag158 CFDTMDF1_31;                            /* CFDTMDF1_31      */
    union __tag158 CFDTMDF2_31;                            /* CFDTMDF2_31      */
    union __tag158 CFDTMDF3_31;                            /* CFDTMDF3_31      */
    union __tag158 CFDTMDF4_31;                            /* CFDTMDF4_31      */
    union __tag158 CFDTMDF5_31;                            /* CFDTMDF5_31      */
    union __tag158 CFDTMDF6_31;                            /* CFDTMDF6_31      */
    union __tag158 CFDTMDF7_31;                            /* CFDTMDF7_31      */
    union __tag158 CFDTMDF8_31;                            /* CFDTMDF8_31      */
    union __tag158 CFDTMDF9_31;                            /* CFDTMDF9_31      */
    union __tag158 CFDTMDF10_31;                           /* CFDTMDF10_31     */
    union __tag158 CFDTMDF11_31;                           /* CFDTMDF11_31     */
    union __tag158 CFDTMDF12_31;                           /* CFDTMDF12_31     */
    union __tag158 CFDTMDF13_31;                           /* CFDTMDF13_31     */
    union __tag158 CFDTMDF14_31;                           /* CFDTMDF14_31     */
    union __tag158 CFDTMDF15_31;                           /* CFDTMDF15_31     */
    unsigned char  dummy296[52];                           /* Reserved         */
    union __tag158 CFDTMID32;                              /* CFDTMID32        */
    union __tag158 CFDTMPTR32;                             /* CFDTMPTR32       */
    union __tag158 CFDTMFDCTR32;                           /* CFDTMFDCTR32     */
    union __tag158 CFDTMDF0_32;                            /* CFDTMDF0_32      */
    union __tag158 CFDTMDF1_32;                            /* CFDTMDF1_32      */
    union __tag158 CFDTMDF2_32;                            /* CFDTMDF2_32      */
    union __tag158 CFDTMDF3_32;                            /* CFDTMDF3_32      */
    union __tag158 CFDTMDF4_32;                            /* CFDTMDF4_32      */
    union __tag158 CFDTMDF5_32;                            /* CFDTMDF5_32      */
    union __tag158 CFDTMDF6_32;                            /* CFDTMDF6_32      */
    union __tag158 CFDTMDF7_32;                            /* CFDTMDF7_32      */
    union __tag158 CFDTMDF8_32;                            /* CFDTMDF8_32      */
    union __tag158 CFDTMDF9_32;                            /* CFDTMDF9_32      */
    union __tag158 CFDTMDF10_32;                           /* CFDTMDF10_32     */
    union __tag158 CFDTMDF11_32;                           /* CFDTMDF11_32     */
    union __tag158 CFDTMDF12_32;                           /* CFDTMDF12_32     */
    union __tag158 CFDTMDF13_32;                           /* CFDTMDF13_32     */
    union __tag158 CFDTMDF14_32;                           /* CFDTMDF14_32     */
    union __tag158 CFDTMDF15_32;                           /* CFDTMDF15_32     */
    unsigned char  dummy297[52];                           /* Reserved         */
    union __tag158 CFDTMID33;                              /* CFDTMID33        */
    union __tag158 CFDTMPTR33;                             /* CFDTMPTR33       */
    union __tag158 CFDTMFDCTR33;                           /* CFDTMFDCTR33     */
    union __tag158 CFDTMDF0_33;                            /* CFDTMDF0_33      */
    union __tag158 CFDTMDF1_33;                            /* CFDTMDF1_33      */
    union __tag158 CFDTMDF2_33;                            /* CFDTMDF2_33      */
    union __tag158 CFDTMDF3_33;                            /* CFDTMDF3_33      */
    union __tag158 CFDTMDF4_33;                            /* CFDTMDF4_33      */
    union __tag158 CFDTMDF5_33;                            /* CFDTMDF5_33      */
    union __tag158 CFDTMDF6_33;                            /* CFDTMDF6_33      */
    union __tag158 CFDTMDF7_33;                            /* CFDTMDF7_33      */
    union __tag158 CFDTMDF8_33;                            /* CFDTMDF8_33      */
    union __tag158 CFDTMDF9_33;                            /* CFDTMDF9_33      */
    union __tag158 CFDTMDF10_33;                           /* CFDTMDF10_33     */
    union __tag158 CFDTMDF11_33;                           /* CFDTMDF11_33     */
    union __tag158 CFDTMDF12_33;                           /* CFDTMDF12_33     */
    union __tag158 CFDTMDF13_33;                           /* CFDTMDF13_33     */
    union __tag158 CFDTMDF14_33;                           /* CFDTMDF14_33     */
    union __tag158 CFDTMDF15_33;                           /* CFDTMDF15_33     */
    unsigned char  dummy298[52];                           /* Reserved         */
    union __tag158 CFDTMID34;                              /* CFDTMID34        */
    union __tag158 CFDTMPTR34;                             /* CFDTMPTR34       */
    union __tag158 CFDTMFDCTR34;                           /* CFDTMFDCTR34     */
    union __tag158 CFDTMDF0_34;                            /* CFDTMDF0_34      */
    union __tag158 CFDTMDF1_34;                            /* CFDTMDF1_34      */
    union __tag158 CFDTMDF2_34;                            /* CFDTMDF2_34      */
    union __tag158 CFDTMDF3_34;                            /* CFDTMDF3_34      */
    union __tag158 CFDTMDF4_34;                            /* CFDTMDF4_34      */
    union __tag158 CFDTMDF5_34;                            /* CFDTMDF5_34      */
    union __tag158 CFDTMDF6_34;                            /* CFDTMDF6_34      */
    union __tag158 CFDTMDF7_34;                            /* CFDTMDF7_34      */
    union __tag158 CFDTMDF8_34;                            /* CFDTMDF8_34      */
    union __tag158 CFDTMDF9_34;                            /* CFDTMDF9_34      */
    union __tag158 CFDTMDF10_34;                           /* CFDTMDF10_34     */
    union __tag158 CFDTMDF11_34;                           /* CFDTMDF11_34     */
    union __tag158 CFDTMDF12_34;                           /* CFDTMDF12_34     */
    union __tag158 CFDTMDF13_34;                           /* CFDTMDF13_34     */
    union __tag158 CFDTMDF14_34;                           /* CFDTMDF14_34     */
    union __tag158 CFDTMDF15_34;                           /* CFDTMDF15_34     */
    unsigned char  dummy299[52];                           /* Reserved         */
    union __tag158 CFDTMID35;                              /* CFDTMID35        */
    union __tag158 CFDTMPTR35;                             /* CFDTMPTR35       */
    union __tag158 CFDTMFDCTR35;                           /* CFDTMFDCTR35     */
    union __tag158 CFDTMDF0_35;                            /* CFDTMDF0_35      */
    union __tag158 CFDTMDF1_35;                            /* CFDTMDF1_35      */
    union __tag158 CFDTMDF2_35;                            /* CFDTMDF2_35      */
    union __tag158 CFDTMDF3_35;                            /* CFDTMDF3_35      */
    union __tag158 CFDTMDF4_35;                            /* CFDTMDF4_35      */
    union __tag158 CFDTMDF5_35;                            /* CFDTMDF5_35      */
    union __tag158 CFDTMDF6_35;                            /* CFDTMDF6_35      */
    union __tag158 CFDTMDF7_35;                            /* CFDTMDF7_35      */
    union __tag158 CFDTMDF8_35;                            /* CFDTMDF8_35      */
    union __tag158 CFDTMDF9_35;                            /* CFDTMDF9_35      */
    union __tag158 CFDTMDF10_35;                           /* CFDTMDF10_35     */
    union __tag158 CFDTMDF11_35;                           /* CFDTMDF11_35     */
    union __tag158 CFDTMDF12_35;                           /* CFDTMDF12_35     */
    union __tag158 CFDTMDF13_35;                           /* CFDTMDF13_35     */
    union __tag158 CFDTMDF14_35;                           /* CFDTMDF14_35     */
    union __tag158 CFDTMDF15_35;                           /* CFDTMDF15_35     */
    unsigned char  dummy300[52];                           /* Reserved         */
    union __tag158 CFDTMID36;                              /* CFDTMID36        */
    union __tag158 CFDTMPTR36;                             /* CFDTMPTR36       */
    union __tag158 CFDTMFDCTR36;                           /* CFDTMFDCTR36     */
    union __tag158 CFDTMDF0_36;                            /* CFDTMDF0_36      */
    union __tag158 CFDTMDF1_36;                            /* CFDTMDF1_36      */
    union __tag158 CFDTMDF2_36;                            /* CFDTMDF2_36      */
    union __tag158 CFDTMDF3_36;                            /* CFDTMDF3_36      */
    union __tag158 CFDTMDF4_36;                            /* CFDTMDF4_36      */
    union __tag158 CFDTMDF5_36;                            /* CFDTMDF5_36      */
    union __tag158 CFDTMDF6_36;                            /* CFDTMDF6_36      */
    union __tag158 CFDTMDF7_36;                            /* CFDTMDF7_36      */
    union __tag158 CFDTMDF8_36;                            /* CFDTMDF8_36      */
    union __tag158 CFDTMDF9_36;                            /* CFDTMDF9_36      */
    union __tag158 CFDTMDF10_36;                           /* CFDTMDF10_36     */
    union __tag158 CFDTMDF11_36;                           /* CFDTMDF11_36     */
    union __tag158 CFDTMDF12_36;                           /* CFDTMDF12_36     */
    union __tag158 CFDTMDF13_36;                           /* CFDTMDF13_36     */
    union __tag158 CFDTMDF14_36;                           /* CFDTMDF14_36     */
    union __tag158 CFDTMDF15_36;                           /* CFDTMDF15_36     */
    unsigned char  dummy301[52];                           /* Reserved         */
    union __tag158 CFDTMID37;                              /* CFDTMID37        */
    union __tag158 CFDTMPTR37;                             /* CFDTMPTR37       */
    union __tag158 CFDTMFDCTR37;                           /* CFDTMFDCTR37     */
    union __tag158 CFDTMDF0_37;                            /* CFDTMDF0_37      */
    union __tag158 CFDTMDF1_37;                            /* CFDTMDF1_37      */
    union __tag158 CFDTMDF2_37;                            /* CFDTMDF2_37      */
    union __tag158 CFDTMDF3_37;                            /* CFDTMDF3_37      */
    union __tag158 CFDTMDF4_37;                            /* CFDTMDF4_37      */
    union __tag158 CFDTMDF5_37;                            /* CFDTMDF5_37      */
    union __tag158 CFDTMDF6_37;                            /* CFDTMDF6_37      */
    union __tag158 CFDTMDF7_37;                            /* CFDTMDF7_37      */
    union __tag158 CFDTMDF8_37;                            /* CFDTMDF8_37      */
    union __tag158 CFDTMDF9_37;                            /* CFDTMDF9_37      */
    union __tag158 CFDTMDF10_37;                           /* CFDTMDF10_37     */
    union __tag158 CFDTMDF11_37;                           /* CFDTMDF11_37     */
    union __tag158 CFDTMDF12_37;                           /* CFDTMDF12_37     */
    union __tag158 CFDTMDF13_37;                           /* CFDTMDF13_37     */
    union __tag158 CFDTMDF14_37;                           /* CFDTMDF14_37     */
    union __tag158 CFDTMDF15_37;                           /* CFDTMDF15_37     */
    unsigned char  dummy302[52];                           /* Reserved         */
    union __tag158 CFDTMID38;                              /* CFDTMID38        */
    union __tag158 CFDTMPTR38;                             /* CFDTMPTR38       */
    union __tag158 CFDTMFDCTR38;                           /* CFDTMFDCTR38     */
    union __tag158 CFDTMDF0_38;                            /* CFDTMDF0_38      */
    union __tag158 CFDTMDF1_38;                            /* CFDTMDF1_38      */
    union __tag158 CFDTMDF2_38;                            /* CFDTMDF2_38      */
    union __tag158 CFDTMDF3_38;                            /* CFDTMDF3_38      */
    union __tag158 CFDTMDF4_38;                            /* CFDTMDF4_38      */
    union __tag158 CFDTMDF5_38;                            /* CFDTMDF5_38      */
    union __tag158 CFDTMDF6_38;                            /* CFDTMDF6_38      */
    union __tag158 CFDTMDF7_38;                            /* CFDTMDF7_38      */
    union __tag158 CFDTMDF8_38;                            /* CFDTMDF8_38      */
    union __tag158 CFDTMDF9_38;                            /* CFDTMDF9_38      */
    union __tag158 CFDTMDF10_38;                           /* CFDTMDF10_38     */
    union __tag158 CFDTMDF11_38;                           /* CFDTMDF11_38     */
    union __tag158 CFDTMDF12_38;                           /* CFDTMDF12_38     */
    union __tag158 CFDTMDF13_38;                           /* CFDTMDF13_38     */
    union __tag158 CFDTMDF14_38;                           /* CFDTMDF14_38     */
    union __tag158 CFDTMDF15_38;                           /* CFDTMDF15_38     */
    unsigned char  dummy303[52];                           /* Reserved         */
    union __tag158 CFDTMID39;                              /* CFDTMID39        */
    union __tag158 CFDTMPTR39;                             /* CFDTMPTR39       */
    union __tag158 CFDTMFDCTR39;                           /* CFDTMFDCTR39     */
    union __tag158 CFDTMDF0_39;                            /* CFDTMDF0_39      */
    union __tag158 CFDTMDF1_39;                            /* CFDTMDF1_39      */
    union __tag158 CFDTMDF2_39;                            /* CFDTMDF2_39      */
    union __tag158 CFDTMDF3_39;                            /* CFDTMDF3_39      */
    union __tag158 CFDTMDF4_39;                            /* CFDTMDF4_39      */
    union __tag158 CFDTMDF5_39;                            /* CFDTMDF5_39      */
    union __tag158 CFDTMDF6_39;                            /* CFDTMDF6_39      */
    union __tag158 CFDTMDF7_39;                            /* CFDTMDF7_39      */
    union __tag158 CFDTMDF8_39;                            /* CFDTMDF8_39      */
    union __tag158 CFDTMDF9_39;                            /* CFDTMDF9_39      */
    union __tag158 CFDTMDF10_39;                           /* CFDTMDF10_39     */
    union __tag158 CFDTMDF11_39;                           /* CFDTMDF11_39     */
    union __tag158 CFDTMDF12_39;                           /* CFDTMDF12_39     */
    union __tag158 CFDTMDF13_39;                           /* CFDTMDF13_39     */
    union __tag158 CFDTMDF14_39;                           /* CFDTMDF14_39     */
    union __tag158 CFDTMDF15_39;                           /* CFDTMDF15_39     */
    unsigned char  dummy304[52];                           /* Reserved         */
    union __tag158 CFDTMID40;                              /* CFDTMID40        */
    union __tag158 CFDTMPTR40;                             /* CFDTMPTR40       */
    union __tag158 CFDTMFDCTR40;                           /* CFDTMFDCTR40     */
    union __tag158 CFDTMDF0_40;                            /* CFDTMDF0_40      */
    union __tag158 CFDTMDF1_40;                            /* CFDTMDF1_40      */
    union __tag158 CFDTMDF2_40;                            /* CFDTMDF2_40      */
    union __tag158 CFDTMDF3_40;                            /* CFDTMDF3_40      */
    union __tag158 CFDTMDF4_40;                            /* CFDTMDF4_40      */
    union __tag158 CFDTMDF5_40;                            /* CFDTMDF5_40      */
    union __tag158 CFDTMDF6_40;                            /* CFDTMDF6_40      */
    union __tag158 CFDTMDF7_40;                            /* CFDTMDF7_40      */
    union __tag158 CFDTMDF8_40;                            /* CFDTMDF8_40      */
    union __tag158 CFDTMDF9_40;                            /* CFDTMDF9_40      */
    union __tag158 CFDTMDF10_40;                           /* CFDTMDF10_40     */
    union __tag158 CFDTMDF11_40;                           /* CFDTMDF11_40     */
    union __tag158 CFDTMDF12_40;                           /* CFDTMDF12_40     */
    union __tag158 CFDTMDF13_40;                           /* CFDTMDF13_40     */
    union __tag158 CFDTMDF14_40;                           /* CFDTMDF14_40     */
    union __tag158 CFDTMDF15_40;                           /* CFDTMDF15_40     */
    unsigned char  dummy305[52];                           /* Reserved         */
    union __tag158 CFDTMID41;                              /* CFDTMID41        */
    union __tag158 CFDTMPTR41;                             /* CFDTMPTR41       */
    union __tag158 CFDTMFDCTR41;                           /* CFDTMFDCTR41     */
    union __tag158 CFDTMDF0_41;                            /* CFDTMDF0_41      */
    union __tag158 CFDTMDF1_41;                            /* CFDTMDF1_41      */
    union __tag158 CFDTMDF2_41;                            /* CFDTMDF2_41      */
    union __tag158 CFDTMDF3_41;                            /* CFDTMDF3_41      */
    union __tag158 CFDTMDF4_41;                            /* CFDTMDF4_41      */
    union __tag158 CFDTMDF5_41;                            /* CFDTMDF5_41      */
    union __tag158 CFDTMDF6_41;                            /* CFDTMDF6_41      */
    union __tag158 CFDTMDF7_41;                            /* CFDTMDF7_41      */
    union __tag158 CFDTMDF8_41;                            /* CFDTMDF8_41      */
    union __tag158 CFDTMDF9_41;                            /* CFDTMDF9_41      */
    union __tag158 CFDTMDF10_41;                           /* CFDTMDF10_41     */
    union __tag158 CFDTMDF11_41;                           /* CFDTMDF11_41     */
    union __tag158 CFDTMDF12_41;                           /* CFDTMDF12_41     */
    union __tag158 CFDTMDF13_41;                           /* CFDTMDF13_41     */
    union __tag158 CFDTMDF14_41;                           /* CFDTMDF14_41     */
    union __tag158 CFDTMDF15_41;                           /* CFDTMDF15_41     */
    unsigned char  dummy306[52];                           /* Reserved         */
    union __tag158 CFDTMID42;                              /* CFDTMID42        */
    union __tag158 CFDTMPTR42;                             /* CFDTMPTR42       */
    union __tag158 CFDTMFDCTR42;                           /* CFDTMFDCTR42     */
    union __tag158 CFDTMDF0_42;                            /* CFDTMDF0_42      */
    union __tag158 CFDTMDF1_42;                            /* CFDTMDF1_42      */
    union __tag158 CFDTMDF2_42;                            /* CFDTMDF2_42      */
    union __tag158 CFDTMDF3_42;                            /* CFDTMDF3_42      */
    union __tag158 CFDTMDF4_42;                            /* CFDTMDF4_42      */
    union __tag158 CFDTMDF5_42;                            /* CFDTMDF5_42      */
    union __tag158 CFDTMDF6_42;                            /* CFDTMDF6_42      */
    union __tag158 CFDTMDF7_42;                            /* CFDTMDF7_42      */
    union __tag158 CFDTMDF8_42;                            /* CFDTMDF8_42      */
    union __tag158 CFDTMDF9_42;                            /* CFDTMDF9_42      */
    union __tag158 CFDTMDF10_42;                           /* CFDTMDF10_42     */
    union __tag158 CFDTMDF11_42;                           /* CFDTMDF11_42     */
    union __tag158 CFDTMDF12_42;                           /* CFDTMDF12_42     */
    union __tag158 CFDTMDF13_42;                           /* CFDTMDF13_42     */
    union __tag158 CFDTMDF14_42;                           /* CFDTMDF14_42     */
    union __tag158 CFDTMDF15_42;                           /* CFDTMDF15_42     */
    unsigned char  dummy307[52];                           /* Reserved         */
    union __tag158 CFDTMID43;                              /* CFDTMID43        */
    union __tag158 CFDTMPTR43;                             /* CFDTMPTR43       */
    union __tag158 CFDTMFDCTR43;                           /* CFDTMFDCTR43     */
    union __tag158 CFDTMDF0_43;                            /* CFDTMDF0_43      */
    union __tag158 CFDTMDF1_43;                            /* CFDTMDF1_43      */
    union __tag158 CFDTMDF2_43;                            /* CFDTMDF2_43      */
    union __tag158 CFDTMDF3_43;                            /* CFDTMDF3_43      */
    union __tag158 CFDTMDF4_43;                            /* CFDTMDF4_43      */
    union __tag158 CFDTMDF5_43;                            /* CFDTMDF5_43      */
    union __tag158 CFDTMDF6_43;                            /* CFDTMDF6_43      */
    union __tag158 CFDTMDF7_43;                            /* CFDTMDF7_43      */
    union __tag158 CFDTMDF8_43;                            /* CFDTMDF8_43      */
    union __tag158 CFDTMDF9_43;                            /* CFDTMDF9_43      */
    union __tag158 CFDTMDF10_43;                           /* CFDTMDF10_43     */
    union __tag158 CFDTMDF11_43;                           /* CFDTMDF11_43     */
    union __tag158 CFDTMDF12_43;                           /* CFDTMDF12_43     */
    union __tag158 CFDTMDF13_43;                           /* CFDTMDF13_43     */
    union __tag158 CFDTMDF14_43;                           /* CFDTMDF14_43     */
    union __tag158 CFDTMDF15_43;                           /* CFDTMDF15_43     */
    unsigned char  dummy308[52];                           /* Reserved         */
    union __tag158 CFDTMID44;                              /* CFDTMID44        */
    union __tag158 CFDTMPTR44;                             /* CFDTMPTR44       */
    union __tag158 CFDTMFDCTR44;                           /* CFDTMFDCTR44     */
    union __tag158 CFDTMDF0_44;                            /* CFDTMDF0_44      */
    union __tag158 CFDTMDF1_44;                            /* CFDTMDF1_44      */
    union __tag158 CFDTMDF2_44;                            /* CFDTMDF2_44      */
    union __tag158 CFDTMDF3_44;                            /* CFDTMDF3_44      */
    union __tag158 CFDTMDF4_44;                            /* CFDTMDF4_44      */
    union __tag158 CFDTMDF5_44;                            /* CFDTMDF5_44      */
    union __tag158 CFDTMDF6_44;                            /* CFDTMDF6_44      */
    union __tag158 CFDTMDF7_44;                            /* CFDTMDF7_44      */
    union __tag158 CFDTMDF8_44;                            /* CFDTMDF8_44      */
    union __tag158 CFDTMDF9_44;                            /* CFDTMDF9_44      */
    union __tag158 CFDTMDF10_44;                           /* CFDTMDF10_44     */
    union __tag158 CFDTMDF11_44;                           /* CFDTMDF11_44     */
    union __tag158 CFDTMDF12_44;                           /* CFDTMDF12_44     */
    union __tag158 CFDTMDF13_44;                           /* CFDTMDF13_44     */
    union __tag158 CFDTMDF14_44;                           /* CFDTMDF14_44     */
    union __tag158 CFDTMDF15_44;                           /* CFDTMDF15_44     */
    unsigned char  dummy309[52];                           /* Reserved         */
    union __tag158 CFDTMID45;                              /* CFDTMID45        */
    union __tag158 CFDTMPTR45;                             /* CFDTMPTR45       */
    union __tag158 CFDTMFDCTR45;                           /* CFDTMFDCTR45     */
    union __tag158 CFDTMDF0_45;                            /* CFDTMDF0_45      */
    union __tag158 CFDTMDF1_45;                            /* CFDTMDF1_45      */
    union __tag158 CFDTMDF2_45;                            /* CFDTMDF2_45      */
    union __tag158 CFDTMDF3_45;                            /* CFDTMDF3_45      */
    union __tag158 CFDTMDF4_45;                            /* CFDTMDF4_45      */
    union __tag158 CFDTMDF5_45;                            /* CFDTMDF5_45      */
    union __tag158 CFDTMDF6_45;                            /* CFDTMDF6_45      */
    union __tag158 CFDTMDF7_45;                            /* CFDTMDF7_45      */
    union __tag158 CFDTMDF8_45;                            /* CFDTMDF8_45      */
    union __tag158 CFDTMDF9_45;                            /* CFDTMDF9_45      */
    union __tag158 CFDTMDF10_45;                           /* CFDTMDF10_45     */
    union __tag158 CFDTMDF11_45;                           /* CFDTMDF11_45     */
    union __tag158 CFDTMDF12_45;                           /* CFDTMDF12_45     */
    union __tag158 CFDTMDF13_45;                           /* CFDTMDF13_45     */
    union __tag158 CFDTMDF14_45;                           /* CFDTMDF14_45     */
    union __tag158 CFDTMDF15_45;                           /* CFDTMDF15_45     */
    unsigned char  dummy310[52];                           /* Reserved         */
    union __tag158 CFDTMID46;                              /* CFDTMID46        */
    union __tag158 CFDTMPTR46;                             /* CFDTMPTR46       */
    union __tag158 CFDTMFDCTR46;                           /* CFDTMFDCTR46     */
    union __tag158 CFDTMDF0_46;                            /* CFDTMDF0_46      */
    union __tag158 CFDTMDF1_46;                            /* CFDTMDF1_46      */
    union __tag158 CFDTMDF2_46;                            /* CFDTMDF2_46      */
    union __tag158 CFDTMDF3_46;                            /* CFDTMDF3_46      */
    union __tag158 CFDTMDF4_46;                            /* CFDTMDF4_46      */
    union __tag158 CFDTMDF5_46;                            /* CFDTMDF5_46      */
    union __tag158 CFDTMDF6_46;                            /* CFDTMDF6_46      */
    union __tag158 CFDTMDF7_46;                            /* CFDTMDF7_46      */
    union __tag158 CFDTMDF8_46;                            /* CFDTMDF8_46      */
    union __tag158 CFDTMDF9_46;                            /* CFDTMDF9_46      */
    union __tag158 CFDTMDF10_46;                           /* CFDTMDF10_46     */
    union __tag158 CFDTMDF11_46;                           /* CFDTMDF11_46     */
    union __tag158 CFDTMDF12_46;                           /* CFDTMDF12_46     */
    union __tag158 CFDTMDF13_46;                           /* CFDTMDF13_46     */
    union __tag158 CFDTMDF14_46;                           /* CFDTMDF14_46     */
    union __tag158 CFDTMDF15_46;                           /* CFDTMDF15_46     */
    unsigned char  dummy311[52];                           /* Reserved         */
    union __tag158 CFDTMID47;                              /* CFDTMID47        */
    union __tag158 CFDTMPTR47;                             /* CFDTMPTR47       */
    union __tag158 CFDTMFDCTR47;                           /* CFDTMFDCTR47     */
    union __tag158 CFDTMDF0_47;                            /* CFDTMDF0_47      */
    union __tag158 CFDTMDF1_47;                            /* CFDTMDF1_47      */
    union __tag158 CFDTMDF2_47;                            /* CFDTMDF2_47      */
    union __tag158 CFDTMDF3_47;                            /* CFDTMDF3_47      */
    union __tag158 CFDTMDF4_47;                            /* CFDTMDF4_47      */
    union __tag158 CFDTMDF5_47;                            /* CFDTMDF5_47      */
    union __tag158 CFDTMDF6_47;                            /* CFDTMDF6_47      */
    union __tag158 CFDTMDF7_47;                            /* CFDTMDF7_47      */
    union __tag158 CFDTMDF8_47;                            /* CFDTMDF8_47      */
    union __tag158 CFDTMDF9_47;                            /* CFDTMDF9_47      */
    union __tag158 CFDTMDF10_47;                           /* CFDTMDF10_47     */
    union __tag158 CFDTMDF11_47;                           /* CFDTMDF11_47     */
    union __tag158 CFDTMDF12_47;                           /* CFDTMDF12_47     */
    union __tag158 CFDTMDF13_47;                           /* CFDTMDF13_47     */
    union __tag158 CFDTMDF14_47;                           /* CFDTMDF14_47     */
    union __tag158 CFDTMDF15_47;                           /* CFDTMDF15_47     */
    unsigned char  dummy312[52];                           /* Reserved         */
    union __tag158 CFDTMID48;                              /* CFDTMID48        */
    union __tag158 CFDTMPTR48;                             /* CFDTMPTR48       */
    union __tag158 CFDTMFDCTR48;                           /* CFDTMFDCTR48     */
    union __tag158 CFDTMDF0_48;                            /* CFDTMDF0_48      */
    union __tag158 CFDTMDF1_48;                            /* CFDTMDF1_48      */
    union __tag158 CFDTMDF2_48;                            /* CFDTMDF2_48      */
    union __tag158 CFDTMDF3_48;                            /* CFDTMDF3_48      */
    union __tag158 CFDTMDF4_48;                            /* CFDTMDF4_48      */
    union __tag158 CFDTMDF5_48;                            /* CFDTMDF5_48      */
    union __tag158 CFDTMDF6_48;                            /* CFDTMDF6_48      */
    union __tag158 CFDTMDF7_48;                            /* CFDTMDF7_48      */
    union __tag158 CFDTMDF8_48;                            /* CFDTMDF8_48      */
    union __tag158 CFDTMDF9_48;                            /* CFDTMDF9_48      */
    union __tag158 CFDTMDF10_48;                           /* CFDTMDF10_48     */
    union __tag158 CFDTMDF11_48;                           /* CFDTMDF11_48     */
    union __tag158 CFDTMDF12_48;                           /* CFDTMDF12_48     */
    union __tag158 CFDTMDF13_48;                           /* CFDTMDF13_48     */
    union __tag158 CFDTMDF14_48;                           /* CFDTMDF14_48     */
    union __tag158 CFDTMDF15_48;                           /* CFDTMDF15_48     */
    unsigned char  dummy313[52];                           /* Reserved         */
    union __tag158 CFDTMID49;                              /* CFDTMID49        */
    union __tag158 CFDTMPTR49;                             /* CFDTMPTR49       */
    union __tag158 CFDTMFDCTR49;                           /* CFDTMFDCTR49     */
    union __tag158 CFDTMDF0_49;                            /* CFDTMDF0_49      */
    union __tag158 CFDTMDF1_49;                            /* CFDTMDF1_49      */
    union __tag158 CFDTMDF2_49;                            /* CFDTMDF2_49      */
    union __tag158 CFDTMDF3_49;                            /* CFDTMDF3_49      */
    union __tag158 CFDTMDF4_49;                            /* CFDTMDF4_49      */
    union __tag158 CFDTMDF5_49;                            /* CFDTMDF5_49      */
    union __tag158 CFDTMDF6_49;                            /* CFDTMDF6_49      */
    union __tag158 CFDTMDF7_49;                            /* CFDTMDF7_49      */
    union __tag158 CFDTMDF8_49;                            /* CFDTMDF8_49      */
    union __tag158 CFDTMDF9_49;                            /* CFDTMDF9_49      */
    union __tag158 CFDTMDF10_49;                           /* CFDTMDF10_49     */
    union __tag158 CFDTMDF11_49;                           /* CFDTMDF11_49     */
    union __tag158 CFDTMDF12_49;                           /* CFDTMDF12_49     */
    union __tag158 CFDTMDF13_49;                           /* CFDTMDF13_49     */
    union __tag158 CFDTMDF14_49;                           /* CFDTMDF14_49     */
    union __tag158 CFDTMDF15_49;                           /* CFDTMDF15_49     */
    unsigned char  dummy314[52];                           /* Reserved         */
    union __tag158 CFDTMID50;                              /* CFDTMID50        */
    union __tag158 CFDTMPTR50;                             /* CFDTMPTR50       */
    union __tag158 CFDTMFDCTR50;                           /* CFDTMFDCTR50     */
    union __tag158 CFDTMDF0_50;                            /* CFDTMDF0_50      */
    union __tag158 CFDTMDF1_50;                            /* CFDTMDF1_50      */
    union __tag158 CFDTMDF2_50;                            /* CFDTMDF2_50      */
    union __tag158 CFDTMDF3_50;                            /* CFDTMDF3_50      */
    union __tag158 CFDTMDF4_50;                            /* CFDTMDF4_50      */
    union __tag158 CFDTMDF5_50;                            /* CFDTMDF5_50      */
    union __tag158 CFDTMDF6_50;                            /* CFDTMDF6_50      */
    union __tag158 CFDTMDF7_50;                            /* CFDTMDF7_50      */
    union __tag158 CFDTMDF8_50;                            /* CFDTMDF8_50      */
    union __tag158 CFDTMDF9_50;                            /* CFDTMDF9_50      */
    union __tag158 CFDTMDF10_50;                           /* CFDTMDF10_50     */
    union __tag158 CFDTMDF11_50;                           /* CFDTMDF11_50     */
    union __tag158 CFDTMDF12_50;                           /* CFDTMDF12_50     */
    union __tag158 CFDTMDF13_50;                           /* CFDTMDF13_50     */
    union __tag158 CFDTMDF14_50;                           /* CFDTMDF14_50     */
    union __tag158 CFDTMDF15_50;                           /* CFDTMDF15_50     */
    unsigned char  dummy315[52];                           /* Reserved         */
    union __tag158 CFDTMID51;                              /* CFDTMID51        */
    union __tag158 CFDTMPTR51;                             /* CFDTMPTR51       */
    union __tag158 CFDTMFDCTR51;                           /* CFDTMFDCTR51     */
    union __tag158 CFDTMDF0_51;                            /* CFDTMDF0_51      */
    union __tag158 CFDTMDF1_51;                            /* CFDTMDF1_51      */
    union __tag158 CFDTMDF2_51;                            /* CFDTMDF2_51      */
    union __tag158 CFDTMDF3_51;                            /* CFDTMDF3_51      */
    union __tag158 CFDTMDF4_51;                            /* CFDTMDF4_51      */
    union __tag158 CFDTMDF5_51;                            /* CFDTMDF5_51      */
    union __tag158 CFDTMDF6_51;                            /* CFDTMDF6_51      */
    union __tag158 CFDTMDF7_51;                            /* CFDTMDF7_51      */
    union __tag158 CFDTMDF8_51;                            /* CFDTMDF8_51      */
    union __tag158 CFDTMDF9_51;                            /* CFDTMDF9_51      */
    union __tag158 CFDTMDF10_51;                           /* CFDTMDF10_51     */
    union __tag158 CFDTMDF11_51;                           /* CFDTMDF11_51     */
    union __tag158 CFDTMDF12_51;                           /* CFDTMDF12_51     */
    union __tag158 CFDTMDF13_51;                           /* CFDTMDF13_51     */
    union __tag158 CFDTMDF14_51;                           /* CFDTMDF14_51     */
    union __tag158 CFDTMDF15_51;                           /* CFDTMDF15_51     */
    unsigned char  dummy316[52];                           /* Reserved         */
    union __tag158 CFDTMID52;                              /* CFDTMID52        */
    union __tag158 CFDTMPTR52;                             /* CFDTMPTR52       */
    union __tag158 CFDTMFDCTR52;                           /* CFDTMFDCTR52     */
    union __tag158 CFDTMDF0_52;                            /* CFDTMDF0_52      */
    union __tag158 CFDTMDF1_52;                            /* CFDTMDF1_52      */
    union __tag158 CFDTMDF2_52;                            /* CFDTMDF2_52      */
    union __tag158 CFDTMDF3_52;                            /* CFDTMDF3_52      */
    union __tag158 CFDTMDF4_52;                            /* CFDTMDF4_52      */
    union __tag158 CFDTMDF5_52;                            /* CFDTMDF5_52      */
    union __tag158 CFDTMDF6_52;                            /* CFDTMDF6_52      */
    union __tag158 CFDTMDF7_52;                            /* CFDTMDF7_52      */
    union __tag158 CFDTMDF8_52;                            /* CFDTMDF8_52      */
    union __tag158 CFDTMDF9_52;                            /* CFDTMDF9_52      */
    union __tag158 CFDTMDF10_52;                           /* CFDTMDF10_52     */
    union __tag158 CFDTMDF11_52;                           /* CFDTMDF11_52     */
    union __tag158 CFDTMDF12_52;                           /* CFDTMDF12_52     */
    union __tag158 CFDTMDF13_52;                           /* CFDTMDF13_52     */
    union __tag158 CFDTMDF14_52;                           /* CFDTMDF14_52     */
    union __tag158 CFDTMDF15_52;                           /* CFDTMDF15_52     */
    unsigned char  dummy317[52];                           /* Reserved         */
    union __tag158 CFDTMID53;                              /* CFDTMID53        */
    union __tag158 CFDTMPTR53;                             /* CFDTMPTR53       */
    union __tag158 CFDTMFDCTR53;                           /* CFDTMFDCTR53     */
    union __tag158 CFDTMDF0_53;                            /* CFDTMDF0_53      */
    union __tag158 CFDTMDF1_53;                            /* CFDTMDF1_53      */
    union __tag158 CFDTMDF2_53;                            /* CFDTMDF2_53      */
    union __tag158 CFDTMDF3_53;                            /* CFDTMDF3_53      */
    union __tag158 CFDTMDF4_53;                            /* CFDTMDF4_53      */
    union __tag158 CFDTMDF5_53;                            /* CFDTMDF5_53      */
    union __tag158 CFDTMDF6_53;                            /* CFDTMDF6_53      */
    union __tag158 CFDTMDF7_53;                            /* CFDTMDF7_53      */
    union __tag158 CFDTMDF8_53;                            /* CFDTMDF8_53      */
    union __tag158 CFDTMDF9_53;                            /* CFDTMDF9_53      */
    union __tag158 CFDTMDF10_53;                           /* CFDTMDF10_53     */
    union __tag158 CFDTMDF11_53;                           /* CFDTMDF11_53     */
    union __tag158 CFDTMDF12_53;                           /* CFDTMDF12_53     */
    union __tag158 CFDTMDF13_53;                           /* CFDTMDF13_53     */
    union __tag158 CFDTMDF14_53;                           /* CFDTMDF14_53     */
    union __tag158 CFDTMDF15_53;                           /* CFDTMDF15_53     */
    unsigned char  dummy318[52];                           /* Reserved         */
    union __tag158 CFDTMID54;                              /* CFDTMID54        */
    union __tag158 CFDTMPTR54;                             /* CFDTMPTR54       */
    union __tag158 CFDTMFDCTR54;                           /* CFDTMFDCTR54     */
    union __tag158 CFDTMDF0_54;                            /* CFDTMDF0_54      */
    union __tag158 CFDTMDF1_54;                            /* CFDTMDF1_54      */
    union __tag158 CFDTMDF2_54;                            /* CFDTMDF2_54      */
    union __tag158 CFDTMDF3_54;                            /* CFDTMDF3_54      */
    union __tag158 CFDTMDF4_54;                            /* CFDTMDF4_54      */
    union __tag158 CFDTMDF5_54;                            /* CFDTMDF5_54      */
    union __tag158 CFDTMDF6_54;                            /* CFDTMDF6_54      */
    union __tag158 CFDTMDF7_54;                            /* CFDTMDF7_54      */
    union __tag158 CFDTMDF8_54;                            /* CFDTMDF8_54      */
    union __tag158 CFDTMDF9_54;                            /* CFDTMDF9_54      */
    union __tag158 CFDTMDF10_54;                           /* CFDTMDF10_54     */
    union __tag158 CFDTMDF11_54;                           /* CFDTMDF11_54     */
    union __tag158 CFDTMDF12_54;                           /* CFDTMDF12_54     */
    union __tag158 CFDTMDF13_54;                           /* CFDTMDF13_54     */
    union __tag158 CFDTMDF14_54;                           /* CFDTMDF14_54     */
    union __tag158 CFDTMDF15_54;                           /* CFDTMDF15_54     */
    unsigned char  dummy319[52];                           /* Reserved         */
    union __tag158 CFDTMID55;                              /* CFDTMID55        */
    union __tag158 CFDTMPTR55;                             /* CFDTMPTR55       */
    union __tag158 CFDTMFDCTR55;                           /* CFDTMFDCTR55     */
    union __tag158 CFDTMDF0_55;                            /* CFDTMDF0_55      */
    union __tag158 CFDTMDF1_55;                            /* CFDTMDF1_55      */
    union __tag158 CFDTMDF2_55;                            /* CFDTMDF2_55      */
    union __tag158 CFDTMDF3_55;                            /* CFDTMDF3_55      */
    union __tag158 CFDTMDF4_55;                            /* CFDTMDF4_55      */
    union __tag158 CFDTMDF5_55;                            /* CFDTMDF5_55      */
    union __tag158 CFDTMDF6_55;                            /* CFDTMDF6_55      */
    union __tag158 CFDTMDF7_55;                            /* CFDTMDF7_55      */
    union __tag158 CFDTMDF8_55;                            /* CFDTMDF8_55      */
    union __tag158 CFDTMDF9_55;                            /* CFDTMDF9_55      */
    union __tag158 CFDTMDF10_55;                           /* CFDTMDF10_55     */
    union __tag158 CFDTMDF11_55;                           /* CFDTMDF11_55     */
    union __tag158 CFDTMDF12_55;                           /* CFDTMDF12_55     */
    union __tag158 CFDTMDF13_55;                           /* CFDTMDF13_55     */
    union __tag158 CFDTMDF14_55;                           /* CFDTMDF14_55     */
    union __tag158 CFDTMDF15_55;                           /* CFDTMDF15_55     */
    unsigned char  dummy320[52];                           /* Reserved         */
    union __tag158 CFDTMID56;                              /* CFDTMID56        */
    union __tag158 CFDTMPTR56;                             /* CFDTMPTR56       */
    union __tag158 CFDTMFDCTR56;                           /* CFDTMFDCTR56     */
    union __tag158 CFDTMDF0_56;                            /* CFDTMDF0_56      */
    union __tag158 CFDTMDF1_56;                            /* CFDTMDF1_56      */
    union __tag158 CFDTMDF2_56;                            /* CFDTMDF2_56      */
    union __tag158 CFDTMDF3_56;                            /* CFDTMDF3_56      */
    union __tag158 CFDTMDF4_56;                            /* CFDTMDF4_56      */
    union __tag158 CFDTMDF5_56;                            /* CFDTMDF5_56      */
    union __tag158 CFDTMDF6_56;                            /* CFDTMDF6_56      */
    union __tag158 CFDTMDF7_56;                            /* CFDTMDF7_56      */
    union __tag158 CFDTMDF8_56;                            /* CFDTMDF8_56      */
    union __tag158 CFDTMDF9_56;                            /* CFDTMDF9_56      */
    union __tag158 CFDTMDF10_56;                           /* CFDTMDF10_56     */
    union __tag158 CFDTMDF11_56;                           /* CFDTMDF11_56     */
    union __tag158 CFDTMDF12_56;                           /* CFDTMDF12_56     */
    union __tag158 CFDTMDF13_56;                           /* CFDTMDF13_56     */
    union __tag158 CFDTMDF14_56;                           /* CFDTMDF14_56     */
    union __tag158 CFDTMDF15_56;                           /* CFDTMDF15_56     */
    unsigned char  dummy321[52];                           /* Reserved         */
    union __tag158 CFDTMID57;                              /* CFDTMID57        */
    union __tag158 CFDTMPTR57;                             /* CFDTMPTR57       */
    union __tag158 CFDTMFDCTR57;                           /* CFDTMFDCTR57     */
    union __tag158 CFDTMDF0_57;                            /* CFDTMDF0_57      */
    union __tag158 CFDTMDF1_57;                            /* CFDTMDF1_57      */
    union __tag158 CFDTMDF2_57;                            /* CFDTMDF2_57      */
    union __tag158 CFDTMDF3_57;                            /* CFDTMDF3_57      */
    union __tag158 CFDTMDF4_57;                            /* CFDTMDF4_57      */
    union __tag158 CFDTMDF5_57;                            /* CFDTMDF5_57      */
    union __tag158 CFDTMDF6_57;                            /* CFDTMDF6_57      */
    union __tag158 CFDTMDF7_57;                            /* CFDTMDF7_57      */
    union __tag158 CFDTMDF8_57;                            /* CFDTMDF8_57      */
    union __tag158 CFDTMDF9_57;                            /* CFDTMDF9_57      */
    union __tag158 CFDTMDF10_57;                           /* CFDTMDF10_57     */
    union __tag158 CFDTMDF11_57;                           /* CFDTMDF11_57     */
    union __tag158 CFDTMDF12_57;                           /* CFDTMDF12_57     */
    union __tag158 CFDTMDF13_57;                           /* CFDTMDF13_57     */
    union __tag158 CFDTMDF14_57;                           /* CFDTMDF14_57     */
    union __tag158 CFDTMDF15_57;                           /* CFDTMDF15_57     */
    unsigned char  dummy322[52];                           /* Reserved         */
    union __tag158 CFDTMID58;                              /* CFDTMID58        */
    union __tag158 CFDTMPTR58;                             /* CFDTMPTR58       */
    union __tag158 CFDTMFDCTR58;                           /* CFDTMFDCTR58     */
    union __tag158 CFDTMDF0_58;                            /* CFDTMDF0_58      */
    union __tag158 CFDTMDF1_58;                            /* CFDTMDF1_58      */
    union __tag158 CFDTMDF2_58;                            /* CFDTMDF2_58      */
    union __tag158 CFDTMDF3_58;                            /* CFDTMDF3_58      */
    union __tag158 CFDTMDF4_58;                            /* CFDTMDF4_58      */
    union __tag158 CFDTMDF5_58;                            /* CFDTMDF5_58      */
    union __tag158 CFDTMDF6_58;                            /* CFDTMDF6_58      */
    union __tag158 CFDTMDF7_58;                            /* CFDTMDF7_58      */
    union __tag158 CFDTMDF8_58;                            /* CFDTMDF8_58      */
    union __tag158 CFDTMDF9_58;                            /* CFDTMDF9_58      */
    union __tag158 CFDTMDF10_58;                           /* CFDTMDF10_58     */
    union __tag158 CFDTMDF11_58;                           /* CFDTMDF11_58     */
    union __tag158 CFDTMDF12_58;                           /* CFDTMDF12_58     */
    union __tag158 CFDTMDF13_58;                           /* CFDTMDF13_58     */
    union __tag158 CFDTMDF14_58;                           /* CFDTMDF14_58     */
    union __tag158 CFDTMDF15_58;                           /* CFDTMDF15_58     */
    unsigned char  dummy323[52];                           /* Reserved         */
    union __tag158 CFDTMID59;                              /* CFDTMID59        */
    union __tag158 CFDTMPTR59;                             /* CFDTMPTR59       */
    union __tag158 CFDTMFDCTR59;                           /* CFDTMFDCTR59     */
    union __tag158 CFDTMDF0_59;                            /* CFDTMDF0_59      */
    union __tag158 CFDTMDF1_59;                            /* CFDTMDF1_59      */
    union __tag158 CFDTMDF2_59;                            /* CFDTMDF2_59      */
    union __tag158 CFDTMDF3_59;                            /* CFDTMDF3_59      */
    union __tag158 CFDTMDF4_59;                            /* CFDTMDF4_59      */
    union __tag158 CFDTMDF5_59;                            /* CFDTMDF5_59      */
    union __tag158 CFDTMDF6_59;                            /* CFDTMDF6_59      */
    union __tag158 CFDTMDF7_59;                            /* CFDTMDF7_59      */
    union __tag158 CFDTMDF8_59;                            /* CFDTMDF8_59      */
    union __tag158 CFDTMDF9_59;                            /* CFDTMDF9_59      */
    union __tag158 CFDTMDF10_59;                           /* CFDTMDF10_59     */
    union __tag158 CFDTMDF11_59;                           /* CFDTMDF11_59     */
    union __tag158 CFDTMDF12_59;                           /* CFDTMDF12_59     */
    union __tag158 CFDTMDF13_59;                           /* CFDTMDF13_59     */
    union __tag158 CFDTMDF14_59;                           /* CFDTMDF14_59     */
    union __tag158 CFDTMDF15_59;                           /* CFDTMDF15_59     */
    unsigned char  dummy324[52];                           /* Reserved         */
    union __tag158 CFDTMID60;                              /* CFDTMID60        */
    union __tag158 CFDTMPTR60;                             /* CFDTMPTR60       */
    union __tag158 CFDTMFDCTR60;                           /* CFDTMFDCTR60     */
    union __tag158 CFDTMDF0_60;                            /* CFDTMDF0_60      */
    union __tag158 CFDTMDF1_60;                            /* CFDTMDF1_60      */
    union __tag158 CFDTMDF2_60;                            /* CFDTMDF2_60      */
    union __tag158 CFDTMDF3_60;                            /* CFDTMDF3_60      */
    union __tag158 CFDTMDF4_60;                            /* CFDTMDF4_60      */
    union __tag158 CFDTMDF5_60;                            /* CFDTMDF5_60      */
    union __tag158 CFDTMDF6_60;                            /* CFDTMDF6_60      */
    union __tag158 CFDTMDF7_60;                            /* CFDTMDF7_60      */
    union __tag158 CFDTMDF8_60;                            /* CFDTMDF8_60      */
    union __tag158 CFDTMDF9_60;                            /* CFDTMDF9_60      */
    union __tag158 CFDTMDF10_60;                           /* CFDTMDF10_60     */
    union __tag158 CFDTMDF11_60;                           /* CFDTMDF11_60     */
    union __tag158 CFDTMDF12_60;                           /* CFDTMDF12_60     */
    union __tag158 CFDTMDF13_60;                           /* CFDTMDF13_60     */
    union __tag158 CFDTMDF14_60;                           /* CFDTMDF14_60     */
    union __tag158 CFDTMDF15_60;                           /* CFDTMDF15_60     */
    unsigned char  dummy325[52];                           /* Reserved         */
    union __tag158 CFDTMID61;                              /* CFDTMID61        */
    union __tag158 CFDTMPTR61;                             /* CFDTMPTR61       */
    union __tag158 CFDTMFDCTR61;                           /* CFDTMFDCTR61     */
    union __tag158 CFDTMDF0_61;                            /* CFDTMDF0_61      */
    union __tag158 CFDTMDF1_61;                            /* CFDTMDF1_61      */
    union __tag158 CFDTMDF2_61;                            /* CFDTMDF2_61      */
    union __tag158 CFDTMDF3_61;                            /* CFDTMDF3_61      */
    union __tag158 CFDTMDF4_61;                            /* CFDTMDF4_61      */
    union __tag158 CFDTMDF5_61;                            /* CFDTMDF5_61      */
    union __tag158 CFDTMDF6_61;                            /* CFDTMDF6_61      */
    union __tag158 CFDTMDF7_61;                            /* CFDTMDF7_61      */
    union __tag158 CFDTMDF8_61;                            /* CFDTMDF8_61      */
    union __tag158 CFDTMDF9_61;                            /* CFDTMDF9_61      */
    union __tag158 CFDTMDF10_61;                           /* CFDTMDF10_61     */
    union __tag158 CFDTMDF11_61;                           /* CFDTMDF11_61     */
    union __tag158 CFDTMDF12_61;                           /* CFDTMDF12_61     */
    union __tag158 CFDTMDF13_61;                           /* CFDTMDF13_61     */
    union __tag158 CFDTMDF14_61;                           /* CFDTMDF14_61     */
    union __tag158 CFDTMDF15_61;                           /* CFDTMDF15_61     */
    unsigned char  dummy326[52];                           /* Reserved         */
    union __tag158 CFDTMID62;                              /* CFDTMID62        */
    union __tag158 CFDTMPTR62;                             /* CFDTMPTR62       */
    union __tag158 CFDTMFDCTR62;                           /* CFDTMFDCTR62     */
    union __tag158 CFDTMDF0_62;                            /* CFDTMDF0_62      */
    union __tag158 CFDTMDF1_62;                            /* CFDTMDF1_62      */
    union __tag158 CFDTMDF2_62;                            /* CFDTMDF2_62      */
    union __tag158 CFDTMDF3_62;                            /* CFDTMDF3_62      */
    union __tag158 CFDTMDF4_62;                            /* CFDTMDF4_62      */
    union __tag158 CFDTMDF5_62;                            /* CFDTMDF5_62      */
    union __tag158 CFDTMDF6_62;                            /* CFDTMDF6_62      */
    union __tag158 CFDTMDF7_62;                            /* CFDTMDF7_62      */
    union __tag158 CFDTMDF8_62;                            /* CFDTMDF8_62      */
    union __tag158 CFDTMDF9_62;                            /* CFDTMDF9_62      */
    union __tag158 CFDTMDF10_62;                           /* CFDTMDF10_62     */
    union __tag158 CFDTMDF11_62;                           /* CFDTMDF11_62     */
    union __tag158 CFDTMDF12_62;                           /* CFDTMDF12_62     */
    union __tag158 CFDTMDF13_62;                           /* CFDTMDF13_62     */
    union __tag158 CFDTMDF14_62;                           /* CFDTMDF14_62     */
    union __tag158 CFDTMDF15_62;                           /* CFDTMDF15_62     */
    unsigned char  dummy327[52];                           /* Reserved         */
    union __tag158 CFDTMID63;                              /* CFDTMID63        */
    union __tag158 CFDTMPTR63;                             /* CFDTMPTR63       */
    union __tag158 CFDTMFDCTR63;                           /* CFDTMFDCTR63     */
    union __tag158 CFDTMDF0_63;                            /* CFDTMDF0_63      */
    union __tag158 CFDTMDF1_63;                            /* CFDTMDF1_63      */
    union __tag158 CFDTMDF2_63;                            /* CFDTMDF2_63      */
    union __tag158 CFDTMDF3_63;                            /* CFDTMDF3_63      */
    union __tag158 CFDTMDF4_63;                            /* CFDTMDF4_63      */
    union __tag158 CFDTMDF5_63;                            /* CFDTMDF5_63      */
    union __tag158 CFDTMDF6_63;                            /* CFDTMDF6_63      */
    union __tag158 CFDTMDF7_63;                            /* CFDTMDF7_63      */
    union __tag158 CFDTMDF8_63;                            /* CFDTMDF8_63      */
    union __tag158 CFDTMDF9_63;                            /* CFDTMDF9_63      */
    union __tag158 CFDTMDF10_63;                           /* CFDTMDF10_63     */
    union __tag158 CFDTMDF11_63;                           /* CFDTMDF11_63     */
    union __tag158 CFDTMDF12_63;                           /* CFDTMDF12_63     */
    union __tag158 CFDTMDF13_63;                           /* CFDTMDF13_63     */
    union __tag158 CFDTMDF14_63;                           /* CFDTMDF14_63     */
    union __tag158 CFDTMDF15_63;                           /* CFDTMDF15_63     */
    unsigned char  dummy328[52];                           /* Reserved         */
    union __tag158 CFDTMID64;                              /* CFDTMID64        */
    union __tag158 CFDTMPTR64;                             /* CFDTMPTR64       */
    union __tag158 CFDTMFDCTR64;                           /* CFDTMFDCTR64     */
    union __tag158 CFDTMDF0_64;                            /* CFDTMDF0_64      */
    union __tag158 CFDTMDF1_64;                            /* CFDTMDF1_64      */
    union __tag158 CFDTMDF2_64;                            /* CFDTMDF2_64      */
    union __tag158 CFDTMDF3_64;                            /* CFDTMDF3_64      */
    union __tag158 CFDTMDF4_64;                            /* CFDTMDF4_64      */
    union __tag158 CFDTMDF5_64;                            /* CFDTMDF5_64      */
    union __tag158 CFDTMDF6_64;                            /* CFDTMDF6_64      */
    union __tag158 CFDTMDF7_64;                            /* CFDTMDF7_64      */
    union __tag158 CFDTMDF8_64;                            /* CFDTMDF8_64      */
    union __tag158 CFDTMDF9_64;                            /* CFDTMDF9_64      */
    union __tag158 CFDTMDF10_64;                           /* CFDTMDF10_64     */
    union __tag158 CFDTMDF11_64;                           /* CFDTMDF11_64     */
    union __tag158 CFDTMDF12_64;                           /* CFDTMDF12_64     */
    union __tag158 CFDTMDF13_64;                           /* CFDTMDF13_64     */
    union __tag158 CFDTMDF14_64;                           /* CFDTMDF14_64     */
    union __tag158 CFDTMDF15_64;                           /* CFDTMDF15_64     */
    unsigned char  dummy329[52];                           /* Reserved         */
    union __tag158 CFDTMID65;                              /* CFDTMID65        */
    union __tag158 CFDTMPTR65;                             /* CFDTMPTR65       */
    union __tag158 CFDTMFDCTR65;                           /* CFDTMFDCTR65     */
    union __tag158 CFDTMDF0_65;                            /* CFDTMDF0_65      */
    union __tag158 CFDTMDF1_65;                            /* CFDTMDF1_65      */
    union __tag158 CFDTMDF2_65;                            /* CFDTMDF2_65      */
    union __tag158 CFDTMDF3_65;                            /* CFDTMDF3_65      */
    union __tag158 CFDTMDF4_65;                            /* CFDTMDF4_65      */
    union __tag158 CFDTMDF5_65;                            /* CFDTMDF5_65      */
    union __tag158 CFDTMDF6_65;                            /* CFDTMDF6_65      */
    union __tag158 CFDTMDF7_65;                            /* CFDTMDF7_65      */
    union __tag158 CFDTMDF8_65;                            /* CFDTMDF8_65      */
    union __tag158 CFDTMDF9_65;                            /* CFDTMDF9_65      */
    union __tag158 CFDTMDF10_65;                           /* CFDTMDF10_65     */
    union __tag158 CFDTMDF11_65;                           /* CFDTMDF11_65     */
    union __tag158 CFDTMDF12_65;                           /* CFDTMDF12_65     */
    union __tag158 CFDTMDF13_65;                           /* CFDTMDF13_65     */
    union __tag158 CFDTMDF14_65;                           /* CFDTMDF14_65     */
    union __tag158 CFDTMDF15_65;                           /* CFDTMDF15_65     */
    unsigned char  dummy330[52];                           /* Reserved         */
    union __tag158 CFDTMID66;                              /* CFDTMID66        */
    union __tag158 CFDTMPTR66;                             /* CFDTMPTR66       */
    union __tag158 CFDTMFDCTR66;                           /* CFDTMFDCTR66     */
    union __tag158 CFDTMDF0_66;                            /* CFDTMDF0_66      */
    union __tag158 CFDTMDF1_66;                            /* CFDTMDF1_66      */
    union __tag158 CFDTMDF2_66;                            /* CFDTMDF2_66      */
    union __tag158 CFDTMDF3_66;                            /* CFDTMDF3_66      */
    union __tag158 CFDTMDF4_66;                            /* CFDTMDF4_66      */
    union __tag158 CFDTMDF5_66;                            /* CFDTMDF5_66      */
    union __tag158 CFDTMDF6_66;                            /* CFDTMDF6_66      */
    union __tag158 CFDTMDF7_66;                            /* CFDTMDF7_66      */
    union __tag158 CFDTMDF8_66;                            /* CFDTMDF8_66      */
    union __tag158 CFDTMDF9_66;                            /* CFDTMDF9_66      */
    union __tag158 CFDTMDF10_66;                           /* CFDTMDF10_66     */
    union __tag158 CFDTMDF11_66;                           /* CFDTMDF11_66     */
    union __tag158 CFDTMDF12_66;                           /* CFDTMDF12_66     */
    union __tag158 CFDTMDF13_66;                           /* CFDTMDF13_66     */
    union __tag158 CFDTMDF14_66;                           /* CFDTMDF14_66     */
    union __tag158 CFDTMDF15_66;                           /* CFDTMDF15_66     */
    unsigned char  dummy331[52];                           /* Reserved         */
    union __tag158 CFDTMID67;                              /* CFDTMID67        */
    union __tag158 CFDTMPTR67;                             /* CFDTMPTR67       */
    union __tag158 CFDTMFDCTR67;                           /* CFDTMFDCTR67     */
    union __tag158 CFDTMDF0_67;                            /* CFDTMDF0_67      */
    union __tag158 CFDTMDF1_67;                            /* CFDTMDF1_67      */
    union __tag158 CFDTMDF2_67;                            /* CFDTMDF2_67      */
    union __tag158 CFDTMDF3_67;                            /* CFDTMDF3_67      */
    union __tag158 CFDTMDF4_67;                            /* CFDTMDF4_67      */
    union __tag158 CFDTMDF5_67;                            /* CFDTMDF5_67      */
    union __tag158 CFDTMDF6_67;                            /* CFDTMDF6_67      */
    union __tag158 CFDTMDF7_67;                            /* CFDTMDF7_67      */
    union __tag158 CFDTMDF8_67;                            /* CFDTMDF8_67      */
    union __tag158 CFDTMDF9_67;                            /* CFDTMDF9_67      */
    union __tag158 CFDTMDF10_67;                           /* CFDTMDF10_67     */
    union __tag158 CFDTMDF11_67;                           /* CFDTMDF11_67     */
    union __tag158 CFDTMDF12_67;                           /* CFDTMDF12_67     */
    union __tag158 CFDTMDF13_67;                           /* CFDTMDF13_67     */
    union __tag158 CFDTMDF14_67;                           /* CFDTMDF14_67     */
    union __tag158 CFDTMDF15_67;                           /* CFDTMDF15_67     */
    unsigned char  dummy332[52];                           /* Reserved         */
    union __tag158 CFDTMID68;                              /* CFDTMID68        */
    union __tag158 CFDTMPTR68;                             /* CFDTMPTR68       */
    union __tag158 CFDTMFDCTR68;                           /* CFDTMFDCTR68     */
    union __tag158 CFDTMDF0_68;                            /* CFDTMDF0_68      */
    union __tag158 CFDTMDF1_68;                            /* CFDTMDF1_68      */
    union __tag158 CFDTMDF2_68;                            /* CFDTMDF2_68      */
    union __tag158 CFDTMDF3_68;                            /* CFDTMDF3_68      */
    union __tag158 CFDTMDF4_68;                            /* CFDTMDF4_68      */
    union __tag158 CFDTMDF5_68;                            /* CFDTMDF5_68      */
    union __tag158 CFDTMDF6_68;                            /* CFDTMDF6_68      */
    union __tag158 CFDTMDF7_68;                            /* CFDTMDF7_68      */
    union __tag158 CFDTMDF8_68;                            /* CFDTMDF8_68      */
    union __tag158 CFDTMDF9_68;                            /* CFDTMDF9_68      */
    union __tag158 CFDTMDF10_68;                           /* CFDTMDF10_68     */
    union __tag158 CFDTMDF11_68;                           /* CFDTMDF11_68     */
    union __tag158 CFDTMDF12_68;                           /* CFDTMDF12_68     */
    union __tag158 CFDTMDF13_68;                           /* CFDTMDF13_68     */
    union __tag158 CFDTMDF14_68;                           /* CFDTMDF14_68     */
    union __tag158 CFDTMDF15_68;                           /* CFDTMDF15_68     */
    unsigned char  dummy333[52];                           /* Reserved         */
    union __tag158 CFDTMID69;                              /* CFDTMID69        */
    union __tag158 CFDTMPTR69;                             /* CFDTMPTR69       */
    union __tag158 CFDTMFDCTR69;                           /* CFDTMFDCTR69     */
    union __tag158 CFDTMDF0_69;                            /* CFDTMDF0_69      */
    union __tag158 CFDTMDF1_69;                            /* CFDTMDF1_69      */
    union __tag158 CFDTMDF2_69;                            /* CFDTMDF2_69      */
    union __tag158 CFDTMDF3_69;                            /* CFDTMDF3_69      */
    union __tag158 CFDTMDF4_69;                            /* CFDTMDF4_69      */
    union __tag158 CFDTMDF5_69;                            /* CFDTMDF5_69      */
    union __tag158 CFDTMDF6_69;                            /* CFDTMDF6_69      */
    union __tag158 CFDTMDF7_69;                            /* CFDTMDF7_69      */
    union __tag158 CFDTMDF8_69;                            /* CFDTMDF8_69      */
    union __tag158 CFDTMDF9_69;                            /* CFDTMDF9_69      */
    union __tag158 CFDTMDF10_69;                           /* CFDTMDF10_69     */
    union __tag158 CFDTMDF11_69;                           /* CFDTMDF11_69     */
    union __tag158 CFDTMDF12_69;                           /* CFDTMDF12_69     */
    union __tag158 CFDTMDF13_69;                           /* CFDTMDF13_69     */
    union __tag158 CFDTMDF14_69;                           /* CFDTMDF14_69     */
    union __tag158 CFDTMDF15_69;                           /* CFDTMDF15_69     */
    unsigned char  dummy334[52];                           /* Reserved         */
    union __tag158 CFDTMID70;                              /* CFDTMID70        */
    union __tag158 CFDTMPTR70;                             /* CFDTMPTR70       */
    union __tag158 CFDTMFDCTR70;                           /* CFDTMFDCTR70     */
    union __tag158 CFDTMDF0_70;                            /* CFDTMDF0_70      */
    union __tag158 CFDTMDF1_70;                            /* CFDTMDF1_70      */
    union __tag158 CFDTMDF2_70;                            /* CFDTMDF2_70      */
    union __tag158 CFDTMDF3_70;                            /* CFDTMDF3_70      */
    union __tag158 CFDTMDF4_70;                            /* CFDTMDF4_70      */
    union __tag158 CFDTMDF5_70;                            /* CFDTMDF5_70      */
    union __tag158 CFDTMDF6_70;                            /* CFDTMDF6_70      */
    union __tag158 CFDTMDF7_70;                            /* CFDTMDF7_70      */
    union __tag158 CFDTMDF8_70;                            /* CFDTMDF8_70      */
    union __tag158 CFDTMDF9_70;                            /* CFDTMDF9_70      */
    union __tag158 CFDTMDF10_70;                           /* CFDTMDF10_70     */
    union __tag158 CFDTMDF11_70;                           /* CFDTMDF11_70     */
    union __tag158 CFDTMDF12_70;                           /* CFDTMDF12_70     */
    union __tag158 CFDTMDF13_70;                           /* CFDTMDF13_70     */
    union __tag158 CFDTMDF14_70;                           /* CFDTMDF14_70     */
    union __tag158 CFDTMDF15_70;                           /* CFDTMDF15_70     */
    unsigned char  dummy335[52];                           /* Reserved         */
    union __tag158 CFDTMID71;                              /* CFDTMID71        */
    union __tag158 CFDTMPTR71;                             /* CFDTMPTR71       */
    union __tag158 CFDTMFDCTR71;                           /* CFDTMFDCTR71     */
    union __tag158 CFDTMDF0_71;                            /* CFDTMDF0_71      */
    union __tag158 CFDTMDF1_71;                            /* CFDTMDF1_71      */
    union __tag158 CFDTMDF2_71;                            /* CFDTMDF2_71      */
    union __tag158 CFDTMDF3_71;                            /* CFDTMDF3_71      */
    union __tag158 CFDTMDF4_71;                            /* CFDTMDF4_71      */
    union __tag158 CFDTMDF5_71;                            /* CFDTMDF5_71      */
    union __tag158 CFDTMDF6_71;                            /* CFDTMDF6_71      */
    union __tag158 CFDTMDF7_71;                            /* CFDTMDF7_71      */
    union __tag158 CFDTMDF8_71;                            /* CFDTMDF8_71      */
    union __tag158 CFDTMDF9_71;                            /* CFDTMDF9_71      */
    union __tag158 CFDTMDF10_71;                           /* CFDTMDF10_71     */
    union __tag158 CFDTMDF11_71;                           /* CFDTMDF11_71     */
    union __tag158 CFDTMDF12_71;                           /* CFDTMDF12_71     */
    union __tag158 CFDTMDF13_71;                           /* CFDTMDF13_71     */
    union __tag158 CFDTMDF14_71;                           /* CFDTMDF14_71     */
    union __tag158 CFDTMDF15_71;                           /* CFDTMDF15_71     */
    unsigned char  dummy336[52];                           /* Reserved         */
    union __tag158 CFDTMID72;                              /* CFDTMID72        */
    union __tag158 CFDTMPTR72;                             /* CFDTMPTR72       */
    union __tag158 CFDTMFDCTR72;                           /* CFDTMFDCTR72     */
    union __tag158 CFDTMDF0_72;                            /* CFDTMDF0_72      */
    union __tag158 CFDTMDF1_72;                            /* CFDTMDF1_72      */
    union __tag158 CFDTMDF2_72;                            /* CFDTMDF2_72      */
    union __tag158 CFDTMDF3_72;                            /* CFDTMDF3_72      */
    union __tag158 CFDTMDF4_72;                            /* CFDTMDF4_72      */
    union __tag158 CFDTMDF5_72;                            /* CFDTMDF5_72      */
    union __tag158 CFDTMDF6_72;                            /* CFDTMDF6_72      */
    union __tag158 CFDTMDF7_72;                            /* CFDTMDF7_72      */
    union __tag158 CFDTMDF8_72;                            /* CFDTMDF8_72      */
    union __tag158 CFDTMDF9_72;                            /* CFDTMDF9_72      */
    union __tag158 CFDTMDF10_72;                           /* CFDTMDF10_72     */
    union __tag158 CFDTMDF11_72;                           /* CFDTMDF11_72     */
    union __tag158 CFDTMDF12_72;                           /* CFDTMDF12_72     */
    union __tag158 CFDTMDF13_72;                           /* CFDTMDF13_72     */
    union __tag158 CFDTMDF14_72;                           /* CFDTMDF14_72     */
    union __tag158 CFDTMDF15_72;                           /* CFDTMDF15_72     */
    unsigned char  dummy337[52];                           /* Reserved         */
    union __tag158 CFDTMID73;                              /* CFDTMID73        */
    union __tag158 CFDTMPTR73;                             /* CFDTMPTR73       */
    union __tag158 CFDTMFDCTR73;                           /* CFDTMFDCTR73     */
    union __tag158 CFDTMDF0_73;                            /* CFDTMDF0_73      */
    union __tag158 CFDTMDF1_73;                            /* CFDTMDF1_73      */
    union __tag158 CFDTMDF2_73;                            /* CFDTMDF2_73      */
    union __tag158 CFDTMDF3_73;                            /* CFDTMDF3_73      */
    union __tag158 CFDTMDF4_73;                            /* CFDTMDF4_73      */
    union __tag158 CFDTMDF5_73;                            /* CFDTMDF5_73      */
    union __tag158 CFDTMDF6_73;                            /* CFDTMDF6_73      */
    union __tag158 CFDTMDF7_73;                            /* CFDTMDF7_73      */
    union __tag158 CFDTMDF8_73;                            /* CFDTMDF8_73      */
    union __tag158 CFDTMDF9_73;                            /* CFDTMDF9_73      */
    union __tag158 CFDTMDF10_73;                           /* CFDTMDF10_73     */
    union __tag158 CFDTMDF11_73;                           /* CFDTMDF11_73     */
    union __tag158 CFDTMDF12_73;                           /* CFDTMDF12_73     */
    union __tag158 CFDTMDF13_73;                           /* CFDTMDF13_73     */
    union __tag158 CFDTMDF14_73;                           /* CFDTMDF14_73     */
    union __tag158 CFDTMDF15_73;                           /* CFDTMDF15_73     */
    unsigned char  dummy338[52];                           /* Reserved         */
    union __tag158 CFDTMID74;                              /* CFDTMID74        */
    union __tag158 CFDTMPTR74;                             /* CFDTMPTR74       */
    union __tag158 CFDTMFDCTR74;                           /* CFDTMFDCTR74     */
    union __tag158 CFDTMDF0_74;                            /* CFDTMDF0_74      */
    union __tag158 CFDTMDF1_74;                            /* CFDTMDF1_74      */
    union __tag158 CFDTMDF2_74;                            /* CFDTMDF2_74      */
    union __tag158 CFDTMDF3_74;                            /* CFDTMDF3_74      */
    union __tag158 CFDTMDF4_74;                            /* CFDTMDF4_74      */
    union __tag158 CFDTMDF5_74;                            /* CFDTMDF5_74      */
    union __tag158 CFDTMDF6_74;                            /* CFDTMDF6_74      */
    union __tag158 CFDTMDF7_74;                            /* CFDTMDF7_74      */
    union __tag158 CFDTMDF8_74;                            /* CFDTMDF8_74      */
    union __tag158 CFDTMDF9_74;                            /* CFDTMDF9_74      */
    union __tag158 CFDTMDF10_74;                           /* CFDTMDF10_74     */
    union __tag158 CFDTMDF11_74;                           /* CFDTMDF11_74     */
    union __tag158 CFDTMDF12_74;                           /* CFDTMDF12_74     */
    union __tag158 CFDTMDF13_74;                           /* CFDTMDF13_74     */
    union __tag158 CFDTMDF14_74;                           /* CFDTMDF14_74     */
    union __tag158 CFDTMDF15_74;                           /* CFDTMDF15_74     */
    unsigned char  dummy339[52];                           /* Reserved         */
    union __tag158 CFDTMID75;                              /* CFDTMID75        */
    union __tag158 CFDTMPTR75;                             /* CFDTMPTR75       */
    union __tag158 CFDTMFDCTR75;                           /* CFDTMFDCTR75     */
    union __tag158 CFDTMDF0_75;                            /* CFDTMDF0_75      */
    union __tag158 CFDTMDF1_75;                            /* CFDTMDF1_75      */
    union __tag158 CFDTMDF2_75;                            /* CFDTMDF2_75      */
    union __tag158 CFDTMDF3_75;                            /* CFDTMDF3_75      */
    union __tag158 CFDTMDF4_75;                            /* CFDTMDF4_75      */
    union __tag158 CFDTMDF5_75;                            /* CFDTMDF5_75      */
    union __tag158 CFDTMDF6_75;                            /* CFDTMDF6_75      */
    union __tag158 CFDTMDF7_75;                            /* CFDTMDF7_75      */
    union __tag158 CFDTMDF8_75;                            /* CFDTMDF8_75      */
    union __tag158 CFDTMDF9_75;                            /* CFDTMDF9_75      */
    union __tag158 CFDTMDF10_75;                           /* CFDTMDF10_75     */
    union __tag158 CFDTMDF11_75;                           /* CFDTMDF11_75     */
    union __tag158 CFDTMDF12_75;                           /* CFDTMDF12_75     */
    union __tag158 CFDTMDF13_75;                           /* CFDTMDF13_75     */
    union __tag158 CFDTMDF14_75;                           /* CFDTMDF14_75     */
    union __tag158 CFDTMDF15_75;                           /* CFDTMDF15_75     */
    unsigned char  dummy340[52];                           /* Reserved         */
    union __tag158 CFDTMID76;                              /* CFDTMID76        */
    union __tag158 CFDTMPTR76;                             /* CFDTMPTR76       */
    union __tag158 CFDTMFDCTR76;                           /* CFDTMFDCTR76     */
    union __tag158 CFDTMDF0_76;                            /* CFDTMDF0_76      */
    union __tag158 CFDTMDF1_76;                            /* CFDTMDF1_76      */
    union __tag158 CFDTMDF2_76;                            /* CFDTMDF2_76      */
    union __tag158 CFDTMDF3_76;                            /* CFDTMDF3_76      */
    union __tag158 CFDTMDF4_76;                            /* CFDTMDF4_76      */
    union __tag158 CFDTMDF5_76;                            /* CFDTMDF5_76      */
    union __tag158 CFDTMDF6_76;                            /* CFDTMDF6_76      */
    union __tag158 CFDTMDF7_76;                            /* CFDTMDF7_76      */
    union __tag158 CFDTMDF8_76;                            /* CFDTMDF8_76      */
    union __tag158 CFDTMDF9_76;                            /* CFDTMDF9_76      */
    union __tag158 CFDTMDF10_76;                           /* CFDTMDF10_76     */
    union __tag158 CFDTMDF11_76;                           /* CFDTMDF11_76     */
    union __tag158 CFDTMDF12_76;                           /* CFDTMDF12_76     */
    union __tag158 CFDTMDF13_76;                           /* CFDTMDF13_76     */
    union __tag158 CFDTMDF14_76;                           /* CFDTMDF14_76     */
    union __tag158 CFDTMDF15_76;                           /* CFDTMDF15_76     */
    unsigned char  dummy341[52];                           /* Reserved         */
    union __tag158 CFDTMID77;                              /* CFDTMID77        */
    union __tag158 CFDTMPTR77;                             /* CFDTMPTR77       */
    union __tag158 CFDTMFDCTR77;                           /* CFDTMFDCTR77     */
    union __tag158 CFDTMDF0_77;                            /* CFDTMDF0_77      */
    union __tag158 CFDTMDF1_77;                            /* CFDTMDF1_77      */
    union __tag158 CFDTMDF2_77;                            /* CFDTMDF2_77      */
    union __tag158 CFDTMDF3_77;                            /* CFDTMDF3_77      */
    union __tag158 CFDTMDF4_77;                            /* CFDTMDF4_77      */
    union __tag158 CFDTMDF5_77;                            /* CFDTMDF5_77      */
    union __tag158 CFDTMDF6_77;                            /* CFDTMDF6_77      */
    union __tag158 CFDTMDF7_77;                            /* CFDTMDF7_77      */
    union __tag158 CFDTMDF8_77;                            /* CFDTMDF8_77      */
    union __tag158 CFDTMDF9_77;                            /* CFDTMDF9_77      */
    union __tag158 CFDTMDF10_77;                           /* CFDTMDF10_77     */
    union __tag158 CFDTMDF11_77;                           /* CFDTMDF11_77     */
    union __tag158 CFDTMDF12_77;                           /* CFDTMDF12_77     */
    union __tag158 CFDTMDF13_77;                           /* CFDTMDF13_77     */
    union __tag158 CFDTMDF14_77;                           /* CFDTMDF14_77     */
    union __tag158 CFDTMDF15_77;                           /* CFDTMDF15_77     */
    unsigned char  dummy342[52];                           /* Reserved         */
    union __tag158 CFDTMID78;                              /* CFDTMID78        */
    union __tag158 CFDTMPTR78;                             /* CFDTMPTR78       */
    union __tag158 CFDTMFDCTR78;                           /* CFDTMFDCTR78     */
    union __tag158 CFDTMDF0_78;                            /* CFDTMDF0_78      */
    union __tag158 CFDTMDF1_78;                            /* CFDTMDF1_78      */
    union __tag158 CFDTMDF2_78;                            /* CFDTMDF2_78      */
    union __tag158 CFDTMDF3_78;                            /* CFDTMDF3_78      */
    union __tag158 CFDTMDF4_78;                            /* CFDTMDF4_78      */
    union __tag158 CFDTMDF5_78;                            /* CFDTMDF5_78      */
    union __tag158 CFDTMDF6_78;                            /* CFDTMDF6_78      */
    union __tag158 CFDTMDF7_78;                            /* CFDTMDF7_78      */
    union __tag158 CFDTMDF8_78;                            /* CFDTMDF8_78      */
    union __tag158 CFDTMDF9_78;                            /* CFDTMDF9_78      */
    union __tag158 CFDTMDF10_78;                           /* CFDTMDF10_78     */
    union __tag158 CFDTMDF11_78;                           /* CFDTMDF11_78     */
    union __tag158 CFDTMDF12_78;                           /* CFDTMDF12_78     */
    union __tag158 CFDTMDF13_78;                           /* CFDTMDF13_78     */
    union __tag158 CFDTMDF14_78;                           /* CFDTMDF14_78     */
    union __tag158 CFDTMDF15_78;                           /* CFDTMDF15_78     */
    unsigned char  dummy343[52];                           /* Reserved         */
    union __tag158 CFDTMID79;                              /* CFDTMID79        */
    union __tag158 CFDTMPTR79;                             /* CFDTMPTR79       */
    union __tag158 CFDTMFDCTR79;                           /* CFDTMFDCTR79     */
    union __tag158 CFDTMDF0_79;                            /* CFDTMDF0_79      */
    union __tag158 CFDTMDF1_79;                            /* CFDTMDF1_79      */
    union __tag158 CFDTMDF2_79;                            /* CFDTMDF2_79      */
    union __tag158 CFDTMDF3_79;                            /* CFDTMDF3_79      */
    union __tag158 CFDTMDF4_79;                            /* CFDTMDF4_79      */
    union __tag158 CFDTMDF5_79;                            /* CFDTMDF5_79      */
    union __tag158 CFDTMDF6_79;                            /* CFDTMDF6_79      */
    union __tag158 CFDTMDF7_79;                            /* CFDTMDF7_79      */
    union __tag158 CFDTMDF8_79;                            /* CFDTMDF8_79      */
    union __tag158 CFDTMDF9_79;                            /* CFDTMDF9_79      */
    union __tag158 CFDTMDF10_79;                           /* CFDTMDF10_79     */
    union __tag158 CFDTMDF11_79;                           /* CFDTMDF11_79     */
    union __tag158 CFDTMDF12_79;                           /* CFDTMDF12_79     */
    union __tag158 CFDTMDF13_79;                           /* CFDTMDF13_79     */
    union __tag158 CFDTMDF14_79;                           /* CFDTMDF14_79     */
    union __tag158 CFDTMDF15_79;                           /* CFDTMDF15_79     */
    unsigned char  dummy344[52];                           /* Reserved         */
    union __tag158 CFDTMID80;                              /* CFDTMID80        */
    union __tag158 CFDTMPTR80;                             /* CFDTMPTR80       */
    union __tag158 CFDTMFDCTR80;                           /* CFDTMFDCTR80     */
    union __tag158 CFDTMDF0_80;                            /* CFDTMDF0_80      */
    union __tag158 CFDTMDF1_80;                            /* CFDTMDF1_80      */
    union __tag158 CFDTMDF2_80;                            /* CFDTMDF2_80      */
    union __tag158 CFDTMDF3_80;                            /* CFDTMDF3_80      */
    union __tag158 CFDTMDF4_80;                            /* CFDTMDF4_80      */
    union __tag158 CFDTMDF5_80;                            /* CFDTMDF5_80      */
    union __tag158 CFDTMDF6_80;                            /* CFDTMDF6_80      */
    union __tag158 CFDTMDF7_80;                            /* CFDTMDF7_80      */
    union __tag158 CFDTMDF8_80;                            /* CFDTMDF8_80      */
    union __tag158 CFDTMDF9_80;                            /* CFDTMDF9_80      */
    union __tag158 CFDTMDF10_80;                           /* CFDTMDF10_80     */
    union __tag158 CFDTMDF11_80;                           /* CFDTMDF11_80     */
    union __tag158 CFDTMDF12_80;                           /* CFDTMDF12_80     */
    union __tag158 CFDTMDF13_80;                           /* CFDTMDF13_80     */
    union __tag158 CFDTMDF14_80;                           /* CFDTMDF14_80     */
    union __tag158 CFDTMDF15_80;                           /* CFDTMDF15_80     */
    unsigned char  dummy345[52];                           /* Reserved         */
    union __tag158 CFDTMID81;                              /* CFDTMID81        */
    union __tag158 CFDTMPTR81;                             /* CFDTMPTR81       */
    union __tag158 CFDTMFDCTR81;                           /* CFDTMFDCTR81     */
    union __tag158 CFDTMDF0_81;                            /* CFDTMDF0_81      */
    union __tag158 CFDTMDF1_81;                            /* CFDTMDF1_81      */
    union __tag158 CFDTMDF2_81;                            /* CFDTMDF2_81      */
    union __tag158 CFDTMDF3_81;                            /* CFDTMDF3_81      */
    union __tag158 CFDTMDF4_81;                            /* CFDTMDF4_81      */
    union __tag158 CFDTMDF5_81;                            /* CFDTMDF5_81      */
    union __tag158 CFDTMDF6_81;                            /* CFDTMDF6_81      */
    union __tag158 CFDTMDF7_81;                            /* CFDTMDF7_81      */
    union __tag158 CFDTMDF8_81;                            /* CFDTMDF8_81      */
    union __tag158 CFDTMDF9_81;                            /* CFDTMDF9_81      */
    union __tag158 CFDTMDF10_81;                           /* CFDTMDF10_81     */
    union __tag158 CFDTMDF11_81;                           /* CFDTMDF11_81     */
    union __tag158 CFDTMDF12_81;                           /* CFDTMDF12_81     */
    union __tag158 CFDTMDF13_81;                           /* CFDTMDF13_81     */
    union __tag158 CFDTMDF14_81;                           /* CFDTMDF14_81     */
    union __tag158 CFDTMDF15_81;                           /* CFDTMDF15_81     */
    unsigned char  dummy346[52];                           /* Reserved         */
    union __tag158 CFDTMID82;                              /* CFDTMID82        */
    union __tag158 CFDTMPTR82;                             /* CFDTMPTR82       */
    union __tag158 CFDTMFDCTR82;                           /* CFDTMFDCTR82     */
    union __tag158 CFDTMDF0_82;                            /* CFDTMDF0_82      */
    union __tag158 CFDTMDF1_82;                            /* CFDTMDF1_82      */
    union __tag158 CFDTMDF2_82;                            /* CFDTMDF2_82      */
    union __tag158 CFDTMDF3_82;                            /* CFDTMDF3_82      */
    union __tag158 CFDTMDF4_82;                            /* CFDTMDF4_82      */
    union __tag158 CFDTMDF5_82;                            /* CFDTMDF5_82      */
    union __tag158 CFDTMDF6_82;                            /* CFDTMDF6_82      */
    union __tag158 CFDTMDF7_82;                            /* CFDTMDF7_82      */
    union __tag158 CFDTMDF8_82;                            /* CFDTMDF8_82      */
    union __tag158 CFDTMDF9_82;                            /* CFDTMDF9_82      */
    union __tag158 CFDTMDF10_82;                           /* CFDTMDF10_82     */
    union __tag158 CFDTMDF11_82;                           /* CFDTMDF11_82     */
    union __tag158 CFDTMDF12_82;                           /* CFDTMDF12_82     */
    union __tag158 CFDTMDF13_82;                           /* CFDTMDF13_82     */
    union __tag158 CFDTMDF14_82;                           /* CFDTMDF14_82     */
    union __tag158 CFDTMDF15_82;                           /* CFDTMDF15_82     */
    unsigned char  dummy347[52];                           /* Reserved         */
    union __tag158 CFDTMID83;                              /* CFDTMID83        */
    union __tag158 CFDTMPTR83;                             /* CFDTMPTR83       */
    union __tag158 CFDTMFDCTR83;                           /* CFDTMFDCTR83     */
    union __tag158 CFDTMDF0_83;                            /* CFDTMDF0_83      */
    union __tag158 CFDTMDF1_83;                            /* CFDTMDF1_83      */
    union __tag158 CFDTMDF2_83;                            /* CFDTMDF2_83      */
    union __tag158 CFDTMDF3_83;                            /* CFDTMDF3_83      */
    union __tag158 CFDTMDF4_83;                            /* CFDTMDF4_83      */
    union __tag158 CFDTMDF5_83;                            /* CFDTMDF5_83      */
    union __tag158 CFDTMDF6_83;                            /* CFDTMDF6_83      */
    union __tag158 CFDTMDF7_83;                            /* CFDTMDF7_83      */
    union __tag158 CFDTMDF8_83;                            /* CFDTMDF8_83      */
    union __tag158 CFDTMDF9_83;                            /* CFDTMDF9_83      */
    union __tag158 CFDTMDF10_83;                           /* CFDTMDF10_83     */
    union __tag158 CFDTMDF11_83;                           /* CFDTMDF11_83     */
    union __tag158 CFDTMDF12_83;                           /* CFDTMDF12_83     */
    union __tag158 CFDTMDF13_83;                           /* CFDTMDF13_83     */
    union __tag158 CFDTMDF14_83;                           /* CFDTMDF14_83     */
    union __tag158 CFDTMDF15_83;                           /* CFDTMDF15_83     */
    unsigned char  dummy348[52];                           /* Reserved         */
    union __tag158 CFDTMID84;                              /* CFDTMID84        */
    union __tag158 CFDTMPTR84;                             /* CFDTMPTR84       */
    union __tag158 CFDTMFDCTR84;                           /* CFDTMFDCTR84     */
    union __tag158 CFDTMDF0_84;                            /* CFDTMDF0_84      */
    union __tag158 CFDTMDF1_84;                            /* CFDTMDF1_84      */
    union __tag158 CFDTMDF2_84;                            /* CFDTMDF2_84      */
    union __tag158 CFDTMDF3_84;                            /* CFDTMDF3_84      */
    union __tag158 CFDTMDF4_84;                            /* CFDTMDF4_84      */
    union __tag158 CFDTMDF5_84;                            /* CFDTMDF5_84      */
    union __tag158 CFDTMDF6_84;                            /* CFDTMDF6_84      */
    union __tag158 CFDTMDF7_84;                            /* CFDTMDF7_84      */
    union __tag158 CFDTMDF8_84;                            /* CFDTMDF8_84      */
    union __tag158 CFDTMDF9_84;                            /* CFDTMDF9_84      */
    union __tag158 CFDTMDF10_84;                           /* CFDTMDF10_84     */
    union __tag158 CFDTMDF11_84;                           /* CFDTMDF11_84     */
    union __tag158 CFDTMDF12_84;                           /* CFDTMDF12_84     */
    union __tag158 CFDTMDF13_84;                           /* CFDTMDF13_84     */
    union __tag158 CFDTMDF14_84;                           /* CFDTMDF14_84     */
    union __tag158 CFDTMDF15_84;                           /* CFDTMDF15_84     */
    unsigned char  dummy349[52];                           /* Reserved         */
    union __tag158 CFDTMID85;                              /* CFDTMID85        */
    union __tag158 CFDTMPTR85;                             /* CFDTMPTR85       */
    union __tag158 CFDTMFDCTR85;                           /* CFDTMFDCTR85     */
    union __tag158 CFDTMDF0_85;                            /* CFDTMDF0_85      */
    union __tag158 CFDTMDF1_85;                            /* CFDTMDF1_85      */
    union __tag158 CFDTMDF2_85;                            /* CFDTMDF2_85      */
    union __tag158 CFDTMDF3_85;                            /* CFDTMDF3_85      */
    union __tag158 CFDTMDF4_85;                            /* CFDTMDF4_85      */
    union __tag158 CFDTMDF5_85;                            /* CFDTMDF5_85      */
    union __tag158 CFDTMDF6_85;                            /* CFDTMDF6_85      */
    union __tag158 CFDTMDF7_85;                            /* CFDTMDF7_85      */
    union __tag158 CFDTMDF8_85;                            /* CFDTMDF8_85      */
    union __tag158 CFDTMDF9_85;                            /* CFDTMDF9_85      */
    union __tag158 CFDTMDF10_85;                           /* CFDTMDF10_85     */
    union __tag158 CFDTMDF11_85;                           /* CFDTMDF11_85     */
    union __tag158 CFDTMDF12_85;                           /* CFDTMDF12_85     */
    union __tag158 CFDTMDF13_85;                           /* CFDTMDF13_85     */
    union __tag158 CFDTMDF14_85;                           /* CFDTMDF14_85     */
    union __tag158 CFDTMDF15_85;                           /* CFDTMDF15_85     */
    unsigned char  dummy350[52];                           /* Reserved         */
    union __tag158 CFDTMID86;                              /* CFDTMID86        */
    union __tag158 CFDTMPTR86;                             /* CFDTMPTR86       */
    union __tag158 CFDTMFDCTR86;                           /* CFDTMFDCTR86     */
    union __tag158 CFDTMDF0_86;                            /* CFDTMDF0_86      */
    union __tag158 CFDTMDF1_86;                            /* CFDTMDF1_86      */
    union __tag158 CFDTMDF2_86;                            /* CFDTMDF2_86      */
    union __tag158 CFDTMDF3_86;                            /* CFDTMDF3_86      */
    union __tag158 CFDTMDF4_86;                            /* CFDTMDF4_86      */
    union __tag158 CFDTMDF5_86;                            /* CFDTMDF5_86      */
    union __tag158 CFDTMDF6_86;                            /* CFDTMDF6_86      */
    union __tag158 CFDTMDF7_86;                            /* CFDTMDF7_86      */
    union __tag158 CFDTMDF8_86;                            /* CFDTMDF8_86      */
    union __tag158 CFDTMDF9_86;                            /* CFDTMDF9_86      */
    union __tag158 CFDTMDF10_86;                           /* CFDTMDF10_86     */
    union __tag158 CFDTMDF11_86;                           /* CFDTMDF11_86     */
    union __tag158 CFDTMDF12_86;                           /* CFDTMDF12_86     */
    union __tag158 CFDTMDF13_86;                           /* CFDTMDF13_86     */
    union __tag158 CFDTMDF14_86;                           /* CFDTMDF14_86     */
    union __tag158 CFDTMDF15_86;                           /* CFDTMDF15_86     */
    unsigned char  dummy351[52];                           /* Reserved         */
    union __tag158 CFDTMID87;                              /* CFDTMID87        */
    union __tag158 CFDTMPTR87;                             /* CFDTMPTR87       */
    union __tag158 CFDTMFDCTR87;                           /* CFDTMFDCTR87     */
    union __tag158 CFDTMDF0_87;                            /* CFDTMDF0_87      */
    union __tag158 CFDTMDF1_87;                            /* CFDTMDF1_87      */
    union __tag158 CFDTMDF2_87;                            /* CFDTMDF2_87      */
    union __tag158 CFDTMDF3_87;                            /* CFDTMDF3_87      */
    union __tag158 CFDTMDF4_87;                            /* CFDTMDF4_87      */
    union __tag158 CFDTMDF5_87;                            /* CFDTMDF5_87      */
    union __tag158 CFDTMDF6_87;                            /* CFDTMDF6_87      */
    union __tag158 CFDTMDF7_87;                            /* CFDTMDF7_87      */
    union __tag158 CFDTMDF8_87;                            /* CFDTMDF8_87      */
    union __tag158 CFDTMDF9_87;                            /* CFDTMDF9_87      */
    union __tag158 CFDTMDF10_87;                           /* CFDTMDF10_87     */
    union __tag158 CFDTMDF11_87;                           /* CFDTMDF11_87     */
    union __tag158 CFDTMDF12_87;                           /* CFDTMDF12_87     */
    union __tag158 CFDTMDF13_87;                           /* CFDTMDF13_87     */
    union __tag158 CFDTMDF14_87;                           /* CFDTMDF14_87     */
    union __tag158 CFDTMDF15_87;                           /* CFDTMDF15_87     */
    unsigned char  dummy352[52];                           /* Reserved         */
    union __tag158 CFDTMID88;                              /* CFDTMID88        */
    union __tag158 CFDTMPTR88;                             /* CFDTMPTR88       */
    union __tag158 CFDTMFDCTR88;                           /* CFDTMFDCTR88     */
    union __tag158 CFDTMDF0_88;                            /* CFDTMDF0_88      */
    union __tag158 CFDTMDF1_88;                            /* CFDTMDF1_88      */
    union __tag158 CFDTMDF2_88;                            /* CFDTMDF2_88      */
    union __tag158 CFDTMDF3_88;                            /* CFDTMDF3_88      */
    union __tag158 CFDTMDF4_88;                            /* CFDTMDF4_88      */
    union __tag158 CFDTMDF5_88;                            /* CFDTMDF5_88      */
    union __tag158 CFDTMDF6_88;                            /* CFDTMDF6_88      */
    union __tag158 CFDTMDF7_88;                            /* CFDTMDF7_88      */
    union __tag158 CFDTMDF8_88;                            /* CFDTMDF8_88      */
    union __tag158 CFDTMDF9_88;                            /* CFDTMDF9_88      */
    union __tag158 CFDTMDF10_88;                           /* CFDTMDF10_88     */
    union __tag158 CFDTMDF11_88;                           /* CFDTMDF11_88     */
    union __tag158 CFDTMDF12_88;                           /* CFDTMDF12_88     */
    union __tag158 CFDTMDF13_88;                           /* CFDTMDF13_88     */
    union __tag158 CFDTMDF14_88;                           /* CFDTMDF14_88     */
    union __tag158 CFDTMDF15_88;                           /* CFDTMDF15_88     */
    unsigned char  dummy353[52];                           /* Reserved         */
    union __tag158 CFDTMID89;                              /* CFDTMID89        */
    union __tag158 CFDTMPTR89;                             /* CFDTMPTR89       */
    union __tag158 CFDTMFDCTR89;                           /* CFDTMFDCTR89     */
    union __tag158 CFDTMDF0_89;                            /* CFDTMDF0_89      */
    union __tag158 CFDTMDF1_89;                            /* CFDTMDF1_89      */
    union __tag158 CFDTMDF2_89;                            /* CFDTMDF2_89      */
    union __tag158 CFDTMDF3_89;                            /* CFDTMDF3_89      */
    union __tag158 CFDTMDF4_89;                            /* CFDTMDF4_89      */
    union __tag158 CFDTMDF5_89;                            /* CFDTMDF5_89      */
    union __tag158 CFDTMDF6_89;                            /* CFDTMDF6_89      */
    union __tag158 CFDTMDF7_89;                            /* CFDTMDF7_89      */
    union __tag158 CFDTMDF8_89;                            /* CFDTMDF8_89      */
    union __tag158 CFDTMDF9_89;                            /* CFDTMDF9_89      */
    union __tag158 CFDTMDF10_89;                           /* CFDTMDF10_89     */
    union __tag158 CFDTMDF11_89;                           /* CFDTMDF11_89     */
    union __tag158 CFDTMDF12_89;                           /* CFDTMDF12_89     */
    union __tag158 CFDTMDF13_89;                           /* CFDTMDF13_89     */
    union __tag158 CFDTMDF14_89;                           /* CFDTMDF14_89     */
    union __tag158 CFDTMDF15_89;                           /* CFDTMDF15_89     */
    unsigned char  dummy354[52];                           /* Reserved         */
    union __tag158 CFDTMID90;                              /* CFDTMID90        */
    union __tag158 CFDTMPTR90;                             /* CFDTMPTR90       */
    union __tag158 CFDTMFDCTR90;                           /* CFDTMFDCTR90     */
    union __tag158 CFDTMDF0_90;                            /* CFDTMDF0_90      */
    union __tag158 CFDTMDF1_90;                            /* CFDTMDF1_90      */
    union __tag158 CFDTMDF2_90;                            /* CFDTMDF2_90      */
    union __tag158 CFDTMDF3_90;                            /* CFDTMDF3_90      */
    union __tag158 CFDTMDF4_90;                            /* CFDTMDF4_90      */
    union __tag158 CFDTMDF5_90;                            /* CFDTMDF5_90      */
    union __tag158 CFDTMDF6_90;                            /* CFDTMDF6_90      */
    union __tag158 CFDTMDF7_90;                            /* CFDTMDF7_90      */
    union __tag158 CFDTMDF8_90;                            /* CFDTMDF8_90      */
    union __tag158 CFDTMDF9_90;                            /* CFDTMDF9_90      */
    union __tag158 CFDTMDF10_90;                           /* CFDTMDF10_90     */
    union __tag158 CFDTMDF11_90;                           /* CFDTMDF11_90     */
    union __tag158 CFDTMDF12_90;                           /* CFDTMDF12_90     */
    union __tag158 CFDTMDF13_90;                           /* CFDTMDF13_90     */
    union __tag158 CFDTMDF14_90;                           /* CFDTMDF14_90     */
    union __tag158 CFDTMDF15_90;                           /* CFDTMDF15_90     */
    unsigned char  dummy355[52];                           /* Reserved         */
    union __tag158 CFDTMID91;                              /* CFDTMID91        */
    union __tag158 CFDTMPTR91;                             /* CFDTMPTR91       */
    union __tag158 CFDTMFDCTR91;                           /* CFDTMFDCTR91     */
    union __tag158 CFDTMDF0_91;                            /* CFDTMDF0_91      */
    union __tag158 CFDTMDF1_91;                            /* CFDTMDF1_91      */
    union __tag158 CFDTMDF2_91;                            /* CFDTMDF2_91      */
    union __tag158 CFDTMDF3_91;                            /* CFDTMDF3_91      */
    union __tag158 CFDTMDF4_91;                            /* CFDTMDF4_91      */
    union __tag158 CFDTMDF5_91;                            /* CFDTMDF5_91      */
    union __tag158 CFDTMDF6_91;                            /* CFDTMDF6_91      */
    union __tag158 CFDTMDF7_91;                            /* CFDTMDF7_91      */
    union __tag158 CFDTMDF8_91;                            /* CFDTMDF8_91      */
    union __tag158 CFDTMDF9_91;                            /* CFDTMDF9_91      */
    union __tag158 CFDTMDF10_91;                           /* CFDTMDF10_91     */
    union __tag158 CFDTMDF11_91;                           /* CFDTMDF11_91     */
    union __tag158 CFDTMDF12_91;                           /* CFDTMDF12_91     */
    union __tag158 CFDTMDF13_91;                           /* CFDTMDF13_91     */
    union __tag158 CFDTMDF14_91;                           /* CFDTMDF14_91     */
    union __tag158 CFDTMDF15_91;                           /* CFDTMDF15_91     */
    unsigned char  dummy356[52];                           /* Reserved         */
    union __tag158 CFDTMID92;                              /* CFDTMID92        */
    union __tag158 CFDTMPTR92;                             /* CFDTMPTR92       */
    union __tag158 CFDTMFDCTR92;                           /* CFDTMFDCTR92     */
    union __tag158 CFDTMDF0_92;                            /* CFDTMDF0_92      */
    union __tag158 CFDTMDF1_92;                            /* CFDTMDF1_92      */
    union __tag158 CFDTMDF2_92;                            /* CFDTMDF2_92      */
    union __tag158 CFDTMDF3_92;                            /* CFDTMDF3_92      */
    union __tag158 CFDTMDF4_92;                            /* CFDTMDF4_92      */
    union __tag158 CFDTMDF5_92;                            /* CFDTMDF5_92      */
    union __tag158 CFDTMDF6_92;                            /* CFDTMDF6_92      */
    union __tag158 CFDTMDF7_92;                            /* CFDTMDF7_92      */
    union __tag158 CFDTMDF8_92;                            /* CFDTMDF8_92      */
    union __tag158 CFDTMDF9_92;                            /* CFDTMDF9_92      */
    union __tag158 CFDTMDF10_92;                           /* CFDTMDF10_92     */
    union __tag158 CFDTMDF11_92;                           /* CFDTMDF11_92     */
    union __tag158 CFDTMDF12_92;                           /* CFDTMDF12_92     */
    union __tag158 CFDTMDF13_92;                           /* CFDTMDF13_92     */
    union __tag158 CFDTMDF14_92;                           /* CFDTMDF14_92     */
    union __tag158 CFDTMDF15_92;                           /* CFDTMDF15_92     */
    unsigned char  dummy357[52];                           /* Reserved         */
    union __tag158 CFDTMID93;                              /* CFDTMID93        */
    union __tag158 CFDTMPTR93;                             /* CFDTMPTR93       */
    union __tag158 CFDTMFDCTR93;                           /* CFDTMFDCTR93     */
    union __tag158 CFDTMDF0_93;                            /* CFDTMDF0_93      */
    union __tag158 CFDTMDF1_93;                            /* CFDTMDF1_93      */
    union __tag158 CFDTMDF2_93;                            /* CFDTMDF2_93      */
    union __tag158 CFDTMDF3_93;                            /* CFDTMDF3_93      */
    union __tag158 CFDTMDF4_93;                            /* CFDTMDF4_93      */
    union __tag158 CFDTMDF5_93;                            /* CFDTMDF5_93      */
    union __tag158 CFDTMDF6_93;                            /* CFDTMDF6_93      */
    union __tag158 CFDTMDF7_93;                            /* CFDTMDF7_93      */
    union __tag158 CFDTMDF8_93;                            /* CFDTMDF8_93      */
    union __tag158 CFDTMDF9_93;                            /* CFDTMDF9_93      */
    union __tag158 CFDTMDF10_93;                           /* CFDTMDF10_93     */
    union __tag158 CFDTMDF11_93;                           /* CFDTMDF11_93     */
    union __tag158 CFDTMDF12_93;                           /* CFDTMDF12_93     */
    union __tag158 CFDTMDF13_93;                           /* CFDTMDF13_93     */
    union __tag158 CFDTMDF14_93;                           /* CFDTMDF14_93     */
    union __tag158 CFDTMDF15_93;                           /* CFDTMDF15_93     */
    unsigned char  dummy358[52];                           /* Reserved         */
    union __tag158 CFDTMID94;                              /* CFDTMID94        */
    union __tag158 CFDTMPTR94;                             /* CFDTMPTR94       */
    union __tag158 CFDTMFDCTR94;                           /* CFDTMFDCTR94     */
    union __tag158 CFDTMDF0_94;                            /* CFDTMDF0_94      */
    union __tag158 CFDTMDF1_94;                            /* CFDTMDF1_94      */
    union __tag158 CFDTMDF2_94;                            /* CFDTMDF2_94      */
    union __tag158 CFDTMDF3_94;                            /* CFDTMDF3_94      */
    union __tag158 CFDTMDF4_94;                            /* CFDTMDF4_94      */
    union __tag158 CFDTMDF5_94;                            /* CFDTMDF5_94      */
    union __tag158 CFDTMDF6_94;                            /* CFDTMDF6_94      */
    union __tag158 CFDTMDF7_94;                            /* CFDTMDF7_94      */
    union __tag158 CFDTMDF8_94;                            /* CFDTMDF8_94      */
    union __tag158 CFDTMDF9_94;                            /* CFDTMDF9_94      */
    union __tag158 CFDTMDF10_94;                           /* CFDTMDF10_94     */
    union __tag158 CFDTMDF11_94;                           /* CFDTMDF11_94     */
    union __tag158 CFDTMDF12_94;                           /* CFDTMDF12_94     */
    union __tag158 CFDTMDF13_94;                           /* CFDTMDF13_94     */
    union __tag158 CFDTMDF14_94;                           /* CFDTMDF14_94     */
    union __tag158 CFDTMDF15_94;                           /* CFDTMDF15_94     */
    unsigned char  dummy359[52];                           /* Reserved         */
    union __tag158 CFDTMID95;                              /* CFDTMID95        */
    union __tag158 CFDTMPTR95;                             /* CFDTMPTR95       */
    union __tag158 CFDTMFDCTR95;                           /* CFDTMFDCTR95     */
    union __tag158 CFDTMDF0_95;                            /* CFDTMDF0_95      */
    union __tag158 CFDTMDF1_95;                            /* CFDTMDF1_95      */
    union __tag158 CFDTMDF2_95;                            /* CFDTMDF2_95      */
    union __tag158 CFDTMDF3_95;                            /* CFDTMDF3_95      */
    union __tag158 CFDTMDF4_95;                            /* CFDTMDF4_95      */
    union __tag158 CFDTMDF5_95;                            /* CFDTMDF5_95      */
    union __tag158 CFDTMDF6_95;                            /* CFDTMDF6_95      */
    union __tag158 CFDTMDF7_95;                            /* CFDTMDF7_95      */
    union __tag158 CFDTMDF8_95;                            /* CFDTMDF8_95      */
    union __tag158 CFDTMDF9_95;                            /* CFDTMDF9_95      */
    union __tag158 CFDTMDF10_95;                           /* CFDTMDF10_95     */
    union __tag158 CFDTMDF11_95;                           /* CFDTMDF11_95     */
    union __tag158 CFDTMDF12_95;                           /* CFDTMDF12_95     */
    union __tag158 CFDTMDF13_95;                           /* CFDTMDF13_95     */
    union __tag158 CFDTMDF14_95;                           /* CFDTMDF14_95     */
    union __tag158 CFDTMDF15_95;                           /* CFDTMDF15_95     */
    unsigned char  dummy360[20532];                        /* Reserved         */
    union __tag158 CFDTHLACC00;                            /* CFDTHLACC00      */
    union __tag158 CFDTHLACC10;                            /* CFDTHLACC10      */
    union __tag158 CFDTHLACC01;                            /* CFDTHLACC01      */
    union __tag158 CFDTHLACC11;                            /* CFDTHLACC11      */
    union __tag158 CFDTHLACC02;                            /* CFDTHLACC02      */
    union __tag158 CFDTHLACC12;                            /* CFDTHLACC12      */
    unsigned char  dummy361[1000];                         /* Reserved         */
    union __tag158 CFDRPGACC0;                             /* CFDRPGACC0       */
    union __tag158 CFDRPGACC1;                             /* CFDRPGACC1       */
    union __tag158 CFDRPGACC2;                             /* CFDRPGACC2       */
    union __tag158 CFDRPGACC3;                             /* CFDRPGACC3       */
    union __tag158 CFDRPGACC4;                             /* CFDRPGACC4       */
    union __tag158 CFDRPGACC5;                             /* CFDRPGACC5       */
    union __tag158 CFDRPGACC6;                             /* CFDRPGACC6       */
    union __tag158 CFDRPGACC7;                             /* CFDRPGACC7       */
    union __tag158 CFDRPGACC8;                             /* CFDRPGACC8       */
    union __tag158 CFDRPGACC9;                             /* CFDRPGACC9       */
    union __tag158 CFDRPGACC10;                            /* CFDRPGACC10      */
    union __tag158 CFDRPGACC11;                            /* CFDRPGACC11      */
    union __tag158 CFDRPGACC12;                            /* CFDRPGACC12      */
    union __tag158 CFDRPGACC13;                            /* CFDRPGACC13      */
    union __tag158 CFDRPGACC14;                            /* CFDRPGACC14      */
    union __tag158 CFDRPGACC15;                            /* CFDRPGACC15      */
    union __tag158 CFDRPGACC16;                            /* CFDRPGACC16      */
    union __tag158 CFDRPGACC17;                            /* CFDRPGACC17      */
    union __tag158 CFDRPGACC18;                            /* CFDRPGACC18      */
    union __tag158 CFDRPGACC19;                            /* CFDRPGACC19      */
    union __tag158 CFDRPGACC20;                            /* CFDRPGACC20      */
    union __tag158 CFDRPGACC21;                            /* CFDRPGACC21      */
    union __tag158 CFDRPGACC22;                            /* CFDRPGACC22      */
    union __tag158 CFDRPGACC23;                            /* CFDRPGACC23      */
    union __tag158 CFDRPGACC24;                            /* CFDRPGACC24      */
    union __tag158 CFDRPGACC25;                            /* CFDRPGACC25      */
    union __tag158 CFDRPGACC26;                            /* CFDRPGACC26      */
    union __tag158 CFDRPGACC27;                            /* CFDRPGACC27      */
    union __tag158 CFDRPGACC28;                            /* CFDRPGACC28      */
    union __tag158 CFDRPGACC29;                            /* CFDRPGACC29      */
    union __tag158 CFDRPGACC30;                            /* CFDRPGACC30      */
    union __tag158 CFDRPGACC31;                            /* CFDRPGACC31      */
    union __tag158 CFDRPGACC32;                            /* CFDRPGACC32      */
    union __tag158 CFDRPGACC33;                            /* CFDRPGACC33      */
    union __tag158 CFDRPGACC34;                            /* CFDRPGACC34      */
    union __tag158 CFDRPGACC35;                            /* CFDRPGACC35      */
    union __tag158 CFDRPGACC36;                            /* CFDRPGACC36      */
    union __tag158 CFDRPGACC37;                            /* CFDRPGACC37      */
    union __tag158 CFDRPGACC38;                            /* CFDRPGACC38      */
    union __tag158 CFDRPGACC39;                            /* CFDRPGACC39      */
    union __tag158 CFDRPGACC40;                            /* CFDRPGACC40      */
    union __tag158 CFDRPGACC41;                            /* CFDRPGACC41      */
    union __tag158 CFDRPGACC42;                            /* CFDRPGACC42      */
    union __tag158 CFDRPGACC43;                            /* CFDRPGACC43      */
    union __tag158 CFDRPGACC44;                            /* CFDRPGACC44      */
    union __tag158 CFDRPGACC45;                            /* CFDRPGACC45      */
    union __tag158 CFDRPGACC46;                            /* CFDRPGACC46      */
    union __tag158 CFDRPGACC47;                            /* CFDRPGACC47      */
    union __tag158 CFDRPGACC48;                            /* CFDRPGACC48      */
    union __tag158 CFDRPGACC49;                            /* CFDRPGACC49      */
    union __tag158 CFDRPGACC50;                            /* CFDRPGACC50      */
    union __tag158 CFDRPGACC51;                            /* CFDRPGACC51      */
    union __tag158 CFDRPGACC52;                            /* CFDRPGACC52      */
    union __tag158 CFDRPGACC53;                            /* CFDRPGACC53      */
    union __tag158 CFDRPGACC54;                            /* CFDRPGACC54      */
    union __tag158 CFDRPGACC55;                            /* CFDRPGACC55      */
    union __tag158 CFDRPGACC56;                            /* CFDRPGACC56      */
    union __tag158 CFDRPGACC57;                            /* CFDRPGACC57      */
    union __tag158 CFDRPGACC58;                            /* CFDRPGACC58      */
    union __tag158 CFDRPGACC59;                            /* CFDRPGACC59      */
    union __tag158 CFDRPGACC60;                            /* CFDRPGACC60      */
    union __tag158 CFDRPGACC61;                            /* CFDRPGACC61      */
    union __tag158 CFDRPGACC62;                            /* CFDRPGACC62      */
    union __tag158 CFDRPGACC63;                            /* CFDRPGACC63      */
};
struct __tag359
{                                                          /* Module           */
    unsigned long  CMP;                                    /* CMP              */
    unsigned long  CNT;                                    /* CNT              */
    unsigned char  dummy362[8];                            /* Reserved         */
    unsigned char  TE;                                     /* TE               */
    unsigned char  dummy363[3];                            /* Reserved         */
    unsigned char  TS;                                     /* TS               */
    unsigned char  dummy364[3];                            /* Reserved         */
    unsigned char  TT;                                     /* TT               */
    unsigned char  dummy365[7];                            /* Reserved         */
    unsigned char  CTL;                                    /* CTL              */
    unsigned char  dummy366[3];                            /* Reserved         */
    unsigned char  EMU;                                    /* EMU              */
};
struct __tag360
{                                                          /* Module           */
    unsigned char  CTL0;                                   /* CTL0             */
    unsigned char  dummy367[3];                            /* Reserved         */
    unsigned long  STR0;                                   /* STR0             */
    unsigned short STCR0;                                  /* STCR0            */
    unsigned char  dummy368[6];                            /* Reserved         */
    unsigned long  CTL1;                                   /* CTL1             */
    unsigned short CTL2;                                   /* CTL2             */
    unsigned char  dummy369[2];                            /* Reserved         */
    union __tag168 EMU;                                    /* EMU              */
    unsigned char  dummy370[4071];                         /* Reserved         */
    unsigned long  MCTL1;                                  /* MCTL1            */
    unsigned long  MCTL2;                                  /* MCTL2            */
    unsigned long  TX0W;                                   /* TX0W             */
    unsigned short TX0H;                                   /* TX0H             */
    unsigned char  dummy371[2];                            /* Reserved         */
    unsigned long  RX0W;                                   /* RX0W             */
    unsigned short RX0H;                                   /* RX0H             */
    unsigned char  dummy372[2];                            /* Reserved         */
    unsigned long  MRWP0;                                  /* MRWP0            */
    unsigned char  dummy373[36];                           /* Reserved         */
    unsigned short MCTL0;                                  /* MCTL0            */
    unsigned char  dummy374[2];                            /* Reserved         */
    unsigned long  CFG0;                                   /* CFG0             */
    unsigned long  CFG1;                                   /* CFG1             */
    unsigned long  CFG2;                                   /* CFG2             */
    unsigned long  CFG3;                                   /* CFG3             */
    unsigned char  dummy375[20];                           /* Reserved         */
    unsigned short BRS0;                                   /* BRS0             */
    unsigned char  dummy376[2];                            /* Reserved         */
    unsigned short BRS1;                                   /* BRS1             */
    unsigned char  dummy377[2];                            /* Reserved         */
    unsigned short BRS2;                                   /* BRS2             */
    unsigned char  dummy378[2];                            /* Reserved         */
    unsigned short BRS3;                                   /* BRS3             */
};
struct __tag361
{                                                          /* Module           */
    unsigned char  CTL0;                                   /* CTL0             */
    unsigned char  dummy379[3];                            /* Reserved         */
    unsigned long  STR0;                                   /* STR0             */
    unsigned short STCR0;                                  /* STCR0            */
    unsigned char  dummy380[6];                            /* Reserved         */
    unsigned long  CTL1;                                   /* CTL1             */
    unsigned short CTL2;                                   /* CTL2             */
    unsigned char  dummy381[2];                            /* Reserved         */
    union __tag168 EMU;                                    /* EMU              */
    unsigned char  dummy382[4071];                         /* Reserved         */
    union __tag169 BCTL0;                                  /* BCTL0            */
    unsigned char  dummy383[3];                            /* Reserved         */
    unsigned long  TX0W;                                   /* TX0W             */
    unsigned short TX0H;                                   /* TX0H             */
    unsigned char  dummy384[2];                            /* Reserved         */
    unsigned short RX0;                                    /* RX0              */
    unsigned char  dummy385[2];                            /* Reserved         */
    unsigned long  CFG0;                                   /* CFG0             */
};
struct __tag362
{                                                          /* Module           */
    unsigned char  SST;                                    /* SST              */
    unsigned char  dummy386[11];                           /* Reserved         */
    unsigned short SSER0;                                  /* SSER0            */
    unsigned char  dummy387[6];                            /* Reserved         */
    unsigned short SSER2;                                  /* SSER2            */
    unsigned char  dummy388[102];                          /* Reserved         */
    unsigned char  HIZCEN0;                                /* HIZCEN0          */
    unsigned char  dummy389[15];                           /* Reserved         */
    unsigned short ADTEN400;                               /* ADTEN400         */
    unsigned char  dummy390[2];                            /* Reserved         */
    unsigned short ADTEN401;                               /* ADTEN401         */
    unsigned char  dummy391[2];                            /* Reserved         */
    unsigned short ADTEN402;                               /* ADTEN402         */
    unsigned char  dummy392[38];                           /* Reserved         */
    unsigned long  REG200;                                 /* REG200           */
    unsigned long  REG201;                                 /* REG201           */
    unsigned long  REG202;                                 /* REG202           */
    unsigned long  REG203;                                 /* REG203           */
    unsigned char  dummy393[24];                           /* Reserved         */
    unsigned long  REG30;                                  /* REG30            */
    unsigned long  REG31;                                  /* REG31            */
};
struct __tag363
{                                                          /* Module           */
    union __tag158 FSGD02PROT0;                            /* FSGD02PROT0      */
    union __tag158 FSGD02PROT1;                            /* FSGD02PROT1      */
    union __tag158 FSGD02PROT2;                            /* FSGD02PROT2      */
    union __tag158 FSGD02PROT3;                            /* FSGD02PROT3      */
    union __tag158 FSGD02PROT4;                            /* FSGD02PROT4      */
    union __tag158 FSGD02PROT5;                            /* FSGD02PROT5      */
    union __tag158 FSGD02PROT6;                            /* FSGD02PROT6      */
    unsigned char  dummy394[4];                            /* Reserved         */
    union __tag158 FSGD02PROT8;                            /* FSGD02PROT8      */
    union __tag158 FSGD02PROT9;                            /* FSGD02PROT9      */
    union __tag158 FSGD02PROT10;                           /* FSGD02PROT10     */
    union __tag158 FSGD02PROT11;                           /* FSGD02PROT11     */
    unsigned char  dummy395[8];                            /* Reserved         */
    union __tag158 FSGD02PROT14;                           /* FSGD02PROT14     */
    union __tag158 FSGD02PROT15;                           /* FSGD02PROT15     */
    union __tag158 ERRSLV02CTL;                            /* ERRSLV02CTL      */
    union __tag158 ERRSLV02STAT;                           /* ERRSLV02STAT     */
    unsigned long  ERRSLV02ADDR;                           /* ERRSLV02ADDR     */
    union __tag164 ERRSLV02TYPE;                           /* ERRSLV02TYPE     */
};
struct __tag364
{                                                          /* Module           */
    union __tag158 FSGD09PROT0;                            /* FSGD09PROT0      */
    union __tag158 FSGD09PROT1;                            /* FSGD09PROT1      */
    unsigned char  dummy396[24];                           /* Reserved         */
    union __tag158 FSGD09PROT8;                            /* FSGD09PROT8      */
    union __tag158 FSGD09PROT9;                            /* FSGD09PROT9      */
    unsigned char  dummy397[24];                           /* Reserved         */
    union __tag158 ERRSLV09CTL;                            /* ERRSLV09CTL      */
    union __tag158 ERRSLV09STAT;                           /* ERRSLV09STAT     */
    unsigned long  ERRSLV09ADDR;                           /* ERRSLV09ADDR     */
    union __tag164 ERRSLV09TYPE;                           /* ERRSLV09TYPE     */
};
struct __tag365
{                                                          /* Module           */
    unsigned short CDR0;                                   /* CDR0             */
    unsigned char  dummy398[2];                            /* Reserved         */
    unsigned short CDR1;                                   /* CDR1             */
    unsigned char  dummy399[2];                            /* Reserved         */
    unsigned short CDR2;                                   /* CDR2             */
    unsigned char  dummy400[2];                            /* Reserved         */
    unsigned short CDR3;                                   /* CDR3             */
    unsigned char  dummy401[2];                            /* Reserved         */
    unsigned short CDR4;                                   /* CDR4             */
    unsigned char  dummy402[2];                            /* Reserved         */
    unsigned short CDR5;                                   /* CDR5             */
    unsigned char  dummy403[2];                            /* Reserved         */
    unsigned short CDR6;                                   /* CDR6             */
    unsigned char  dummy404[2];                            /* Reserved         */
    unsigned short CDR7;                                   /* CDR7             */
    unsigned char  dummy405[2];                            /* Reserved         */
    unsigned short CDR8;                                   /* CDR8             */
    unsigned char  dummy406[2];                            /* Reserved         */
    unsigned short CDR9;                                   /* CDR9             */
    unsigned char  dummy407[2];                            /* Reserved         */
    unsigned short CDR10;                                  /* CDR10            */
    unsigned char  dummy408[2];                            /* Reserved         */
    unsigned short CDR11;                                  /* CDR11            */
    unsigned char  dummy409[2];                            /* Reserved         */
    unsigned short CDR12;                                  /* CDR12            */
    unsigned char  dummy410[2];                            /* Reserved         */
    unsigned short CDR13;                                  /* CDR13            */
    unsigned char  dummy411[2];                            /* Reserved         */
    unsigned short CDR14;                                  /* CDR14            */
    unsigned char  dummy412[2];                            /* Reserved         */
    unsigned short CDR15;                                  /* CDR15            */
    unsigned char  dummy413[2];                            /* Reserved         */
    unsigned short TOL;                                    /* TOL              */
    unsigned char  dummy414[2];                            /* Reserved         */
    unsigned short RDT;                                    /* RDT              */
    unsigned char  dummy415[2];                            /* Reserved         */
    unsigned short RSF;                                    /* RSF              */
    unsigned char  dummy416[2];                            /* Reserved         */
    unsigned short TRO;                                    /* TRO              */
    unsigned char  dummy417[2];                            /* Reserved         */
    unsigned short TME;                                    /* TME              */
    unsigned char  dummy418[2];                            /* Reserved         */
    unsigned short TDL;                                    /* TDL              */
    unsigned char  dummy419[2];                            /* Reserved         */
    unsigned short TO;                                     /* TO               */
    unsigned char  dummy420[2];                            /* Reserved         */
    unsigned short TOE;                                    /* TOE              */
    unsigned char  dummy421[34];                           /* Reserved         */
    unsigned short CNT0;                                   /* CNT0             */
    unsigned char  dummy422[2];                            /* Reserved         */
    unsigned short CNT1;                                   /* CNT1             */
    unsigned char  dummy423[2];                            /* Reserved         */
    unsigned short CNT2;                                   /* CNT2             */
    unsigned char  dummy424[2];                            /* Reserved         */
    unsigned short CNT3;                                   /* CNT3             */
    unsigned char  dummy425[2];                            /* Reserved         */
    unsigned short CNT4;                                   /* CNT4             */
    unsigned char  dummy426[2];                            /* Reserved         */
    unsigned short CNT5;                                   /* CNT5             */
    unsigned char  dummy427[2];                            /* Reserved         */
    unsigned short CNT6;                                   /* CNT6             */
    unsigned char  dummy428[2];                            /* Reserved         */
    unsigned short CNT7;                                   /* CNT7             */
    unsigned char  dummy429[2];                            /* Reserved         */
    unsigned short CNT8;                                   /* CNT8             */
    unsigned char  dummy430[2];                            /* Reserved         */
    unsigned short CNT9;                                   /* CNT9             */
    unsigned char  dummy431[2];                            /* Reserved         */
    unsigned short CNT10;                                  /* CNT10            */
    unsigned char  dummy432[2];                            /* Reserved         */
    unsigned short CNT11;                                  /* CNT11            */
    unsigned char  dummy433[2];                            /* Reserved         */
    unsigned short CNT12;                                  /* CNT12            */
    unsigned char  dummy434[2];                            /* Reserved         */
    unsigned short CNT13;                                  /* CNT13            */
    unsigned char  dummy435[2];                            /* Reserved         */
    unsigned short CNT14;                                  /* CNT14            */
    unsigned char  dummy436[2];                            /* Reserved         */
    unsigned short CNT15;                                  /* CNT15            */
    unsigned char  dummy437[2];                            /* Reserved         */
    unsigned char  CMUR0;                                  /* CMUR0            */
    unsigned char  dummy438[3];                            /* Reserved         */
    unsigned char  CMUR1;                                  /* CMUR1            */
    unsigned char  dummy439[3];                            /* Reserved         */
    unsigned char  CMUR2;                                  /* CMUR2            */
    unsigned char  dummy440[3];                            /* Reserved         */
    unsigned char  CMUR3;                                  /* CMUR3            */
    unsigned char  dummy441[3];                            /* Reserved         */
    unsigned char  CMUR4;                                  /* CMUR4            */
    unsigned char  dummy442[3];                            /* Reserved         */
    unsigned char  CMUR5;                                  /* CMUR5            */
    unsigned char  dummy443[3];                            /* Reserved         */
    unsigned char  CMUR6;                                  /* CMUR6            */
    unsigned char  dummy444[3];                            /* Reserved         */
    unsigned char  CMUR7;                                  /* CMUR7            */
    unsigned char  dummy445[3];                            /* Reserved         */
    unsigned char  CMUR8;                                  /* CMUR8            */
    unsigned char  dummy446[3];                            /* Reserved         */
    unsigned char  CMUR9;                                  /* CMUR9            */
    unsigned char  dummy447[3];                            /* Reserved         */
    unsigned char  CMUR10;                                 /* CMUR10           */
    unsigned char  dummy448[3];                            /* Reserved         */
    unsigned char  CMUR11;                                 /* CMUR11           */
    unsigned char  dummy449[3];                            /* Reserved         */
    unsigned char  CMUR12;                                 /* CMUR12           */
    unsigned char  dummy450[3];                            /* Reserved         */
    unsigned char  CMUR13;                                 /* CMUR13           */
    unsigned char  dummy451[3];                            /* Reserved         */
    unsigned char  CMUR14;                                 /* CMUR14           */
    unsigned char  dummy452[3];                            /* Reserved         */
    unsigned char  CMUR15;                                 /* CMUR15           */
    unsigned char  dummy453[67];                           /* Reserved         */
    unsigned char  CSR0;                                   /* CSR0             */
    unsigned char  dummy454[3];                            /* Reserved         */
    unsigned char  CSR1;                                   /* CSR1             */
    unsigned char  dummy455[3];                            /* Reserved         */
    unsigned char  CSR2;                                   /* CSR2             */
    unsigned char  dummy456[3];                            /* Reserved         */
    unsigned char  CSR3;                                   /* CSR3             */
    unsigned char  dummy457[3];                            /* Reserved         */
    unsigned char  CSR4;                                   /* CSR4             */
    unsigned char  dummy458[3];                            /* Reserved         */
    unsigned char  CSR5;                                   /* CSR5             */
    unsigned char  dummy459[3];                            /* Reserved         */
    unsigned char  CSR6;                                   /* CSR6             */
    unsigned char  dummy460[3];                            /* Reserved         */
    unsigned char  CSR7;                                   /* CSR7             */
    unsigned char  dummy461[3];                            /* Reserved         */
    unsigned char  CSR8;                                   /* CSR8             */
    unsigned char  dummy462[3];                            /* Reserved         */
    unsigned char  CSR9;                                   /* CSR9             */
    unsigned char  dummy463[3];                            /* Reserved         */
    unsigned char  CSR10;                                  /* CSR10            */
    unsigned char  dummy464[3];                            /* Reserved         */
    unsigned char  CSR11;                                  /* CSR11            */
    unsigned char  dummy465[3];                            /* Reserved         */
    unsigned char  CSR12;                                  /* CSR12            */
    unsigned char  dummy466[3];                            /* Reserved         */
    unsigned char  CSR13;                                  /* CSR13            */
    unsigned char  dummy467[3];                            /* Reserved         */
    unsigned char  CSR14;                                  /* CSR14            */
    unsigned char  dummy468[3];                            /* Reserved         */
    unsigned char  CSR15;                                  /* CSR15            */
    unsigned char  dummy469[3];                            /* Reserved         */
    unsigned char  CSC0;                                   /* CSC0             */
    unsigned char  dummy470[3];                            /* Reserved         */
    unsigned char  CSC1;                                   /* CSC1             */
    unsigned char  dummy471[3];                            /* Reserved         */
    unsigned char  CSC2;                                   /* CSC2             */
    unsigned char  dummy472[3];                            /* Reserved         */
    unsigned char  CSC3;                                   /* CSC3             */
    unsigned char  dummy473[3];                            /* Reserved         */
    unsigned char  CSC4;                                   /* CSC4             */
    unsigned char  dummy474[3];                            /* Reserved         */
    unsigned char  CSC5;                                   /* CSC5             */
    unsigned char  dummy475[3];                            /* Reserved         */
    unsigned char  CSC6;                                   /* CSC6             */
    unsigned char  dummy476[3];                            /* Reserved         */
    unsigned char  CSC7;                                   /* CSC7             */
    unsigned char  dummy477[3];                            /* Reserved         */
    unsigned char  CSC8;                                   /* CSC8             */
    unsigned char  dummy478[3];                            /* Reserved         */
    unsigned char  CSC9;                                   /* CSC9             */
    unsigned char  dummy479[3];                            /* Reserved         */
    unsigned char  CSC10;                                  /* CSC10            */
    unsigned char  dummy480[3];                            /* Reserved         */
    unsigned char  CSC11;                                  /* CSC11            */
    unsigned char  dummy481[3];                            /* Reserved         */
    unsigned char  CSC12;                                  /* CSC12            */
    unsigned char  dummy482[3];                            /* Reserved         */
    unsigned char  CSC13;                                  /* CSC13            */
    unsigned char  dummy483[3];                            /* Reserved         */
    unsigned char  CSC14;                                  /* CSC14            */
    unsigned char  dummy484[3];                            /* Reserved         */
    unsigned char  CSC15;                                  /* CSC15            */
    unsigned char  dummy485[3];                            /* Reserved         */
    unsigned short TE;                                     /* TE               */
    unsigned char  dummy486[2];                            /* Reserved         */
    unsigned short TS;                                     /* TS               */
    unsigned char  dummy487[2];                            /* Reserved         */
    unsigned short TT;                                     /* TT               */
    unsigned char  dummy488[54];                           /* Reserved         */
    unsigned short CMOR0;                                  /* CMOR0            */
    unsigned char  dummy489[2];                            /* Reserved         */
    unsigned short CMOR1;                                  /* CMOR1            */
    unsigned char  dummy490[2];                            /* Reserved         */
    unsigned short CMOR2;                                  /* CMOR2            */
    unsigned char  dummy491[2];                            /* Reserved         */
    unsigned short CMOR3;                                  /* CMOR3            */
    unsigned char  dummy492[2];                            /* Reserved         */
    unsigned short CMOR4;                                  /* CMOR4            */
    unsigned char  dummy493[2];                            /* Reserved         */
    unsigned short CMOR5;                                  /* CMOR5            */
    unsigned char  dummy494[2];                            /* Reserved         */
    unsigned short CMOR6;                                  /* CMOR6            */
    unsigned char  dummy495[2];                            /* Reserved         */
    unsigned short CMOR7;                                  /* CMOR7            */
    unsigned char  dummy496[2];                            /* Reserved         */
    unsigned short CMOR8;                                  /* CMOR8            */
    unsigned char  dummy497[2];                            /* Reserved         */
    unsigned short CMOR9;                                  /* CMOR9            */
    unsigned char  dummy498[2];                            /* Reserved         */
    unsigned short CMOR10;                                 /* CMOR10           */
    unsigned char  dummy499[2];                            /* Reserved         */
    unsigned short CMOR11;                                 /* CMOR11           */
    unsigned char  dummy500[2];                            /* Reserved         */
    unsigned short CMOR12;                                 /* CMOR12           */
    unsigned char  dummy501[2];                            /* Reserved         */
    unsigned short CMOR13;                                 /* CMOR13           */
    unsigned char  dummy502[2];                            /* Reserved         */
    unsigned short CMOR14;                                 /* CMOR14           */
    unsigned char  dummy503[2];                            /* Reserved         */
    unsigned short CMOR15;                                 /* CMOR15           */
    unsigned char  dummy504[2];                            /* Reserved         */
    unsigned short TPS;                                    /* TPS              */
    unsigned char  dummy505[2];                            /* Reserved         */
    unsigned char  BRS;                                    /* BRS              */
    unsigned char  dummy506[3];                            /* Reserved         */
    unsigned short TOM;                                    /* TOM              */
    unsigned char  dummy507[2];                            /* Reserved         */
    unsigned short TOC;                                    /* TOC              */
    unsigned char  dummy508[2];                            /* Reserved         */
    unsigned short TDE;                                    /* TDE              */
    unsigned char  dummy509[2];                            /* Reserved         */
    unsigned short TDM;                                    /* TDM              */
    unsigned char  dummy510[2];                            /* Reserved         */
    unsigned short TRE;                                    /* TRE              */
    unsigned char  dummy511[2];                            /* Reserved         */
    unsigned short TRC;                                    /* TRC              */
    unsigned char  dummy512[2];                            /* Reserved         */
    unsigned short RDE;                                    /* RDE              */
    unsigned char  dummy513[2];                            /* Reserved         */
    unsigned short RDM;                                    /* RDM              */
    unsigned char  dummy514[2];                            /* Reserved         */
    unsigned short RDS;                                    /* RDS              */
    unsigned char  dummy515[2];                            /* Reserved         */
    unsigned short RDC;                                    /* RDC              */
    unsigned char  dummy516[34];                           /* Reserved         */
    unsigned char  EMU;                                    /* EMU              */
};
struct __tag366
{                                                          /* Module           */
    unsigned short SELB_TAUD0I;                            /* SELB_TAUD0I      */
};
struct __tag367
{                                                          /* Module           */
    unsigned long  CDR0;                                   /* CDR0             */
    unsigned long  CDR1;                                   /* CDR1             */
    unsigned long  CDR2;                                   /* CDR2             */
    unsigned long  CDR3;                                   /* CDR3             */
    unsigned long  CNT0;                                   /* CNT0             */
    unsigned long  CNT1;                                   /* CNT1             */
    unsigned long  CNT2;                                   /* CNT2             */
    unsigned long  CNT3;                                   /* CNT3             */
    unsigned char  CMUR0;                                  /* CMUR0            */
    unsigned char  dummy517[3];                            /* Reserved         */
    unsigned char  CMUR1;                                  /* CMUR1            */
    unsigned char  dummy518[3];                            /* Reserved         */
    unsigned char  CMUR2;                                  /* CMUR2            */
    unsigned char  dummy519[3];                            /* Reserved         */
    unsigned char  CMUR3;                                  /* CMUR3            */
    unsigned char  dummy520[3];                            /* Reserved         */
    unsigned char  CSR0;                                   /* CSR0             */
    unsigned char  dummy521[3];                            /* Reserved         */
    unsigned char  CSR1;                                   /* CSR1             */
    unsigned char  dummy522[3];                            /* Reserved         */
    unsigned char  CSR2;                                   /* CSR2             */
    unsigned char  dummy523[3];                            /* Reserved         */
    unsigned char  CSR3;                                   /* CSR3             */
    unsigned char  dummy524[3];                            /* Reserved         */
    unsigned char  CSC0;                                   /* CSC0             */
    unsigned char  dummy525[3];                            /* Reserved         */
    unsigned char  CSC1;                                   /* CSC1             */
    unsigned char  dummy526[3];                            /* Reserved         */
    unsigned char  CSC2;                                   /* CSC2             */
    unsigned char  dummy527[3];                            /* Reserved         */
    unsigned char  CSC3;                                   /* CSC3             */
    unsigned char  dummy528[3];                            /* Reserved         */
    unsigned char  TE;                                     /* TE               */
    unsigned char  dummy529[3];                            /* Reserved         */
    unsigned char  TS;                                     /* TS               */
    unsigned char  dummy530[3];                            /* Reserved         */
    unsigned char  TT;                                     /* TT               */
    unsigned char  dummy531[3];                            /* Reserved         */
    unsigned char  TO;                                     /* TO               */
    unsigned char  dummy532[3];                            /* Reserved         */
    unsigned char  TOE;                                    /* TOE              */
    unsigned char  dummy533[3];                            /* Reserved         */
    unsigned char  TOL;                                    /* TOL              */
    unsigned char  dummy534[3];                            /* Reserved         */
    unsigned char  RDT;                                    /* RDT              */
    unsigned char  dummy535[3];                            /* Reserved         */
    unsigned char  RSF;                                    /* RSF              */
    unsigned char  dummy536[19];                           /* Reserved         */
    unsigned short CMOR0;                                  /* CMOR0            */
    unsigned char  dummy537[2];                            /* Reserved         */
    unsigned short CMOR1;                                  /* CMOR1            */
    unsigned char  dummy538[2];                            /* Reserved         */
    unsigned short CMOR2;                                  /* CMOR2            */
    unsigned char  dummy539[2];                            /* Reserved         */
    unsigned short CMOR3;                                  /* CMOR3            */
    unsigned char  dummy540[2];                            /* Reserved         */
    unsigned short TPS;                                    /* TPS              */
    unsigned char  dummy541[2];                            /* Reserved         */
    unsigned char  BRS;                                    /* BRS              */
    unsigned char  dummy542[3];                            /* Reserved         */
    unsigned char  TOM;                                    /* TOM              */
    unsigned char  dummy543[3];                            /* Reserved         */
    unsigned char  TOC;                                    /* TOC              */
    unsigned char  dummy544[3];                            /* Reserved         */
    unsigned char  RDE;                                    /* RDE              */
    unsigned char  dummy545[3];                            /* Reserved         */
    unsigned char  RDM;                                    /* RDM              */
    unsigned char  dummy546[3];                            /* Reserved         */
    unsigned char  EMU;                                    /* EMU              */
};
struct __tag368
{                                                          /* Module           */
    unsigned char  SELB_TAUJ0I;                            /* SELB_TAUJ0I      */
};
struct __tag369
{                                                          /* Module           */
    unsigned char  SELB_TAUJ2I;                            /* SELB_TAUJ2I      */
};
struct __tag370
{                                                          /* Module           */
    unsigned char  CTL;                                    /* CTL              */
    unsigned char  dummy547[3];                            /* Reserved         */
    unsigned char  STR;                                    /* STR              */
    unsigned char  dummy548[3];                            /* Reserved         */
    unsigned char  STC;                                    /* STC              */
    unsigned char  dummy549[3];                            /* Reserved         */
    unsigned char  EMU;                                    /* EMU              */
    unsigned char  dummy550[19];                           /* Reserved         */
    unsigned char  QUE0;                                   /* QUE0             */
    unsigned char  dummy551[3];                            /* Reserved         */
    unsigned char  QUE1;                                   /* QUE1             */
    unsigned char  dummy552[3];                            /* Reserved         */
    unsigned char  QUE2;                                   /* QUE2             */
    unsigned char  dummy553[3];                            /* Reserved         */
    unsigned char  QUE3;                                   /* QUE3             */
    unsigned char  dummy554[3];                            /* Reserved         */
    unsigned char  QUE4;                                   /* QUE4             */
    unsigned char  dummy555[3];                            /* Reserved         */
    unsigned char  QUE5;                                   /* QUE5             */
    unsigned char  dummy556[3];                            /* Reserved         */
    unsigned char  QUE6;                                   /* QUE6             */
    unsigned char  dummy557[3];                            /* Reserved         */
    unsigned char  QUE7;                                   /* QUE7             */
    unsigned char  dummy558[3];                            /* Reserved         */
    union __tag164 PVCR00_01;                              /* PVCR00_01        */
    union __tag164 PVCR02_03;                              /* PVCR02_03        */
    union __tag164 PVCR04_05;                              /* PVCR04_05        */
    union __tag164 PVCR06_07;                              /* PVCR06_07        */
    union __tag164 PVCR08_09;                              /* PVCR08_09        */
    union __tag164 PVCR10_11;                              /* PVCR10_11        */
    union __tag164 PVCR12_13;                              /* PVCR12_13        */
    union __tag164 PVCR14_15;                              /* PVCR14_15        */
    union __tag164 PVCR16_17;                              /* PVCR16_17        */
    union __tag164 PVCR18_19;                              /* PVCR18_19        */
    union __tag164 PVCR20_21;                              /* PVCR20_21        */
    union __tag164 PVCR22_23;                              /* PVCR22_23        */
    unsigned char  dummy559[400];                          /* Reserved         */
    unsigned long  PWDDIR00;                               /* PWDDIR00         */
    unsigned long  PWDDIR01;                               /* PWDDIR01         */
    unsigned long  PWDDIR02;                               /* PWDDIR02         */
    unsigned long  PWDDIR03;                               /* PWDDIR03         */
    unsigned long  PWDDIR04;                               /* PWDDIR04         */
    unsigned long  PWDDIR05;                               /* PWDDIR05         */
    unsigned long  PWDDIR06;                               /* PWDDIR06         */
    unsigned long  PWDDIR07;                               /* PWDDIR07         */
    unsigned long  PWDDIR08;                               /* PWDDIR08         */
    unsigned long  PWDDIR09;                               /* PWDDIR09         */
    unsigned long  PWDDIR10;                               /* PWDDIR10         */
    unsigned long  PWDDIR11;                               /* PWDDIR11         */
    unsigned long  PWDDIR12;                               /* PWDDIR12         */
    unsigned long  PWDDIR13;                               /* PWDDIR13         */
    unsigned long  PWDDIR14;                               /* PWDDIR14         */
    unsigned long  PWDDIR15;                               /* PWDDIR15         */
    unsigned long  PWDDIR16;                               /* PWDDIR16         */
    unsigned long  PWDDIR17;                               /* PWDDIR17         */
    unsigned long  PWDDIR18;                               /* PWDDIR18         */
    unsigned long  PWDDIR19;                               /* PWDDIR19         */
    unsigned long  PWDDIR20;                               /* PWDDIR20         */
    unsigned long  PWDDIR21;                               /* PWDDIR21         */
    unsigned long  PWDDIR22;                               /* PWDDIR22         */
    unsigned long  PWDDIR23;                               /* PWDDIR23         */
};
struct __tag371
{                                                          /* Module           */
    unsigned short CSDR;                                   /* CSDR             */
    unsigned char  dummy560[2];                            /* Reserved         */
    unsigned short CRDR;                                   /* CRDR             */
    unsigned char  dummy561[2];                            /* Reserved         */
    unsigned short CTDR;                                   /* CTDR             */
    unsigned char  dummy562[2];                            /* Reserved         */
    unsigned char  RDT;                                    /* RDT              */
    unsigned char  dummy563[3];                            /* Reserved         */
    unsigned char  RSF;                                    /* RSF              */
    unsigned char  dummy564[3];                            /* Reserved         */
    unsigned short CNT;                                    /* CNT              */
    unsigned char  dummy565[2];                            /* Reserved         */
    unsigned char  TCR;                                    /* TCR              */
    unsigned char  dummy566[3];                            /* Reserved         */
    unsigned char  TCBR;                                   /* TCBR             */
    unsigned char  dummy567[3];                            /* Reserved         */
    unsigned char  CTL;                                    /* CTL              */
    unsigned char  dummy568[3];                            /* Reserved         */
    unsigned short CSBR;                                   /* CSBR             */
    unsigned char  dummy569[2];                            /* Reserved         */
    unsigned short CRBR;                                   /* CRBR             */
    unsigned char  dummy570[2];                            /* Reserved         */
    unsigned short CTBR;                                   /* CTBR             */
};
struct __tag372
{                                                          /* Module           */
    unsigned short BRS0;                                   /* BRS0             */
    unsigned char  dummy571[2];                            /* Reserved         */
    unsigned short BRS1;                                   /* BRS1             */
    unsigned char  dummy572[2];                            /* Reserved         */
    unsigned short BRS2;                                   /* BRS2             */
    unsigned char  dummy573[2];                            /* Reserved         */
    unsigned short BRS3;                                   /* BRS3             */
    unsigned char  dummy574[2];                            /* Reserved         */
    unsigned char  TE;                                     /* TE               */
    unsigned char  dummy575[3];                            /* Reserved         */
    unsigned char  TS;                                     /* TS               */
    unsigned char  dummy576[3];                            /* Reserved         */
    unsigned char  TT;                                     /* TT               */
    unsigned char  dummy577[3];                            /* Reserved         */
    unsigned char  EMU;                                    /* EMU              */
};
struct __tag373
{                                                          /* Module           */
    unsigned long  A0;                                     /* A0               */
    unsigned char  dummy578[8];                            /* Reserved         */
    unsigned short PWGAPRD;                                /* PWGAPRD          */
    unsigned char  dummy579[2];                            /* Reserved         */
    unsigned long  PWGAPRDSL0;                             /* PWGAPRDSL0       */
};
struct __tag374
{                                                          /* Module           */
    unsigned long  PWGAINTF00;                             /* PWGAINTF00       */
    unsigned long  PWGAINTMSK00;                           /* PWGAINTMSK00     */
    unsigned long  PWGAINTFC00;                            /* PWGAINTFC00      */
};
struct __tag375
{                                                          /* Module           */
    union __tag170 CTL0;                                   /* CTL0             */
    unsigned char  dummy580[3];                            /* Reserved         */
    union __tag171 CTL1;                                   /* CTL1             */
    unsigned char  dummy581[3];                            /* Reserved         */
    union __tag172 CTL2;                                   /* CTL2             */
    unsigned char  dummy582[3];                            /* Reserved         */
    unsigned long  SUBC;                                   /* SUBC             */
    unsigned long  SRBU;                                   /* SRBU             */
    unsigned char  SEC;                                    /* SEC              */
    unsigned char  dummy583[3];                            /* Reserved         */
    unsigned char  MIN;                                    /* MIN              */
    unsigned char  dummy584[3];                            /* Reserved         */
    unsigned char  HOUR;                                   /* HOUR             */
    unsigned char  dummy585[3];                            /* Reserved         */
    unsigned char  WEEK;                                   /* WEEK             */
    unsigned char  dummy586[3];                            /* Reserved         */
    unsigned char  DAY;                                    /* DAY              */
    unsigned char  dummy587[3];                            /* Reserved         */
    unsigned char  MONTH;                                  /* MONTH            */
    unsigned char  dummy588[3];                            /* Reserved         */
    unsigned char  YEAR;                                   /* YEAR             */
    unsigned char  dummy589[3];                            /* Reserved         */
    unsigned long  TIME;                                   /* TIME             */
    unsigned long  CAL;                                    /* CAL              */
    unsigned char  SUBU;                                   /* SUBU             */
    unsigned char  dummy590[3];                            /* Reserved         */
    unsigned long  SCMP;                                   /* SCMP             */
    unsigned char  ALM;                                    /* ALM              */
    unsigned char  dummy591[3];                            /* Reserved         */
    unsigned char  ALH;                                    /* ALH              */
    unsigned char  dummy592[3];                            /* Reserved         */
    unsigned char  ALW;                                    /* ALW              */
    unsigned char  dummy593[3];                            /* Reserved         */
    unsigned char  SECC;                                   /* SECC             */
    unsigned char  dummy594[3];                            /* Reserved         */
    unsigned char  MINC;                                   /* MINC             */
    unsigned char  dummy595[3];                            /* Reserved         */
    unsigned char  HOURC;                                  /* HOURC            */
    unsigned char  dummy596[3];                            /* Reserved         */
    unsigned char  WEEKC;                                  /* WEEKC            */
    unsigned char  dummy597[3];                            /* Reserved         */
    unsigned char  DAYC;                                   /* DAYC             */
    unsigned char  dummy598[3];                            /* Reserved         */
    unsigned char  MONC;                                   /* MONC             */
    unsigned char  dummy599[3];                            /* Reserved         */
    unsigned char  YEARC;                                  /* YEARC            */
    unsigned char  dummy600[3];                            /* Reserved         */
    unsigned long  TIMEC;                                  /* TIMEC            */
    unsigned long  CALC;                                   /* CALC             */
    unsigned char  dummy601[4];                            /* Reserved         */
    union __tag168 EMU;                                    /* EMU              */
};
struct __tag376
{                                                          /* Module           */
    unsigned short CCR0;                                   /* CCR0             */
    unsigned char  dummy602[2];                            /* Reserved         */
    unsigned short CCR1;                                   /* CCR1             */
    unsigned char  dummy603[2];                            /* Reserved         */
    unsigned short CNT;                                    /* CNT              */
    unsigned char  dummy604[2];                            /* Reserved         */
    unsigned char  FLG;                                    /* FLG              */
    unsigned char  dummy605[3];                            /* Reserved         */
    unsigned char  FGC;                                    /* FGC              */
    unsigned char  dummy606[3];                            /* Reserved         */
    unsigned char  TE;                                     /* TE               */
    unsigned char  dummy607[3];                            /* Reserved         */
    unsigned char  TS;                                     /* TS               */
    unsigned char  dummy608[3];                            /* Reserved         */
    unsigned char  TT;                                     /* TT               */
    unsigned char  dummy609[3];                            /* Reserved         */
    unsigned char  IOC0;                                   /* IOC0             */
    unsigned char  dummy610[31];                           /* Reserved         */
    unsigned short CTL;                                    /* CTL              */
    unsigned char  dummy611[2];                            /* Reserved         */
    unsigned char  IOC1;                                   /* IOC1             */
    unsigned char  dummy612[3];                            /* Reserved         */
    unsigned char  EMU;                                    /* EMU              */
};
struct __tag377
{                                                          /* Module           */
    unsigned short FLG;                                    /* FLG              */
    unsigned char  dummy613[2];                            /* Reserved         */
    unsigned char  ACWE;                                   /* ACWE             */
    unsigned char  dummy614[3];                            /* Reserved         */
    unsigned char  ACTS;                                   /* ACTS             */
    unsigned char  dummy615[3];                            /* Reserved         */
    unsigned char  ACTT;                                   /* ACTT             */
    unsigned char  dummy616[7];                            /* Reserved         */
    unsigned char  OPHS;                                   /* OPHS             */
    unsigned char  dummy617[3];                            /* Reserved         */
    unsigned char  OPHT;                                   /* OPHT             */
    unsigned char  dummy618[7];                            /* Reserved         */
    unsigned short CTL0;                                   /* CTL0             */
    unsigned char  dummy619[2];                            /* Reserved         */
    unsigned char  CTL1;                                   /* CTL1             */
    unsigned char  dummy620[3];                            /* Reserved         */
    unsigned char  EMU;                                    /* EMU              */
};
struct __tag378
{                                                          /* Module           */
    unsigned char  WDTE;                                   /* WDTE             */
    unsigned char  dummy621[3];                            /* Reserved         */
    unsigned char  EVAC;                                   /* EVAC             */
    unsigned char  dummy622[3];                            /* Reserved         */
    unsigned char  REF;                                    /* REF              */
    unsigned char  dummy623[3];                            /* Reserved         */
    unsigned char  MD;                                     /* MD               */
};
struct __tag379
{                                                          /* Module           */
    union __tag158 VCR00;                                  /* VCR00            */
    union __tag158 VCR01;                                  /* VCR01            */
    union __tag158 VCR02;                                  /* VCR02            */
    union __tag158 VCR03;                                  /* VCR03            */
    union __tag158 VCR04;                                  /* VCR04            */
    union __tag158 VCR05;                                  /* VCR05            */
    union __tag158 VCR06;                                  /* VCR06            */
    union __tag158 VCR07;                                  /* VCR07            */
    union __tag158 VCR08;                                  /* VCR08            */
    union __tag158 VCR09;                                  /* VCR09            */
    union __tag158 VCR10;                                  /* VCR10            */
    union __tag158 VCR11;                                  /* VCR11            */
    union __tag158 VCR12;                                  /* VCR12            */
    union __tag158 VCR13;                                  /* VCR13            */
    union __tag158 VCR14;                                  /* VCR14            */
    union __tag158 VCR15;                                  /* VCR15            */
    union __tag158 VCR16;                                  /* VCR16            */
    union __tag158 VCR17;                                  /* VCR17            */
    union __tag158 VCR18;                                  /* VCR18            */
    union __tag158 VCR19;                                  /* VCR19            */
    union __tag158 VCR20;                                  /* VCR20            */
    union __tag158 VCR21;                                  /* VCR21            */
    union __tag158 VCR22;                                  /* VCR22            */
    union __tag158 VCR23;                                  /* VCR23            */
    union __tag158 VCR24;                                  /* VCR24            */
    union __tag158 VCR25;                                  /* VCR25            */
    union __tag158 VCR26;                                  /* VCR26            */
    union __tag158 VCR27;                                  /* VCR27            */
    union __tag158 VCR28;                                  /* VCR28            */
    unsigned char  dummy624[16];                           /* Reserved         */
    union __tag158 VCR33;                                  /* VCR33            */
    union __tag158 VCR34;                                  /* VCR34            */
    union __tag158 VCR35;                                  /* VCR35            */
    unsigned char  dummy625[100];                          /* Reserved         */
    union __tag158 PWDVCR;                                 /* PWDVCR           */
    unsigned char  dummy626[8];                            /* Reserved         */
    union __tag164 DR00;                                   /* DR00             */
    union __tag164 DR02;                                   /* DR02             */
    union __tag164 DR04;                                   /* DR04             */
    union __tag164 DR06;                                   /* DR06             */
    union __tag164 DR08;                                   /* DR08             */
    union __tag164 DR10;                                   /* DR10             */
    union __tag164 DR12;                                   /* DR12             */
    union __tag164 DR14;                                   /* DR14             */
    union __tag164 DR16;                                   /* DR16             */
    union __tag164 DR18;                                   /* DR18             */
    union __tag164 DR20;                                   /* DR20             */
    union __tag164 DR22;                                   /* DR22             */
    union __tag164 DR24;                                   /* DR24             */
    union __tag164 DR26;                                   /* DR26             */
    union __tag164 DR28;                                   /* DR28             */
    unsigned char  dummy627[4];                            /* Reserved         */
    union __tag164 DR32;                                   /* DR32             */
    union __tag164 DR34;                                   /* DR34             */
    unsigned char  dummy628[48];                           /* Reserved         */
    union __tag164 PWDTSNDR;                               /* PWDTSNDR         */
    unsigned char  dummy629[132];                          /* Reserved         */
    unsigned long  DIR00;                                  /* DIR00            */
    unsigned long  DIR01;                                  /* DIR01            */
    unsigned long  DIR02;                                  /* DIR02            */
    unsigned long  DIR03;                                  /* DIR03            */
    unsigned long  DIR04;                                  /* DIR04            */
    unsigned long  DIR05;                                  /* DIR05            */
    unsigned long  DIR06;                                  /* DIR06            */
    unsigned long  DIR07;                                  /* DIR07            */
    unsigned long  DIR08;                                  /* DIR08            */
    unsigned long  DIR09;                                  /* DIR09            */
    unsigned long  DIR10;                                  /* DIR10            */
    unsigned long  DIR11;                                  /* DIR11            */
    unsigned long  DIR12;                                  /* DIR12            */
    unsigned long  DIR13;                                  /* DIR13            */
    unsigned long  DIR14;                                  /* DIR14            */
    unsigned long  DIR15;                                  /* DIR15            */
    unsigned long  DIR16;                                  /* DIR16            */
    unsigned long  DIR17;                                  /* DIR17            */
    unsigned long  DIR18;                                  /* DIR18            */
    unsigned long  DIR19;                                  /* DIR19            */
    unsigned long  DIR20;                                  /* DIR20            */
    unsigned long  DIR21;                                  /* DIR21            */
    unsigned long  DIR22;                                  /* DIR22            */
    unsigned long  DIR23;                                  /* DIR23            */
    unsigned long  DIR24;                                  /* DIR24            */
    unsigned long  DIR25;                                  /* DIR25            */
    unsigned long  DIR26;                                  /* DIR26            */
    unsigned long  DIR27;                                  /* DIR27            */
    unsigned long  DIR28;                                  /* DIR28            */
    unsigned char  dummy630[16];                           /* Reserved         */
    unsigned long  DIR33;                                  /* DIR33            */
    unsigned long  DIR34;                                  /* DIR34            */
    unsigned long  DIR35;                                  /* DIR35            */
    unsigned char  dummy631[100];                          /* Reserved         */
    unsigned long  PWDDIR;                                 /* PWDDIR           */
    unsigned char  dummy632[8];                            /* Reserved         */
    union __tag158 ADHALTR;                                /* ADHALTR          */
    union __tag158 ADCR;                                   /* ADCR             */
    union __tag164 SGSTR;                                  /* SGSTR            */
    union __tag158 MPXCURR;                                /* MPXCURR          */
    unsigned char  dummy633[4];                            /* Reserved         */
    union __tag158 THSMPSTCR;                              /* THSMPSTCR        */
    union __tag158 THCR;                                   /* THCR             */
    union __tag158 THAHLDSTCR;                             /* THAHLDSTCR       */
    union __tag158 THBHLDSTCR;                             /* THBHLDSTCR       */
    union __tag158 THACR;                                  /* THACR            */
    union __tag158 THBCR;                                  /* THBCR            */
    union __tag158 THER;                                   /* THER             */
    union __tag158 THGSR;                                  /* THGSR            */
    union __tag158 SFTCR;                                  /* SFTCR            */
    union __tag164 ULLMTBR0;                               /* ULLMTBR0         */
    union __tag164 ULLMTBR1;                               /* ULLMTBR1         */
    union __tag164 ULLMTBR2;                               /* ULLMTBR2         */
    union __tag158 ECR;                                    /* ECR              */
    union __tag158 ULER;                                   /* ULER             */
    union __tag158 OWER;                                   /* OWER             */
    union __tag158 DGCTL0;                                 /* DGCTL0           */
    union __tag164 DGCTL1;                                 /* DGCTL1           */
    union __tag164 PDCTL1;                                 /* PDCTL1           */
    union __tag158 PDCTL2;                                 /* PDCTL2           */
    unsigned char  dummy634[32];                           /* Reserved         */
    union __tag158 SMPCR;                                  /* SMPCR            */
    unsigned char  dummy635[4];                            /* Reserved         */
    unsigned char  EMU;                                    /* EMU              */
    unsigned char  dummy636[183];                          /* Reserved         */
    union __tag158 SGSTCR1;                                /* SGSTCR1          */
    union __tag158 SGSTPCR1;                               /* SGSTPCR1         */
    union __tag158 SGCR1;                                  /* SGCR1            */
    union __tag158 SGVCSP1;                                /* SGVCSP1          */
    union __tag158 SGVCEP1;                                /* SGVCEP1          */
    union __tag158 SGMCYCR1;                               /* SGMCYCR1         */
    union __tag158 SGSEFCR1;                               /* SGSEFCR1         */
    union __tag164 SGTSEL1;                                /* SGTSEL1          */
    unsigned char  dummy637[32];                           /* Reserved         */
    union __tag158 SGSTCR2;                                /* SGSTCR2          */
    union __tag158 SGSTPCR2;                               /* SGSTPCR2         */
    union __tag158 SGCR2;                                  /* SGCR2            */
    union __tag158 SGVCSP2;                                /* SGVCSP2          */
    union __tag158 SGVCEP2;                                /* SGVCEP2          */
    union __tag158 SGMCYCR2;                               /* SGMCYCR2         */
    union __tag158 SGSEFCR2;                               /* SGSEFCR2         */
    union __tag164 SGTSEL2;                                /* SGTSEL2          */
    unsigned char  dummy638[32];                           /* Reserved         */
    union __tag158 SGSTCR3;                                /* SGSTCR3          */
    union __tag158 SGSTPCR3;                               /* SGSTPCR3         */
    union __tag158 SGCR3;                                  /* SGCR3            */
    union __tag158 SGVCSP3;                                /* SGVCSP3          */
    union __tag158 SGVCEP3;                                /* SGVCEP3          */
    union __tag158 SGMCYCR3;                               /* SGMCYCR3         */
    union __tag158 SGSEFCR3;                               /* SGSEFCR3         */
    union __tag164 SGTSEL3;                                /* SGTSEL3          */
    unsigned char  dummy639[36];                           /* Reserved         */
    union __tag158 PWDSGSTPCR;                             /* PWDSGSTPCR       */
    union __tag158 PWDSGCR;                                /* PWDSGCR          */
    unsigned char  dummy640[12];                           /* Reserved         */
    union __tag158 PWDSGSEFCR;                             /* PWDSGSEFCR       */
    unsigned char  dummy641[36];                           /* Reserved         */
    unsigned long  ULEVCFR0;                               /* ULEVCFR0         */
    unsigned long  ULEVCFR1;                               /* ULEVCFR1         */
    unsigned char  dummy642[28];                           /* Reserved         */
    union __tag164 ULLMTBR3;                               /* ULLMTBR3         */
    union __tag164 ULLMTBR4;                               /* ULLMTBR4         */
    union __tag164 ULLMTBR5;                               /* ULLMTBR5         */
    union __tag164 ULLMTBR6;                               /* ULLMTBR6         */
    union __tag164 ULLMTBR7;                               /* ULLMTBR7         */
    unsigned char  dummy643[120];                          /* Reserved         */
    union __tag164 MPXSTBTSELR0;                           /* MPXSTBTSELR0     */
    union __tag164 MPXSTBTSELR1;                           /* MPXSTBTSELR1     */
    union __tag164 MPXSTBTSELR2;                           /* MPXSTBTSELR2     */
    union __tag164 MPXSTBTSELR3;                           /* MPXSTBTSELR3     */
    unsigned char  dummy644[16];                           /* Reserved         */
    union __tag164 MPXSTBTR0;                              /* MPXSTBTR0        */
    union __tag164 MPXSTBTR1;                              /* MPXSTBTR1        */
    union __tag164 MPXSTBTR2;                              /* MPXSTBTR2        */
    union __tag164 MPXSTBTR3;                              /* MPXSTBTR3        */
    union __tag164 MPXSTBTR4;                              /* MPXSTBTR4        */
    union __tag164 MPXSTBTR5;                              /* MPXSTBTR5        */
    union __tag164 MPXSTBTR6;                              /* MPXSTBTR6        */
    union __tag164 MPXSTBTR7;                              /* MPXSTBTR7        */
};
struct __tag380
{                                                          /* Module           */
    unsigned long  CIN;                                    /* CIN              */
    unsigned long  COUT;                                   /* COUT             */
    unsigned char  dummy645[24];                           /* Reserved         */
    unsigned char  CTL;                                    /* CTL              */
};
struct __tag381
{                                                          /* Module           */
    union __tag173 KRM;                                    /* KRM              */
};
struct __tag382
{                                                          /* Module           */
    unsigned long  PROTCMD0;                               /* PROTCMD0         */
    unsigned long  PROTS0;                                 /* PROTS0           */
    unsigned char  dummy646[32760];                        /* Reserved         */
    unsigned long  PROTCMD1;                               /* PROTCMD1         */
    unsigned long  PROTS1;                                 /* PROTS1           */
};
struct __tag383
{                                                          /* Module           */
    unsigned long  PSC;                                    /* PSC              */
    unsigned char  dummy647[12];                           /* Reserved         */
    unsigned long  STPT;                                   /* STPT             */
};
struct __tag384
{                                                          /* Module           */
    unsigned long  WUF0;                                   /* WUF0             */
    unsigned long  WUFMSK0;                                /* WUFMSK0          */
    unsigned long  WUFC0;                                  /* WUFC0            */
};
struct __tag385
{                                                          /* Module           */
    unsigned long  WUF1;                                   /* WUF1             */
    unsigned long  WUFMSK1;                                /* WUFMSK1          */
    unsigned long  WUFC1;                                  /* WUFC1            */
};
struct __tag386
{                                                          /* Module           */
    unsigned long  WUF20;                                  /* WUF20            */
    unsigned long  WUFMSK20;                               /* WUFMSK20         */
    unsigned long  WUFC20;                                 /* WUFC20           */
};
struct __tag387
{                                                          /* Module           */
    unsigned long  RESF;                                   /* RESF             */
    unsigned char  dummy648[4];                            /* Reserved         */
    unsigned long  RESFC;                                  /* RESFC            */
    unsigned char  dummy649[244];                          /* Reserved         */
    unsigned long  RESFR;                                  /* RESFR            */
    unsigned char  dummy650[4];                            /* Reserved         */
    unsigned long  RESFCR;                                 /* RESFCR           */
    unsigned char  dummy651[408];                          /* Reserved         */
    unsigned long  SWRESA;                                 /* SWRESA           */
    unsigned char  dummy652[11256];                        /* Reserved         */
    unsigned long  CYCRBASE;                               /* CYCRBASE         */
};
struct __tag388
{                                                          /* Module           */
    unsigned long  VLVF;                                   /* VLVF             */
    unsigned char  dummy653[4];                            /* Reserved         */
    unsigned long  VLVFC;                                  /* VLVFC            */
    unsigned char  dummy654[116];                          /* Reserved         */
    unsigned long  LVICNT;                                 /* LVICNT           */
    unsigned char  dummy655[9980];                         /* Reserved         */
    unsigned long  CVMF;                                   /* CVMF             */
    unsigned long  CVMDE;                                  /* CVMDE            */
    unsigned char  dummy656[12];                           /* Reserved         */
    unsigned long  CVMDIAG;                                /* CVMDIAG          */
    unsigned char  dummy657[232];                          /* Reserved         */
    unsigned long  PROTCMDCVM;                             /* PROTCMDCVM       */
    unsigned long  PROTSCVM;                               /* PROTSCVM         */
};
struct __tag389
{                                                          /* Module           */
    unsigned long  IOHOLD;                                 /* IOHOLD           */
};
struct __tag390
{                                                          /* Module           */
    unsigned long  ROSCE;                                  /* ROSCE            */
    unsigned long  ROSCS;                                  /* ROSCS            */
    unsigned char  dummy658[16];                           /* Reserved         */
    unsigned long  ROSCSTPM;                               /* ROSCSTPM         */
    unsigned long  ROSCUT;                                 /* ROSCUT           */
    unsigned char  dummy659[224];                          /* Reserved         */
    unsigned long  MOSCE;                                  /* MOSCE            */
    unsigned long  MOSCS;                                  /* MOSCS            */
    unsigned long  MOSCC;                                  /* MOSCC            */
    unsigned long  MOSCST;                                 /* MOSCST           */
    unsigned char  dummy660[8];                            /* Reserved         */
    unsigned long  MOSCSTPM;                               /* MOSCSTPM         */
    unsigned long  MOSCM;                                  /* MOSCM            */
    unsigned char  dummy661[3808];                         /* Reserved         */
    unsigned long  CKSC_AWDTAD_CTL;                        /* CKSC_AWDTAD_CTL  */
    unsigned char  dummy662[4];                            /* Reserved         */
    unsigned long  CKSC_AWDTAD_ACT;                        /* CKSC_AWDTAD_ACT  */
    unsigned char  dummy663[12];                           /* Reserved         */
    unsigned long  CKSC_AWDTAD_STPM;                       /* CKSC_AWDTAD_STPM */
    unsigned char  dummy664[228];                          /* Reserved         */
    unsigned long  CKSC_ATAUJS_CTL;                        /* CKSC_ATAUJS_CTL  */
    unsigned char  dummy665[4];                            /* Reserved         */
    unsigned long  CKSC_ATAUJS_ACT;                        /* CKSC_ATAUJS_ACT  */
    unsigned char  dummy666[244];                          /* Reserved         */
    unsigned long  CKSC_ATAUJD_CTL;                        /* CKSC_ATAUJD_CTL  */
    unsigned char  dummy667[4];                            /* Reserved         */
    unsigned long  CKSC_ATAUJD_ACT;                        /* CKSC_ATAUJD_ACT  */
    unsigned char  dummy668[12];                           /* Reserved         */
    unsigned long  CKSC_ATAUJD_STPM;                       /* CKSC_ATAUJD_STPM */
    unsigned char  dummy669[228];                          /* Reserved         */
    unsigned long  CKSC_ARTCAS_CTL;                        /* CKSC_ARTCAS_CTL  */
    unsigned char  dummy670[4];                            /* Reserved         */
    unsigned long  CKSC_ARTCAS_ACT;                        /* CKSC_ARTCAS_ACT  */
    unsigned char  dummy671[244];                          /* Reserved         */
    unsigned long  CKSC_ARTCAD_CTL;                        /* CKSC_ARTCAD_CTL  */
    unsigned char  dummy672[4];                            /* Reserved         */
    unsigned long  CKSC_ARTCAD_ACT;                        /* CKSC_ARTCAD_ACT  */
    unsigned char  dummy673[12];                           /* Reserved         */
    unsigned long  CKSC_ARTCAD_STPM;                       /* CKSC_ARTCAD_STPM */
    unsigned char  dummy674[228];                          /* Reserved         */
    unsigned long  CKSC_AADCAS_CTL;                        /* CKSC_AADCAS_CTL  */
    unsigned char  dummy675[4];                            /* Reserved         */
    unsigned long  CKSC_AADCAS_ACT;                        /* CKSC_AADCAS_ACT  */
    unsigned char  dummy676[244];                          /* Reserved         */
    unsigned long  CKSC_AADCAD_CTL;                        /* CKSC_AADCAD_CTL  */
    unsigned char  dummy677[4];                            /* Reserved         */
    unsigned long  CKSC_AADCAD_ACT;                        /* CKSC_AADCAD_ACT  */
    unsigned char  dummy678[12];                           /* Reserved         */
    unsigned long  CKSC_AADCAD_STPM;                       /* CKSC_AADCAD_STPM */
    unsigned char  dummy679[228];                          /* Reserved         */
    unsigned long  CKSC_AFOUTS_CTL;                        /* CKSC_AFOUTS_CTL  */
    unsigned char  dummy680[4];                            /* Reserved         */
    unsigned long  CKSC_AFOUTS_ACT;                        /* CKSC_AFOUTS_ACT  */
    unsigned char  dummy681[12];                           /* Reserved         */
    unsigned long  CKSC_AFOUTS_STPM;                       /* CKSC_AFOUTS_STPM */
    unsigned char  dummy682[228];                          /* Reserved         */
    unsigned long  FOUTDIV;                                /* FOUTDIV          */
    unsigned long  FOUTSTAT;                               /* FOUTSTAT         */
    unsigned char  dummy683[26616];                        /* Reserved         */
    unsigned long  PLL1E;                                  /* PLL1E            */
    unsigned long  PLL1S;                                  /* PLL1S            */
    unsigned long  PLL1C;                                  /* PLL1C            */
    unsigned char  dummy684[4084];                         /* Reserved         */
    unsigned long  CKSC_CPUCLKS_CTL;                       /* CKSC_CPUCLKS_CTL */
    unsigned char  dummy685[4];                            /* Reserved         */
    unsigned long  CKSC_CPUCLKS_ACT;                       /* CKSC_CPUCLKS_ACT */
    unsigned char  dummy686[4];                            /* Reserved         */
    unsigned long  CKSC_PPLLCLKS_CTL;                      /* CKSC_PPLLCLKS_CTL */
    unsigned char  dummy687[4];                            /* Reserved         */
    unsigned long  CKSC_PPLLCLKS_ACT;                      /* CKSC_PPLLCLKS_ACT */
    unsigned char  dummy688[228];                          /* Reserved         */
    unsigned long  CKSC_CPUCLKD_CTL;                       /* CKSC_CPUCLKD_CTL */
    unsigned char  dummy689[4];                            /* Reserved         */
    unsigned long  CKSC_CPUCLKD_ACT;                       /* CKSC_CPUCLKD_ACT */
    unsigned char  dummy690[244];                          /* Reserved         */
    unsigned long  CKSC_IPERI1S_CTL;                       /* CKSC_IPERI1S_CTL */
    unsigned char  dummy691[4];                            /* Reserved         */
    unsigned long  CKSC_IPERI1S_ACT;                       /* CKSC_IPERI1S_ACT */
    unsigned char  dummy692[244];                          /* Reserved         */
    unsigned long  CKSC_IPERI2S_CTL;                       /* CKSC_IPERI2S_CTL */
    unsigned char  dummy693[4];                            /* Reserved         */
    unsigned long  CKSC_IPERI2S_ACT;                       /* CKSC_IPERI2S_ACT */
    unsigned char  dummy694[244];                          /* Reserved         */
    unsigned long  CKSC_ILINS_CTL;                         /* CKSC_ILINS_CTL   */
    unsigned char  dummy695[4];                            /* Reserved         */
    unsigned long  CKSC_ILINS_ACT;                         /* CKSC_ILINS_ACT   */
    unsigned char  dummy696[756];                          /* Reserved         */
    unsigned long  CKSC_PLL1IS_CTL;                        /* CKSC_PLL1IS_CTL  */
    unsigned char  dummy697[4];                            /* Reserved         */
    unsigned long  CKSC_PLL1IS_ACT;                        /* CKSC_PLL1IS_ACT  */
    unsigned char  dummy698[244];                          /* Reserved         */
    unsigned long  CKSC_ILIND_CTL;                         /* CKSC_ILIND_CTL   */
    unsigned char  dummy699[4];                            /* Reserved         */
    unsigned long  CKSC_ILIND_ACT;                         /* CKSC_ILIND_ACT   */
    unsigned char  dummy700[12];                           /* Reserved         */
    unsigned long  CKSC_ILIND_STPM;                        /* CKSC_ILIND_STPM  */
    unsigned char  dummy701[228];                          /* Reserved         */
    unsigned long  CKSC_ICANS_CTL;                         /* CKSC_ICANS_CTL   */
    unsigned char  dummy702[4];                            /* Reserved         */
    unsigned long  CKSC_ICANS_ACT;                         /* CKSC_ICANS_ACT   */
    unsigned char  dummy703[12];                           /* Reserved         */
    unsigned long  CKSC_ICANS_STPM;                        /* CKSC_ICANS_STPM  */
    unsigned char  dummy704[228];                          /* Reserved         */
    unsigned long  CKSC_ICANOSCD_CTL;                      /* CKSC_ICANOSCD_CTL */
    unsigned char  dummy705[4];                            /* Reserved         */
    unsigned long  CKSC_ICANOSCD_ACT;                      /* CKSC_ICANOSCD_ACT */
    unsigned char  dummy706[12];                           /* Reserved         */
    unsigned long  CKSC_ICANOSCD_STPM;                     /* CKSC_ICANOSCD_STPM */
    unsigned char  dummy707[228];                          /* Reserved         */
    unsigned long  CKSC_ICSIS_CTL;                         /* CKSC_ICSIS_CTL   */
    unsigned char  dummy708[4];                            /* Reserved         */
    unsigned long  CKSC_ICSIS_ACT;                         /* CKSC_ICSIS_ACT   */
    unsigned char  dummy709[244];                          /* Reserved         */
    unsigned long  CKSC_IIICS_CTL;                         /* CKSC_IIICS_CTL   */
    unsigned char  dummy710[4];                            /* Reserved         */
    unsigned long  CKSC_IIICS_ACT;                         /* CKSC_IIICS_ACT   */
};
struct __tag391
{                                                          /* Module           */
    unsigned long  SCTLR;                                  /* SCTLR            */
    unsigned long  EVFR;                                   /* EVFR             */
    unsigned long  DPSELR0;                                /* DPSELR0          */
    union __tag174 DPSELRM;                                /* DPSELRM          */
    union __tag175 DPSELRH;                                /* DPSELRH          */
    unsigned long  DPDSR0;                                 /* DPDSR0           */
    union __tag176 DPDSRM;                                 /* DPDSRM           */
    union __tag177 DPDSRH;                                 /* DPDSRH           */
    unsigned long  DPDIMR0;                                /* DPDIMR0          */
    unsigned char  DPDIMR1;                                /* DPDIMR1          */
    unsigned char  dummy711[3];                            /* Reserved         */
    unsigned char  DPDIMR2;                                /* DPDIMR2          */
    unsigned char  dummy712[3];                            /* Reserved         */
    unsigned char  DPDIMR3;                                /* DPDIMR3          */
    unsigned char  dummy713[3];                            /* Reserved         */
    unsigned char  DPDIMR4;                                /* DPDIMR4          */
    unsigned char  dummy714[3];                            /* Reserved         */
    unsigned char  DPDIMR5;                                /* DPDIMR5          */
    unsigned char  dummy715[3];                            /* Reserved         */
    unsigned char  DPDIMR6;                                /* DPDIMR6          */
    unsigned char  dummy716[3];                            /* Reserved         */
    unsigned char  DPDIMR7;                                /* DPDIMR7          */
    unsigned char  dummy717[3];                            /* Reserved         */
    unsigned short CNTVAL;                                 /* CNTVAL           */
    unsigned char  dummy718[2];                            /* Reserved         */
    unsigned char  SOSTR;                                  /* SOSTR            */
};
struct __tag392
{                                                          /* Module           */
    unsigned long  WUF_ISO0;                               /* WUF_ISO0         */
    unsigned long  WUFMSK_ISO0;                            /* WUFMSK_ISO0      */
    unsigned long  WUFC_ISO0;                              /* WUFC_ISO0        */
};
struct __tag393
{                                                          /* Module           */
    unsigned char  CTL0;                                   /* CTL0             */
    unsigned char  dummy719[7];                            /* Reserved         */
    unsigned short CMPL;                                   /* CMPL             */
    unsigned char  dummy720[2];                            /* Reserved         */
    unsigned short CMPH;                                   /* CMPH             */
    unsigned char  dummy721[2];                            /* Reserved         */
    unsigned char  PCMD;                                   /* PCMD             */
    unsigned char  dummy722[3];                            /* Reserved         */
    unsigned char  PS;                                     /* PS               */
    unsigned char  dummy723[3];                            /* Reserved         */
    unsigned char  EMU0;                                   /* EMU0             */
};
struct __tag394
{                                                          /* Module           */
    unsigned long  TEST;                                   /* TEST             */
    unsigned long  TESTS;                                  /* TESTS            */
    unsigned char  dummy724[248];                          /* Reserved         */
    unsigned long  PROTCMDCLMA;                            /* PROTCMDCLMA      */
    unsigned long  PROTSCLMA;                              /* PROTSCLMA        */
};
struct __tag395
{                                                          /* Module           */
    union __tag158 FSGD06PROT0;                            /* FSGD06PROT0      */
    union __tag158 FSGD06PROT1;                            /* FSGD06PROT1      */
    unsigned char  dummy725[8];                            /* Reserved         */
    union __tag158 FSGD06PROT4;                            /* FSGD06PROT4      */
    union __tag158 FSGD06PROT5;                            /* FSGD06PROT5      */
    union __tag158 FSGD06PROT6;                            /* FSGD06PROT6      */
    union __tag158 FSGD06PROT7;                            /* FSGD06PROT7      */
    union __tag158 FSGD06PROT8;                            /* FSGD06PROT8      */
    unsigned char  dummy726[28];                           /* Reserved         */
    union __tag158 ERRSLV06CTL;                            /* ERRSLV06CTL      */
    union __tag158 ERRSLV06STAT;                           /* ERRSLV06STAT     */
    unsigned long  ERRSLV06ADDR;                           /* ERRSLV06ADDR     */
    union __tag164 ERRSLV06TYPE;                           /* ERRSLV06TYPE     */
};
struct __tag396
{                                                          /* Module           */
    union __tag158 FSGD03PROT0;                            /* FSGD03PROT0      */
    union __tag158 FSGD03PROT1;                            /* FSGD03PROT1      */
    union __tag158 FSGD03PROT2;                            /* FSGD03PROT2      */
    unsigned char  dummy727[20];                           /* Reserved         */
    union __tag158 FSGD03PROT8;                            /* FSGD03PROT8      */
    unsigned char  dummy728[28];                           /* Reserved         */
    union __tag158 ERRSLV03CTL;                            /* ERRSLV03CTL      */
    union __tag158 ERRSLV03STAT;                           /* ERRSLV03STAT     */
    unsigned long  ERRSLV03ADDR;                           /* ERRSLV03ADDR     */
    union __tag164 ERRSLV03TYPE;                           /* ERRSLV03TYPE     */
};
struct __tag397
{                                                          /* Module           */
    union __tag158 FSGD04PROT0;                            /* FSGD04PROT0      */
    unsigned char  dummy729[12];                           /* Reserved         */
    union __tag158 FSGD04PROT4;                            /* FSGD04PROT4      */
    unsigned char  dummy730[12];                           /* Reserved         */
    union __tag158 FSGD04PROT8;                            /* FSGD04PROT8      */
    union __tag158 FSGD04PROT9;                            /* FSGD04PROT9      */
    union __tag158 FSGD04PROT10;                           /* FSGD04PROT10     */
    unsigned char  dummy731[20];                           /* Reserved         */
    union __tag158 ERRSLV04CTL;                            /* ERRSLV04CTL      */
    union __tag158 ERRSLV04STAT;                           /* ERRSLV04STAT     */
    unsigned long  ERRSLV04ADDR;                           /* ERRSLV04ADDR     */
    union __tag164 ERRSLV04TYPE;                           /* ERRSLV04TYPE     */
};
struct __tag398
{                                                          /* Module           */
    union __tag158 FSGD05PROT0;                            /* FSGD05PROT0      */
    union __tag158 FSGD05PROT1;                            /* FSGD05PROT1      */
    unsigned char  dummy732[24];                           /* Reserved         */
    union __tag158 FSGD05PROT8;                            /* FSGD05PROT8      */
    union __tag158 FSGD05PROT9;                            /* FSGD05PROT9      */
    unsigned char  dummy733[24];                           /* Reserved         */
    union __tag158 ERRSLV05CTL;                            /* ERRSLV05CTL      */
    union __tag158 ERRSLV05STAT;                           /* ERRSLV05STAT     */
    unsigned long  ERRSLV05ADDR;                           /* ERRSLV05ADDR     */
    union __tag164 ERRSLV05TYPE;                           /* ERRSLV05TYPE     */
};
struct __tag399
{                                                          /* Module           */
    unsigned char  dummy734[2];                            /* Reserved         */
    union __tag167 ECRUM;                                  /* ECRUM            */
    unsigned char  dummy735[4];                            /* Reserved         */
    union __tag158 ADRUM;                                  /* ADRUM            */
    unsigned char  dummy736[1];                            /* Reserved         */
    unsigned char  ENUM;                                   /* ENUM             */
    unsigned char  dummy737[18];                           /* Reserved         */
    unsigned char  PMTUM0;                                 /* PMTUM0           */
    unsigned char  dummy738[1];                            /* Reserved         */
    unsigned char  PMTUM2;                                 /* PMTUM2           */
    unsigned char  PMTUM3;                                 /* PMTUM3           */
    unsigned char  PMTUM4;                                 /* PMTUM4           */
};
struct __tag400
{                                                          /* Module           */
    union __tag158 SP;                                     /* SP               */
    unsigned char  dummy739[112];                          /* Reserved         */
    union __tag158 G0MK;                                   /* G0MK             */
    union __tag158 G0BA;                                   /* G0BA             */
    unsigned char  dummy740[8];                            /* Reserved         */
    union __tag158 G1MK;                                   /* G1MK             */
    union __tag158 G1BA;                                   /* G1BA             */
    unsigned char  dummy741[8];                            /* Reserved         */
    union __tag158 G2MK;                                   /* G2MK             */
    union __tag158 G2BA;                                   /* G2BA             */
    unsigned char  dummy742[8];                            /* Reserved         */
    union __tag158 G3MK;                                   /* G3MK             */
    union __tag158 G3BA;                                   /* G3BA             */
};
struct __tag401
{                                                          /* Module           */
    unsigned short CONT;                                   /* CONT             */
    unsigned short FLAG;                                   /* FLAG             */
    unsigned char  dummy743[4];                            /* Reserved         */
    unsigned long  ADDR;                                   /* ADDR             */
};
struct __tag402
{                                                          /* Module           */
    union __tag178 ICTAUD0I0;                              /* ICTAUD0I0        */
    union __tag179 ICTAUD0I2;                              /* ICTAUD0I2        */
    union __tag180 ICTAUD0I4;                              /* ICTAUD0I4        */
    union __tag181 ICTAUD0I6;                              /* ICTAUD0I6        */
    union __tag182 ICTAUD0I8;                              /* ICTAUD0I8        */
    union __tag183 ICTAUD0I10;                             /* ICTAUD0I10       */
    union __tag184 ICTAUD0I12;                             /* ICTAUD0I12       */
    union __tag185 ICTAUD0I14;                             /* ICTAUD0I14       */
    union __tag186 ICTAPA0IPEK0;                           /* ICTAPA0IPEK0     */
    union __tag187 ICTAPA0IVLY0;                           /* ICTAPA0IVLY0     */
    union __tag188 ICADCA0I0;                              /* ICADCA0I0        */
    union __tag189 ICADCA0I1;                              /* ICADCA0I1        */
    union __tag190 ICADCA0I2;                              /* ICADCA0I2        */
    union __tag191 ICDCUTDI;                               /* ICDCUTDI         */
    union __tag192 ICRCANGERR0;                            /* ICRCANGERR0      */
    union __tag193 ICRCANGRECC0;                           /* ICRCANGRECC0     */
    union __tag194 ICRCAN0ERR;                             /* ICRCAN0ERR       */
    union __tag195 ICRCAN0REC;                             /* ICRCAN0REC       */
    union __tag196 ICRCAN0TRX;                             /* ICRCAN0TRX       */
    union __tag197 ICCSIG0IC;                              /* ICCSIG0IC        */
    union __tag198 ICCSIG0IR;                              /* ICCSIG0IR        */
    union __tag199 ICCSIH0IC;                              /* ICCSIH0IC        */
    union __tag200 ICCSIH0IR;                              /* ICCSIH0IR        */
    union __tag201 ICCSIH0IRE;                             /* ICCSIH0IRE       */
    unsigned char  dummy744[56];                           /* Reserved         */
    union __tag202 FNC;                                    /* FNC              */
    union __tag203 FIC;                                    /* FIC              */
    unsigned char  dummy745[116];                          /* Reserved         */
    union __tag204 IMR0;                                   /* IMR0             */
};
struct __tag403
{                                                          /* Module           */
    unsigned long  DMACTL;                                 /* DMACTL           */
    unsigned char  dummy746[28];                           /* Reserved         */
    unsigned long  DMACER;                                 /* DMACER           */
    unsigned char  dummy747[12];                           /* Reserved         */
    unsigned long  DM0CMV;                                 /* DM0CMV           */
    unsigned long  DM1CMV;                                 /* DM1CMV           */
    unsigned char  dummy748[4];                            /* Reserved         */
    unsigned long  CMVC;                                   /* CMVC             */
    unsigned char  dummy749[192];                          /* Reserved         */
    unsigned long  DM00CM;                                 /* DM00CM           */
    unsigned long  DM01CM;                                 /* DM01CM           */
    unsigned long  DM02CM;                                 /* DM02CM           */
    unsigned long  DM03CM;                                 /* DM03CM           */
    unsigned long  DM04CM;                                 /* DM04CM           */
    unsigned long  DM05CM;                                 /* DM05CM           */
    unsigned long  DM06CM;                                 /* DM06CM           */
    unsigned long  DM07CM;                                 /* DM07CM           */
    unsigned long  DM10CM;                                 /* DM10CM           */
    unsigned long  DM11CM;                                 /* DM11CM           */
    unsigned long  DM12CM;                                 /* DM12CM           */
    unsigned long  DM13CM;                                 /* DM13CM           */
    unsigned long  DM14CM;                                 /* DM14CM           */
    unsigned long  DM15CM;                                 /* DM15CM           */
    unsigned long  DM16CM;                                 /* DM16CM           */
    unsigned long  DM17CM;                                 /* DM17CM           */
    unsigned char  dummy750[704];                          /* Reserved         */
    unsigned long  DSA0;                                   /* DSA0             */
    unsigned long  DDA0;                                   /* DDA0             */
    unsigned long  DTC0;                                   /* DTC0             */
    unsigned long  DTCT0;                                  /* DTCT0            */
    unsigned long  DRSA0;                                  /* DRSA0            */
    unsigned long  DRDA0;                                  /* DRDA0            */
    unsigned long  DRTC0;                                  /* DRTC0            */
    unsigned char  dummy751[4];                            /* Reserved         */
    unsigned long  DCEN0;                                  /* DCEN0            */
    unsigned long  DCST0;                                  /* DCST0            */
    unsigned long  DCSTS0;                                 /* DCSTS0           */
    unsigned long  DCSTC0;                                 /* DCSTC0           */
    unsigned long  DTFR0;                                  /* DTFR0            */
    unsigned long  DTFRRQ0;                                /* DTFRRQ0          */
    unsigned long  DTFRRQC0;                               /* DTFRRQC0         */
    unsigned char  dummy752[4];                            /* Reserved         */
    unsigned long  DSA1;                                   /* DSA1             */
    unsigned long  DDA1;                                   /* DDA1             */
    unsigned long  DTC1;                                   /* DTC1             */
    unsigned long  DTCT1;                                  /* DTCT1            */
    unsigned long  DRSA1;                                  /* DRSA1            */
    unsigned long  DRDA1;                                  /* DRDA1            */
    unsigned long  DRTC1;                                  /* DRTC1            */
    unsigned char  dummy753[4];                            /* Reserved         */
    unsigned long  DCEN1;                                  /* DCEN1            */
    unsigned long  DCST1;                                  /* DCST1            */
    unsigned long  DCSTS1;                                 /* DCSTS1           */
    unsigned long  DCSTC1;                                 /* DCSTC1           */
    unsigned long  DTFR1;                                  /* DTFR1            */
    unsigned long  DTFRRQ1;                                /* DTFRRQ1          */
    unsigned long  DTFRRQC1;                               /* DTFRRQC1         */
    unsigned char  dummy754[4];                            /* Reserved         */
    unsigned long  DSA2;                                   /* DSA2             */
    unsigned long  DDA2;                                   /* DDA2             */
    unsigned long  DTC2;                                   /* DTC2             */
    unsigned long  DTCT2;                                  /* DTCT2            */
    unsigned long  DRSA2;                                  /* DRSA2            */
    unsigned long  DRDA2;                                  /* DRDA2            */
    unsigned long  DRTC2;                                  /* DRTC2            */
    unsigned char  dummy755[4];                            /* Reserved         */
    unsigned long  DCEN2;                                  /* DCEN2            */
    unsigned long  DCST2;                                  /* DCST2            */
    unsigned long  DCSTS2;                                 /* DCSTS2           */
    unsigned long  DCSTC2;                                 /* DCSTC2           */
    unsigned long  DTFR2;                                  /* DTFR2            */
    unsigned long  DTFRRQ2;                                /* DTFRRQ2          */
    unsigned long  DTFRRQC2;                               /* DTFRRQC2         */
    unsigned char  dummy756[4];                            /* Reserved         */
    unsigned long  DSA3;                                   /* DSA3             */
    unsigned long  DDA3;                                   /* DDA3             */
    unsigned long  DTC3;                                   /* DTC3             */
    unsigned long  DTCT3;                                  /* DTCT3            */
    unsigned long  DRSA3;                                  /* DRSA3            */
    unsigned long  DRDA3;                                  /* DRDA3            */
    unsigned long  DRTC3;                                  /* DRTC3            */
    unsigned char  dummy757[4];                            /* Reserved         */
    unsigned long  DCEN3;                                  /* DCEN3            */
    unsigned long  DCST3;                                  /* DCST3            */
    unsigned long  DCSTS3;                                 /* DCSTS3           */
    unsigned long  DCSTC3;                                 /* DCSTC3           */
    unsigned long  DTFR3;                                  /* DTFR3            */
    unsigned long  DTFRRQ3;                                /* DTFRRQ3          */
    unsigned long  DTFRRQC3;                               /* DTFRRQC3         */
    unsigned char  dummy758[4];                            /* Reserved         */
    unsigned long  DSA4;                                   /* DSA4             */
    unsigned long  DDA4;                                   /* DDA4             */
    unsigned long  DTC4;                                   /* DTC4             */
    unsigned long  DTCT4;                                  /* DTCT4            */
    unsigned long  DRSA4;                                  /* DRSA4            */
    unsigned long  DRDA4;                                  /* DRDA4            */
    unsigned long  DRTC4;                                  /* DRTC4            */
    unsigned char  dummy759[4];                            /* Reserved         */
    unsigned long  DCEN4;                                  /* DCEN4            */
    unsigned long  DCST4;                                  /* DCST4            */
    unsigned long  DCSTS4;                                 /* DCSTS4           */
    unsigned long  DCSTC4;                                 /* DCSTC4           */
    unsigned long  DTFR4;                                  /* DTFR4            */
    unsigned long  DTFRRQ4;                                /* DTFRRQ4          */
    unsigned long  DTFRRQC4;                               /* DTFRRQC4         */
    unsigned char  dummy760[4];                            /* Reserved         */
    unsigned long  DSA5;                                   /* DSA5             */
    unsigned long  DDA5;                                   /* DDA5             */
    unsigned long  DTC5;                                   /* DTC5             */
    unsigned long  DTCT5;                                  /* DTCT5            */
    unsigned long  DRSA5;                                  /* DRSA5            */
    unsigned long  DRDA5;                                  /* DRDA5            */
    unsigned long  DRTC5;                                  /* DRTC5            */
    unsigned char  dummy761[4];                            /* Reserved         */
    unsigned long  DCEN5;                                  /* DCEN5            */
    unsigned long  DCST5;                                  /* DCST5            */
    unsigned long  DCSTS5;                                 /* DCSTS5           */
    unsigned long  DCSTC5;                                 /* DCSTC5           */
    unsigned long  DTFR5;                                  /* DTFR5            */
    unsigned long  DTFRRQ5;                                /* DTFRRQ5          */
    unsigned long  DTFRRQC5;                               /* DTFRRQC5         */
    unsigned char  dummy762[4];                            /* Reserved         */
    unsigned long  DSA6;                                   /* DSA6             */
    unsigned long  DDA6;                                   /* DDA6             */
    unsigned long  DTC6;                                   /* DTC6             */
    unsigned long  DTCT6;                                  /* DTCT6            */
    unsigned long  DRSA6;                                  /* DRSA6            */
    unsigned long  DRDA6;                                  /* DRDA6            */
    unsigned long  DRTC6;                                  /* DRTC6            */
    unsigned char  dummy763[4];                            /* Reserved         */
    unsigned long  DCEN6;                                  /* DCEN6            */
    unsigned long  DCST6;                                  /* DCST6            */
    unsigned long  DCSTS6;                                 /* DCSTS6           */
    unsigned long  DCSTC6;                                 /* DCSTC6           */
    unsigned long  DTFR6;                                  /* DTFR6            */
    unsigned long  DTFRRQ6;                                /* DTFRRQ6          */
    unsigned long  DTFRRQC6;                               /* DTFRRQC6         */
    unsigned char  dummy764[4];                            /* Reserved         */
    unsigned long  DSA7;                                   /* DSA7             */
    unsigned long  DDA7;                                   /* DDA7             */
    unsigned long  DTC7;                                   /* DTC7             */
    unsigned long  DTCT7;                                  /* DTCT7            */
    unsigned long  DRSA7;                                  /* DRSA7            */
    unsigned long  DRDA7;                                  /* DRDA7            */
    unsigned long  DRTC7;                                  /* DRTC7            */
    unsigned char  dummy765[4];                            /* Reserved         */
    unsigned long  DCEN7;                                  /* DCEN7            */
    unsigned long  DCST7;                                  /* DCST7            */
    unsigned long  DCSTS7;                                 /* DCSTS7           */
    unsigned long  DCSTC7;                                 /* DCSTC7           */
    unsigned long  DTFR7;                                  /* DTFR7            */
    unsigned long  DTFRRQ7;                                /* DTFRRQ7          */
    unsigned long  DTFRRQC7;                               /* DTFRRQC7         */
    unsigned char  dummy766[4];                            /* Reserved         */
    unsigned long  DSA8;                                   /* DSA8             */
    unsigned long  DDA8;                                   /* DDA8             */
    unsigned long  DTC8;                                   /* DTC8             */
    unsigned long  DTCT8;                                  /* DTCT8            */
    unsigned long  DRSA8;                                  /* DRSA8            */
    unsigned long  DRDA8;                                  /* DRDA8            */
    unsigned long  DRTC8;                                  /* DRTC8            */
    unsigned char  dummy767[4];                            /* Reserved         */
    unsigned long  DCEN8;                                  /* DCEN8            */
    unsigned long  DCST8;                                  /* DCST8            */
    unsigned long  DCSTS8;                                 /* DCSTS8           */
    unsigned long  DCSTC8;                                 /* DCSTC8           */
    unsigned long  DTFR8;                                  /* DTFR8            */
    unsigned long  DTFRRQ8;                                /* DTFRRQ8          */
    unsigned long  DTFRRQC8;                               /* DTFRRQC8         */
    unsigned char  dummy768[4];                            /* Reserved         */
    unsigned long  DSA9;                                   /* DSA9             */
    unsigned long  DDA9;                                   /* DDA9             */
    unsigned long  DTC9;                                   /* DTC9             */
    unsigned long  DTCT9;                                  /* DTCT9            */
    unsigned long  DRSA9;                                  /* DRSA9            */
    unsigned long  DRDA9;                                  /* DRDA9            */
    unsigned long  DRTC9;                                  /* DRTC9            */
    unsigned char  dummy769[4];                            /* Reserved         */
    unsigned long  DCEN9;                                  /* DCEN9            */
    unsigned long  DCST9;                                  /* DCST9            */
    unsigned long  DCSTS9;                                 /* DCSTS9           */
    unsigned long  DCSTC9;                                 /* DCSTC9           */
    unsigned long  DTFR9;                                  /* DTFR9            */
    unsigned long  DTFRRQ9;                                /* DTFRRQ9          */
    unsigned long  DTFRRQC9;                               /* DTFRRQC9         */
    unsigned char  dummy770[4];                            /* Reserved         */
    unsigned long  DSA10;                                  /* DSA10            */
    unsigned long  DDA10;                                  /* DDA10            */
    unsigned long  DTC10;                                  /* DTC10            */
    unsigned long  DTCT10;                                 /* DTCT10           */
    unsigned long  DRSA10;                                 /* DRSA10           */
    unsigned long  DRDA10;                                 /* DRDA10           */
    unsigned long  DRTC10;                                 /* DRTC10           */
    unsigned char  dummy771[4];                            /* Reserved         */
    unsigned long  DCEN10;                                 /* DCEN10           */
    unsigned long  DCST10;                                 /* DCST10           */
    unsigned long  DCSTS10;                                /* DCSTS10          */
    unsigned long  DCSTC10;                                /* DCSTC10          */
    unsigned long  DTFR10;                                 /* DTFR10           */
    unsigned long  DTFRRQ10;                               /* DTFRRQ10         */
    unsigned long  DTFRRQC10;                              /* DTFRRQC10        */
    unsigned char  dummy772[4];                            /* Reserved         */
    unsigned long  DSA11;                                  /* DSA11            */
    unsigned long  DDA11;                                  /* DDA11            */
    unsigned long  DTC11;                                  /* DTC11            */
    unsigned long  DTCT11;                                 /* DTCT11           */
    unsigned long  DRSA11;                                 /* DRSA11           */
    unsigned long  DRDA11;                                 /* DRDA11           */
    unsigned long  DRTC11;                                 /* DRTC11           */
    unsigned char  dummy773[4];                            /* Reserved         */
    unsigned long  DCEN11;                                 /* DCEN11           */
    unsigned long  DCST11;                                 /* DCST11           */
    unsigned long  DCSTS11;                                /* DCSTS11          */
    unsigned long  DCSTC11;                                /* DCSTC11          */
    unsigned long  DTFR11;                                 /* DTFR11           */
    unsigned long  DTFRRQ11;                               /* DTFRRQ11         */
    unsigned long  DTFRRQC11;                              /* DTFRRQC11        */
    unsigned char  dummy774[4];                            /* Reserved         */
    unsigned long  DSA12;                                  /* DSA12            */
    unsigned long  DDA12;                                  /* DDA12            */
    unsigned long  DTC12;                                  /* DTC12            */
    unsigned long  DTCT12;                                 /* DTCT12           */
    unsigned long  DRSA12;                                 /* DRSA12           */
    unsigned long  DRDA12;                                 /* DRDA12           */
    unsigned long  DRTC12;                                 /* DRTC12           */
    unsigned char  dummy775[4];                            /* Reserved         */
    unsigned long  DCEN12;                                 /* DCEN12           */
    unsigned long  DCST12;                                 /* DCST12           */
    unsigned long  DCSTS12;                                /* DCSTS12          */
    unsigned long  DCSTC12;                                /* DCSTC12          */
    unsigned long  DTFR12;                                 /* DTFR12           */
    unsigned long  DTFRRQ12;                               /* DTFRRQ12         */
    unsigned long  DTFRRQC12;                              /* DTFRRQC12        */
    unsigned char  dummy776[4];                            /* Reserved         */
    unsigned long  DSA13;                                  /* DSA13            */
    unsigned long  DDA13;                                  /* DDA13            */
    unsigned long  DTC13;                                  /* DTC13            */
    unsigned long  DTCT13;                                 /* DTCT13           */
    unsigned long  DRSA13;                                 /* DRSA13           */
    unsigned long  DRDA13;                                 /* DRDA13           */
    unsigned long  DRTC13;                                 /* DRTC13           */
    unsigned char  dummy777[4];                            /* Reserved         */
    unsigned long  DCEN13;                                 /* DCEN13           */
    unsigned long  DCST13;                                 /* DCST13           */
    unsigned long  DCSTS13;                                /* DCSTS13          */
    unsigned long  DCSTC13;                                /* DCSTC13          */
    unsigned long  DTFR13;                                 /* DTFR13           */
    unsigned long  DTFRRQ13;                               /* DTFRRQ13         */
    unsigned long  DTFRRQC13;                              /* DTFRRQC13        */
    unsigned char  dummy778[4];                            /* Reserved         */
    unsigned long  DSA14;                                  /* DSA14            */
    unsigned long  DDA14;                                  /* DDA14            */
    unsigned long  DTC14;                                  /* DTC14            */
    unsigned long  DTCT14;                                 /* DTCT14           */
    unsigned long  DRSA14;                                 /* DRSA14           */
    unsigned long  DRDA14;                                 /* DRDA14           */
    unsigned long  DRTC14;                                 /* DRTC14           */
    unsigned char  dummy779[4];                            /* Reserved         */
    unsigned long  DCEN14;                                 /* DCEN14           */
    unsigned long  DCST14;                                 /* DCST14           */
    unsigned long  DCSTS14;                                /* DCSTS14          */
    unsigned long  DCSTC14;                                /* DCSTC14          */
    unsigned long  DTFR14;                                 /* DTFR14           */
    unsigned long  DTFRRQ14;                               /* DTFRRQ14         */
    unsigned long  DTFRRQC14;                              /* DTFRRQC14        */
    unsigned char  dummy780[4];                            /* Reserved         */
    unsigned long  DSA15;                                  /* DSA15            */
    unsigned long  DDA15;                                  /* DDA15            */
    unsigned long  DTC15;                                  /* DTC15            */
    unsigned long  DTCT15;                                 /* DTCT15           */
    unsigned long  DRSA15;                                 /* DRSA15           */
    unsigned long  DRDA15;                                 /* DRDA15           */
    unsigned long  DRTC15;                                 /* DRTC15           */
    unsigned char  dummy781[4];                            /* Reserved         */
    unsigned long  DCEN15;                                 /* DCEN15           */
    unsigned long  DCST15;                                 /* DCST15           */
    unsigned long  DCSTS15;                                /* DCSTS15          */
    unsigned long  DCSTC15;                                /* DCSTC15          */
    unsigned long  DTFR15;                                 /* DTFR15           */
    unsigned long  DTFRRQ15;                               /* DTFRRQ15         */
    unsigned long  DTFRRQC15;                              /* DTFRRQC15        */
};
struct __tag404
{                                                          /* Module           */
    union __tag205 ICADCA0I2_2;                            /* ICADCA0I2_2      */
    union __tag206 ICRLIN30;                               /* ICRLIN30         */
    union __tag207 ICRLIN30UR0;                            /* ICRLIN30UR0      */
    union __tag208 ICRLIN30UR1;                            /* ICRLIN30UR1      */
    union __tag209 ICRLIN30UR2;                            /* ICRLIN30UR2      */
    union __tag210 ICP0;                                   /* ICP0             */
    union __tag211 ICP1;                                   /* ICP1             */
    union __tag212 ICP2;                                   /* ICP2             */
    union __tag213 ICWDTA0;                                /* ICWDTA0          */
    union __tag214 ICWDTA1;                                /* ICWDTA1          */
    unsigned char  dummy782[2];                            /* Reserved         */
    union __tag215 ICP3;                                   /* ICP3             */
    union __tag216 ICP4;                                   /* ICP4             */
    union __tag217 ICP5;                                   /* ICP5             */
    union __tag218 ICP10;                                  /* ICP10            */
    union __tag219 ICP11;                                  /* ICP11            */
    union __tag220 ICTAUD0I1;                              /* ICTAUD0I1        */
    union __tag221 ICTAUD0I3;                              /* ICTAUD0I3        */
    union __tag222 ICTAUD0I5;                              /* ICTAUD0I5        */
    union __tag223 ICTAUD0I7;                              /* ICTAUD0I7        */
    union __tag224 ICTAUD0I9;                              /* ICTAUD0I9        */
    union __tag225 ICTAUD0I11;                             /* ICTAUD0I11       */
    union __tag226 ICTAUD0I13;                             /* ICTAUD0I13       */
    union __tag227 ICTAUD0I15;                             /* ICTAUD0I15       */
    union __tag228 ICADCA0ERR;                             /* ICADCA0ERR       */
    union __tag229 ICCSIG0IRE;                             /* ICCSIG0IRE       */
    union __tag230 ICRLIN20;                               /* ICRLIN20         */
    union __tag231 ICRLIN21;                               /* ICRLIN21         */
    union __tag232 ICDMA0;                                 /* ICDMA0           */
    union __tag233 ICDMA1;                                 /* ICDMA1           */
    union __tag234 ICDMA2;                                 /* ICDMA2           */
    union __tag235 ICDMA3;                                 /* ICDMA3           */
    union __tag236 ICDMA4;                                 /* ICDMA4           */
    union __tag237 ICDMA5;                                 /* ICDMA5           */
    union __tag238 ICDMA6;                                 /* ICDMA6           */
    union __tag239 ICDMA7;                                 /* ICDMA7           */
    union __tag240 ICDMA8;                                 /* ICDMA8           */
    union __tag241 ICDMA9;                                 /* ICDMA9           */
    union __tag242 ICDMA10;                                /* ICDMA10          */
    union __tag243 ICDMA11;                                /* ICDMA11          */
    union __tag244 ICDMA12;                                /* ICDMA12          */
    union __tag245 ICDMA13;                                /* ICDMA13          */
    union __tag246 ICDMA14;                                /* ICDMA14          */
    union __tag247 ICDMA15;                                /* ICDMA15          */
    union __tag248 ICRIIC0TI;                              /* ICRIIC0TI        */
    union __tag249 ICRIIC0EE;                              /* ICRIIC0EE        */
    union __tag250 ICRIIC0RI;                              /* ICRIIC0RI        */
    union __tag251 ICRIIC0TEI;                             /* ICRIIC0TEI       */
    union __tag252 ICTAUJ0I0;                              /* ICTAUJ0I0        */
    union __tag253 ICTAUJ0I1;                              /* ICTAUJ0I1        */
    union __tag254 ICTAUJ0I2;                              /* ICTAUJ0I2        */
    union __tag255 ICTAUJ0I3;                              /* ICTAUJ0I3        */
    union __tag256 ICOSTM0;                                /* ICOSTM0          */
    union __tag257 ICENCA0IOV;                             /* ICENCA0IOV       */
    union __tag258 ICENCA0IUD;                             /* ICENCA0IUD       */
    union __tag259 ICENCA0I0;                              /* ICENCA0I0        */
    union __tag260 ICENCA0I1;                              /* ICENCA0I1        */
    union __tag261 ICENCA0IEC;                             /* ICENCA0IEC       */
    union __tag262 ICKR0;                                  /* ICKR0            */
    union __tag263 ICQFULL;                                /* ICQFULL          */
    union __tag264 ICPWGAG00;                              /* ICPWGAG00        */
    unsigned char  dummy783[34];                           /* Reserved         */
    union __tag265 ICFLERR;                                /* ICFLERR          */
    union __tag266 ICFLENDNM;                              /* ICFLENDNM        */
    union __tag267 ICCWEND;                                /* ICCWEND          */
    union __tag268 ICRCAN1ERR;                             /* ICRCAN1ERR       */
    union __tag269 ICRCAN1REC;                             /* ICRCAN1REC       */
    union __tag270 ICRCAN1TRX;                             /* ICRCAN1TRX       */
    union __tag271 ICTAPA0IPEK0_2;                         /* ICTAPA0IPEK0_2   */
    union __tag272 ICTAPA0IVLY0_2;                         /* ICTAPA0IVLY0_2   */
    union __tag273 ICCSIG0IC_2;                            /* ICCSIG0IC_2      */
    union __tag274 ICCSIG0IR_2;                            /* ICCSIG0IR_2      */
    union __tag275 ICRLIN31;                               /* ICRLIN31         */
    union __tag276 ICRLIN31UR0;                            /* ICRLIN31UR0      */
    union __tag277 ICRLIN31UR1;                            /* ICRLIN31UR1      */
    union __tag278 ICRLIN31UR2;                            /* ICRLIN31UR2      */
    unsigned char  dummy784[16];                           /* Reserved         */
    union __tag279 ICTAUD0I0_2;                            /* ICTAUD0I0_2      */
    union __tag280 ICTAUD0I4_2;                            /* ICTAUD0I4_2      */
    union __tag281 ICTAUD0I6_2;                            /* ICTAUD0I6_2      */
    union __tag282 ICTAUD0I8_2;                            /* ICTAUD0I8_2      */
    unsigned char  dummy785[44];                           /* Reserved         */
    union __tag283 ICTAUD0I2_2;                            /* ICTAUD0I2_2      */
    union __tag284 ICTAUD0I10_2;                           /* ICTAUD0I10_2     */
    union __tag285 ICTAUD0I12_2;                           /* ICTAUD0I12_2     */
    union __tag286 ICTAUD0I14_2;                           /* ICTAUD0I14_2     */
    unsigned char  dummy786[12];                           /* Reserved         */
    union __tag287 ICTAUJ1I0;                              /* ICTAUJ1I0        */
    union __tag288 ICTAUJ1I1;                              /* ICTAUJ1I1        */
    union __tag289 ICTAUJ1I2;                              /* ICTAUJ1I2        */
    union __tag290 ICTAUJ1I3;                              /* ICTAUJ1I3        */
    unsigned char  dummy787[74];                           /* Reserved         */
    union __tag291 ICRTCA01S;                              /* ICRTCA01S        */
    union __tag292 ICRTCA0AL;                              /* ICRTCA0AL        */
    union __tag293 ICRTCA0R;                               /* ICRTCA0R         */
    unsigned char  dummy788[10];                           /* Reserved         */
    union __tag294 ICRCAN2ERR;                             /* ICRCAN2ERR       */
    union __tag295 ICRCAN2REC;                             /* ICRCAN2REC       */
    union __tag296 ICRCAN2TRX;                             /* ICRCAN2TRX       */
    unsigned char  dummy789[40];                           /* Reserved         */
    union __tag297 ICRIIC1TI;                              /* ICRIIC1TI        */
    union __tag298 ICRIIC1EE;                              /* ICRIIC1EE        */
    union __tag299 ICRIIC1RI;                              /* ICRIIC1RI        */
    union __tag300 ICRIIC1TEI;                             /* ICRIIC1TEI       */
    unsigned char  dummy790[66];                           /* Reserved         */
    union __tag301 ICTAUJ2I0;                              /* ICTAUJ2I0        */
    union __tag302 ICTAUJ2I1;                              /* ICTAUJ2I1        */
    union __tag303 ICTAUJ2I2;                              /* ICTAUJ2I2        */
    union __tag304 ICTAUJ2I3;                              /* ICTAUJ2I3        */
    union __tag305 ICTAUJ3I0;                              /* ICTAUJ3I0        */
    union __tag306 ICTAUJ3I1;                              /* ICTAUJ3I1        */
    union __tag307 ICTAUJ3I2;                              /* ICTAUJ3I2        */
    union __tag308 ICTAUJ3I3;                              /* ICTAUJ3I3        */
    unsigned char  dummy791[124];                          /* Reserved         */
    union __tag309 ICSENT0SI;                              /* ICSENT0SI        */
    union __tag310 ICSENT0RI;                              /* ICSENT0RI        */
    union __tag311 ICSENT1SI;                              /* ICSENT1SI        */
    union __tag312 ICSENT1RI;                              /* ICSENT1RI        */
    unsigned char  dummy792[10];                           /* Reserved         */
    union __tag313 ICDPE;                                  /* ICDPE            */
    union __tag314 ICAPE;                                  /* ICAPE            */
    unsigned char  dummy793[312];                          /* Reserved         */
    union __tag315 IMR1;                                   /* IMR1             */
    union __tag316 IMR2;                                   /* IMR2             */
    union __tag317 IMR3;                                   /* IMR3             */
    union __tag318 IMR4;                                   /* IMR4             */
    union __tag319 IMR5;                                   /* IMR5             */
    union __tag320 IMR6;                                   /* IMR6             */
    union __tag321 IMR7;                                   /* IMR7             */
    union __tag322 IMR8;                                   /* IMR8             */
    unsigned char  dummy794[4];                            /* Reserved         */
    union __tag323 IMR10;                                  /* IMR10            */
    union __tag324 IMR11;                                  /* IMR11            */
};

#define ICCSIH0IJC_1 ICADCA0I2
#define ICCSIH0IJC_1L ICADCA0I2L
#define ICCSIH0IJC_1H ICADCA0I2H
#define ICCSIH0IJC ICADCA0I2_2
#define ICCSIH0IJCL ICADCA0I2_2L
#define ICCSIH0IJCH ICADCA0I2_2H
#define P0CSIH0IJC_1 P0ADCA0I2
#define P1CSIH0IJC_1 P1ADCA0I2
#define P2CSIH0IJC_1 P2ADCA0I2
#define P3CSIH0IJC_1 P3ADCA0I2
#define TBCSIH0IJC_1 TBADCA0I2
#define MKCSIH0IJC_1 MKADCA0I2
#define RFCSIH0IJC_1 RFADCA0I2
#define CTCSIH0IJC_1 CTADCA0I2
#define P0CSIH0IJC P0ADCA0I2_2
#define P1CSIH0IJC P1ADCA0I2_2
#define P2CSIH0IJC P2ADCA0I2_2
#define P3CSIH0IJC P3ADCA0I2_2
#define TBCSIH0IJC TBADCA0I2_2
#define MKCSIH0IJC MKADCA0I2_2
#define RFCSIH0IJC RFADCA0I2_2
#define CTCSIH0IJC CTADCA0I2_2


#define FLMD     (*(volatile struct __tag325 *)0xFFA00000) /* FLMD */
#define SELF     (*(volatile struct __tag326 *)0xFFA08000) /* SELF */
#define FACI     (*(volatile struct __tag327 *)0xFFA10000) /* FACI */
#define ECON_NMI (*(volatile struct __tag328 *)0xFFC00000) /* ECON_NMI */
#define ECON_FEINT (*(volatile struct __tag329 *)0xFFC00100) /* ECON_FEINT */
#define SL_INTC  (*(volatile struct __tag330 *)0xFFC01000) /* SL_INTC */
#define SL_DMAC  (*(volatile struct __tag331 *)0xFFC02000) /* SL_DMAC */
#define PORT     (*(volatile struct __tag332 *)0xFFC10000) /* PORT */
#define JTAG     (*(volatile struct __tag333 *)0xFFC20000) /* JTAG */
#define DNF      (*(volatile struct __tag334 *)0xFFC30000) /* DNF */
#define FCLA0    (*(volatile struct __tag335 *)0xFFC34000) /* FCLA0 */
#define PBG10    (*(volatile struct __tag336 *)0xFFC40000) /* PBG10 */
#define PBG11    (*(volatile struct __tag337 *)0xFFC40100) /* PBG11 */
#define PBG12    (*(volatile struct __tag338 *)0xFFC40400) /* PBG12 */
#define PBG13    (*(volatile struct __tag339 *)0xFFC40500) /* PBG13 */
#define PBGC0    (*(volatile struct __tag340 *)0xFFC4C000) /* PBGC0 */
#define PBGC1    (*(volatile struct __tag341 *)0xFFC4C120) /* PBGC1 */
#define DCIB     (*(volatile struct __tag342 *)0xFFC59810) /* DCIB */
#define FBUF_CTRL (*(volatile struct __tag343 *)0xFFC5B000) /* FBUF_CTRL */
#define CFECC_VCI (*(volatile struct __tag344 *)0xFFC62200) /* CFECC_VCI */
#define CFECC_CPU1 (*(volatile struct __tag345 *)0xFFC62400) /* CFECC_CPU1 */
#define DFECC    (*(volatile struct __tag346 *)0xFFC62A00) /* DFECC */
#define LRTST    (*(volatile struct __tag347 *)0xFFC65004) /* LRTST */
#define LRECC    (*(volatile struct __tag348 *)0xFFC65400) /* LRECC */
#define ECCCSIH0 (*(volatile struct __tag349 *)0xFFC70100) /* ECCCSIH0 */
#define ECCCFD0MB (*(volatile struct __tag349 *)0xFFC71300) /* ECCCFD0MB */
#define ECCCFD0AFL0 (*(volatile struct __tag349 *)0xFFC71400) /* ECCCFD0AFL0 */
#define ECCCFD0AFL1 (*(volatile struct __tag349 *)0xFFC71500) /* ECCCFD0AFL1 */
#define SL_READTEST (*(volatile struct __tag350 *)0xFFC78000) /* SL_READTEST */
#define RIIC0    (*(volatile struct __tag351 *)0xFFCA0000) /* RIIC0 */
#define RIIC1    (*(volatile struct __tag351 *)0xFFCA0080) /* RIIC1 */
#define SCDS     (*(volatile struct __tag352 *)0xFFCD00D0) /* SCDS */
#define RLN240   (*(volatile struct __tag353 *)0xFFCE0000) /* RLN240 */
#define RLN2400  (*(volatile struct __tag354 *)0xFFCE0008) /* RLN2400 */
#define RLN2401  (*(volatile struct __tag355 *)0xFFCE0028) /* RLN2401 */
#define RLN30    (*(volatile struct __tag356 *)0xFFCE2000) /* RLN30 */
#define RLN31    (*(volatile struct __tag356 *)0xFFCE2040) /* RLN31 */
#define RSENT0   (*(volatile struct __tag357 *)0xFFCF0000) /* RSENT0 */
#define RSENT1   (*(volatile struct __tag357 *)0xFFCF0100) /* RSENT1 */
#define RCFDC0   (*(volatile struct __tag358 *)0xFFD00000) /* RCFDC0 */
#define OSTM0    (*(volatile struct __tag359 *)0xFFD70000) /* OSTM0 */
#define CSIH0    (*(volatile struct __tag360 *)0xFFD80000) /* CSIH0 */
#define CSIG0    (*(volatile struct __tag361 *)0xFFD88000) /* CSIG0 */
#define PIC0     (*(volatile struct __tag362 *)0xFFDD0004) /* PIC0 */
#define PBG20    (*(volatile struct __tag363 *)0xFFDDD000) /* PBG20 */
#define PBG21    (*(volatile struct __tag364 *)0xFFDDD100) /* PBG21 */
#define TAUD0    (*(volatile struct __tag365 *)0xFFE20000) /* TAUD0 */
#define SL_TAUD0 (*(volatile struct __tag366 *)0xFFE24000) /* SL_TAUD0 */
#define TAUJ0    (*(volatile struct __tag367 *)0xFFE50000) /* TAUJ0 */
#define TAUJ2    (*(volatile struct __tag367 *)0xFFE50100) /* TAUJ2 */
#define TAUJ1    (*(volatile struct __tag367 *)0xFFE51000) /* TAUJ1 */
#define TAUJ3    (*(volatile struct __tag367 *)0xFFE51100) /* TAUJ3 */
#define SL_TAUJ0 (*(volatile struct __tag368 *)0xFFE54000) /* SL_TAUJ0 */
#define SL_TAUJ2 (*(volatile struct __tag369 *)0xFFE54004) /* SL_TAUJ2 */
#define PWSA0    (*(volatile struct __tag370 *)0xFFE70000) /* PWSA0 */
#define PWGA0    (*(volatile struct __tag371 *)0xFFE71000) /* PWGA0 */
#define PWGA1    (*(volatile struct __tag371 *)0xFFE71040) /* PWGA1 */
#define PWGA2    (*(volatile struct __tag371 *)0xFFE71080) /* PWGA2 */
#define PWGA3    (*(volatile struct __tag371 *)0xFFE710C0) /* PWGA3 */
#define PWGA4    (*(volatile struct __tag371 *)0xFFE71100) /* PWGA4 */
#define PWGA5    (*(volatile struct __tag371 *)0xFFE71140) /* PWGA5 */
#define PWGA6    (*(volatile struct __tag371 *)0xFFE71180) /* PWGA6 */
#define PWGA7    (*(volatile struct __tag371 *)0xFFE711C0) /* PWGA7 */
#define PWGA8    (*(volatile struct __tag371 *)0xFFE71200) /* PWGA8 */
#define PWGA9    (*(volatile struct __tag371 *)0xFFE71240) /* PWGA9 */
#define PWGA10   (*(volatile struct __tag371 *)0xFFE71280) /* PWGA10 */
#define PWGA11   (*(volatile struct __tag371 *)0xFFE712C0) /* PWGA11 */
#define PWGA12   (*(volatile struct __tag371 *)0xFFE71300) /* PWGA12 */
#define PWGA13   (*(volatile struct __tag371 *)0xFFE71340) /* PWGA13 */
#define PWGA14   (*(volatile struct __tag371 *)0xFFE71380) /* PWGA14 */
#define PWGA15   (*(volatile struct __tag371 *)0xFFE713C0) /* PWGA15 */
#define PWGA16   (*(volatile struct __tag371 *)0xFFE71400) /* PWGA16 */
#define PWGA17   (*(volatile struct __tag371 *)0xFFE71440) /* PWGA17 */
#define PWGA18   (*(volatile struct __tag371 *)0xFFE71480) /* PWGA18 */
#define PWGA19   (*(volatile struct __tag371 *)0xFFE714C0) /* PWGA19 */
#define PWGA20   (*(volatile struct __tag371 *)0xFFE71500) /* PWGA20 */
#define PWGA21   (*(volatile struct __tag371 *)0xFFE71540) /* PWGA21 */
#define PWGA22   (*(volatile struct __tag371 *)0xFFE71580) /* PWGA22 */
#define PWGA23   (*(volatile struct __tag371 *)0xFFE715C0) /* PWGA23 */
#define PWBA0    (*(volatile struct __tag372 *)0xFFE72800) /* PWBA0 */
#define SLPWG    (*(volatile struct __tag373 *)0xFFE73000) /* SLPWG */
#define PWGA_INTF (*(volatile struct __tag374 *)0xFFE73100) /* PWGA_INTF */
#define RTCA0    (*(volatile struct __tag375 *)0xFFE78000) /* RTCA0 */
#define ENCA0    (*(volatile struct __tag376 *)0xFFE80000) /* ENCA0 */
#define TAPA0    (*(volatile struct __tag377 *)0xFFE90000) /* TAPA0 */
#define WDTA0    (*(volatile struct __tag378 *)0xFFED0000) /* WDTA0 */
#define WDTA1    (*(volatile struct __tag378 *)0xFFED1000) /* WDTA1 */
#define ADCA0    (*(volatile struct __tag379 *)0xFFF20000) /* ADCA0 */
#define DCRA0    (*(volatile struct __tag380 *)0xFFF70000) /* DCRA0 */
#define KR0      (*(volatile struct __tag381 *)0xFFF78000) /* KR0 */
#define WPROTR   (*(volatile struct __tag382 *)0xFFF80000) /* WPROTR */
#define STBC0    (*(volatile struct __tag383 *)0xFFF80100) /* STBC0 */
#define STBC_WUF0 (*(volatile struct __tag384 *)0xFFF80400) /* STBC_WUF0 */
#define STBC_WUF1 (*(volatile struct __tag385 *)0xFFF80410) /* STBC_WUF1 */
#define STBC_WUF20 (*(volatile struct __tag386 *)0xFFF80520) /* STBC_WUF20 */
#define RESCTL   (*(volatile struct __tag387 *)0xFFF80760) /* RESCTL */
#define SVM      (*(volatile struct __tag388 *)0xFFF80980) /* SVM */
#define STBC_IOHOLD (*(volatile struct __tag389 *)0xFFF80B00) /* STBC_IOHOLD */
#define CLKCTL   (*(volatile struct __tag390 *)0xFFF81000) /* CLKCTL */
#define LPS0     (*(volatile struct __tag391 *)0xFFF83000) /* LPS0 */
#define STBC_WUFISO (*(volatile struct __tag392 *)0xFFF88110) /* STBC_WUFISO */
#define CLMA0    (*(volatile struct __tag393 *)0xFFF8C000) /* CLMA0 */
#define CLMA     (*(volatile struct __tag394 *)0xFFF8C100) /* CLMA */
#define CLMA1    (*(volatile struct __tag393 *)0xFFF8D000) /* CLMA1 */
#define CLMA3    (*(volatile struct __tag393 *)0xFFF8E000) /* CLMA3 */
#define PBG50    (*(volatile struct __tag395 *)0xFFF90000) /* PBG50 */
#define PBG30    (*(volatile struct __tag396 *)0xFFF94000) /* PBG30 */
#define PBG31    (*(volatile struct __tag397 *)0xFFF94100) /* PBG31 */
#define PBG32    (*(volatile struct __tag398 *)0xFFF94200) /* PBG32 */
#define IPG      (*(volatile struct __tag399 *)0xFFFEE000) /* IPG */
#define PEG      (*(volatile struct __tag400 *)0xFFFEE60C) /* PEG */
#define SEG      (*(volatile struct __tag401 *)0xFFFEE980) /* SEG */
#define INTC1    (*(volatile struct __tag402 *)0xFFFEEA10) /* INTC1 */
#define PDMA0    (*(volatile struct __tag403 *)0xFFFF8000) /* PDMA0 */
#define INTC2    (*(volatile struct __tag404 *)0xFFFFB040) /* INTC2 */

/* IOR List *
FLMD.CNT
FLMD.PCMD
FLMD.PS
SELF.ID0 ... SELF.ID3
SELF.IDST.UINT32
SELF.IDST.UINT16[L]
SELF.IDST.UINT8[LL]
FACI.FPMON
FACI.FASTAT
FACI.FAEINT
FACI.FAREASELC
FACI.FSADDR
FACI.FEADDR
FACI.FSTATR.UINT32
FACI.FSTATR.UINT16[L/H]
FACI.FSTATR.UINT8[LL/LH/HL]
FACI.FENTRYR
FACI.FPROTR
FACI.FSUINITR
FACI.FLKSTAT
FACI.FRTSTAT
FACI.FCMDR
FACI.FPESTAT
FACI.FBCCNT
FACI.FBCSTAT
FACI.FPSADDR
FACI.FCPSR
FACI.FPCKAR
FACI.FECCEMON
FACI.FECCTMD
FACI.FDMYECC
FACI.BFASELR
ECON_NMI.WDTNMIF
ECON_NMI.WDTNMIFC
ECON_FEINT.FEINTF
ECON_FEINT.FEINTFMSK
ECON_FEINT.FEINTFC
SL_INTC.SELB_INTC1
SL_DMAC.DTFSEL_TAUD0
PORT.P0
PORT.P8 ... PORT.P10
PORT.AP0
PORT.PSR0
PORT.PSR8 ... PORT.PSR10
PORT.APSR0
PORT.PPR0
PORT.PPR8 ... PORT.PPR10
PORT.APPR0
PORT.PM0
PORT.PM8 ... PORT.PM10
PORT.APM0
PORT.PMC0
PORT.PMC8 ... PORT.PMC10
PORT.PFC0
PORT.PFC8 ... PORT.PFC10
PORT.PFCE0
PORT.PFCE8 ... PORT.PFCE10
PORT.PNOT0
PORT.PNOT8 ... PORT.PNOT10
PORT.APNOT0
PORT.PMSR0
PORT.PMSR8 ... PORT.PMSR10
PORT.APMSR0
PORT.PMCSR0
PORT.PMCSR8 ... PORT.PMCSR10
PORT.PFCAE0
PORT.PFCAE8 ... PORT.PFCAE10
PORT.PIBC0
PORT.PIBC8 ... PORT.PIBC10
PORT.APIBC0
PORT.PBDC0
PORT.PBDC8 ... PORT.PBDC10
PORT.APBDC0
PORT.PIPC0
PORT.PIPC10
PORT.PU0
PORT.PU8 ... PORT.PU10
PORT.PD0
PORT.PD8 ... PORT.PD10
PORT.PODC0
PORT.PODC8 ... PORT.PODC10
PORT.PDSC0
PORT.PDSC10
PORT.PIS0
PORT.PIS8 ... PORT.PIS10
PORT.PPROTS0
PORT.PPROTS8 ... PORT.PPROTS10
PORT.PPCMD0
PORT.PPCMD8 ... PORT.PPCMD10
JTAG.JP0
JTAG.JPSR0
JTAG.JPPR0
JTAG.JPM0
JTAG.JPMC0
JTAG.JPFC0
JTAG.JPFCE0
JTAG.JPNOT0
JTAG.JPMSR0
JTAG.JPMCSR0
JTAG.JPIBC0
JTAG.JPBDC0
JTAG.JPU0
JTAG.JPD0
JTAG.JPODC0
JTAG.JPDSC0
JTAG.JPIS0
JTAG.JPISA0
JTAG.JPPROTS0
JTAG.JPPCMD0
DNF.ATAUD0ICTL
DNF.ATAUD0IEN
DNF.ATAUD0IENH.UINT8
DNF.ATAUD0IENH.BIT.ATAUD0IENH0 ... DNF.ATAUD0IENH.BIT.ATAUD0IENH7
DNF.ATAUD0IENL.UINT8
DNF.ATAUD0IENL.BIT.ATAUD0IENL0 ... DNF.ATAUD0IENL.BIT.ATAUD0IENL7
DNF.AENCA0ICTL
DNF.AENCA0IEN
DNF.AENCA0IENL.UINT8
DNF.AENCA0IENL.BIT.AENCA0IENL0 ... DNF.AENCA0IENL.BIT.AENCA0IENL4
DNF.AADCTL0CTL
DNF.AADCTL0EN
DNF.AADCTL0ENL.UINT8
DNF.AADCTL0ENL.BIT.AADCTL0ENL0 ... DNF.AADCTL0ENL.BIT.AADCTL0ENL2
DNF.ASENTICTL
DNF.ASENTIEN
DNF.ASENTIENL.UINT8
DNF.ASENTIENL.BIT.ASENTIENL0
DNF.ASENTIENL.BIT.ASENTIENL1
FCLA0.CTL0_NMI
FCLA0.CTL0_INTPL
FCLA0.CTL1_INTPL
FCLA0.CTL2_INTPL
FCLA0.CTL3_INTPL
FCLA0.CTL4_INTPL
FCLA0.CTL5_INTPL
FCLA0.CTL2_INTPH
FCLA0.CTL3_INTPH
FCLA0.CTL0_ADC0
FCLA0.CTL1_ADC0
FCLA0.CTL2_ADC0
PBG10.FSGD00PROT0.UINT32
PBG10.FSGD00PROT0.UINT16[L/H]
PBG10.FSGD00PROT0.UINT8[LL/HL/HH]
PBG10.FSGD00PROT1.UINT32
PBG10.FSGD00PROT1.UINT16[L/H]
PBG10.FSGD00PROT1.UINT8[LL/HL/HH]
PBG10.FSGD00PROT2.UINT32
PBG10.FSGD00PROT2.UINT16[L/H]
PBG10.FSGD00PROT2.UINT8[LL/HL/HH]
PBG10.FSGD00PROT3.UINT32
PBG10.FSGD00PROT3.UINT16[L/H]
PBG10.FSGD00PROT3.UINT8[LL/HL/HH]
PBG10.FSGD00PROT4.UINT32
PBG10.FSGD00PROT4.UINT16[L/H]
PBG10.FSGD00PROT4.UINT8[LL/HL/HH]
PBG10.FSGD00PROT5.UINT32
PBG10.FSGD00PROT5.UINT16[L/H]
PBG10.FSGD00PROT5.UINT8[LL/HL/HH]
PBG10.FSGD00PROT6.UINT32
PBG10.FSGD00PROT6.UINT16[L/H]
PBG10.FSGD00PROT6.UINT8[LL/HL/HH]
PBG10.FSGD00PROT7.UINT32
PBG10.FSGD00PROT7.UINT16[L/H]
PBG10.FSGD00PROT7.UINT8[LL/HL/HH]
PBG10.FSGD00PROT8.UINT32
PBG10.FSGD00PROT8.UINT16[L/H]
PBG10.FSGD00PROT8.UINT8[LL/HL/HH]
PBG10.FSGD00PROT9.UINT32
PBG10.FSGD00PROT9.UINT16[L/H]
PBG10.FSGD00PROT9.UINT8[LL/HL/HH]
PBG10.ERRSLV00CTL.UINT32
PBG10.ERRSLV00CTL.UINT16[L]
PBG10.ERRSLV00CTL.UINT8[LL]
PBG10.ERRSLV00STAT.UINT32
PBG10.ERRSLV00STAT.UINT16[L]
PBG10.ERRSLV00STAT.UINT8[LL]
PBG10.ERRSLV00ADDR
PBG10.ERRSLV00TYPE.UINT32
PBG10.ERRSLV00TYPE.UINT16[L]
PBG11.FSGD01PROT0.UINT32
PBG11.FSGD01PROT0.UINT16[L/H]
PBG11.FSGD01PROT0.UINT8[LL/HL/HH]
PBG11.FSGD01PROT1.UINT32
PBG11.FSGD01PROT1.UINT16[L/H]
PBG11.FSGD01PROT1.UINT8[LL/HL/HH]
PBG11.FSGD01PROT2.UINT32
PBG11.FSGD01PROT2.UINT16[L/H]
PBG11.FSGD01PROT2.UINT8[LL/HL/HH]
PBG11.FSGD01PROT3.UINT32
PBG11.FSGD01PROT3.UINT16[L/H]
PBG11.FSGD01PROT3.UINT8[LL/HL/HH]
PBG11.FSGD01PROT4.UINT32
PBG11.FSGD01PROT4.UINT16[L/H]
PBG11.FSGD01PROT4.UINT8[LL/HL/HH]
PBG11.FSGD01PROT5.UINT32
PBG11.FSGD01PROT5.UINT16[L/H]
PBG11.FSGD01PROT5.UINT8[LL/HL/HH]
PBG11.FSGD01PROT6.UINT32
PBG11.FSGD01PROT6.UINT16[L/H]
PBG11.FSGD01PROT6.UINT8[LL/HL/HH]
PBG11.FSGD01PROT12.UINT32
PBG11.FSGD01PROT12.UINT16[L/H]
PBG11.FSGD01PROT12.UINT8[LL/HL/HH]
PBG11.FSGD01PROT13.UINT32
PBG11.FSGD01PROT13.UINT16[L/H]
PBG11.FSGD01PROT13.UINT8[LL/HL/HH]
PBG11.FSGD01PROT14.UINT32
PBG11.FSGD01PROT14.UINT16[L/H]
PBG11.FSGD01PROT14.UINT8[LL/HL/HH]
PBG11.ERRSLV01CTL.UINT32
PBG11.ERRSLV01CTL.UINT16[L]
PBG11.ERRSLV01CTL.UINT8[LL]
PBG11.ERRSLV01STAT.UINT32
PBG11.ERRSLV01STAT.UINT16[L]
PBG11.ERRSLV01STAT.UINT8[LL]
PBG11.ERRSLV01ADDR
PBG11.ERRSLV01TYPE.UINT32
PBG11.ERRSLV01TYPE.UINT16[L]
PBG12.FSGD07PROT0.UINT32
PBG12.FSGD07PROT0.UINT16[L/H]
PBG12.FSGD07PROT0.UINT8[LL/HL/HH]
PBG12.FSGD07PROT1.UINT32
PBG12.FSGD07PROT1.UINT16[L/H]
PBG12.FSGD07PROT1.UINT8[LL/HL/HH]
PBG12.FSGD07PROT2.UINT32
PBG12.FSGD07PROT2.UINT16[L/H]
PBG12.FSGD07PROT2.UINT8[LL/HL/HH]
PBG12.FSGD07PROT15.UINT32
PBG12.FSGD07PROT15.UINT16[L/H]
PBG12.FSGD07PROT15.UINT8[LL/HL/HH]
PBG12.ERRSLV07CTL.UINT32
PBG12.ERRSLV07CTL.UINT16[L]
PBG12.ERRSLV07CTL.UINT8[LL]
PBG12.ERRSLV07STAT.UINT32
PBG12.ERRSLV07STAT.UINT16[L]
PBG12.ERRSLV07STAT.UINT8[LL]
PBG12.ERRSLV07ADDR
PBG12.ERRSLV07TYPE.UINT32
PBG12.ERRSLV07TYPE.UINT16[L]
PBG13.FSGD08PROT0.UINT32
PBG13.FSGD08PROT0.UINT16[L/H]
PBG13.FSGD08PROT0.UINT8[LL/HL/HH]
PBG13.FSGD08PROT4.UINT32
PBG13.FSGD08PROT4.UINT16[L/H]
PBG13.FSGD08PROT4.UINT8[LL/HL/HH]
PBG13.FSGD08PROT5.UINT32
PBG13.FSGD08PROT5.UINT16[L/H]
PBG13.FSGD08PROT5.UINT8[LL/HL/HH]
PBG13.FSGD08PROT6.UINT32
PBG13.FSGD08PROT6.UINT16[L/H]
PBG13.FSGD08PROT6.UINT8[LL/HL/HH]
PBG13.FSGD08PROT8.UINT32
PBG13.FSGD08PROT8.UINT16[L/H]
PBG13.FSGD08PROT8.UINT8[LL/HL/HH]
PBG13.FSGD08PROT13.UINT32
PBG13.FSGD08PROT13.UINT16[L/H]
PBG13.FSGD08PROT13.UINT8[LL/HL/HH]
PBG13.FSGD08PROT14.UINT32
PBG13.FSGD08PROT14.UINT16[L/H]
PBG13.FSGD08PROT14.UINT8[LL/HL/HH]
PBG13.ERRSLV08CTL.UINT32
PBG13.ERRSLV08CTL.UINT16[L]
PBG13.ERRSLV08CTL.UINT8[LL]
PBG13.ERRSLV08STAT.UINT32
PBG13.ERRSLV08STAT.UINT16[L]
PBG13.ERRSLV08STAT.UINT8[LL]
PBG13.ERRSLV08ADDR
PBG13.ERRSLV08TYPE.UINT32
PBG13.ERRSLV08TYPE.UINT16[L]
PBGC0.FSGDC0PROT0.UINT32
PBGC0.FSGDC0PROT0.UINT16[L/H]
PBGC0.FSGDC0PROT0.UINT8[LL/HL/HH]
PBGC0.FSGDC0PROT1.UINT32
PBGC0.FSGDC0PROT1.UINT16[L/H]
PBGC0.FSGDC0PROT1.UINT8[LL/HL/HH]
PBGC0.ERRSLVC0CTL.UINT32
PBGC0.ERRSLVC0CTL.UINT16[L]
PBGC0.ERRSLVC0CTL.UINT8[LL]
PBGC0.ERRSLVC0STAT.UINT32
PBGC0.ERRSLVC0STAT.UINT16[L]
PBGC0.ERRSLVC0STAT.UINT8[LL]
PBGC0.ERRSLVC0ADDR
PBGC0.ERRSLVC0TYPE.UINT32
PBGC0.ERRSLVC0TYPE.UINT16[L]
PBGC1.FSGDC1PROT0.UINT32
PBGC1.FSGDC1PROT0.UINT16[L/H]
PBGC1.FSGDC1PROT0.UINT8[LL/HL/HH]
PBGC1.FSGDC1PROT1.UINT32
PBGC1.FSGDC1PROT1.UINT16[L/H]
PBGC1.FSGDC1PROT1.UINT8[LL/HL/HH]
PBGC1.FSGDC1PROT2.UINT32
PBGC1.FSGDC1PROT2.UINT16[L/H]
PBGC1.FSGDC1PROT2.UINT8[LL/HL/HH]
PBGC1.FSGDC1PROT3.UINT32
PBGC1.FSGDC1PROT3.UINT16[L/H]
PBGC1.FSGDC1PROT3.UINT8[LL/HL/HH]
PBGC1.FSGDC1PROT4.UINT32
PBGC1.FSGDC1PROT4.UINT16[L/H]
PBGC1.FSGDC1PROT4.UINT8[LL/HL/HH]
PBGC1.FSGDC1PROT5.UINT32
PBGC1.FSGDC1PROT5.UINT16[L/H]
PBGC1.FSGDC1PROT5.UINT8[LL/HL/HH]
PBGC1.ERRSLVC1CTL.UINT32
PBGC1.ERRSLVC1CTL.UINT16[L]
PBGC1.ERRSLVC1CTL.UINT8[LL]
PBGC1.ERRSLVC1STAT.UINT32
PBGC1.ERRSLVC1STAT.UINT16[L]
PBGC1.ERRSLVC1STAT.UINT8[LL]
PBGC1.ERRSLVC1ADDR
PBGC1.ERRSLVC1TYPE.UINT32
PBGC1.ERRSLVC1TYPE.UINT16[L]
DCIB.EEPRDCYCL
FBUF_CTRL.FBUFCCTL.UINT32
FBUF_CTRL.FBUFCCTL.UINT16[L]
FBUF_CTRL.FBUFCCTL.UINT8[LL]
CFECC_VCI.CFECCCTL_VCI.UINT32
CFECC_VCI.CFECCCTL_VCI.UINT16[L]
CFECC_VCI.CFERRINT_VCI.UINT32
CFECC_VCI.CFERRINT_VCI.UINT16[L]
CFECC_VCI.CFERRINT_VCI.UINT8[LL]
CFECC_VCI.CFSTCLR_VCI.UINT32
CFECC_VCI.CFSTCLR_VCI.UINT16[L]
CFECC_VCI.CFSTCLR_VCI.UINT8[LL]
CFECC_VCI.CFOVFSTR_VCI.UINT32
CFECC_VCI.CFOVFSTR_VCI.UINT16[L]
CFECC_VCI.CFOVFSTR_VCI.UINT8[LL]
CFECC_VCI.CF1STERSTR_VCI.UINT32
CFECC_VCI.CF1STERSTR_VCI.UINT16[L]
CFECC_VCI.CF1STERSTR_VCI.UINT8[LL]
CFECC_VCI.CF1STEADR0_VCI.UINT32
CFECC_VCI.CF1STEADR0_VCI.UINT16[L/H]
CFECC_VCI.CF1STEADR0_VCI.UINT8[LL/LH/HL/HH]
CFECC_VCI.CFSTSTCTL_VCI.UINT32
CFECC_VCI.CFSTSTCTL_VCI.UINT16[L]
CFECC_CPU1.CFECCCTL_PE1.UINT32
CFECC_CPU1.CFECCCTL_PE1.UINT16[L]
CFECC_CPU1.CFERRINT_PE1.UINT32
CFECC_CPU1.CFERRINT_PE1.UINT16[L]
CFECC_CPU1.CFERRINT_PE1.UINT8[LL]
CFECC_CPU1.CFSTCLR_PE1.UINT32
CFECC_CPU1.CFSTCLR_PE1.UINT16[L]
CFECC_CPU1.CFSTCLR_PE1.UINT8[LL]
CFECC_CPU1.CFOVFSTR_PE1.UINT32
CFECC_CPU1.CFOVFSTR_PE1.UINT16[L]
CFECC_CPU1.CFOVFSTR_PE1.UINT8[LL]
CFECC_CPU1.CF1STERSTR_PE1.UINT32
CFECC_CPU1.CF1STERSTR_PE1.UINT16[L]
CFECC_CPU1.CF1STERSTR_PE1.UINT8[LL]
CFECC_CPU1.CF1STEADR0_PE1.UINT32
CFECC_CPU1.CF1STEADR0_PE1.UINT16[L/H]
CFECC_CPU1.CF1STEADR0_PE1.UINT8[LL/LH/HL/HH]
DFECC.CTL
DFECC.DFERSTR
DFECC.DFERSTC
DFECC.DFOVFSTR
DFECC.DFOVFSTC
DFECC.DFERRINT
DFECC.DFEADR
DFECC.DFTSTCTL
LRTST.CTL_PE1.UINT32
LRTST.CTL_PE1.UINT16[L]
LRTST.LRTDATBF0_PE1
LRECC.CTL_PE1.UINT32
LRECC.CTL_PE1.UINT16[L]
LRECC.LRERRINT_PE1.UINT32
LRECC.LRERRINT_PE1.UINT16[L]
LRECC.LRERRINT_PE1.UINT8[LL]
LRECC.LRSTCLR_PE1.UINT32
LRECC.LRSTCLR_PE1.UINT16[L]
LRECC.LRSTCLR_PE1.UINT8[LL]
LRECC.LROVFSTR_PE1.UINT32
LRECC.LROVFSTR_PE1.UINT16[L]
LRECC.LROVFSTR_PE1.UINT8[LL]
LRECC.LR1STERSTR_PE1.UINT32
LRECC.LR1STERSTR_PE1.UINT16[L]
LRECC.LR1STERSTR_PE1.UINT8[LL]
LRECC.LR1STEADR0_PE1.UINT32
LRECC.LR1STEADR0_PE1.UINT16[L/H]
LRECC.LR1STEADR0_PE1.UINT8[LL/LH/HL]
ECCCSIH0.CTL
ECCCSIH0.TMC
ECCCSIH0.TRC.UINT32
ECCCSIH0.TRC.UINT8[LL/LH/HL/HH]
ECCCSIH0.TRC.REGS8.ERDB.UINT8
ECCCSIH0.TRC.REGS8.ECRD.UINT8
ECCCSIH0.TRC.REGS8.HORD.UINT8
ECCCSIH0.TRC.REGS8.SYND.UINT8
ECCCSIH0.TED
ECCCSIH0.AD0
ECCCFD0MB.CTL
ECCCFD0MB.TMC
ECCCFD0MB.TRC.UINT32
ECCCFD0MB.TRC.UINT8[LL/LH/HL/HH]
ECCCFD0MB.TRC.REGS8.ERDB.UINT8
ECCCFD0MB.TRC.REGS8.ECRD.UINT8
ECCCFD0MB.TRC.REGS8.HORD.UINT8
ECCCFD0MB.TRC.REGS8.SYND.UINT8
ECCCFD0MB.TED
ECCCFD0MB.AD0
ECCCFD0AFL0.CTL
ECCCFD0AFL0.TMC
ECCCFD0AFL0.TRC.UINT32
ECCCFD0AFL0.TRC.UINT8[LL/LH/HL/HH]
ECCCFD0AFL0.TRC.REGS8.ERDB.UINT8
ECCCFD0AFL0.TRC.REGS8.ECRD.UINT8
ECCCFD0AFL0.TRC.REGS8.HORD.UINT8
ECCCFD0AFL0.TRC.REGS8.SYND.UINT8
ECCCFD0AFL0.TED
ECCCFD0AFL0.AD0
ECCCFD0AFL1.CTL
ECCCFD0AFL1.TMC
ECCCFD0AFL1.TRC.UINT32
ECCCFD0AFL1.TRC.UINT8[LL/LH/HL/HH]
ECCCFD0AFL1.TRC.REGS8.ERDB.UINT8
ECCCFD0AFL1.TRC.REGS8.ECRD.UINT8
ECCCFD0AFL1.TRC.REGS8.HORD.UINT8
ECCCFD0AFL1.TRC.REGS8.SYND.UINT8
ECCCFD0AFL1.TED
ECCCFD0AFL1.AD0
SL_READTEST.SELB_READTEST
RIIC0.CR1.UINT32
RIIC0.CR1.UINT16[L]
RIIC0.CR1.UINT8[LL]
RIIC0.CR2.UINT32
RIIC0.CR2.UINT16[L]
RIIC0.CR2.UINT8[LL]
RIIC0.MR1.UINT32
RIIC0.MR1.UINT16[L]
RIIC0.MR1.UINT8[LL]
RIIC0.MR2.UINT32
RIIC0.MR2.UINT16[L]
RIIC0.MR2.UINT8[LL]
RIIC0.MR3.UINT32
RIIC0.MR3.UINT16[L]
RIIC0.MR3.UINT8[LL]
RIIC0.FER.UINT32
RIIC0.FER.UINT16[L]
RIIC0.FER.UINT8[LL]
RIIC0.SER.UINT32
RIIC0.SER.UINT16[L]
RIIC0.SER.UINT8[LL]
RIIC0.IER.UINT32
RIIC0.IER.UINT16[L]
RIIC0.IER.UINT8[LL]
RIIC0.SR1.UINT32
RIIC0.SR1.UINT16[L]
RIIC0.SR1.UINT8[LL]
RIIC0.SR2.UINT32
RIIC0.SR2.UINT16[L]
RIIC0.SR2.UINT8[LL]
RIIC0.SAR0.UINT32
RIIC0.SAR0.UINT16[L]
RIIC0.SAR0.UINT8[LL/LH]
RIIC0.SAR1.UINT32
RIIC0.SAR1.UINT16[L]
RIIC0.SAR1.UINT8[LL/LH]
RIIC0.SAR2.UINT32
RIIC0.SAR2.UINT16[L]
RIIC0.SAR2.UINT8[LL/LH]
RIIC0.BRL.UINT32
RIIC0.BRL.UINT16[L]
RIIC0.BRL.UINT8[LL]
RIIC0.BRH.UINT32
RIIC0.BRH.UINT16[L]
RIIC0.BRH.UINT8[LL]
RIIC0.DRT.UINT32
RIIC0.DRT.UINT16[L]
RIIC0.DRT.UINT8[LL]
RIIC0.DRR.UINT32
RIIC0.DRR.UINT16[L]
RIIC0.DRR.UINT8[LL]
RIIC1.CR1.UINT32
RIIC1.CR1.UINT16[L]
RIIC1.CR1.UINT8[LL]
RIIC1.CR2.UINT32
RIIC1.CR2.UINT16[L]
RIIC1.CR2.UINT8[LL]
RIIC1.MR1.UINT32
RIIC1.MR1.UINT16[L]
RIIC1.MR1.UINT8[LL]
RIIC1.MR2.UINT32
RIIC1.MR2.UINT16[L]
RIIC1.MR2.UINT8[LL]
RIIC1.MR3.UINT32
RIIC1.MR3.UINT16[L]
RIIC1.MR3.UINT8[LL]
RIIC1.FER.UINT32
RIIC1.FER.UINT16[L]
RIIC1.FER.UINT8[LL]
RIIC1.SER.UINT32
RIIC1.SER.UINT16[L]
RIIC1.SER.UINT8[LL]
RIIC1.IER.UINT32
RIIC1.IER.UINT16[L]
RIIC1.IER.UINT8[LL]
RIIC1.SR1.UINT32
RIIC1.SR1.UINT16[L]
RIIC1.SR1.UINT8[LL]
RIIC1.SR2.UINT32
RIIC1.SR2.UINT16[L]
RIIC1.SR2.UINT8[LL]
RIIC1.SAR0.UINT32
RIIC1.SAR0.UINT16[L]
RIIC1.SAR0.UINT8[LL/LH]
RIIC1.SAR1.UINT32
RIIC1.SAR1.UINT16[L]
RIIC1.SAR1.UINT8[LL/LH]
RIIC1.SAR2.UINT32
RIIC1.SAR2.UINT16[L]
RIIC1.SAR2.UINT8[LL/LH]
RIIC1.BRL.UINT32
RIIC1.BRL.UINT16[L]
RIIC1.BRL.UINT8[LL]
RIIC1.BRH.UINT32
RIIC1.BRH.UINT16[L]
RIIC1.BRH.UINT8[LL]
RIIC1.DRT.UINT32
RIIC1.DRT.UINT16[L]
RIIC1.DRT.UINT8[LL]
RIIC1.DRR.UINT32
RIIC1.DRR.UINT16[L]
RIIC1.DRR.UINT8[LL]
SCDS.PRDNAME1 ... SCDS.PRDNAME3
SCDS.CHIPID1LL
SCDS.CHIPID1LH
SCDS.CHIPID1HL
SCDS.CHIPID1HH
SCDS.CHIPID2LL
SCDS.CHIPID2LH
SCDS.CHIPID2HL
SCDS.CHIPID2HH
RLN240.GLWBR
RLN240.GLBRP0
RLN240.GLBRP1
RLN240.GLSTC
RLN2400.L0MD
RLN2400.L0BFC
RLN2400.L0SC
RLN2400.L0WUP
RLN2400.L0IE
RLN2400.L0EDE
RLN2400.L0CUC
RLN2400.L0TRC
RLN2400.L0MST
RLN2400.L0ST
RLN2400.L0EST
RLN2400.L0DFC
RLN2400.L0IDB
RLN2400.L0CBR
RLN2400.L0DBR1 ... RLN2400.L0DBR8
RLN2401.L1MD
RLN2401.L1BFC
RLN2401.L1SC
RLN2401.L1WUP
RLN2401.L1IE
RLN2401.L1EDE
RLN2401.L1CUC
RLN2401.L1TRC
RLN2401.L1MST
RLN2401.L1ST
RLN2401.L1EST
RLN2401.L1DFC
RLN2401.L1IDB
RLN2401.L1CBR
RLN2401.L1DBR1 ... RLN2401.L1DBR8
RLN30.LWBR
RLN30.LBRP01.UINT16
RLN30.LBRP01.UINT8[L/H]
RLN30.LBRP01.REGS8.LBRP0.UINT8
RLN30.LBRP01.REGS8.LBRP1.UINT8
RLN30.LSTC
RLN30.LMD
RLN30.LBFC
RLN30.LSC
RLN30.LWUP
RLN30.LIE
RLN30.LEDE
RLN30.LCUC
RLN30.LTRC
RLN30.LMST
RLN30.LST
RLN30.LEST
RLN30.LDFC
RLN30.LIDB
RLN30.LCBR
RLN30.LUDB0
RLN30.LDBR1 ... RLN30.LDBR8
RLN30.LUOER
RLN30.LUOR1
RLN30.LUTDR.UINT16
RLN30.LUTDR.UINT8[L/H]
RLN30.LURDR.UINT16
RLN30.LURDR.UINT8[L/H]
RLN30.LUWTDR.UINT16
RLN30.LUWTDR.UINT8[L/H]
RLN31.LWBR
RLN31.LBRP01.UINT16
RLN31.LBRP01.UINT8[L/H]
RLN31.LBRP01.REGS8.LBRP0.UINT8
RLN31.LBRP01.REGS8.LBRP1.UINT8
RLN31.LSTC
RLN31.LMD
RLN31.LBFC
RLN31.LSC
RLN31.LWUP
RLN31.LIE
RLN31.LEDE
RLN31.LCUC
RLN31.LTRC
RLN31.LMST
RLN31.LST
RLN31.LEST
RLN31.LDFC
RLN31.LIDB
RLN31.LCBR
RLN31.LUDB0
RLN31.LDBR1 ... RLN31.LDBR8
RLN31.LUOER
RLN31.LUOR1
RLN31.LUTDR.UINT16
RLN31.LUTDR.UINT8[L/H]
RLN31.LURDR.UINT16
RLN31.LURDR.UINT8[L/H]
RLN31.LUWTDR.UINT16
RLN31.LUWTDR.UINT8[L/H]
RSENT0.TSPC
RSENT0.TSC
RSENT0.CC
RSENT0.BRP
RSENT0.IDE
RSENT0.MDC
RSENT0.SPCT
RSENT0.MST
RSENT0.CS
RSENT0.CSC
RSENT0.SRTS
RSENT0.SRXD
RSENT0.CPL
RSENT0.ML
RSENT0.FRTS
RSENT0.FRXD
RSENT0.CPLM
RSENT0.MLM
RSENT0.FRTSM
RSENT0.EFRD0
RSENT0.EFRD1
RSENT1.TSPC
RSENT1.TSC
RSENT1.CC
RSENT1.BRP
RSENT1.IDE
RSENT1.MDC
RSENT1.SPCT
RSENT1.MST
RSENT1.CS
RSENT1.CSC
RSENT1.SRTS
RSENT1.SRXD
RSENT1.CPL
RSENT1.ML
RSENT1.FRTS
RSENT1.FRXD
RSENT1.CPLM
RSENT1.MLM
RSENT1.FRTSM
RSENT1.EFRD0
RSENT1.EFRD1
RCFDC0.CFDC0NCFG.UINT32
RCFDC0.CFDC0NCFG.UINT16[L/H]
RCFDC0.CFDC0NCFG.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC0CTR.UINT32
RCFDC0.CFDC0CTR.UINT16[L/H]
RCFDC0.CFDC0CTR.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC0STS.UINT32
RCFDC0.CFDC0STS.UINT16[L/H]
RCFDC0.CFDC0STS.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC0ERFL.UINT32
RCFDC0.CFDC0ERFL.UINT16[L/H]
RCFDC0.CFDC0ERFL.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC1NCFG.UINT32
RCFDC0.CFDC1NCFG.UINT16[L/H]
RCFDC0.CFDC1NCFG.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC1CTR.UINT32
RCFDC0.CFDC1CTR.UINT16[L/H]
RCFDC0.CFDC1CTR.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC1STS.UINT32
RCFDC0.CFDC1STS.UINT16[L/H]
RCFDC0.CFDC1STS.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC1ERFL.UINT32
RCFDC0.CFDC1ERFL.UINT16[L/H]
RCFDC0.CFDC1ERFL.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC2NCFG.UINT32
RCFDC0.CFDC2NCFG.UINT16[L/H]
RCFDC0.CFDC2NCFG.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC2CTR.UINT32
RCFDC0.CFDC2CTR.UINT16[L/H]
RCFDC0.CFDC2CTR.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC2STS.UINT32
RCFDC0.CFDC2STS.UINT16[L/H]
RCFDC0.CFDC2STS.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC2ERFL.UINT32
RCFDC0.CFDC2ERFL.UINT16[L/H]
RCFDC0.CFDC2ERFL.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGCFG.UINT32
RCFDC0.CFDGCFG.UINT16[L/H]
RCFDC0.CFDGCFG.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGCTR.UINT32
RCFDC0.CFDGCTR.UINT16[L/H]
RCFDC0.CFDGCTR.UINT8[LL/LH/HL]
RCFDC0.CFDGSTS.UINT32
RCFDC0.CFDGSTS.UINT16[L]
RCFDC0.CFDGSTS.UINT8[LL]
RCFDC0.CFDGERFL.UINT32
RCFDC0.CFDGERFL.UINT16[L/H]
RCFDC0.CFDGERFL.UINT8[LL/HL]
RCFDC0.CFDGTSC.UINT32
RCFDC0.CFDGTSC.UINT16[L]
RCFDC0.CFDGAFLECTR.UINT32
RCFDC0.CFDGAFLECTR.UINT16[L]
RCFDC0.CFDGAFLECTR.UINT8[LL/LH]
RCFDC0.CFDGAFLCFG0.UINT32
RCFDC0.CFDGAFLCFG0.UINT16[L/H]
RCFDC0.CFDGAFLCFG0.UINT8[LH/HL/HH]
RCFDC0.CFDRMNB.UINT32
RCFDC0.CFDRMNB.UINT16[L]
RCFDC0.CFDRMNB.UINT8[LL/LH]
RCFDC0.CFDRMND0.UINT32
RCFDC0.CFDRMND0.UINT16[L/H]
RCFDC0.CFDRMND0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMND1.UINT32
RCFDC0.CFDRMND1.UINT16[L]
RCFDC0.CFDRMND1.UINT8[LL/LH]
RCFDC0.CFDRFCC0.UINT32
RCFDC0.CFDRFCC0.UINT16[L]
RCFDC0.CFDRFCC0.UINT8[LL/LH]
RCFDC0.CFDRFCC1.UINT32
RCFDC0.CFDRFCC1.UINT16[L]
RCFDC0.CFDRFCC1.UINT8[LL/LH]
RCFDC0.CFDRFCC2.UINT32
RCFDC0.CFDRFCC2.UINT16[L]
RCFDC0.CFDRFCC2.UINT8[LL/LH]
RCFDC0.CFDRFCC3.UINT32
RCFDC0.CFDRFCC3.UINT16[L]
RCFDC0.CFDRFCC3.UINT8[LL/LH]
RCFDC0.CFDRFCC4.UINT32
RCFDC0.CFDRFCC4.UINT16[L]
RCFDC0.CFDRFCC4.UINT8[LL/LH]
RCFDC0.CFDRFCC5.UINT32
RCFDC0.CFDRFCC5.UINT16[L]
RCFDC0.CFDRFCC5.UINT8[LL/LH]
RCFDC0.CFDRFCC6.UINT32
RCFDC0.CFDRFCC6.UINT16[L]
RCFDC0.CFDRFCC6.UINT8[LL/LH]
RCFDC0.CFDRFCC7.UINT32
RCFDC0.CFDRFCC7.UINT16[L]
RCFDC0.CFDRFCC7.UINT8[LL/LH]
RCFDC0.CFDRFSTS0.UINT32
RCFDC0.CFDRFSTS0.UINT16[L]
RCFDC0.CFDRFSTS0.UINT8[LL/LH]
RCFDC0.CFDRFSTS1.UINT32
RCFDC0.CFDRFSTS1.UINT16[L]
RCFDC0.CFDRFSTS1.UINT8[LL/LH]
RCFDC0.CFDRFSTS2.UINT32
RCFDC0.CFDRFSTS2.UINT16[L]
RCFDC0.CFDRFSTS2.UINT8[LL/LH]
RCFDC0.CFDRFSTS3.UINT32
RCFDC0.CFDRFSTS3.UINT16[L]
RCFDC0.CFDRFSTS3.UINT8[LL/LH]
RCFDC0.CFDRFSTS4.UINT32
RCFDC0.CFDRFSTS4.UINT16[L]
RCFDC0.CFDRFSTS4.UINT8[LL/LH]
RCFDC0.CFDRFSTS5.UINT32
RCFDC0.CFDRFSTS5.UINT16[L]
RCFDC0.CFDRFSTS5.UINT8[LL/LH]
RCFDC0.CFDRFSTS6.UINT32
RCFDC0.CFDRFSTS6.UINT16[L]
RCFDC0.CFDRFSTS6.UINT8[LL/LH]
RCFDC0.CFDRFSTS7.UINT32
RCFDC0.CFDRFSTS7.UINT16[L]
RCFDC0.CFDRFSTS7.UINT8[LL/LH]
RCFDC0.CFDRFPCTR0.UINT32
RCFDC0.CFDRFPCTR0.UINT16[L]
RCFDC0.CFDRFPCTR0.UINT8[LL]
RCFDC0.CFDRFPCTR1.UINT32
RCFDC0.CFDRFPCTR1.UINT16[L]
RCFDC0.CFDRFPCTR1.UINT8[LL]
RCFDC0.CFDRFPCTR2.UINT32
RCFDC0.CFDRFPCTR2.UINT16[L]
RCFDC0.CFDRFPCTR2.UINT8[LL]
RCFDC0.CFDRFPCTR3.UINT32
RCFDC0.CFDRFPCTR3.UINT16[L]
RCFDC0.CFDRFPCTR3.UINT8[LL]
RCFDC0.CFDRFPCTR4.UINT32
RCFDC0.CFDRFPCTR4.UINT16[L]
RCFDC0.CFDRFPCTR4.UINT8[LL]
RCFDC0.CFDRFPCTR5.UINT32
RCFDC0.CFDRFPCTR5.UINT16[L]
RCFDC0.CFDRFPCTR5.UINT8[LL]
RCFDC0.CFDRFPCTR6.UINT32
RCFDC0.CFDRFPCTR6.UINT16[L]
RCFDC0.CFDRFPCTR6.UINT8[LL]
RCFDC0.CFDRFPCTR7.UINT32
RCFDC0.CFDRFPCTR7.UINT16[L]
RCFDC0.CFDRFPCTR7.UINT8[LL]
RCFDC0.CFDCFCC0.UINT32
RCFDC0.CFDCFCC0.UINT16[L/H]
RCFDC0.CFDCFCC0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFCC1.UINT32
RCFDC0.CFDCFCC1.UINT16[L/H]
RCFDC0.CFDCFCC1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFCC2.UINT32
RCFDC0.CFDCFCC2.UINT16[L/H]
RCFDC0.CFDCFCC2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFCC3.UINT32
RCFDC0.CFDCFCC3.UINT16[L/H]
RCFDC0.CFDCFCC3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFCC4.UINT32
RCFDC0.CFDCFCC4.UINT16[L/H]
RCFDC0.CFDCFCC4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFCC5.UINT32
RCFDC0.CFDCFCC5.UINT16[L/H]
RCFDC0.CFDCFCC5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFCC6.UINT32
RCFDC0.CFDCFCC6.UINT16[L/H]
RCFDC0.CFDCFCC6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFCC7.UINT32
RCFDC0.CFDCFCC7.UINT16[L/H]
RCFDC0.CFDCFCC7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFCC8.UINT32
RCFDC0.CFDCFCC8.UINT16[L/H]
RCFDC0.CFDCFCC8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFSTS0.UINT32
RCFDC0.CFDCFSTS0.UINT16[L]
RCFDC0.CFDCFSTS0.UINT8[LL/LH]
RCFDC0.CFDCFSTS1.UINT32
RCFDC0.CFDCFSTS1.UINT16[L]
RCFDC0.CFDCFSTS1.UINT8[LL/LH]
RCFDC0.CFDCFSTS2.UINT32
RCFDC0.CFDCFSTS2.UINT16[L]
RCFDC0.CFDCFSTS2.UINT8[LL/LH]
RCFDC0.CFDCFSTS3.UINT32
RCFDC0.CFDCFSTS3.UINT16[L]
RCFDC0.CFDCFSTS3.UINT8[LL/LH]
RCFDC0.CFDCFSTS4.UINT32
RCFDC0.CFDCFSTS4.UINT16[L]
RCFDC0.CFDCFSTS4.UINT8[LL/LH]
RCFDC0.CFDCFSTS5.UINT32
RCFDC0.CFDCFSTS5.UINT16[L]
RCFDC0.CFDCFSTS5.UINT8[LL/LH]
RCFDC0.CFDCFSTS6.UINT32
RCFDC0.CFDCFSTS6.UINT16[L]
RCFDC0.CFDCFSTS6.UINT8[LL/LH]
RCFDC0.CFDCFSTS7.UINT32
RCFDC0.CFDCFSTS7.UINT16[L]
RCFDC0.CFDCFSTS7.UINT8[LL/LH]
RCFDC0.CFDCFSTS8.UINT32
RCFDC0.CFDCFSTS8.UINT16[L]
RCFDC0.CFDCFSTS8.UINT8[LL/LH]
RCFDC0.CFDCFPCTR0.UINT32
RCFDC0.CFDCFPCTR0.UINT16[L]
RCFDC0.CFDCFPCTR0.UINT8[LL]
RCFDC0.CFDCFPCTR1.UINT32
RCFDC0.CFDCFPCTR1.UINT16[L]
RCFDC0.CFDCFPCTR1.UINT8[LL]
RCFDC0.CFDCFPCTR2.UINT32
RCFDC0.CFDCFPCTR2.UINT16[L]
RCFDC0.CFDCFPCTR2.UINT8[LL]
RCFDC0.CFDCFPCTR3.UINT32
RCFDC0.CFDCFPCTR3.UINT16[L]
RCFDC0.CFDCFPCTR3.UINT8[LL]
RCFDC0.CFDCFPCTR4.UINT32
RCFDC0.CFDCFPCTR4.UINT16[L]
RCFDC0.CFDCFPCTR4.UINT8[LL]
RCFDC0.CFDCFPCTR5.UINT32
RCFDC0.CFDCFPCTR5.UINT16[L]
RCFDC0.CFDCFPCTR5.UINT8[LL]
RCFDC0.CFDCFPCTR6.UINT32
RCFDC0.CFDCFPCTR6.UINT16[L]
RCFDC0.CFDCFPCTR6.UINT8[LL]
RCFDC0.CFDCFPCTR7.UINT32
RCFDC0.CFDCFPCTR7.UINT16[L]
RCFDC0.CFDCFPCTR7.UINT8[LL]
RCFDC0.CFDCFPCTR8.UINT32
RCFDC0.CFDCFPCTR8.UINT16[L]
RCFDC0.CFDCFPCTR8.UINT8[LL]
RCFDC0.CFDFESTS.UINT32
RCFDC0.CFDFESTS.UINT16[L/H]
RCFDC0.CFDFESTS.UINT8[LL/LH/HL]
RCFDC0.CFDFFSTS.UINT32
RCFDC0.CFDFFSTS.UINT16[L/H]
RCFDC0.CFDFFSTS.UINT8[LL/LH/HL]
RCFDC0.CFDFMSTS.UINT32
RCFDC0.CFDFMSTS.UINT16[L/H]
RCFDC0.CFDFMSTS.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFISTS.UINT32
RCFDC0.CFDRFISTS.UINT16[L]
RCFDC0.CFDRFISTS.UINT8[LL]
RCFDC0.CFDCFRISTS.UINT32
RCFDC0.CFDCFRISTS.UINT16[L]
RCFDC0.CFDCFRISTS.UINT8[LL/LH]
RCFDC0.CFDCFTISTS.UINT32
RCFDC0.CFDCFTISTS.UINT16[L]
RCFDC0.CFDCFTISTS.UINT8[LL/LH]
RCFDC0.CFDTMC0 ... RCFDC0.CFDTMC95
RCFDC0.CFDTMSTS0 ... RCFDC0.CFDTMSTS95
RCFDC0.CFDTMTRSTS0.UINT32
RCFDC0.CFDTMTRSTS0.UINT16[L/H]
RCFDC0.CFDTMTRSTS0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTRSTS1.UINT32
RCFDC0.CFDTMTRSTS1.UINT16[L/H]
RCFDC0.CFDTMTRSTS1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTRSTS2.UINT32
RCFDC0.CFDTMTRSTS2.UINT16[L/H]
RCFDC0.CFDTMTRSTS2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTARSTS0.UINT32
RCFDC0.CFDTMTARSTS0.UINT16[L/H]
RCFDC0.CFDTMTARSTS0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTARSTS1.UINT32
RCFDC0.CFDTMTARSTS1.UINT16[L/H]
RCFDC0.CFDTMTARSTS1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTARSTS2.UINT32
RCFDC0.CFDTMTARSTS2.UINT16[L/H]
RCFDC0.CFDTMTARSTS2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTCSTS0.UINT32
RCFDC0.CFDTMTCSTS0.UINT16[L/H]
RCFDC0.CFDTMTCSTS0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTCSTS1.UINT32
RCFDC0.CFDTMTCSTS1.UINT16[L/H]
RCFDC0.CFDTMTCSTS1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTCSTS2.UINT32
RCFDC0.CFDTMTCSTS2.UINT16[L/H]
RCFDC0.CFDTMTCSTS2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTASTS0.UINT32
RCFDC0.CFDTMTASTS0.UINT16[L/H]
RCFDC0.CFDTMTASTS0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTASTS1.UINT32
RCFDC0.CFDTMTASTS1.UINT16[L/H]
RCFDC0.CFDTMTASTS1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMTASTS2.UINT32
RCFDC0.CFDTMTASTS2.UINT16[L/H]
RCFDC0.CFDTMTASTS2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMIEC0.UINT32
RCFDC0.CFDTMIEC0.UINT16[L/H]
RCFDC0.CFDTMIEC0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMIEC1.UINT32
RCFDC0.CFDTMIEC1.UINT16[L/H]
RCFDC0.CFDTMIEC1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMIEC2.UINT32
RCFDC0.CFDTMIEC2.UINT16[L/H]
RCFDC0.CFDTMIEC2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTXQCC0.UINT32
RCFDC0.CFDTXQCC0.UINT16[L]
RCFDC0.CFDTXQCC0.UINT8[LL/LH]
RCFDC0.CFDTXQCC1.UINT32
RCFDC0.CFDTXQCC1.UINT16[L]
RCFDC0.CFDTXQCC1.UINT8[LL/LH]
RCFDC0.CFDTXQCC2.UINT32
RCFDC0.CFDTXQCC2.UINT16[L]
RCFDC0.CFDTXQCC2.UINT8[LL/LH]
RCFDC0.CFDTXQSTS0.UINT32
RCFDC0.CFDTXQSTS0.UINT16[L]
RCFDC0.CFDTXQSTS0.UINT8[LL]
RCFDC0.CFDTXQSTS1.UINT32
RCFDC0.CFDTXQSTS1.UINT16[L]
RCFDC0.CFDTXQSTS1.UINT8[LL]
RCFDC0.CFDTXQSTS2.UINT32
RCFDC0.CFDTXQSTS2.UINT16[L]
RCFDC0.CFDTXQSTS2.UINT8[LL]
RCFDC0.CFDTXQPCTR0.UINT32
RCFDC0.CFDTXQPCTR0.UINT16[L]
RCFDC0.CFDTXQPCTR0.UINT8[LL]
RCFDC0.CFDTXQPCTR1.UINT32
RCFDC0.CFDTXQPCTR1.UINT16[L]
RCFDC0.CFDTXQPCTR1.UINT8[LL]
RCFDC0.CFDTXQPCTR2.UINT32
RCFDC0.CFDTXQPCTR2.UINT16[L]
RCFDC0.CFDTXQPCTR2.UINT8[LL]
RCFDC0.CFDTHLCC0.UINT32
RCFDC0.CFDTHLCC0.UINT16[L]
RCFDC0.CFDTHLCC0.UINT8[LL/LH]
RCFDC0.CFDTHLCC1.UINT32
RCFDC0.CFDTHLCC1.UINT16[L]
RCFDC0.CFDTHLCC1.UINT8[LL/LH]
RCFDC0.CFDTHLCC2.UINT32
RCFDC0.CFDTHLCC2.UINT16[L]
RCFDC0.CFDTHLCC2.UINT8[LL/LH]
RCFDC0.CFDTHLSTS0.UINT32
RCFDC0.CFDTHLSTS0.UINT16[L]
RCFDC0.CFDTHLSTS0.UINT8[LL/LH]
RCFDC0.CFDTHLSTS1.UINT32
RCFDC0.CFDTHLSTS1.UINT16[L]
RCFDC0.CFDTHLSTS1.UINT8[LL/LH]
RCFDC0.CFDTHLSTS2.UINT32
RCFDC0.CFDTHLSTS2.UINT16[L]
RCFDC0.CFDTHLSTS2.UINT8[LL/LH]
RCFDC0.CFDTHLPCTR0.UINT32
RCFDC0.CFDTHLPCTR0.UINT16[L]
RCFDC0.CFDTHLPCTR0.UINT8[LL]
RCFDC0.CFDTHLPCTR1.UINT32
RCFDC0.CFDTHLPCTR1.UINT16[L]
RCFDC0.CFDTHLPCTR1.UINT8[LL]
RCFDC0.CFDTHLPCTR2.UINT32
RCFDC0.CFDTHLPCTR2.UINT16[L]
RCFDC0.CFDTHLPCTR2.UINT8[LL]
RCFDC0.CFDGTINTSTS0.UINT32
RCFDC0.CFDGTINTSTS0.UINT16[L/H]
RCFDC0.CFDGTINTSTS0.UINT8[LL/LH/HL]
RCFDC0.CFDGTSTCFG.UINT32
RCFDC0.CFDGTSTCFG.UINT16[L/H]
RCFDC0.CFDGTSTCFG.UINT8[LL/HL/HH]
RCFDC0.CFDGTSTCTR.UINT32
RCFDC0.CFDGTSTCTR.UINT16[L]
RCFDC0.CFDGTSTCTR.UINT8[LL]
RCFDC0.CFDGFDCFG.UINT32
RCFDC0.CFDGFDCFG.UINT16[L]
RCFDC0.CFDGFDCFG.UINT8[LL/LH]
RCFDC0.CFDGLOCKK.UINT32
RCFDC0.CFDGLOCKK.UINT16[L]
RCFDC0.CFDCDTCT.UINT32
RCFDC0.CFDCDTCT.UINT16[L]
RCFDC0.CFDCDTCT.UINT8[LL/LH]
RCFDC0.CFDCDTSTS.UINT32
RCFDC0.CFDCDTSTS.UINT16[L]
RCFDC0.CFDCDTSTS.UINT8[LL/LH]
RCFDC0.CFDC0DCFG.UINT32
RCFDC0.CFDC0DCFG.UINT16[L/H]
RCFDC0.CFDC0DCFG.UINT8[LL/HL/HH]
RCFDC0.CFDC0FDCFG.UINT32
RCFDC0.CFDC0FDCFG.UINT16[L/H]
RCFDC0.CFDC0FDCFG.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC0FDCTR.UINT32
RCFDC0.CFDC0FDCTR.UINT16[L]
RCFDC0.CFDC0FDCTR.UINT8[LL]
RCFDC0.CFDC0FDSTS.UINT32
RCFDC0.CFDC0FDSTS.UINT16[L/H]
RCFDC0.CFDC0FDSTS.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC0FDCRC.UINT32
RCFDC0.CFDC0FDCRC.UINT16[L/H]
RCFDC0.CFDC0FDCRC.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC1DCFG.UINT32
RCFDC0.CFDC1DCFG.UINT16[L/H]
RCFDC0.CFDC1DCFG.UINT8[LL/HL/HH]
RCFDC0.CFDC1FDCFG.UINT32
RCFDC0.CFDC1FDCFG.UINT16[L/H]
RCFDC0.CFDC1FDCFG.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC1FDCTR.UINT32
RCFDC0.CFDC1FDCTR.UINT16[L]
RCFDC0.CFDC1FDCTR.UINT8[LL]
RCFDC0.CFDC1FDSTS.UINT32
RCFDC0.CFDC1FDSTS.UINT16[L/H]
RCFDC0.CFDC1FDSTS.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC1FDCRC.UINT32
RCFDC0.CFDC1FDCRC.UINT16[L/H]
RCFDC0.CFDC1FDCRC.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC2DCFG.UINT32
RCFDC0.CFDC2DCFG.UINT16[L/H]
RCFDC0.CFDC2DCFG.UINT8[LL/HL/HH]
RCFDC0.CFDC2FDCFG.UINT32
RCFDC0.CFDC2FDCFG.UINT16[L/H]
RCFDC0.CFDC2FDCFG.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC2FDCTR.UINT32
RCFDC0.CFDC2FDCTR.UINT16[L]
RCFDC0.CFDC2FDCTR.UINT8[LL]
RCFDC0.CFDC2FDSTS.UINT32
RCFDC0.CFDC2FDSTS.UINT16[L/H]
RCFDC0.CFDC2FDSTS.UINT8[LL/LH/HL/HH]
RCFDC0.CFDC2FDCRC.UINT32
RCFDC0.CFDC2FDCRC.UINT16[L/H]
RCFDC0.CFDC2FDCRC.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLID0.UINT32
RCFDC0.CFDGAFLID0.UINT16[L/H]
RCFDC0.CFDGAFLID0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM0.UINT32
RCFDC0.CFDGAFLM0.UINT16[L/H]
RCFDC0.CFDGAFLM0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_0.UINT32
RCFDC0.CFDGAFLP0_0.UINT16[L/H]
RCFDC0.CFDGAFLP0_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_0.UINT32
RCFDC0.CFDGAFLP1_0.UINT16[L/H]
RCFDC0.CFDGAFLP1_0.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID1.UINT32
RCFDC0.CFDGAFLID1.UINT16[L/H]
RCFDC0.CFDGAFLID1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM1.UINT32
RCFDC0.CFDGAFLM1.UINT16[L/H]
RCFDC0.CFDGAFLM1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_1.UINT32
RCFDC0.CFDGAFLP0_1.UINT16[L/H]
RCFDC0.CFDGAFLP0_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_1.UINT32
RCFDC0.CFDGAFLP1_1.UINT16[L/H]
RCFDC0.CFDGAFLP1_1.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID2.UINT32
RCFDC0.CFDGAFLID2.UINT16[L/H]
RCFDC0.CFDGAFLID2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM2.UINT32
RCFDC0.CFDGAFLM2.UINT16[L/H]
RCFDC0.CFDGAFLM2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_2.UINT32
RCFDC0.CFDGAFLP0_2.UINT16[L/H]
RCFDC0.CFDGAFLP0_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_2.UINT32
RCFDC0.CFDGAFLP1_2.UINT16[L/H]
RCFDC0.CFDGAFLP1_2.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID3.UINT32
RCFDC0.CFDGAFLID3.UINT16[L/H]
RCFDC0.CFDGAFLID3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM3.UINT32
RCFDC0.CFDGAFLM3.UINT16[L/H]
RCFDC0.CFDGAFLM3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_3.UINT32
RCFDC0.CFDGAFLP0_3.UINT16[L/H]
RCFDC0.CFDGAFLP0_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_3.UINT32
RCFDC0.CFDGAFLP1_3.UINT16[L/H]
RCFDC0.CFDGAFLP1_3.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID4.UINT32
RCFDC0.CFDGAFLID4.UINT16[L/H]
RCFDC0.CFDGAFLID4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM4.UINT32
RCFDC0.CFDGAFLM4.UINT16[L/H]
RCFDC0.CFDGAFLM4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_4.UINT32
RCFDC0.CFDGAFLP0_4.UINT16[L/H]
RCFDC0.CFDGAFLP0_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_4.UINT32
RCFDC0.CFDGAFLP1_4.UINT16[L/H]
RCFDC0.CFDGAFLP1_4.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID5.UINT32
RCFDC0.CFDGAFLID5.UINT16[L/H]
RCFDC0.CFDGAFLID5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM5.UINT32
RCFDC0.CFDGAFLM5.UINT16[L/H]
RCFDC0.CFDGAFLM5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_5.UINT32
RCFDC0.CFDGAFLP0_5.UINT16[L/H]
RCFDC0.CFDGAFLP0_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_5.UINT32
RCFDC0.CFDGAFLP1_5.UINT16[L/H]
RCFDC0.CFDGAFLP1_5.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID6.UINT32
RCFDC0.CFDGAFLID6.UINT16[L/H]
RCFDC0.CFDGAFLID6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM6.UINT32
RCFDC0.CFDGAFLM6.UINT16[L/H]
RCFDC0.CFDGAFLM6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_6.UINT32
RCFDC0.CFDGAFLP0_6.UINT16[L/H]
RCFDC0.CFDGAFLP0_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_6.UINT32
RCFDC0.CFDGAFLP1_6.UINT16[L/H]
RCFDC0.CFDGAFLP1_6.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID7.UINT32
RCFDC0.CFDGAFLID7.UINT16[L/H]
RCFDC0.CFDGAFLID7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM7.UINT32
RCFDC0.CFDGAFLM7.UINT16[L/H]
RCFDC0.CFDGAFLM7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_7.UINT32
RCFDC0.CFDGAFLP0_7.UINT16[L/H]
RCFDC0.CFDGAFLP0_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_7.UINT32
RCFDC0.CFDGAFLP1_7.UINT16[L/H]
RCFDC0.CFDGAFLP1_7.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID8.UINT32
RCFDC0.CFDGAFLID8.UINT16[L/H]
RCFDC0.CFDGAFLID8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM8.UINT32
RCFDC0.CFDGAFLM8.UINT16[L/H]
RCFDC0.CFDGAFLM8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_8.UINT32
RCFDC0.CFDGAFLP0_8.UINT16[L/H]
RCFDC0.CFDGAFLP0_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_8.UINT32
RCFDC0.CFDGAFLP1_8.UINT16[L/H]
RCFDC0.CFDGAFLP1_8.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID9.UINT32
RCFDC0.CFDGAFLID9.UINT16[L/H]
RCFDC0.CFDGAFLID9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM9.UINT32
RCFDC0.CFDGAFLM9.UINT16[L/H]
RCFDC0.CFDGAFLM9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_9.UINT32
RCFDC0.CFDGAFLP0_9.UINT16[L/H]
RCFDC0.CFDGAFLP0_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_9.UINT32
RCFDC0.CFDGAFLP1_9.UINT16[L/H]
RCFDC0.CFDGAFLP1_9.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID10.UINT32
RCFDC0.CFDGAFLID10.UINT16[L/H]
RCFDC0.CFDGAFLID10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM10.UINT32
RCFDC0.CFDGAFLM10.UINT16[L/H]
RCFDC0.CFDGAFLM10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_10.UINT32
RCFDC0.CFDGAFLP0_10.UINT16[L/H]
RCFDC0.CFDGAFLP0_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_10.UINT32
RCFDC0.CFDGAFLP1_10.UINT16[L/H]
RCFDC0.CFDGAFLP1_10.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID11.UINT32
RCFDC0.CFDGAFLID11.UINT16[L/H]
RCFDC0.CFDGAFLID11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM11.UINT32
RCFDC0.CFDGAFLM11.UINT16[L/H]
RCFDC0.CFDGAFLM11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_11.UINT32
RCFDC0.CFDGAFLP0_11.UINT16[L/H]
RCFDC0.CFDGAFLP0_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_11.UINT32
RCFDC0.CFDGAFLP1_11.UINT16[L/H]
RCFDC0.CFDGAFLP1_11.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID12.UINT32
RCFDC0.CFDGAFLID12.UINT16[L/H]
RCFDC0.CFDGAFLID12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM12.UINT32
RCFDC0.CFDGAFLM12.UINT16[L/H]
RCFDC0.CFDGAFLM12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_12.UINT32
RCFDC0.CFDGAFLP0_12.UINT16[L/H]
RCFDC0.CFDGAFLP0_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_12.UINT32
RCFDC0.CFDGAFLP1_12.UINT16[L/H]
RCFDC0.CFDGAFLP1_12.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID13.UINT32
RCFDC0.CFDGAFLID13.UINT16[L/H]
RCFDC0.CFDGAFLID13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM13.UINT32
RCFDC0.CFDGAFLM13.UINT16[L/H]
RCFDC0.CFDGAFLM13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_13.UINT32
RCFDC0.CFDGAFLP0_13.UINT16[L/H]
RCFDC0.CFDGAFLP0_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_13.UINT32
RCFDC0.CFDGAFLP1_13.UINT16[L/H]
RCFDC0.CFDGAFLP1_13.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID14.UINT32
RCFDC0.CFDGAFLID14.UINT16[L/H]
RCFDC0.CFDGAFLID14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM14.UINT32
RCFDC0.CFDGAFLM14.UINT16[L/H]
RCFDC0.CFDGAFLM14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_14.UINT32
RCFDC0.CFDGAFLP0_14.UINT16[L/H]
RCFDC0.CFDGAFLP0_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_14.UINT32
RCFDC0.CFDGAFLP1_14.UINT16[L/H]
RCFDC0.CFDGAFLP1_14.UINT8[LL/LH/HL]
RCFDC0.CFDGAFLID15.UINT32
RCFDC0.CFDGAFLID15.UINT16[L/H]
RCFDC0.CFDGAFLID15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLM15.UINT32
RCFDC0.CFDGAFLM15.UINT16[L/H]
RCFDC0.CFDGAFLM15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP0_15.UINT32
RCFDC0.CFDGAFLP0_15.UINT16[L/H]
RCFDC0.CFDGAFLP0_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDGAFLP1_15.UINT32
RCFDC0.CFDGAFLP1_15.UINT16[L/H]
RCFDC0.CFDGAFLP1_15.UINT8[LL/LH/HL]
RCFDC0.CFDRMID0.UINT32
RCFDC0.CFDRMID0.UINT16[L/H]
RCFDC0.CFDRMID0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR0.UINT32
RCFDC0.CFDRMPTR0.UINT16[L/H]
RCFDC0.CFDRMPTR0.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS0.UINT32
RCFDC0.CFDRMFDSTS0.UINT16[L/H]
RCFDC0.CFDRMFDSTS0.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_0.UINT32
RCFDC0.CFDRMDF0_0.UINT16[L/H]
RCFDC0.CFDRMDF0_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_0.UINT32
RCFDC0.CFDRMDF1_0.UINT16[L/H]
RCFDC0.CFDRMDF1_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_0.UINT32
RCFDC0.CFDRMDF2_0.UINT16[L/H]
RCFDC0.CFDRMDF2_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_0.UINT32
RCFDC0.CFDRMDF3_0.UINT16[L/H]
RCFDC0.CFDRMDF3_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_0.UINT32
RCFDC0.CFDRMDF4_0.UINT16[L/H]
RCFDC0.CFDRMDF4_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_0.UINT32
RCFDC0.CFDRMDF5_0.UINT16[L/H]
RCFDC0.CFDRMDF5_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_0.UINT32
RCFDC0.CFDRMDF6_0.UINT16[L/H]
RCFDC0.CFDRMDF6_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_0.UINT32
RCFDC0.CFDRMDF7_0.UINT16[L/H]
RCFDC0.CFDRMDF7_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_0.UINT32
RCFDC0.CFDRMDF8_0.UINT16[L/H]
RCFDC0.CFDRMDF8_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_0.UINT32
RCFDC0.CFDRMDF9_0.UINT16[L/H]
RCFDC0.CFDRMDF9_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_0.UINT32
RCFDC0.CFDRMDF10_0.UINT16[L/H]
RCFDC0.CFDRMDF10_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_0.UINT32
RCFDC0.CFDRMDF11_0.UINT16[L/H]
RCFDC0.CFDRMDF11_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_0.UINT32
RCFDC0.CFDRMDF12_0.UINT16[L/H]
RCFDC0.CFDRMDF12_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_0.UINT32
RCFDC0.CFDRMDF13_0.UINT16[L/H]
RCFDC0.CFDRMDF13_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_0.UINT32
RCFDC0.CFDRMDF14_0.UINT16[L/H]
RCFDC0.CFDRMDF14_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_0.UINT32
RCFDC0.CFDRMDF15_0.UINT16[L/H]
RCFDC0.CFDRMDF15_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID1.UINT32
RCFDC0.CFDRMID1.UINT16[L/H]
RCFDC0.CFDRMID1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR1.UINT32
RCFDC0.CFDRMPTR1.UINT16[L/H]
RCFDC0.CFDRMPTR1.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS1.UINT32
RCFDC0.CFDRMFDSTS1.UINT16[L/H]
RCFDC0.CFDRMFDSTS1.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_1.UINT32
RCFDC0.CFDRMDF0_1.UINT16[L/H]
RCFDC0.CFDRMDF0_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_1.UINT32
RCFDC0.CFDRMDF1_1.UINT16[L/H]
RCFDC0.CFDRMDF1_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_1.UINT32
RCFDC0.CFDRMDF2_1.UINT16[L/H]
RCFDC0.CFDRMDF2_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_1.UINT32
RCFDC0.CFDRMDF3_1.UINT16[L/H]
RCFDC0.CFDRMDF3_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_1.UINT32
RCFDC0.CFDRMDF4_1.UINT16[L/H]
RCFDC0.CFDRMDF4_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_1.UINT32
RCFDC0.CFDRMDF5_1.UINT16[L/H]
RCFDC0.CFDRMDF5_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_1.UINT32
RCFDC0.CFDRMDF6_1.UINT16[L/H]
RCFDC0.CFDRMDF6_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_1.UINT32
RCFDC0.CFDRMDF7_1.UINT16[L/H]
RCFDC0.CFDRMDF7_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_1.UINT32
RCFDC0.CFDRMDF8_1.UINT16[L/H]
RCFDC0.CFDRMDF8_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_1.UINT32
RCFDC0.CFDRMDF9_1.UINT16[L/H]
RCFDC0.CFDRMDF9_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_1.UINT32
RCFDC0.CFDRMDF10_1.UINT16[L/H]
RCFDC0.CFDRMDF10_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_1.UINT32
RCFDC0.CFDRMDF11_1.UINT16[L/H]
RCFDC0.CFDRMDF11_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_1.UINT32
RCFDC0.CFDRMDF12_1.UINT16[L/H]
RCFDC0.CFDRMDF12_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_1.UINT32
RCFDC0.CFDRMDF13_1.UINT16[L/H]
RCFDC0.CFDRMDF13_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_1.UINT32
RCFDC0.CFDRMDF14_1.UINT16[L/H]
RCFDC0.CFDRMDF14_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_1.UINT32
RCFDC0.CFDRMDF15_1.UINT16[L/H]
RCFDC0.CFDRMDF15_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID2.UINT32
RCFDC0.CFDRMID2.UINT16[L/H]
RCFDC0.CFDRMID2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR2.UINT32
RCFDC0.CFDRMPTR2.UINT16[L/H]
RCFDC0.CFDRMPTR2.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS2.UINT32
RCFDC0.CFDRMFDSTS2.UINT16[L/H]
RCFDC0.CFDRMFDSTS2.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_2.UINT32
RCFDC0.CFDRMDF0_2.UINT16[L/H]
RCFDC0.CFDRMDF0_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_2.UINT32
RCFDC0.CFDRMDF1_2.UINT16[L/H]
RCFDC0.CFDRMDF1_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_2.UINT32
RCFDC0.CFDRMDF2_2.UINT16[L/H]
RCFDC0.CFDRMDF2_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_2.UINT32
RCFDC0.CFDRMDF3_2.UINT16[L/H]
RCFDC0.CFDRMDF3_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_2.UINT32
RCFDC0.CFDRMDF4_2.UINT16[L/H]
RCFDC0.CFDRMDF4_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_2.UINT32
RCFDC0.CFDRMDF5_2.UINT16[L/H]
RCFDC0.CFDRMDF5_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_2.UINT32
RCFDC0.CFDRMDF6_2.UINT16[L/H]
RCFDC0.CFDRMDF6_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_2.UINT32
RCFDC0.CFDRMDF7_2.UINT16[L/H]
RCFDC0.CFDRMDF7_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_2.UINT32
RCFDC0.CFDRMDF8_2.UINT16[L/H]
RCFDC0.CFDRMDF8_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_2.UINT32
RCFDC0.CFDRMDF9_2.UINT16[L/H]
RCFDC0.CFDRMDF9_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_2.UINT32
RCFDC0.CFDRMDF10_2.UINT16[L/H]
RCFDC0.CFDRMDF10_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_2.UINT32
RCFDC0.CFDRMDF11_2.UINT16[L/H]
RCFDC0.CFDRMDF11_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_2.UINT32
RCFDC0.CFDRMDF12_2.UINT16[L/H]
RCFDC0.CFDRMDF12_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_2.UINT32
RCFDC0.CFDRMDF13_2.UINT16[L/H]
RCFDC0.CFDRMDF13_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_2.UINT32
RCFDC0.CFDRMDF14_2.UINT16[L/H]
RCFDC0.CFDRMDF14_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_2.UINT32
RCFDC0.CFDRMDF15_2.UINT16[L/H]
RCFDC0.CFDRMDF15_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID3.UINT32
RCFDC0.CFDRMID3.UINT16[L/H]
RCFDC0.CFDRMID3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR3.UINT32
RCFDC0.CFDRMPTR3.UINT16[L/H]
RCFDC0.CFDRMPTR3.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS3.UINT32
RCFDC0.CFDRMFDSTS3.UINT16[L/H]
RCFDC0.CFDRMFDSTS3.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_3.UINT32
RCFDC0.CFDRMDF0_3.UINT16[L/H]
RCFDC0.CFDRMDF0_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_3.UINT32
RCFDC0.CFDRMDF1_3.UINT16[L/H]
RCFDC0.CFDRMDF1_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_3.UINT32
RCFDC0.CFDRMDF2_3.UINT16[L/H]
RCFDC0.CFDRMDF2_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_3.UINT32
RCFDC0.CFDRMDF3_3.UINT16[L/H]
RCFDC0.CFDRMDF3_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_3.UINT32
RCFDC0.CFDRMDF4_3.UINT16[L/H]
RCFDC0.CFDRMDF4_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_3.UINT32
RCFDC0.CFDRMDF5_3.UINT16[L/H]
RCFDC0.CFDRMDF5_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_3.UINT32
RCFDC0.CFDRMDF6_3.UINT16[L/H]
RCFDC0.CFDRMDF6_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_3.UINT32
RCFDC0.CFDRMDF7_3.UINT16[L/H]
RCFDC0.CFDRMDF7_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_3.UINT32
RCFDC0.CFDRMDF8_3.UINT16[L/H]
RCFDC0.CFDRMDF8_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_3.UINT32
RCFDC0.CFDRMDF9_3.UINT16[L/H]
RCFDC0.CFDRMDF9_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_3.UINT32
RCFDC0.CFDRMDF10_3.UINT16[L/H]
RCFDC0.CFDRMDF10_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_3.UINT32
RCFDC0.CFDRMDF11_3.UINT16[L/H]
RCFDC0.CFDRMDF11_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_3.UINT32
RCFDC0.CFDRMDF12_3.UINT16[L/H]
RCFDC0.CFDRMDF12_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_3.UINT32
RCFDC0.CFDRMDF13_3.UINT16[L/H]
RCFDC0.CFDRMDF13_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_3.UINT32
RCFDC0.CFDRMDF14_3.UINT16[L/H]
RCFDC0.CFDRMDF14_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_3.UINT32
RCFDC0.CFDRMDF15_3.UINT16[L/H]
RCFDC0.CFDRMDF15_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID4.UINT32
RCFDC0.CFDRMID4.UINT16[L/H]
RCFDC0.CFDRMID4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR4.UINT32
RCFDC0.CFDRMPTR4.UINT16[L/H]
RCFDC0.CFDRMPTR4.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS4.UINT32
RCFDC0.CFDRMFDSTS4.UINT16[L/H]
RCFDC0.CFDRMFDSTS4.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_4.UINT32
RCFDC0.CFDRMDF0_4.UINT16[L/H]
RCFDC0.CFDRMDF0_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_4.UINT32
RCFDC0.CFDRMDF1_4.UINT16[L/H]
RCFDC0.CFDRMDF1_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_4.UINT32
RCFDC0.CFDRMDF2_4.UINT16[L/H]
RCFDC0.CFDRMDF2_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_4.UINT32
RCFDC0.CFDRMDF3_4.UINT16[L/H]
RCFDC0.CFDRMDF3_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_4.UINT32
RCFDC0.CFDRMDF4_4.UINT16[L/H]
RCFDC0.CFDRMDF4_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_4.UINT32
RCFDC0.CFDRMDF5_4.UINT16[L/H]
RCFDC0.CFDRMDF5_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_4.UINT32
RCFDC0.CFDRMDF6_4.UINT16[L/H]
RCFDC0.CFDRMDF6_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_4.UINT32
RCFDC0.CFDRMDF7_4.UINT16[L/H]
RCFDC0.CFDRMDF7_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_4.UINT32
RCFDC0.CFDRMDF8_4.UINT16[L/H]
RCFDC0.CFDRMDF8_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_4.UINT32
RCFDC0.CFDRMDF9_4.UINT16[L/H]
RCFDC0.CFDRMDF9_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_4.UINT32
RCFDC0.CFDRMDF10_4.UINT16[L/H]
RCFDC0.CFDRMDF10_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_4.UINT32
RCFDC0.CFDRMDF11_4.UINT16[L/H]
RCFDC0.CFDRMDF11_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_4.UINT32
RCFDC0.CFDRMDF12_4.UINT16[L/H]
RCFDC0.CFDRMDF12_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_4.UINT32
RCFDC0.CFDRMDF13_4.UINT16[L/H]
RCFDC0.CFDRMDF13_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_4.UINT32
RCFDC0.CFDRMDF14_4.UINT16[L/H]
RCFDC0.CFDRMDF14_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_4.UINT32
RCFDC0.CFDRMDF15_4.UINT16[L/H]
RCFDC0.CFDRMDF15_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID5.UINT32
RCFDC0.CFDRMID5.UINT16[L/H]
RCFDC0.CFDRMID5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR5.UINT32
RCFDC0.CFDRMPTR5.UINT16[L/H]
RCFDC0.CFDRMPTR5.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS5.UINT32
RCFDC0.CFDRMFDSTS5.UINT16[L/H]
RCFDC0.CFDRMFDSTS5.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_5.UINT32
RCFDC0.CFDRMDF0_5.UINT16[L/H]
RCFDC0.CFDRMDF0_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_5.UINT32
RCFDC0.CFDRMDF1_5.UINT16[L/H]
RCFDC0.CFDRMDF1_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_5.UINT32
RCFDC0.CFDRMDF2_5.UINT16[L/H]
RCFDC0.CFDRMDF2_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_5.UINT32
RCFDC0.CFDRMDF3_5.UINT16[L/H]
RCFDC0.CFDRMDF3_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_5.UINT32
RCFDC0.CFDRMDF4_5.UINT16[L/H]
RCFDC0.CFDRMDF4_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_5.UINT32
RCFDC0.CFDRMDF5_5.UINT16[L/H]
RCFDC0.CFDRMDF5_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_5.UINT32
RCFDC0.CFDRMDF6_5.UINT16[L/H]
RCFDC0.CFDRMDF6_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_5.UINT32
RCFDC0.CFDRMDF7_5.UINT16[L/H]
RCFDC0.CFDRMDF7_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_5.UINT32
RCFDC0.CFDRMDF8_5.UINT16[L/H]
RCFDC0.CFDRMDF8_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_5.UINT32
RCFDC0.CFDRMDF9_5.UINT16[L/H]
RCFDC0.CFDRMDF9_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_5.UINT32
RCFDC0.CFDRMDF10_5.UINT16[L/H]
RCFDC0.CFDRMDF10_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_5.UINT32
RCFDC0.CFDRMDF11_5.UINT16[L/H]
RCFDC0.CFDRMDF11_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_5.UINT32
RCFDC0.CFDRMDF12_5.UINT16[L/H]
RCFDC0.CFDRMDF12_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_5.UINT32
RCFDC0.CFDRMDF13_5.UINT16[L/H]
RCFDC0.CFDRMDF13_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_5.UINT32
RCFDC0.CFDRMDF14_5.UINT16[L/H]
RCFDC0.CFDRMDF14_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_5.UINT32
RCFDC0.CFDRMDF15_5.UINT16[L/H]
RCFDC0.CFDRMDF15_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID6.UINT32
RCFDC0.CFDRMID6.UINT16[L/H]
RCFDC0.CFDRMID6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR6.UINT32
RCFDC0.CFDRMPTR6.UINT16[L/H]
RCFDC0.CFDRMPTR6.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS6.UINT32
RCFDC0.CFDRMFDSTS6.UINT16[L/H]
RCFDC0.CFDRMFDSTS6.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_6.UINT32
RCFDC0.CFDRMDF0_6.UINT16[L/H]
RCFDC0.CFDRMDF0_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_6.UINT32
RCFDC0.CFDRMDF1_6.UINT16[L/H]
RCFDC0.CFDRMDF1_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_6.UINT32
RCFDC0.CFDRMDF2_6.UINT16[L/H]
RCFDC0.CFDRMDF2_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_6.UINT32
RCFDC0.CFDRMDF3_6.UINT16[L/H]
RCFDC0.CFDRMDF3_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_6.UINT32
RCFDC0.CFDRMDF4_6.UINT16[L/H]
RCFDC0.CFDRMDF4_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_6.UINT32
RCFDC0.CFDRMDF5_6.UINT16[L/H]
RCFDC0.CFDRMDF5_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_6.UINT32
RCFDC0.CFDRMDF6_6.UINT16[L/H]
RCFDC0.CFDRMDF6_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_6.UINT32
RCFDC0.CFDRMDF7_6.UINT16[L/H]
RCFDC0.CFDRMDF7_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_6.UINT32
RCFDC0.CFDRMDF8_6.UINT16[L/H]
RCFDC0.CFDRMDF8_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_6.UINT32
RCFDC0.CFDRMDF9_6.UINT16[L/H]
RCFDC0.CFDRMDF9_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_6.UINT32
RCFDC0.CFDRMDF10_6.UINT16[L/H]
RCFDC0.CFDRMDF10_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_6.UINT32
RCFDC0.CFDRMDF11_6.UINT16[L/H]
RCFDC0.CFDRMDF11_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_6.UINT32
RCFDC0.CFDRMDF12_6.UINT16[L/H]
RCFDC0.CFDRMDF12_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_6.UINT32
RCFDC0.CFDRMDF13_6.UINT16[L/H]
RCFDC0.CFDRMDF13_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_6.UINT32
RCFDC0.CFDRMDF14_6.UINT16[L/H]
RCFDC0.CFDRMDF14_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_6.UINT32
RCFDC0.CFDRMDF15_6.UINT16[L/H]
RCFDC0.CFDRMDF15_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID7.UINT32
RCFDC0.CFDRMID7.UINT16[L/H]
RCFDC0.CFDRMID7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR7.UINT32
RCFDC0.CFDRMPTR7.UINT16[L/H]
RCFDC0.CFDRMPTR7.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS7.UINT32
RCFDC0.CFDRMFDSTS7.UINT16[L/H]
RCFDC0.CFDRMFDSTS7.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_7.UINT32
RCFDC0.CFDRMDF0_7.UINT16[L/H]
RCFDC0.CFDRMDF0_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_7.UINT32
RCFDC0.CFDRMDF1_7.UINT16[L/H]
RCFDC0.CFDRMDF1_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_7.UINT32
RCFDC0.CFDRMDF2_7.UINT16[L/H]
RCFDC0.CFDRMDF2_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_7.UINT32
RCFDC0.CFDRMDF3_7.UINT16[L/H]
RCFDC0.CFDRMDF3_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_7.UINT32
RCFDC0.CFDRMDF4_7.UINT16[L/H]
RCFDC0.CFDRMDF4_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_7.UINT32
RCFDC0.CFDRMDF5_7.UINT16[L/H]
RCFDC0.CFDRMDF5_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_7.UINT32
RCFDC0.CFDRMDF6_7.UINT16[L/H]
RCFDC0.CFDRMDF6_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_7.UINT32
RCFDC0.CFDRMDF7_7.UINT16[L/H]
RCFDC0.CFDRMDF7_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_7.UINT32
RCFDC0.CFDRMDF8_7.UINT16[L/H]
RCFDC0.CFDRMDF8_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_7.UINT32
RCFDC0.CFDRMDF9_7.UINT16[L/H]
RCFDC0.CFDRMDF9_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_7.UINT32
RCFDC0.CFDRMDF10_7.UINT16[L/H]
RCFDC0.CFDRMDF10_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_7.UINT32
RCFDC0.CFDRMDF11_7.UINT16[L/H]
RCFDC0.CFDRMDF11_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_7.UINT32
RCFDC0.CFDRMDF12_7.UINT16[L/H]
RCFDC0.CFDRMDF12_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_7.UINT32
RCFDC0.CFDRMDF13_7.UINT16[L/H]
RCFDC0.CFDRMDF13_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_7.UINT32
RCFDC0.CFDRMDF14_7.UINT16[L/H]
RCFDC0.CFDRMDF14_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_7.UINT32
RCFDC0.CFDRMDF15_7.UINT16[L/H]
RCFDC0.CFDRMDF15_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID8.UINT32
RCFDC0.CFDRMID8.UINT16[L/H]
RCFDC0.CFDRMID8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR8.UINT32
RCFDC0.CFDRMPTR8.UINT16[L/H]
RCFDC0.CFDRMPTR8.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS8.UINT32
RCFDC0.CFDRMFDSTS8.UINT16[L/H]
RCFDC0.CFDRMFDSTS8.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_8.UINT32
RCFDC0.CFDRMDF0_8.UINT16[L/H]
RCFDC0.CFDRMDF0_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_8.UINT32
RCFDC0.CFDRMDF1_8.UINT16[L/H]
RCFDC0.CFDRMDF1_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_8.UINT32
RCFDC0.CFDRMDF2_8.UINT16[L/H]
RCFDC0.CFDRMDF2_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_8.UINT32
RCFDC0.CFDRMDF3_8.UINT16[L/H]
RCFDC0.CFDRMDF3_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_8.UINT32
RCFDC0.CFDRMDF4_8.UINT16[L/H]
RCFDC0.CFDRMDF4_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_8.UINT32
RCFDC0.CFDRMDF5_8.UINT16[L/H]
RCFDC0.CFDRMDF5_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_8.UINT32
RCFDC0.CFDRMDF6_8.UINT16[L/H]
RCFDC0.CFDRMDF6_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_8.UINT32
RCFDC0.CFDRMDF7_8.UINT16[L/H]
RCFDC0.CFDRMDF7_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_8.UINT32
RCFDC0.CFDRMDF8_8.UINT16[L/H]
RCFDC0.CFDRMDF8_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_8.UINT32
RCFDC0.CFDRMDF9_8.UINT16[L/H]
RCFDC0.CFDRMDF9_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_8.UINT32
RCFDC0.CFDRMDF10_8.UINT16[L/H]
RCFDC0.CFDRMDF10_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_8.UINT32
RCFDC0.CFDRMDF11_8.UINT16[L/H]
RCFDC0.CFDRMDF11_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_8.UINT32
RCFDC0.CFDRMDF12_8.UINT16[L/H]
RCFDC0.CFDRMDF12_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_8.UINT32
RCFDC0.CFDRMDF13_8.UINT16[L/H]
RCFDC0.CFDRMDF13_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_8.UINT32
RCFDC0.CFDRMDF14_8.UINT16[L/H]
RCFDC0.CFDRMDF14_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_8.UINT32
RCFDC0.CFDRMDF15_8.UINT16[L/H]
RCFDC0.CFDRMDF15_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID9.UINT32
RCFDC0.CFDRMID9.UINT16[L/H]
RCFDC0.CFDRMID9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR9.UINT32
RCFDC0.CFDRMPTR9.UINT16[L/H]
RCFDC0.CFDRMPTR9.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS9.UINT32
RCFDC0.CFDRMFDSTS9.UINT16[L/H]
RCFDC0.CFDRMFDSTS9.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_9.UINT32
RCFDC0.CFDRMDF0_9.UINT16[L/H]
RCFDC0.CFDRMDF0_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_9.UINT32
RCFDC0.CFDRMDF1_9.UINT16[L/H]
RCFDC0.CFDRMDF1_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_9.UINT32
RCFDC0.CFDRMDF2_9.UINT16[L/H]
RCFDC0.CFDRMDF2_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_9.UINT32
RCFDC0.CFDRMDF3_9.UINT16[L/H]
RCFDC0.CFDRMDF3_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_9.UINT32
RCFDC0.CFDRMDF4_9.UINT16[L/H]
RCFDC0.CFDRMDF4_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_9.UINT32
RCFDC0.CFDRMDF5_9.UINT16[L/H]
RCFDC0.CFDRMDF5_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_9.UINT32
RCFDC0.CFDRMDF6_9.UINT16[L/H]
RCFDC0.CFDRMDF6_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_9.UINT32
RCFDC0.CFDRMDF7_9.UINT16[L/H]
RCFDC0.CFDRMDF7_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_9.UINT32
RCFDC0.CFDRMDF8_9.UINT16[L/H]
RCFDC0.CFDRMDF8_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_9.UINT32
RCFDC0.CFDRMDF9_9.UINT16[L/H]
RCFDC0.CFDRMDF9_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_9.UINT32
RCFDC0.CFDRMDF10_9.UINT16[L/H]
RCFDC0.CFDRMDF10_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_9.UINT32
RCFDC0.CFDRMDF11_9.UINT16[L/H]
RCFDC0.CFDRMDF11_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_9.UINT32
RCFDC0.CFDRMDF12_9.UINT16[L/H]
RCFDC0.CFDRMDF12_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_9.UINT32
RCFDC0.CFDRMDF13_9.UINT16[L/H]
RCFDC0.CFDRMDF13_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_9.UINT32
RCFDC0.CFDRMDF14_9.UINT16[L/H]
RCFDC0.CFDRMDF14_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_9.UINT32
RCFDC0.CFDRMDF15_9.UINT16[L/H]
RCFDC0.CFDRMDF15_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID10.UINT32
RCFDC0.CFDRMID10.UINT16[L/H]
RCFDC0.CFDRMID10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR10.UINT32
RCFDC0.CFDRMPTR10.UINT16[L/H]
RCFDC0.CFDRMPTR10.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS10.UINT32
RCFDC0.CFDRMFDSTS10.UINT16[L/H]
RCFDC0.CFDRMFDSTS10.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_10.UINT32
RCFDC0.CFDRMDF0_10.UINT16[L/H]
RCFDC0.CFDRMDF0_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_10.UINT32
RCFDC0.CFDRMDF1_10.UINT16[L/H]
RCFDC0.CFDRMDF1_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_10.UINT32
RCFDC0.CFDRMDF2_10.UINT16[L/H]
RCFDC0.CFDRMDF2_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_10.UINT32
RCFDC0.CFDRMDF3_10.UINT16[L/H]
RCFDC0.CFDRMDF3_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_10.UINT32
RCFDC0.CFDRMDF4_10.UINT16[L/H]
RCFDC0.CFDRMDF4_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_10.UINT32
RCFDC0.CFDRMDF5_10.UINT16[L/H]
RCFDC0.CFDRMDF5_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_10.UINT32
RCFDC0.CFDRMDF6_10.UINT16[L/H]
RCFDC0.CFDRMDF6_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_10.UINT32
RCFDC0.CFDRMDF7_10.UINT16[L/H]
RCFDC0.CFDRMDF7_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_10.UINT32
RCFDC0.CFDRMDF8_10.UINT16[L/H]
RCFDC0.CFDRMDF8_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_10.UINT32
RCFDC0.CFDRMDF9_10.UINT16[L/H]
RCFDC0.CFDRMDF9_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_10.UINT32
RCFDC0.CFDRMDF10_10.UINT16[L/H]
RCFDC0.CFDRMDF10_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_10.UINT32
RCFDC0.CFDRMDF11_10.UINT16[L/H]
RCFDC0.CFDRMDF11_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_10.UINT32
RCFDC0.CFDRMDF12_10.UINT16[L/H]
RCFDC0.CFDRMDF12_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_10.UINT32
RCFDC0.CFDRMDF13_10.UINT16[L/H]
RCFDC0.CFDRMDF13_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_10.UINT32
RCFDC0.CFDRMDF14_10.UINT16[L/H]
RCFDC0.CFDRMDF14_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_10.UINT32
RCFDC0.CFDRMDF15_10.UINT16[L/H]
RCFDC0.CFDRMDF15_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID11.UINT32
RCFDC0.CFDRMID11.UINT16[L/H]
RCFDC0.CFDRMID11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR11.UINT32
RCFDC0.CFDRMPTR11.UINT16[L/H]
RCFDC0.CFDRMPTR11.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS11.UINT32
RCFDC0.CFDRMFDSTS11.UINT16[L/H]
RCFDC0.CFDRMFDSTS11.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_11.UINT32
RCFDC0.CFDRMDF0_11.UINT16[L/H]
RCFDC0.CFDRMDF0_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_11.UINT32
RCFDC0.CFDRMDF1_11.UINT16[L/H]
RCFDC0.CFDRMDF1_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_11.UINT32
RCFDC0.CFDRMDF2_11.UINT16[L/H]
RCFDC0.CFDRMDF2_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_11.UINT32
RCFDC0.CFDRMDF3_11.UINT16[L/H]
RCFDC0.CFDRMDF3_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_11.UINT32
RCFDC0.CFDRMDF4_11.UINT16[L/H]
RCFDC0.CFDRMDF4_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_11.UINT32
RCFDC0.CFDRMDF5_11.UINT16[L/H]
RCFDC0.CFDRMDF5_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_11.UINT32
RCFDC0.CFDRMDF6_11.UINT16[L/H]
RCFDC0.CFDRMDF6_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_11.UINT32
RCFDC0.CFDRMDF7_11.UINT16[L/H]
RCFDC0.CFDRMDF7_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_11.UINT32
RCFDC0.CFDRMDF8_11.UINT16[L/H]
RCFDC0.CFDRMDF8_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_11.UINT32
RCFDC0.CFDRMDF9_11.UINT16[L/H]
RCFDC0.CFDRMDF9_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_11.UINT32
RCFDC0.CFDRMDF10_11.UINT16[L/H]
RCFDC0.CFDRMDF10_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_11.UINT32
RCFDC0.CFDRMDF11_11.UINT16[L/H]
RCFDC0.CFDRMDF11_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_11.UINT32
RCFDC0.CFDRMDF12_11.UINT16[L/H]
RCFDC0.CFDRMDF12_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_11.UINT32
RCFDC0.CFDRMDF13_11.UINT16[L/H]
RCFDC0.CFDRMDF13_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_11.UINT32
RCFDC0.CFDRMDF14_11.UINT16[L/H]
RCFDC0.CFDRMDF14_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_11.UINT32
RCFDC0.CFDRMDF15_11.UINT16[L/H]
RCFDC0.CFDRMDF15_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID12.UINT32
RCFDC0.CFDRMID12.UINT16[L/H]
RCFDC0.CFDRMID12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR12.UINT32
RCFDC0.CFDRMPTR12.UINT16[L/H]
RCFDC0.CFDRMPTR12.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS12.UINT32
RCFDC0.CFDRMFDSTS12.UINT16[L/H]
RCFDC0.CFDRMFDSTS12.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_12.UINT32
RCFDC0.CFDRMDF0_12.UINT16[L/H]
RCFDC0.CFDRMDF0_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_12.UINT32
RCFDC0.CFDRMDF1_12.UINT16[L/H]
RCFDC0.CFDRMDF1_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_12.UINT32
RCFDC0.CFDRMDF2_12.UINT16[L/H]
RCFDC0.CFDRMDF2_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_12.UINT32
RCFDC0.CFDRMDF3_12.UINT16[L/H]
RCFDC0.CFDRMDF3_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_12.UINT32
RCFDC0.CFDRMDF4_12.UINT16[L/H]
RCFDC0.CFDRMDF4_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_12.UINT32
RCFDC0.CFDRMDF5_12.UINT16[L/H]
RCFDC0.CFDRMDF5_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_12.UINT32
RCFDC0.CFDRMDF6_12.UINT16[L/H]
RCFDC0.CFDRMDF6_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_12.UINT32
RCFDC0.CFDRMDF7_12.UINT16[L/H]
RCFDC0.CFDRMDF7_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_12.UINT32
RCFDC0.CFDRMDF8_12.UINT16[L/H]
RCFDC0.CFDRMDF8_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_12.UINT32
RCFDC0.CFDRMDF9_12.UINT16[L/H]
RCFDC0.CFDRMDF9_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_12.UINT32
RCFDC0.CFDRMDF10_12.UINT16[L/H]
RCFDC0.CFDRMDF10_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_12.UINT32
RCFDC0.CFDRMDF11_12.UINT16[L/H]
RCFDC0.CFDRMDF11_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_12.UINT32
RCFDC0.CFDRMDF12_12.UINT16[L/H]
RCFDC0.CFDRMDF12_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_12.UINT32
RCFDC0.CFDRMDF13_12.UINT16[L/H]
RCFDC0.CFDRMDF13_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_12.UINT32
RCFDC0.CFDRMDF14_12.UINT16[L/H]
RCFDC0.CFDRMDF14_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_12.UINT32
RCFDC0.CFDRMDF15_12.UINT16[L/H]
RCFDC0.CFDRMDF15_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID13.UINT32
RCFDC0.CFDRMID13.UINT16[L/H]
RCFDC0.CFDRMID13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR13.UINT32
RCFDC0.CFDRMPTR13.UINT16[L/H]
RCFDC0.CFDRMPTR13.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS13.UINT32
RCFDC0.CFDRMFDSTS13.UINT16[L/H]
RCFDC0.CFDRMFDSTS13.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_13.UINT32
RCFDC0.CFDRMDF0_13.UINT16[L/H]
RCFDC0.CFDRMDF0_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_13.UINT32
RCFDC0.CFDRMDF1_13.UINT16[L/H]
RCFDC0.CFDRMDF1_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_13.UINT32
RCFDC0.CFDRMDF2_13.UINT16[L/H]
RCFDC0.CFDRMDF2_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_13.UINT32
RCFDC0.CFDRMDF3_13.UINT16[L/H]
RCFDC0.CFDRMDF3_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_13.UINT32
RCFDC0.CFDRMDF4_13.UINT16[L/H]
RCFDC0.CFDRMDF4_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_13.UINT32
RCFDC0.CFDRMDF5_13.UINT16[L/H]
RCFDC0.CFDRMDF5_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_13.UINT32
RCFDC0.CFDRMDF6_13.UINT16[L/H]
RCFDC0.CFDRMDF6_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_13.UINT32
RCFDC0.CFDRMDF7_13.UINT16[L/H]
RCFDC0.CFDRMDF7_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_13.UINT32
RCFDC0.CFDRMDF8_13.UINT16[L/H]
RCFDC0.CFDRMDF8_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_13.UINT32
RCFDC0.CFDRMDF9_13.UINT16[L/H]
RCFDC0.CFDRMDF9_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_13.UINT32
RCFDC0.CFDRMDF10_13.UINT16[L/H]
RCFDC0.CFDRMDF10_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_13.UINT32
RCFDC0.CFDRMDF11_13.UINT16[L/H]
RCFDC0.CFDRMDF11_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_13.UINT32
RCFDC0.CFDRMDF12_13.UINT16[L/H]
RCFDC0.CFDRMDF12_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_13.UINT32
RCFDC0.CFDRMDF13_13.UINT16[L/H]
RCFDC0.CFDRMDF13_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_13.UINT32
RCFDC0.CFDRMDF14_13.UINT16[L/H]
RCFDC0.CFDRMDF14_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_13.UINT32
RCFDC0.CFDRMDF15_13.UINT16[L/H]
RCFDC0.CFDRMDF15_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID14.UINT32
RCFDC0.CFDRMID14.UINT16[L/H]
RCFDC0.CFDRMID14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR14.UINT32
RCFDC0.CFDRMPTR14.UINT16[L/H]
RCFDC0.CFDRMPTR14.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS14.UINT32
RCFDC0.CFDRMFDSTS14.UINT16[L/H]
RCFDC0.CFDRMFDSTS14.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_14.UINT32
RCFDC0.CFDRMDF0_14.UINT16[L/H]
RCFDC0.CFDRMDF0_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_14.UINT32
RCFDC0.CFDRMDF1_14.UINT16[L/H]
RCFDC0.CFDRMDF1_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_14.UINT32
RCFDC0.CFDRMDF2_14.UINT16[L/H]
RCFDC0.CFDRMDF2_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_14.UINT32
RCFDC0.CFDRMDF3_14.UINT16[L/H]
RCFDC0.CFDRMDF3_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_14.UINT32
RCFDC0.CFDRMDF4_14.UINT16[L/H]
RCFDC0.CFDRMDF4_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_14.UINT32
RCFDC0.CFDRMDF5_14.UINT16[L/H]
RCFDC0.CFDRMDF5_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_14.UINT32
RCFDC0.CFDRMDF6_14.UINT16[L/H]
RCFDC0.CFDRMDF6_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_14.UINT32
RCFDC0.CFDRMDF7_14.UINT16[L/H]
RCFDC0.CFDRMDF7_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_14.UINT32
RCFDC0.CFDRMDF8_14.UINT16[L/H]
RCFDC0.CFDRMDF8_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_14.UINT32
RCFDC0.CFDRMDF9_14.UINT16[L/H]
RCFDC0.CFDRMDF9_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_14.UINT32
RCFDC0.CFDRMDF10_14.UINT16[L/H]
RCFDC0.CFDRMDF10_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_14.UINT32
RCFDC0.CFDRMDF11_14.UINT16[L/H]
RCFDC0.CFDRMDF11_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_14.UINT32
RCFDC0.CFDRMDF12_14.UINT16[L/H]
RCFDC0.CFDRMDF12_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_14.UINT32
RCFDC0.CFDRMDF13_14.UINT16[L/H]
RCFDC0.CFDRMDF13_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_14.UINT32
RCFDC0.CFDRMDF14_14.UINT16[L/H]
RCFDC0.CFDRMDF14_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_14.UINT32
RCFDC0.CFDRMDF15_14.UINT16[L/H]
RCFDC0.CFDRMDF15_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID15.UINT32
RCFDC0.CFDRMID15.UINT16[L/H]
RCFDC0.CFDRMID15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR15.UINT32
RCFDC0.CFDRMPTR15.UINT16[L/H]
RCFDC0.CFDRMPTR15.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS15.UINT32
RCFDC0.CFDRMFDSTS15.UINT16[L/H]
RCFDC0.CFDRMFDSTS15.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_15.UINT32
RCFDC0.CFDRMDF0_15.UINT16[L/H]
RCFDC0.CFDRMDF0_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_15.UINT32
RCFDC0.CFDRMDF1_15.UINT16[L/H]
RCFDC0.CFDRMDF1_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_15.UINT32
RCFDC0.CFDRMDF2_15.UINT16[L/H]
RCFDC0.CFDRMDF2_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_15.UINT32
RCFDC0.CFDRMDF3_15.UINT16[L/H]
RCFDC0.CFDRMDF3_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_15.UINT32
RCFDC0.CFDRMDF4_15.UINT16[L/H]
RCFDC0.CFDRMDF4_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_15.UINT32
RCFDC0.CFDRMDF5_15.UINT16[L/H]
RCFDC0.CFDRMDF5_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_15.UINT32
RCFDC0.CFDRMDF6_15.UINT16[L/H]
RCFDC0.CFDRMDF6_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_15.UINT32
RCFDC0.CFDRMDF7_15.UINT16[L/H]
RCFDC0.CFDRMDF7_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_15.UINT32
RCFDC0.CFDRMDF8_15.UINT16[L/H]
RCFDC0.CFDRMDF8_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_15.UINT32
RCFDC0.CFDRMDF9_15.UINT16[L/H]
RCFDC0.CFDRMDF9_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_15.UINT32
RCFDC0.CFDRMDF10_15.UINT16[L/H]
RCFDC0.CFDRMDF10_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_15.UINT32
RCFDC0.CFDRMDF11_15.UINT16[L/H]
RCFDC0.CFDRMDF11_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_15.UINT32
RCFDC0.CFDRMDF12_15.UINT16[L/H]
RCFDC0.CFDRMDF12_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_15.UINT32
RCFDC0.CFDRMDF13_15.UINT16[L/H]
RCFDC0.CFDRMDF13_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_15.UINT32
RCFDC0.CFDRMDF14_15.UINT16[L/H]
RCFDC0.CFDRMDF14_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_15.UINT32
RCFDC0.CFDRMDF15_15.UINT16[L/H]
RCFDC0.CFDRMDF15_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID16.UINT32
RCFDC0.CFDRMID16.UINT16[L/H]
RCFDC0.CFDRMID16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR16.UINT32
RCFDC0.CFDRMPTR16.UINT16[L/H]
RCFDC0.CFDRMPTR16.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS16.UINT32
RCFDC0.CFDRMFDSTS16.UINT16[L/H]
RCFDC0.CFDRMFDSTS16.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_16.UINT32
RCFDC0.CFDRMDF0_16.UINT16[L/H]
RCFDC0.CFDRMDF0_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_16.UINT32
RCFDC0.CFDRMDF1_16.UINT16[L/H]
RCFDC0.CFDRMDF1_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_16.UINT32
RCFDC0.CFDRMDF2_16.UINT16[L/H]
RCFDC0.CFDRMDF2_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_16.UINT32
RCFDC0.CFDRMDF3_16.UINT16[L/H]
RCFDC0.CFDRMDF3_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_16.UINT32
RCFDC0.CFDRMDF4_16.UINT16[L/H]
RCFDC0.CFDRMDF4_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_16.UINT32
RCFDC0.CFDRMDF5_16.UINT16[L/H]
RCFDC0.CFDRMDF5_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_16.UINT32
RCFDC0.CFDRMDF6_16.UINT16[L/H]
RCFDC0.CFDRMDF6_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_16.UINT32
RCFDC0.CFDRMDF7_16.UINT16[L/H]
RCFDC0.CFDRMDF7_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_16.UINT32
RCFDC0.CFDRMDF8_16.UINT16[L/H]
RCFDC0.CFDRMDF8_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_16.UINT32
RCFDC0.CFDRMDF9_16.UINT16[L/H]
RCFDC0.CFDRMDF9_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_16.UINT32
RCFDC0.CFDRMDF10_16.UINT16[L/H]
RCFDC0.CFDRMDF10_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_16.UINT32
RCFDC0.CFDRMDF11_16.UINT16[L/H]
RCFDC0.CFDRMDF11_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_16.UINT32
RCFDC0.CFDRMDF12_16.UINT16[L/H]
RCFDC0.CFDRMDF12_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_16.UINT32
RCFDC0.CFDRMDF13_16.UINT16[L/H]
RCFDC0.CFDRMDF13_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_16.UINT32
RCFDC0.CFDRMDF14_16.UINT16[L/H]
RCFDC0.CFDRMDF14_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_16.UINT32
RCFDC0.CFDRMDF15_16.UINT16[L/H]
RCFDC0.CFDRMDF15_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID17.UINT32
RCFDC0.CFDRMID17.UINT16[L/H]
RCFDC0.CFDRMID17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR17.UINT32
RCFDC0.CFDRMPTR17.UINT16[L/H]
RCFDC0.CFDRMPTR17.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS17.UINT32
RCFDC0.CFDRMFDSTS17.UINT16[L/H]
RCFDC0.CFDRMFDSTS17.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_17.UINT32
RCFDC0.CFDRMDF0_17.UINT16[L/H]
RCFDC0.CFDRMDF0_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_17.UINT32
RCFDC0.CFDRMDF1_17.UINT16[L/H]
RCFDC0.CFDRMDF1_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_17.UINT32
RCFDC0.CFDRMDF2_17.UINT16[L/H]
RCFDC0.CFDRMDF2_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_17.UINT32
RCFDC0.CFDRMDF3_17.UINT16[L/H]
RCFDC0.CFDRMDF3_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_17.UINT32
RCFDC0.CFDRMDF4_17.UINT16[L/H]
RCFDC0.CFDRMDF4_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_17.UINT32
RCFDC0.CFDRMDF5_17.UINT16[L/H]
RCFDC0.CFDRMDF5_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_17.UINT32
RCFDC0.CFDRMDF6_17.UINT16[L/H]
RCFDC0.CFDRMDF6_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_17.UINT32
RCFDC0.CFDRMDF7_17.UINT16[L/H]
RCFDC0.CFDRMDF7_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_17.UINT32
RCFDC0.CFDRMDF8_17.UINT16[L/H]
RCFDC0.CFDRMDF8_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_17.UINT32
RCFDC0.CFDRMDF9_17.UINT16[L/H]
RCFDC0.CFDRMDF9_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_17.UINT32
RCFDC0.CFDRMDF10_17.UINT16[L/H]
RCFDC0.CFDRMDF10_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_17.UINT32
RCFDC0.CFDRMDF11_17.UINT16[L/H]
RCFDC0.CFDRMDF11_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_17.UINT32
RCFDC0.CFDRMDF12_17.UINT16[L/H]
RCFDC0.CFDRMDF12_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_17.UINT32
RCFDC0.CFDRMDF13_17.UINT16[L/H]
RCFDC0.CFDRMDF13_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_17.UINT32
RCFDC0.CFDRMDF14_17.UINT16[L/H]
RCFDC0.CFDRMDF14_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_17.UINT32
RCFDC0.CFDRMDF15_17.UINT16[L/H]
RCFDC0.CFDRMDF15_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID18.UINT32
RCFDC0.CFDRMID18.UINT16[L/H]
RCFDC0.CFDRMID18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR18.UINT32
RCFDC0.CFDRMPTR18.UINT16[L/H]
RCFDC0.CFDRMPTR18.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS18.UINT32
RCFDC0.CFDRMFDSTS18.UINT16[L/H]
RCFDC0.CFDRMFDSTS18.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_18.UINT32
RCFDC0.CFDRMDF0_18.UINT16[L/H]
RCFDC0.CFDRMDF0_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_18.UINT32
RCFDC0.CFDRMDF1_18.UINT16[L/H]
RCFDC0.CFDRMDF1_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_18.UINT32
RCFDC0.CFDRMDF2_18.UINT16[L/H]
RCFDC0.CFDRMDF2_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_18.UINT32
RCFDC0.CFDRMDF3_18.UINT16[L/H]
RCFDC0.CFDRMDF3_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_18.UINT32
RCFDC0.CFDRMDF4_18.UINT16[L/H]
RCFDC0.CFDRMDF4_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_18.UINT32
RCFDC0.CFDRMDF5_18.UINT16[L/H]
RCFDC0.CFDRMDF5_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_18.UINT32
RCFDC0.CFDRMDF6_18.UINT16[L/H]
RCFDC0.CFDRMDF6_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_18.UINT32
RCFDC0.CFDRMDF7_18.UINT16[L/H]
RCFDC0.CFDRMDF7_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_18.UINT32
RCFDC0.CFDRMDF8_18.UINT16[L/H]
RCFDC0.CFDRMDF8_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_18.UINT32
RCFDC0.CFDRMDF9_18.UINT16[L/H]
RCFDC0.CFDRMDF9_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_18.UINT32
RCFDC0.CFDRMDF10_18.UINT16[L/H]
RCFDC0.CFDRMDF10_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_18.UINT32
RCFDC0.CFDRMDF11_18.UINT16[L/H]
RCFDC0.CFDRMDF11_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_18.UINT32
RCFDC0.CFDRMDF12_18.UINT16[L/H]
RCFDC0.CFDRMDF12_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_18.UINT32
RCFDC0.CFDRMDF13_18.UINT16[L/H]
RCFDC0.CFDRMDF13_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_18.UINT32
RCFDC0.CFDRMDF14_18.UINT16[L/H]
RCFDC0.CFDRMDF14_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_18.UINT32
RCFDC0.CFDRMDF15_18.UINT16[L/H]
RCFDC0.CFDRMDF15_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID19.UINT32
RCFDC0.CFDRMID19.UINT16[L/H]
RCFDC0.CFDRMID19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR19.UINT32
RCFDC0.CFDRMPTR19.UINT16[L/H]
RCFDC0.CFDRMPTR19.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS19.UINT32
RCFDC0.CFDRMFDSTS19.UINT16[L/H]
RCFDC0.CFDRMFDSTS19.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_19.UINT32
RCFDC0.CFDRMDF0_19.UINT16[L/H]
RCFDC0.CFDRMDF0_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_19.UINT32
RCFDC0.CFDRMDF1_19.UINT16[L/H]
RCFDC0.CFDRMDF1_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_19.UINT32
RCFDC0.CFDRMDF2_19.UINT16[L/H]
RCFDC0.CFDRMDF2_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_19.UINT32
RCFDC0.CFDRMDF3_19.UINT16[L/H]
RCFDC0.CFDRMDF3_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_19.UINT32
RCFDC0.CFDRMDF4_19.UINT16[L/H]
RCFDC0.CFDRMDF4_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_19.UINT32
RCFDC0.CFDRMDF5_19.UINT16[L/H]
RCFDC0.CFDRMDF5_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_19.UINT32
RCFDC0.CFDRMDF6_19.UINT16[L/H]
RCFDC0.CFDRMDF6_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_19.UINT32
RCFDC0.CFDRMDF7_19.UINT16[L/H]
RCFDC0.CFDRMDF7_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_19.UINT32
RCFDC0.CFDRMDF8_19.UINT16[L/H]
RCFDC0.CFDRMDF8_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_19.UINT32
RCFDC0.CFDRMDF9_19.UINT16[L/H]
RCFDC0.CFDRMDF9_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_19.UINT32
RCFDC0.CFDRMDF10_19.UINT16[L/H]
RCFDC0.CFDRMDF10_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_19.UINT32
RCFDC0.CFDRMDF11_19.UINT16[L/H]
RCFDC0.CFDRMDF11_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_19.UINT32
RCFDC0.CFDRMDF12_19.UINT16[L/H]
RCFDC0.CFDRMDF12_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_19.UINT32
RCFDC0.CFDRMDF13_19.UINT16[L/H]
RCFDC0.CFDRMDF13_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_19.UINT32
RCFDC0.CFDRMDF14_19.UINT16[L/H]
RCFDC0.CFDRMDF14_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_19.UINT32
RCFDC0.CFDRMDF15_19.UINT16[L/H]
RCFDC0.CFDRMDF15_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID20.UINT32
RCFDC0.CFDRMID20.UINT16[L/H]
RCFDC0.CFDRMID20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR20.UINT32
RCFDC0.CFDRMPTR20.UINT16[L/H]
RCFDC0.CFDRMPTR20.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS20.UINT32
RCFDC0.CFDRMFDSTS20.UINT16[L/H]
RCFDC0.CFDRMFDSTS20.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_20.UINT32
RCFDC0.CFDRMDF0_20.UINT16[L/H]
RCFDC0.CFDRMDF0_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_20.UINT32
RCFDC0.CFDRMDF1_20.UINT16[L/H]
RCFDC0.CFDRMDF1_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_20.UINT32
RCFDC0.CFDRMDF2_20.UINT16[L/H]
RCFDC0.CFDRMDF2_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_20.UINT32
RCFDC0.CFDRMDF3_20.UINT16[L/H]
RCFDC0.CFDRMDF3_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_20.UINT32
RCFDC0.CFDRMDF4_20.UINT16[L/H]
RCFDC0.CFDRMDF4_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_20.UINT32
RCFDC0.CFDRMDF5_20.UINT16[L/H]
RCFDC0.CFDRMDF5_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_20.UINT32
RCFDC0.CFDRMDF6_20.UINT16[L/H]
RCFDC0.CFDRMDF6_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_20.UINT32
RCFDC0.CFDRMDF7_20.UINT16[L/H]
RCFDC0.CFDRMDF7_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_20.UINT32
RCFDC0.CFDRMDF8_20.UINT16[L/H]
RCFDC0.CFDRMDF8_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_20.UINT32
RCFDC0.CFDRMDF9_20.UINT16[L/H]
RCFDC0.CFDRMDF9_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_20.UINT32
RCFDC0.CFDRMDF10_20.UINT16[L/H]
RCFDC0.CFDRMDF10_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_20.UINT32
RCFDC0.CFDRMDF11_20.UINT16[L/H]
RCFDC0.CFDRMDF11_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_20.UINT32
RCFDC0.CFDRMDF12_20.UINT16[L/H]
RCFDC0.CFDRMDF12_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_20.UINT32
RCFDC0.CFDRMDF13_20.UINT16[L/H]
RCFDC0.CFDRMDF13_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_20.UINT32
RCFDC0.CFDRMDF14_20.UINT16[L/H]
RCFDC0.CFDRMDF14_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_20.UINT32
RCFDC0.CFDRMDF15_20.UINT16[L/H]
RCFDC0.CFDRMDF15_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID21.UINT32
RCFDC0.CFDRMID21.UINT16[L/H]
RCFDC0.CFDRMID21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR21.UINT32
RCFDC0.CFDRMPTR21.UINT16[L/H]
RCFDC0.CFDRMPTR21.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS21.UINT32
RCFDC0.CFDRMFDSTS21.UINT16[L/H]
RCFDC0.CFDRMFDSTS21.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_21.UINT32
RCFDC0.CFDRMDF0_21.UINT16[L/H]
RCFDC0.CFDRMDF0_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_21.UINT32
RCFDC0.CFDRMDF1_21.UINT16[L/H]
RCFDC0.CFDRMDF1_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_21.UINT32
RCFDC0.CFDRMDF2_21.UINT16[L/H]
RCFDC0.CFDRMDF2_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_21.UINT32
RCFDC0.CFDRMDF3_21.UINT16[L/H]
RCFDC0.CFDRMDF3_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_21.UINT32
RCFDC0.CFDRMDF4_21.UINT16[L/H]
RCFDC0.CFDRMDF4_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_21.UINT32
RCFDC0.CFDRMDF5_21.UINT16[L/H]
RCFDC0.CFDRMDF5_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_21.UINT32
RCFDC0.CFDRMDF6_21.UINT16[L/H]
RCFDC0.CFDRMDF6_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_21.UINT32
RCFDC0.CFDRMDF7_21.UINT16[L/H]
RCFDC0.CFDRMDF7_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_21.UINT32
RCFDC0.CFDRMDF8_21.UINT16[L/H]
RCFDC0.CFDRMDF8_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_21.UINT32
RCFDC0.CFDRMDF9_21.UINT16[L/H]
RCFDC0.CFDRMDF9_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_21.UINT32
RCFDC0.CFDRMDF10_21.UINT16[L/H]
RCFDC0.CFDRMDF10_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_21.UINT32
RCFDC0.CFDRMDF11_21.UINT16[L/H]
RCFDC0.CFDRMDF11_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_21.UINT32
RCFDC0.CFDRMDF12_21.UINT16[L/H]
RCFDC0.CFDRMDF12_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_21.UINT32
RCFDC0.CFDRMDF13_21.UINT16[L/H]
RCFDC0.CFDRMDF13_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_21.UINT32
RCFDC0.CFDRMDF14_21.UINT16[L/H]
RCFDC0.CFDRMDF14_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_21.UINT32
RCFDC0.CFDRMDF15_21.UINT16[L/H]
RCFDC0.CFDRMDF15_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID22.UINT32
RCFDC0.CFDRMID22.UINT16[L/H]
RCFDC0.CFDRMID22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR22.UINT32
RCFDC0.CFDRMPTR22.UINT16[L/H]
RCFDC0.CFDRMPTR22.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS22.UINT32
RCFDC0.CFDRMFDSTS22.UINT16[L/H]
RCFDC0.CFDRMFDSTS22.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_22.UINT32
RCFDC0.CFDRMDF0_22.UINT16[L/H]
RCFDC0.CFDRMDF0_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_22.UINT32
RCFDC0.CFDRMDF1_22.UINT16[L/H]
RCFDC0.CFDRMDF1_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_22.UINT32
RCFDC0.CFDRMDF2_22.UINT16[L/H]
RCFDC0.CFDRMDF2_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_22.UINT32
RCFDC0.CFDRMDF3_22.UINT16[L/H]
RCFDC0.CFDRMDF3_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_22.UINT32
RCFDC0.CFDRMDF4_22.UINT16[L/H]
RCFDC0.CFDRMDF4_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_22.UINT32
RCFDC0.CFDRMDF5_22.UINT16[L/H]
RCFDC0.CFDRMDF5_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_22.UINT32
RCFDC0.CFDRMDF6_22.UINT16[L/H]
RCFDC0.CFDRMDF6_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_22.UINT32
RCFDC0.CFDRMDF7_22.UINT16[L/H]
RCFDC0.CFDRMDF7_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_22.UINT32
RCFDC0.CFDRMDF8_22.UINT16[L/H]
RCFDC0.CFDRMDF8_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_22.UINT32
RCFDC0.CFDRMDF9_22.UINT16[L/H]
RCFDC0.CFDRMDF9_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_22.UINT32
RCFDC0.CFDRMDF10_22.UINT16[L/H]
RCFDC0.CFDRMDF10_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_22.UINT32
RCFDC0.CFDRMDF11_22.UINT16[L/H]
RCFDC0.CFDRMDF11_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_22.UINT32
RCFDC0.CFDRMDF12_22.UINT16[L/H]
RCFDC0.CFDRMDF12_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_22.UINT32
RCFDC0.CFDRMDF13_22.UINT16[L/H]
RCFDC0.CFDRMDF13_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_22.UINT32
RCFDC0.CFDRMDF14_22.UINT16[L/H]
RCFDC0.CFDRMDF14_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_22.UINT32
RCFDC0.CFDRMDF15_22.UINT16[L/H]
RCFDC0.CFDRMDF15_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID23.UINT32
RCFDC0.CFDRMID23.UINT16[L/H]
RCFDC0.CFDRMID23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR23.UINT32
RCFDC0.CFDRMPTR23.UINT16[L/H]
RCFDC0.CFDRMPTR23.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS23.UINT32
RCFDC0.CFDRMFDSTS23.UINT16[L/H]
RCFDC0.CFDRMFDSTS23.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_23.UINT32
RCFDC0.CFDRMDF0_23.UINT16[L/H]
RCFDC0.CFDRMDF0_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_23.UINT32
RCFDC0.CFDRMDF1_23.UINT16[L/H]
RCFDC0.CFDRMDF1_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_23.UINT32
RCFDC0.CFDRMDF2_23.UINT16[L/H]
RCFDC0.CFDRMDF2_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_23.UINT32
RCFDC0.CFDRMDF3_23.UINT16[L/H]
RCFDC0.CFDRMDF3_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_23.UINT32
RCFDC0.CFDRMDF4_23.UINT16[L/H]
RCFDC0.CFDRMDF4_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_23.UINT32
RCFDC0.CFDRMDF5_23.UINT16[L/H]
RCFDC0.CFDRMDF5_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_23.UINT32
RCFDC0.CFDRMDF6_23.UINT16[L/H]
RCFDC0.CFDRMDF6_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_23.UINT32
RCFDC0.CFDRMDF7_23.UINT16[L/H]
RCFDC0.CFDRMDF7_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_23.UINT32
RCFDC0.CFDRMDF8_23.UINT16[L/H]
RCFDC0.CFDRMDF8_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_23.UINT32
RCFDC0.CFDRMDF9_23.UINT16[L/H]
RCFDC0.CFDRMDF9_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_23.UINT32
RCFDC0.CFDRMDF10_23.UINT16[L/H]
RCFDC0.CFDRMDF10_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_23.UINT32
RCFDC0.CFDRMDF11_23.UINT16[L/H]
RCFDC0.CFDRMDF11_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_23.UINT32
RCFDC0.CFDRMDF12_23.UINT16[L/H]
RCFDC0.CFDRMDF12_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_23.UINT32
RCFDC0.CFDRMDF13_23.UINT16[L/H]
RCFDC0.CFDRMDF13_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_23.UINT32
RCFDC0.CFDRMDF14_23.UINT16[L/H]
RCFDC0.CFDRMDF14_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_23.UINT32
RCFDC0.CFDRMDF15_23.UINT16[L/H]
RCFDC0.CFDRMDF15_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID24.UINT32
RCFDC0.CFDRMID24.UINT16[L/H]
RCFDC0.CFDRMID24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR24.UINT32
RCFDC0.CFDRMPTR24.UINT16[L/H]
RCFDC0.CFDRMPTR24.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS24.UINT32
RCFDC0.CFDRMFDSTS24.UINT16[L/H]
RCFDC0.CFDRMFDSTS24.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_24.UINT32
RCFDC0.CFDRMDF0_24.UINT16[L/H]
RCFDC0.CFDRMDF0_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_24.UINT32
RCFDC0.CFDRMDF1_24.UINT16[L/H]
RCFDC0.CFDRMDF1_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_24.UINT32
RCFDC0.CFDRMDF2_24.UINT16[L/H]
RCFDC0.CFDRMDF2_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_24.UINT32
RCFDC0.CFDRMDF3_24.UINT16[L/H]
RCFDC0.CFDRMDF3_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_24.UINT32
RCFDC0.CFDRMDF4_24.UINT16[L/H]
RCFDC0.CFDRMDF4_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_24.UINT32
RCFDC0.CFDRMDF5_24.UINT16[L/H]
RCFDC0.CFDRMDF5_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_24.UINT32
RCFDC0.CFDRMDF6_24.UINT16[L/H]
RCFDC0.CFDRMDF6_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_24.UINT32
RCFDC0.CFDRMDF7_24.UINT16[L/H]
RCFDC0.CFDRMDF7_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_24.UINT32
RCFDC0.CFDRMDF8_24.UINT16[L/H]
RCFDC0.CFDRMDF8_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_24.UINT32
RCFDC0.CFDRMDF9_24.UINT16[L/H]
RCFDC0.CFDRMDF9_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_24.UINT32
RCFDC0.CFDRMDF10_24.UINT16[L/H]
RCFDC0.CFDRMDF10_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_24.UINT32
RCFDC0.CFDRMDF11_24.UINT16[L/H]
RCFDC0.CFDRMDF11_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_24.UINT32
RCFDC0.CFDRMDF12_24.UINT16[L/H]
RCFDC0.CFDRMDF12_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_24.UINT32
RCFDC0.CFDRMDF13_24.UINT16[L/H]
RCFDC0.CFDRMDF13_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_24.UINT32
RCFDC0.CFDRMDF14_24.UINT16[L/H]
RCFDC0.CFDRMDF14_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_24.UINT32
RCFDC0.CFDRMDF15_24.UINT16[L/H]
RCFDC0.CFDRMDF15_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID25.UINT32
RCFDC0.CFDRMID25.UINT16[L/H]
RCFDC0.CFDRMID25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR25.UINT32
RCFDC0.CFDRMPTR25.UINT16[L/H]
RCFDC0.CFDRMPTR25.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS25.UINT32
RCFDC0.CFDRMFDSTS25.UINT16[L/H]
RCFDC0.CFDRMFDSTS25.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_25.UINT32
RCFDC0.CFDRMDF0_25.UINT16[L/H]
RCFDC0.CFDRMDF0_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_25.UINT32
RCFDC0.CFDRMDF1_25.UINT16[L/H]
RCFDC0.CFDRMDF1_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_25.UINT32
RCFDC0.CFDRMDF2_25.UINT16[L/H]
RCFDC0.CFDRMDF2_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_25.UINT32
RCFDC0.CFDRMDF3_25.UINT16[L/H]
RCFDC0.CFDRMDF3_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_25.UINT32
RCFDC0.CFDRMDF4_25.UINT16[L/H]
RCFDC0.CFDRMDF4_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_25.UINT32
RCFDC0.CFDRMDF5_25.UINT16[L/H]
RCFDC0.CFDRMDF5_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_25.UINT32
RCFDC0.CFDRMDF6_25.UINT16[L/H]
RCFDC0.CFDRMDF6_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_25.UINT32
RCFDC0.CFDRMDF7_25.UINT16[L/H]
RCFDC0.CFDRMDF7_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_25.UINT32
RCFDC0.CFDRMDF8_25.UINT16[L/H]
RCFDC0.CFDRMDF8_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_25.UINT32
RCFDC0.CFDRMDF9_25.UINT16[L/H]
RCFDC0.CFDRMDF9_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_25.UINT32
RCFDC0.CFDRMDF10_25.UINT16[L/H]
RCFDC0.CFDRMDF10_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_25.UINT32
RCFDC0.CFDRMDF11_25.UINT16[L/H]
RCFDC0.CFDRMDF11_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_25.UINT32
RCFDC0.CFDRMDF12_25.UINT16[L/H]
RCFDC0.CFDRMDF12_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_25.UINT32
RCFDC0.CFDRMDF13_25.UINT16[L/H]
RCFDC0.CFDRMDF13_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_25.UINT32
RCFDC0.CFDRMDF14_25.UINT16[L/H]
RCFDC0.CFDRMDF14_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_25.UINT32
RCFDC0.CFDRMDF15_25.UINT16[L/H]
RCFDC0.CFDRMDF15_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID26.UINT32
RCFDC0.CFDRMID26.UINT16[L/H]
RCFDC0.CFDRMID26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR26.UINT32
RCFDC0.CFDRMPTR26.UINT16[L/H]
RCFDC0.CFDRMPTR26.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS26.UINT32
RCFDC0.CFDRMFDSTS26.UINT16[L/H]
RCFDC0.CFDRMFDSTS26.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_26.UINT32
RCFDC0.CFDRMDF0_26.UINT16[L/H]
RCFDC0.CFDRMDF0_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_26.UINT32
RCFDC0.CFDRMDF1_26.UINT16[L/H]
RCFDC0.CFDRMDF1_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_26.UINT32
RCFDC0.CFDRMDF2_26.UINT16[L/H]
RCFDC0.CFDRMDF2_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_26.UINT32
RCFDC0.CFDRMDF3_26.UINT16[L/H]
RCFDC0.CFDRMDF3_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_26.UINT32
RCFDC0.CFDRMDF4_26.UINT16[L/H]
RCFDC0.CFDRMDF4_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_26.UINT32
RCFDC0.CFDRMDF5_26.UINT16[L/H]
RCFDC0.CFDRMDF5_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_26.UINT32
RCFDC0.CFDRMDF6_26.UINT16[L/H]
RCFDC0.CFDRMDF6_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_26.UINT32
RCFDC0.CFDRMDF7_26.UINT16[L/H]
RCFDC0.CFDRMDF7_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_26.UINT32
RCFDC0.CFDRMDF8_26.UINT16[L/H]
RCFDC0.CFDRMDF8_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_26.UINT32
RCFDC0.CFDRMDF9_26.UINT16[L/H]
RCFDC0.CFDRMDF9_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_26.UINT32
RCFDC0.CFDRMDF10_26.UINT16[L/H]
RCFDC0.CFDRMDF10_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_26.UINT32
RCFDC0.CFDRMDF11_26.UINT16[L/H]
RCFDC0.CFDRMDF11_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_26.UINT32
RCFDC0.CFDRMDF12_26.UINT16[L/H]
RCFDC0.CFDRMDF12_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_26.UINT32
RCFDC0.CFDRMDF13_26.UINT16[L/H]
RCFDC0.CFDRMDF13_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_26.UINT32
RCFDC0.CFDRMDF14_26.UINT16[L/H]
RCFDC0.CFDRMDF14_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_26.UINT32
RCFDC0.CFDRMDF15_26.UINT16[L/H]
RCFDC0.CFDRMDF15_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID27.UINT32
RCFDC0.CFDRMID27.UINT16[L/H]
RCFDC0.CFDRMID27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR27.UINT32
RCFDC0.CFDRMPTR27.UINT16[L/H]
RCFDC0.CFDRMPTR27.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS27.UINT32
RCFDC0.CFDRMFDSTS27.UINT16[L/H]
RCFDC0.CFDRMFDSTS27.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_27.UINT32
RCFDC0.CFDRMDF0_27.UINT16[L/H]
RCFDC0.CFDRMDF0_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_27.UINT32
RCFDC0.CFDRMDF1_27.UINT16[L/H]
RCFDC0.CFDRMDF1_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_27.UINT32
RCFDC0.CFDRMDF2_27.UINT16[L/H]
RCFDC0.CFDRMDF2_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_27.UINT32
RCFDC0.CFDRMDF3_27.UINT16[L/H]
RCFDC0.CFDRMDF3_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_27.UINT32
RCFDC0.CFDRMDF4_27.UINT16[L/H]
RCFDC0.CFDRMDF4_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_27.UINT32
RCFDC0.CFDRMDF5_27.UINT16[L/H]
RCFDC0.CFDRMDF5_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_27.UINT32
RCFDC0.CFDRMDF6_27.UINT16[L/H]
RCFDC0.CFDRMDF6_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_27.UINT32
RCFDC0.CFDRMDF7_27.UINT16[L/H]
RCFDC0.CFDRMDF7_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_27.UINT32
RCFDC0.CFDRMDF8_27.UINT16[L/H]
RCFDC0.CFDRMDF8_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_27.UINT32
RCFDC0.CFDRMDF9_27.UINT16[L/H]
RCFDC0.CFDRMDF9_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_27.UINT32
RCFDC0.CFDRMDF10_27.UINT16[L/H]
RCFDC0.CFDRMDF10_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_27.UINT32
RCFDC0.CFDRMDF11_27.UINT16[L/H]
RCFDC0.CFDRMDF11_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_27.UINT32
RCFDC0.CFDRMDF12_27.UINT16[L/H]
RCFDC0.CFDRMDF12_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_27.UINT32
RCFDC0.CFDRMDF13_27.UINT16[L/H]
RCFDC0.CFDRMDF13_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_27.UINT32
RCFDC0.CFDRMDF14_27.UINT16[L/H]
RCFDC0.CFDRMDF14_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_27.UINT32
RCFDC0.CFDRMDF15_27.UINT16[L/H]
RCFDC0.CFDRMDF15_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID28.UINT32
RCFDC0.CFDRMID28.UINT16[L/H]
RCFDC0.CFDRMID28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR28.UINT32
RCFDC0.CFDRMPTR28.UINT16[L/H]
RCFDC0.CFDRMPTR28.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS28.UINT32
RCFDC0.CFDRMFDSTS28.UINT16[L/H]
RCFDC0.CFDRMFDSTS28.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_28.UINT32
RCFDC0.CFDRMDF0_28.UINT16[L/H]
RCFDC0.CFDRMDF0_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_28.UINT32
RCFDC0.CFDRMDF1_28.UINT16[L/H]
RCFDC0.CFDRMDF1_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_28.UINT32
RCFDC0.CFDRMDF2_28.UINT16[L/H]
RCFDC0.CFDRMDF2_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_28.UINT32
RCFDC0.CFDRMDF3_28.UINT16[L/H]
RCFDC0.CFDRMDF3_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_28.UINT32
RCFDC0.CFDRMDF4_28.UINT16[L/H]
RCFDC0.CFDRMDF4_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_28.UINT32
RCFDC0.CFDRMDF5_28.UINT16[L/H]
RCFDC0.CFDRMDF5_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_28.UINT32
RCFDC0.CFDRMDF6_28.UINT16[L/H]
RCFDC0.CFDRMDF6_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_28.UINT32
RCFDC0.CFDRMDF7_28.UINT16[L/H]
RCFDC0.CFDRMDF7_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_28.UINT32
RCFDC0.CFDRMDF8_28.UINT16[L/H]
RCFDC0.CFDRMDF8_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_28.UINT32
RCFDC0.CFDRMDF9_28.UINT16[L/H]
RCFDC0.CFDRMDF9_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_28.UINT32
RCFDC0.CFDRMDF10_28.UINT16[L/H]
RCFDC0.CFDRMDF10_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_28.UINT32
RCFDC0.CFDRMDF11_28.UINT16[L/H]
RCFDC0.CFDRMDF11_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_28.UINT32
RCFDC0.CFDRMDF12_28.UINT16[L/H]
RCFDC0.CFDRMDF12_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_28.UINT32
RCFDC0.CFDRMDF13_28.UINT16[L/H]
RCFDC0.CFDRMDF13_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_28.UINT32
RCFDC0.CFDRMDF14_28.UINT16[L/H]
RCFDC0.CFDRMDF14_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_28.UINT32
RCFDC0.CFDRMDF15_28.UINT16[L/H]
RCFDC0.CFDRMDF15_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID29.UINT32
RCFDC0.CFDRMID29.UINT16[L/H]
RCFDC0.CFDRMID29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR29.UINT32
RCFDC0.CFDRMPTR29.UINT16[L/H]
RCFDC0.CFDRMPTR29.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS29.UINT32
RCFDC0.CFDRMFDSTS29.UINT16[L/H]
RCFDC0.CFDRMFDSTS29.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_29.UINT32
RCFDC0.CFDRMDF0_29.UINT16[L/H]
RCFDC0.CFDRMDF0_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_29.UINT32
RCFDC0.CFDRMDF1_29.UINT16[L/H]
RCFDC0.CFDRMDF1_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_29.UINT32
RCFDC0.CFDRMDF2_29.UINT16[L/H]
RCFDC0.CFDRMDF2_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_29.UINT32
RCFDC0.CFDRMDF3_29.UINT16[L/H]
RCFDC0.CFDRMDF3_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_29.UINT32
RCFDC0.CFDRMDF4_29.UINT16[L/H]
RCFDC0.CFDRMDF4_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_29.UINT32
RCFDC0.CFDRMDF5_29.UINT16[L/H]
RCFDC0.CFDRMDF5_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_29.UINT32
RCFDC0.CFDRMDF6_29.UINT16[L/H]
RCFDC0.CFDRMDF6_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_29.UINT32
RCFDC0.CFDRMDF7_29.UINT16[L/H]
RCFDC0.CFDRMDF7_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_29.UINT32
RCFDC0.CFDRMDF8_29.UINT16[L/H]
RCFDC0.CFDRMDF8_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_29.UINT32
RCFDC0.CFDRMDF9_29.UINT16[L/H]
RCFDC0.CFDRMDF9_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_29.UINT32
RCFDC0.CFDRMDF10_29.UINT16[L/H]
RCFDC0.CFDRMDF10_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_29.UINT32
RCFDC0.CFDRMDF11_29.UINT16[L/H]
RCFDC0.CFDRMDF11_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_29.UINT32
RCFDC0.CFDRMDF12_29.UINT16[L/H]
RCFDC0.CFDRMDF12_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_29.UINT32
RCFDC0.CFDRMDF13_29.UINT16[L/H]
RCFDC0.CFDRMDF13_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_29.UINT32
RCFDC0.CFDRMDF14_29.UINT16[L/H]
RCFDC0.CFDRMDF14_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_29.UINT32
RCFDC0.CFDRMDF15_29.UINT16[L/H]
RCFDC0.CFDRMDF15_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID30.UINT32
RCFDC0.CFDRMID30.UINT16[L/H]
RCFDC0.CFDRMID30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR30.UINT32
RCFDC0.CFDRMPTR30.UINT16[L/H]
RCFDC0.CFDRMPTR30.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS30.UINT32
RCFDC0.CFDRMFDSTS30.UINT16[L/H]
RCFDC0.CFDRMFDSTS30.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_30.UINT32
RCFDC0.CFDRMDF0_30.UINT16[L/H]
RCFDC0.CFDRMDF0_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_30.UINT32
RCFDC0.CFDRMDF1_30.UINT16[L/H]
RCFDC0.CFDRMDF1_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_30.UINT32
RCFDC0.CFDRMDF2_30.UINT16[L/H]
RCFDC0.CFDRMDF2_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_30.UINT32
RCFDC0.CFDRMDF3_30.UINT16[L/H]
RCFDC0.CFDRMDF3_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_30.UINT32
RCFDC0.CFDRMDF4_30.UINT16[L/H]
RCFDC0.CFDRMDF4_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_30.UINT32
RCFDC0.CFDRMDF5_30.UINT16[L/H]
RCFDC0.CFDRMDF5_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_30.UINT32
RCFDC0.CFDRMDF6_30.UINT16[L/H]
RCFDC0.CFDRMDF6_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_30.UINT32
RCFDC0.CFDRMDF7_30.UINT16[L/H]
RCFDC0.CFDRMDF7_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_30.UINT32
RCFDC0.CFDRMDF8_30.UINT16[L/H]
RCFDC0.CFDRMDF8_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_30.UINT32
RCFDC0.CFDRMDF9_30.UINT16[L/H]
RCFDC0.CFDRMDF9_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_30.UINT32
RCFDC0.CFDRMDF10_30.UINT16[L/H]
RCFDC0.CFDRMDF10_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_30.UINT32
RCFDC0.CFDRMDF11_30.UINT16[L/H]
RCFDC0.CFDRMDF11_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_30.UINT32
RCFDC0.CFDRMDF12_30.UINT16[L/H]
RCFDC0.CFDRMDF12_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_30.UINT32
RCFDC0.CFDRMDF13_30.UINT16[L/H]
RCFDC0.CFDRMDF13_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_30.UINT32
RCFDC0.CFDRMDF14_30.UINT16[L/H]
RCFDC0.CFDRMDF14_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_30.UINT32
RCFDC0.CFDRMDF15_30.UINT16[L/H]
RCFDC0.CFDRMDF15_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID31.UINT32
RCFDC0.CFDRMID31.UINT16[L/H]
RCFDC0.CFDRMID31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR31.UINT32
RCFDC0.CFDRMPTR31.UINT16[L/H]
RCFDC0.CFDRMPTR31.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS31.UINT32
RCFDC0.CFDRMFDSTS31.UINT16[L/H]
RCFDC0.CFDRMFDSTS31.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_31.UINT32
RCFDC0.CFDRMDF0_31.UINT16[L/H]
RCFDC0.CFDRMDF0_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_31.UINT32
RCFDC0.CFDRMDF1_31.UINT16[L/H]
RCFDC0.CFDRMDF1_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_31.UINT32
RCFDC0.CFDRMDF2_31.UINT16[L/H]
RCFDC0.CFDRMDF2_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_31.UINT32
RCFDC0.CFDRMDF3_31.UINT16[L/H]
RCFDC0.CFDRMDF3_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_31.UINT32
RCFDC0.CFDRMDF4_31.UINT16[L/H]
RCFDC0.CFDRMDF4_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_31.UINT32
RCFDC0.CFDRMDF5_31.UINT16[L/H]
RCFDC0.CFDRMDF5_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_31.UINT32
RCFDC0.CFDRMDF6_31.UINT16[L/H]
RCFDC0.CFDRMDF6_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_31.UINT32
RCFDC0.CFDRMDF7_31.UINT16[L/H]
RCFDC0.CFDRMDF7_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_31.UINT32
RCFDC0.CFDRMDF8_31.UINT16[L/H]
RCFDC0.CFDRMDF8_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_31.UINT32
RCFDC0.CFDRMDF9_31.UINT16[L/H]
RCFDC0.CFDRMDF9_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_31.UINT32
RCFDC0.CFDRMDF10_31.UINT16[L/H]
RCFDC0.CFDRMDF10_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_31.UINT32
RCFDC0.CFDRMDF11_31.UINT16[L/H]
RCFDC0.CFDRMDF11_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_31.UINT32
RCFDC0.CFDRMDF12_31.UINT16[L/H]
RCFDC0.CFDRMDF12_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_31.UINT32
RCFDC0.CFDRMDF13_31.UINT16[L/H]
RCFDC0.CFDRMDF13_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_31.UINT32
RCFDC0.CFDRMDF14_31.UINT16[L/H]
RCFDC0.CFDRMDF14_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_31.UINT32
RCFDC0.CFDRMDF15_31.UINT16[L/H]
RCFDC0.CFDRMDF15_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID32.UINT32
RCFDC0.CFDRMID32.UINT16[L/H]
RCFDC0.CFDRMID32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR32.UINT32
RCFDC0.CFDRMPTR32.UINT16[L/H]
RCFDC0.CFDRMPTR32.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS32.UINT32
RCFDC0.CFDRMFDSTS32.UINT16[L/H]
RCFDC0.CFDRMFDSTS32.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_32.UINT32
RCFDC0.CFDRMDF0_32.UINT16[L/H]
RCFDC0.CFDRMDF0_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_32.UINT32
RCFDC0.CFDRMDF1_32.UINT16[L/H]
RCFDC0.CFDRMDF1_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_32.UINT32
RCFDC0.CFDRMDF2_32.UINT16[L/H]
RCFDC0.CFDRMDF2_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_32.UINT32
RCFDC0.CFDRMDF3_32.UINT16[L/H]
RCFDC0.CFDRMDF3_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_32.UINT32
RCFDC0.CFDRMDF4_32.UINT16[L/H]
RCFDC0.CFDRMDF4_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_32.UINT32
RCFDC0.CFDRMDF5_32.UINT16[L/H]
RCFDC0.CFDRMDF5_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_32.UINT32
RCFDC0.CFDRMDF6_32.UINT16[L/H]
RCFDC0.CFDRMDF6_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_32.UINT32
RCFDC0.CFDRMDF7_32.UINT16[L/H]
RCFDC0.CFDRMDF7_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_32.UINT32
RCFDC0.CFDRMDF8_32.UINT16[L/H]
RCFDC0.CFDRMDF8_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_32.UINT32
RCFDC0.CFDRMDF9_32.UINT16[L/H]
RCFDC0.CFDRMDF9_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_32.UINT32
RCFDC0.CFDRMDF10_32.UINT16[L/H]
RCFDC0.CFDRMDF10_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_32.UINT32
RCFDC0.CFDRMDF11_32.UINT16[L/H]
RCFDC0.CFDRMDF11_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_32.UINT32
RCFDC0.CFDRMDF12_32.UINT16[L/H]
RCFDC0.CFDRMDF12_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_32.UINT32
RCFDC0.CFDRMDF13_32.UINT16[L/H]
RCFDC0.CFDRMDF13_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_32.UINT32
RCFDC0.CFDRMDF14_32.UINT16[L/H]
RCFDC0.CFDRMDF14_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_32.UINT32
RCFDC0.CFDRMDF15_32.UINT16[L/H]
RCFDC0.CFDRMDF15_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID33.UINT32
RCFDC0.CFDRMID33.UINT16[L/H]
RCFDC0.CFDRMID33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR33.UINT32
RCFDC0.CFDRMPTR33.UINT16[L/H]
RCFDC0.CFDRMPTR33.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS33.UINT32
RCFDC0.CFDRMFDSTS33.UINT16[L/H]
RCFDC0.CFDRMFDSTS33.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_33.UINT32
RCFDC0.CFDRMDF0_33.UINT16[L/H]
RCFDC0.CFDRMDF0_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_33.UINT32
RCFDC0.CFDRMDF1_33.UINT16[L/H]
RCFDC0.CFDRMDF1_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_33.UINT32
RCFDC0.CFDRMDF2_33.UINT16[L/H]
RCFDC0.CFDRMDF2_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_33.UINT32
RCFDC0.CFDRMDF3_33.UINT16[L/H]
RCFDC0.CFDRMDF3_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_33.UINT32
RCFDC0.CFDRMDF4_33.UINT16[L/H]
RCFDC0.CFDRMDF4_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_33.UINT32
RCFDC0.CFDRMDF5_33.UINT16[L/H]
RCFDC0.CFDRMDF5_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_33.UINT32
RCFDC0.CFDRMDF6_33.UINT16[L/H]
RCFDC0.CFDRMDF6_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_33.UINT32
RCFDC0.CFDRMDF7_33.UINT16[L/H]
RCFDC0.CFDRMDF7_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_33.UINT32
RCFDC0.CFDRMDF8_33.UINT16[L/H]
RCFDC0.CFDRMDF8_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_33.UINT32
RCFDC0.CFDRMDF9_33.UINT16[L/H]
RCFDC0.CFDRMDF9_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_33.UINT32
RCFDC0.CFDRMDF10_33.UINT16[L/H]
RCFDC0.CFDRMDF10_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_33.UINT32
RCFDC0.CFDRMDF11_33.UINT16[L/H]
RCFDC0.CFDRMDF11_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_33.UINT32
RCFDC0.CFDRMDF12_33.UINT16[L/H]
RCFDC0.CFDRMDF12_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_33.UINT32
RCFDC0.CFDRMDF13_33.UINT16[L/H]
RCFDC0.CFDRMDF13_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_33.UINT32
RCFDC0.CFDRMDF14_33.UINT16[L/H]
RCFDC0.CFDRMDF14_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_33.UINT32
RCFDC0.CFDRMDF15_33.UINT16[L/H]
RCFDC0.CFDRMDF15_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID34.UINT32
RCFDC0.CFDRMID34.UINT16[L/H]
RCFDC0.CFDRMID34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR34.UINT32
RCFDC0.CFDRMPTR34.UINT16[L/H]
RCFDC0.CFDRMPTR34.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS34.UINT32
RCFDC0.CFDRMFDSTS34.UINT16[L/H]
RCFDC0.CFDRMFDSTS34.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_34.UINT32
RCFDC0.CFDRMDF0_34.UINT16[L/H]
RCFDC0.CFDRMDF0_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_34.UINT32
RCFDC0.CFDRMDF1_34.UINT16[L/H]
RCFDC0.CFDRMDF1_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_34.UINT32
RCFDC0.CFDRMDF2_34.UINT16[L/H]
RCFDC0.CFDRMDF2_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_34.UINT32
RCFDC0.CFDRMDF3_34.UINT16[L/H]
RCFDC0.CFDRMDF3_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_34.UINT32
RCFDC0.CFDRMDF4_34.UINT16[L/H]
RCFDC0.CFDRMDF4_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_34.UINT32
RCFDC0.CFDRMDF5_34.UINT16[L/H]
RCFDC0.CFDRMDF5_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_34.UINT32
RCFDC0.CFDRMDF6_34.UINT16[L/H]
RCFDC0.CFDRMDF6_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_34.UINT32
RCFDC0.CFDRMDF7_34.UINT16[L/H]
RCFDC0.CFDRMDF7_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_34.UINT32
RCFDC0.CFDRMDF8_34.UINT16[L/H]
RCFDC0.CFDRMDF8_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_34.UINT32
RCFDC0.CFDRMDF9_34.UINT16[L/H]
RCFDC0.CFDRMDF9_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_34.UINT32
RCFDC0.CFDRMDF10_34.UINT16[L/H]
RCFDC0.CFDRMDF10_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_34.UINT32
RCFDC0.CFDRMDF11_34.UINT16[L/H]
RCFDC0.CFDRMDF11_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_34.UINT32
RCFDC0.CFDRMDF12_34.UINT16[L/H]
RCFDC0.CFDRMDF12_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_34.UINT32
RCFDC0.CFDRMDF13_34.UINT16[L/H]
RCFDC0.CFDRMDF13_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_34.UINT32
RCFDC0.CFDRMDF14_34.UINT16[L/H]
RCFDC0.CFDRMDF14_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_34.UINT32
RCFDC0.CFDRMDF15_34.UINT16[L/H]
RCFDC0.CFDRMDF15_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID35.UINT32
RCFDC0.CFDRMID35.UINT16[L/H]
RCFDC0.CFDRMID35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR35.UINT32
RCFDC0.CFDRMPTR35.UINT16[L/H]
RCFDC0.CFDRMPTR35.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS35.UINT32
RCFDC0.CFDRMFDSTS35.UINT16[L/H]
RCFDC0.CFDRMFDSTS35.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_35.UINT32
RCFDC0.CFDRMDF0_35.UINT16[L/H]
RCFDC0.CFDRMDF0_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_35.UINT32
RCFDC0.CFDRMDF1_35.UINT16[L/H]
RCFDC0.CFDRMDF1_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_35.UINT32
RCFDC0.CFDRMDF2_35.UINT16[L/H]
RCFDC0.CFDRMDF2_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_35.UINT32
RCFDC0.CFDRMDF3_35.UINT16[L/H]
RCFDC0.CFDRMDF3_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_35.UINT32
RCFDC0.CFDRMDF4_35.UINT16[L/H]
RCFDC0.CFDRMDF4_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_35.UINT32
RCFDC0.CFDRMDF5_35.UINT16[L/H]
RCFDC0.CFDRMDF5_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_35.UINT32
RCFDC0.CFDRMDF6_35.UINT16[L/H]
RCFDC0.CFDRMDF6_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_35.UINT32
RCFDC0.CFDRMDF7_35.UINT16[L/H]
RCFDC0.CFDRMDF7_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_35.UINT32
RCFDC0.CFDRMDF8_35.UINT16[L/H]
RCFDC0.CFDRMDF8_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_35.UINT32
RCFDC0.CFDRMDF9_35.UINT16[L/H]
RCFDC0.CFDRMDF9_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_35.UINT32
RCFDC0.CFDRMDF10_35.UINT16[L/H]
RCFDC0.CFDRMDF10_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_35.UINT32
RCFDC0.CFDRMDF11_35.UINT16[L/H]
RCFDC0.CFDRMDF11_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_35.UINT32
RCFDC0.CFDRMDF12_35.UINT16[L/H]
RCFDC0.CFDRMDF12_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_35.UINT32
RCFDC0.CFDRMDF13_35.UINT16[L/H]
RCFDC0.CFDRMDF13_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_35.UINT32
RCFDC0.CFDRMDF14_35.UINT16[L/H]
RCFDC0.CFDRMDF14_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_35.UINT32
RCFDC0.CFDRMDF15_35.UINT16[L/H]
RCFDC0.CFDRMDF15_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID36.UINT32
RCFDC0.CFDRMID36.UINT16[L/H]
RCFDC0.CFDRMID36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR36.UINT32
RCFDC0.CFDRMPTR36.UINT16[L/H]
RCFDC0.CFDRMPTR36.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS36.UINT32
RCFDC0.CFDRMFDSTS36.UINT16[L/H]
RCFDC0.CFDRMFDSTS36.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_36.UINT32
RCFDC0.CFDRMDF0_36.UINT16[L/H]
RCFDC0.CFDRMDF0_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_36.UINT32
RCFDC0.CFDRMDF1_36.UINT16[L/H]
RCFDC0.CFDRMDF1_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_36.UINT32
RCFDC0.CFDRMDF2_36.UINT16[L/H]
RCFDC0.CFDRMDF2_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_36.UINT32
RCFDC0.CFDRMDF3_36.UINT16[L/H]
RCFDC0.CFDRMDF3_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_36.UINT32
RCFDC0.CFDRMDF4_36.UINT16[L/H]
RCFDC0.CFDRMDF4_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_36.UINT32
RCFDC0.CFDRMDF5_36.UINT16[L/H]
RCFDC0.CFDRMDF5_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_36.UINT32
RCFDC0.CFDRMDF6_36.UINT16[L/H]
RCFDC0.CFDRMDF6_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_36.UINT32
RCFDC0.CFDRMDF7_36.UINT16[L/H]
RCFDC0.CFDRMDF7_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_36.UINT32
RCFDC0.CFDRMDF8_36.UINT16[L/H]
RCFDC0.CFDRMDF8_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_36.UINT32
RCFDC0.CFDRMDF9_36.UINT16[L/H]
RCFDC0.CFDRMDF9_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_36.UINT32
RCFDC0.CFDRMDF10_36.UINT16[L/H]
RCFDC0.CFDRMDF10_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_36.UINT32
RCFDC0.CFDRMDF11_36.UINT16[L/H]
RCFDC0.CFDRMDF11_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_36.UINT32
RCFDC0.CFDRMDF12_36.UINT16[L/H]
RCFDC0.CFDRMDF12_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_36.UINT32
RCFDC0.CFDRMDF13_36.UINT16[L/H]
RCFDC0.CFDRMDF13_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_36.UINT32
RCFDC0.CFDRMDF14_36.UINT16[L/H]
RCFDC0.CFDRMDF14_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_36.UINT32
RCFDC0.CFDRMDF15_36.UINT16[L/H]
RCFDC0.CFDRMDF15_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID37.UINT32
RCFDC0.CFDRMID37.UINT16[L/H]
RCFDC0.CFDRMID37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR37.UINT32
RCFDC0.CFDRMPTR37.UINT16[L/H]
RCFDC0.CFDRMPTR37.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS37.UINT32
RCFDC0.CFDRMFDSTS37.UINT16[L/H]
RCFDC0.CFDRMFDSTS37.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_37.UINT32
RCFDC0.CFDRMDF0_37.UINT16[L/H]
RCFDC0.CFDRMDF0_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_37.UINT32
RCFDC0.CFDRMDF1_37.UINT16[L/H]
RCFDC0.CFDRMDF1_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_37.UINT32
RCFDC0.CFDRMDF2_37.UINT16[L/H]
RCFDC0.CFDRMDF2_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_37.UINT32
RCFDC0.CFDRMDF3_37.UINT16[L/H]
RCFDC0.CFDRMDF3_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_37.UINT32
RCFDC0.CFDRMDF4_37.UINT16[L/H]
RCFDC0.CFDRMDF4_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_37.UINT32
RCFDC0.CFDRMDF5_37.UINT16[L/H]
RCFDC0.CFDRMDF5_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_37.UINT32
RCFDC0.CFDRMDF6_37.UINT16[L/H]
RCFDC0.CFDRMDF6_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_37.UINT32
RCFDC0.CFDRMDF7_37.UINT16[L/H]
RCFDC0.CFDRMDF7_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_37.UINT32
RCFDC0.CFDRMDF8_37.UINT16[L/H]
RCFDC0.CFDRMDF8_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_37.UINT32
RCFDC0.CFDRMDF9_37.UINT16[L/H]
RCFDC0.CFDRMDF9_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_37.UINT32
RCFDC0.CFDRMDF10_37.UINT16[L/H]
RCFDC0.CFDRMDF10_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_37.UINT32
RCFDC0.CFDRMDF11_37.UINT16[L/H]
RCFDC0.CFDRMDF11_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_37.UINT32
RCFDC0.CFDRMDF12_37.UINT16[L/H]
RCFDC0.CFDRMDF12_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_37.UINT32
RCFDC0.CFDRMDF13_37.UINT16[L/H]
RCFDC0.CFDRMDF13_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_37.UINT32
RCFDC0.CFDRMDF14_37.UINT16[L/H]
RCFDC0.CFDRMDF14_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_37.UINT32
RCFDC0.CFDRMDF15_37.UINT16[L/H]
RCFDC0.CFDRMDF15_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID38.UINT32
RCFDC0.CFDRMID38.UINT16[L/H]
RCFDC0.CFDRMID38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR38.UINT32
RCFDC0.CFDRMPTR38.UINT16[L/H]
RCFDC0.CFDRMPTR38.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS38.UINT32
RCFDC0.CFDRMFDSTS38.UINT16[L/H]
RCFDC0.CFDRMFDSTS38.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_38.UINT32
RCFDC0.CFDRMDF0_38.UINT16[L/H]
RCFDC0.CFDRMDF0_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_38.UINT32
RCFDC0.CFDRMDF1_38.UINT16[L/H]
RCFDC0.CFDRMDF1_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_38.UINT32
RCFDC0.CFDRMDF2_38.UINT16[L/H]
RCFDC0.CFDRMDF2_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_38.UINT32
RCFDC0.CFDRMDF3_38.UINT16[L/H]
RCFDC0.CFDRMDF3_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_38.UINT32
RCFDC0.CFDRMDF4_38.UINT16[L/H]
RCFDC0.CFDRMDF4_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_38.UINT32
RCFDC0.CFDRMDF5_38.UINT16[L/H]
RCFDC0.CFDRMDF5_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_38.UINT32
RCFDC0.CFDRMDF6_38.UINT16[L/H]
RCFDC0.CFDRMDF6_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_38.UINT32
RCFDC0.CFDRMDF7_38.UINT16[L/H]
RCFDC0.CFDRMDF7_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_38.UINT32
RCFDC0.CFDRMDF8_38.UINT16[L/H]
RCFDC0.CFDRMDF8_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_38.UINT32
RCFDC0.CFDRMDF9_38.UINT16[L/H]
RCFDC0.CFDRMDF9_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_38.UINT32
RCFDC0.CFDRMDF10_38.UINT16[L/H]
RCFDC0.CFDRMDF10_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_38.UINT32
RCFDC0.CFDRMDF11_38.UINT16[L/H]
RCFDC0.CFDRMDF11_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_38.UINT32
RCFDC0.CFDRMDF12_38.UINT16[L/H]
RCFDC0.CFDRMDF12_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_38.UINT32
RCFDC0.CFDRMDF13_38.UINT16[L/H]
RCFDC0.CFDRMDF13_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_38.UINT32
RCFDC0.CFDRMDF14_38.UINT16[L/H]
RCFDC0.CFDRMDF14_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_38.UINT32
RCFDC0.CFDRMDF15_38.UINT16[L/H]
RCFDC0.CFDRMDF15_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID39.UINT32
RCFDC0.CFDRMID39.UINT16[L/H]
RCFDC0.CFDRMID39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR39.UINT32
RCFDC0.CFDRMPTR39.UINT16[L/H]
RCFDC0.CFDRMPTR39.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS39.UINT32
RCFDC0.CFDRMFDSTS39.UINT16[L/H]
RCFDC0.CFDRMFDSTS39.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_39.UINT32
RCFDC0.CFDRMDF0_39.UINT16[L/H]
RCFDC0.CFDRMDF0_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_39.UINT32
RCFDC0.CFDRMDF1_39.UINT16[L/H]
RCFDC0.CFDRMDF1_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_39.UINT32
RCFDC0.CFDRMDF2_39.UINT16[L/H]
RCFDC0.CFDRMDF2_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_39.UINT32
RCFDC0.CFDRMDF3_39.UINT16[L/H]
RCFDC0.CFDRMDF3_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_39.UINT32
RCFDC0.CFDRMDF4_39.UINT16[L/H]
RCFDC0.CFDRMDF4_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_39.UINT32
RCFDC0.CFDRMDF5_39.UINT16[L/H]
RCFDC0.CFDRMDF5_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_39.UINT32
RCFDC0.CFDRMDF6_39.UINT16[L/H]
RCFDC0.CFDRMDF6_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_39.UINT32
RCFDC0.CFDRMDF7_39.UINT16[L/H]
RCFDC0.CFDRMDF7_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_39.UINT32
RCFDC0.CFDRMDF8_39.UINT16[L/H]
RCFDC0.CFDRMDF8_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_39.UINT32
RCFDC0.CFDRMDF9_39.UINT16[L/H]
RCFDC0.CFDRMDF9_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_39.UINT32
RCFDC0.CFDRMDF10_39.UINT16[L/H]
RCFDC0.CFDRMDF10_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_39.UINT32
RCFDC0.CFDRMDF11_39.UINT16[L/H]
RCFDC0.CFDRMDF11_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_39.UINT32
RCFDC0.CFDRMDF12_39.UINT16[L/H]
RCFDC0.CFDRMDF12_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_39.UINT32
RCFDC0.CFDRMDF13_39.UINT16[L/H]
RCFDC0.CFDRMDF13_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_39.UINT32
RCFDC0.CFDRMDF14_39.UINT16[L/H]
RCFDC0.CFDRMDF14_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_39.UINT32
RCFDC0.CFDRMDF15_39.UINT16[L/H]
RCFDC0.CFDRMDF15_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID40.UINT32
RCFDC0.CFDRMID40.UINT16[L/H]
RCFDC0.CFDRMID40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR40.UINT32
RCFDC0.CFDRMPTR40.UINT16[L/H]
RCFDC0.CFDRMPTR40.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS40.UINT32
RCFDC0.CFDRMFDSTS40.UINT16[L/H]
RCFDC0.CFDRMFDSTS40.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_40.UINT32
RCFDC0.CFDRMDF0_40.UINT16[L/H]
RCFDC0.CFDRMDF0_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_40.UINT32
RCFDC0.CFDRMDF1_40.UINT16[L/H]
RCFDC0.CFDRMDF1_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_40.UINT32
RCFDC0.CFDRMDF2_40.UINT16[L/H]
RCFDC0.CFDRMDF2_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_40.UINT32
RCFDC0.CFDRMDF3_40.UINT16[L/H]
RCFDC0.CFDRMDF3_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_40.UINT32
RCFDC0.CFDRMDF4_40.UINT16[L/H]
RCFDC0.CFDRMDF4_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_40.UINT32
RCFDC0.CFDRMDF5_40.UINT16[L/H]
RCFDC0.CFDRMDF5_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_40.UINT32
RCFDC0.CFDRMDF6_40.UINT16[L/H]
RCFDC0.CFDRMDF6_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_40.UINT32
RCFDC0.CFDRMDF7_40.UINT16[L/H]
RCFDC0.CFDRMDF7_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_40.UINT32
RCFDC0.CFDRMDF8_40.UINT16[L/H]
RCFDC0.CFDRMDF8_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_40.UINT32
RCFDC0.CFDRMDF9_40.UINT16[L/H]
RCFDC0.CFDRMDF9_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_40.UINT32
RCFDC0.CFDRMDF10_40.UINT16[L/H]
RCFDC0.CFDRMDF10_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_40.UINT32
RCFDC0.CFDRMDF11_40.UINT16[L/H]
RCFDC0.CFDRMDF11_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_40.UINT32
RCFDC0.CFDRMDF12_40.UINT16[L/H]
RCFDC0.CFDRMDF12_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_40.UINT32
RCFDC0.CFDRMDF13_40.UINT16[L/H]
RCFDC0.CFDRMDF13_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_40.UINT32
RCFDC0.CFDRMDF14_40.UINT16[L/H]
RCFDC0.CFDRMDF14_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_40.UINT32
RCFDC0.CFDRMDF15_40.UINT16[L/H]
RCFDC0.CFDRMDF15_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID41.UINT32
RCFDC0.CFDRMID41.UINT16[L/H]
RCFDC0.CFDRMID41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR41.UINT32
RCFDC0.CFDRMPTR41.UINT16[L/H]
RCFDC0.CFDRMPTR41.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS41.UINT32
RCFDC0.CFDRMFDSTS41.UINT16[L/H]
RCFDC0.CFDRMFDSTS41.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_41.UINT32
RCFDC0.CFDRMDF0_41.UINT16[L/H]
RCFDC0.CFDRMDF0_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_41.UINT32
RCFDC0.CFDRMDF1_41.UINT16[L/H]
RCFDC0.CFDRMDF1_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_41.UINT32
RCFDC0.CFDRMDF2_41.UINT16[L/H]
RCFDC0.CFDRMDF2_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_41.UINT32
RCFDC0.CFDRMDF3_41.UINT16[L/H]
RCFDC0.CFDRMDF3_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_41.UINT32
RCFDC0.CFDRMDF4_41.UINT16[L/H]
RCFDC0.CFDRMDF4_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_41.UINT32
RCFDC0.CFDRMDF5_41.UINT16[L/H]
RCFDC0.CFDRMDF5_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_41.UINT32
RCFDC0.CFDRMDF6_41.UINT16[L/H]
RCFDC0.CFDRMDF6_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_41.UINT32
RCFDC0.CFDRMDF7_41.UINT16[L/H]
RCFDC0.CFDRMDF7_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_41.UINT32
RCFDC0.CFDRMDF8_41.UINT16[L/H]
RCFDC0.CFDRMDF8_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_41.UINT32
RCFDC0.CFDRMDF9_41.UINT16[L/H]
RCFDC0.CFDRMDF9_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_41.UINT32
RCFDC0.CFDRMDF10_41.UINT16[L/H]
RCFDC0.CFDRMDF10_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_41.UINT32
RCFDC0.CFDRMDF11_41.UINT16[L/H]
RCFDC0.CFDRMDF11_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_41.UINT32
RCFDC0.CFDRMDF12_41.UINT16[L/H]
RCFDC0.CFDRMDF12_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_41.UINT32
RCFDC0.CFDRMDF13_41.UINT16[L/H]
RCFDC0.CFDRMDF13_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_41.UINT32
RCFDC0.CFDRMDF14_41.UINT16[L/H]
RCFDC0.CFDRMDF14_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_41.UINT32
RCFDC0.CFDRMDF15_41.UINT16[L/H]
RCFDC0.CFDRMDF15_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID42.UINT32
RCFDC0.CFDRMID42.UINT16[L/H]
RCFDC0.CFDRMID42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR42.UINT32
RCFDC0.CFDRMPTR42.UINT16[L/H]
RCFDC0.CFDRMPTR42.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS42.UINT32
RCFDC0.CFDRMFDSTS42.UINT16[L/H]
RCFDC0.CFDRMFDSTS42.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_42.UINT32
RCFDC0.CFDRMDF0_42.UINT16[L/H]
RCFDC0.CFDRMDF0_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_42.UINT32
RCFDC0.CFDRMDF1_42.UINT16[L/H]
RCFDC0.CFDRMDF1_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_42.UINT32
RCFDC0.CFDRMDF2_42.UINT16[L/H]
RCFDC0.CFDRMDF2_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_42.UINT32
RCFDC0.CFDRMDF3_42.UINT16[L/H]
RCFDC0.CFDRMDF3_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_42.UINT32
RCFDC0.CFDRMDF4_42.UINT16[L/H]
RCFDC0.CFDRMDF4_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_42.UINT32
RCFDC0.CFDRMDF5_42.UINT16[L/H]
RCFDC0.CFDRMDF5_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_42.UINT32
RCFDC0.CFDRMDF6_42.UINT16[L/H]
RCFDC0.CFDRMDF6_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_42.UINT32
RCFDC0.CFDRMDF7_42.UINT16[L/H]
RCFDC0.CFDRMDF7_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_42.UINT32
RCFDC0.CFDRMDF8_42.UINT16[L/H]
RCFDC0.CFDRMDF8_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_42.UINT32
RCFDC0.CFDRMDF9_42.UINT16[L/H]
RCFDC0.CFDRMDF9_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_42.UINT32
RCFDC0.CFDRMDF10_42.UINT16[L/H]
RCFDC0.CFDRMDF10_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_42.UINT32
RCFDC0.CFDRMDF11_42.UINT16[L/H]
RCFDC0.CFDRMDF11_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_42.UINT32
RCFDC0.CFDRMDF12_42.UINT16[L/H]
RCFDC0.CFDRMDF12_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_42.UINT32
RCFDC0.CFDRMDF13_42.UINT16[L/H]
RCFDC0.CFDRMDF13_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_42.UINT32
RCFDC0.CFDRMDF14_42.UINT16[L/H]
RCFDC0.CFDRMDF14_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_42.UINT32
RCFDC0.CFDRMDF15_42.UINT16[L/H]
RCFDC0.CFDRMDF15_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID43.UINT32
RCFDC0.CFDRMID43.UINT16[L/H]
RCFDC0.CFDRMID43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR43.UINT32
RCFDC0.CFDRMPTR43.UINT16[L/H]
RCFDC0.CFDRMPTR43.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS43.UINT32
RCFDC0.CFDRMFDSTS43.UINT16[L/H]
RCFDC0.CFDRMFDSTS43.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_43.UINT32
RCFDC0.CFDRMDF0_43.UINT16[L/H]
RCFDC0.CFDRMDF0_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_43.UINT32
RCFDC0.CFDRMDF1_43.UINT16[L/H]
RCFDC0.CFDRMDF1_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_43.UINT32
RCFDC0.CFDRMDF2_43.UINT16[L/H]
RCFDC0.CFDRMDF2_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_43.UINT32
RCFDC0.CFDRMDF3_43.UINT16[L/H]
RCFDC0.CFDRMDF3_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_43.UINT32
RCFDC0.CFDRMDF4_43.UINT16[L/H]
RCFDC0.CFDRMDF4_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_43.UINT32
RCFDC0.CFDRMDF5_43.UINT16[L/H]
RCFDC0.CFDRMDF5_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_43.UINT32
RCFDC0.CFDRMDF6_43.UINT16[L/H]
RCFDC0.CFDRMDF6_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_43.UINT32
RCFDC0.CFDRMDF7_43.UINT16[L/H]
RCFDC0.CFDRMDF7_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_43.UINT32
RCFDC0.CFDRMDF8_43.UINT16[L/H]
RCFDC0.CFDRMDF8_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_43.UINT32
RCFDC0.CFDRMDF9_43.UINT16[L/H]
RCFDC0.CFDRMDF9_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_43.UINT32
RCFDC0.CFDRMDF10_43.UINT16[L/H]
RCFDC0.CFDRMDF10_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_43.UINT32
RCFDC0.CFDRMDF11_43.UINT16[L/H]
RCFDC0.CFDRMDF11_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_43.UINT32
RCFDC0.CFDRMDF12_43.UINT16[L/H]
RCFDC0.CFDRMDF12_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_43.UINT32
RCFDC0.CFDRMDF13_43.UINT16[L/H]
RCFDC0.CFDRMDF13_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_43.UINT32
RCFDC0.CFDRMDF14_43.UINT16[L/H]
RCFDC0.CFDRMDF14_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_43.UINT32
RCFDC0.CFDRMDF15_43.UINT16[L/H]
RCFDC0.CFDRMDF15_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID44.UINT32
RCFDC0.CFDRMID44.UINT16[L/H]
RCFDC0.CFDRMID44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR44.UINT32
RCFDC0.CFDRMPTR44.UINT16[L/H]
RCFDC0.CFDRMPTR44.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS44.UINT32
RCFDC0.CFDRMFDSTS44.UINT16[L/H]
RCFDC0.CFDRMFDSTS44.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_44.UINT32
RCFDC0.CFDRMDF0_44.UINT16[L/H]
RCFDC0.CFDRMDF0_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_44.UINT32
RCFDC0.CFDRMDF1_44.UINT16[L/H]
RCFDC0.CFDRMDF1_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_44.UINT32
RCFDC0.CFDRMDF2_44.UINT16[L/H]
RCFDC0.CFDRMDF2_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_44.UINT32
RCFDC0.CFDRMDF3_44.UINT16[L/H]
RCFDC0.CFDRMDF3_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_44.UINT32
RCFDC0.CFDRMDF4_44.UINT16[L/H]
RCFDC0.CFDRMDF4_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_44.UINT32
RCFDC0.CFDRMDF5_44.UINT16[L/H]
RCFDC0.CFDRMDF5_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_44.UINT32
RCFDC0.CFDRMDF6_44.UINT16[L/H]
RCFDC0.CFDRMDF6_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_44.UINT32
RCFDC0.CFDRMDF7_44.UINT16[L/H]
RCFDC0.CFDRMDF7_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_44.UINT32
RCFDC0.CFDRMDF8_44.UINT16[L/H]
RCFDC0.CFDRMDF8_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_44.UINT32
RCFDC0.CFDRMDF9_44.UINT16[L/H]
RCFDC0.CFDRMDF9_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_44.UINT32
RCFDC0.CFDRMDF10_44.UINT16[L/H]
RCFDC0.CFDRMDF10_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_44.UINT32
RCFDC0.CFDRMDF11_44.UINT16[L/H]
RCFDC0.CFDRMDF11_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_44.UINT32
RCFDC0.CFDRMDF12_44.UINT16[L/H]
RCFDC0.CFDRMDF12_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_44.UINT32
RCFDC0.CFDRMDF13_44.UINT16[L/H]
RCFDC0.CFDRMDF13_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_44.UINT32
RCFDC0.CFDRMDF14_44.UINT16[L/H]
RCFDC0.CFDRMDF14_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_44.UINT32
RCFDC0.CFDRMDF15_44.UINT16[L/H]
RCFDC0.CFDRMDF15_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID45.UINT32
RCFDC0.CFDRMID45.UINT16[L/H]
RCFDC0.CFDRMID45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR45.UINT32
RCFDC0.CFDRMPTR45.UINT16[L/H]
RCFDC0.CFDRMPTR45.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS45.UINT32
RCFDC0.CFDRMFDSTS45.UINT16[L/H]
RCFDC0.CFDRMFDSTS45.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_45.UINT32
RCFDC0.CFDRMDF0_45.UINT16[L/H]
RCFDC0.CFDRMDF0_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_45.UINT32
RCFDC0.CFDRMDF1_45.UINT16[L/H]
RCFDC0.CFDRMDF1_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_45.UINT32
RCFDC0.CFDRMDF2_45.UINT16[L/H]
RCFDC0.CFDRMDF2_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_45.UINT32
RCFDC0.CFDRMDF3_45.UINT16[L/H]
RCFDC0.CFDRMDF3_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_45.UINT32
RCFDC0.CFDRMDF4_45.UINT16[L/H]
RCFDC0.CFDRMDF4_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_45.UINT32
RCFDC0.CFDRMDF5_45.UINT16[L/H]
RCFDC0.CFDRMDF5_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_45.UINT32
RCFDC0.CFDRMDF6_45.UINT16[L/H]
RCFDC0.CFDRMDF6_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_45.UINT32
RCFDC0.CFDRMDF7_45.UINT16[L/H]
RCFDC0.CFDRMDF7_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_45.UINT32
RCFDC0.CFDRMDF8_45.UINT16[L/H]
RCFDC0.CFDRMDF8_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_45.UINT32
RCFDC0.CFDRMDF9_45.UINT16[L/H]
RCFDC0.CFDRMDF9_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_45.UINT32
RCFDC0.CFDRMDF10_45.UINT16[L/H]
RCFDC0.CFDRMDF10_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_45.UINT32
RCFDC0.CFDRMDF11_45.UINT16[L/H]
RCFDC0.CFDRMDF11_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_45.UINT32
RCFDC0.CFDRMDF12_45.UINT16[L/H]
RCFDC0.CFDRMDF12_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_45.UINT32
RCFDC0.CFDRMDF13_45.UINT16[L/H]
RCFDC0.CFDRMDF13_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_45.UINT32
RCFDC0.CFDRMDF14_45.UINT16[L/H]
RCFDC0.CFDRMDF14_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_45.UINT32
RCFDC0.CFDRMDF15_45.UINT16[L/H]
RCFDC0.CFDRMDF15_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID46.UINT32
RCFDC0.CFDRMID46.UINT16[L/H]
RCFDC0.CFDRMID46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR46.UINT32
RCFDC0.CFDRMPTR46.UINT16[L/H]
RCFDC0.CFDRMPTR46.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS46.UINT32
RCFDC0.CFDRMFDSTS46.UINT16[L/H]
RCFDC0.CFDRMFDSTS46.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_46.UINT32
RCFDC0.CFDRMDF0_46.UINT16[L/H]
RCFDC0.CFDRMDF0_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_46.UINT32
RCFDC0.CFDRMDF1_46.UINT16[L/H]
RCFDC0.CFDRMDF1_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_46.UINT32
RCFDC0.CFDRMDF2_46.UINT16[L/H]
RCFDC0.CFDRMDF2_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_46.UINT32
RCFDC0.CFDRMDF3_46.UINT16[L/H]
RCFDC0.CFDRMDF3_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_46.UINT32
RCFDC0.CFDRMDF4_46.UINT16[L/H]
RCFDC0.CFDRMDF4_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_46.UINT32
RCFDC0.CFDRMDF5_46.UINT16[L/H]
RCFDC0.CFDRMDF5_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_46.UINT32
RCFDC0.CFDRMDF6_46.UINT16[L/H]
RCFDC0.CFDRMDF6_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_46.UINT32
RCFDC0.CFDRMDF7_46.UINT16[L/H]
RCFDC0.CFDRMDF7_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_46.UINT32
RCFDC0.CFDRMDF8_46.UINT16[L/H]
RCFDC0.CFDRMDF8_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_46.UINT32
RCFDC0.CFDRMDF9_46.UINT16[L/H]
RCFDC0.CFDRMDF9_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_46.UINT32
RCFDC0.CFDRMDF10_46.UINT16[L/H]
RCFDC0.CFDRMDF10_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_46.UINT32
RCFDC0.CFDRMDF11_46.UINT16[L/H]
RCFDC0.CFDRMDF11_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_46.UINT32
RCFDC0.CFDRMDF12_46.UINT16[L/H]
RCFDC0.CFDRMDF12_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_46.UINT32
RCFDC0.CFDRMDF13_46.UINT16[L/H]
RCFDC0.CFDRMDF13_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_46.UINT32
RCFDC0.CFDRMDF14_46.UINT16[L/H]
RCFDC0.CFDRMDF14_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_46.UINT32
RCFDC0.CFDRMDF15_46.UINT16[L/H]
RCFDC0.CFDRMDF15_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMID47.UINT32
RCFDC0.CFDRMID47.UINT16[L/H]
RCFDC0.CFDRMID47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMPTR47.UINT32
RCFDC0.CFDRMPTR47.UINT16[L/H]
RCFDC0.CFDRMPTR47.UINT8[LL/LH/HH]
RCFDC0.CFDRMFDSTS47.UINT32
RCFDC0.CFDRMFDSTS47.UINT16[L/H]
RCFDC0.CFDRMFDSTS47.UINT8[LL/HL/HH]
RCFDC0.CFDRMDF0_47.UINT32
RCFDC0.CFDRMDF0_47.UINT16[L/H]
RCFDC0.CFDRMDF0_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF1_47.UINT32
RCFDC0.CFDRMDF1_47.UINT16[L/H]
RCFDC0.CFDRMDF1_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF2_47.UINT32
RCFDC0.CFDRMDF2_47.UINT16[L/H]
RCFDC0.CFDRMDF2_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF3_47.UINT32
RCFDC0.CFDRMDF3_47.UINT16[L/H]
RCFDC0.CFDRMDF3_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF4_47.UINT32
RCFDC0.CFDRMDF4_47.UINT16[L/H]
RCFDC0.CFDRMDF4_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF5_47.UINT32
RCFDC0.CFDRMDF5_47.UINT16[L/H]
RCFDC0.CFDRMDF5_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF6_47.UINT32
RCFDC0.CFDRMDF6_47.UINT16[L/H]
RCFDC0.CFDRMDF6_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF7_47.UINT32
RCFDC0.CFDRMDF7_47.UINT16[L/H]
RCFDC0.CFDRMDF7_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF8_47.UINT32
RCFDC0.CFDRMDF8_47.UINT16[L/H]
RCFDC0.CFDRMDF8_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF9_47.UINT32
RCFDC0.CFDRMDF9_47.UINT16[L/H]
RCFDC0.CFDRMDF9_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF10_47.UINT32
RCFDC0.CFDRMDF10_47.UINT16[L/H]
RCFDC0.CFDRMDF10_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF11_47.UINT32
RCFDC0.CFDRMDF11_47.UINT16[L/H]
RCFDC0.CFDRMDF11_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF12_47.UINT32
RCFDC0.CFDRMDF12_47.UINT16[L/H]
RCFDC0.CFDRMDF12_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF13_47.UINT32
RCFDC0.CFDRMDF13_47.UINT16[L/H]
RCFDC0.CFDRMDF13_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF14_47.UINT32
RCFDC0.CFDRMDF14_47.UINT16[L/H]
RCFDC0.CFDRMDF14_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRMDF15_47.UINT32
RCFDC0.CFDRMDF15_47.UINT16[L/H]
RCFDC0.CFDRMDF15_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFID0.UINT32
RCFDC0.CFDRFID0.UINT16[L/H]
RCFDC0.CFDRFID0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFPTR0.UINT32
RCFDC0.CFDRFPTR0.UINT16[L/H]
RCFDC0.CFDRFPTR0.UINT8[LL/LH/HH]
RCFDC0.CFDRFFDSTS0.UINT32
RCFDC0.CFDRFFDSTS0.UINT16[L/H]
RCFDC0.CFDRFFDSTS0.UINT8[LL/HL/HH]
RCFDC0.CFDRFDF0_0.UINT32
RCFDC0.CFDRFDF0_0.UINT16[L/H]
RCFDC0.CFDRFDF0_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF1_0.UINT32
RCFDC0.CFDRFDF1_0.UINT16[L/H]
RCFDC0.CFDRFDF1_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF2_0.UINT32
RCFDC0.CFDRFDF2_0.UINT16[L/H]
RCFDC0.CFDRFDF2_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF3_0.UINT32
RCFDC0.CFDRFDF3_0.UINT16[L/H]
RCFDC0.CFDRFDF3_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF4_0.UINT32
RCFDC0.CFDRFDF4_0.UINT16[L/H]
RCFDC0.CFDRFDF4_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF5_0.UINT32
RCFDC0.CFDRFDF5_0.UINT16[L/H]
RCFDC0.CFDRFDF5_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF6_0.UINT32
RCFDC0.CFDRFDF6_0.UINT16[L/H]
RCFDC0.CFDRFDF6_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF7_0.UINT32
RCFDC0.CFDRFDF7_0.UINT16[L/H]
RCFDC0.CFDRFDF7_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF8_0.UINT32
RCFDC0.CFDRFDF8_0.UINT16[L/H]
RCFDC0.CFDRFDF8_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF9_0.UINT32
RCFDC0.CFDRFDF9_0.UINT16[L/H]
RCFDC0.CFDRFDF9_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF10_0.UINT32
RCFDC0.CFDRFDF10_0.UINT16[L/H]
RCFDC0.CFDRFDF10_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF11_0.UINT32
RCFDC0.CFDRFDF11_0.UINT16[L/H]
RCFDC0.CFDRFDF11_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF12_0.UINT32
RCFDC0.CFDRFDF12_0.UINT16[L/H]
RCFDC0.CFDRFDF12_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF13_0.UINT32
RCFDC0.CFDRFDF13_0.UINT16[L/H]
RCFDC0.CFDRFDF13_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF14_0.UINT32
RCFDC0.CFDRFDF14_0.UINT16[L/H]
RCFDC0.CFDRFDF14_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF15_0.UINT32
RCFDC0.CFDRFDF15_0.UINT16[L/H]
RCFDC0.CFDRFDF15_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFID1.UINT32
RCFDC0.CFDRFID1.UINT16[L/H]
RCFDC0.CFDRFID1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFPTR1.UINT32
RCFDC0.CFDRFPTR1.UINT16[L/H]
RCFDC0.CFDRFPTR1.UINT8[LL/LH/HH]
RCFDC0.CFDRFFDSTS1.UINT32
RCFDC0.CFDRFFDSTS1.UINT16[L/H]
RCFDC0.CFDRFFDSTS1.UINT8[LL/HL/HH]
RCFDC0.CFDRFDF0_1.UINT32
RCFDC0.CFDRFDF0_1.UINT16[L/H]
RCFDC0.CFDRFDF0_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF1_1.UINT32
RCFDC0.CFDRFDF1_1.UINT16[L/H]
RCFDC0.CFDRFDF1_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF2_1.UINT32
RCFDC0.CFDRFDF2_1.UINT16[L/H]
RCFDC0.CFDRFDF2_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF3_1.UINT32
RCFDC0.CFDRFDF3_1.UINT16[L/H]
RCFDC0.CFDRFDF3_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF4_1.UINT32
RCFDC0.CFDRFDF4_1.UINT16[L/H]
RCFDC0.CFDRFDF4_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF5_1.UINT32
RCFDC0.CFDRFDF5_1.UINT16[L/H]
RCFDC0.CFDRFDF5_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF6_1.UINT32
RCFDC0.CFDRFDF6_1.UINT16[L/H]
RCFDC0.CFDRFDF6_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF7_1.UINT32
RCFDC0.CFDRFDF7_1.UINT16[L/H]
RCFDC0.CFDRFDF7_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF8_1.UINT32
RCFDC0.CFDRFDF8_1.UINT16[L/H]
RCFDC0.CFDRFDF8_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF9_1.UINT32
RCFDC0.CFDRFDF9_1.UINT16[L/H]
RCFDC0.CFDRFDF9_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF10_1.UINT32
RCFDC0.CFDRFDF10_1.UINT16[L/H]
RCFDC0.CFDRFDF10_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF11_1.UINT32
RCFDC0.CFDRFDF11_1.UINT16[L/H]
RCFDC0.CFDRFDF11_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF12_1.UINT32
RCFDC0.CFDRFDF12_1.UINT16[L/H]
RCFDC0.CFDRFDF12_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF13_1.UINT32
RCFDC0.CFDRFDF13_1.UINT16[L/H]
RCFDC0.CFDRFDF13_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF14_1.UINT32
RCFDC0.CFDRFDF14_1.UINT16[L/H]
RCFDC0.CFDRFDF14_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF15_1.UINT32
RCFDC0.CFDRFDF15_1.UINT16[L/H]
RCFDC0.CFDRFDF15_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFID2.UINT32
RCFDC0.CFDRFID2.UINT16[L/H]
RCFDC0.CFDRFID2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFPTR2.UINT32
RCFDC0.CFDRFPTR2.UINT16[L/H]
RCFDC0.CFDRFPTR2.UINT8[LL/LH/HH]
RCFDC0.CFDRFFDSTS2.UINT32
RCFDC0.CFDRFFDSTS2.UINT16[L/H]
RCFDC0.CFDRFFDSTS2.UINT8[LL/HL/HH]
RCFDC0.CFDRFDF0_2.UINT32
RCFDC0.CFDRFDF0_2.UINT16[L/H]
RCFDC0.CFDRFDF0_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF1_2.UINT32
RCFDC0.CFDRFDF1_2.UINT16[L/H]
RCFDC0.CFDRFDF1_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF2_2.UINT32
RCFDC0.CFDRFDF2_2.UINT16[L/H]
RCFDC0.CFDRFDF2_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF3_2.UINT32
RCFDC0.CFDRFDF3_2.UINT16[L/H]
RCFDC0.CFDRFDF3_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF4_2.UINT32
RCFDC0.CFDRFDF4_2.UINT16[L/H]
RCFDC0.CFDRFDF4_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF5_2.UINT32
RCFDC0.CFDRFDF5_2.UINT16[L/H]
RCFDC0.CFDRFDF5_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF6_2.UINT32
RCFDC0.CFDRFDF6_2.UINT16[L/H]
RCFDC0.CFDRFDF6_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF7_2.UINT32
RCFDC0.CFDRFDF7_2.UINT16[L/H]
RCFDC0.CFDRFDF7_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF8_2.UINT32
RCFDC0.CFDRFDF8_2.UINT16[L/H]
RCFDC0.CFDRFDF8_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF9_2.UINT32
RCFDC0.CFDRFDF9_2.UINT16[L/H]
RCFDC0.CFDRFDF9_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF10_2.UINT32
RCFDC0.CFDRFDF10_2.UINT16[L/H]
RCFDC0.CFDRFDF10_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF11_2.UINT32
RCFDC0.CFDRFDF11_2.UINT16[L/H]
RCFDC0.CFDRFDF11_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF12_2.UINT32
RCFDC0.CFDRFDF12_2.UINT16[L/H]
RCFDC0.CFDRFDF12_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF13_2.UINT32
RCFDC0.CFDRFDF13_2.UINT16[L/H]
RCFDC0.CFDRFDF13_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF14_2.UINT32
RCFDC0.CFDRFDF14_2.UINT16[L/H]
RCFDC0.CFDRFDF14_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF15_2.UINT32
RCFDC0.CFDRFDF15_2.UINT16[L/H]
RCFDC0.CFDRFDF15_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFID3.UINT32
RCFDC0.CFDRFID3.UINT16[L/H]
RCFDC0.CFDRFID3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFPTR3.UINT32
RCFDC0.CFDRFPTR3.UINT16[L/H]
RCFDC0.CFDRFPTR3.UINT8[LL/LH/HH]
RCFDC0.CFDRFFDSTS3.UINT32
RCFDC0.CFDRFFDSTS3.UINT16[L/H]
RCFDC0.CFDRFFDSTS3.UINT8[LL/HL/HH]
RCFDC0.CFDRFDF0_3.UINT32
RCFDC0.CFDRFDF0_3.UINT16[L/H]
RCFDC0.CFDRFDF0_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF1_3.UINT32
RCFDC0.CFDRFDF1_3.UINT16[L/H]
RCFDC0.CFDRFDF1_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF2_3.UINT32
RCFDC0.CFDRFDF2_3.UINT16[L/H]
RCFDC0.CFDRFDF2_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF3_3.UINT32
RCFDC0.CFDRFDF3_3.UINT16[L/H]
RCFDC0.CFDRFDF3_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF4_3.UINT32
RCFDC0.CFDRFDF4_3.UINT16[L/H]
RCFDC0.CFDRFDF4_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF5_3.UINT32
RCFDC0.CFDRFDF5_3.UINT16[L/H]
RCFDC0.CFDRFDF5_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF6_3.UINT32
RCFDC0.CFDRFDF6_3.UINT16[L/H]
RCFDC0.CFDRFDF6_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF7_3.UINT32
RCFDC0.CFDRFDF7_3.UINT16[L/H]
RCFDC0.CFDRFDF7_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF8_3.UINT32
RCFDC0.CFDRFDF8_3.UINT16[L/H]
RCFDC0.CFDRFDF8_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF9_3.UINT32
RCFDC0.CFDRFDF9_3.UINT16[L/H]
RCFDC0.CFDRFDF9_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF10_3.UINT32
RCFDC0.CFDRFDF10_3.UINT16[L/H]
RCFDC0.CFDRFDF10_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF11_3.UINT32
RCFDC0.CFDRFDF11_3.UINT16[L/H]
RCFDC0.CFDRFDF11_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF12_3.UINT32
RCFDC0.CFDRFDF12_3.UINT16[L/H]
RCFDC0.CFDRFDF12_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF13_3.UINT32
RCFDC0.CFDRFDF13_3.UINT16[L/H]
RCFDC0.CFDRFDF13_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF14_3.UINT32
RCFDC0.CFDRFDF14_3.UINT16[L/H]
RCFDC0.CFDRFDF14_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF15_3.UINT32
RCFDC0.CFDRFDF15_3.UINT16[L/H]
RCFDC0.CFDRFDF15_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFID4.UINT32
RCFDC0.CFDRFID4.UINT16[L/H]
RCFDC0.CFDRFID4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFPTR4.UINT32
RCFDC0.CFDRFPTR4.UINT16[L/H]
RCFDC0.CFDRFPTR4.UINT8[LL/LH/HH]
RCFDC0.CFDRFFDSTS4.UINT32
RCFDC0.CFDRFFDSTS4.UINT16[L/H]
RCFDC0.CFDRFFDSTS4.UINT8[LL/HL/HH]
RCFDC0.CFDRFDF0_4.UINT32
RCFDC0.CFDRFDF0_4.UINT16[L/H]
RCFDC0.CFDRFDF0_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF1_4.UINT32
RCFDC0.CFDRFDF1_4.UINT16[L/H]
RCFDC0.CFDRFDF1_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF2_4.UINT32
RCFDC0.CFDRFDF2_4.UINT16[L/H]
RCFDC0.CFDRFDF2_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF3_4.UINT32
RCFDC0.CFDRFDF3_4.UINT16[L/H]
RCFDC0.CFDRFDF3_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF4_4.UINT32
RCFDC0.CFDRFDF4_4.UINT16[L/H]
RCFDC0.CFDRFDF4_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF5_4.UINT32
RCFDC0.CFDRFDF5_4.UINT16[L/H]
RCFDC0.CFDRFDF5_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF6_4.UINT32
RCFDC0.CFDRFDF6_4.UINT16[L/H]
RCFDC0.CFDRFDF6_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF7_4.UINT32
RCFDC0.CFDRFDF7_4.UINT16[L/H]
RCFDC0.CFDRFDF7_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF8_4.UINT32
RCFDC0.CFDRFDF8_4.UINT16[L/H]
RCFDC0.CFDRFDF8_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF9_4.UINT32
RCFDC0.CFDRFDF9_4.UINT16[L/H]
RCFDC0.CFDRFDF9_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF10_4.UINT32
RCFDC0.CFDRFDF10_4.UINT16[L/H]
RCFDC0.CFDRFDF10_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF11_4.UINT32
RCFDC0.CFDRFDF11_4.UINT16[L/H]
RCFDC0.CFDRFDF11_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF12_4.UINT32
RCFDC0.CFDRFDF12_4.UINT16[L/H]
RCFDC0.CFDRFDF12_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF13_4.UINT32
RCFDC0.CFDRFDF13_4.UINT16[L/H]
RCFDC0.CFDRFDF13_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF14_4.UINT32
RCFDC0.CFDRFDF14_4.UINT16[L/H]
RCFDC0.CFDRFDF14_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF15_4.UINT32
RCFDC0.CFDRFDF15_4.UINT16[L/H]
RCFDC0.CFDRFDF15_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFID5.UINT32
RCFDC0.CFDRFID5.UINT16[L/H]
RCFDC0.CFDRFID5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFPTR5.UINT32
RCFDC0.CFDRFPTR5.UINT16[L/H]
RCFDC0.CFDRFPTR5.UINT8[LL/LH/HH]
RCFDC0.CFDRFFDSTS5.UINT32
RCFDC0.CFDRFFDSTS5.UINT16[L/H]
RCFDC0.CFDRFFDSTS5.UINT8[LL/HL/HH]
RCFDC0.CFDRFDF0_5.UINT32
RCFDC0.CFDRFDF0_5.UINT16[L/H]
RCFDC0.CFDRFDF0_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF1_5.UINT32
RCFDC0.CFDRFDF1_5.UINT16[L/H]
RCFDC0.CFDRFDF1_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF2_5.UINT32
RCFDC0.CFDRFDF2_5.UINT16[L/H]
RCFDC0.CFDRFDF2_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF3_5.UINT32
RCFDC0.CFDRFDF3_5.UINT16[L/H]
RCFDC0.CFDRFDF3_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF4_5.UINT32
RCFDC0.CFDRFDF4_5.UINT16[L/H]
RCFDC0.CFDRFDF4_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF5_5.UINT32
RCFDC0.CFDRFDF5_5.UINT16[L/H]
RCFDC0.CFDRFDF5_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF6_5.UINT32
RCFDC0.CFDRFDF6_5.UINT16[L/H]
RCFDC0.CFDRFDF6_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF7_5.UINT32
RCFDC0.CFDRFDF7_5.UINT16[L/H]
RCFDC0.CFDRFDF7_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF8_5.UINT32
RCFDC0.CFDRFDF8_5.UINT16[L/H]
RCFDC0.CFDRFDF8_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF9_5.UINT32
RCFDC0.CFDRFDF9_5.UINT16[L/H]
RCFDC0.CFDRFDF9_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF10_5.UINT32
RCFDC0.CFDRFDF10_5.UINT16[L/H]
RCFDC0.CFDRFDF10_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF11_5.UINT32
RCFDC0.CFDRFDF11_5.UINT16[L/H]
RCFDC0.CFDRFDF11_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF12_5.UINT32
RCFDC0.CFDRFDF12_5.UINT16[L/H]
RCFDC0.CFDRFDF12_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF13_5.UINT32
RCFDC0.CFDRFDF13_5.UINT16[L/H]
RCFDC0.CFDRFDF13_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF14_5.UINT32
RCFDC0.CFDRFDF14_5.UINT16[L/H]
RCFDC0.CFDRFDF14_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF15_5.UINT32
RCFDC0.CFDRFDF15_5.UINT16[L/H]
RCFDC0.CFDRFDF15_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFID6.UINT32
RCFDC0.CFDRFID6.UINT16[L/H]
RCFDC0.CFDRFID6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFPTR6.UINT32
RCFDC0.CFDRFPTR6.UINT16[L/H]
RCFDC0.CFDRFPTR6.UINT8[LL/LH/HH]
RCFDC0.CFDRFFDSTS6.UINT32
RCFDC0.CFDRFFDSTS6.UINT16[L/H]
RCFDC0.CFDRFFDSTS6.UINT8[LL/HL/HH]
RCFDC0.CFDRFDF0_6.UINT32
RCFDC0.CFDRFDF0_6.UINT16[L/H]
RCFDC0.CFDRFDF0_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF1_6.UINT32
RCFDC0.CFDRFDF1_6.UINT16[L/H]
RCFDC0.CFDRFDF1_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF2_6.UINT32
RCFDC0.CFDRFDF2_6.UINT16[L/H]
RCFDC0.CFDRFDF2_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF3_6.UINT32
RCFDC0.CFDRFDF3_6.UINT16[L/H]
RCFDC0.CFDRFDF3_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF4_6.UINT32
RCFDC0.CFDRFDF4_6.UINT16[L/H]
RCFDC0.CFDRFDF4_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF5_6.UINT32
RCFDC0.CFDRFDF5_6.UINT16[L/H]
RCFDC0.CFDRFDF5_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF6_6.UINT32
RCFDC0.CFDRFDF6_6.UINT16[L/H]
RCFDC0.CFDRFDF6_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF7_6.UINT32
RCFDC0.CFDRFDF7_6.UINT16[L/H]
RCFDC0.CFDRFDF7_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF8_6.UINT32
RCFDC0.CFDRFDF8_6.UINT16[L/H]
RCFDC0.CFDRFDF8_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF9_6.UINT32
RCFDC0.CFDRFDF9_6.UINT16[L/H]
RCFDC0.CFDRFDF9_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF10_6.UINT32
RCFDC0.CFDRFDF10_6.UINT16[L/H]
RCFDC0.CFDRFDF10_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF11_6.UINT32
RCFDC0.CFDRFDF11_6.UINT16[L/H]
RCFDC0.CFDRFDF11_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF12_6.UINT32
RCFDC0.CFDRFDF12_6.UINT16[L/H]
RCFDC0.CFDRFDF12_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF13_6.UINT32
RCFDC0.CFDRFDF13_6.UINT16[L/H]
RCFDC0.CFDRFDF13_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF14_6.UINT32
RCFDC0.CFDRFDF14_6.UINT16[L/H]
RCFDC0.CFDRFDF14_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF15_6.UINT32
RCFDC0.CFDRFDF15_6.UINT16[L/H]
RCFDC0.CFDRFDF15_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFID7.UINT32
RCFDC0.CFDRFID7.UINT16[L/H]
RCFDC0.CFDRFID7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFPTR7.UINT32
RCFDC0.CFDRFPTR7.UINT16[L/H]
RCFDC0.CFDRFPTR7.UINT8[LL/LH/HH]
RCFDC0.CFDRFFDSTS7.UINT32
RCFDC0.CFDRFFDSTS7.UINT16[L/H]
RCFDC0.CFDRFFDSTS7.UINT8[LL/HL/HH]
RCFDC0.CFDRFDF0_7.UINT32
RCFDC0.CFDRFDF0_7.UINT16[L/H]
RCFDC0.CFDRFDF0_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF1_7.UINT32
RCFDC0.CFDRFDF1_7.UINT16[L/H]
RCFDC0.CFDRFDF1_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF2_7.UINT32
RCFDC0.CFDRFDF2_7.UINT16[L/H]
RCFDC0.CFDRFDF2_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF3_7.UINT32
RCFDC0.CFDRFDF3_7.UINT16[L/H]
RCFDC0.CFDRFDF3_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF4_7.UINT32
RCFDC0.CFDRFDF4_7.UINT16[L/H]
RCFDC0.CFDRFDF4_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF5_7.UINT32
RCFDC0.CFDRFDF5_7.UINT16[L/H]
RCFDC0.CFDRFDF5_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF6_7.UINT32
RCFDC0.CFDRFDF6_7.UINT16[L/H]
RCFDC0.CFDRFDF6_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF7_7.UINT32
RCFDC0.CFDRFDF7_7.UINT16[L/H]
RCFDC0.CFDRFDF7_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF8_7.UINT32
RCFDC0.CFDRFDF8_7.UINT16[L/H]
RCFDC0.CFDRFDF8_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF9_7.UINT32
RCFDC0.CFDRFDF9_7.UINT16[L/H]
RCFDC0.CFDRFDF9_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF10_7.UINT32
RCFDC0.CFDRFDF10_7.UINT16[L/H]
RCFDC0.CFDRFDF10_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF11_7.UINT32
RCFDC0.CFDRFDF11_7.UINT16[L/H]
RCFDC0.CFDRFDF11_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF12_7.UINT32
RCFDC0.CFDRFDF12_7.UINT16[L/H]
RCFDC0.CFDRFDF12_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF13_7.UINT32
RCFDC0.CFDRFDF13_7.UINT16[L/H]
RCFDC0.CFDRFDF13_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF14_7.UINT32
RCFDC0.CFDRFDF14_7.UINT16[L/H]
RCFDC0.CFDRFDF14_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRFDF15_7.UINT32
RCFDC0.CFDRFDF15_7.UINT16[L/H]
RCFDC0.CFDRFDF15_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFID0.UINT32
RCFDC0.CFDCFID0.UINT16[L/H]
RCFDC0.CFDCFID0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFPTR0.UINT32
RCFDC0.CFDCFPTR0.UINT16[L/H]
RCFDC0.CFDCFPTR0.UINT8[LL/LH/HH]
RCFDC0.CFDCFFDCSTS0.UINT32
RCFDC0.CFDCFFDCSTS0.UINT16[L/H]
RCFDC0.CFDCFFDCSTS0.UINT8[LL/HL/HH]
RCFDC0.CFDCFDF0_0.UINT32
RCFDC0.CFDCFDF0_0.UINT16[L/H]
RCFDC0.CFDCFDF0_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF1_0.UINT32
RCFDC0.CFDCFDF1_0.UINT16[L/H]
RCFDC0.CFDCFDF1_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF2_0.UINT32
RCFDC0.CFDCFDF2_0.UINT16[L/H]
RCFDC0.CFDCFDF2_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF3_0.UINT32
RCFDC0.CFDCFDF3_0.UINT16[L/H]
RCFDC0.CFDCFDF3_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF4_0.UINT32
RCFDC0.CFDCFDF4_0.UINT16[L/H]
RCFDC0.CFDCFDF4_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF5_0.UINT32
RCFDC0.CFDCFDF5_0.UINT16[L/H]
RCFDC0.CFDCFDF5_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF6_0.UINT32
RCFDC0.CFDCFDF6_0.UINT16[L/H]
RCFDC0.CFDCFDF6_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF7_0.UINT32
RCFDC0.CFDCFDF7_0.UINT16[L/H]
RCFDC0.CFDCFDF7_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF8_0.UINT32
RCFDC0.CFDCFDF8_0.UINT16[L/H]
RCFDC0.CFDCFDF8_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF9_0.UINT32
RCFDC0.CFDCFDF9_0.UINT16[L/H]
RCFDC0.CFDCFDF9_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF10_0.UINT32
RCFDC0.CFDCFDF10_0.UINT16[L/H]
RCFDC0.CFDCFDF10_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF11_0.UINT32
RCFDC0.CFDCFDF11_0.UINT16[L/H]
RCFDC0.CFDCFDF11_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF12_0.UINT32
RCFDC0.CFDCFDF12_0.UINT16[L/H]
RCFDC0.CFDCFDF12_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF13_0.UINT32
RCFDC0.CFDCFDF13_0.UINT16[L/H]
RCFDC0.CFDCFDF13_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF14_0.UINT32
RCFDC0.CFDCFDF14_0.UINT16[L/H]
RCFDC0.CFDCFDF14_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF15_0.UINT32
RCFDC0.CFDCFDF15_0.UINT16[L/H]
RCFDC0.CFDCFDF15_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFID1.UINT32
RCFDC0.CFDCFID1.UINT16[L/H]
RCFDC0.CFDCFID1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFPTR1.UINT32
RCFDC0.CFDCFPTR1.UINT16[L/H]
RCFDC0.CFDCFPTR1.UINT8[LL/LH/HH]
RCFDC0.CFDCFFDCSTS1.UINT32
RCFDC0.CFDCFFDCSTS1.UINT16[L/H]
RCFDC0.CFDCFFDCSTS1.UINT8[LL/HL/HH]
RCFDC0.CFDCFDF0_1.UINT32
RCFDC0.CFDCFDF0_1.UINT16[L/H]
RCFDC0.CFDCFDF0_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF1_1.UINT32
RCFDC0.CFDCFDF1_1.UINT16[L/H]
RCFDC0.CFDCFDF1_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF2_1.UINT32
RCFDC0.CFDCFDF2_1.UINT16[L/H]
RCFDC0.CFDCFDF2_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF3_1.UINT32
RCFDC0.CFDCFDF3_1.UINT16[L/H]
RCFDC0.CFDCFDF3_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF4_1.UINT32
RCFDC0.CFDCFDF4_1.UINT16[L/H]
RCFDC0.CFDCFDF4_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF5_1.UINT32
RCFDC0.CFDCFDF5_1.UINT16[L/H]
RCFDC0.CFDCFDF5_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF6_1.UINT32
RCFDC0.CFDCFDF6_1.UINT16[L/H]
RCFDC0.CFDCFDF6_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF7_1.UINT32
RCFDC0.CFDCFDF7_1.UINT16[L/H]
RCFDC0.CFDCFDF7_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF8_1.UINT32
RCFDC0.CFDCFDF8_1.UINT16[L/H]
RCFDC0.CFDCFDF8_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF9_1.UINT32
RCFDC0.CFDCFDF9_1.UINT16[L/H]
RCFDC0.CFDCFDF9_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF10_1.UINT32
RCFDC0.CFDCFDF10_1.UINT16[L/H]
RCFDC0.CFDCFDF10_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF11_1.UINT32
RCFDC0.CFDCFDF11_1.UINT16[L/H]
RCFDC0.CFDCFDF11_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF12_1.UINT32
RCFDC0.CFDCFDF12_1.UINT16[L/H]
RCFDC0.CFDCFDF12_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF13_1.UINT32
RCFDC0.CFDCFDF13_1.UINT16[L/H]
RCFDC0.CFDCFDF13_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF14_1.UINT32
RCFDC0.CFDCFDF14_1.UINT16[L/H]
RCFDC0.CFDCFDF14_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF15_1.UINT32
RCFDC0.CFDCFDF15_1.UINT16[L/H]
RCFDC0.CFDCFDF15_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFID2.UINT32
RCFDC0.CFDCFID2.UINT16[L/H]
RCFDC0.CFDCFID2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFPTR2.UINT32
RCFDC0.CFDCFPTR2.UINT16[L/H]
RCFDC0.CFDCFPTR2.UINT8[LL/LH/HH]
RCFDC0.CFDCFFDCSTS2.UINT32
RCFDC0.CFDCFFDCSTS2.UINT16[L/H]
RCFDC0.CFDCFFDCSTS2.UINT8[LL/HL/HH]
RCFDC0.CFDCFDF0_2.UINT32
RCFDC0.CFDCFDF0_2.UINT16[L/H]
RCFDC0.CFDCFDF0_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF1_2.UINT32
RCFDC0.CFDCFDF1_2.UINT16[L/H]
RCFDC0.CFDCFDF1_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF2_2.UINT32
RCFDC0.CFDCFDF2_2.UINT16[L/H]
RCFDC0.CFDCFDF2_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF3_2.UINT32
RCFDC0.CFDCFDF3_2.UINT16[L/H]
RCFDC0.CFDCFDF3_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF4_2.UINT32
RCFDC0.CFDCFDF4_2.UINT16[L/H]
RCFDC0.CFDCFDF4_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF5_2.UINT32
RCFDC0.CFDCFDF5_2.UINT16[L/H]
RCFDC0.CFDCFDF5_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF6_2.UINT32
RCFDC0.CFDCFDF6_2.UINT16[L/H]
RCFDC0.CFDCFDF6_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF7_2.UINT32
RCFDC0.CFDCFDF7_2.UINT16[L/H]
RCFDC0.CFDCFDF7_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF8_2.UINT32
RCFDC0.CFDCFDF8_2.UINT16[L/H]
RCFDC0.CFDCFDF8_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF9_2.UINT32
RCFDC0.CFDCFDF9_2.UINT16[L/H]
RCFDC0.CFDCFDF9_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF10_2.UINT32
RCFDC0.CFDCFDF10_2.UINT16[L/H]
RCFDC0.CFDCFDF10_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF11_2.UINT32
RCFDC0.CFDCFDF11_2.UINT16[L/H]
RCFDC0.CFDCFDF11_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF12_2.UINT32
RCFDC0.CFDCFDF12_2.UINT16[L/H]
RCFDC0.CFDCFDF12_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF13_2.UINT32
RCFDC0.CFDCFDF13_2.UINT16[L/H]
RCFDC0.CFDCFDF13_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF14_2.UINT32
RCFDC0.CFDCFDF14_2.UINT16[L/H]
RCFDC0.CFDCFDF14_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF15_2.UINT32
RCFDC0.CFDCFDF15_2.UINT16[L/H]
RCFDC0.CFDCFDF15_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFID3.UINT32
RCFDC0.CFDCFID3.UINT16[L/H]
RCFDC0.CFDCFID3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFPTR3.UINT32
RCFDC0.CFDCFPTR3.UINT16[L/H]
RCFDC0.CFDCFPTR3.UINT8[LL/LH/HH]
RCFDC0.CFDCFFDCSTS3.UINT32
RCFDC0.CFDCFFDCSTS3.UINT16[L/H]
RCFDC0.CFDCFFDCSTS3.UINT8[LL/HL/HH]
RCFDC0.CFDCFDF0_3.UINT32
RCFDC0.CFDCFDF0_3.UINT16[L/H]
RCFDC0.CFDCFDF0_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF1_3.UINT32
RCFDC0.CFDCFDF1_3.UINT16[L/H]
RCFDC0.CFDCFDF1_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF2_3.UINT32
RCFDC0.CFDCFDF2_3.UINT16[L/H]
RCFDC0.CFDCFDF2_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF3_3.UINT32
RCFDC0.CFDCFDF3_3.UINT16[L/H]
RCFDC0.CFDCFDF3_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF4_3.UINT32
RCFDC0.CFDCFDF4_3.UINT16[L/H]
RCFDC0.CFDCFDF4_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF5_3.UINT32
RCFDC0.CFDCFDF5_3.UINT16[L/H]
RCFDC0.CFDCFDF5_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF6_3.UINT32
RCFDC0.CFDCFDF6_3.UINT16[L/H]
RCFDC0.CFDCFDF6_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF7_3.UINT32
RCFDC0.CFDCFDF7_3.UINT16[L/H]
RCFDC0.CFDCFDF7_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF8_3.UINT32
RCFDC0.CFDCFDF8_3.UINT16[L/H]
RCFDC0.CFDCFDF8_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF9_3.UINT32
RCFDC0.CFDCFDF9_3.UINT16[L/H]
RCFDC0.CFDCFDF9_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF10_3.UINT32
RCFDC0.CFDCFDF10_3.UINT16[L/H]
RCFDC0.CFDCFDF10_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF11_3.UINT32
RCFDC0.CFDCFDF11_3.UINT16[L/H]
RCFDC0.CFDCFDF11_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF12_3.UINT32
RCFDC0.CFDCFDF12_3.UINT16[L/H]
RCFDC0.CFDCFDF12_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF13_3.UINT32
RCFDC0.CFDCFDF13_3.UINT16[L/H]
RCFDC0.CFDCFDF13_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF14_3.UINT32
RCFDC0.CFDCFDF14_3.UINT16[L/H]
RCFDC0.CFDCFDF14_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF15_3.UINT32
RCFDC0.CFDCFDF15_3.UINT16[L/H]
RCFDC0.CFDCFDF15_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFID4.UINT32
RCFDC0.CFDCFID4.UINT16[L/H]
RCFDC0.CFDCFID4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFPTR4.UINT32
RCFDC0.CFDCFPTR4.UINT16[L/H]
RCFDC0.CFDCFPTR4.UINT8[LL/LH/HH]
RCFDC0.CFDCFFDCSTS4.UINT32
RCFDC0.CFDCFFDCSTS4.UINT16[L/H]
RCFDC0.CFDCFFDCSTS4.UINT8[LL/HL/HH]
RCFDC0.CFDCFDF0_4.UINT32
RCFDC0.CFDCFDF0_4.UINT16[L/H]
RCFDC0.CFDCFDF0_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF1_4.UINT32
RCFDC0.CFDCFDF1_4.UINT16[L/H]
RCFDC0.CFDCFDF1_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF2_4.UINT32
RCFDC0.CFDCFDF2_4.UINT16[L/H]
RCFDC0.CFDCFDF2_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF3_4.UINT32
RCFDC0.CFDCFDF3_4.UINT16[L/H]
RCFDC0.CFDCFDF3_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF4_4.UINT32
RCFDC0.CFDCFDF4_4.UINT16[L/H]
RCFDC0.CFDCFDF4_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF5_4.UINT32
RCFDC0.CFDCFDF5_4.UINT16[L/H]
RCFDC0.CFDCFDF5_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF6_4.UINT32
RCFDC0.CFDCFDF6_4.UINT16[L/H]
RCFDC0.CFDCFDF6_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF7_4.UINT32
RCFDC0.CFDCFDF7_4.UINT16[L/H]
RCFDC0.CFDCFDF7_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF8_4.UINT32
RCFDC0.CFDCFDF8_4.UINT16[L/H]
RCFDC0.CFDCFDF8_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF9_4.UINT32
RCFDC0.CFDCFDF9_4.UINT16[L/H]
RCFDC0.CFDCFDF9_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF10_4.UINT32
RCFDC0.CFDCFDF10_4.UINT16[L/H]
RCFDC0.CFDCFDF10_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF11_4.UINT32
RCFDC0.CFDCFDF11_4.UINT16[L/H]
RCFDC0.CFDCFDF11_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF12_4.UINT32
RCFDC0.CFDCFDF12_4.UINT16[L/H]
RCFDC0.CFDCFDF12_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF13_4.UINT32
RCFDC0.CFDCFDF13_4.UINT16[L/H]
RCFDC0.CFDCFDF13_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF14_4.UINT32
RCFDC0.CFDCFDF14_4.UINT16[L/H]
RCFDC0.CFDCFDF14_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF15_4.UINT32
RCFDC0.CFDCFDF15_4.UINT16[L/H]
RCFDC0.CFDCFDF15_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFID5.UINT32
RCFDC0.CFDCFID5.UINT16[L/H]
RCFDC0.CFDCFID5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFPTR5.UINT32
RCFDC0.CFDCFPTR5.UINT16[L/H]
RCFDC0.CFDCFPTR5.UINT8[LL/LH/HH]
RCFDC0.CFDCFFDCSTS5.UINT32
RCFDC0.CFDCFFDCSTS5.UINT16[L/H]
RCFDC0.CFDCFFDCSTS5.UINT8[LL/HL/HH]
RCFDC0.CFDCFDF0_5.UINT32
RCFDC0.CFDCFDF0_5.UINT16[L/H]
RCFDC0.CFDCFDF0_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF1_5.UINT32
RCFDC0.CFDCFDF1_5.UINT16[L/H]
RCFDC0.CFDCFDF1_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF2_5.UINT32
RCFDC0.CFDCFDF2_5.UINT16[L/H]
RCFDC0.CFDCFDF2_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF3_5.UINT32
RCFDC0.CFDCFDF3_5.UINT16[L/H]
RCFDC0.CFDCFDF3_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF4_5.UINT32
RCFDC0.CFDCFDF4_5.UINT16[L/H]
RCFDC0.CFDCFDF4_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF5_5.UINT32
RCFDC0.CFDCFDF5_5.UINT16[L/H]
RCFDC0.CFDCFDF5_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF6_5.UINT32
RCFDC0.CFDCFDF6_5.UINT16[L/H]
RCFDC0.CFDCFDF6_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF7_5.UINT32
RCFDC0.CFDCFDF7_5.UINT16[L/H]
RCFDC0.CFDCFDF7_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF8_5.UINT32
RCFDC0.CFDCFDF8_5.UINT16[L/H]
RCFDC0.CFDCFDF8_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF9_5.UINT32
RCFDC0.CFDCFDF9_5.UINT16[L/H]
RCFDC0.CFDCFDF9_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF10_5.UINT32
RCFDC0.CFDCFDF10_5.UINT16[L/H]
RCFDC0.CFDCFDF10_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF11_5.UINT32
RCFDC0.CFDCFDF11_5.UINT16[L/H]
RCFDC0.CFDCFDF11_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF12_5.UINT32
RCFDC0.CFDCFDF12_5.UINT16[L/H]
RCFDC0.CFDCFDF12_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF13_5.UINT32
RCFDC0.CFDCFDF13_5.UINT16[L/H]
RCFDC0.CFDCFDF13_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF14_5.UINT32
RCFDC0.CFDCFDF14_5.UINT16[L/H]
RCFDC0.CFDCFDF14_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF15_5.UINT32
RCFDC0.CFDCFDF15_5.UINT16[L/H]
RCFDC0.CFDCFDF15_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFID6.UINT32
RCFDC0.CFDCFID6.UINT16[L/H]
RCFDC0.CFDCFID6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFPTR6.UINT32
RCFDC0.CFDCFPTR6.UINT16[L/H]
RCFDC0.CFDCFPTR6.UINT8[LL/LH/HH]
RCFDC0.CFDCFFDCSTS6.UINT32
RCFDC0.CFDCFFDCSTS6.UINT16[L/H]
RCFDC0.CFDCFFDCSTS6.UINT8[LL/HL/HH]
RCFDC0.CFDCFDF0_6.UINT32
RCFDC0.CFDCFDF0_6.UINT16[L/H]
RCFDC0.CFDCFDF0_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF1_6.UINT32
RCFDC0.CFDCFDF1_6.UINT16[L/H]
RCFDC0.CFDCFDF1_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF2_6.UINT32
RCFDC0.CFDCFDF2_6.UINT16[L/H]
RCFDC0.CFDCFDF2_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF3_6.UINT32
RCFDC0.CFDCFDF3_6.UINT16[L/H]
RCFDC0.CFDCFDF3_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF4_6.UINT32
RCFDC0.CFDCFDF4_6.UINT16[L/H]
RCFDC0.CFDCFDF4_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF5_6.UINT32
RCFDC0.CFDCFDF5_6.UINT16[L/H]
RCFDC0.CFDCFDF5_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF6_6.UINT32
RCFDC0.CFDCFDF6_6.UINT16[L/H]
RCFDC0.CFDCFDF6_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF7_6.UINT32
RCFDC0.CFDCFDF7_6.UINT16[L/H]
RCFDC0.CFDCFDF7_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF8_6.UINT32
RCFDC0.CFDCFDF8_6.UINT16[L/H]
RCFDC0.CFDCFDF8_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF9_6.UINT32
RCFDC0.CFDCFDF9_6.UINT16[L/H]
RCFDC0.CFDCFDF9_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF10_6.UINT32
RCFDC0.CFDCFDF10_6.UINT16[L/H]
RCFDC0.CFDCFDF10_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF11_6.UINT32
RCFDC0.CFDCFDF11_6.UINT16[L/H]
RCFDC0.CFDCFDF11_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF12_6.UINT32
RCFDC0.CFDCFDF12_6.UINT16[L/H]
RCFDC0.CFDCFDF12_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF13_6.UINT32
RCFDC0.CFDCFDF13_6.UINT16[L/H]
RCFDC0.CFDCFDF13_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF14_6.UINT32
RCFDC0.CFDCFDF14_6.UINT16[L/H]
RCFDC0.CFDCFDF14_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF15_6.UINT32
RCFDC0.CFDCFDF15_6.UINT16[L/H]
RCFDC0.CFDCFDF15_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFID7.UINT32
RCFDC0.CFDCFID7.UINT16[L/H]
RCFDC0.CFDCFID7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFPTR7.UINT32
RCFDC0.CFDCFPTR7.UINT16[L/H]
RCFDC0.CFDCFPTR7.UINT8[LL/LH/HH]
RCFDC0.CFDCFFDCSTS7.UINT32
RCFDC0.CFDCFFDCSTS7.UINT16[L/H]
RCFDC0.CFDCFFDCSTS7.UINT8[LL/HL/HH]
RCFDC0.CFDCFDF0_7.UINT32
RCFDC0.CFDCFDF0_7.UINT16[L/H]
RCFDC0.CFDCFDF0_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF1_7.UINT32
RCFDC0.CFDCFDF1_7.UINT16[L/H]
RCFDC0.CFDCFDF1_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF2_7.UINT32
RCFDC0.CFDCFDF2_7.UINT16[L/H]
RCFDC0.CFDCFDF2_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF3_7.UINT32
RCFDC0.CFDCFDF3_7.UINT16[L/H]
RCFDC0.CFDCFDF3_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF4_7.UINT32
RCFDC0.CFDCFDF4_7.UINT16[L/H]
RCFDC0.CFDCFDF4_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF5_7.UINT32
RCFDC0.CFDCFDF5_7.UINT16[L/H]
RCFDC0.CFDCFDF5_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF6_7.UINT32
RCFDC0.CFDCFDF6_7.UINT16[L/H]
RCFDC0.CFDCFDF6_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF7_7.UINT32
RCFDC0.CFDCFDF7_7.UINT16[L/H]
RCFDC0.CFDCFDF7_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF8_7.UINT32
RCFDC0.CFDCFDF8_7.UINT16[L/H]
RCFDC0.CFDCFDF8_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF9_7.UINT32
RCFDC0.CFDCFDF9_7.UINT16[L/H]
RCFDC0.CFDCFDF9_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF10_7.UINT32
RCFDC0.CFDCFDF10_7.UINT16[L/H]
RCFDC0.CFDCFDF10_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF11_7.UINT32
RCFDC0.CFDCFDF11_7.UINT16[L/H]
RCFDC0.CFDCFDF11_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF12_7.UINT32
RCFDC0.CFDCFDF12_7.UINT16[L/H]
RCFDC0.CFDCFDF12_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF13_7.UINT32
RCFDC0.CFDCFDF13_7.UINT16[L/H]
RCFDC0.CFDCFDF13_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF14_7.UINT32
RCFDC0.CFDCFDF14_7.UINT16[L/H]
RCFDC0.CFDCFDF14_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF15_7.UINT32
RCFDC0.CFDCFDF15_7.UINT16[L/H]
RCFDC0.CFDCFDF15_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFID8.UINT32
RCFDC0.CFDCFID8.UINT16[L/H]
RCFDC0.CFDCFID8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFPTR8.UINT32
RCFDC0.CFDCFPTR8.UINT16[L/H]
RCFDC0.CFDCFPTR8.UINT8[LL/LH/HH]
RCFDC0.CFDCFFDCSTS8.UINT32
RCFDC0.CFDCFFDCSTS8.UINT16[L/H]
RCFDC0.CFDCFFDCSTS8.UINT8[LL/HL/HH]
RCFDC0.CFDCFDF0_8.UINT32
RCFDC0.CFDCFDF0_8.UINT16[L/H]
RCFDC0.CFDCFDF0_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF1_8.UINT32
RCFDC0.CFDCFDF1_8.UINT16[L/H]
RCFDC0.CFDCFDF1_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF2_8.UINT32
RCFDC0.CFDCFDF2_8.UINT16[L/H]
RCFDC0.CFDCFDF2_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF3_8.UINT32
RCFDC0.CFDCFDF3_8.UINT16[L/H]
RCFDC0.CFDCFDF3_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF4_8.UINT32
RCFDC0.CFDCFDF4_8.UINT16[L/H]
RCFDC0.CFDCFDF4_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF5_8.UINT32
RCFDC0.CFDCFDF5_8.UINT16[L/H]
RCFDC0.CFDCFDF5_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF6_8.UINT32
RCFDC0.CFDCFDF6_8.UINT16[L/H]
RCFDC0.CFDCFDF6_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF7_8.UINT32
RCFDC0.CFDCFDF7_8.UINT16[L/H]
RCFDC0.CFDCFDF7_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF8_8.UINT32
RCFDC0.CFDCFDF8_8.UINT16[L/H]
RCFDC0.CFDCFDF8_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF9_8.UINT32
RCFDC0.CFDCFDF9_8.UINT16[L/H]
RCFDC0.CFDCFDF9_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF10_8.UINT32
RCFDC0.CFDCFDF10_8.UINT16[L/H]
RCFDC0.CFDCFDF10_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF11_8.UINT32
RCFDC0.CFDCFDF11_8.UINT16[L/H]
RCFDC0.CFDCFDF11_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF12_8.UINT32
RCFDC0.CFDCFDF12_8.UINT16[L/H]
RCFDC0.CFDCFDF12_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF13_8.UINT32
RCFDC0.CFDCFDF13_8.UINT16[L/H]
RCFDC0.CFDCFDF13_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF14_8.UINT32
RCFDC0.CFDCFDF14_8.UINT16[L/H]
RCFDC0.CFDCFDF14_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDCFDF15_8.UINT32
RCFDC0.CFDCFDF15_8.UINT16[L/H]
RCFDC0.CFDCFDF15_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID0.UINT32
RCFDC0.CFDTMID0.UINT16[L/H]
RCFDC0.CFDTMID0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR0.UINT32
RCFDC0.CFDTMPTR0.UINT16[H]
RCFDC0.CFDTMPTR0.UINT8[HH]
RCFDC0.CFDTMFDCTR0.UINT32
RCFDC0.CFDTMFDCTR0.UINT16[L/H]
RCFDC0.CFDTMFDCTR0.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_0.UINT32
RCFDC0.CFDTMDF0_0.UINT16[L/H]
RCFDC0.CFDTMDF0_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_0.UINT32
RCFDC0.CFDTMDF1_0.UINT16[L/H]
RCFDC0.CFDTMDF1_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_0.UINT32
RCFDC0.CFDTMDF2_0.UINT16[L/H]
RCFDC0.CFDTMDF2_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_0.UINT32
RCFDC0.CFDTMDF3_0.UINT16[L/H]
RCFDC0.CFDTMDF3_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_0.UINT32
RCFDC0.CFDTMDF4_0.UINT16[L/H]
RCFDC0.CFDTMDF4_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_0.UINT32
RCFDC0.CFDTMDF5_0.UINT16[L/H]
RCFDC0.CFDTMDF5_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_0.UINT32
RCFDC0.CFDTMDF6_0.UINT16[L/H]
RCFDC0.CFDTMDF6_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_0.UINT32
RCFDC0.CFDTMDF7_0.UINT16[L/H]
RCFDC0.CFDTMDF7_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_0.UINT32
RCFDC0.CFDTMDF8_0.UINT16[L/H]
RCFDC0.CFDTMDF8_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_0.UINT32
RCFDC0.CFDTMDF9_0.UINT16[L/H]
RCFDC0.CFDTMDF9_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_0.UINT32
RCFDC0.CFDTMDF10_0.UINT16[L/H]
RCFDC0.CFDTMDF10_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_0.UINT32
RCFDC0.CFDTMDF11_0.UINT16[L/H]
RCFDC0.CFDTMDF11_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_0.UINT32
RCFDC0.CFDTMDF12_0.UINT16[L/H]
RCFDC0.CFDTMDF12_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_0.UINT32
RCFDC0.CFDTMDF13_0.UINT16[L/H]
RCFDC0.CFDTMDF13_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_0.UINT32
RCFDC0.CFDTMDF14_0.UINT16[L/H]
RCFDC0.CFDTMDF14_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_0.UINT32
RCFDC0.CFDTMDF15_0.UINT16[L/H]
RCFDC0.CFDTMDF15_0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID1.UINT32
RCFDC0.CFDTMID1.UINT16[L/H]
RCFDC0.CFDTMID1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR1.UINT32
RCFDC0.CFDTMPTR1.UINT16[H]
RCFDC0.CFDTMPTR1.UINT8[HH]
RCFDC0.CFDTMFDCTR1.UINT32
RCFDC0.CFDTMFDCTR1.UINT16[L/H]
RCFDC0.CFDTMFDCTR1.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_1.UINT32
RCFDC0.CFDTMDF0_1.UINT16[L/H]
RCFDC0.CFDTMDF0_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_1.UINT32
RCFDC0.CFDTMDF1_1.UINT16[L/H]
RCFDC0.CFDTMDF1_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_1.UINT32
RCFDC0.CFDTMDF2_1.UINT16[L/H]
RCFDC0.CFDTMDF2_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_1.UINT32
RCFDC0.CFDTMDF3_1.UINT16[L/H]
RCFDC0.CFDTMDF3_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_1.UINT32
RCFDC0.CFDTMDF4_1.UINT16[L/H]
RCFDC0.CFDTMDF4_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_1.UINT32
RCFDC0.CFDTMDF5_1.UINT16[L/H]
RCFDC0.CFDTMDF5_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_1.UINT32
RCFDC0.CFDTMDF6_1.UINT16[L/H]
RCFDC0.CFDTMDF6_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_1.UINT32
RCFDC0.CFDTMDF7_1.UINT16[L/H]
RCFDC0.CFDTMDF7_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_1.UINT32
RCFDC0.CFDTMDF8_1.UINT16[L/H]
RCFDC0.CFDTMDF8_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_1.UINT32
RCFDC0.CFDTMDF9_1.UINT16[L/H]
RCFDC0.CFDTMDF9_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_1.UINT32
RCFDC0.CFDTMDF10_1.UINT16[L/H]
RCFDC0.CFDTMDF10_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_1.UINT32
RCFDC0.CFDTMDF11_1.UINT16[L/H]
RCFDC0.CFDTMDF11_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_1.UINT32
RCFDC0.CFDTMDF12_1.UINT16[L/H]
RCFDC0.CFDTMDF12_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_1.UINT32
RCFDC0.CFDTMDF13_1.UINT16[L/H]
RCFDC0.CFDTMDF13_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_1.UINT32
RCFDC0.CFDTMDF14_1.UINT16[L/H]
RCFDC0.CFDTMDF14_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_1.UINT32
RCFDC0.CFDTMDF15_1.UINT16[L/H]
RCFDC0.CFDTMDF15_1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID2.UINT32
RCFDC0.CFDTMID2.UINT16[L/H]
RCFDC0.CFDTMID2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR2.UINT32
RCFDC0.CFDTMPTR2.UINT16[H]
RCFDC0.CFDTMPTR2.UINT8[HH]
RCFDC0.CFDTMFDCTR2.UINT32
RCFDC0.CFDTMFDCTR2.UINT16[L/H]
RCFDC0.CFDTMFDCTR2.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_2.UINT32
RCFDC0.CFDTMDF0_2.UINT16[L/H]
RCFDC0.CFDTMDF0_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_2.UINT32
RCFDC0.CFDTMDF1_2.UINT16[L/H]
RCFDC0.CFDTMDF1_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_2.UINT32
RCFDC0.CFDTMDF2_2.UINT16[L/H]
RCFDC0.CFDTMDF2_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_2.UINT32
RCFDC0.CFDTMDF3_2.UINT16[L/H]
RCFDC0.CFDTMDF3_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_2.UINT32
RCFDC0.CFDTMDF4_2.UINT16[L/H]
RCFDC0.CFDTMDF4_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_2.UINT32
RCFDC0.CFDTMDF5_2.UINT16[L/H]
RCFDC0.CFDTMDF5_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_2.UINT32
RCFDC0.CFDTMDF6_2.UINT16[L/H]
RCFDC0.CFDTMDF6_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_2.UINT32
RCFDC0.CFDTMDF7_2.UINT16[L/H]
RCFDC0.CFDTMDF7_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_2.UINT32
RCFDC0.CFDTMDF8_2.UINT16[L/H]
RCFDC0.CFDTMDF8_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_2.UINT32
RCFDC0.CFDTMDF9_2.UINT16[L/H]
RCFDC0.CFDTMDF9_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_2.UINT32
RCFDC0.CFDTMDF10_2.UINT16[L/H]
RCFDC0.CFDTMDF10_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_2.UINT32
RCFDC0.CFDTMDF11_2.UINT16[L/H]
RCFDC0.CFDTMDF11_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_2.UINT32
RCFDC0.CFDTMDF12_2.UINT16[L/H]
RCFDC0.CFDTMDF12_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_2.UINT32
RCFDC0.CFDTMDF13_2.UINT16[L/H]
RCFDC0.CFDTMDF13_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_2.UINT32
RCFDC0.CFDTMDF14_2.UINT16[L/H]
RCFDC0.CFDTMDF14_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_2.UINT32
RCFDC0.CFDTMDF15_2.UINT16[L/H]
RCFDC0.CFDTMDF15_2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID3.UINT32
RCFDC0.CFDTMID3.UINT16[L/H]
RCFDC0.CFDTMID3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR3.UINT32
RCFDC0.CFDTMPTR3.UINT16[H]
RCFDC0.CFDTMPTR3.UINT8[HH]
RCFDC0.CFDTMFDCTR3.UINT32
RCFDC0.CFDTMFDCTR3.UINT16[L/H]
RCFDC0.CFDTMFDCTR3.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_3.UINT32
RCFDC0.CFDTMDF0_3.UINT16[L/H]
RCFDC0.CFDTMDF0_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_3.UINT32
RCFDC0.CFDTMDF1_3.UINT16[L/H]
RCFDC0.CFDTMDF1_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_3.UINT32
RCFDC0.CFDTMDF2_3.UINT16[L/H]
RCFDC0.CFDTMDF2_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_3.UINT32
RCFDC0.CFDTMDF3_3.UINT16[L/H]
RCFDC0.CFDTMDF3_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_3.UINT32
RCFDC0.CFDTMDF4_3.UINT16[L/H]
RCFDC0.CFDTMDF4_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_3.UINT32
RCFDC0.CFDTMDF5_3.UINT16[L/H]
RCFDC0.CFDTMDF5_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_3.UINT32
RCFDC0.CFDTMDF6_3.UINT16[L/H]
RCFDC0.CFDTMDF6_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_3.UINT32
RCFDC0.CFDTMDF7_3.UINT16[L/H]
RCFDC0.CFDTMDF7_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_3.UINT32
RCFDC0.CFDTMDF8_3.UINT16[L/H]
RCFDC0.CFDTMDF8_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_3.UINT32
RCFDC0.CFDTMDF9_3.UINT16[L/H]
RCFDC0.CFDTMDF9_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_3.UINT32
RCFDC0.CFDTMDF10_3.UINT16[L/H]
RCFDC0.CFDTMDF10_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_3.UINT32
RCFDC0.CFDTMDF11_3.UINT16[L/H]
RCFDC0.CFDTMDF11_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_3.UINT32
RCFDC0.CFDTMDF12_3.UINT16[L/H]
RCFDC0.CFDTMDF12_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_3.UINT32
RCFDC0.CFDTMDF13_3.UINT16[L/H]
RCFDC0.CFDTMDF13_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_3.UINT32
RCFDC0.CFDTMDF14_3.UINT16[L/H]
RCFDC0.CFDTMDF14_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_3.UINT32
RCFDC0.CFDTMDF15_3.UINT16[L/H]
RCFDC0.CFDTMDF15_3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID4.UINT32
RCFDC0.CFDTMID4.UINT16[L/H]
RCFDC0.CFDTMID4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR4.UINT32
RCFDC0.CFDTMPTR4.UINT16[H]
RCFDC0.CFDTMPTR4.UINT8[HH]
RCFDC0.CFDTMFDCTR4.UINT32
RCFDC0.CFDTMFDCTR4.UINT16[L/H]
RCFDC0.CFDTMFDCTR4.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_4.UINT32
RCFDC0.CFDTMDF0_4.UINT16[L/H]
RCFDC0.CFDTMDF0_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_4.UINT32
RCFDC0.CFDTMDF1_4.UINT16[L/H]
RCFDC0.CFDTMDF1_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_4.UINT32
RCFDC0.CFDTMDF2_4.UINT16[L/H]
RCFDC0.CFDTMDF2_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_4.UINT32
RCFDC0.CFDTMDF3_4.UINT16[L/H]
RCFDC0.CFDTMDF3_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_4.UINT32
RCFDC0.CFDTMDF4_4.UINT16[L/H]
RCFDC0.CFDTMDF4_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_4.UINT32
RCFDC0.CFDTMDF5_4.UINT16[L/H]
RCFDC0.CFDTMDF5_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_4.UINT32
RCFDC0.CFDTMDF6_4.UINT16[L/H]
RCFDC0.CFDTMDF6_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_4.UINT32
RCFDC0.CFDTMDF7_4.UINT16[L/H]
RCFDC0.CFDTMDF7_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_4.UINT32
RCFDC0.CFDTMDF8_4.UINT16[L/H]
RCFDC0.CFDTMDF8_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_4.UINT32
RCFDC0.CFDTMDF9_4.UINT16[L/H]
RCFDC0.CFDTMDF9_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_4.UINT32
RCFDC0.CFDTMDF10_4.UINT16[L/H]
RCFDC0.CFDTMDF10_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_4.UINT32
RCFDC0.CFDTMDF11_4.UINT16[L/H]
RCFDC0.CFDTMDF11_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_4.UINT32
RCFDC0.CFDTMDF12_4.UINT16[L/H]
RCFDC0.CFDTMDF12_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_4.UINT32
RCFDC0.CFDTMDF13_4.UINT16[L/H]
RCFDC0.CFDTMDF13_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_4.UINT32
RCFDC0.CFDTMDF14_4.UINT16[L/H]
RCFDC0.CFDTMDF14_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_4.UINT32
RCFDC0.CFDTMDF15_4.UINT16[L/H]
RCFDC0.CFDTMDF15_4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID5.UINT32
RCFDC0.CFDTMID5.UINT16[L/H]
RCFDC0.CFDTMID5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR5.UINT32
RCFDC0.CFDTMPTR5.UINT16[H]
RCFDC0.CFDTMPTR5.UINT8[HH]
RCFDC0.CFDTMFDCTR5.UINT32
RCFDC0.CFDTMFDCTR5.UINT16[L/H]
RCFDC0.CFDTMFDCTR5.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_5.UINT32
RCFDC0.CFDTMDF0_5.UINT16[L/H]
RCFDC0.CFDTMDF0_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_5.UINT32
RCFDC0.CFDTMDF1_5.UINT16[L/H]
RCFDC0.CFDTMDF1_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_5.UINT32
RCFDC0.CFDTMDF2_5.UINT16[L/H]
RCFDC0.CFDTMDF2_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_5.UINT32
RCFDC0.CFDTMDF3_5.UINT16[L/H]
RCFDC0.CFDTMDF3_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_5.UINT32
RCFDC0.CFDTMDF4_5.UINT16[L/H]
RCFDC0.CFDTMDF4_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_5.UINT32
RCFDC0.CFDTMDF5_5.UINT16[L/H]
RCFDC0.CFDTMDF5_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_5.UINT32
RCFDC0.CFDTMDF6_5.UINT16[L/H]
RCFDC0.CFDTMDF6_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_5.UINT32
RCFDC0.CFDTMDF7_5.UINT16[L/H]
RCFDC0.CFDTMDF7_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_5.UINT32
RCFDC0.CFDTMDF8_5.UINT16[L/H]
RCFDC0.CFDTMDF8_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_5.UINT32
RCFDC0.CFDTMDF9_5.UINT16[L/H]
RCFDC0.CFDTMDF9_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_5.UINT32
RCFDC0.CFDTMDF10_5.UINT16[L/H]
RCFDC0.CFDTMDF10_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_5.UINT32
RCFDC0.CFDTMDF11_5.UINT16[L/H]
RCFDC0.CFDTMDF11_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_5.UINT32
RCFDC0.CFDTMDF12_5.UINT16[L/H]
RCFDC0.CFDTMDF12_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_5.UINT32
RCFDC0.CFDTMDF13_5.UINT16[L/H]
RCFDC0.CFDTMDF13_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_5.UINT32
RCFDC0.CFDTMDF14_5.UINT16[L/H]
RCFDC0.CFDTMDF14_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_5.UINT32
RCFDC0.CFDTMDF15_5.UINT16[L/H]
RCFDC0.CFDTMDF15_5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID6.UINT32
RCFDC0.CFDTMID6.UINT16[L/H]
RCFDC0.CFDTMID6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR6.UINT32
RCFDC0.CFDTMPTR6.UINT16[H]
RCFDC0.CFDTMPTR6.UINT8[HH]
RCFDC0.CFDTMFDCTR6.UINT32
RCFDC0.CFDTMFDCTR6.UINT16[L/H]
RCFDC0.CFDTMFDCTR6.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_6.UINT32
RCFDC0.CFDTMDF0_6.UINT16[L/H]
RCFDC0.CFDTMDF0_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_6.UINT32
RCFDC0.CFDTMDF1_6.UINT16[L/H]
RCFDC0.CFDTMDF1_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_6.UINT32
RCFDC0.CFDTMDF2_6.UINT16[L/H]
RCFDC0.CFDTMDF2_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_6.UINT32
RCFDC0.CFDTMDF3_6.UINT16[L/H]
RCFDC0.CFDTMDF3_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_6.UINT32
RCFDC0.CFDTMDF4_6.UINT16[L/H]
RCFDC0.CFDTMDF4_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_6.UINT32
RCFDC0.CFDTMDF5_6.UINT16[L/H]
RCFDC0.CFDTMDF5_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_6.UINT32
RCFDC0.CFDTMDF6_6.UINT16[L/H]
RCFDC0.CFDTMDF6_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_6.UINT32
RCFDC0.CFDTMDF7_6.UINT16[L/H]
RCFDC0.CFDTMDF7_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_6.UINT32
RCFDC0.CFDTMDF8_6.UINT16[L/H]
RCFDC0.CFDTMDF8_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_6.UINT32
RCFDC0.CFDTMDF9_6.UINT16[L/H]
RCFDC0.CFDTMDF9_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_6.UINT32
RCFDC0.CFDTMDF10_6.UINT16[L/H]
RCFDC0.CFDTMDF10_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_6.UINT32
RCFDC0.CFDTMDF11_6.UINT16[L/H]
RCFDC0.CFDTMDF11_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_6.UINT32
RCFDC0.CFDTMDF12_6.UINT16[L/H]
RCFDC0.CFDTMDF12_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_6.UINT32
RCFDC0.CFDTMDF13_6.UINT16[L/H]
RCFDC0.CFDTMDF13_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_6.UINT32
RCFDC0.CFDTMDF14_6.UINT16[L/H]
RCFDC0.CFDTMDF14_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_6.UINT32
RCFDC0.CFDTMDF15_6.UINT16[L/H]
RCFDC0.CFDTMDF15_6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID7.UINT32
RCFDC0.CFDTMID7.UINT16[L/H]
RCFDC0.CFDTMID7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR7.UINT32
RCFDC0.CFDTMPTR7.UINT16[H]
RCFDC0.CFDTMPTR7.UINT8[HH]
RCFDC0.CFDTMFDCTR7.UINT32
RCFDC0.CFDTMFDCTR7.UINT16[L/H]
RCFDC0.CFDTMFDCTR7.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_7.UINT32
RCFDC0.CFDTMDF0_7.UINT16[L/H]
RCFDC0.CFDTMDF0_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_7.UINT32
RCFDC0.CFDTMDF1_7.UINT16[L/H]
RCFDC0.CFDTMDF1_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_7.UINT32
RCFDC0.CFDTMDF2_7.UINT16[L/H]
RCFDC0.CFDTMDF2_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_7.UINT32
RCFDC0.CFDTMDF3_7.UINT16[L/H]
RCFDC0.CFDTMDF3_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_7.UINT32
RCFDC0.CFDTMDF4_7.UINT16[L/H]
RCFDC0.CFDTMDF4_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_7.UINT32
RCFDC0.CFDTMDF5_7.UINT16[L/H]
RCFDC0.CFDTMDF5_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_7.UINT32
RCFDC0.CFDTMDF6_7.UINT16[L/H]
RCFDC0.CFDTMDF6_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_7.UINT32
RCFDC0.CFDTMDF7_7.UINT16[L/H]
RCFDC0.CFDTMDF7_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_7.UINT32
RCFDC0.CFDTMDF8_7.UINT16[L/H]
RCFDC0.CFDTMDF8_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_7.UINT32
RCFDC0.CFDTMDF9_7.UINT16[L/H]
RCFDC0.CFDTMDF9_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_7.UINT32
RCFDC0.CFDTMDF10_7.UINT16[L/H]
RCFDC0.CFDTMDF10_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_7.UINT32
RCFDC0.CFDTMDF11_7.UINT16[L/H]
RCFDC0.CFDTMDF11_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_7.UINT32
RCFDC0.CFDTMDF12_7.UINT16[L/H]
RCFDC0.CFDTMDF12_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_7.UINT32
RCFDC0.CFDTMDF13_7.UINT16[L/H]
RCFDC0.CFDTMDF13_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_7.UINT32
RCFDC0.CFDTMDF14_7.UINT16[L/H]
RCFDC0.CFDTMDF14_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_7.UINT32
RCFDC0.CFDTMDF15_7.UINT16[L/H]
RCFDC0.CFDTMDF15_7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID8.UINT32
RCFDC0.CFDTMID8.UINT16[L/H]
RCFDC0.CFDTMID8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR8.UINT32
RCFDC0.CFDTMPTR8.UINT16[H]
RCFDC0.CFDTMPTR8.UINT8[HH]
RCFDC0.CFDTMFDCTR8.UINT32
RCFDC0.CFDTMFDCTR8.UINT16[L/H]
RCFDC0.CFDTMFDCTR8.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_8.UINT32
RCFDC0.CFDTMDF0_8.UINT16[L/H]
RCFDC0.CFDTMDF0_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_8.UINT32
RCFDC0.CFDTMDF1_8.UINT16[L/H]
RCFDC0.CFDTMDF1_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_8.UINT32
RCFDC0.CFDTMDF2_8.UINT16[L/H]
RCFDC0.CFDTMDF2_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_8.UINT32
RCFDC0.CFDTMDF3_8.UINT16[L/H]
RCFDC0.CFDTMDF3_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_8.UINT32
RCFDC0.CFDTMDF4_8.UINT16[L/H]
RCFDC0.CFDTMDF4_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_8.UINT32
RCFDC0.CFDTMDF5_8.UINT16[L/H]
RCFDC0.CFDTMDF5_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_8.UINT32
RCFDC0.CFDTMDF6_8.UINT16[L/H]
RCFDC0.CFDTMDF6_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_8.UINT32
RCFDC0.CFDTMDF7_8.UINT16[L/H]
RCFDC0.CFDTMDF7_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_8.UINT32
RCFDC0.CFDTMDF8_8.UINT16[L/H]
RCFDC0.CFDTMDF8_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_8.UINT32
RCFDC0.CFDTMDF9_8.UINT16[L/H]
RCFDC0.CFDTMDF9_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_8.UINT32
RCFDC0.CFDTMDF10_8.UINT16[L/H]
RCFDC0.CFDTMDF10_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_8.UINT32
RCFDC0.CFDTMDF11_8.UINT16[L/H]
RCFDC0.CFDTMDF11_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_8.UINT32
RCFDC0.CFDTMDF12_8.UINT16[L/H]
RCFDC0.CFDTMDF12_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_8.UINT32
RCFDC0.CFDTMDF13_8.UINT16[L/H]
RCFDC0.CFDTMDF13_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_8.UINT32
RCFDC0.CFDTMDF14_8.UINT16[L/H]
RCFDC0.CFDTMDF14_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_8.UINT32
RCFDC0.CFDTMDF15_8.UINT16[L/H]
RCFDC0.CFDTMDF15_8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID9.UINT32
RCFDC0.CFDTMID9.UINT16[L/H]
RCFDC0.CFDTMID9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR9.UINT32
RCFDC0.CFDTMPTR9.UINT16[H]
RCFDC0.CFDTMPTR9.UINT8[HH]
RCFDC0.CFDTMFDCTR9.UINT32
RCFDC0.CFDTMFDCTR9.UINT16[L/H]
RCFDC0.CFDTMFDCTR9.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_9.UINT32
RCFDC0.CFDTMDF0_9.UINT16[L/H]
RCFDC0.CFDTMDF0_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_9.UINT32
RCFDC0.CFDTMDF1_9.UINT16[L/H]
RCFDC0.CFDTMDF1_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_9.UINT32
RCFDC0.CFDTMDF2_9.UINT16[L/H]
RCFDC0.CFDTMDF2_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_9.UINT32
RCFDC0.CFDTMDF3_9.UINT16[L/H]
RCFDC0.CFDTMDF3_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_9.UINT32
RCFDC0.CFDTMDF4_9.UINT16[L/H]
RCFDC0.CFDTMDF4_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_9.UINT32
RCFDC0.CFDTMDF5_9.UINT16[L/H]
RCFDC0.CFDTMDF5_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_9.UINT32
RCFDC0.CFDTMDF6_9.UINT16[L/H]
RCFDC0.CFDTMDF6_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_9.UINT32
RCFDC0.CFDTMDF7_9.UINT16[L/H]
RCFDC0.CFDTMDF7_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_9.UINT32
RCFDC0.CFDTMDF8_9.UINT16[L/H]
RCFDC0.CFDTMDF8_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_9.UINT32
RCFDC0.CFDTMDF9_9.UINT16[L/H]
RCFDC0.CFDTMDF9_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_9.UINT32
RCFDC0.CFDTMDF10_9.UINT16[L/H]
RCFDC0.CFDTMDF10_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_9.UINT32
RCFDC0.CFDTMDF11_9.UINT16[L/H]
RCFDC0.CFDTMDF11_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_9.UINT32
RCFDC0.CFDTMDF12_9.UINT16[L/H]
RCFDC0.CFDTMDF12_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_9.UINT32
RCFDC0.CFDTMDF13_9.UINT16[L/H]
RCFDC0.CFDTMDF13_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_9.UINT32
RCFDC0.CFDTMDF14_9.UINT16[L/H]
RCFDC0.CFDTMDF14_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_9.UINT32
RCFDC0.CFDTMDF15_9.UINT16[L/H]
RCFDC0.CFDTMDF15_9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID10.UINT32
RCFDC0.CFDTMID10.UINT16[L/H]
RCFDC0.CFDTMID10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR10.UINT32
RCFDC0.CFDTMPTR10.UINT16[H]
RCFDC0.CFDTMPTR10.UINT8[HH]
RCFDC0.CFDTMFDCTR10.UINT32
RCFDC0.CFDTMFDCTR10.UINT16[L/H]
RCFDC0.CFDTMFDCTR10.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_10.UINT32
RCFDC0.CFDTMDF0_10.UINT16[L/H]
RCFDC0.CFDTMDF0_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_10.UINT32
RCFDC0.CFDTMDF1_10.UINT16[L/H]
RCFDC0.CFDTMDF1_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_10.UINT32
RCFDC0.CFDTMDF2_10.UINT16[L/H]
RCFDC0.CFDTMDF2_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_10.UINT32
RCFDC0.CFDTMDF3_10.UINT16[L/H]
RCFDC0.CFDTMDF3_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_10.UINT32
RCFDC0.CFDTMDF4_10.UINT16[L/H]
RCFDC0.CFDTMDF4_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_10.UINT32
RCFDC0.CFDTMDF5_10.UINT16[L/H]
RCFDC0.CFDTMDF5_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_10.UINT32
RCFDC0.CFDTMDF6_10.UINT16[L/H]
RCFDC0.CFDTMDF6_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_10.UINT32
RCFDC0.CFDTMDF7_10.UINT16[L/H]
RCFDC0.CFDTMDF7_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_10.UINT32
RCFDC0.CFDTMDF8_10.UINT16[L/H]
RCFDC0.CFDTMDF8_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_10.UINT32
RCFDC0.CFDTMDF9_10.UINT16[L/H]
RCFDC0.CFDTMDF9_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_10.UINT32
RCFDC0.CFDTMDF10_10.UINT16[L/H]
RCFDC0.CFDTMDF10_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_10.UINT32
RCFDC0.CFDTMDF11_10.UINT16[L/H]
RCFDC0.CFDTMDF11_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_10.UINT32
RCFDC0.CFDTMDF12_10.UINT16[L/H]
RCFDC0.CFDTMDF12_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_10.UINT32
RCFDC0.CFDTMDF13_10.UINT16[L/H]
RCFDC0.CFDTMDF13_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_10.UINT32
RCFDC0.CFDTMDF14_10.UINT16[L/H]
RCFDC0.CFDTMDF14_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_10.UINT32
RCFDC0.CFDTMDF15_10.UINT16[L/H]
RCFDC0.CFDTMDF15_10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID11.UINT32
RCFDC0.CFDTMID11.UINT16[L/H]
RCFDC0.CFDTMID11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR11.UINT32
RCFDC0.CFDTMPTR11.UINT16[H]
RCFDC0.CFDTMPTR11.UINT8[HH]
RCFDC0.CFDTMFDCTR11.UINT32
RCFDC0.CFDTMFDCTR11.UINT16[L/H]
RCFDC0.CFDTMFDCTR11.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_11.UINT32
RCFDC0.CFDTMDF0_11.UINT16[L/H]
RCFDC0.CFDTMDF0_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_11.UINT32
RCFDC0.CFDTMDF1_11.UINT16[L/H]
RCFDC0.CFDTMDF1_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_11.UINT32
RCFDC0.CFDTMDF2_11.UINT16[L/H]
RCFDC0.CFDTMDF2_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_11.UINT32
RCFDC0.CFDTMDF3_11.UINT16[L/H]
RCFDC0.CFDTMDF3_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_11.UINT32
RCFDC0.CFDTMDF4_11.UINT16[L/H]
RCFDC0.CFDTMDF4_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_11.UINT32
RCFDC0.CFDTMDF5_11.UINT16[L/H]
RCFDC0.CFDTMDF5_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_11.UINT32
RCFDC0.CFDTMDF6_11.UINT16[L/H]
RCFDC0.CFDTMDF6_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_11.UINT32
RCFDC0.CFDTMDF7_11.UINT16[L/H]
RCFDC0.CFDTMDF7_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_11.UINT32
RCFDC0.CFDTMDF8_11.UINT16[L/H]
RCFDC0.CFDTMDF8_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_11.UINT32
RCFDC0.CFDTMDF9_11.UINT16[L/H]
RCFDC0.CFDTMDF9_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_11.UINT32
RCFDC0.CFDTMDF10_11.UINT16[L/H]
RCFDC0.CFDTMDF10_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_11.UINT32
RCFDC0.CFDTMDF11_11.UINT16[L/H]
RCFDC0.CFDTMDF11_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_11.UINT32
RCFDC0.CFDTMDF12_11.UINT16[L/H]
RCFDC0.CFDTMDF12_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_11.UINT32
RCFDC0.CFDTMDF13_11.UINT16[L/H]
RCFDC0.CFDTMDF13_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_11.UINT32
RCFDC0.CFDTMDF14_11.UINT16[L/H]
RCFDC0.CFDTMDF14_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_11.UINT32
RCFDC0.CFDTMDF15_11.UINT16[L/H]
RCFDC0.CFDTMDF15_11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID12.UINT32
RCFDC0.CFDTMID12.UINT16[L/H]
RCFDC0.CFDTMID12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR12.UINT32
RCFDC0.CFDTMPTR12.UINT16[H]
RCFDC0.CFDTMPTR12.UINT8[HH]
RCFDC0.CFDTMFDCTR12.UINT32
RCFDC0.CFDTMFDCTR12.UINT16[L/H]
RCFDC0.CFDTMFDCTR12.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_12.UINT32
RCFDC0.CFDTMDF0_12.UINT16[L/H]
RCFDC0.CFDTMDF0_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_12.UINT32
RCFDC0.CFDTMDF1_12.UINT16[L/H]
RCFDC0.CFDTMDF1_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_12.UINT32
RCFDC0.CFDTMDF2_12.UINT16[L/H]
RCFDC0.CFDTMDF2_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_12.UINT32
RCFDC0.CFDTMDF3_12.UINT16[L/H]
RCFDC0.CFDTMDF3_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_12.UINT32
RCFDC0.CFDTMDF4_12.UINT16[L/H]
RCFDC0.CFDTMDF4_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_12.UINT32
RCFDC0.CFDTMDF5_12.UINT16[L/H]
RCFDC0.CFDTMDF5_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_12.UINT32
RCFDC0.CFDTMDF6_12.UINT16[L/H]
RCFDC0.CFDTMDF6_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_12.UINT32
RCFDC0.CFDTMDF7_12.UINT16[L/H]
RCFDC0.CFDTMDF7_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_12.UINT32
RCFDC0.CFDTMDF8_12.UINT16[L/H]
RCFDC0.CFDTMDF8_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_12.UINT32
RCFDC0.CFDTMDF9_12.UINT16[L/H]
RCFDC0.CFDTMDF9_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_12.UINT32
RCFDC0.CFDTMDF10_12.UINT16[L/H]
RCFDC0.CFDTMDF10_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_12.UINT32
RCFDC0.CFDTMDF11_12.UINT16[L/H]
RCFDC0.CFDTMDF11_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_12.UINT32
RCFDC0.CFDTMDF12_12.UINT16[L/H]
RCFDC0.CFDTMDF12_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_12.UINT32
RCFDC0.CFDTMDF13_12.UINT16[L/H]
RCFDC0.CFDTMDF13_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_12.UINT32
RCFDC0.CFDTMDF14_12.UINT16[L/H]
RCFDC0.CFDTMDF14_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_12.UINT32
RCFDC0.CFDTMDF15_12.UINT16[L/H]
RCFDC0.CFDTMDF15_12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID13.UINT32
RCFDC0.CFDTMID13.UINT16[L/H]
RCFDC0.CFDTMID13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR13.UINT32
RCFDC0.CFDTMPTR13.UINT16[H]
RCFDC0.CFDTMPTR13.UINT8[HH]
RCFDC0.CFDTMFDCTR13.UINT32
RCFDC0.CFDTMFDCTR13.UINT16[L/H]
RCFDC0.CFDTMFDCTR13.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_13.UINT32
RCFDC0.CFDTMDF0_13.UINT16[L/H]
RCFDC0.CFDTMDF0_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_13.UINT32
RCFDC0.CFDTMDF1_13.UINT16[L/H]
RCFDC0.CFDTMDF1_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_13.UINT32
RCFDC0.CFDTMDF2_13.UINT16[L/H]
RCFDC0.CFDTMDF2_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_13.UINT32
RCFDC0.CFDTMDF3_13.UINT16[L/H]
RCFDC0.CFDTMDF3_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_13.UINT32
RCFDC0.CFDTMDF4_13.UINT16[L/H]
RCFDC0.CFDTMDF4_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_13.UINT32
RCFDC0.CFDTMDF5_13.UINT16[L/H]
RCFDC0.CFDTMDF5_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_13.UINT32
RCFDC0.CFDTMDF6_13.UINT16[L/H]
RCFDC0.CFDTMDF6_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_13.UINT32
RCFDC0.CFDTMDF7_13.UINT16[L/H]
RCFDC0.CFDTMDF7_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_13.UINT32
RCFDC0.CFDTMDF8_13.UINT16[L/H]
RCFDC0.CFDTMDF8_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_13.UINT32
RCFDC0.CFDTMDF9_13.UINT16[L/H]
RCFDC0.CFDTMDF9_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_13.UINT32
RCFDC0.CFDTMDF10_13.UINT16[L/H]
RCFDC0.CFDTMDF10_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_13.UINT32
RCFDC0.CFDTMDF11_13.UINT16[L/H]
RCFDC0.CFDTMDF11_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_13.UINT32
RCFDC0.CFDTMDF12_13.UINT16[L/H]
RCFDC0.CFDTMDF12_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_13.UINT32
RCFDC0.CFDTMDF13_13.UINT16[L/H]
RCFDC0.CFDTMDF13_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_13.UINT32
RCFDC0.CFDTMDF14_13.UINT16[L/H]
RCFDC0.CFDTMDF14_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_13.UINT32
RCFDC0.CFDTMDF15_13.UINT16[L/H]
RCFDC0.CFDTMDF15_13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID14.UINT32
RCFDC0.CFDTMID14.UINT16[L/H]
RCFDC0.CFDTMID14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR14.UINT32
RCFDC0.CFDTMPTR14.UINT16[H]
RCFDC0.CFDTMPTR14.UINT8[HH]
RCFDC0.CFDTMFDCTR14.UINT32
RCFDC0.CFDTMFDCTR14.UINT16[L/H]
RCFDC0.CFDTMFDCTR14.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_14.UINT32
RCFDC0.CFDTMDF0_14.UINT16[L/H]
RCFDC0.CFDTMDF0_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_14.UINT32
RCFDC0.CFDTMDF1_14.UINT16[L/H]
RCFDC0.CFDTMDF1_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_14.UINT32
RCFDC0.CFDTMDF2_14.UINT16[L/H]
RCFDC0.CFDTMDF2_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_14.UINT32
RCFDC0.CFDTMDF3_14.UINT16[L/H]
RCFDC0.CFDTMDF3_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_14.UINT32
RCFDC0.CFDTMDF4_14.UINT16[L/H]
RCFDC0.CFDTMDF4_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_14.UINT32
RCFDC0.CFDTMDF5_14.UINT16[L/H]
RCFDC0.CFDTMDF5_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_14.UINT32
RCFDC0.CFDTMDF6_14.UINT16[L/H]
RCFDC0.CFDTMDF6_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_14.UINT32
RCFDC0.CFDTMDF7_14.UINT16[L/H]
RCFDC0.CFDTMDF7_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_14.UINT32
RCFDC0.CFDTMDF8_14.UINT16[L/H]
RCFDC0.CFDTMDF8_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_14.UINT32
RCFDC0.CFDTMDF9_14.UINT16[L/H]
RCFDC0.CFDTMDF9_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_14.UINT32
RCFDC0.CFDTMDF10_14.UINT16[L/H]
RCFDC0.CFDTMDF10_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_14.UINT32
RCFDC0.CFDTMDF11_14.UINT16[L/H]
RCFDC0.CFDTMDF11_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_14.UINT32
RCFDC0.CFDTMDF12_14.UINT16[L/H]
RCFDC0.CFDTMDF12_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_14.UINT32
RCFDC0.CFDTMDF13_14.UINT16[L/H]
RCFDC0.CFDTMDF13_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_14.UINT32
RCFDC0.CFDTMDF14_14.UINT16[L/H]
RCFDC0.CFDTMDF14_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_14.UINT32
RCFDC0.CFDTMDF15_14.UINT16[L/H]
RCFDC0.CFDTMDF15_14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID15.UINT32
RCFDC0.CFDTMID15.UINT16[L/H]
RCFDC0.CFDTMID15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR15.UINT32
RCFDC0.CFDTMPTR15.UINT16[H]
RCFDC0.CFDTMPTR15.UINT8[HH]
RCFDC0.CFDTMFDCTR15.UINT32
RCFDC0.CFDTMFDCTR15.UINT16[L/H]
RCFDC0.CFDTMFDCTR15.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_15.UINT32
RCFDC0.CFDTMDF0_15.UINT16[L/H]
RCFDC0.CFDTMDF0_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_15.UINT32
RCFDC0.CFDTMDF1_15.UINT16[L/H]
RCFDC0.CFDTMDF1_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_15.UINT32
RCFDC0.CFDTMDF2_15.UINT16[L/H]
RCFDC0.CFDTMDF2_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_15.UINT32
RCFDC0.CFDTMDF3_15.UINT16[L/H]
RCFDC0.CFDTMDF3_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_15.UINT32
RCFDC0.CFDTMDF4_15.UINT16[L/H]
RCFDC0.CFDTMDF4_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_15.UINT32
RCFDC0.CFDTMDF5_15.UINT16[L/H]
RCFDC0.CFDTMDF5_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_15.UINT32
RCFDC0.CFDTMDF6_15.UINT16[L/H]
RCFDC0.CFDTMDF6_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_15.UINT32
RCFDC0.CFDTMDF7_15.UINT16[L/H]
RCFDC0.CFDTMDF7_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_15.UINT32
RCFDC0.CFDTMDF8_15.UINT16[L/H]
RCFDC0.CFDTMDF8_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_15.UINT32
RCFDC0.CFDTMDF9_15.UINT16[L/H]
RCFDC0.CFDTMDF9_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_15.UINT32
RCFDC0.CFDTMDF10_15.UINT16[L/H]
RCFDC0.CFDTMDF10_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_15.UINT32
RCFDC0.CFDTMDF11_15.UINT16[L/H]
RCFDC0.CFDTMDF11_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_15.UINT32
RCFDC0.CFDTMDF12_15.UINT16[L/H]
RCFDC0.CFDTMDF12_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_15.UINT32
RCFDC0.CFDTMDF13_15.UINT16[L/H]
RCFDC0.CFDTMDF13_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_15.UINT32
RCFDC0.CFDTMDF14_15.UINT16[L/H]
RCFDC0.CFDTMDF14_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_15.UINT32
RCFDC0.CFDTMDF15_15.UINT16[L/H]
RCFDC0.CFDTMDF15_15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID16.UINT32
RCFDC0.CFDTMID16.UINT16[L/H]
RCFDC0.CFDTMID16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR16.UINT32
RCFDC0.CFDTMPTR16.UINT16[H]
RCFDC0.CFDTMPTR16.UINT8[HH]
RCFDC0.CFDTMFDCTR16.UINT32
RCFDC0.CFDTMFDCTR16.UINT16[L/H]
RCFDC0.CFDTMFDCTR16.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_16.UINT32
RCFDC0.CFDTMDF0_16.UINT16[L/H]
RCFDC0.CFDTMDF0_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_16.UINT32
RCFDC0.CFDTMDF1_16.UINT16[L/H]
RCFDC0.CFDTMDF1_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_16.UINT32
RCFDC0.CFDTMDF2_16.UINT16[L/H]
RCFDC0.CFDTMDF2_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_16.UINT32
RCFDC0.CFDTMDF3_16.UINT16[L/H]
RCFDC0.CFDTMDF3_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_16.UINT32
RCFDC0.CFDTMDF4_16.UINT16[L/H]
RCFDC0.CFDTMDF4_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_16.UINT32
RCFDC0.CFDTMDF5_16.UINT16[L/H]
RCFDC0.CFDTMDF5_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_16.UINT32
RCFDC0.CFDTMDF6_16.UINT16[L/H]
RCFDC0.CFDTMDF6_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_16.UINT32
RCFDC0.CFDTMDF7_16.UINT16[L/H]
RCFDC0.CFDTMDF7_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_16.UINT32
RCFDC0.CFDTMDF8_16.UINT16[L/H]
RCFDC0.CFDTMDF8_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_16.UINT32
RCFDC0.CFDTMDF9_16.UINT16[L/H]
RCFDC0.CFDTMDF9_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_16.UINT32
RCFDC0.CFDTMDF10_16.UINT16[L/H]
RCFDC0.CFDTMDF10_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_16.UINT32
RCFDC0.CFDTMDF11_16.UINT16[L/H]
RCFDC0.CFDTMDF11_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_16.UINT32
RCFDC0.CFDTMDF12_16.UINT16[L/H]
RCFDC0.CFDTMDF12_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_16.UINT32
RCFDC0.CFDTMDF13_16.UINT16[L/H]
RCFDC0.CFDTMDF13_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_16.UINT32
RCFDC0.CFDTMDF14_16.UINT16[L/H]
RCFDC0.CFDTMDF14_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_16.UINT32
RCFDC0.CFDTMDF15_16.UINT16[L/H]
RCFDC0.CFDTMDF15_16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID17.UINT32
RCFDC0.CFDTMID17.UINT16[L/H]
RCFDC0.CFDTMID17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR17.UINT32
RCFDC0.CFDTMPTR17.UINT16[H]
RCFDC0.CFDTMPTR17.UINT8[HH]
RCFDC0.CFDTMFDCTR17.UINT32
RCFDC0.CFDTMFDCTR17.UINT16[L/H]
RCFDC0.CFDTMFDCTR17.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_17.UINT32
RCFDC0.CFDTMDF0_17.UINT16[L/H]
RCFDC0.CFDTMDF0_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_17.UINT32
RCFDC0.CFDTMDF1_17.UINT16[L/H]
RCFDC0.CFDTMDF1_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_17.UINT32
RCFDC0.CFDTMDF2_17.UINT16[L/H]
RCFDC0.CFDTMDF2_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_17.UINT32
RCFDC0.CFDTMDF3_17.UINT16[L/H]
RCFDC0.CFDTMDF3_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_17.UINT32
RCFDC0.CFDTMDF4_17.UINT16[L/H]
RCFDC0.CFDTMDF4_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_17.UINT32
RCFDC0.CFDTMDF5_17.UINT16[L/H]
RCFDC0.CFDTMDF5_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_17.UINT32
RCFDC0.CFDTMDF6_17.UINT16[L/H]
RCFDC0.CFDTMDF6_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_17.UINT32
RCFDC0.CFDTMDF7_17.UINT16[L/H]
RCFDC0.CFDTMDF7_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_17.UINT32
RCFDC0.CFDTMDF8_17.UINT16[L/H]
RCFDC0.CFDTMDF8_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_17.UINT32
RCFDC0.CFDTMDF9_17.UINT16[L/H]
RCFDC0.CFDTMDF9_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_17.UINT32
RCFDC0.CFDTMDF10_17.UINT16[L/H]
RCFDC0.CFDTMDF10_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_17.UINT32
RCFDC0.CFDTMDF11_17.UINT16[L/H]
RCFDC0.CFDTMDF11_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_17.UINT32
RCFDC0.CFDTMDF12_17.UINT16[L/H]
RCFDC0.CFDTMDF12_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_17.UINT32
RCFDC0.CFDTMDF13_17.UINT16[L/H]
RCFDC0.CFDTMDF13_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_17.UINT32
RCFDC0.CFDTMDF14_17.UINT16[L/H]
RCFDC0.CFDTMDF14_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_17.UINT32
RCFDC0.CFDTMDF15_17.UINT16[L/H]
RCFDC0.CFDTMDF15_17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID18.UINT32
RCFDC0.CFDTMID18.UINT16[L/H]
RCFDC0.CFDTMID18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR18.UINT32
RCFDC0.CFDTMPTR18.UINT16[H]
RCFDC0.CFDTMPTR18.UINT8[HH]
RCFDC0.CFDTMFDCTR18.UINT32
RCFDC0.CFDTMFDCTR18.UINT16[L/H]
RCFDC0.CFDTMFDCTR18.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_18.UINT32
RCFDC0.CFDTMDF0_18.UINT16[L/H]
RCFDC0.CFDTMDF0_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_18.UINT32
RCFDC0.CFDTMDF1_18.UINT16[L/H]
RCFDC0.CFDTMDF1_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_18.UINT32
RCFDC0.CFDTMDF2_18.UINT16[L/H]
RCFDC0.CFDTMDF2_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_18.UINT32
RCFDC0.CFDTMDF3_18.UINT16[L/H]
RCFDC0.CFDTMDF3_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_18.UINT32
RCFDC0.CFDTMDF4_18.UINT16[L/H]
RCFDC0.CFDTMDF4_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_18.UINT32
RCFDC0.CFDTMDF5_18.UINT16[L/H]
RCFDC0.CFDTMDF5_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_18.UINT32
RCFDC0.CFDTMDF6_18.UINT16[L/H]
RCFDC0.CFDTMDF6_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_18.UINT32
RCFDC0.CFDTMDF7_18.UINT16[L/H]
RCFDC0.CFDTMDF7_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_18.UINT32
RCFDC0.CFDTMDF8_18.UINT16[L/H]
RCFDC0.CFDTMDF8_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_18.UINT32
RCFDC0.CFDTMDF9_18.UINT16[L/H]
RCFDC0.CFDTMDF9_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_18.UINT32
RCFDC0.CFDTMDF10_18.UINT16[L/H]
RCFDC0.CFDTMDF10_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_18.UINT32
RCFDC0.CFDTMDF11_18.UINT16[L/H]
RCFDC0.CFDTMDF11_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_18.UINT32
RCFDC0.CFDTMDF12_18.UINT16[L/H]
RCFDC0.CFDTMDF12_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_18.UINT32
RCFDC0.CFDTMDF13_18.UINT16[L/H]
RCFDC0.CFDTMDF13_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_18.UINT32
RCFDC0.CFDTMDF14_18.UINT16[L/H]
RCFDC0.CFDTMDF14_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_18.UINT32
RCFDC0.CFDTMDF15_18.UINT16[L/H]
RCFDC0.CFDTMDF15_18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID19.UINT32
RCFDC0.CFDTMID19.UINT16[L/H]
RCFDC0.CFDTMID19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR19.UINT32
RCFDC0.CFDTMPTR19.UINT16[H]
RCFDC0.CFDTMPTR19.UINT8[HH]
RCFDC0.CFDTMFDCTR19.UINT32
RCFDC0.CFDTMFDCTR19.UINT16[L/H]
RCFDC0.CFDTMFDCTR19.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_19.UINT32
RCFDC0.CFDTMDF0_19.UINT16[L/H]
RCFDC0.CFDTMDF0_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_19.UINT32
RCFDC0.CFDTMDF1_19.UINT16[L/H]
RCFDC0.CFDTMDF1_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_19.UINT32
RCFDC0.CFDTMDF2_19.UINT16[L/H]
RCFDC0.CFDTMDF2_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_19.UINT32
RCFDC0.CFDTMDF3_19.UINT16[L/H]
RCFDC0.CFDTMDF3_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_19.UINT32
RCFDC0.CFDTMDF4_19.UINT16[L/H]
RCFDC0.CFDTMDF4_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_19.UINT32
RCFDC0.CFDTMDF5_19.UINT16[L/H]
RCFDC0.CFDTMDF5_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_19.UINT32
RCFDC0.CFDTMDF6_19.UINT16[L/H]
RCFDC0.CFDTMDF6_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_19.UINT32
RCFDC0.CFDTMDF7_19.UINT16[L/H]
RCFDC0.CFDTMDF7_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_19.UINT32
RCFDC0.CFDTMDF8_19.UINT16[L/H]
RCFDC0.CFDTMDF8_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_19.UINT32
RCFDC0.CFDTMDF9_19.UINT16[L/H]
RCFDC0.CFDTMDF9_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_19.UINT32
RCFDC0.CFDTMDF10_19.UINT16[L/H]
RCFDC0.CFDTMDF10_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_19.UINT32
RCFDC0.CFDTMDF11_19.UINT16[L/H]
RCFDC0.CFDTMDF11_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_19.UINT32
RCFDC0.CFDTMDF12_19.UINT16[L/H]
RCFDC0.CFDTMDF12_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_19.UINT32
RCFDC0.CFDTMDF13_19.UINT16[L/H]
RCFDC0.CFDTMDF13_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_19.UINT32
RCFDC0.CFDTMDF14_19.UINT16[L/H]
RCFDC0.CFDTMDF14_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_19.UINT32
RCFDC0.CFDTMDF15_19.UINT16[L/H]
RCFDC0.CFDTMDF15_19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID20.UINT32
RCFDC0.CFDTMID20.UINT16[L/H]
RCFDC0.CFDTMID20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR20.UINT32
RCFDC0.CFDTMPTR20.UINT16[H]
RCFDC0.CFDTMPTR20.UINT8[HH]
RCFDC0.CFDTMFDCTR20.UINT32
RCFDC0.CFDTMFDCTR20.UINT16[L/H]
RCFDC0.CFDTMFDCTR20.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_20.UINT32
RCFDC0.CFDTMDF0_20.UINT16[L/H]
RCFDC0.CFDTMDF0_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_20.UINT32
RCFDC0.CFDTMDF1_20.UINT16[L/H]
RCFDC0.CFDTMDF1_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_20.UINT32
RCFDC0.CFDTMDF2_20.UINT16[L/H]
RCFDC0.CFDTMDF2_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_20.UINT32
RCFDC0.CFDTMDF3_20.UINT16[L/H]
RCFDC0.CFDTMDF3_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_20.UINT32
RCFDC0.CFDTMDF4_20.UINT16[L/H]
RCFDC0.CFDTMDF4_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_20.UINT32
RCFDC0.CFDTMDF5_20.UINT16[L/H]
RCFDC0.CFDTMDF5_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_20.UINT32
RCFDC0.CFDTMDF6_20.UINT16[L/H]
RCFDC0.CFDTMDF6_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_20.UINT32
RCFDC0.CFDTMDF7_20.UINT16[L/H]
RCFDC0.CFDTMDF7_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_20.UINT32
RCFDC0.CFDTMDF8_20.UINT16[L/H]
RCFDC0.CFDTMDF8_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_20.UINT32
RCFDC0.CFDTMDF9_20.UINT16[L/H]
RCFDC0.CFDTMDF9_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_20.UINT32
RCFDC0.CFDTMDF10_20.UINT16[L/H]
RCFDC0.CFDTMDF10_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_20.UINT32
RCFDC0.CFDTMDF11_20.UINT16[L/H]
RCFDC0.CFDTMDF11_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_20.UINT32
RCFDC0.CFDTMDF12_20.UINT16[L/H]
RCFDC0.CFDTMDF12_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_20.UINT32
RCFDC0.CFDTMDF13_20.UINT16[L/H]
RCFDC0.CFDTMDF13_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_20.UINT32
RCFDC0.CFDTMDF14_20.UINT16[L/H]
RCFDC0.CFDTMDF14_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_20.UINT32
RCFDC0.CFDTMDF15_20.UINT16[L/H]
RCFDC0.CFDTMDF15_20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID21.UINT32
RCFDC0.CFDTMID21.UINT16[L/H]
RCFDC0.CFDTMID21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR21.UINT32
RCFDC0.CFDTMPTR21.UINT16[H]
RCFDC0.CFDTMPTR21.UINT8[HH]
RCFDC0.CFDTMFDCTR21.UINT32
RCFDC0.CFDTMFDCTR21.UINT16[L/H]
RCFDC0.CFDTMFDCTR21.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_21.UINT32
RCFDC0.CFDTMDF0_21.UINT16[L/H]
RCFDC0.CFDTMDF0_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_21.UINT32
RCFDC0.CFDTMDF1_21.UINT16[L/H]
RCFDC0.CFDTMDF1_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_21.UINT32
RCFDC0.CFDTMDF2_21.UINT16[L/H]
RCFDC0.CFDTMDF2_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_21.UINT32
RCFDC0.CFDTMDF3_21.UINT16[L/H]
RCFDC0.CFDTMDF3_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_21.UINT32
RCFDC0.CFDTMDF4_21.UINT16[L/H]
RCFDC0.CFDTMDF4_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_21.UINT32
RCFDC0.CFDTMDF5_21.UINT16[L/H]
RCFDC0.CFDTMDF5_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_21.UINT32
RCFDC0.CFDTMDF6_21.UINT16[L/H]
RCFDC0.CFDTMDF6_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_21.UINT32
RCFDC0.CFDTMDF7_21.UINT16[L/H]
RCFDC0.CFDTMDF7_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_21.UINT32
RCFDC0.CFDTMDF8_21.UINT16[L/H]
RCFDC0.CFDTMDF8_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_21.UINT32
RCFDC0.CFDTMDF9_21.UINT16[L/H]
RCFDC0.CFDTMDF9_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_21.UINT32
RCFDC0.CFDTMDF10_21.UINT16[L/H]
RCFDC0.CFDTMDF10_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_21.UINT32
RCFDC0.CFDTMDF11_21.UINT16[L/H]
RCFDC0.CFDTMDF11_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_21.UINT32
RCFDC0.CFDTMDF12_21.UINT16[L/H]
RCFDC0.CFDTMDF12_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_21.UINT32
RCFDC0.CFDTMDF13_21.UINT16[L/H]
RCFDC0.CFDTMDF13_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_21.UINT32
RCFDC0.CFDTMDF14_21.UINT16[L/H]
RCFDC0.CFDTMDF14_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_21.UINT32
RCFDC0.CFDTMDF15_21.UINT16[L/H]
RCFDC0.CFDTMDF15_21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID22.UINT32
RCFDC0.CFDTMID22.UINT16[L/H]
RCFDC0.CFDTMID22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR22.UINT32
RCFDC0.CFDTMPTR22.UINT16[H]
RCFDC0.CFDTMPTR22.UINT8[HH]
RCFDC0.CFDTMFDCTR22.UINT32
RCFDC0.CFDTMFDCTR22.UINT16[L/H]
RCFDC0.CFDTMFDCTR22.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_22.UINT32
RCFDC0.CFDTMDF0_22.UINT16[L/H]
RCFDC0.CFDTMDF0_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_22.UINT32
RCFDC0.CFDTMDF1_22.UINT16[L/H]
RCFDC0.CFDTMDF1_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_22.UINT32
RCFDC0.CFDTMDF2_22.UINT16[L/H]
RCFDC0.CFDTMDF2_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_22.UINT32
RCFDC0.CFDTMDF3_22.UINT16[L/H]
RCFDC0.CFDTMDF3_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_22.UINT32
RCFDC0.CFDTMDF4_22.UINT16[L/H]
RCFDC0.CFDTMDF4_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_22.UINT32
RCFDC0.CFDTMDF5_22.UINT16[L/H]
RCFDC0.CFDTMDF5_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_22.UINT32
RCFDC0.CFDTMDF6_22.UINT16[L/H]
RCFDC0.CFDTMDF6_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_22.UINT32
RCFDC0.CFDTMDF7_22.UINT16[L/H]
RCFDC0.CFDTMDF7_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_22.UINT32
RCFDC0.CFDTMDF8_22.UINT16[L/H]
RCFDC0.CFDTMDF8_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_22.UINT32
RCFDC0.CFDTMDF9_22.UINT16[L/H]
RCFDC0.CFDTMDF9_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_22.UINT32
RCFDC0.CFDTMDF10_22.UINT16[L/H]
RCFDC0.CFDTMDF10_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_22.UINT32
RCFDC0.CFDTMDF11_22.UINT16[L/H]
RCFDC0.CFDTMDF11_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_22.UINT32
RCFDC0.CFDTMDF12_22.UINT16[L/H]
RCFDC0.CFDTMDF12_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_22.UINT32
RCFDC0.CFDTMDF13_22.UINT16[L/H]
RCFDC0.CFDTMDF13_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_22.UINT32
RCFDC0.CFDTMDF14_22.UINT16[L/H]
RCFDC0.CFDTMDF14_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_22.UINT32
RCFDC0.CFDTMDF15_22.UINT16[L/H]
RCFDC0.CFDTMDF15_22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID23.UINT32
RCFDC0.CFDTMID23.UINT16[L/H]
RCFDC0.CFDTMID23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR23.UINT32
RCFDC0.CFDTMPTR23.UINT16[H]
RCFDC0.CFDTMPTR23.UINT8[HH]
RCFDC0.CFDTMFDCTR23.UINT32
RCFDC0.CFDTMFDCTR23.UINT16[L/H]
RCFDC0.CFDTMFDCTR23.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_23.UINT32
RCFDC0.CFDTMDF0_23.UINT16[L/H]
RCFDC0.CFDTMDF0_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_23.UINT32
RCFDC0.CFDTMDF1_23.UINT16[L/H]
RCFDC0.CFDTMDF1_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_23.UINT32
RCFDC0.CFDTMDF2_23.UINT16[L/H]
RCFDC0.CFDTMDF2_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_23.UINT32
RCFDC0.CFDTMDF3_23.UINT16[L/H]
RCFDC0.CFDTMDF3_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_23.UINT32
RCFDC0.CFDTMDF4_23.UINT16[L/H]
RCFDC0.CFDTMDF4_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_23.UINT32
RCFDC0.CFDTMDF5_23.UINT16[L/H]
RCFDC0.CFDTMDF5_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_23.UINT32
RCFDC0.CFDTMDF6_23.UINT16[L/H]
RCFDC0.CFDTMDF6_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_23.UINT32
RCFDC0.CFDTMDF7_23.UINT16[L/H]
RCFDC0.CFDTMDF7_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_23.UINT32
RCFDC0.CFDTMDF8_23.UINT16[L/H]
RCFDC0.CFDTMDF8_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_23.UINT32
RCFDC0.CFDTMDF9_23.UINT16[L/H]
RCFDC0.CFDTMDF9_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_23.UINT32
RCFDC0.CFDTMDF10_23.UINT16[L/H]
RCFDC0.CFDTMDF10_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_23.UINT32
RCFDC0.CFDTMDF11_23.UINT16[L/H]
RCFDC0.CFDTMDF11_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_23.UINT32
RCFDC0.CFDTMDF12_23.UINT16[L/H]
RCFDC0.CFDTMDF12_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_23.UINT32
RCFDC0.CFDTMDF13_23.UINT16[L/H]
RCFDC0.CFDTMDF13_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_23.UINT32
RCFDC0.CFDTMDF14_23.UINT16[L/H]
RCFDC0.CFDTMDF14_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_23.UINT32
RCFDC0.CFDTMDF15_23.UINT16[L/H]
RCFDC0.CFDTMDF15_23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID24.UINT32
RCFDC0.CFDTMID24.UINT16[L/H]
RCFDC0.CFDTMID24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR24.UINT32
RCFDC0.CFDTMPTR24.UINT16[H]
RCFDC0.CFDTMPTR24.UINT8[HH]
RCFDC0.CFDTMFDCTR24.UINT32
RCFDC0.CFDTMFDCTR24.UINT16[L/H]
RCFDC0.CFDTMFDCTR24.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_24.UINT32
RCFDC0.CFDTMDF0_24.UINT16[L/H]
RCFDC0.CFDTMDF0_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_24.UINT32
RCFDC0.CFDTMDF1_24.UINT16[L/H]
RCFDC0.CFDTMDF1_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_24.UINT32
RCFDC0.CFDTMDF2_24.UINT16[L/H]
RCFDC0.CFDTMDF2_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_24.UINT32
RCFDC0.CFDTMDF3_24.UINT16[L/H]
RCFDC0.CFDTMDF3_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_24.UINT32
RCFDC0.CFDTMDF4_24.UINT16[L/H]
RCFDC0.CFDTMDF4_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_24.UINT32
RCFDC0.CFDTMDF5_24.UINT16[L/H]
RCFDC0.CFDTMDF5_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_24.UINT32
RCFDC0.CFDTMDF6_24.UINT16[L/H]
RCFDC0.CFDTMDF6_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_24.UINT32
RCFDC0.CFDTMDF7_24.UINT16[L/H]
RCFDC0.CFDTMDF7_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_24.UINT32
RCFDC0.CFDTMDF8_24.UINT16[L/H]
RCFDC0.CFDTMDF8_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_24.UINT32
RCFDC0.CFDTMDF9_24.UINT16[L/H]
RCFDC0.CFDTMDF9_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_24.UINT32
RCFDC0.CFDTMDF10_24.UINT16[L/H]
RCFDC0.CFDTMDF10_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_24.UINT32
RCFDC0.CFDTMDF11_24.UINT16[L/H]
RCFDC0.CFDTMDF11_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_24.UINT32
RCFDC0.CFDTMDF12_24.UINT16[L/H]
RCFDC0.CFDTMDF12_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_24.UINT32
RCFDC0.CFDTMDF13_24.UINT16[L/H]
RCFDC0.CFDTMDF13_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_24.UINT32
RCFDC0.CFDTMDF14_24.UINT16[L/H]
RCFDC0.CFDTMDF14_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_24.UINT32
RCFDC0.CFDTMDF15_24.UINT16[L/H]
RCFDC0.CFDTMDF15_24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID25.UINT32
RCFDC0.CFDTMID25.UINT16[L/H]
RCFDC0.CFDTMID25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR25.UINT32
RCFDC0.CFDTMPTR25.UINT16[H]
RCFDC0.CFDTMPTR25.UINT8[HH]
RCFDC0.CFDTMFDCTR25.UINT32
RCFDC0.CFDTMFDCTR25.UINT16[L/H]
RCFDC0.CFDTMFDCTR25.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_25.UINT32
RCFDC0.CFDTMDF0_25.UINT16[L/H]
RCFDC0.CFDTMDF0_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_25.UINT32
RCFDC0.CFDTMDF1_25.UINT16[L/H]
RCFDC0.CFDTMDF1_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_25.UINT32
RCFDC0.CFDTMDF2_25.UINT16[L/H]
RCFDC0.CFDTMDF2_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_25.UINT32
RCFDC0.CFDTMDF3_25.UINT16[L/H]
RCFDC0.CFDTMDF3_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_25.UINT32
RCFDC0.CFDTMDF4_25.UINT16[L/H]
RCFDC0.CFDTMDF4_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_25.UINT32
RCFDC0.CFDTMDF5_25.UINT16[L/H]
RCFDC0.CFDTMDF5_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_25.UINT32
RCFDC0.CFDTMDF6_25.UINT16[L/H]
RCFDC0.CFDTMDF6_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_25.UINT32
RCFDC0.CFDTMDF7_25.UINT16[L/H]
RCFDC0.CFDTMDF7_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_25.UINT32
RCFDC0.CFDTMDF8_25.UINT16[L/H]
RCFDC0.CFDTMDF8_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_25.UINT32
RCFDC0.CFDTMDF9_25.UINT16[L/H]
RCFDC0.CFDTMDF9_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_25.UINT32
RCFDC0.CFDTMDF10_25.UINT16[L/H]
RCFDC0.CFDTMDF10_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_25.UINT32
RCFDC0.CFDTMDF11_25.UINT16[L/H]
RCFDC0.CFDTMDF11_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_25.UINT32
RCFDC0.CFDTMDF12_25.UINT16[L/H]
RCFDC0.CFDTMDF12_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_25.UINT32
RCFDC0.CFDTMDF13_25.UINT16[L/H]
RCFDC0.CFDTMDF13_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_25.UINT32
RCFDC0.CFDTMDF14_25.UINT16[L/H]
RCFDC0.CFDTMDF14_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_25.UINT32
RCFDC0.CFDTMDF15_25.UINT16[L/H]
RCFDC0.CFDTMDF15_25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID26.UINT32
RCFDC0.CFDTMID26.UINT16[L/H]
RCFDC0.CFDTMID26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR26.UINT32
RCFDC0.CFDTMPTR26.UINT16[H]
RCFDC0.CFDTMPTR26.UINT8[HH]
RCFDC0.CFDTMFDCTR26.UINT32
RCFDC0.CFDTMFDCTR26.UINT16[L/H]
RCFDC0.CFDTMFDCTR26.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_26.UINT32
RCFDC0.CFDTMDF0_26.UINT16[L/H]
RCFDC0.CFDTMDF0_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_26.UINT32
RCFDC0.CFDTMDF1_26.UINT16[L/H]
RCFDC0.CFDTMDF1_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_26.UINT32
RCFDC0.CFDTMDF2_26.UINT16[L/H]
RCFDC0.CFDTMDF2_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_26.UINT32
RCFDC0.CFDTMDF3_26.UINT16[L/H]
RCFDC0.CFDTMDF3_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_26.UINT32
RCFDC0.CFDTMDF4_26.UINT16[L/H]
RCFDC0.CFDTMDF4_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_26.UINT32
RCFDC0.CFDTMDF5_26.UINT16[L/H]
RCFDC0.CFDTMDF5_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_26.UINT32
RCFDC0.CFDTMDF6_26.UINT16[L/H]
RCFDC0.CFDTMDF6_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_26.UINT32
RCFDC0.CFDTMDF7_26.UINT16[L/H]
RCFDC0.CFDTMDF7_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_26.UINT32
RCFDC0.CFDTMDF8_26.UINT16[L/H]
RCFDC0.CFDTMDF8_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_26.UINT32
RCFDC0.CFDTMDF9_26.UINT16[L/H]
RCFDC0.CFDTMDF9_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_26.UINT32
RCFDC0.CFDTMDF10_26.UINT16[L/H]
RCFDC0.CFDTMDF10_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_26.UINT32
RCFDC0.CFDTMDF11_26.UINT16[L/H]
RCFDC0.CFDTMDF11_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_26.UINT32
RCFDC0.CFDTMDF12_26.UINT16[L/H]
RCFDC0.CFDTMDF12_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_26.UINT32
RCFDC0.CFDTMDF13_26.UINT16[L/H]
RCFDC0.CFDTMDF13_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_26.UINT32
RCFDC0.CFDTMDF14_26.UINT16[L/H]
RCFDC0.CFDTMDF14_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_26.UINT32
RCFDC0.CFDTMDF15_26.UINT16[L/H]
RCFDC0.CFDTMDF15_26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID27.UINT32
RCFDC0.CFDTMID27.UINT16[L/H]
RCFDC0.CFDTMID27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR27.UINT32
RCFDC0.CFDTMPTR27.UINT16[H]
RCFDC0.CFDTMPTR27.UINT8[HH]
RCFDC0.CFDTMFDCTR27.UINT32
RCFDC0.CFDTMFDCTR27.UINT16[L/H]
RCFDC0.CFDTMFDCTR27.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_27.UINT32
RCFDC0.CFDTMDF0_27.UINT16[L/H]
RCFDC0.CFDTMDF0_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_27.UINT32
RCFDC0.CFDTMDF1_27.UINT16[L/H]
RCFDC0.CFDTMDF1_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_27.UINT32
RCFDC0.CFDTMDF2_27.UINT16[L/H]
RCFDC0.CFDTMDF2_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_27.UINT32
RCFDC0.CFDTMDF3_27.UINT16[L/H]
RCFDC0.CFDTMDF3_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_27.UINT32
RCFDC0.CFDTMDF4_27.UINT16[L/H]
RCFDC0.CFDTMDF4_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_27.UINT32
RCFDC0.CFDTMDF5_27.UINT16[L/H]
RCFDC0.CFDTMDF5_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_27.UINT32
RCFDC0.CFDTMDF6_27.UINT16[L/H]
RCFDC0.CFDTMDF6_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_27.UINT32
RCFDC0.CFDTMDF7_27.UINT16[L/H]
RCFDC0.CFDTMDF7_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_27.UINT32
RCFDC0.CFDTMDF8_27.UINT16[L/H]
RCFDC0.CFDTMDF8_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_27.UINT32
RCFDC0.CFDTMDF9_27.UINT16[L/H]
RCFDC0.CFDTMDF9_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_27.UINT32
RCFDC0.CFDTMDF10_27.UINT16[L/H]
RCFDC0.CFDTMDF10_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_27.UINT32
RCFDC0.CFDTMDF11_27.UINT16[L/H]
RCFDC0.CFDTMDF11_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_27.UINT32
RCFDC0.CFDTMDF12_27.UINT16[L/H]
RCFDC0.CFDTMDF12_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_27.UINT32
RCFDC0.CFDTMDF13_27.UINT16[L/H]
RCFDC0.CFDTMDF13_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_27.UINT32
RCFDC0.CFDTMDF14_27.UINT16[L/H]
RCFDC0.CFDTMDF14_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_27.UINT32
RCFDC0.CFDTMDF15_27.UINT16[L/H]
RCFDC0.CFDTMDF15_27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID28.UINT32
RCFDC0.CFDTMID28.UINT16[L/H]
RCFDC0.CFDTMID28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR28.UINT32
RCFDC0.CFDTMPTR28.UINT16[H]
RCFDC0.CFDTMPTR28.UINT8[HH]
RCFDC0.CFDTMFDCTR28.UINT32
RCFDC0.CFDTMFDCTR28.UINT16[L/H]
RCFDC0.CFDTMFDCTR28.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_28.UINT32
RCFDC0.CFDTMDF0_28.UINT16[L/H]
RCFDC0.CFDTMDF0_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_28.UINT32
RCFDC0.CFDTMDF1_28.UINT16[L/H]
RCFDC0.CFDTMDF1_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_28.UINT32
RCFDC0.CFDTMDF2_28.UINT16[L/H]
RCFDC0.CFDTMDF2_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_28.UINT32
RCFDC0.CFDTMDF3_28.UINT16[L/H]
RCFDC0.CFDTMDF3_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_28.UINT32
RCFDC0.CFDTMDF4_28.UINT16[L/H]
RCFDC0.CFDTMDF4_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_28.UINT32
RCFDC0.CFDTMDF5_28.UINT16[L/H]
RCFDC0.CFDTMDF5_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_28.UINT32
RCFDC0.CFDTMDF6_28.UINT16[L/H]
RCFDC0.CFDTMDF6_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_28.UINT32
RCFDC0.CFDTMDF7_28.UINT16[L/H]
RCFDC0.CFDTMDF7_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_28.UINT32
RCFDC0.CFDTMDF8_28.UINT16[L/H]
RCFDC0.CFDTMDF8_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_28.UINT32
RCFDC0.CFDTMDF9_28.UINT16[L/H]
RCFDC0.CFDTMDF9_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_28.UINT32
RCFDC0.CFDTMDF10_28.UINT16[L/H]
RCFDC0.CFDTMDF10_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_28.UINT32
RCFDC0.CFDTMDF11_28.UINT16[L/H]
RCFDC0.CFDTMDF11_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_28.UINT32
RCFDC0.CFDTMDF12_28.UINT16[L/H]
RCFDC0.CFDTMDF12_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_28.UINT32
RCFDC0.CFDTMDF13_28.UINT16[L/H]
RCFDC0.CFDTMDF13_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_28.UINT32
RCFDC0.CFDTMDF14_28.UINT16[L/H]
RCFDC0.CFDTMDF14_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_28.UINT32
RCFDC0.CFDTMDF15_28.UINT16[L/H]
RCFDC0.CFDTMDF15_28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID29.UINT32
RCFDC0.CFDTMID29.UINT16[L/H]
RCFDC0.CFDTMID29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR29.UINT32
RCFDC0.CFDTMPTR29.UINT16[H]
RCFDC0.CFDTMPTR29.UINT8[HH]
RCFDC0.CFDTMFDCTR29.UINT32
RCFDC0.CFDTMFDCTR29.UINT16[L/H]
RCFDC0.CFDTMFDCTR29.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_29.UINT32
RCFDC0.CFDTMDF0_29.UINT16[L/H]
RCFDC0.CFDTMDF0_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_29.UINT32
RCFDC0.CFDTMDF1_29.UINT16[L/H]
RCFDC0.CFDTMDF1_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_29.UINT32
RCFDC0.CFDTMDF2_29.UINT16[L/H]
RCFDC0.CFDTMDF2_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_29.UINT32
RCFDC0.CFDTMDF3_29.UINT16[L/H]
RCFDC0.CFDTMDF3_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_29.UINT32
RCFDC0.CFDTMDF4_29.UINT16[L/H]
RCFDC0.CFDTMDF4_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_29.UINT32
RCFDC0.CFDTMDF5_29.UINT16[L/H]
RCFDC0.CFDTMDF5_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_29.UINT32
RCFDC0.CFDTMDF6_29.UINT16[L/H]
RCFDC0.CFDTMDF6_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_29.UINT32
RCFDC0.CFDTMDF7_29.UINT16[L/H]
RCFDC0.CFDTMDF7_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_29.UINT32
RCFDC0.CFDTMDF8_29.UINT16[L/H]
RCFDC0.CFDTMDF8_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_29.UINT32
RCFDC0.CFDTMDF9_29.UINT16[L/H]
RCFDC0.CFDTMDF9_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_29.UINT32
RCFDC0.CFDTMDF10_29.UINT16[L/H]
RCFDC0.CFDTMDF10_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_29.UINT32
RCFDC0.CFDTMDF11_29.UINT16[L/H]
RCFDC0.CFDTMDF11_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_29.UINT32
RCFDC0.CFDTMDF12_29.UINT16[L/H]
RCFDC0.CFDTMDF12_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_29.UINT32
RCFDC0.CFDTMDF13_29.UINT16[L/H]
RCFDC0.CFDTMDF13_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_29.UINT32
RCFDC0.CFDTMDF14_29.UINT16[L/H]
RCFDC0.CFDTMDF14_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_29.UINT32
RCFDC0.CFDTMDF15_29.UINT16[L/H]
RCFDC0.CFDTMDF15_29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID30.UINT32
RCFDC0.CFDTMID30.UINT16[L/H]
RCFDC0.CFDTMID30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR30.UINT32
RCFDC0.CFDTMPTR30.UINT16[H]
RCFDC0.CFDTMPTR30.UINT8[HH]
RCFDC0.CFDTMFDCTR30.UINT32
RCFDC0.CFDTMFDCTR30.UINT16[L/H]
RCFDC0.CFDTMFDCTR30.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_30.UINT32
RCFDC0.CFDTMDF0_30.UINT16[L/H]
RCFDC0.CFDTMDF0_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_30.UINT32
RCFDC0.CFDTMDF1_30.UINT16[L/H]
RCFDC0.CFDTMDF1_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_30.UINT32
RCFDC0.CFDTMDF2_30.UINT16[L/H]
RCFDC0.CFDTMDF2_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_30.UINT32
RCFDC0.CFDTMDF3_30.UINT16[L/H]
RCFDC0.CFDTMDF3_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_30.UINT32
RCFDC0.CFDTMDF4_30.UINT16[L/H]
RCFDC0.CFDTMDF4_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_30.UINT32
RCFDC0.CFDTMDF5_30.UINT16[L/H]
RCFDC0.CFDTMDF5_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_30.UINT32
RCFDC0.CFDTMDF6_30.UINT16[L/H]
RCFDC0.CFDTMDF6_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_30.UINT32
RCFDC0.CFDTMDF7_30.UINT16[L/H]
RCFDC0.CFDTMDF7_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_30.UINT32
RCFDC0.CFDTMDF8_30.UINT16[L/H]
RCFDC0.CFDTMDF8_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_30.UINT32
RCFDC0.CFDTMDF9_30.UINT16[L/H]
RCFDC0.CFDTMDF9_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_30.UINT32
RCFDC0.CFDTMDF10_30.UINT16[L/H]
RCFDC0.CFDTMDF10_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_30.UINT32
RCFDC0.CFDTMDF11_30.UINT16[L/H]
RCFDC0.CFDTMDF11_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_30.UINT32
RCFDC0.CFDTMDF12_30.UINT16[L/H]
RCFDC0.CFDTMDF12_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_30.UINT32
RCFDC0.CFDTMDF13_30.UINT16[L/H]
RCFDC0.CFDTMDF13_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_30.UINT32
RCFDC0.CFDTMDF14_30.UINT16[L/H]
RCFDC0.CFDTMDF14_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_30.UINT32
RCFDC0.CFDTMDF15_30.UINT16[L/H]
RCFDC0.CFDTMDF15_30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID31.UINT32
RCFDC0.CFDTMID31.UINT16[L/H]
RCFDC0.CFDTMID31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR31.UINT32
RCFDC0.CFDTMPTR31.UINT16[H]
RCFDC0.CFDTMPTR31.UINT8[HH]
RCFDC0.CFDTMFDCTR31.UINT32
RCFDC0.CFDTMFDCTR31.UINT16[L/H]
RCFDC0.CFDTMFDCTR31.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_31.UINT32
RCFDC0.CFDTMDF0_31.UINT16[L/H]
RCFDC0.CFDTMDF0_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_31.UINT32
RCFDC0.CFDTMDF1_31.UINT16[L/H]
RCFDC0.CFDTMDF1_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_31.UINT32
RCFDC0.CFDTMDF2_31.UINT16[L/H]
RCFDC0.CFDTMDF2_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_31.UINT32
RCFDC0.CFDTMDF3_31.UINT16[L/H]
RCFDC0.CFDTMDF3_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_31.UINT32
RCFDC0.CFDTMDF4_31.UINT16[L/H]
RCFDC0.CFDTMDF4_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_31.UINT32
RCFDC0.CFDTMDF5_31.UINT16[L/H]
RCFDC0.CFDTMDF5_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_31.UINT32
RCFDC0.CFDTMDF6_31.UINT16[L/H]
RCFDC0.CFDTMDF6_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_31.UINT32
RCFDC0.CFDTMDF7_31.UINT16[L/H]
RCFDC0.CFDTMDF7_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_31.UINT32
RCFDC0.CFDTMDF8_31.UINT16[L/H]
RCFDC0.CFDTMDF8_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_31.UINT32
RCFDC0.CFDTMDF9_31.UINT16[L/H]
RCFDC0.CFDTMDF9_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_31.UINT32
RCFDC0.CFDTMDF10_31.UINT16[L/H]
RCFDC0.CFDTMDF10_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_31.UINT32
RCFDC0.CFDTMDF11_31.UINT16[L/H]
RCFDC0.CFDTMDF11_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_31.UINT32
RCFDC0.CFDTMDF12_31.UINT16[L/H]
RCFDC0.CFDTMDF12_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_31.UINT32
RCFDC0.CFDTMDF13_31.UINT16[L/H]
RCFDC0.CFDTMDF13_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_31.UINT32
RCFDC0.CFDTMDF14_31.UINT16[L/H]
RCFDC0.CFDTMDF14_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_31.UINT32
RCFDC0.CFDTMDF15_31.UINT16[L/H]
RCFDC0.CFDTMDF15_31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID32.UINT32
RCFDC0.CFDTMID32.UINT16[L/H]
RCFDC0.CFDTMID32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR32.UINT32
RCFDC0.CFDTMPTR32.UINT16[H]
RCFDC0.CFDTMPTR32.UINT8[HH]
RCFDC0.CFDTMFDCTR32.UINT32
RCFDC0.CFDTMFDCTR32.UINT16[L/H]
RCFDC0.CFDTMFDCTR32.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_32.UINT32
RCFDC0.CFDTMDF0_32.UINT16[L/H]
RCFDC0.CFDTMDF0_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_32.UINT32
RCFDC0.CFDTMDF1_32.UINT16[L/H]
RCFDC0.CFDTMDF1_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_32.UINT32
RCFDC0.CFDTMDF2_32.UINT16[L/H]
RCFDC0.CFDTMDF2_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_32.UINT32
RCFDC0.CFDTMDF3_32.UINT16[L/H]
RCFDC0.CFDTMDF3_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_32.UINT32
RCFDC0.CFDTMDF4_32.UINT16[L/H]
RCFDC0.CFDTMDF4_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_32.UINT32
RCFDC0.CFDTMDF5_32.UINT16[L/H]
RCFDC0.CFDTMDF5_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_32.UINT32
RCFDC0.CFDTMDF6_32.UINT16[L/H]
RCFDC0.CFDTMDF6_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_32.UINT32
RCFDC0.CFDTMDF7_32.UINT16[L/H]
RCFDC0.CFDTMDF7_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_32.UINT32
RCFDC0.CFDTMDF8_32.UINT16[L/H]
RCFDC0.CFDTMDF8_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_32.UINT32
RCFDC0.CFDTMDF9_32.UINT16[L/H]
RCFDC0.CFDTMDF9_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_32.UINT32
RCFDC0.CFDTMDF10_32.UINT16[L/H]
RCFDC0.CFDTMDF10_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_32.UINT32
RCFDC0.CFDTMDF11_32.UINT16[L/H]
RCFDC0.CFDTMDF11_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_32.UINT32
RCFDC0.CFDTMDF12_32.UINT16[L/H]
RCFDC0.CFDTMDF12_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_32.UINT32
RCFDC0.CFDTMDF13_32.UINT16[L/H]
RCFDC0.CFDTMDF13_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_32.UINT32
RCFDC0.CFDTMDF14_32.UINT16[L/H]
RCFDC0.CFDTMDF14_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_32.UINT32
RCFDC0.CFDTMDF15_32.UINT16[L/H]
RCFDC0.CFDTMDF15_32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID33.UINT32
RCFDC0.CFDTMID33.UINT16[L/H]
RCFDC0.CFDTMID33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR33.UINT32
RCFDC0.CFDTMPTR33.UINT16[H]
RCFDC0.CFDTMPTR33.UINT8[HH]
RCFDC0.CFDTMFDCTR33.UINT32
RCFDC0.CFDTMFDCTR33.UINT16[L/H]
RCFDC0.CFDTMFDCTR33.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_33.UINT32
RCFDC0.CFDTMDF0_33.UINT16[L/H]
RCFDC0.CFDTMDF0_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_33.UINT32
RCFDC0.CFDTMDF1_33.UINT16[L/H]
RCFDC0.CFDTMDF1_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_33.UINT32
RCFDC0.CFDTMDF2_33.UINT16[L/H]
RCFDC0.CFDTMDF2_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_33.UINT32
RCFDC0.CFDTMDF3_33.UINT16[L/H]
RCFDC0.CFDTMDF3_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_33.UINT32
RCFDC0.CFDTMDF4_33.UINT16[L/H]
RCFDC0.CFDTMDF4_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_33.UINT32
RCFDC0.CFDTMDF5_33.UINT16[L/H]
RCFDC0.CFDTMDF5_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_33.UINT32
RCFDC0.CFDTMDF6_33.UINT16[L/H]
RCFDC0.CFDTMDF6_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_33.UINT32
RCFDC0.CFDTMDF7_33.UINT16[L/H]
RCFDC0.CFDTMDF7_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_33.UINT32
RCFDC0.CFDTMDF8_33.UINT16[L/H]
RCFDC0.CFDTMDF8_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_33.UINT32
RCFDC0.CFDTMDF9_33.UINT16[L/H]
RCFDC0.CFDTMDF9_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_33.UINT32
RCFDC0.CFDTMDF10_33.UINT16[L/H]
RCFDC0.CFDTMDF10_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_33.UINT32
RCFDC0.CFDTMDF11_33.UINT16[L/H]
RCFDC0.CFDTMDF11_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_33.UINT32
RCFDC0.CFDTMDF12_33.UINT16[L/H]
RCFDC0.CFDTMDF12_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_33.UINT32
RCFDC0.CFDTMDF13_33.UINT16[L/H]
RCFDC0.CFDTMDF13_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_33.UINT32
RCFDC0.CFDTMDF14_33.UINT16[L/H]
RCFDC0.CFDTMDF14_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_33.UINT32
RCFDC0.CFDTMDF15_33.UINT16[L/H]
RCFDC0.CFDTMDF15_33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID34.UINT32
RCFDC0.CFDTMID34.UINT16[L/H]
RCFDC0.CFDTMID34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR34.UINT32
RCFDC0.CFDTMPTR34.UINT16[H]
RCFDC0.CFDTMPTR34.UINT8[HH]
RCFDC0.CFDTMFDCTR34.UINT32
RCFDC0.CFDTMFDCTR34.UINT16[L/H]
RCFDC0.CFDTMFDCTR34.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_34.UINT32
RCFDC0.CFDTMDF0_34.UINT16[L/H]
RCFDC0.CFDTMDF0_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_34.UINT32
RCFDC0.CFDTMDF1_34.UINT16[L/H]
RCFDC0.CFDTMDF1_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_34.UINT32
RCFDC0.CFDTMDF2_34.UINT16[L/H]
RCFDC0.CFDTMDF2_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_34.UINT32
RCFDC0.CFDTMDF3_34.UINT16[L/H]
RCFDC0.CFDTMDF3_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_34.UINT32
RCFDC0.CFDTMDF4_34.UINT16[L/H]
RCFDC0.CFDTMDF4_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_34.UINT32
RCFDC0.CFDTMDF5_34.UINT16[L/H]
RCFDC0.CFDTMDF5_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_34.UINT32
RCFDC0.CFDTMDF6_34.UINT16[L/H]
RCFDC0.CFDTMDF6_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_34.UINT32
RCFDC0.CFDTMDF7_34.UINT16[L/H]
RCFDC0.CFDTMDF7_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_34.UINT32
RCFDC0.CFDTMDF8_34.UINT16[L/H]
RCFDC0.CFDTMDF8_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_34.UINT32
RCFDC0.CFDTMDF9_34.UINT16[L/H]
RCFDC0.CFDTMDF9_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_34.UINT32
RCFDC0.CFDTMDF10_34.UINT16[L/H]
RCFDC0.CFDTMDF10_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_34.UINT32
RCFDC0.CFDTMDF11_34.UINT16[L/H]
RCFDC0.CFDTMDF11_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_34.UINT32
RCFDC0.CFDTMDF12_34.UINT16[L/H]
RCFDC0.CFDTMDF12_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_34.UINT32
RCFDC0.CFDTMDF13_34.UINT16[L/H]
RCFDC0.CFDTMDF13_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_34.UINT32
RCFDC0.CFDTMDF14_34.UINT16[L/H]
RCFDC0.CFDTMDF14_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_34.UINT32
RCFDC0.CFDTMDF15_34.UINT16[L/H]
RCFDC0.CFDTMDF15_34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID35.UINT32
RCFDC0.CFDTMID35.UINT16[L/H]
RCFDC0.CFDTMID35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR35.UINT32
RCFDC0.CFDTMPTR35.UINT16[H]
RCFDC0.CFDTMPTR35.UINT8[HH]
RCFDC0.CFDTMFDCTR35.UINT32
RCFDC0.CFDTMFDCTR35.UINT16[L/H]
RCFDC0.CFDTMFDCTR35.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_35.UINT32
RCFDC0.CFDTMDF0_35.UINT16[L/H]
RCFDC0.CFDTMDF0_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_35.UINT32
RCFDC0.CFDTMDF1_35.UINT16[L/H]
RCFDC0.CFDTMDF1_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_35.UINT32
RCFDC0.CFDTMDF2_35.UINT16[L/H]
RCFDC0.CFDTMDF2_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_35.UINT32
RCFDC0.CFDTMDF3_35.UINT16[L/H]
RCFDC0.CFDTMDF3_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_35.UINT32
RCFDC0.CFDTMDF4_35.UINT16[L/H]
RCFDC0.CFDTMDF4_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_35.UINT32
RCFDC0.CFDTMDF5_35.UINT16[L/H]
RCFDC0.CFDTMDF5_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_35.UINT32
RCFDC0.CFDTMDF6_35.UINT16[L/H]
RCFDC0.CFDTMDF6_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_35.UINT32
RCFDC0.CFDTMDF7_35.UINT16[L/H]
RCFDC0.CFDTMDF7_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_35.UINT32
RCFDC0.CFDTMDF8_35.UINT16[L/H]
RCFDC0.CFDTMDF8_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_35.UINT32
RCFDC0.CFDTMDF9_35.UINT16[L/H]
RCFDC0.CFDTMDF9_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_35.UINT32
RCFDC0.CFDTMDF10_35.UINT16[L/H]
RCFDC0.CFDTMDF10_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_35.UINT32
RCFDC0.CFDTMDF11_35.UINT16[L/H]
RCFDC0.CFDTMDF11_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_35.UINT32
RCFDC0.CFDTMDF12_35.UINT16[L/H]
RCFDC0.CFDTMDF12_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_35.UINT32
RCFDC0.CFDTMDF13_35.UINT16[L/H]
RCFDC0.CFDTMDF13_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_35.UINT32
RCFDC0.CFDTMDF14_35.UINT16[L/H]
RCFDC0.CFDTMDF14_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_35.UINT32
RCFDC0.CFDTMDF15_35.UINT16[L/H]
RCFDC0.CFDTMDF15_35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID36.UINT32
RCFDC0.CFDTMID36.UINT16[L/H]
RCFDC0.CFDTMID36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR36.UINT32
RCFDC0.CFDTMPTR36.UINT16[H]
RCFDC0.CFDTMPTR36.UINT8[HH]
RCFDC0.CFDTMFDCTR36.UINT32
RCFDC0.CFDTMFDCTR36.UINT16[L/H]
RCFDC0.CFDTMFDCTR36.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_36.UINT32
RCFDC0.CFDTMDF0_36.UINT16[L/H]
RCFDC0.CFDTMDF0_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_36.UINT32
RCFDC0.CFDTMDF1_36.UINT16[L/H]
RCFDC0.CFDTMDF1_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_36.UINT32
RCFDC0.CFDTMDF2_36.UINT16[L/H]
RCFDC0.CFDTMDF2_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_36.UINT32
RCFDC0.CFDTMDF3_36.UINT16[L/H]
RCFDC0.CFDTMDF3_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_36.UINT32
RCFDC0.CFDTMDF4_36.UINT16[L/H]
RCFDC0.CFDTMDF4_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_36.UINT32
RCFDC0.CFDTMDF5_36.UINT16[L/H]
RCFDC0.CFDTMDF5_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_36.UINT32
RCFDC0.CFDTMDF6_36.UINT16[L/H]
RCFDC0.CFDTMDF6_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_36.UINT32
RCFDC0.CFDTMDF7_36.UINT16[L/H]
RCFDC0.CFDTMDF7_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_36.UINT32
RCFDC0.CFDTMDF8_36.UINT16[L/H]
RCFDC0.CFDTMDF8_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_36.UINT32
RCFDC0.CFDTMDF9_36.UINT16[L/H]
RCFDC0.CFDTMDF9_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_36.UINT32
RCFDC0.CFDTMDF10_36.UINT16[L/H]
RCFDC0.CFDTMDF10_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_36.UINT32
RCFDC0.CFDTMDF11_36.UINT16[L/H]
RCFDC0.CFDTMDF11_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_36.UINT32
RCFDC0.CFDTMDF12_36.UINT16[L/H]
RCFDC0.CFDTMDF12_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_36.UINT32
RCFDC0.CFDTMDF13_36.UINT16[L/H]
RCFDC0.CFDTMDF13_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_36.UINT32
RCFDC0.CFDTMDF14_36.UINT16[L/H]
RCFDC0.CFDTMDF14_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_36.UINT32
RCFDC0.CFDTMDF15_36.UINT16[L/H]
RCFDC0.CFDTMDF15_36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID37.UINT32
RCFDC0.CFDTMID37.UINT16[L/H]
RCFDC0.CFDTMID37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR37.UINT32
RCFDC0.CFDTMPTR37.UINT16[H]
RCFDC0.CFDTMPTR37.UINT8[HH]
RCFDC0.CFDTMFDCTR37.UINT32
RCFDC0.CFDTMFDCTR37.UINT16[L/H]
RCFDC0.CFDTMFDCTR37.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_37.UINT32
RCFDC0.CFDTMDF0_37.UINT16[L/H]
RCFDC0.CFDTMDF0_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_37.UINT32
RCFDC0.CFDTMDF1_37.UINT16[L/H]
RCFDC0.CFDTMDF1_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_37.UINT32
RCFDC0.CFDTMDF2_37.UINT16[L/H]
RCFDC0.CFDTMDF2_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_37.UINT32
RCFDC0.CFDTMDF3_37.UINT16[L/H]
RCFDC0.CFDTMDF3_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_37.UINT32
RCFDC0.CFDTMDF4_37.UINT16[L/H]
RCFDC0.CFDTMDF4_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_37.UINT32
RCFDC0.CFDTMDF5_37.UINT16[L/H]
RCFDC0.CFDTMDF5_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_37.UINT32
RCFDC0.CFDTMDF6_37.UINT16[L/H]
RCFDC0.CFDTMDF6_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_37.UINT32
RCFDC0.CFDTMDF7_37.UINT16[L/H]
RCFDC0.CFDTMDF7_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_37.UINT32
RCFDC0.CFDTMDF8_37.UINT16[L/H]
RCFDC0.CFDTMDF8_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_37.UINT32
RCFDC0.CFDTMDF9_37.UINT16[L/H]
RCFDC0.CFDTMDF9_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_37.UINT32
RCFDC0.CFDTMDF10_37.UINT16[L/H]
RCFDC0.CFDTMDF10_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_37.UINT32
RCFDC0.CFDTMDF11_37.UINT16[L/H]
RCFDC0.CFDTMDF11_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_37.UINT32
RCFDC0.CFDTMDF12_37.UINT16[L/H]
RCFDC0.CFDTMDF12_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_37.UINT32
RCFDC0.CFDTMDF13_37.UINT16[L/H]
RCFDC0.CFDTMDF13_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_37.UINT32
RCFDC0.CFDTMDF14_37.UINT16[L/H]
RCFDC0.CFDTMDF14_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_37.UINT32
RCFDC0.CFDTMDF15_37.UINT16[L/H]
RCFDC0.CFDTMDF15_37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID38.UINT32
RCFDC0.CFDTMID38.UINT16[L/H]
RCFDC0.CFDTMID38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR38.UINT32
RCFDC0.CFDTMPTR38.UINT16[H]
RCFDC0.CFDTMPTR38.UINT8[HH]
RCFDC0.CFDTMFDCTR38.UINT32
RCFDC0.CFDTMFDCTR38.UINT16[L/H]
RCFDC0.CFDTMFDCTR38.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_38.UINT32
RCFDC0.CFDTMDF0_38.UINT16[L/H]
RCFDC0.CFDTMDF0_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_38.UINT32
RCFDC0.CFDTMDF1_38.UINT16[L/H]
RCFDC0.CFDTMDF1_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_38.UINT32
RCFDC0.CFDTMDF2_38.UINT16[L/H]
RCFDC0.CFDTMDF2_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_38.UINT32
RCFDC0.CFDTMDF3_38.UINT16[L/H]
RCFDC0.CFDTMDF3_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_38.UINT32
RCFDC0.CFDTMDF4_38.UINT16[L/H]
RCFDC0.CFDTMDF4_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_38.UINT32
RCFDC0.CFDTMDF5_38.UINT16[L/H]
RCFDC0.CFDTMDF5_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_38.UINT32
RCFDC0.CFDTMDF6_38.UINT16[L/H]
RCFDC0.CFDTMDF6_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_38.UINT32
RCFDC0.CFDTMDF7_38.UINT16[L/H]
RCFDC0.CFDTMDF7_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_38.UINT32
RCFDC0.CFDTMDF8_38.UINT16[L/H]
RCFDC0.CFDTMDF8_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_38.UINT32
RCFDC0.CFDTMDF9_38.UINT16[L/H]
RCFDC0.CFDTMDF9_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_38.UINT32
RCFDC0.CFDTMDF10_38.UINT16[L/H]
RCFDC0.CFDTMDF10_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_38.UINT32
RCFDC0.CFDTMDF11_38.UINT16[L/H]
RCFDC0.CFDTMDF11_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_38.UINT32
RCFDC0.CFDTMDF12_38.UINT16[L/H]
RCFDC0.CFDTMDF12_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_38.UINT32
RCFDC0.CFDTMDF13_38.UINT16[L/H]
RCFDC0.CFDTMDF13_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_38.UINT32
RCFDC0.CFDTMDF14_38.UINT16[L/H]
RCFDC0.CFDTMDF14_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_38.UINT32
RCFDC0.CFDTMDF15_38.UINT16[L/H]
RCFDC0.CFDTMDF15_38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID39.UINT32
RCFDC0.CFDTMID39.UINT16[L/H]
RCFDC0.CFDTMID39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR39.UINT32
RCFDC0.CFDTMPTR39.UINT16[H]
RCFDC0.CFDTMPTR39.UINT8[HH]
RCFDC0.CFDTMFDCTR39.UINT32
RCFDC0.CFDTMFDCTR39.UINT16[L/H]
RCFDC0.CFDTMFDCTR39.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_39.UINT32
RCFDC0.CFDTMDF0_39.UINT16[L/H]
RCFDC0.CFDTMDF0_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_39.UINT32
RCFDC0.CFDTMDF1_39.UINT16[L/H]
RCFDC0.CFDTMDF1_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_39.UINT32
RCFDC0.CFDTMDF2_39.UINT16[L/H]
RCFDC0.CFDTMDF2_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_39.UINT32
RCFDC0.CFDTMDF3_39.UINT16[L/H]
RCFDC0.CFDTMDF3_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_39.UINT32
RCFDC0.CFDTMDF4_39.UINT16[L/H]
RCFDC0.CFDTMDF4_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_39.UINT32
RCFDC0.CFDTMDF5_39.UINT16[L/H]
RCFDC0.CFDTMDF5_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_39.UINT32
RCFDC0.CFDTMDF6_39.UINT16[L/H]
RCFDC0.CFDTMDF6_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_39.UINT32
RCFDC0.CFDTMDF7_39.UINT16[L/H]
RCFDC0.CFDTMDF7_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_39.UINT32
RCFDC0.CFDTMDF8_39.UINT16[L/H]
RCFDC0.CFDTMDF8_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_39.UINT32
RCFDC0.CFDTMDF9_39.UINT16[L/H]
RCFDC0.CFDTMDF9_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_39.UINT32
RCFDC0.CFDTMDF10_39.UINT16[L/H]
RCFDC0.CFDTMDF10_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_39.UINT32
RCFDC0.CFDTMDF11_39.UINT16[L/H]
RCFDC0.CFDTMDF11_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_39.UINT32
RCFDC0.CFDTMDF12_39.UINT16[L/H]
RCFDC0.CFDTMDF12_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_39.UINT32
RCFDC0.CFDTMDF13_39.UINT16[L/H]
RCFDC0.CFDTMDF13_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_39.UINT32
RCFDC0.CFDTMDF14_39.UINT16[L/H]
RCFDC0.CFDTMDF14_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_39.UINT32
RCFDC0.CFDTMDF15_39.UINT16[L/H]
RCFDC0.CFDTMDF15_39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID40.UINT32
RCFDC0.CFDTMID40.UINT16[L/H]
RCFDC0.CFDTMID40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR40.UINT32
RCFDC0.CFDTMPTR40.UINT16[H]
RCFDC0.CFDTMPTR40.UINT8[HH]
RCFDC0.CFDTMFDCTR40.UINT32
RCFDC0.CFDTMFDCTR40.UINT16[L/H]
RCFDC0.CFDTMFDCTR40.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_40.UINT32
RCFDC0.CFDTMDF0_40.UINT16[L/H]
RCFDC0.CFDTMDF0_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_40.UINT32
RCFDC0.CFDTMDF1_40.UINT16[L/H]
RCFDC0.CFDTMDF1_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_40.UINT32
RCFDC0.CFDTMDF2_40.UINT16[L/H]
RCFDC0.CFDTMDF2_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_40.UINT32
RCFDC0.CFDTMDF3_40.UINT16[L/H]
RCFDC0.CFDTMDF3_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_40.UINT32
RCFDC0.CFDTMDF4_40.UINT16[L/H]
RCFDC0.CFDTMDF4_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_40.UINT32
RCFDC0.CFDTMDF5_40.UINT16[L/H]
RCFDC0.CFDTMDF5_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_40.UINT32
RCFDC0.CFDTMDF6_40.UINT16[L/H]
RCFDC0.CFDTMDF6_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_40.UINT32
RCFDC0.CFDTMDF7_40.UINT16[L/H]
RCFDC0.CFDTMDF7_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_40.UINT32
RCFDC0.CFDTMDF8_40.UINT16[L/H]
RCFDC0.CFDTMDF8_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_40.UINT32
RCFDC0.CFDTMDF9_40.UINT16[L/H]
RCFDC0.CFDTMDF9_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_40.UINT32
RCFDC0.CFDTMDF10_40.UINT16[L/H]
RCFDC0.CFDTMDF10_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_40.UINT32
RCFDC0.CFDTMDF11_40.UINT16[L/H]
RCFDC0.CFDTMDF11_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_40.UINT32
RCFDC0.CFDTMDF12_40.UINT16[L/H]
RCFDC0.CFDTMDF12_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_40.UINT32
RCFDC0.CFDTMDF13_40.UINT16[L/H]
RCFDC0.CFDTMDF13_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_40.UINT32
RCFDC0.CFDTMDF14_40.UINT16[L/H]
RCFDC0.CFDTMDF14_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_40.UINT32
RCFDC0.CFDTMDF15_40.UINT16[L/H]
RCFDC0.CFDTMDF15_40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID41.UINT32
RCFDC0.CFDTMID41.UINT16[L/H]
RCFDC0.CFDTMID41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR41.UINT32
RCFDC0.CFDTMPTR41.UINT16[H]
RCFDC0.CFDTMPTR41.UINT8[HH]
RCFDC0.CFDTMFDCTR41.UINT32
RCFDC0.CFDTMFDCTR41.UINT16[L/H]
RCFDC0.CFDTMFDCTR41.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_41.UINT32
RCFDC0.CFDTMDF0_41.UINT16[L/H]
RCFDC0.CFDTMDF0_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_41.UINT32
RCFDC0.CFDTMDF1_41.UINT16[L/H]
RCFDC0.CFDTMDF1_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_41.UINT32
RCFDC0.CFDTMDF2_41.UINT16[L/H]
RCFDC0.CFDTMDF2_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_41.UINT32
RCFDC0.CFDTMDF3_41.UINT16[L/H]
RCFDC0.CFDTMDF3_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_41.UINT32
RCFDC0.CFDTMDF4_41.UINT16[L/H]
RCFDC0.CFDTMDF4_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_41.UINT32
RCFDC0.CFDTMDF5_41.UINT16[L/H]
RCFDC0.CFDTMDF5_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_41.UINT32
RCFDC0.CFDTMDF6_41.UINT16[L/H]
RCFDC0.CFDTMDF6_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_41.UINT32
RCFDC0.CFDTMDF7_41.UINT16[L/H]
RCFDC0.CFDTMDF7_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_41.UINT32
RCFDC0.CFDTMDF8_41.UINT16[L/H]
RCFDC0.CFDTMDF8_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_41.UINT32
RCFDC0.CFDTMDF9_41.UINT16[L/H]
RCFDC0.CFDTMDF9_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_41.UINT32
RCFDC0.CFDTMDF10_41.UINT16[L/H]
RCFDC0.CFDTMDF10_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_41.UINT32
RCFDC0.CFDTMDF11_41.UINT16[L/H]
RCFDC0.CFDTMDF11_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_41.UINT32
RCFDC0.CFDTMDF12_41.UINT16[L/H]
RCFDC0.CFDTMDF12_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_41.UINT32
RCFDC0.CFDTMDF13_41.UINT16[L/H]
RCFDC0.CFDTMDF13_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_41.UINT32
RCFDC0.CFDTMDF14_41.UINT16[L/H]
RCFDC0.CFDTMDF14_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_41.UINT32
RCFDC0.CFDTMDF15_41.UINT16[L/H]
RCFDC0.CFDTMDF15_41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID42.UINT32
RCFDC0.CFDTMID42.UINT16[L/H]
RCFDC0.CFDTMID42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR42.UINT32
RCFDC0.CFDTMPTR42.UINT16[H]
RCFDC0.CFDTMPTR42.UINT8[HH]
RCFDC0.CFDTMFDCTR42.UINT32
RCFDC0.CFDTMFDCTR42.UINT16[L/H]
RCFDC0.CFDTMFDCTR42.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_42.UINT32
RCFDC0.CFDTMDF0_42.UINT16[L/H]
RCFDC0.CFDTMDF0_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_42.UINT32
RCFDC0.CFDTMDF1_42.UINT16[L/H]
RCFDC0.CFDTMDF1_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_42.UINT32
RCFDC0.CFDTMDF2_42.UINT16[L/H]
RCFDC0.CFDTMDF2_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_42.UINT32
RCFDC0.CFDTMDF3_42.UINT16[L/H]
RCFDC0.CFDTMDF3_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_42.UINT32
RCFDC0.CFDTMDF4_42.UINT16[L/H]
RCFDC0.CFDTMDF4_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_42.UINT32
RCFDC0.CFDTMDF5_42.UINT16[L/H]
RCFDC0.CFDTMDF5_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_42.UINT32
RCFDC0.CFDTMDF6_42.UINT16[L/H]
RCFDC0.CFDTMDF6_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_42.UINT32
RCFDC0.CFDTMDF7_42.UINT16[L/H]
RCFDC0.CFDTMDF7_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_42.UINT32
RCFDC0.CFDTMDF8_42.UINT16[L/H]
RCFDC0.CFDTMDF8_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_42.UINT32
RCFDC0.CFDTMDF9_42.UINT16[L/H]
RCFDC0.CFDTMDF9_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_42.UINT32
RCFDC0.CFDTMDF10_42.UINT16[L/H]
RCFDC0.CFDTMDF10_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_42.UINT32
RCFDC0.CFDTMDF11_42.UINT16[L/H]
RCFDC0.CFDTMDF11_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_42.UINT32
RCFDC0.CFDTMDF12_42.UINT16[L/H]
RCFDC0.CFDTMDF12_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_42.UINT32
RCFDC0.CFDTMDF13_42.UINT16[L/H]
RCFDC0.CFDTMDF13_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_42.UINT32
RCFDC0.CFDTMDF14_42.UINT16[L/H]
RCFDC0.CFDTMDF14_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_42.UINT32
RCFDC0.CFDTMDF15_42.UINT16[L/H]
RCFDC0.CFDTMDF15_42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID43.UINT32
RCFDC0.CFDTMID43.UINT16[L/H]
RCFDC0.CFDTMID43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR43.UINT32
RCFDC0.CFDTMPTR43.UINT16[H]
RCFDC0.CFDTMPTR43.UINT8[HH]
RCFDC0.CFDTMFDCTR43.UINT32
RCFDC0.CFDTMFDCTR43.UINT16[L/H]
RCFDC0.CFDTMFDCTR43.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_43.UINT32
RCFDC0.CFDTMDF0_43.UINT16[L/H]
RCFDC0.CFDTMDF0_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_43.UINT32
RCFDC0.CFDTMDF1_43.UINT16[L/H]
RCFDC0.CFDTMDF1_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_43.UINT32
RCFDC0.CFDTMDF2_43.UINT16[L/H]
RCFDC0.CFDTMDF2_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_43.UINT32
RCFDC0.CFDTMDF3_43.UINT16[L/H]
RCFDC0.CFDTMDF3_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_43.UINT32
RCFDC0.CFDTMDF4_43.UINT16[L/H]
RCFDC0.CFDTMDF4_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_43.UINT32
RCFDC0.CFDTMDF5_43.UINT16[L/H]
RCFDC0.CFDTMDF5_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_43.UINT32
RCFDC0.CFDTMDF6_43.UINT16[L/H]
RCFDC0.CFDTMDF6_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_43.UINT32
RCFDC0.CFDTMDF7_43.UINT16[L/H]
RCFDC0.CFDTMDF7_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_43.UINT32
RCFDC0.CFDTMDF8_43.UINT16[L/H]
RCFDC0.CFDTMDF8_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_43.UINT32
RCFDC0.CFDTMDF9_43.UINT16[L/H]
RCFDC0.CFDTMDF9_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_43.UINT32
RCFDC0.CFDTMDF10_43.UINT16[L/H]
RCFDC0.CFDTMDF10_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_43.UINT32
RCFDC0.CFDTMDF11_43.UINT16[L/H]
RCFDC0.CFDTMDF11_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_43.UINT32
RCFDC0.CFDTMDF12_43.UINT16[L/H]
RCFDC0.CFDTMDF12_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_43.UINT32
RCFDC0.CFDTMDF13_43.UINT16[L/H]
RCFDC0.CFDTMDF13_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_43.UINT32
RCFDC0.CFDTMDF14_43.UINT16[L/H]
RCFDC0.CFDTMDF14_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_43.UINT32
RCFDC0.CFDTMDF15_43.UINT16[L/H]
RCFDC0.CFDTMDF15_43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID44.UINT32
RCFDC0.CFDTMID44.UINT16[L/H]
RCFDC0.CFDTMID44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR44.UINT32
RCFDC0.CFDTMPTR44.UINT16[H]
RCFDC0.CFDTMPTR44.UINT8[HH]
RCFDC0.CFDTMFDCTR44.UINT32
RCFDC0.CFDTMFDCTR44.UINT16[L/H]
RCFDC0.CFDTMFDCTR44.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_44.UINT32
RCFDC0.CFDTMDF0_44.UINT16[L/H]
RCFDC0.CFDTMDF0_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_44.UINT32
RCFDC0.CFDTMDF1_44.UINT16[L/H]
RCFDC0.CFDTMDF1_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_44.UINT32
RCFDC0.CFDTMDF2_44.UINT16[L/H]
RCFDC0.CFDTMDF2_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_44.UINT32
RCFDC0.CFDTMDF3_44.UINT16[L/H]
RCFDC0.CFDTMDF3_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_44.UINT32
RCFDC0.CFDTMDF4_44.UINT16[L/H]
RCFDC0.CFDTMDF4_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_44.UINT32
RCFDC0.CFDTMDF5_44.UINT16[L/H]
RCFDC0.CFDTMDF5_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_44.UINT32
RCFDC0.CFDTMDF6_44.UINT16[L/H]
RCFDC0.CFDTMDF6_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_44.UINT32
RCFDC0.CFDTMDF7_44.UINT16[L/H]
RCFDC0.CFDTMDF7_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_44.UINT32
RCFDC0.CFDTMDF8_44.UINT16[L/H]
RCFDC0.CFDTMDF8_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_44.UINT32
RCFDC0.CFDTMDF9_44.UINT16[L/H]
RCFDC0.CFDTMDF9_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_44.UINT32
RCFDC0.CFDTMDF10_44.UINT16[L/H]
RCFDC0.CFDTMDF10_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_44.UINT32
RCFDC0.CFDTMDF11_44.UINT16[L/H]
RCFDC0.CFDTMDF11_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_44.UINT32
RCFDC0.CFDTMDF12_44.UINT16[L/H]
RCFDC0.CFDTMDF12_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_44.UINT32
RCFDC0.CFDTMDF13_44.UINT16[L/H]
RCFDC0.CFDTMDF13_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_44.UINT32
RCFDC0.CFDTMDF14_44.UINT16[L/H]
RCFDC0.CFDTMDF14_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_44.UINT32
RCFDC0.CFDTMDF15_44.UINT16[L/H]
RCFDC0.CFDTMDF15_44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID45.UINT32
RCFDC0.CFDTMID45.UINT16[L/H]
RCFDC0.CFDTMID45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR45.UINT32
RCFDC0.CFDTMPTR45.UINT16[H]
RCFDC0.CFDTMPTR45.UINT8[HH]
RCFDC0.CFDTMFDCTR45.UINT32
RCFDC0.CFDTMFDCTR45.UINT16[L/H]
RCFDC0.CFDTMFDCTR45.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_45.UINT32
RCFDC0.CFDTMDF0_45.UINT16[L/H]
RCFDC0.CFDTMDF0_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_45.UINT32
RCFDC0.CFDTMDF1_45.UINT16[L/H]
RCFDC0.CFDTMDF1_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_45.UINT32
RCFDC0.CFDTMDF2_45.UINT16[L/H]
RCFDC0.CFDTMDF2_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_45.UINT32
RCFDC0.CFDTMDF3_45.UINT16[L/H]
RCFDC0.CFDTMDF3_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_45.UINT32
RCFDC0.CFDTMDF4_45.UINT16[L/H]
RCFDC0.CFDTMDF4_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_45.UINT32
RCFDC0.CFDTMDF5_45.UINT16[L/H]
RCFDC0.CFDTMDF5_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_45.UINT32
RCFDC0.CFDTMDF6_45.UINT16[L/H]
RCFDC0.CFDTMDF6_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_45.UINT32
RCFDC0.CFDTMDF7_45.UINT16[L/H]
RCFDC0.CFDTMDF7_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_45.UINT32
RCFDC0.CFDTMDF8_45.UINT16[L/H]
RCFDC0.CFDTMDF8_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_45.UINT32
RCFDC0.CFDTMDF9_45.UINT16[L/H]
RCFDC0.CFDTMDF9_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_45.UINT32
RCFDC0.CFDTMDF10_45.UINT16[L/H]
RCFDC0.CFDTMDF10_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_45.UINT32
RCFDC0.CFDTMDF11_45.UINT16[L/H]
RCFDC0.CFDTMDF11_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_45.UINT32
RCFDC0.CFDTMDF12_45.UINT16[L/H]
RCFDC0.CFDTMDF12_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_45.UINT32
RCFDC0.CFDTMDF13_45.UINT16[L/H]
RCFDC0.CFDTMDF13_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_45.UINT32
RCFDC0.CFDTMDF14_45.UINT16[L/H]
RCFDC0.CFDTMDF14_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_45.UINT32
RCFDC0.CFDTMDF15_45.UINT16[L/H]
RCFDC0.CFDTMDF15_45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID46.UINT32
RCFDC0.CFDTMID46.UINT16[L/H]
RCFDC0.CFDTMID46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR46.UINT32
RCFDC0.CFDTMPTR46.UINT16[H]
RCFDC0.CFDTMPTR46.UINT8[HH]
RCFDC0.CFDTMFDCTR46.UINT32
RCFDC0.CFDTMFDCTR46.UINT16[L/H]
RCFDC0.CFDTMFDCTR46.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_46.UINT32
RCFDC0.CFDTMDF0_46.UINT16[L/H]
RCFDC0.CFDTMDF0_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_46.UINT32
RCFDC0.CFDTMDF1_46.UINT16[L/H]
RCFDC0.CFDTMDF1_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_46.UINT32
RCFDC0.CFDTMDF2_46.UINT16[L/H]
RCFDC0.CFDTMDF2_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_46.UINT32
RCFDC0.CFDTMDF3_46.UINT16[L/H]
RCFDC0.CFDTMDF3_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_46.UINT32
RCFDC0.CFDTMDF4_46.UINT16[L/H]
RCFDC0.CFDTMDF4_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_46.UINT32
RCFDC0.CFDTMDF5_46.UINT16[L/H]
RCFDC0.CFDTMDF5_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_46.UINT32
RCFDC0.CFDTMDF6_46.UINT16[L/H]
RCFDC0.CFDTMDF6_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_46.UINT32
RCFDC0.CFDTMDF7_46.UINT16[L/H]
RCFDC0.CFDTMDF7_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_46.UINT32
RCFDC0.CFDTMDF8_46.UINT16[L/H]
RCFDC0.CFDTMDF8_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_46.UINT32
RCFDC0.CFDTMDF9_46.UINT16[L/H]
RCFDC0.CFDTMDF9_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_46.UINT32
RCFDC0.CFDTMDF10_46.UINT16[L/H]
RCFDC0.CFDTMDF10_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_46.UINT32
RCFDC0.CFDTMDF11_46.UINT16[L/H]
RCFDC0.CFDTMDF11_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_46.UINT32
RCFDC0.CFDTMDF12_46.UINT16[L/H]
RCFDC0.CFDTMDF12_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_46.UINT32
RCFDC0.CFDTMDF13_46.UINT16[L/H]
RCFDC0.CFDTMDF13_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_46.UINT32
RCFDC0.CFDTMDF14_46.UINT16[L/H]
RCFDC0.CFDTMDF14_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_46.UINT32
RCFDC0.CFDTMDF15_46.UINT16[L/H]
RCFDC0.CFDTMDF15_46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID47.UINT32
RCFDC0.CFDTMID47.UINT16[L/H]
RCFDC0.CFDTMID47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR47.UINT32
RCFDC0.CFDTMPTR47.UINT16[H]
RCFDC0.CFDTMPTR47.UINT8[HH]
RCFDC0.CFDTMFDCTR47.UINT32
RCFDC0.CFDTMFDCTR47.UINT16[L/H]
RCFDC0.CFDTMFDCTR47.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_47.UINT32
RCFDC0.CFDTMDF0_47.UINT16[L/H]
RCFDC0.CFDTMDF0_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_47.UINT32
RCFDC0.CFDTMDF1_47.UINT16[L/H]
RCFDC0.CFDTMDF1_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_47.UINT32
RCFDC0.CFDTMDF2_47.UINT16[L/H]
RCFDC0.CFDTMDF2_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_47.UINT32
RCFDC0.CFDTMDF3_47.UINT16[L/H]
RCFDC0.CFDTMDF3_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_47.UINT32
RCFDC0.CFDTMDF4_47.UINT16[L/H]
RCFDC0.CFDTMDF4_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_47.UINT32
RCFDC0.CFDTMDF5_47.UINT16[L/H]
RCFDC0.CFDTMDF5_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_47.UINT32
RCFDC0.CFDTMDF6_47.UINT16[L/H]
RCFDC0.CFDTMDF6_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_47.UINT32
RCFDC0.CFDTMDF7_47.UINT16[L/H]
RCFDC0.CFDTMDF7_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_47.UINT32
RCFDC0.CFDTMDF8_47.UINT16[L/H]
RCFDC0.CFDTMDF8_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_47.UINT32
RCFDC0.CFDTMDF9_47.UINT16[L/H]
RCFDC0.CFDTMDF9_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_47.UINT32
RCFDC0.CFDTMDF10_47.UINT16[L/H]
RCFDC0.CFDTMDF10_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_47.UINT32
RCFDC0.CFDTMDF11_47.UINT16[L/H]
RCFDC0.CFDTMDF11_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_47.UINT32
RCFDC0.CFDTMDF12_47.UINT16[L/H]
RCFDC0.CFDTMDF12_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_47.UINT32
RCFDC0.CFDTMDF13_47.UINT16[L/H]
RCFDC0.CFDTMDF13_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_47.UINT32
RCFDC0.CFDTMDF14_47.UINT16[L/H]
RCFDC0.CFDTMDF14_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_47.UINT32
RCFDC0.CFDTMDF15_47.UINT16[L/H]
RCFDC0.CFDTMDF15_47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID48.UINT32
RCFDC0.CFDTMID48.UINT16[L/H]
RCFDC0.CFDTMID48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR48.UINT32
RCFDC0.CFDTMPTR48.UINT16[H]
RCFDC0.CFDTMPTR48.UINT8[HH]
RCFDC0.CFDTMFDCTR48.UINT32
RCFDC0.CFDTMFDCTR48.UINT16[L/H]
RCFDC0.CFDTMFDCTR48.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_48.UINT32
RCFDC0.CFDTMDF0_48.UINT16[L/H]
RCFDC0.CFDTMDF0_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_48.UINT32
RCFDC0.CFDTMDF1_48.UINT16[L/H]
RCFDC0.CFDTMDF1_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_48.UINT32
RCFDC0.CFDTMDF2_48.UINT16[L/H]
RCFDC0.CFDTMDF2_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_48.UINT32
RCFDC0.CFDTMDF3_48.UINT16[L/H]
RCFDC0.CFDTMDF3_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_48.UINT32
RCFDC0.CFDTMDF4_48.UINT16[L/H]
RCFDC0.CFDTMDF4_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_48.UINT32
RCFDC0.CFDTMDF5_48.UINT16[L/H]
RCFDC0.CFDTMDF5_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_48.UINT32
RCFDC0.CFDTMDF6_48.UINT16[L/H]
RCFDC0.CFDTMDF6_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_48.UINT32
RCFDC0.CFDTMDF7_48.UINT16[L/H]
RCFDC0.CFDTMDF7_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_48.UINT32
RCFDC0.CFDTMDF8_48.UINT16[L/H]
RCFDC0.CFDTMDF8_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_48.UINT32
RCFDC0.CFDTMDF9_48.UINT16[L/H]
RCFDC0.CFDTMDF9_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_48.UINT32
RCFDC0.CFDTMDF10_48.UINT16[L/H]
RCFDC0.CFDTMDF10_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_48.UINT32
RCFDC0.CFDTMDF11_48.UINT16[L/H]
RCFDC0.CFDTMDF11_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_48.UINT32
RCFDC0.CFDTMDF12_48.UINT16[L/H]
RCFDC0.CFDTMDF12_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_48.UINT32
RCFDC0.CFDTMDF13_48.UINT16[L/H]
RCFDC0.CFDTMDF13_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_48.UINT32
RCFDC0.CFDTMDF14_48.UINT16[L/H]
RCFDC0.CFDTMDF14_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_48.UINT32
RCFDC0.CFDTMDF15_48.UINT16[L/H]
RCFDC0.CFDTMDF15_48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID49.UINT32
RCFDC0.CFDTMID49.UINT16[L/H]
RCFDC0.CFDTMID49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR49.UINT32
RCFDC0.CFDTMPTR49.UINT16[H]
RCFDC0.CFDTMPTR49.UINT8[HH]
RCFDC0.CFDTMFDCTR49.UINT32
RCFDC0.CFDTMFDCTR49.UINT16[L/H]
RCFDC0.CFDTMFDCTR49.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_49.UINT32
RCFDC0.CFDTMDF0_49.UINT16[L/H]
RCFDC0.CFDTMDF0_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_49.UINT32
RCFDC0.CFDTMDF1_49.UINT16[L/H]
RCFDC0.CFDTMDF1_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_49.UINT32
RCFDC0.CFDTMDF2_49.UINT16[L/H]
RCFDC0.CFDTMDF2_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_49.UINT32
RCFDC0.CFDTMDF3_49.UINT16[L/H]
RCFDC0.CFDTMDF3_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_49.UINT32
RCFDC0.CFDTMDF4_49.UINT16[L/H]
RCFDC0.CFDTMDF4_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_49.UINT32
RCFDC0.CFDTMDF5_49.UINT16[L/H]
RCFDC0.CFDTMDF5_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_49.UINT32
RCFDC0.CFDTMDF6_49.UINT16[L/H]
RCFDC0.CFDTMDF6_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_49.UINT32
RCFDC0.CFDTMDF7_49.UINT16[L/H]
RCFDC0.CFDTMDF7_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_49.UINT32
RCFDC0.CFDTMDF8_49.UINT16[L/H]
RCFDC0.CFDTMDF8_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_49.UINT32
RCFDC0.CFDTMDF9_49.UINT16[L/H]
RCFDC0.CFDTMDF9_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_49.UINT32
RCFDC0.CFDTMDF10_49.UINT16[L/H]
RCFDC0.CFDTMDF10_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_49.UINT32
RCFDC0.CFDTMDF11_49.UINT16[L/H]
RCFDC0.CFDTMDF11_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_49.UINT32
RCFDC0.CFDTMDF12_49.UINT16[L/H]
RCFDC0.CFDTMDF12_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_49.UINT32
RCFDC0.CFDTMDF13_49.UINT16[L/H]
RCFDC0.CFDTMDF13_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_49.UINT32
RCFDC0.CFDTMDF14_49.UINT16[L/H]
RCFDC0.CFDTMDF14_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_49.UINT32
RCFDC0.CFDTMDF15_49.UINT16[L/H]
RCFDC0.CFDTMDF15_49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID50.UINT32
RCFDC0.CFDTMID50.UINT16[L/H]
RCFDC0.CFDTMID50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR50.UINT32
RCFDC0.CFDTMPTR50.UINT16[H]
RCFDC0.CFDTMPTR50.UINT8[HH]
RCFDC0.CFDTMFDCTR50.UINT32
RCFDC0.CFDTMFDCTR50.UINT16[L/H]
RCFDC0.CFDTMFDCTR50.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_50.UINT32
RCFDC0.CFDTMDF0_50.UINT16[L/H]
RCFDC0.CFDTMDF0_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_50.UINT32
RCFDC0.CFDTMDF1_50.UINT16[L/H]
RCFDC0.CFDTMDF1_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_50.UINT32
RCFDC0.CFDTMDF2_50.UINT16[L/H]
RCFDC0.CFDTMDF2_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_50.UINT32
RCFDC0.CFDTMDF3_50.UINT16[L/H]
RCFDC0.CFDTMDF3_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_50.UINT32
RCFDC0.CFDTMDF4_50.UINT16[L/H]
RCFDC0.CFDTMDF4_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_50.UINT32
RCFDC0.CFDTMDF5_50.UINT16[L/H]
RCFDC0.CFDTMDF5_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_50.UINT32
RCFDC0.CFDTMDF6_50.UINT16[L/H]
RCFDC0.CFDTMDF6_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_50.UINT32
RCFDC0.CFDTMDF7_50.UINT16[L/H]
RCFDC0.CFDTMDF7_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_50.UINT32
RCFDC0.CFDTMDF8_50.UINT16[L/H]
RCFDC0.CFDTMDF8_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_50.UINT32
RCFDC0.CFDTMDF9_50.UINT16[L/H]
RCFDC0.CFDTMDF9_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_50.UINT32
RCFDC0.CFDTMDF10_50.UINT16[L/H]
RCFDC0.CFDTMDF10_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_50.UINT32
RCFDC0.CFDTMDF11_50.UINT16[L/H]
RCFDC0.CFDTMDF11_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_50.UINT32
RCFDC0.CFDTMDF12_50.UINT16[L/H]
RCFDC0.CFDTMDF12_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_50.UINT32
RCFDC0.CFDTMDF13_50.UINT16[L/H]
RCFDC0.CFDTMDF13_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_50.UINT32
RCFDC0.CFDTMDF14_50.UINT16[L/H]
RCFDC0.CFDTMDF14_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_50.UINT32
RCFDC0.CFDTMDF15_50.UINT16[L/H]
RCFDC0.CFDTMDF15_50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID51.UINT32
RCFDC0.CFDTMID51.UINT16[L/H]
RCFDC0.CFDTMID51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR51.UINT32
RCFDC0.CFDTMPTR51.UINT16[H]
RCFDC0.CFDTMPTR51.UINT8[HH]
RCFDC0.CFDTMFDCTR51.UINT32
RCFDC0.CFDTMFDCTR51.UINT16[L/H]
RCFDC0.CFDTMFDCTR51.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_51.UINT32
RCFDC0.CFDTMDF0_51.UINT16[L/H]
RCFDC0.CFDTMDF0_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_51.UINT32
RCFDC0.CFDTMDF1_51.UINT16[L/H]
RCFDC0.CFDTMDF1_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_51.UINT32
RCFDC0.CFDTMDF2_51.UINT16[L/H]
RCFDC0.CFDTMDF2_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_51.UINT32
RCFDC0.CFDTMDF3_51.UINT16[L/H]
RCFDC0.CFDTMDF3_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_51.UINT32
RCFDC0.CFDTMDF4_51.UINT16[L/H]
RCFDC0.CFDTMDF4_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_51.UINT32
RCFDC0.CFDTMDF5_51.UINT16[L/H]
RCFDC0.CFDTMDF5_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_51.UINT32
RCFDC0.CFDTMDF6_51.UINT16[L/H]
RCFDC0.CFDTMDF6_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_51.UINT32
RCFDC0.CFDTMDF7_51.UINT16[L/H]
RCFDC0.CFDTMDF7_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_51.UINT32
RCFDC0.CFDTMDF8_51.UINT16[L/H]
RCFDC0.CFDTMDF8_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_51.UINT32
RCFDC0.CFDTMDF9_51.UINT16[L/H]
RCFDC0.CFDTMDF9_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_51.UINT32
RCFDC0.CFDTMDF10_51.UINT16[L/H]
RCFDC0.CFDTMDF10_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_51.UINT32
RCFDC0.CFDTMDF11_51.UINT16[L/H]
RCFDC0.CFDTMDF11_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_51.UINT32
RCFDC0.CFDTMDF12_51.UINT16[L/H]
RCFDC0.CFDTMDF12_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_51.UINT32
RCFDC0.CFDTMDF13_51.UINT16[L/H]
RCFDC0.CFDTMDF13_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_51.UINT32
RCFDC0.CFDTMDF14_51.UINT16[L/H]
RCFDC0.CFDTMDF14_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_51.UINT32
RCFDC0.CFDTMDF15_51.UINT16[L/H]
RCFDC0.CFDTMDF15_51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID52.UINT32
RCFDC0.CFDTMID52.UINT16[L/H]
RCFDC0.CFDTMID52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR52.UINT32
RCFDC0.CFDTMPTR52.UINT16[H]
RCFDC0.CFDTMPTR52.UINT8[HH]
RCFDC0.CFDTMFDCTR52.UINT32
RCFDC0.CFDTMFDCTR52.UINT16[L/H]
RCFDC0.CFDTMFDCTR52.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_52.UINT32
RCFDC0.CFDTMDF0_52.UINT16[L/H]
RCFDC0.CFDTMDF0_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_52.UINT32
RCFDC0.CFDTMDF1_52.UINT16[L/H]
RCFDC0.CFDTMDF1_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_52.UINT32
RCFDC0.CFDTMDF2_52.UINT16[L/H]
RCFDC0.CFDTMDF2_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_52.UINT32
RCFDC0.CFDTMDF3_52.UINT16[L/H]
RCFDC0.CFDTMDF3_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_52.UINT32
RCFDC0.CFDTMDF4_52.UINT16[L/H]
RCFDC0.CFDTMDF4_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_52.UINT32
RCFDC0.CFDTMDF5_52.UINT16[L/H]
RCFDC0.CFDTMDF5_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_52.UINT32
RCFDC0.CFDTMDF6_52.UINT16[L/H]
RCFDC0.CFDTMDF6_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_52.UINT32
RCFDC0.CFDTMDF7_52.UINT16[L/H]
RCFDC0.CFDTMDF7_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_52.UINT32
RCFDC0.CFDTMDF8_52.UINT16[L/H]
RCFDC0.CFDTMDF8_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_52.UINT32
RCFDC0.CFDTMDF9_52.UINT16[L/H]
RCFDC0.CFDTMDF9_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_52.UINT32
RCFDC0.CFDTMDF10_52.UINT16[L/H]
RCFDC0.CFDTMDF10_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_52.UINT32
RCFDC0.CFDTMDF11_52.UINT16[L/H]
RCFDC0.CFDTMDF11_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_52.UINT32
RCFDC0.CFDTMDF12_52.UINT16[L/H]
RCFDC0.CFDTMDF12_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_52.UINT32
RCFDC0.CFDTMDF13_52.UINT16[L/H]
RCFDC0.CFDTMDF13_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_52.UINT32
RCFDC0.CFDTMDF14_52.UINT16[L/H]
RCFDC0.CFDTMDF14_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_52.UINT32
RCFDC0.CFDTMDF15_52.UINT16[L/H]
RCFDC0.CFDTMDF15_52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID53.UINT32
RCFDC0.CFDTMID53.UINT16[L/H]
RCFDC0.CFDTMID53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR53.UINT32
RCFDC0.CFDTMPTR53.UINT16[H]
RCFDC0.CFDTMPTR53.UINT8[HH]
RCFDC0.CFDTMFDCTR53.UINT32
RCFDC0.CFDTMFDCTR53.UINT16[L/H]
RCFDC0.CFDTMFDCTR53.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_53.UINT32
RCFDC0.CFDTMDF0_53.UINT16[L/H]
RCFDC0.CFDTMDF0_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_53.UINT32
RCFDC0.CFDTMDF1_53.UINT16[L/H]
RCFDC0.CFDTMDF1_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_53.UINT32
RCFDC0.CFDTMDF2_53.UINT16[L/H]
RCFDC0.CFDTMDF2_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_53.UINT32
RCFDC0.CFDTMDF3_53.UINT16[L/H]
RCFDC0.CFDTMDF3_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_53.UINT32
RCFDC0.CFDTMDF4_53.UINT16[L/H]
RCFDC0.CFDTMDF4_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_53.UINT32
RCFDC0.CFDTMDF5_53.UINT16[L/H]
RCFDC0.CFDTMDF5_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_53.UINT32
RCFDC0.CFDTMDF6_53.UINT16[L/H]
RCFDC0.CFDTMDF6_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_53.UINT32
RCFDC0.CFDTMDF7_53.UINT16[L/H]
RCFDC0.CFDTMDF7_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_53.UINT32
RCFDC0.CFDTMDF8_53.UINT16[L/H]
RCFDC0.CFDTMDF8_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_53.UINT32
RCFDC0.CFDTMDF9_53.UINT16[L/H]
RCFDC0.CFDTMDF9_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_53.UINT32
RCFDC0.CFDTMDF10_53.UINT16[L/H]
RCFDC0.CFDTMDF10_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_53.UINT32
RCFDC0.CFDTMDF11_53.UINT16[L/H]
RCFDC0.CFDTMDF11_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_53.UINT32
RCFDC0.CFDTMDF12_53.UINT16[L/H]
RCFDC0.CFDTMDF12_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_53.UINT32
RCFDC0.CFDTMDF13_53.UINT16[L/H]
RCFDC0.CFDTMDF13_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_53.UINT32
RCFDC0.CFDTMDF14_53.UINT16[L/H]
RCFDC0.CFDTMDF14_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_53.UINT32
RCFDC0.CFDTMDF15_53.UINT16[L/H]
RCFDC0.CFDTMDF15_53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID54.UINT32
RCFDC0.CFDTMID54.UINT16[L/H]
RCFDC0.CFDTMID54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR54.UINT32
RCFDC0.CFDTMPTR54.UINT16[H]
RCFDC0.CFDTMPTR54.UINT8[HH]
RCFDC0.CFDTMFDCTR54.UINT32
RCFDC0.CFDTMFDCTR54.UINT16[L/H]
RCFDC0.CFDTMFDCTR54.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_54.UINT32
RCFDC0.CFDTMDF0_54.UINT16[L/H]
RCFDC0.CFDTMDF0_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_54.UINT32
RCFDC0.CFDTMDF1_54.UINT16[L/H]
RCFDC0.CFDTMDF1_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_54.UINT32
RCFDC0.CFDTMDF2_54.UINT16[L/H]
RCFDC0.CFDTMDF2_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_54.UINT32
RCFDC0.CFDTMDF3_54.UINT16[L/H]
RCFDC0.CFDTMDF3_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_54.UINT32
RCFDC0.CFDTMDF4_54.UINT16[L/H]
RCFDC0.CFDTMDF4_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_54.UINT32
RCFDC0.CFDTMDF5_54.UINT16[L/H]
RCFDC0.CFDTMDF5_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_54.UINT32
RCFDC0.CFDTMDF6_54.UINT16[L/H]
RCFDC0.CFDTMDF6_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_54.UINT32
RCFDC0.CFDTMDF7_54.UINT16[L/H]
RCFDC0.CFDTMDF7_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_54.UINT32
RCFDC0.CFDTMDF8_54.UINT16[L/H]
RCFDC0.CFDTMDF8_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_54.UINT32
RCFDC0.CFDTMDF9_54.UINT16[L/H]
RCFDC0.CFDTMDF9_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_54.UINT32
RCFDC0.CFDTMDF10_54.UINT16[L/H]
RCFDC0.CFDTMDF10_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_54.UINT32
RCFDC0.CFDTMDF11_54.UINT16[L/H]
RCFDC0.CFDTMDF11_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_54.UINT32
RCFDC0.CFDTMDF12_54.UINT16[L/H]
RCFDC0.CFDTMDF12_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_54.UINT32
RCFDC0.CFDTMDF13_54.UINT16[L/H]
RCFDC0.CFDTMDF13_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_54.UINT32
RCFDC0.CFDTMDF14_54.UINT16[L/H]
RCFDC0.CFDTMDF14_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_54.UINT32
RCFDC0.CFDTMDF15_54.UINT16[L/H]
RCFDC0.CFDTMDF15_54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID55.UINT32
RCFDC0.CFDTMID55.UINT16[L/H]
RCFDC0.CFDTMID55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR55.UINT32
RCFDC0.CFDTMPTR55.UINT16[H]
RCFDC0.CFDTMPTR55.UINT8[HH]
RCFDC0.CFDTMFDCTR55.UINT32
RCFDC0.CFDTMFDCTR55.UINT16[L/H]
RCFDC0.CFDTMFDCTR55.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_55.UINT32
RCFDC0.CFDTMDF0_55.UINT16[L/H]
RCFDC0.CFDTMDF0_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_55.UINT32
RCFDC0.CFDTMDF1_55.UINT16[L/H]
RCFDC0.CFDTMDF1_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_55.UINT32
RCFDC0.CFDTMDF2_55.UINT16[L/H]
RCFDC0.CFDTMDF2_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_55.UINT32
RCFDC0.CFDTMDF3_55.UINT16[L/H]
RCFDC0.CFDTMDF3_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_55.UINT32
RCFDC0.CFDTMDF4_55.UINT16[L/H]
RCFDC0.CFDTMDF4_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_55.UINT32
RCFDC0.CFDTMDF5_55.UINT16[L/H]
RCFDC0.CFDTMDF5_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_55.UINT32
RCFDC0.CFDTMDF6_55.UINT16[L/H]
RCFDC0.CFDTMDF6_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_55.UINT32
RCFDC0.CFDTMDF7_55.UINT16[L/H]
RCFDC0.CFDTMDF7_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_55.UINT32
RCFDC0.CFDTMDF8_55.UINT16[L/H]
RCFDC0.CFDTMDF8_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_55.UINT32
RCFDC0.CFDTMDF9_55.UINT16[L/H]
RCFDC0.CFDTMDF9_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_55.UINT32
RCFDC0.CFDTMDF10_55.UINT16[L/H]
RCFDC0.CFDTMDF10_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_55.UINT32
RCFDC0.CFDTMDF11_55.UINT16[L/H]
RCFDC0.CFDTMDF11_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_55.UINT32
RCFDC0.CFDTMDF12_55.UINT16[L/H]
RCFDC0.CFDTMDF12_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_55.UINT32
RCFDC0.CFDTMDF13_55.UINT16[L/H]
RCFDC0.CFDTMDF13_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_55.UINT32
RCFDC0.CFDTMDF14_55.UINT16[L/H]
RCFDC0.CFDTMDF14_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_55.UINT32
RCFDC0.CFDTMDF15_55.UINT16[L/H]
RCFDC0.CFDTMDF15_55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID56.UINT32
RCFDC0.CFDTMID56.UINT16[L/H]
RCFDC0.CFDTMID56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR56.UINT32
RCFDC0.CFDTMPTR56.UINT16[H]
RCFDC0.CFDTMPTR56.UINT8[HH]
RCFDC0.CFDTMFDCTR56.UINT32
RCFDC0.CFDTMFDCTR56.UINT16[L/H]
RCFDC0.CFDTMFDCTR56.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_56.UINT32
RCFDC0.CFDTMDF0_56.UINT16[L/H]
RCFDC0.CFDTMDF0_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_56.UINT32
RCFDC0.CFDTMDF1_56.UINT16[L/H]
RCFDC0.CFDTMDF1_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_56.UINT32
RCFDC0.CFDTMDF2_56.UINT16[L/H]
RCFDC0.CFDTMDF2_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_56.UINT32
RCFDC0.CFDTMDF3_56.UINT16[L/H]
RCFDC0.CFDTMDF3_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_56.UINT32
RCFDC0.CFDTMDF4_56.UINT16[L/H]
RCFDC0.CFDTMDF4_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_56.UINT32
RCFDC0.CFDTMDF5_56.UINT16[L/H]
RCFDC0.CFDTMDF5_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_56.UINT32
RCFDC0.CFDTMDF6_56.UINT16[L/H]
RCFDC0.CFDTMDF6_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_56.UINT32
RCFDC0.CFDTMDF7_56.UINT16[L/H]
RCFDC0.CFDTMDF7_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_56.UINT32
RCFDC0.CFDTMDF8_56.UINT16[L/H]
RCFDC0.CFDTMDF8_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_56.UINT32
RCFDC0.CFDTMDF9_56.UINT16[L/H]
RCFDC0.CFDTMDF9_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_56.UINT32
RCFDC0.CFDTMDF10_56.UINT16[L/H]
RCFDC0.CFDTMDF10_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_56.UINT32
RCFDC0.CFDTMDF11_56.UINT16[L/H]
RCFDC0.CFDTMDF11_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_56.UINT32
RCFDC0.CFDTMDF12_56.UINT16[L/H]
RCFDC0.CFDTMDF12_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_56.UINT32
RCFDC0.CFDTMDF13_56.UINT16[L/H]
RCFDC0.CFDTMDF13_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_56.UINT32
RCFDC0.CFDTMDF14_56.UINT16[L/H]
RCFDC0.CFDTMDF14_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_56.UINT32
RCFDC0.CFDTMDF15_56.UINT16[L/H]
RCFDC0.CFDTMDF15_56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID57.UINT32
RCFDC0.CFDTMID57.UINT16[L/H]
RCFDC0.CFDTMID57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR57.UINT32
RCFDC0.CFDTMPTR57.UINT16[H]
RCFDC0.CFDTMPTR57.UINT8[HH]
RCFDC0.CFDTMFDCTR57.UINT32
RCFDC0.CFDTMFDCTR57.UINT16[L/H]
RCFDC0.CFDTMFDCTR57.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_57.UINT32
RCFDC0.CFDTMDF0_57.UINT16[L/H]
RCFDC0.CFDTMDF0_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_57.UINT32
RCFDC0.CFDTMDF1_57.UINT16[L/H]
RCFDC0.CFDTMDF1_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_57.UINT32
RCFDC0.CFDTMDF2_57.UINT16[L/H]
RCFDC0.CFDTMDF2_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_57.UINT32
RCFDC0.CFDTMDF3_57.UINT16[L/H]
RCFDC0.CFDTMDF3_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_57.UINT32
RCFDC0.CFDTMDF4_57.UINT16[L/H]
RCFDC0.CFDTMDF4_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_57.UINT32
RCFDC0.CFDTMDF5_57.UINT16[L/H]
RCFDC0.CFDTMDF5_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_57.UINT32
RCFDC0.CFDTMDF6_57.UINT16[L/H]
RCFDC0.CFDTMDF6_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_57.UINT32
RCFDC0.CFDTMDF7_57.UINT16[L/H]
RCFDC0.CFDTMDF7_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_57.UINT32
RCFDC0.CFDTMDF8_57.UINT16[L/H]
RCFDC0.CFDTMDF8_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_57.UINT32
RCFDC0.CFDTMDF9_57.UINT16[L/H]
RCFDC0.CFDTMDF9_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_57.UINT32
RCFDC0.CFDTMDF10_57.UINT16[L/H]
RCFDC0.CFDTMDF10_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_57.UINT32
RCFDC0.CFDTMDF11_57.UINT16[L/H]
RCFDC0.CFDTMDF11_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_57.UINT32
RCFDC0.CFDTMDF12_57.UINT16[L/H]
RCFDC0.CFDTMDF12_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_57.UINT32
RCFDC0.CFDTMDF13_57.UINT16[L/H]
RCFDC0.CFDTMDF13_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_57.UINT32
RCFDC0.CFDTMDF14_57.UINT16[L/H]
RCFDC0.CFDTMDF14_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_57.UINT32
RCFDC0.CFDTMDF15_57.UINT16[L/H]
RCFDC0.CFDTMDF15_57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID58.UINT32
RCFDC0.CFDTMID58.UINT16[L/H]
RCFDC0.CFDTMID58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR58.UINT32
RCFDC0.CFDTMPTR58.UINT16[H]
RCFDC0.CFDTMPTR58.UINT8[HH]
RCFDC0.CFDTMFDCTR58.UINT32
RCFDC0.CFDTMFDCTR58.UINT16[L/H]
RCFDC0.CFDTMFDCTR58.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_58.UINT32
RCFDC0.CFDTMDF0_58.UINT16[L/H]
RCFDC0.CFDTMDF0_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_58.UINT32
RCFDC0.CFDTMDF1_58.UINT16[L/H]
RCFDC0.CFDTMDF1_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_58.UINT32
RCFDC0.CFDTMDF2_58.UINT16[L/H]
RCFDC0.CFDTMDF2_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_58.UINT32
RCFDC0.CFDTMDF3_58.UINT16[L/H]
RCFDC0.CFDTMDF3_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_58.UINT32
RCFDC0.CFDTMDF4_58.UINT16[L/H]
RCFDC0.CFDTMDF4_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_58.UINT32
RCFDC0.CFDTMDF5_58.UINT16[L/H]
RCFDC0.CFDTMDF5_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_58.UINT32
RCFDC0.CFDTMDF6_58.UINT16[L/H]
RCFDC0.CFDTMDF6_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_58.UINT32
RCFDC0.CFDTMDF7_58.UINT16[L/H]
RCFDC0.CFDTMDF7_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_58.UINT32
RCFDC0.CFDTMDF8_58.UINT16[L/H]
RCFDC0.CFDTMDF8_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_58.UINT32
RCFDC0.CFDTMDF9_58.UINT16[L/H]
RCFDC0.CFDTMDF9_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_58.UINT32
RCFDC0.CFDTMDF10_58.UINT16[L/H]
RCFDC0.CFDTMDF10_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_58.UINT32
RCFDC0.CFDTMDF11_58.UINT16[L/H]
RCFDC0.CFDTMDF11_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_58.UINT32
RCFDC0.CFDTMDF12_58.UINT16[L/H]
RCFDC0.CFDTMDF12_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_58.UINT32
RCFDC0.CFDTMDF13_58.UINT16[L/H]
RCFDC0.CFDTMDF13_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_58.UINT32
RCFDC0.CFDTMDF14_58.UINT16[L/H]
RCFDC0.CFDTMDF14_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_58.UINT32
RCFDC0.CFDTMDF15_58.UINT16[L/H]
RCFDC0.CFDTMDF15_58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID59.UINT32
RCFDC0.CFDTMID59.UINT16[L/H]
RCFDC0.CFDTMID59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR59.UINT32
RCFDC0.CFDTMPTR59.UINT16[H]
RCFDC0.CFDTMPTR59.UINT8[HH]
RCFDC0.CFDTMFDCTR59.UINT32
RCFDC0.CFDTMFDCTR59.UINT16[L/H]
RCFDC0.CFDTMFDCTR59.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_59.UINT32
RCFDC0.CFDTMDF0_59.UINT16[L/H]
RCFDC0.CFDTMDF0_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_59.UINT32
RCFDC0.CFDTMDF1_59.UINT16[L/H]
RCFDC0.CFDTMDF1_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_59.UINT32
RCFDC0.CFDTMDF2_59.UINT16[L/H]
RCFDC0.CFDTMDF2_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_59.UINT32
RCFDC0.CFDTMDF3_59.UINT16[L/H]
RCFDC0.CFDTMDF3_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_59.UINT32
RCFDC0.CFDTMDF4_59.UINT16[L/H]
RCFDC0.CFDTMDF4_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_59.UINT32
RCFDC0.CFDTMDF5_59.UINT16[L/H]
RCFDC0.CFDTMDF5_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_59.UINT32
RCFDC0.CFDTMDF6_59.UINT16[L/H]
RCFDC0.CFDTMDF6_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_59.UINT32
RCFDC0.CFDTMDF7_59.UINT16[L/H]
RCFDC0.CFDTMDF7_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_59.UINT32
RCFDC0.CFDTMDF8_59.UINT16[L/H]
RCFDC0.CFDTMDF8_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_59.UINT32
RCFDC0.CFDTMDF9_59.UINT16[L/H]
RCFDC0.CFDTMDF9_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_59.UINT32
RCFDC0.CFDTMDF10_59.UINT16[L/H]
RCFDC0.CFDTMDF10_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_59.UINT32
RCFDC0.CFDTMDF11_59.UINT16[L/H]
RCFDC0.CFDTMDF11_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_59.UINT32
RCFDC0.CFDTMDF12_59.UINT16[L/H]
RCFDC0.CFDTMDF12_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_59.UINT32
RCFDC0.CFDTMDF13_59.UINT16[L/H]
RCFDC0.CFDTMDF13_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_59.UINT32
RCFDC0.CFDTMDF14_59.UINT16[L/H]
RCFDC0.CFDTMDF14_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_59.UINT32
RCFDC0.CFDTMDF15_59.UINT16[L/H]
RCFDC0.CFDTMDF15_59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID60.UINT32
RCFDC0.CFDTMID60.UINT16[L/H]
RCFDC0.CFDTMID60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR60.UINT32
RCFDC0.CFDTMPTR60.UINT16[H]
RCFDC0.CFDTMPTR60.UINT8[HH]
RCFDC0.CFDTMFDCTR60.UINT32
RCFDC0.CFDTMFDCTR60.UINT16[L/H]
RCFDC0.CFDTMFDCTR60.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_60.UINT32
RCFDC0.CFDTMDF0_60.UINT16[L/H]
RCFDC0.CFDTMDF0_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_60.UINT32
RCFDC0.CFDTMDF1_60.UINT16[L/H]
RCFDC0.CFDTMDF1_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_60.UINT32
RCFDC0.CFDTMDF2_60.UINT16[L/H]
RCFDC0.CFDTMDF2_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_60.UINT32
RCFDC0.CFDTMDF3_60.UINT16[L/H]
RCFDC0.CFDTMDF3_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_60.UINT32
RCFDC0.CFDTMDF4_60.UINT16[L/H]
RCFDC0.CFDTMDF4_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_60.UINT32
RCFDC0.CFDTMDF5_60.UINT16[L/H]
RCFDC0.CFDTMDF5_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_60.UINT32
RCFDC0.CFDTMDF6_60.UINT16[L/H]
RCFDC0.CFDTMDF6_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_60.UINT32
RCFDC0.CFDTMDF7_60.UINT16[L/H]
RCFDC0.CFDTMDF7_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_60.UINT32
RCFDC0.CFDTMDF8_60.UINT16[L/H]
RCFDC0.CFDTMDF8_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_60.UINT32
RCFDC0.CFDTMDF9_60.UINT16[L/H]
RCFDC0.CFDTMDF9_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_60.UINT32
RCFDC0.CFDTMDF10_60.UINT16[L/H]
RCFDC0.CFDTMDF10_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_60.UINT32
RCFDC0.CFDTMDF11_60.UINT16[L/H]
RCFDC0.CFDTMDF11_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_60.UINT32
RCFDC0.CFDTMDF12_60.UINT16[L/H]
RCFDC0.CFDTMDF12_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_60.UINT32
RCFDC0.CFDTMDF13_60.UINT16[L/H]
RCFDC0.CFDTMDF13_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_60.UINT32
RCFDC0.CFDTMDF14_60.UINT16[L/H]
RCFDC0.CFDTMDF14_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_60.UINT32
RCFDC0.CFDTMDF15_60.UINT16[L/H]
RCFDC0.CFDTMDF15_60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID61.UINT32
RCFDC0.CFDTMID61.UINT16[L/H]
RCFDC0.CFDTMID61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR61.UINT32
RCFDC0.CFDTMPTR61.UINT16[H]
RCFDC0.CFDTMPTR61.UINT8[HH]
RCFDC0.CFDTMFDCTR61.UINT32
RCFDC0.CFDTMFDCTR61.UINT16[L/H]
RCFDC0.CFDTMFDCTR61.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_61.UINT32
RCFDC0.CFDTMDF0_61.UINT16[L/H]
RCFDC0.CFDTMDF0_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_61.UINT32
RCFDC0.CFDTMDF1_61.UINT16[L/H]
RCFDC0.CFDTMDF1_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_61.UINT32
RCFDC0.CFDTMDF2_61.UINT16[L/H]
RCFDC0.CFDTMDF2_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_61.UINT32
RCFDC0.CFDTMDF3_61.UINT16[L/H]
RCFDC0.CFDTMDF3_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_61.UINT32
RCFDC0.CFDTMDF4_61.UINT16[L/H]
RCFDC0.CFDTMDF4_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_61.UINT32
RCFDC0.CFDTMDF5_61.UINT16[L/H]
RCFDC0.CFDTMDF5_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_61.UINT32
RCFDC0.CFDTMDF6_61.UINT16[L/H]
RCFDC0.CFDTMDF6_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_61.UINT32
RCFDC0.CFDTMDF7_61.UINT16[L/H]
RCFDC0.CFDTMDF7_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_61.UINT32
RCFDC0.CFDTMDF8_61.UINT16[L/H]
RCFDC0.CFDTMDF8_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_61.UINT32
RCFDC0.CFDTMDF9_61.UINT16[L/H]
RCFDC0.CFDTMDF9_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_61.UINT32
RCFDC0.CFDTMDF10_61.UINT16[L/H]
RCFDC0.CFDTMDF10_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_61.UINT32
RCFDC0.CFDTMDF11_61.UINT16[L/H]
RCFDC0.CFDTMDF11_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_61.UINT32
RCFDC0.CFDTMDF12_61.UINT16[L/H]
RCFDC0.CFDTMDF12_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_61.UINT32
RCFDC0.CFDTMDF13_61.UINT16[L/H]
RCFDC0.CFDTMDF13_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_61.UINT32
RCFDC0.CFDTMDF14_61.UINT16[L/H]
RCFDC0.CFDTMDF14_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_61.UINT32
RCFDC0.CFDTMDF15_61.UINT16[L/H]
RCFDC0.CFDTMDF15_61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID62.UINT32
RCFDC0.CFDTMID62.UINT16[L/H]
RCFDC0.CFDTMID62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR62.UINT32
RCFDC0.CFDTMPTR62.UINT16[H]
RCFDC0.CFDTMPTR62.UINT8[HH]
RCFDC0.CFDTMFDCTR62.UINT32
RCFDC0.CFDTMFDCTR62.UINT16[L/H]
RCFDC0.CFDTMFDCTR62.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_62.UINT32
RCFDC0.CFDTMDF0_62.UINT16[L/H]
RCFDC0.CFDTMDF0_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_62.UINT32
RCFDC0.CFDTMDF1_62.UINT16[L/H]
RCFDC0.CFDTMDF1_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_62.UINT32
RCFDC0.CFDTMDF2_62.UINT16[L/H]
RCFDC0.CFDTMDF2_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_62.UINT32
RCFDC0.CFDTMDF3_62.UINT16[L/H]
RCFDC0.CFDTMDF3_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_62.UINT32
RCFDC0.CFDTMDF4_62.UINT16[L/H]
RCFDC0.CFDTMDF4_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_62.UINT32
RCFDC0.CFDTMDF5_62.UINT16[L/H]
RCFDC0.CFDTMDF5_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_62.UINT32
RCFDC0.CFDTMDF6_62.UINT16[L/H]
RCFDC0.CFDTMDF6_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_62.UINT32
RCFDC0.CFDTMDF7_62.UINT16[L/H]
RCFDC0.CFDTMDF7_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_62.UINT32
RCFDC0.CFDTMDF8_62.UINT16[L/H]
RCFDC0.CFDTMDF8_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_62.UINT32
RCFDC0.CFDTMDF9_62.UINT16[L/H]
RCFDC0.CFDTMDF9_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_62.UINT32
RCFDC0.CFDTMDF10_62.UINT16[L/H]
RCFDC0.CFDTMDF10_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_62.UINT32
RCFDC0.CFDTMDF11_62.UINT16[L/H]
RCFDC0.CFDTMDF11_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_62.UINT32
RCFDC0.CFDTMDF12_62.UINT16[L/H]
RCFDC0.CFDTMDF12_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_62.UINT32
RCFDC0.CFDTMDF13_62.UINT16[L/H]
RCFDC0.CFDTMDF13_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_62.UINT32
RCFDC0.CFDTMDF14_62.UINT16[L/H]
RCFDC0.CFDTMDF14_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_62.UINT32
RCFDC0.CFDTMDF15_62.UINT16[L/H]
RCFDC0.CFDTMDF15_62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID63.UINT32
RCFDC0.CFDTMID63.UINT16[L/H]
RCFDC0.CFDTMID63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR63.UINT32
RCFDC0.CFDTMPTR63.UINT16[H]
RCFDC0.CFDTMPTR63.UINT8[HH]
RCFDC0.CFDTMFDCTR63.UINT32
RCFDC0.CFDTMFDCTR63.UINT16[L/H]
RCFDC0.CFDTMFDCTR63.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_63.UINT32
RCFDC0.CFDTMDF0_63.UINT16[L/H]
RCFDC0.CFDTMDF0_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_63.UINT32
RCFDC0.CFDTMDF1_63.UINT16[L/H]
RCFDC0.CFDTMDF1_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_63.UINT32
RCFDC0.CFDTMDF2_63.UINT16[L/H]
RCFDC0.CFDTMDF2_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_63.UINT32
RCFDC0.CFDTMDF3_63.UINT16[L/H]
RCFDC0.CFDTMDF3_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_63.UINT32
RCFDC0.CFDTMDF4_63.UINT16[L/H]
RCFDC0.CFDTMDF4_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_63.UINT32
RCFDC0.CFDTMDF5_63.UINT16[L/H]
RCFDC0.CFDTMDF5_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_63.UINT32
RCFDC0.CFDTMDF6_63.UINT16[L/H]
RCFDC0.CFDTMDF6_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_63.UINT32
RCFDC0.CFDTMDF7_63.UINT16[L/H]
RCFDC0.CFDTMDF7_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_63.UINT32
RCFDC0.CFDTMDF8_63.UINT16[L/H]
RCFDC0.CFDTMDF8_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_63.UINT32
RCFDC0.CFDTMDF9_63.UINT16[L/H]
RCFDC0.CFDTMDF9_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_63.UINT32
RCFDC0.CFDTMDF10_63.UINT16[L/H]
RCFDC0.CFDTMDF10_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_63.UINT32
RCFDC0.CFDTMDF11_63.UINT16[L/H]
RCFDC0.CFDTMDF11_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_63.UINT32
RCFDC0.CFDTMDF12_63.UINT16[L/H]
RCFDC0.CFDTMDF12_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_63.UINT32
RCFDC0.CFDTMDF13_63.UINT16[L/H]
RCFDC0.CFDTMDF13_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_63.UINT32
RCFDC0.CFDTMDF14_63.UINT16[L/H]
RCFDC0.CFDTMDF14_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_63.UINT32
RCFDC0.CFDTMDF15_63.UINT16[L/H]
RCFDC0.CFDTMDF15_63.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID64.UINT32
RCFDC0.CFDTMID64.UINT16[L/H]
RCFDC0.CFDTMID64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR64.UINT32
RCFDC0.CFDTMPTR64.UINT16[H]
RCFDC0.CFDTMPTR64.UINT8[HH]
RCFDC0.CFDTMFDCTR64.UINT32
RCFDC0.CFDTMFDCTR64.UINT16[L/H]
RCFDC0.CFDTMFDCTR64.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_64.UINT32
RCFDC0.CFDTMDF0_64.UINT16[L/H]
RCFDC0.CFDTMDF0_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_64.UINT32
RCFDC0.CFDTMDF1_64.UINT16[L/H]
RCFDC0.CFDTMDF1_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_64.UINT32
RCFDC0.CFDTMDF2_64.UINT16[L/H]
RCFDC0.CFDTMDF2_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_64.UINT32
RCFDC0.CFDTMDF3_64.UINT16[L/H]
RCFDC0.CFDTMDF3_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_64.UINT32
RCFDC0.CFDTMDF4_64.UINT16[L/H]
RCFDC0.CFDTMDF4_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_64.UINT32
RCFDC0.CFDTMDF5_64.UINT16[L/H]
RCFDC0.CFDTMDF5_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_64.UINT32
RCFDC0.CFDTMDF6_64.UINT16[L/H]
RCFDC0.CFDTMDF6_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_64.UINT32
RCFDC0.CFDTMDF7_64.UINT16[L/H]
RCFDC0.CFDTMDF7_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_64.UINT32
RCFDC0.CFDTMDF8_64.UINT16[L/H]
RCFDC0.CFDTMDF8_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_64.UINT32
RCFDC0.CFDTMDF9_64.UINT16[L/H]
RCFDC0.CFDTMDF9_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_64.UINT32
RCFDC0.CFDTMDF10_64.UINT16[L/H]
RCFDC0.CFDTMDF10_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_64.UINT32
RCFDC0.CFDTMDF11_64.UINT16[L/H]
RCFDC0.CFDTMDF11_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_64.UINT32
RCFDC0.CFDTMDF12_64.UINT16[L/H]
RCFDC0.CFDTMDF12_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_64.UINT32
RCFDC0.CFDTMDF13_64.UINT16[L/H]
RCFDC0.CFDTMDF13_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_64.UINT32
RCFDC0.CFDTMDF14_64.UINT16[L/H]
RCFDC0.CFDTMDF14_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_64.UINT32
RCFDC0.CFDTMDF15_64.UINT16[L/H]
RCFDC0.CFDTMDF15_64.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID65.UINT32
RCFDC0.CFDTMID65.UINT16[L/H]
RCFDC0.CFDTMID65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR65.UINT32
RCFDC0.CFDTMPTR65.UINT16[H]
RCFDC0.CFDTMPTR65.UINT8[HH]
RCFDC0.CFDTMFDCTR65.UINT32
RCFDC0.CFDTMFDCTR65.UINT16[L/H]
RCFDC0.CFDTMFDCTR65.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_65.UINT32
RCFDC0.CFDTMDF0_65.UINT16[L/H]
RCFDC0.CFDTMDF0_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_65.UINT32
RCFDC0.CFDTMDF1_65.UINT16[L/H]
RCFDC0.CFDTMDF1_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_65.UINT32
RCFDC0.CFDTMDF2_65.UINT16[L/H]
RCFDC0.CFDTMDF2_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_65.UINT32
RCFDC0.CFDTMDF3_65.UINT16[L/H]
RCFDC0.CFDTMDF3_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_65.UINT32
RCFDC0.CFDTMDF4_65.UINT16[L/H]
RCFDC0.CFDTMDF4_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_65.UINT32
RCFDC0.CFDTMDF5_65.UINT16[L/H]
RCFDC0.CFDTMDF5_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_65.UINT32
RCFDC0.CFDTMDF6_65.UINT16[L/H]
RCFDC0.CFDTMDF6_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_65.UINT32
RCFDC0.CFDTMDF7_65.UINT16[L/H]
RCFDC0.CFDTMDF7_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_65.UINT32
RCFDC0.CFDTMDF8_65.UINT16[L/H]
RCFDC0.CFDTMDF8_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_65.UINT32
RCFDC0.CFDTMDF9_65.UINT16[L/H]
RCFDC0.CFDTMDF9_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_65.UINT32
RCFDC0.CFDTMDF10_65.UINT16[L/H]
RCFDC0.CFDTMDF10_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_65.UINT32
RCFDC0.CFDTMDF11_65.UINT16[L/H]
RCFDC0.CFDTMDF11_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_65.UINT32
RCFDC0.CFDTMDF12_65.UINT16[L/H]
RCFDC0.CFDTMDF12_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_65.UINT32
RCFDC0.CFDTMDF13_65.UINT16[L/H]
RCFDC0.CFDTMDF13_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_65.UINT32
RCFDC0.CFDTMDF14_65.UINT16[L/H]
RCFDC0.CFDTMDF14_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_65.UINT32
RCFDC0.CFDTMDF15_65.UINT16[L/H]
RCFDC0.CFDTMDF15_65.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID66.UINT32
RCFDC0.CFDTMID66.UINT16[L/H]
RCFDC0.CFDTMID66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR66.UINT32
RCFDC0.CFDTMPTR66.UINT16[H]
RCFDC0.CFDTMPTR66.UINT8[HH]
RCFDC0.CFDTMFDCTR66.UINT32
RCFDC0.CFDTMFDCTR66.UINT16[L/H]
RCFDC0.CFDTMFDCTR66.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_66.UINT32
RCFDC0.CFDTMDF0_66.UINT16[L/H]
RCFDC0.CFDTMDF0_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_66.UINT32
RCFDC0.CFDTMDF1_66.UINT16[L/H]
RCFDC0.CFDTMDF1_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_66.UINT32
RCFDC0.CFDTMDF2_66.UINT16[L/H]
RCFDC0.CFDTMDF2_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_66.UINT32
RCFDC0.CFDTMDF3_66.UINT16[L/H]
RCFDC0.CFDTMDF3_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_66.UINT32
RCFDC0.CFDTMDF4_66.UINT16[L/H]
RCFDC0.CFDTMDF4_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_66.UINT32
RCFDC0.CFDTMDF5_66.UINT16[L/H]
RCFDC0.CFDTMDF5_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_66.UINT32
RCFDC0.CFDTMDF6_66.UINT16[L/H]
RCFDC0.CFDTMDF6_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_66.UINT32
RCFDC0.CFDTMDF7_66.UINT16[L/H]
RCFDC0.CFDTMDF7_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_66.UINT32
RCFDC0.CFDTMDF8_66.UINT16[L/H]
RCFDC0.CFDTMDF8_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_66.UINT32
RCFDC0.CFDTMDF9_66.UINT16[L/H]
RCFDC0.CFDTMDF9_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_66.UINT32
RCFDC0.CFDTMDF10_66.UINT16[L/H]
RCFDC0.CFDTMDF10_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_66.UINT32
RCFDC0.CFDTMDF11_66.UINT16[L/H]
RCFDC0.CFDTMDF11_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_66.UINT32
RCFDC0.CFDTMDF12_66.UINT16[L/H]
RCFDC0.CFDTMDF12_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_66.UINT32
RCFDC0.CFDTMDF13_66.UINT16[L/H]
RCFDC0.CFDTMDF13_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_66.UINT32
RCFDC0.CFDTMDF14_66.UINT16[L/H]
RCFDC0.CFDTMDF14_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_66.UINT32
RCFDC0.CFDTMDF15_66.UINT16[L/H]
RCFDC0.CFDTMDF15_66.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID67.UINT32
RCFDC0.CFDTMID67.UINT16[L/H]
RCFDC0.CFDTMID67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR67.UINT32
RCFDC0.CFDTMPTR67.UINT16[H]
RCFDC0.CFDTMPTR67.UINT8[HH]
RCFDC0.CFDTMFDCTR67.UINT32
RCFDC0.CFDTMFDCTR67.UINT16[L/H]
RCFDC0.CFDTMFDCTR67.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_67.UINT32
RCFDC0.CFDTMDF0_67.UINT16[L/H]
RCFDC0.CFDTMDF0_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_67.UINT32
RCFDC0.CFDTMDF1_67.UINT16[L/H]
RCFDC0.CFDTMDF1_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_67.UINT32
RCFDC0.CFDTMDF2_67.UINT16[L/H]
RCFDC0.CFDTMDF2_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_67.UINT32
RCFDC0.CFDTMDF3_67.UINT16[L/H]
RCFDC0.CFDTMDF3_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_67.UINT32
RCFDC0.CFDTMDF4_67.UINT16[L/H]
RCFDC0.CFDTMDF4_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_67.UINT32
RCFDC0.CFDTMDF5_67.UINT16[L/H]
RCFDC0.CFDTMDF5_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_67.UINT32
RCFDC0.CFDTMDF6_67.UINT16[L/H]
RCFDC0.CFDTMDF6_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_67.UINT32
RCFDC0.CFDTMDF7_67.UINT16[L/H]
RCFDC0.CFDTMDF7_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_67.UINT32
RCFDC0.CFDTMDF8_67.UINT16[L/H]
RCFDC0.CFDTMDF8_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_67.UINT32
RCFDC0.CFDTMDF9_67.UINT16[L/H]
RCFDC0.CFDTMDF9_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_67.UINT32
RCFDC0.CFDTMDF10_67.UINT16[L/H]
RCFDC0.CFDTMDF10_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_67.UINT32
RCFDC0.CFDTMDF11_67.UINT16[L/H]
RCFDC0.CFDTMDF11_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_67.UINT32
RCFDC0.CFDTMDF12_67.UINT16[L/H]
RCFDC0.CFDTMDF12_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_67.UINT32
RCFDC0.CFDTMDF13_67.UINT16[L/H]
RCFDC0.CFDTMDF13_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_67.UINT32
RCFDC0.CFDTMDF14_67.UINT16[L/H]
RCFDC0.CFDTMDF14_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_67.UINT32
RCFDC0.CFDTMDF15_67.UINT16[L/H]
RCFDC0.CFDTMDF15_67.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID68.UINT32
RCFDC0.CFDTMID68.UINT16[L/H]
RCFDC0.CFDTMID68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR68.UINT32
RCFDC0.CFDTMPTR68.UINT16[H]
RCFDC0.CFDTMPTR68.UINT8[HH]
RCFDC0.CFDTMFDCTR68.UINT32
RCFDC0.CFDTMFDCTR68.UINT16[L/H]
RCFDC0.CFDTMFDCTR68.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_68.UINT32
RCFDC0.CFDTMDF0_68.UINT16[L/H]
RCFDC0.CFDTMDF0_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_68.UINT32
RCFDC0.CFDTMDF1_68.UINT16[L/H]
RCFDC0.CFDTMDF1_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_68.UINT32
RCFDC0.CFDTMDF2_68.UINT16[L/H]
RCFDC0.CFDTMDF2_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_68.UINT32
RCFDC0.CFDTMDF3_68.UINT16[L/H]
RCFDC0.CFDTMDF3_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_68.UINT32
RCFDC0.CFDTMDF4_68.UINT16[L/H]
RCFDC0.CFDTMDF4_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_68.UINT32
RCFDC0.CFDTMDF5_68.UINT16[L/H]
RCFDC0.CFDTMDF5_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_68.UINT32
RCFDC0.CFDTMDF6_68.UINT16[L/H]
RCFDC0.CFDTMDF6_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_68.UINT32
RCFDC0.CFDTMDF7_68.UINT16[L/H]
RCFDC0.CFDTMDF7_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_68.UINT32
RCFDC0.CFDTMDF8_68.UINT16[L/H]
RCFDC0.CFDTMDF8_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_68.UINT32
RCFDC0.CFDTMDF9_68.UINT16[L/H]
RCFDC0.CFDTMDF9_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_68.UINT32
RCFDC0.CFDTMDF10_68.UINT16[L/H]
RCFDC0.CFDTMDF10_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_68.UINT32
RCFDC0.CFDTMDF11_68.UINT16[L/H]
RCFDC0.CFDTMDF11_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_68.UINT32
RCFDC0.CFDTMDF12_68.UINT16[L/H]
RCFDC0.CFDTMDF12_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_68.UINT32
RCFDC0.CFDTMDF13_68.UINT16[L/H]
RCFDC0.CFDTMDF13_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_68.UINT32
RCFDC0.CFDTMDF14_68.UINT16[L/H]
RCFDC0.CFDTMDF14_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_68.UINT32
RCFDC0.CFDTMDF15_68.UINT16[L/H]
RCFDC0.CFDTMDF15_68.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID69.UINT32
RCFDC0.CFDTMID69.UINT16[L/H]
RCFDC0.CFDTMID69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR69.UINT32
RCFDC0.CFDTMPTR69.UINT16[H]
RCFDC0.CFDTMPTR69.UINT8[HH]
RCFDC0.CFDTMFDCTR69.UINT32
RCFDC0.CFDTMFDCTR69.UINT16[L/H]
RCFDC0.CFDTMFDCTR69.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_69.UINT32
RCFDC0.CFDTMDF0_69.UINT16[L/H]
RCFDC0.CFDTMDF0_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_69.UINT32
RCFDC0.CFDTMDF1_69.UINT16[L/H]
RCFDC0.CFDTMDF1_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_69.UINT32
RCFDC0.CFDTMDF2_69.UINT16[L/H]
RCFDC0.CFDTMDF2_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_69.UINT32
RCFDC0.CFDTMDF3_69.UINT16[L/H]
RCFDC0.CFDTMDF3_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_69.UINT32
RCFDC0.CFDTMDF4_69.UINT16[L/H]
RCFDC0.CFDTMDF4_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_69.UINT32
RCFDC0.CFDTMDF5_69.UINT16[L/H]
RCFDC0.CFDTMDF5_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_69.UINT32
RCFDC0.CFDTMDF6_69.UINT16[L/H]
RCFDC0.CFDTMDF6_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_69.UINT32
RCFDC0.CFDTMDF7_69.UINT16[L/H]
RCFDC0.CFDTMDF7_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_69.UINT32
RCFDC0.CFDTMDF8_69.UINT16[L/H]
RCFDC0.CFDTMDF8_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_69.UINT32
RCFDC0.CFDTMDF9_69.UINT16[L/H]
RCFDC0.CFDTMDF9_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_69.UINT32
RCFDC0.CFDTMDF10_69.UINT16[L/H]
RCFDC0.CFDTMDF10_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_69.UINT32
RCFDC0.CFDTMDF11_69.UINT16[L/H]
RCFDC0.CFDTMDF11_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_69.UINT32
RCFDC0.CFDTMDF12_69.UINT16[L/H]
RCFDC0.CFDTMDF12_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_69.UINT32
RCFDC0.CFDTMDF13_69.UINT16[L/H]
RCFDC0.CFDTMDF13_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_69.UINT32
RCFDC0.CFDTMDF14_69.UINT16[L/H]
RCFDC0.CFDTMDF14_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_69.UINT32
RCFDC0.CFDTMDF15_69.UINT16[L/H]
RCFDC0.CFDTMDF15_69.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID70.UINT32
RCFDC0.CFDTMID70.UINT16[L/H]
RCFDC0.CFDTMID70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR70.UINT32
RCFDC0.CFDTMPTR70.UINT16[H]
RCFDC0.CFDTMPTR70.UINT8[HH]
RCFDC0.CFDTMFDCTR70.UINT32
RCFDC0.CFDTMFDCTR70.UINT16[L/H]
RCFDC0.CFDTMFDCTR70.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_70.UINT32
RCFDC0.CFDTMDF0_70.UINT16[L/H]
RCFDC0.CFDTMDF0_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_70.UINT32
RCFDC0.CFDTMDF1_70.UINT16[L/H]
RCFDC0.CFDTMDF1_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_70.UINT32
RCFDC0.CFDTMDF2_70.UINT16[L/H]
RCFDC0.CFDTMDF2_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_70.UINT32
RCFDC0.CFDTMDF3_70.UINT16[L/H]
RCFDC0.CFDTMDF3_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_70.UINT32
RCFDC0.CFDTMDF4_70.UINT16[L/H]
RCFDC0.CFDTMDF4_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_70.UINT32
RCFDC0.CFDTMDF5_70.UINT16[L/H]
RCFDC0.CFDTMDF5_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_70.UINT32
RCFDC0.CFDTMDF6_70.UINT16[L/H]
RCFDC0.CFDTMDF6_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_70.UINT32
RCFDC0.CFDTMDF7_70.UINT16[L/H]
RCFDC0.CFDTMDF7_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_70.UINT32
RCFDC0.CFDTMDF8_70.UINT16[L/H]
RCFDC0.CFDTMDF8_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_70.UINT32
RCFDC0.CFDTMDF9_70.UINT16[L/H]
RCFDC0.CFDTMDF9_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_70.UINT32
RCFDC0.CFDTMDF10_70.UINT16[L/H]
RCFDC0.CFDTMDF10_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_70.UINT32
RCFDC0.CFDTMDF11_70.UINT16[L/H]
RCFDC0.CFDTMDF11_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_70.UINT32
RCFDC0.CFDTMDF12_70.UINT16[L/H]
RCFDC0.CFDTMDF12_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_70.UINT32
RCFDC0.CFDTMDF13_70.UINT16[L/H]
RCFDC0.CFDTMDF13_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_70.UINT32
RCFDC0.CFDTMDF14_70.UINT16[L/H]
RCFDC0.CFDTMDF14_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_70.UINT32
RCFDC0.CFDTMDF15_70.UINT16[L/H]
RCFDC0.CFDTMDF15_70.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID71.UINT32
RCFDC0.CFDTMID71.UINT16[L/H]
RCFDC0.CFDTMID71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR71.UINT32
RCFDC0.CFDTMPTR71.UINT16[H]
RCFDC0.CFDTMPTR71.UINT8[HH]
RCFDC0.CFDTMFDCTR71.UINT32
RCFDC0.CFDTMFDCTR71.UINT16[L/H]
RCFDC0.CFDTMFDCTR71.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_71.UINT32
RCFDC0.CFDTMDF0_71.UINT16[L/H]
RCFDC0.CFDTMDF0_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_71.UINT32
RCFDC0.CFDTMDF1_71.UINT16[L/H]
RCFDC0.CFDTMDF1_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_71.UINT32
RCFDC0.CFDTMDF2_71.UINT16[L/H]
RCFDC0.CFDTMDF2_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_71.UINT32
RCFDC0.CFDTMDF3_71.UINT16[L/H]
RCFDC0.CFDTMDF3_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_71.UINT32
RCFDC0.CFDTMDF4_71.UINT16[L/H]
RCFDC0.CFDTMDF4_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_71.UINT32
RCFDC0.CFDTMDF5_71.UINT16[L/H]
RCFDC0.CFDTMDF5_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_71.UINT32
RCFDC0.CFDTMDF6_71.UINT16[L/H]
RCFDC0.CFDTMDF6_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_71.UINT32
RCFDC0.CFDTMDF7_71.UINT16[L/H]
RCFDC0.CFDTMDF7_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_71.UINT32
RCFDC0.CFDTMDF8_71.UINT16[L/H]
RCFDC0.CFDTMDF8_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_71.UINT32
RCFDC0.CFDTMDF9_71.UINT16[L/H]
RCFDC0.CFDTMDF9_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_71.UINT32
RCFDC0.CFDTMDF10_71.UINT16[L/H]
RCFDC0.CFDTMDF10_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_71.UINT32
RCFDC0.CFDTMDF11_71.UINT16[L/H]
RCFDC0.CFDTMDF11_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_71.UINT32
RCFDC0.CFDTMDF12_71.UINT16[L/H]
RCFDC0.CFDTMDF12_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_71.UINT32
RCFDC0.CFDTMDF13_71.UINT16[L/H]
RCFDC0.CFDTMDF13_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_71.UINT32
RCFDC0.CFDTMDF14_71.UINT16[L/H]
RCFDC0.CFDTMDF14_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_71.UINT32
RCFDC0.CFDTMDF15_71.UINT16[L/H]
RCFDC0.CFDTMDF15_71.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID72.UINT32
RCFDC0.CFDTMID72.UINT16[L/H]
RCFDC0.CFDTMID72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR72.UINT32
RCFDC0.CFDTMPTR72.UINT16[H]
RCFDC0.CFDTMPTR72.UINT8[HH]
RCFDC0.CFDTMFDCTR72.UINT32
RCFDC0.CFDTMFDCTR72.UINT16[L/H]
RCFDC0.CFDTMFDCTR72.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_72.UINT32
RCFDC0.CFDTMDF0_72.UINT16[L/H]
RCFDC0.CFDTMDF0_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_72.UINT32
RCFDC0.CFDTMDF1_72.UINT16[L/H]
RCFDC0.CFDTMDF1_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_72.UINT32
RCFDC0.CFDTMDF2_72.UINT16[L/H]
RCFDC0.CFDTMDF2_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_72.UINT32
RCFDC0.CFDTMDF3_72.UINT16[L/H]
RCFDC0.CFDTMDF3_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_72.UINT32
RCFDC0.CFDTMDF4_72.UINT16[L/H]
RCFDC0.CFDTMDF4_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_72.UINT32
RCFDC0.CFDTMDF5_72.UINT16[L/H]
RCFDC0.CFDTMDF5_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_72.UINT32
RCFDC0.CFDTMDF6_72.UINT16[L/H]
RCFDC0.CFDTMDF6_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_72.UINT32
RCFDC0.CFDTMDF7_72.UINT16[L/H]
RCFDC0.CFDTMDF7_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_72.UINT32
RCFDC0.CFDTMDF8_72.UINT16[L/H]
RCFDC0.CFDTMDF8_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_72.UINT32
RCFDC0.CFDTMDF9_72.UINT16[L/H]
RCFDC0.CFDTMDF9_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_72.UINT32
RCFDC0.CFDTMDF10_72.UINT16[L/H]
RCFDC0.CFDTMDF10_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_72.UINT32
RCFDC0.CFDTMDF11_72.UINT16[L/H]
RCFDC0.CFDTMDF11_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_72.UINT32
RCFDC0.CFDTMDF12_72.UINT16[L/H]
RCFDC0.CFDTMDF12_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_72.UINT32
RCFDC0.CFDTMDF13_72.UINT16[L/H]
RCFDC0.CFDTMDF13_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_72.UINT32
RCFDC0.CFDTMDF14_72.UINT16[L/H]
RCFDC0.CFDTMDF14_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_72.UINT32
RCFDC0.CFDTMDF15_72.UINT16[L/H]
RCFDC0.CFDTMDF15_72.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID73.UINT32
RCFDC0.CFDTMID73.UINT16[L/H]
RCFDC0.CFDTMID73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR73.UINT32
RCFDC0.CFDTMPTR73.UINT16[H]
RCFDC0.CFDTMPTR73.UINT8[HH]
RCFDC0.CFDTMFDCTR73.UINT32
RCFDC0.CFDTMFDCTR73.UINT16[L/H]
RCFDC0.CFDTMFDCTR73.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_73.UINT32
RCFDC0.CFDTMDF0_73.UINT16[L/H]
RCFDC0.CFDTMDF0_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_73.UINT32
RCFDC0.CFDTMDF1_73.UINT16[L/H]
RCFDC0.CFDTMDF1_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_73.UINT32
RCFDC0.CFDTMDF2_73.UINT16[L/H]
RCFDC0.CFDTMDF2_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_73.UINT32
RCFDC0.CFDTMDF3_73.UINT16[L/H]
RCFDC0.CFDTMDF3_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_73.UINT32
RCFDC0.CFDTMDF4_73.UINT16[L/H]
RCFDC0.CFDTMDF4_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_73.UINT32
RCFDC0.CFDTMDF5_73.UINT16[L/H]
RCFDC0.CFDTMDF5_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_73.UINT32
RCFDC0.CFDTMDF6_73.UINT16[L/H]
RCFDC0.CFDTMDF6_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_73.UINT32
RCFDC0.CFDTMDF7_73.UINT16[L/H]
RCFDC0.CFDTMDF7_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_73.UINT32
RCFDC0.CFDTMDF8_73.UINT16[L/H]
RCFDC0.CFDTMDF8_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_73.UINT32
RCFDC0.CFDTMDF9_73.UINT16[L/H]
RCFDC0.CFDTMDF9_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_73.UINT32
RCFDC0.CFDTMDF10_73.UINT16[L/H]
RCFDC0.CFDTMDF10_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_73.UINT32
RCFDC0.CFDTMDF11_73.UINT16[L/H]
RCFDC0.CFDTMDF11_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_73.UINT32
RCFDC0.CFDTMDF12_73.UINT16[L/H]
RCFDC0.CFDTMDF12_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_73.UINT32
RCFDC0.CFDTMDF13_73.UINT16[L/H]
RCFDC0.CFDTMDF13_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_73.UINT32
RCFDC0.CFDTMDF14_73.UINT16[L/H]
RCFDC0.CFDTMDF14_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_73.UINT32
RCFDC0.CFDTMDF15_73.UINT16[L/H]
RCFDC0.CFDTMDF15_73.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID74.UINT32
RCFDC0.CFDTMID74.UINT16[L/H]
RCFDC0.CFDTMID74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR74.UINT32
RCFDC0.CFDTMPTR74.UINT16[H]
RCFDC0.CFDTMPTR74.UINT8[HH]
RCFDC0.CFDTMFDCTR74.UINT32
RCFDC0.CFDTMFDCTR74.UINT16[L/H]
RCFDC0.CFDTMFDCTR74.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_74.UINT32
RCFDC0.CFDTMDF0_74.UINT16[L/H]
RCFDC0.CFDTMDF0_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_74.UINT32
RCFDC0.CFDTMDF1_74.UINT16[L/H]
RCFDC0.CFDTMDF1_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_74.UINT32
RCFDC0.CFDTMDF2_74.UINT16[L/H]
RCFDC0.CFDTMDF2_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_74.UINT32
RCFDC0.CFDTMDF3_74.UINT16[L/H]
RCFDC0.CFDTMDF3_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_74.UINT32
RCFDC0.CFDTMDF4_74.UINT16[L/H]
RCFDC0.CFDTMDF4_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_74.UINT32
RCFDC0.CFDTMDF5_74.UINT16[L/H]
RCFDC0.CFDTMDF5_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_74.UINT32
RCFDC0.CFDTMDF6_74.UINT16[L/H]
RCFDC0.CFDTMDF6_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_74.UINT32
RCFDC0.CFDTMDF7_74.UINT16[L/H]
RCFDC0.CFDTMDF7_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_74.UINT32
RCFDC0.CFDTMDF8_74.UINT16[L/H]
RCFDC0.CFDTMDF8_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_74.UINT32
RCFDC0.CFDTMDF9_74.UINT16[L/H]
RCFDC0.CFDTMDF9_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_74.UINT32
RCFDC0.CFDTMDF10_74.UINT16[L/H]
RCFDC0.CFDTMDF10_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_74.UINT32
RCFDC0.CFDTMDF11_74.UINT16[L/H]
RCFDC0.CFDTMDF11_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_74.UINT32
RCFDC0.CFDTMDF12_74.UINT16[L/H]
RCFDC0.CFDTMDF12_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_74.UINT32
RCFDC0.CFDTMDF13_74.UINT16[L/H]
RCFDC0.CFDTMDF13_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_74.UINT32
RCFDC0.CFDTMDF14_74.UINT16[L/H]
RCFDC0.CFDTMDF14_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_74.UINT32
RCFDC0.CFDTMDF15_74.UINT16[L/H]
RCFDC0.CFDTMDF15_74.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID75.UINT32
RCFDC0.CFDTMID75.UINT16[L/H]
RCFDC0.CFDTMID75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR75.UINT32
RCFDC0.CFDTMPTR75.UINT16[H]
RCFDC0.CFDTMPTR75.UINT8[HH]
RCFDC0.CFDTMFDCTR75.UINT32
RCFDC0.CFDTMFDCTR75.UINT16[L/H]
RCFDC0.CFDTMFDCTR75.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_75.UINT32
RCFDC0.CFDTMDF0_75.UINT16[L/H]
RCFDC0.CFDTMDF0_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_75.UINT32
RCFDC0.CFDTMDF1_75.UINT16[L/H]
RCFDC0.CFDTMDF1_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_75.UINT32
RCFDC0.CFDTMDF2_75.UINT16[L/H]
RCFDC0.CFDTMDF2_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_75.UINT32
RCFDC0.CFDTMDF3_75.UINT16[L/H]
RCFDC0.CFDTMDF3_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_75.UINT32
RCFDC0.CFDTMDF4_75.UINT16[L/H]
RCFDC0.CFDTMDF4_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_75.UINT32
RCFDC0.CFDTMDF5_75.UINT16[L/H]
RCFDC0.CFDTMDF5_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_75.UINT32
RCFDC0.CFDTMDF6_75.UINT16[L/H]
RCFDC0.CFDTMDF6_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_75.UINT32
RCFDC0.CFDTMDF7_75.UINT16[L/H]
RCFDC0.CFDTMDF7_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_75.UINT32
RCFDC0.CFDTMDF8_75.UINT16[L/H]
RCFDC0.CFDTMDF8_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_75.UINT32
RCFDC0.CFDTMDF9_75.UINT16[L/H]
RCFDC0.CFDTMDF9_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_75.UINT32
RCFDC0.CFDTMDF10_75.UINT16[L/H]
RCFDC0.CFDTMDF10_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_75.UINT32
RCFDC0.CFDTMDF11_75.UINT16[L/H]
RCFDC0.CFDTMDF11_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_75.UINT32
RCFDC0.CFDTMDF12_75.UINT16[L/H]
RCFDC0.CFDTMDF12_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_75.UINT32
RCFDC0.CFDTMDF13_75.UINT16[L/H]
RCFDC0.CFDTMDF13_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_75.UINT32
RCFDC0.CFDTMDF14_75.UINT16[L/H]
RCFDC0.CFDTMDF14_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_75.UINT32
RCFDC0.CFDTMDF15_75.UINT16[L/H]
RCFDC0.CFDTMDF15_75.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID76.UINT32
RCFDC0.CFDTMID76.UINT16[L/H]
RCFDC0.CFDTMID76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR76.UINT32
RCFDC0.CFDTMPTR76.UINT16[H]
RCFDC0.CFDTMPTR76.UINT8[HH]
RCFDC0.CFDTMFDCTR76.UINT32
RCFDC0.CFDTMFDCTR76.UINT16[L/H]
RCFDC0.CFDTMFDCTR76.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_76.UINT32
RCFDC0.CFDTMDF0_76.UINT16[L/H]
RCFDC0.CFDTMDF0_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_76.UINT32
RCFDC0.CFDTMDF1_76.UINT16[L/H]
RCFDC0.CFDTMDF1_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_76.UINT32
RCFDC0.CFDTMDF2_76.UINT16[L/H]
RCFDC0.CFDTMDF2_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_76.UINT32
RCFDC0.CFDTMDF3_76.UINT16[L/H]
RCFDC0.CFDTMDF3_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_76.UINT32
RCFDC0.CFDTMDF4_76.UINT16[L/H]
RCFDC0.CFDTMDF4_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_76.UINT32
RCFDC0.CFDTMDF5_76.UINT16[L/H]
RCFDC0.CFDTMDF5_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_76.UINT32
RCFDC0.CFDTMDF6_76.UINT16[L/H]
RCFDC0.CFDTMDF6_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_76.UINT32
RCFDC0.CFDTMDF7_76.UINT16[L/H]
RCFDC0.CFDTMDF7_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_76.UINT32
RCFDC0.CFDTMDF8_76.UINT16[L/H]
RCFDC0.CFDTMDF8_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_76.UINT32
RCFDC0.CFDTMDF9_76.UINT16[L/H]
RCFDC0.CFDTMDF9_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_76.UINT32
RCFDC0.CFDTMDF10_76.UINT16[L/H]
RCFDC0.CFDTMDF10_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_76.UINT32
RCFDC0.CFDTMDF11_76.UINT16[L/H]
RCFDC0.CFDTMDF11_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_76.UINT32
RCFDC0.CFDTMDF12_76.UINT16[L/H]
RCFDC0.CFDTMDF12_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_76.UINT32
RCFDC0.CFDTMDF13_76.UINT16[L/H]
RCFDC0.CFDTMDF13_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_76.UINT32
RCFDC0.CFDTMDF14_76.UINT16[L/H]
RCFDC0.CFDTMDF14_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_76.UINT32
RCFDC0.CFDTMDF15_76.UINT16[L/H]
RCFDC0.CFDTMDF15_76.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID77.UINT32
RCFDC0.CFDTMID77.UINT16[L/H]
RCFDC0.CFDTMID77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR77.UINT32
RCFDC0.CFDTMPTR77.UINT16[H]
RCFDC0.CFDTMPTR77.UINT8[HH]
RCFDC0.CFDTMFDCTR77.UINT32
RCFDC0.CFDTMFDCTR77.UINT16[L/H]
RCFDC0.CFDTMFDCTR77.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_77.UINT32
RCFDC0.CFDTMDF0_77.UINT16[L/H]
RCFDC0.CFDTMDF0_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_77.UINT32
RCFDC0.CFDTMDF1_77.UINT16[L/H]
RCFDC0.CFDTMDF1_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_77.UINT32
RCFDC0.CFDTMDF2_77.UINT16[L/H]
RCFDC0.CFDTMDF2_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_77.UINT32
RCFDC0.CFDTMDF3_77.UINT16[L/H]
RCFDC0.CFDTMDF3_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_77.UINT32
RCFDC0.CFDTMDF4_77.UINT16[L/H]
RCFDC0.CFDTMDF4_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_77.UINT32
RCFDC0.CFDTMDF5_77.UINT16[L/H]
RCFDC0.CFDTMDF5_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_77.UINT32
RCFDC0.CFDTMDF6_77.UINT16[L/H]
RCFDC0.CFDTMDF6_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_77.UINT32
RCFDC0.CFDTMDF7_77.UINT16[L/H]
RCFDC0.CFDTMDF7_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_77.UINT32
RCFDC0.CFDTMDF8_77.UINT16[L/H]
RCFDC0.CFDTMDF8_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_77.UINT32
RCFDC0.CFDTMDF9_77.UINT16[L/H]
RCFDC0.CFDTMDF9_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_77.UINT32
RCFDC0.CFDTMDF10_77.UINT16[L/H]
RCFDC0.CFDTMDF10_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_77.UINT32
RCFDC0.CFDTMDF11_77.UINT16[L/H]
RCFDC0.CFDTMDF11_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_77.UINT32
RCFDC0.CFDTMDF12_77.UINT16[L/H]
RCFDC0.CFDTMDF12_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_77.UINT32
RCFDC0.CFDTMDF13_77.UINT16[L/H]
RCFDC0.CFDTMDF13_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_77.UINT32
RCFDC0.CFDTMDF14_77.UINT16[L/H]
RCFDC0.CFDTMDF14_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_77.UINT32
RCFDC0.CFDTMDF15_77.UINT16[L/H]
RCFDC0.CFDTMDF15_77.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID78.UINT32
RCFDC0.CFDTMID78.UINT16[L/H]
RCFDC0.CFDTMID78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR78.UINT32
RCFDC0.CFDTMPTR78.UINT16[H]
RCFDC0.CFDTMPTR78.UINT8[HH]
RCFDC0.CFDTMFDCTR78.UINT32
RCFDC0.CFDTMFDCTR78.UINT16[L/H]
RCFDC0.CFDTMFDCTR78.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_78.UINT32
RCFDC0.CFDTMDF0_78.UINT16[L/H]
RCFDC0.CFDTMDF0_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_78.UINT32
RCFDC0.CFDTMDF1_78.UINT16[L/H]
RCFDC0.CFDTMDF1_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_78.UINT32
RCFDC0.CFDTMDF2_78.UINT16[L/H]
RCFDC0.CFDTMDF2_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_78.UINT32
RCFDC0.CFDTMDF3_78.UINT16[L/H]
RCFDC0.CFDTMDF3_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_78.UINT32
RCFDC0.CFDTMDF4_78.UINT16[L/H]
RCFDC0.CFDTMDF4_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_78.UINT32
RCFDC0.CFDTMDF5_78.UINT16[L/H]
RCFDC0.CFDTMDF5_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_78.UINT32
RCFDC0.CFDTMDF6_78.UINT16[L/H]
RCFDC0.CFDTMDF6_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_78.UINT32
RCFDC0.CFDTMDF7_78.UINT16[L/H]
RCFDC0.CFDTMDF7_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_78.UINT32
RCFDC0.CFDTMDF8_78.UINT16[L/H]
RCFDC0.CFDTMDF8_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_78.UINT32
RCFDC0.CFDTMDF9_78.UINT16[L/H]
RCFDC0.CFDTMDF9_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_78.UINT32
RCFDC0.CFDTMDF10_78.UINT16[L/H]
RCFDC0.CFDTMDF10_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_78.UINT32
RCFDC0.CFDTMDF11_78.UINT16[L/H]
RCFDC0.CFDTMDF11_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_78.UINT32
RCFDC0.CFDTMDF12_78.UINT16[L/H]
RCFDC0.CFDTMDF12_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_78.UINT32
RCFDC0.CFDTMDF13_78.UINT16[L/H]
RCFDC0.CFDTMDF13_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_78.UINT32
RCFDC0.CFDTMDF14_78.UINT16[L/H]
RCFDC0.CFDTMDF14_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_78.UINT32
RCFDC0.CFDTMDF15_78.UINT16[L/H]
RCFDC0.CFDTMDF15_78.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID79.UINT32
RCFDC0.CFDTMID79.UINT16[L/H]
RCFDC0.CFDTMID79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR79.UINT32
RCFDC0.CFDTMPTR79.UINT16[H]
RCFDC0.CFDTMPTR79.UINT8[HH]
RCFDC0.CFDTMFDCTR79.UINT32
RCFDC0.CFDTMFDCTR79.UINT16[L/H]
RCFDC0.CFDTMFDCTR79.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_79.UINT32
RCFDC0.CFDTMDF0_79.UINT16[L/H]
RCFDC0.CFDTMDF0_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_79.UINT32
RCFDC0.CFDTMDF1_79.UINT16[L/H]
RCFDC0.CFDTMDF1_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_79.UINT32
RCFDC0.CFDTMDF2_79.UINT16[L/H]
RCFDC0.CFDTMDF2_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_79.UINT32
RCFDC0.CFDTMDF3_79.UINT16[L/H]
RCFDC0.CFDTMDF3_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_79.UINT32
RCFDC0.CFDTMDF4_79.UINT16[L/H]
RCFDC0.CFDTMDF4_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_79.UINT32
RCFDC0.CFDTMDF5_79.UINT16[L/H]
RCFDC0.CFDTMDF5_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_79.UINT32
RCFDC0.CFDTMDF6_79.UINT16[L/H]
RCFDC0.CFDTMDF6_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_79.UINT32
RCFDC0.CFDTMDF7_79.UINT16[L/H]
RCFDC0.CFDTMDF7_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_79.UINT32
RCFDC0.CFDTMDF8_79.UINT16[L/H]
RCFDC0.CFDTMDF8_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_79.UINT32
RCFDC0.CFDTMDF9_79.UINT16[L/H]
RCFDC0.CFDTMDF9_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_79.UINT32
RCFDC0.CFDTMDF10_79.UINT16[L/H]
RCFDC0.CFDTMDF10_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_79.UINT32
RCFDC0.CFDTMDF11_79.UINT16[L/H]
RCFDC0.CFDTMDF11_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_79.UINT32
RCFDC0.CFDTMDF12_79.UINT16[L/H]
RCFDC0.CFDTMDF12_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_79.UINT32
RCFDC0.CFDTMDF13_79.UINT16[L/H]
RCFDC0.CFDTMDF13_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_79.UINT32
RCFDC0.CFDTMDF14_79.UINT16[L/H]
RCFDC0.CFDTMDF14_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_79.UINT32
RCFDC0.CFDTMDF15_79.UINT16[L/H]
RCFDC0.CFDTMDF15_79.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID80.UINT32
RCFDC0.CFDTMID80.UINT16[L/H]
RCFDC0.CFDTMID80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR80.UINT32
RCFDC0.CFDTMPTR80.UINT16[H]
RCFDC0.CFDTMPTR80.UINT8[HH]
RCFDC0.CFDTMFDCTR80.UINT32
RCFDC0.CFDTMFDCTR80.UINT16[L/H]
RCFDC0.CFDTMFDCTR80.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_80.UINT32
RCFDC0.CFDTMDF0_80.UINT16[L/H]
RCFDC0.CFDTMDF0_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_80.UINT32
RCFDC0.CFDTMDF1_80.UINT16[L/H]
RCFDC0.CFDTMDF1_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_80.UINT32
RCFDC0.CFDTMDF2_80.UINT16[L/H]
RCFDC0.CFDTMDF2_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_80.UINT32
RCFDC0.CFDTMDF3_80.UINT16[L/H]
RCFDC0.CFDTMDF3_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_80.UINT32
RCFDC0.CFDTMDF4_80.UINT16[L/H]
RCFDC0.CFDTMDF4_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_80.UINT32
RCFDC0.CFDTMDF5_80.UINT16[L/H]
RCFDC0.CFDTMDF5_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_80.UINT32
RCFDC0.CFDTMDF6_80.UINT16[L/H]
RCFDC0.CFDTMDF6_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_80.UINT32
RCFDC0.CFDTMDF7_80.UINT16[L/H]
RCFDC0.CFDTMDF7_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_80.UINT32
RCFDC0.CFDTMDF8_80.UINT16[L/H]
RCFDC0.CFDTMDF8_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_80.UINT32
RCFDC0.CFDTMDF9_80.UINT16[L/H]
RCFDC0.CFDTMDF9_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_80.UINT32
RCFDC0.CFDTMDF10_80.UINT16[L/H]
RCFDC0.CFDTMDF10_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_80.UINT32
RCFDC0.CFDTMDF11_80.UINT16[L/H]
RCFDC0.CFDTMDF11_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_80.UINT32
RCFDC0.CFDTMDF12_80.UINT16[L/H]
RCFDC0.CFDTMDF12_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_80.UINT32
RCFDC0.CFDTMDF13_80.UINT16[L/H]
RCFDC0.CFDTMDF13_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_80.UINT32
RCFDC0.CFDTMDF14_80.UINT16[L/H]
RCFDC0.CFDTMDF14_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_80.UINT32
RCFDC0.CFDTMDF15_80.UINT16[L/H]
RCFDC0.CFDTMDF15_80.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID81.UINT32
RCFDC0.CFDTMID81.UINT16[L/H]
RCFDC0.CFDTMID81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR81.UINT32
RCFDC0.CFDTMPTR81.UINT16[H]
RCFDC0.CFDTMPTR81.UINT8[HH]
RCFDC0.CFDTMFDCTR81.UINT32
RCFDC0.CFDTMFDCTR81.UINT16[L/H]
RCFDC0.CFDTMFDCTR81.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_81.UINT32
RCFDC0.CFDTMDF0_81.UINT16[L/H]
RCFDC0.CFDTMDF0_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_81.UINT32
RCFDC0.CFDTMDF1_81.UINT16[L/H]
RCFDC0.CFDTMDF1_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_81.UINT32
RCFDC0.CFDTMDF2_81.UINT16[L/H]
RCFDC0.CFDTMDF2_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_81.UINT32
RCFDC0.CFDTMDF3_81.UINT16[L/H]
RCFDC0.CFDTMDF3_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_81.UINT32
RCFDC0.CFDTMDF4_81.UINT16[L/H]
RCFDC0.CFDTMDF4_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_81.UINT32
RCFDC0.CFDTMDF5_81.UINT16[L/H]
RCFDC0.CFDTMDF5_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_81.UINT32
RCFDC0.CFDTMDF6_81.UINT16[L/H]
RCFDC0.CFDTMDF6_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_81.UINT32
RCFDC0.CFDTMDF7_81.UINT16[L/H]
RCFDC0.CFDTMDF7_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_81.UINT32
RCFDC0.CFDTMDF8_81.UINT16[L/H]
RCFDC0.CFDTMDF8_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_81.UINT32
RCFDC0.CFDTMDF9_81.UINT16[L/H]
RCFDC0.CFDTMDF9_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_81.UINT32
RCFDC0.CFDTMDF10_81.UINT16[L/H]
RCFDC0.CFDTMDF10_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_81.UINT32
RCFDC0.CFDTMDF11_81.UINT16[L/H]
RCFDC0.CFDTMDF11_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_81.UINT32
RCFDC0.CFDTMDF12_81.UINT16[L/H]
RCFDC0.CFDTMDF12_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_81.UINT32
RCFDC0.CFDTMDF13_81.UINT16[L/H]
RCFDC0.CFDTMDF13_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_81.UINT32
RCFDC0.CFDTMDF14_81.UINT16[L/H]
RCFDC0.CFDTMDF14_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_81.UINT32
RCFDC0.CFDTMDF15_81.UINT16[L/H]
RCFDC0.CFDTMDF15_81.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID82.UINT32
RCFDC0.CFDTMID82.UINT16[L/H]
RCFDC0.CFDTMID82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR82.UINT32
RCFDC0.CFDTMPTR82.UINT16[H]
RCFDC0.CFDTMPTR82.UINT8[HH]
RCFDC0.CFDTMFDCTR82.UINT32
RCFDC0.CFDTMFDCTR82.UINT16[L/H]
RCFDC0.CFDTMFDCTR82.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_82.UINT32
RCFDC0.CFDTMDF0_82.UINT16[L/H]
RCFDC0.CFDTMDF0_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_82.UINT32
RCFDC0.CFDTMDF1_82.UINT16[L/H]
RCFDC0.CFDTMDF1_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_82.UINT32
RCFDC0.CFDTMDF2_82.UINT16[L/H]
RCFDC0.CFDTMDF2_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_82.UINT32
RCFDC0.CFDTMDF3_82.UINT16[L/H]
RCFDC0.CFDTMDF3_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_82.UINT32
RCFDC0.CFDTMDF4_82.UINT16[L/H]
RCFDC0.CFDTMDF4_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_82.UINT32
RCFDC0.CFDTMDF5_82.UINT16[L/H]
RCFDC0.CFDTMDF5_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_82.UINT32
RCFDC0.CFDTMDF6_82.UINT16[L/H]
RCFDC0.CFDTMDF6_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_82.UINT32
RCFDC0.CFDTMDF7_82.UINT16[L/H]
RCFDC0.CFDTMDF7_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_82.UINT32
RCFDC0.CFDTMDF8_82.UINT16[L/H]
RCFDC0.CFDTMDF8_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_82.UINT32
RCFDC0.CFDTMDF9_82.UINT16[L/H]
RCFDC0.CFDTMDF9_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_82.UINT32
RCFDC0.CFDTMDF10_82.UINT16[L/H]
RCFDC0.CFDTMDF10_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_82.UINT32
RCFDC0.CFDTMDF11_82.UINT16[L/H]
RCFDC0.CFDTMDF11_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_82.UINT32
RCFDC0.CFDTMDF12_82.UINT16[L/H]
RCFDC0.CFDTMDF12_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_82.UINT32
RCFDC0.CFDTMDF13_82.UINT16[L/H]
RCFDC0.CFDTMDF13_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_82.UINT32
RCFDC0.CFDTMDF14_82.UINT16[L/H]
RCFDC0.CFDTMDF14_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_82.UINT32
RCFDC0.CFDTMDF15_82.UINT16[L/H]
RCFDC0.CFDTMDF15_82.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID83.UINT32
RCFDC0.CFDTMID83.UINT16[L/H]
RCFDC0.CFDTMID83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR83.UINT32
RCFDC0.CFDTMPTR83.UINT16[H]
RCFDC0.CFDTMPTR83.UINT8[HH]
RCFDC0.CFDTMFDCTR83.UINT32
RCFDC0.CFDTMFDCTR83.UINT16[L/H]
RCFDC0.CFDTMFDCTR83.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_83.UINT32
RCFDC0.CFDTMDF0_83.UINT16[L/H]
RCFDC0.CFDTMDF0_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_83.UINT32
RCFDC0.CFDTMDF1_83.UINT16[L/H]
RCFDC0.CFDTMDF1_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_83.UINT32
RCFDC0.CFDTMDF2_83.UINT16[L/H]
RCFDC0.CFDTMDF2_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_83.UINT32
RCFDC0.CFDTMDF3_83.UINT16[L/H]
RCFDC0.CFDTMDF3_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_83.UINT32
RCFDC0.CFDTMDF4_83.UINT16[L/H]
RCFDC0.CFDTMDF4_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_83.UINT32
RCFDC0.CFDTMDF5_83.UINT16[L/H]
RCFDC0.CFDTMDF5_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_83.UINT32
RCFDC0.CFDTMDF6_83.UINT16[L/H]
RCFDC0.CFDTMDF6_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_83.UINT32
RCFDC0.CFDTMDF7_83.UINT16[L/H]
RCFDC0.CFDTMDF7_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_83.UINT32
RCFDC0.CFDTMDF8_83.UINT16[L/H]
RCFDC0.CFDTMDF8_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_83.UINT32
RCFDC0.CFDTMDF9_83.UINT16[L/H]
RCFDC0.CFDTMDF9_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_83.UINT32
RCFDC0.CFDTMDF10_83.UINT16[L/H]
RCFDC0.CFDTMDF10_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_83.UINT32
RCFDC0.CFDTMDF11_83.UINT16[L/H]
RCFDC0.CFDTMDF11_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_83.UINT32
RCFDC0.CFDTMDF12_83.UINT16[L/H]
RCFDC0.CFDTMDF12_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_83.UINT32
RCFDC0.CFDTMDF13_83.UINT16[L/H]
RCFDC0.CFDTMDF13_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_83.UINT32
RCFDC0.CFDTMDF14_83.UINT16[L/H]
RCFDC0.CFDTMDF14_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_83.UINT32
RCFDC0.CFDTMDF15_83.UINT16[L/H]
RCFDC0.CFDTMDF15_83.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID84.UINT32
RCFDC0.CFDTMID84.UINT16[L/H]
RCFDC0.CFDTMID84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR84.UINT32
RCFDC0.CFDTMPTR84.UINT16[H]
RCFDC0.CFDTMPTR84.UINT8[HH]
RCFDC0.CFDTMFDCTR84.UINT32
RCFDC0.CFDTMFDCTR84.UINT16[L/H]
RCFDC0.CFDTMFDCTR84.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_84.UINT32
RCFDC0.CFDTMDF0_84.UINT16[L/H]
RCFDC0.CFDTMDF0_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_84.UINT32
RCFDC0.CFDTMDF1_84.UINT16[L/H]
RCFDC0.CFDTMDF1_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_84.UINT32
RCFDC0.CFDTMDF2_84.UINT16[L/H]
RCFDC0.CFDTMDF2_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_84.UINT32
RCFDC0.CFDTMDF3_84.UINT16[L/H]
RCFDC0.CFDTMDF3_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_84.UINT32
RCFDC0.CFDTMDF4_84.UINT16[L/H]
RCFDC0.CFDTMDF4_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_84.UINT32
RCFDC0.CFDTMDF5_84.UINT16[L/H]
RCFDC0.CFDTMDF5_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_84.UINT32
RCFDC0.CFDTMDF6_84.UINT16[L/H]
RCFDC0.CFDTMDF6_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_84.UINT32
RCFDC0.CFDTMDF7_84.UINT16[L/H]
RCFDC0.CFDTMDF7_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_84.UINT32
RCFDC0.CFDTMDF8_84.UINT16[L/H]
RCFDC0.CFDTMDF8_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_84.UINT32
RCFDC0.CFDTMDF9_84.UINT16[L/H]
RCFDC0.CFDTMDF9_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_84.UINT32
RCFDC0.CFDTMDF10_84.UINT16[L/H]
RCFDC0.CFDTMDF10_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_84.UINT32
RCFDC0.CFDTMDF11_84.UINT16[L/H]
RCFDC0.CFDTMDF11_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_84.UINT32
RCFDC0.CFDTMDF12_84.UINT16[L/H]
RCFDC0.CFDTMDF12_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_84.UINT32
RCFDC0.CFDTMDF13_84.UINT16[L/H]
RCFDC0.CFDTMDF13_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_84.UINT32
RCFDC0.CFDTMDF14_84.UINT16[L/H]
RCFDC0.CFDTMDF14_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_84.UINT32
RCFDC0.CFDTMDF15_84.UINT16[L/H]
RCFDC0.CFDTMDF15_84.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID85.UINT32
RCFDC0.CFDTMID85.UINT16[L/H]
RCFDC0.CFDTMID85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR85.UINT32
RCFDC0.CFDTMPTR85.UINT16[H]
RCFDC0.CFDTMPTR85.UINT8[HH]
RCFDC0.CFDTMFDCTR85.UINT32
RCFDC0.CFDTMFDCTR85.UINT16[L/H]
RCFDC0.CFDTMFDCTR85.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_85.UINT32
RCFDC0.CFDTMDF0_85.UINT16[L/H]
RCFDC0.CFDTMDF0_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_85.UINT32
RCFDC0.CFDTMDF1_85.UINT16[L/H]
RCFDC0.CFDTMDF1_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_85.UINT32
RCFDC0.CFDTMDF2_85.UINT16[L/H]
RCFDC0.CFDTMDF2_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_85.UINT32
RCFDC0.CFDTMDF3_85.UINT16[L/H]
RCFDC0.CFDTMDF3_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_85.UINT32
RCFDC0.CFDTMDF4_85.UINT16[L/H]
RCFDC0.CFDTMDF4_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_85.UINT32
RCFDC0.CFDTMDF5_85.UINT16[L/H]
RCFDC0.CFDTMDF5_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_85.UINT32
RCFDC0.CFDTMDF6_85.UINT16[L/H]
RCFDC0.CFDTMDF6_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_85.UINT32
RCFDC0.CFDTMDF7_85.UINT16[L/H]
RCFDC0.CFDTMDF7_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_85.UINT32
RCFDC0.CFDTMDF8_85.UINT16[L/H]
RCFDC0.CFDTMDF8_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_85.UINT32
RCFDC0.CFDTMDF9_85.UINT16[L/H]
RCFDC0.CFDTMDF9_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_85.UINT32
RCFDC0.CFDTMDF10_85.UINT16[L/H]
RCFDC0.CFDTMDF10_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_85.UINT32
RCFDC0.CFDTMDF11_85.UINT16[L/H]
RCFDC0.CFDTMDF11_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_85.UINT32
RCFDC0.CFDTMDF12_85.UINT16[L/H]
RCFDC0.CFDTMDF12_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_85.UINT32
RCFDC0.CFDTMDF13_85.UINT16[L/H]
RCFDC0.CFDTMDF13_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_85.UINT32
RCFDC0.CFDTMDF14_85.UINT16[L/H]
RCFDC0.CFDTMDF14_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_85.UINT32
RCFDC0.CFDTMDF15_85.UINT16[L/H]
RCFDC0.CFDTMDF15_85.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID86.UINT32
RCFDC0.CFDTMID86.UINT16[L/H]
RCFDC0.CFDTMID86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR86.UINT32
RCFDC0.CFDTMPTR86.UINT16[H]
RCFDC0.CFDTMPTR86.UINT8[HH]
RCFDC0.CFDTMFDCTR86.UINT32
RCFDC0.CFDTMFDCTR86.UINT16[L/H]
RCFDC0.CFDTMFDCTR86.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_86.UINT32
RCFDC0.CFDTMDF0_86.UINT16[L/H]
RCFDC0.CFDTMDF0_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_86.UINT32
RCFDC0.CFDTMDF1_86.UINT16[L/H]
RCFDC0.CFDTMDF1_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_86.UINT32
RCFDC0.CFDTMDF2_86.UINT16[L/H]
RCFDC0.CFDTMDF2_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_86.UINT32
RCFDC0.CFDTMDF3_86.UINT16[L/H]
RCFDC0.CFDTMDF3_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_86.UINT32
RCFDC0.CFDTMDF4_86.UINT16[L/H]
RCFDC0.CFDTMDF4_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_86.UINT32
RCFDC0.CFDTMDF5_86.UINT16[L/H]
RCFDC0.CFDTMDF5_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_86.UINT32
RCFDC0.CFDTMDF6_86.UINT16[L/H]
RCFDC0.CFDTMDF6_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_86.UINT32
RCFDC0.CFDTMDF7_86.UINT16[L/H]
RCFDC0.CFDTMDF7_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_86.UINT32
RCFDC0.CFDTMDF8_86.UINT16[L/H]
RCFDC0.CFDTMDF8_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_86.UINT32
RCFDC0.CFDTMDF9_86.UINT16[L/H]
RCFDC0.CFDTMDF9_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_86.UINT32
RCFDC0.CFDTMDF10_86.UINT16[L/H]
RCFDC0.CFDTMDF10_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_86.UINT32
RCFDC0.CFDTMDF11_86.UINT16[L/H]
RCFDC0.CFDTMDF11_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_86.UINT32
RCFDC0.CFDTMDF12_86.UINT16[L/H]
RCFDC0.CFDTMDF12_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_86.UINT32
RCFDC0.CFDTMDF13_86.UINT16[L/H]
RCFDC0.CFDTMDF13_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_86.UINT32
RCFDC0.CFDTMDF14_86.UINT16[L/H]
RCFDC0.CFDTMDF14_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_86.UINT32
RCFDC0.CFDTMDF15_86.UINT16[L/H]
RCFDC0.CFDTMDF15_86.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID87.UINT32
RCFDC0.CFDTMID87.UINT16[L/H]
RCFDC0.CFDTMID87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR87.UINT32
RCFDC0.CFDTMPTR87.UINT16[H]
RCFDC0.CFDTMPTR87.UINT8[HH]
RCFDC0.CFDTMFDCTR87.UINT32
RCFDC0.CFDTMFDCTR87.UINT16[L/H]
RCFDC0.CFDTMFDCTR87.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_87.UINT32
RCFDC0.CFDTMDF0_87.UINT16[L/H]
RCFDC0.CFDTMDF0_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_87.UINT32
RCFDC0.CFDTMDF1_87.UINT16[L/H]
RCFDC0.CFDTMDF1_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_87.UINT32
RCFDC0.CFDTMDF2_87.UINT16[L/H]
RCFDC0.CFDTMDF2_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_87.UINT32
RCFDC0.CFDTMDF3_87.UINT16[L/H]
RCFDC0.CFDTMDF3_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_87.UINT32
RCFDC0.CFDTMDF4_87.UINT16[L/H]
RCFDC0.CFDTMDF4_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_87.UINT32
RCFDC0.CFDTMDF5_87.UINT16[L/H]
RCFDC0.CFDTMDF5_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_87.UINT32
RCFDC0.CFDTMDF6_87.UINT16[L/H]
RCFDC0.CFDTMDF6_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_87.UINT32
RCFDC0.CFDTMDF7_87.UINT16[L/H]
RCFDC0.CFDTMDF7_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_87.UINT32
RCFDC0.CFDTMDF8_87.UINT16[L/H]
RCFDC0.CFDTMDF8_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_87.UINT32
RCFDC0.CFDTMDF9_87.UINT16[L/H]
RCFDC0.CFDTMDF9_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_87.UINT32
RCFDC0.CFDTMDF10_87.UINT16[L/H]
RCFDC0.CFDTMDF10_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_87.UINT32
RCFDC0.CFDTMDF11_87.UINT16[L/H]
RCFDC0.CFDTMDF11_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_87.UINT32
RCFDC0.CFDTMDF12_87.UINT16[L/H]
RCFDC0.CFDTMDF12_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_87.UINT32
RCFDC0.CFDTMDF13_87.UINT16[L/H]
RCFDC0.CFDTMDF13_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_87.UINT32
RCFDC0.CFDTMDF14_87.UINT16[L/H]
RCFDC0.CFDTMDF14_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_87.UINT32
RCFDC0.CFDTMDF15_87.UINT16[L/H]
RCFDC0.CFDTMDF15_87.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID88.UINT32
RCFDC0.CFDTMID88.UINT16[L/H]
RCFDC0.CFDTMID88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR88.UINT32
RCFDC0.CFDTMPTR88.UINT16[H]
RCFDC0.CFDTMPTR88.UINT8[HH]
RCFDC0.CFDTMFDCTR88.UINT32
RCFDC0.CFDTMFDCTR88.UINT16[L/H]
RCFDC0.CFDTMFDCTR88.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_88.UINT32
RCFDC0.CFDTMDF0_88.UINT16[L/H]
RCFDC0.CFDTMDF0_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_88.UINT32
RCFDC0.CFDTMDF1_88.UINT16[L/H]
RCFDC0.CFDTMDF1_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_88.UINT32
RCFDC0.CFDTMDF2_88.UINT16[L/H]
RCFDC0.CFDTMDF2_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_88.UINT32
RCFDC0.CFDTMDF3_88.UINT16[L/H]
RCFDC0.CFDTMDF3_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_88.UINT32
RCFDC0.CFDTMDF4_88.UINT16[L/H]
RCFDC0.CFDTMDF4_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_88.UINT32
RCFDC0.CFDTMDF5_88.UINT16[L/H]
RCFDC0.CFDTMDF5_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_88.UINT32
RCFDC0.CFDTMDF6_88.UINT16[L/H]
RCFDC0.CFDTMDF6_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_88.UINT32
RCFDC0.CFDTMDF7_88.UINT16[L/H]
RCFDC0.CFDTMDF7_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_88.UINT32
RCFDC0.CFDTMDF8_88.UINT16[L/H]
RCFDC0.CFDTMDF8_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_88.UINT32
RCFDC0.CFDTMDF9_88.UINT16[L/H]
RCFDC0.CFDTMDF9_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_88.UINT32
RCFDC0.CFDTMDF10_88.UINT16[L/H]
RCFDC0.CFDTMDF10_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_88.UINT32
RCFDC0.CFDTMDF11_88.UINT16[L/H]
RCFDC0.CFDTMDF11_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_88.UINT32
RCFDC0.CFDTMDF12_88.UINT16[L/H]
RCFDC0.CFDTMDF12_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_88.UINT32
RCFDC0.CFDTMDF13_88.UINT16[L/H]
RCFDC0.CFDTMDF13_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_88.UINT32
RCFDC0.CFDTMDF14_88.UINT16[L/H]
RCFDC0.CFDTMDF14_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_88.UINT32
RCFDC0.CFDTMDF15_88.UINT16[L/H]
RCFDC0.CFDTMDF15_88.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID89.UINT32
RCFDC0.CFDTMID89.UINT16[L/H]
RCFDC0.CFDTMID89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR89.UINT32
RCFDC0.CFDTMPTR89.UINT16[H]
RCFDC0.CFDTMPTR89.UINT8[HH]
RCFDC0.CFDTMFDCTR89.UINT32
RCFDC0.CFDTMFDCTR89.UINT16[L/H]
RCFDC0.CFDTMFDCTR89.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_89.UINT32
RCFDC0.CFDTMDF0_89.UINT16[L/H]
RCFDC0.CFDTMDF0_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_89.UINT32
RCFDC0.CFDTMDF1_89.UINT16[L/H]
RCFDC0.CFDTMDF1_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_89.UINT32
RCFDC0.CFDTMDF2_89.UINT16[L/H]
RCFDC0.CFDTMDF2_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_89.UINT32
RCFDC0.CFDTMDF3_89.UINT16[L/H]
RCFDC0.CFDTMDF3_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_89.UINT32
RCFDC0.CFDTMDF4_89.UINT16[L/H]
RCFDC0.CFDTMDF4_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_89.UINT32
RCFDC0.CFDTMDF5_89.UINT16[L/H]
RCFDC0.CFDTMDF5_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_89.UINT32
RCFDC0.CFDTMDF6_89.UINT16[L/H]
RCFDC0.CFDTMDF6_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_89.UINT32
RCFDC0.CFDTMDF7_89.UINT16[L/H]
RCFDC0.CFDTMDF7_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_89.UINT32
RCFDC0.CFDTMDF8_89.UINT16[L/H]
RCFDC0.CFDTMDF8_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_89.UINT32
RCFDC0.CFDTMDF9_89.UINT16[L/H]
RCFDC0.CFDTMDF9_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_89.UINT32
RCFDC0.CFDTMDF10_89.UINT16[L/H]
RCFDC0.CFDTMDF10_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_89.UINT32
RCFDC0.CFDTMDF11_89.UINT16[L/H]
RCFDC0.CFDTMDF11_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_89.UINT32
RCFDC0.CFDTMDF12_89.UINT16[L/H]
RCFDC0.CFDTMDF12_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_89.UINT32
RCFDC0.CFDTMDF13_89.UINT16[L/H]
RCFDC0.CFDTMDF13_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_89.UINT32
RCFDC0.CFDTMDF14_89.UINT16[L/H]
RCFDC0.CFDTMDF14_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_89.UINT32
RCFDC0.CFDTMDF15_89.UINT16[L/H]
RCFDC0.CFDTMDF15_89.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID90.UINT32
RCFDC0.CFDTMID90.UINT16[L/H]
RCFDC0.CFDTMID90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR90.UINT32
RCFDC0.CFDTMPTR90.UINT16[H]
RCFDC0.CFDTMPTR90.UINT8[HH]
RCFDC0.CFDTMFDCTR90.UINT32
RCFDC0.CFDTMFDCTR90.UINT16[L/H]
RCFDC0.CFDTMFDCTR90.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_90.UINT32
RCFDC0.CFDTMDF0_90.UINT16[L/H]
RCFDC0.CFDTMDF0_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_90.UINT32
RCFDC0.CFDTMDF1_90.UINT16[L/H]
RCFDC0.CFDTMDF1_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_90.UINT32
RCFDC0.CFDTMDF2_90.UINT16[L/H]
RCFDC0.CFDTMDF2_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_90.UINT32
RCFDC0.CFDTMDF3_90.UINT16[L/H]
RCFDC0.CFDTMDF3_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_90.UINT32
RCFDC0.CFDTMDF4_90.UINT16[L/H]
RCFDC0.CFDTMDF4_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_90.UINT32
RCFDC0.CFDTMDF5_90.UINT16[L/H]
RCFDC0.CFDTMDF5_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_90.UINT32
RCFDC0.CFDTMDF6_90.UINT16[L/H]
RCFDC0.CFDTMDF6_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_90.UINT32
RCFDC0.CFDTMDF7_90.UINT16[L/H]
RCFDC0.CFDTMDF7_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_90.UINT32
RCFDC0.CFDTMDF8_90.UINT16[L/H]
RCFDC0.CFDTMDF8_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_90.UINT32
RCFDC0.CFDTMDF9_90.UINT16[L/H]
RCFDC0.CFDTMDF9_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_90.UINT32
RCFDC0.CFDTMDF10_90.UINT16[L/H]
RCFDC0.CFDTMDF10_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_90.UINT32
RCFDC0.CFDTMDF11_90.UINT16[L/H]
RCFDC0.CFDTMDF11_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_90.UINT32
RCFDC0.CFDTMDF12_90.UINT16[L/H]
RCFDC0.CFDTMDF12_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_90.UINT32
RCFDC0.CFDTMDF13_90.UINT16[L/H]
RCFDC0.CFDTMDF13_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_90.UINT32
RCFDC0.CFDTMDF14_90.UINT16[L/H]
RCFDC0.CFDTMDF14_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_90.UINT32
RCFDC0.CFDTMDF15_90.UINT16[L/H]
RCFDC0.CFDTMDF15_90.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID91.UINT32
RCFDC0.CFDTMID91.UINT16[L/H]
RCFDC0.CFDTMID91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR91.UINT32
RCFDC0.CFDTMPTR91.UINT16[H]
RCFDC0.CFDTMPTR91.UINT8[HH]
RCFDC0.CFDTMFDCTR91.UINT32
RCFDC0.CFDTMFDCTR91.UINT16[L/H]
RCFDC0.CFDTMFDCTR91.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_91.UINT32
RCFDC0.CFDTMDF0_91.UINT16[L/H]
RCFDC0.CFDTMDF0_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_91.UINT32
RCFDC0.CFDTMDF1_91.UINT16[L/H]
RCFDC0.CFDTMDF1_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_91.UINT32
RCFDC0.CFDTMDF2_91.UINT16[L/H]
RCFDC0.CFDTMDF2_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_91.UINT32
RCFDC0.CFDTMDF3_91.UINT16[L/H]
RCFDC0.CFDTMDF3_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_91.UINT32
RCFDC0.CFDTMDF4_91.UINT16[L/H]
RCFDC0.CFDTMDF4_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_91.UINT32
RCFDC0.CFDTMDF5_91.UINT16[L/H]
RCFDC0.CFDTMDF5_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_91.UINT32
RCFDC0.CFDTMDF6_91.UINT16[L/H]
RCFDC0.CFDTMDF6_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_91.UINT32
RCFDC0.CFDTMDF7_91.UINT16[L/H]
RCFDC0.CFDTMDF7_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_91.UINT32
RCFDC0.CFDTMDF8_91.UINT16[L/H]
RCFDC0.CFDTMDF8_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_91.UINT32
RCFDC0.CFDTMDF9_91.UINT16[L/H]
RCFDC0.CFDTMDF9_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_91.UINT32
RCFDC0.CFDTMDF10_91.UINT16[L/H]
RCFDC0.CFDTMDF10_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_91.UINT32
RCFDC0.CFDTMDF11_91.UINT16[L/H]
RCFDC0.CFDTMDF11_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_91.UINT32
RCFDC0.CFDTMDF12_91.UINT16[L/H]
RCFDC0.CFDTMDF12_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_91.UINT32
RCFDC0.CFDTMDF13_91.UINT16[L/H]
RCFDC0.CFDTMDF13_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_91.UINT32
RCFDC0.CFDTMDF14_91.UINT16[L/H]
RCFDC0.CFDTMDF14_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_91.UINT32
RCFDC0.CFDTMDF15_91.UINT16[L/H]
RCFDC0.CFDTMDF15_91.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID92.UINT32
RCFDC0.CFDTMID92.UINT16[L/H]
RCFDC0.CFDTMID92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR92.UINT32
RCFDC0.CFDTMPTR92.UINT16[H]
RCFDC0.CFDTMPTR92.UINT8[HH]
RCFDC0.CFDTMFDCTR92.UINT32
RCFDC0.CFDTMFDCTR92.UINT16[L/H]
RCFDC0.CFDTMFDCTR92.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_92.UINT32
RCFDC0.CFDTMDF0_92.UINT16[L/H]
RCFDC0.CFDTMDF0_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_92.UINT32
RCFDC0.CFDTMDF1_92.UINT16[L/H]
RCFDC0.CFDTMDF1_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_92.UINT32
RCFDC0.CFDTMDF2_92.UINT16[L/H]
RCFDC0.CFDTMDF2_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_92.UINT32
RCFDC0.CFDTMDF3_92.UINT16[L/H]
RCFDC0.CFDTMDF3_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_92.UINT32
RCFDC0.CFDTMDF4_92.UINT16[L/H]
RCFDC0.CFDTMDF4_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_92.UINT32
RCFDC0.CFDTMDF5_92.UINT16[L/H]
RCFDC0.CFDTMDF5_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_92.UINT32
RCFDC0.CFDTMDF6_92.UINT16[L/H]
RCFDC0.CFDTMDF6_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_92.UINT32
RCFDC0.CFDTMDF7_92.UINT16[L/H]
RCFDC0.CFDTMDF7_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_92.UINT32
RCFDC0.CFDTMDF8_92.UINT16[L/H]
RCFDC0.CFDTMDF8_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_92.UINT32
RCFDC0.CFDTMDF9_92.UINT16[L/H]
RCFDC0.CFDTMDF9_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_92.UINT32
RCFDC0.CFDTMDF10_92.UINT16[L/H]
RCFDC0.CFDTMDF10_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_92.UINT32
RCFDC0.CFDTMDF11_92.UINT16[L/H]
RCFDC0.CFDTMDF11_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_92.UINT32
RCFDC0.CFDTMDF12_92.UINT16[L/H]
RCFDC0.CFDTMDF12_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_92.UINT32
RCFDC0.CFDTMDF13_92.UINT16[L/H]
RCFDC0.CFDTMDF13_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_92.UINT32
RCFDC0.CFDTMDF14_92.UINT16[L/H]
RCFDC0.CFDTMDF14_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_92.UINT32
RCFDC0.CFDTMDF15_92.UINT16[L/H]
RCFDC0.CFDTMDF15_92.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID93.UINT32
RCFDC0.CFDTMID93.UINT16[L/H]
RCFDC0.CFDTMID93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR93.UINT32
RCFDC0.CFDTMPTR93.UINT16[H]
RCFDC0.CFDTMPTR93.UINT8[HH]
RCFDC0.CFDTMFDCTR93.UINT32
RCFDC0.CFDTMFDCTR93.UINT16[L/H]
RCFDC0.CFDTMFDCTR93.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_93.UINT32
RCFDC0.CFDTMDF0_93.UINT16[L/H]
RCFDC0.CFDTMDF0_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_93.UINT32
RCFDC0.CFDTMDF1_93.UINT16[L/H]
RCFDC0.CFDTMDF1_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_93.UINT32
RCFDC0.CFDTMDF2_93.UINT16[L/H]
RCFDC0.CFDTMDF2_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_93.UINT32
RCFDC0.CFDTMDF3_93.UINT16[L/H]
RCFDC0.CFDTMDF3_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_93.UINT32
RCFDC0.CFDTMDF4_93.UINT16[L/H]
RCFDC0.CFDTMDF4_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_93.UINT32
RCFDC0.CFDTMDF5_93.UINT16[L/H]
RCFDC0.CFDTMDF5_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_93.UINT32
RCFDC0.CFDTMDF6_93.UINT16[L/H]
RCFDC0.CFDTMDF6_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_93.UINT32
RCFDC0.CFDTMDF7_93.UINT16[L/H]
RCFDC0.CFDTMDF7_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_93.UINT32
RCFDC0.CFDTMDF8_93.UINT16[L/H]
RCFDC0.CFDTMDF8_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_93.UINT32
RCFDC0.CFDTMDF9_93.UINT16[L/H]
RCFDC0.CFDTMDF9_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_93.UINT32
RCFDC0.CFDTMDF10_93.UINT16[L/H]
RCFDC0.CFDTMDF10_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_93.UINT32
RCFDC0.CFDTMDF11_93.UINT16[L/H]
RCFDC0.CFDTMDF11_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_93.UINT32
RCFDC0.CFDTMDF12_93.UINT16[L/H]
RCFDC0.CFDTMDF12_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_93.UINT32
RCFDC0.CFDTMDF13_93.UINT16[L/H]
RCFDC0.CFDTMDF13_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_93.UINT32
RCFDC0.CFDTMDF14_93.UINT16[L/H]
RCFDC0.CFDTMDF14_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_93.UINT32
RCFDC0.CFDTMDF15_93.UINT16[L/H]
RCFDC0.CFDTMDF15_93.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID94.UINT32
RCFDC0.CFDTMID94.UINT16[L/H]
RCFDC0.CFDTMID94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR94.UINT32
RCFDC0.CFDTMPTR94.UINT16[H]
RCFDC0.CFDTMPTR94.UINT8[HH]
RCFDC0.CFDTMFDCTR94.UINT32
RCFDC0.CFDTMFDCTR94.UINT16[L/H]
RCFDC0.CFDTMFDCTR94.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_94.UINT32
RCFDC0.CFDTMDF0_94.UINT16[L/H]
RCFDC0.CFDTMDF0_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_94.UINT32
RCFDC0.CFDTMDF1_94.UINT16[L/H]
RCFDC0.CFDTMDF1_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_94.UINT32
RCFDC0.CFDTMDF2_94.UINT16[L/H]
RCFDC0.CFDTMDF2_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_94.UINT32
RCFDC0.CFDTMDF3_94.UINT16[L/H]
RCFDC0.CFDTMDF3_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_94.UINT32
RCFDC0.CFDTMDF4_94.UINT16[L/H]
RCFDC0.CFDTMDF4_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_94.UINT32
RCFDC0.CFDTMDF5_94.UINT16[L/H]
RCFDC0.CFDTMDF5_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_94.UINT32
RCFDC0.CFDTMDF6_94.UINT16[L/H]
RCFDC0.CFDTMDF6_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_94.UINT32
RCFDC0.CFDTMDF7_94.UINT16[L/H]
RCFDC0.CFDTMDF7_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_94.UINT32
RCFDC0.CFDTMDF8_94.UINT16[L/H]
RCFDC0.CFDTMDF8_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_94.UINT32
RCFDC0.CFDTMDF9_94.UINT16[L/H]
RCFDC0.CFDTMDF9_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_94.UINT32
RCFDC0.CFDTMDF10_94.UINT16[L/H]
RCFDC0.CFDTMDF10_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_94.UINT32
RCFDC0.CFDTMDF11_94.UINT16[L/H]
RCFDC0.CFDTMDF11_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_94.UINT32
RCFDC0.CFDTMDF12_94.UINT16[L/H]
RCFDC0.CFDTMDF12_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_94.UINT32
RCFDC0.CFDTMDF13_94.UINT16[L/H]
RCFDC0.CFDTMDF13_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_94.UINT32
RCFDC0.CFDTMDF14_94.UINT16[L/H]
RCFDC0.CFDTMDF14_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_94.UINT32
RCFDC0.CFDTMDF15_94.UINT16[L/H]
RCFDC0.CFDTMDF15_94.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMID95.UINT32
RCFDC0.CFDTMID95.UINT16[L/H]
RCFDC0.CFDTMID95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMPTR95.UINT32
RCFDC0.CFDTMPTR95.UINT16[H]
RCFDC0.CFDTMPTR95.UINT8[HH]
RCFDC0.CFDTMFDCTR95.UINT32
RCFDC0.CFDTMFDCTR95.UINT16[L/H]
RCFDC0.CFDTMFDCTR95.UINT8[LL/HL/HH]
RCFDC0.CFDTMDF0_95.UINT32
RCFDC0.CFDTMDF0_95.UINT16[L/H]
RCFDC0.CFDTMDF0_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF1_95.UINT32
RCFDC0.CFDTMDF1_95.UINT16[L/H]
RCFDC0.CFDTMDF1_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF2_95.UINT32
RCFDC0.CFDTMDF2_95.UINT16[L/H]
RCFDC0.CFDTMDF2_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF3_95.UINT32
RCFDC0.CFDTMDF3_95.UINT16[L/H]
RCFDC0.CFDTMDF3_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF4_95.UINT32
RCFDC0.CFDTMDF4_95.UINT16[L/H]
RCFDC0.CFDTMDF4_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF5_95.UINT32
RCFDC0.CFDTMDF5_95.UINT16[L/H]
RCFDC0.CFDTMDF5_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF6_95.UINT32
RCFDC0.CFDTMDF6_95.UINT16[L/H]
RCFDC0.CFDTMDF6_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF7_95.UINT32
RCFDC0.CFDTMDF7_95.UINT16[L/H]
RCFDC0.CFDTMDF7_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF8_95.UINT32
RCFDC0.CFDTMDF8_95.UINT16[L/H]
RCFDC0.CFDTMDF8_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF9_95.UINT32
RCFDC0.CFDTMDF9_95.UINT16[L/H]
RCFDC0.CFDTMDF9_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF10_95.UINT32
RCFDC0.CFDTMDF10_95.UINT16[L/H]
RCFDC0.CFDTMDF10_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF11_95.UINT32
RCFDC0.CFDTMDF11_95.UINT16[L/H]
RCFDC0.CFDTMDF11_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF12_95.UINT32
RCFDC0.CFDTMDF12_95.UINT16[L/H]
RCFDC0.CFDTMDF12_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF13_95.UINT32
RCFDC0.CFDTMDF13_95.UINT16[L/H]
RCFDC0.CFDTMDF13_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF14_95.UINT32
RCFDC0.CFDTMDF14_95.UINT16[L/H]
RCFDC0.CFDTMDF14_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTMDF15_95.UINT32
RCFDC0.CFDTMDF15_95.UINT16[L/H]
RCFDC0.CFDTMDF15_95.UINT8[LL/LH/HL/HH]
RCFDC0.CFDTHLACC00.UINT32
RCFDC0.CFDTHLACC00.UINT16[L/H]
RCFDC0.CFDTHLACC00.UINT8[LL/HL/HH]
RCFDC0.CFDTHLACC10.UINT32
RCFDC0.CFDTHLACC10.UINT16[L]
RCFDC0.CFDTHLACC10.UINT8[LL/LH]
RCFDC0.CFDTHLACC01.UINT32
RCFDC0.CFDTHLACC01.UINT16[L/H]
RCFDC0.CFDTHLACC01.UINT8[LL/HL/HH]
RCFDC0.CFDTHLACC11.UINT32
RCFDC0.CFDTHLACC11.UINT16[L]
RCFDC0.CFDTHLACC11.UINT8[LL/LH]
RCFDC0.CFDTHLACC02.UINT32
RCFDC0.CFDTHLACC02.UINT16[L/H]
RCFDC0.CFDTHLACC02.UINT8[LL/HL/HH]
RCFDC0.CFDTHLACC12.UINT32
RCFDC0.CFDTHLACC12.UINT16[L]
RCFDC0.CFDTHLACC12.UINT8[LL/LH]
RCFDC0.CFDRPGACC0.UINT32
RCFDC0.CFDRPGACC0.UINT16[L/H]
RCFDC0.CFDRPGACC0.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC1.UINT32
RCFDC0.CFDRPGACC1.UINT16[L/H]
RCFDC0.CFDRPGACC1.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC2.UINT32
RCFDC0.CFDRPGACC2.UINT16[L/H]
RCFDC0.CFDRPGACC2.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC3.UINT32
RCFDC0.CFDRPGACC3.UINT16[L/H]
RCFDC0.CFDRPGACC3.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC4.UINT32
RCFDC0.CFDRPGACC4.UINT16[L/H]
RCFDC0.CFDRPGACC4.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC5.UINT32
RCFDC0.CFDRPGACC5.UINT16[L/H]
RCFDC0.CFDRPGACC5.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC6.UINT32
RCFDC0.CFDRPGACC6.UINT16[L/H]
RCFDC0.CFDRPGACC6.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC7.UINT32
RCFDC0.CFDRPGACC7.UINT16[L/H]
RCFDC0.CFDRPGACC7.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC8.UINT32
RCFDC0.CFDRPGACC8.UINT16[L/H]
RCFDC0.CFDRPGACC8.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC9.UINT32
RCFDC0.CFDRPGACC9.UINT16[L/H]
RCFDC0.CFDRPGACC9.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC10.UINT32
RCFDC0.CFDRPGACC10.UINT16[L/H]
RCFDC0.CFDRPGACC10.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC11.UINT32
RCFDC0.CFDRPGACC11.UINT16[L/H]
RCFDC0.CFDRPGACC11.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC12.UINT32
RCFDC0.CFDRPGACC12.UINT16[L/H]
RCFDC0.CFDRPGACC12.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC13.UINT32
RCFDC0.CFDRPGACC13.UINT16[L/H]
RCFDC0.CFDRPGACC13.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC14.UINT32
RCFDC0.CFDRPGACC14.UINT16[L/H]
RCFDC0.CFDRPGACC14.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC15.UINT32
RCFDC0.CFDRPGACC15.UINT16[L/H]
RCFDC0.CFDRPGACC15.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC16.UINT32
RCFDC0.CFDRPGACC16.UINT16[L/H]
RCFDC0.CFDRPGACC16.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC17.UINT32
RCFDC0.CFDRPGACC17.UINT16[L/H]
RCFDC0.CFDRPGACC17.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC18.UINT32
RCFDC0.CFDRPGACC18.UINT16[L/H]
RCFDC0.CFDRPGACC18.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC19.UINT32
RCFDC0.CFDRPGACC19.UINT16[L/H]
RCFDC0.CFDRPGACC19.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC20.UINT32
RCFDC0.CFDRPGACC20.UINT16[L/H]
RCFDC0.CFDRPGACC20.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC21.UINT32
RCFDC0.CFDRPGACC21.UINT16[L/H]
RCFDC0.CFDRPGACC21.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC22.UINT32
RCFDC0.CFDRPGACC22.UINT16[L/H]
RCFDC0.CFDRPGACC22.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC23.UINT32
RCFDC0.CFDRPGACC23.UINT16[L/H]
RCFDC0.CFDRPGACC23.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC24.UINT32
RCFDC0.CFDRPGACC24.UINT16[L/H]
RCFDC0.CFDRPGACC24.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC25.UINT32
RCFDC0.CFDRPGACC25.UINT16[L/H]
RCFDC0.CFDRPGACC25.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC26.UINT32
RCFDC0.CFDRPGACC26.UINT16[L/H]
RCFDC0.CFDRPGACC26.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC27.UINT32
RCFDC0.CFDRPGACC27.UINT16[L/H]
RCFDC0.CFDRPGACC27.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC28.UINT32
RCFDC0.CFDRPGACC28.UINT16[L/H]
RCFDC0.CFDRPGACC28.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC29.UINT32
RCFDC0.CFDRPGACC29.UINT16[L/H]
RCFDC0.CFDRPGACC29.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC30.UINT32
RCFDC0.CFDRPGACC30.UINT16[L/H]
RCFDC0.CFDRPGACC30.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC31.UINT32
RCFDC0.CFDRPGACC31.UINT16[L/H]
RCFDC0.CFDRPGACC31.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC32.UINT32
RCFDC0.CFDRPGACC32.UINT16[L/H]
RCFDC0.CFDRPGACC32.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC33.UINT32
RCFDC0.CFDRPGACC33.UINT16[L/H]
RCFDC0.CFDRPGACC33.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC34.UINT32
RCFDC0.CFDRPGACC34.UINT16[L/H]
RCFDC0.CFDRPGACC34.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC35.UINT32
RCFDC0.CFDRPGACC35.UINT16[L/H]
RCFDC0.CFDRPGACC35.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC36.UINT32
RCFDC0.CFDRPGACC36.UINT16[L/H]
RCFDC0.CFDRPGACC36.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC37.UINT32
RCFDC0.CFDRPGACC37.UINT16[L/H]
RCFDC0.CFDRPGACC37.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC38.UINT32
RCFDC0.CFDRPGACC38.UINT16[L/H]
RCFDC0.CFDRPGACC38.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC39.UINT32
RCFDC0.CFDRPGACC39.UINT16[L/H]
RCFDC0.CFDRPGACC39.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC40.UINT32
RCFDC0.CFDRPGACC40.UINT16[L/H]
RCFDC0.CFDRPGACC40.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC41.UINT32
RCFDC0.CFDRPGACC41.UINT16[L/H]
RCFDC0.CFDRPGACC41.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC42.UINT32
RCFDC0.CFDRPGACC42.UINT16[L/H]
RCFDC0.CFDRPGACC42.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC43.UINT32
RCFDC0.CFDRPGACC43.UINT16[L/H]
RCFDC0.CFDRPGACC43.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC44.UINT32
RCFDC0.CFDRPGACC44.UINT16[L/H]
RCFDC0.CFDRPGACC44.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC45.UINT32
RCFDC0.CFDRPGACC45.UINT16[L/H]
RCFDC0.CFDRPGACC45.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC46.UINT32
RCFDC0.CFDRPGACC46.UINT16[L/H]
RCFDC0.CFDRPGACC46.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC47.UINT32
RCFDC0.CFDRPGACC47.UINT16[L/H]
RCFDC0.CFDRPGACC47.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC48.UINT32
RCFDC0.CFDRPGACC48.UINT16[L/H]
RCFDC0.CFDRPGACC48.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC49.UINT32
RCFDC0.CFDRPGACC49.UINT16[L/H]
RCFDC0.CFDRPGACC49.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC50.UINT32
RCFDC0.CFDRPGACC50.UINT16[L/H]
RCFDC0.CFDRPGACC50.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC51.UINT32
RCFDC0.CFDRPGACC51.UINT16[L/H]
RCFDC0.CFDRPGACC51.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC52.UINT32
RCFDC0.CFDRPGACC52.UINT16[L/H]
RCFDC0.CFDRPGACC52.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC53.UINT32
RCFDC0.CFDRPGACC53.UINT16[L/H]
RCFDC0.CFDRPGACC53.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC54.UINT32
RCFDC0.CFDRPGACC54.UINT16[L/H]
RCFDC0.CFDRPGACC54.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC55.UINT32
RCFDC0.CFDRPGACC55.UINT16[L/H]
RCFDC0.CFDRPGACC55.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC56.UINT32
RCFDC0.CFDRPGACC56.UINT16[L/H]
RCFDC0.CFDRPGACC56.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC57.UINT32
RCFDC0.CFDRPGACC57.UINT16[L/H]
RCFDC0.CFDRPGACC57.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC58.UINT32
RCFDC0.CFDRPGACC58.UINT16[L/H]
RCFDC0.CFDRPGACC58.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC59.UINT32
RCFDC0.CFDRPGACC59.UINT16[L/H]
RCFDC0.CFDRPGACC59.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC60.UINT32
RCFDC0.CFDRPGACC60.UINT16[L/H]
RCFDC0.CFDRPGACC60.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC61.UINT32
RCFDC0.CFDRPGACC61.UINT16[L/H]
RCFDC0.CFDRPGACC61.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC62.UINT32
RCFDC0.CFDRPGACC62.UINT16[L/H]
RCFDC0.CFDRPGACC62.UINT8[LL/LH/HL/HH]
RCFDC0.CFDRPGACC63.UINT32
RCFDC0.CFDRPGACC63.UINT16[L/H]
RCFDC0.CFDRPGACC63.UINT8[LL/LH/HL/HH]
OSTM0.CMP
OSTM0.CNT
OSTM0.TE
OSTM0.TS
OSTM0.TT
OSTM0.CTL
OSTM0.EMU
CSIH0.CTL0
CSIH0.STR0
CSIH0.STCR0
CSIH0.CTL1
CSIH0.CTL2
CSIH0.EMU.UINT8
CSIH0.EMU.BIT.SVSDIS
CSIH0.MCTL1
CSIH0.MCTL2
CSIH0.TX0W
CSIH0.TX0H
CSIH0.RX0W
CSIH0.RX0H
CSIH0.MRWP0
CSIH0.MCTL0
CSIH0.CFG0 ... CSIH0.CFG3
CSIH0.BRS0 ... CSIH0.BRS3
CSIG0.CTL0
CSIG0.STR0
CSIG0.STCR0
CSIG0.CTL1
CSIG0.CTL2
CSIG0.EMU.UINT8
CSIG0.EMU.BIT.SVSDIS
CSIG0.BCTL0.UINT8
CSIG0.BCTL0.BIT.SCE
CSIG0.TX0W
CSIG0.TX0H
CSIG0.RX0
CSIG0.CFG0
PIC0.SST
PIC0.SSER0
PIC0.SSER2
PIC0.HIZCEN0
PIC0.ADTEN400 ... PIC0.ADTEN402
PIC0.REG200 ... PIC0.REG203
PIC0.REG30
PIC0.REG31
PBG20.FSGD02PROT0.UINT32
PBG20.FSGD02PROT0.UINT16[L/H]
PBG20.FSGD02PROT0.UINT8[LL/HL/HH]
PBG20.FSGD02PROT1.UINT32
PBG20.FSGD02PROT1.UINT16[L/H]
PBG20.FSGD02PROT1.UINT8[LL/HL/HH]
PBG20.FSGD02PROT2.UINT32
PBG20.FSGD02PROT2.UINT16[L/H]
PBG20.FSGD02PROT2.UINT8[LL/HL/HH]
PBG20.FSGD02PROT3.UINT32
PBG20.FSGD02PROT3.UINT16[L/H]
PBG20.FSGD02PROT3.UINT8[LL/HL/HH]
PBG20.FSGD02PROT4.UINT32
PBG20.FSGD02PROT4.UINT16[L/H]
PBG20.FSGD02PROT4.UINT8[LL/HL/HH]
PBG20.FSGD02PROT5.UINT32
PBG20.FSGD02PROT5.UINT16[L/H]
PBG20.FSGD02PROT5.UINT8[LL/HL/HH]
PBG20.FSGD02PROT6.UINT32
PBG20.FSGD02PROT6.UINT16[L/H]
PBG20.FSGD02PROT6.UINT8[LL/HL/HH]
PBG20.FSGD02PROT8.UINT32
PBG20.FSGD02PROT8.UINT16[L/H]
PBG20.FSGD02PROT8.UINT8[LL/HL/HH]
PBG20.FSGD02PROT9.UINT32
PBG20.FSGD02PROT9.UINT16[L/H]
PBG20.FSGD02PROT9.UINT8[LL/HL/HH]
PBG20.FSGD02PROT10.UINT32
PBG20.FSGD02PROT10.UINT16[L/H]
PBG20.FSGD02PROT10.UINT8[LL/HL/HH]
PBG20.FSGD02PROT11.UINT32
PBG20.FSGD02PROT11.UINT16[L/H]
PBG20.FSGD02PROT11.UINT8[LL/HL/HH]
PBG20.FSGD02PROT14.UINT32
PBG20.FSGD02PROT14.UINT16[L/H]
PBG20.FSGD02PROT14.UINT8[LL/HL/HH]
PBG20.FSGD02PROT15.UINT32
PBG20.FSGD02PROT15.UINT16[L/H]
PBG20.FSGD02PROT15.UINT8[LL/HL/HH]
PBG20.ERRSLV02CTL.UINT32
PBG20.ERRSLV02CTL.UINT16[L]
PBG20.ERRSLV02CTL.UINT8[LL]
PBG20.ERRSLV02STAT.UINT32
PBG20.ERRSLV02STAT.UINT16[L]
PBG20.ERRSLV02STAT.UINT8[LL]
PBG20.ERRSLV02ADDR
PBG20.ERRSLV02TYPE.UINT32
PBG20.ERRSLV02TYPE.UINT16[L]
PBG21.FSGD09PROT0.UINT32
PBG21.FSGD09PROT0.UINT16[L/H]
PBG21.FSGD09PROT0.UINT8[LL/HL/HH]
PBG21.FSGD09PROT1.UINT32
PBG21.FSGD09PROT1.UINT16[L/H]
PBG21.FSGD09PROT1.UINT8[LL/HL/HH]
PBG21.FSGD09PROT8.UINT32
PBG21.FSGD09PROT8.UINT16[L/H]
PBG21.FSGD09PROT8.UINT8[LL/HL/HH]
PBG21.FSGD09PROT9.UINT32
PBG21.FSGD09PROT9.UINT16[L/H]
PBG21.FSGD09PROT9.UINT8[LL/HL/HH]
PBG21.ERRSLV09CTL.UINT32
PBG21.ERRSLV09CTL.UINT16[L]
PBG21.ERRSLV09CTL.UINT8[LL]
PBG21.ERRSLV09STAT.UINT32
PBG21.ERRSLV09STAT.UINT16[L]
PBG21.ERRSLV09STAT.UINT8[LL]
PBG21.ERRSLV09ADDR
PBG21.ERRSLV09TYPE.UINT32
PBG21.ERRSLV09TYPE.UINT16[L]
TAUD0.CDR0 ... TAUD0.CDR15
TAUD0.TOL
TAUD0.RDT
TAUD0.RSF
TAUD0.TRO
TAUD0.TME
TAUD0.TDL
TAUD0.TO
TAUD0.TOE
TAUD0.CNT0 ... TAUD0.CNT15
TAUD0.CMUR0 ... TAUD0.CMUR15
TAUD0.CSR0 ... TAUD0.CSR15
TAUD0.CSC0 ... TAUD0.CSC15
TAUD0.TE
TAUD0.TS
TAUD0.TT
TAUD0.CMOR0 ... TAUD0.CMOR15
TAUD0.TPS
TAUD0.BRS
TAUD0.TOM
TAUD0.TOC
TAUD0.TDE
TAUD0.TDM
TAUD0.TRE
TAUD0.TRC
TAUD0.RDE
TAUD0.RDM
TAUD0.RDS
TAUD0.RDC
TAUD0.EMU
SL_TAUD0.SELB_TAUD0I
TAUJ0.CDR0 ... TAUJ0.CDR3
TAUJ0.CNT0 ... TAUJ0.CNT3
TAUJ0.CMUR0 ... TAUJ0.CMUR3
TAUJ0.CSR0 ... TAUJ0.CSR3
TAUJ0.CSC0 ... TAUJ0.CSC3
TAUJ0.TE
TAUJ0.TS
TAUJ0.TT
TAUJ0.TO
TAUJ0.TOE
TAUJ0.TOL
TAUJ0.RDT
TAUJ0.RSF
TAUJ0.CMOR0 ... TAUJ0.CMOR3
TAUJ0.TPS
TAUJ0.BRS
TAUJ0.TOM
TAUJ0.TOC
TAUJ0.RDE
TAUJ0.RDM
TAUJ0.EMU
TAUJ2.CDR0 ... TAUJ2.CDR3
TAUJ2.CNT0 ... TAUJ2.CNT3
TAUJ2.CMUR0 ... TAUJ2.CMUR3
TAUJ2.CSR0 ... TAUJ2.CSR3
TAUJ2.CSC0 ... TAUJ2.CSC3
TAUJ2.TE
TAUJ2.TS
TAUJ2.TT
TAUJ2.TO
TAUJ2.TOE
TAUJ2.TOL
TAUJ2.RDT
TAUJ2.RSF
TAUJ2.CMOR0 ... TAUJ2.CMOR3
TAUJ2.TPS
TAUJ2.BRS
TAUJ2.TOM
TAUJ2.TOC
TAUJ2.RDE
TAUJ2.RDM
TAUJ2.EMU
TAUJ1.CDR0 ... TAUJ1.CDR3
TAUJ1.CNT0 ... TAUJ1.CNT3
TAUJ1.CMUR0 ... TAUJ1.CMUR3
TAUJ1.CSR0 ... TAUJ1.CSR3
TAUJ1.CSC0 ... TAUJ1.CSC3
TAUJ1.TE
TAUJ1.TS
TAUJ1.TT
TAUJ1.TO
TAUJ1.TOE
TAUJ1.TOL
TAUJ1.RDT
TAUJ1.RSF
TAUJ1.CMOR0 ... TAUJ1.CMOR3
TAUJ1.TPS
TAUJ1.BRS
TAUJ1.TOM
TAUJ1.TOC
TAUJ1.RDE
TAUJ1.RDM
TAUJ1.EMU
TAUJ3.CDR0 ... TAUJ3.CDR3
TAUJ3.CNT0 ... TAUJ3.CNT3
TAUJ3.CMUR0 ... TAUJ3.CMUR3
TAUJ3.CSR0 ... TAUJ3.CSR3
TAUJ3.CSC0 ... TAUJ3.CSC3
TAUJ3.TE
TAUJ3.TS
TAUJ3.TT
TAUJ3.TO
TAUJ3.TOE
TAUJ3.TOL
TAUJ3.RDT
TAUJ3.RSF
TAUJ3.CMOR0 ... TAUJ3.CMOR3
TAUJ3.TPS
TAUJ3.BRS
TAUJ3.TOM
TAUJ3.TOC
TAUJ3.RDE
TAUJ3.RDM
TAUJ3.EMU
SL_TAUJ0.SELB_TAUJ0I
SL_TAUJ2.SELB_TAUJ2I
PWSA0.CTL
PWSA0.STR
PWSA0.STC
PWSA0.EMU
PWSA0.QUE0 ... PWSA0.QUE7
PWSA0.PVCR00_01.UINT32
PWSA0.PVCR00_01.UINT16[L/H]
PWSA0.PVCR02_03.UINT32
PWSA0.PVCR02_03.UINT16[L/H]
PWSA0.PVCR04_05.UINT32
PWSA0.PVCR04_05.UINT16[L/H]
PWSA0.PVCR06_07.UINT32
PWSA0.PVCR06_07.UINT16[L/H]
PWSA0.PVCR08_09.UINT32
PWSA0.PVCR08_09.UINT16[L/H]
PWSA0.PVCR10_11.UINT32
PWSA0.PVCR10_11.UINT16[L/H]
PWSA0.PVCR12_13.UINT32
PWSA0.PVCR12_13.UINT16[L/H]
PWSA0.PVCR14_15.UINT32
PWSA0.PVCR14_15.UINT16[L/H]
PWSA0.PVCR16_17.UINT32
PWSA0.PVCR16_17.UINT16[L/H]
PWSA0.PVCR18_19.UINT32
PWSA0.PVCR18_19.UINT16[L/H]
PWSA0.PVCR20_21.UINT32
PWSA0.PVCR20_21.UINT16[L/H]
PWSA0.PVCR22_23.UINT32
PWSA0.PVCR22_23.UINT16[L/H]
PWSA0.PWDDIR00 ... PWSA0.PWDDIR23
PWGA0.CSDR
PWGA0.CRDR
PWGA0.CTDR
PWGA0.RDT
PWGA0.RSF
PWGA0.CNT
PWGA0.TCR
PWGA0.TCBR
PWGA0.CTL
PWGA0.CSBR
PWGA0.CRBR
PWGA0.CTBR
PWGA1.CSDR
PWGA1.CRDR
PWGA1.CTDR
PWGA1.RDT
PWGA1.RSF
PWGA1.CNT
PWGA1.TCR
PWGA1.TCBR
PWGA1.CTL
PWGA1.CSBR
PWGA1.CRBR
PWGA1.CTBR
PWGA2.CSDR
PWGA2.CRDR
PWGA2.CTDR
PWGA2.RDT
PWGA2.RSF
PWGA2.CNT
PWGA2.TCR
PWGA2.TCBR
PWGA2.CTL
PWGA2.CSBR
PWGA2.CRBR
PWGA2.CTBR
PWGA3.CSDR
PWGA3.CRDR
PWGA3.CTDR
PWGA3.RDT
PWGA3.RSF
PWGA3.CNT
PWGA3.TCR
PWGA3.TCBR
PWGA3.CTL
PWGA3.CSBR
PWGA3.CRBR
PWGA3.CTBR
PWGA4.CSDR
PWGA4.CRDR
PWGA4.CTDR
PWGA4.RDT
PWGA4.RSF
PWGA4.CNT
PWGA4.TCR
PWGA4.TCBR
PWGA4.CTL
PWGA4.CSBR
PWGA4.CRBR
PWGA4.CTBR
PWGA5.CSDR
PWGA5.CRDR
PWGA5.CTDR
PWGA5.RDT
PWGA5.RSF
PWGA5.CNT
PWGA5.TCR
PWGA5.TCBR
PWGA5.CTL
PWGA5.CSBR
PWGA5.CRBR
PWGA5.CTBR
PWGA6.CSDR
PWGA6.CRDR
PWGA6.CTDR
PWGA6.RDT
PWGA6.RSF
PWGA6.CNT
PWGA6.TCR
PWGA6.TCBR
PWGA6.CTL
PWGA6.CSBR
PWGA6.CRBR
PWGA6.CTBR
PWGA7.CSDR
PWGA7.CRDR
PWGA7.CTDR
PWGA7.RDT
PWGA7.RSF
PWGA7.CNT
PWGA7.TCR
PWGA7.TCBR
PWGA7.CTL
PWGA7.CSBR
PWGA7.CRBR
PWGA7.CTBR
PWGA8.CSDR
PWGA8.CRDR
PWGA8.CTDR
PWGA8.RDT
PWGA8.RSF
PWGA8.CNT
PWGA8.TCR
PWGA8.TCBR
PWGA8.CTL
PWGA8.CSBR
PWGA8.CRBR
PWGA8.CTBR
PWGA9.CSDR
PWGA9.CRDR
PWGA9.CTDR
PWGA9.RDT
PWGA9.RSF
PWGA9.CNT
PWGA9.TCR
PWGA9.TCBR
PWGA9.CTL
PWGA9.CSBR
PWGA9.CRBR
PWGA9.CTBR
PWGA10.CSDR
PWGA10.CRDR
PWGA10.CTDR
PWGA10.RDT
PWGA10.RSF
PWGA10.CNT
PWGA10.TCR
PWGA10.TCBR
PWGA10.CTL
PWGA10.CSBR
PWGA10.CRBR
PWGA10.CTBR
PWGA11.CSDR
PWGA11.CRDR
PWGA11.CTDR
PWGA11.RDT
PWGA11.RSF
PWGA11.CNT
PWGA11.TCR
PWGA11.TCBR
PWGA11.CTL
PWGA11.CSBR
PWGA11.CRBR
PWGA11.CTBR
PWGA12.CSDR
PWGA12.CRDR
PWGA12.CTDR
PWGA12.RDT
PWGA12.RSF
PWGA12.CNT
PWGA12.TCR
PWGA12.TCBR
PWGA12.CTL
PWGA12.CSBR
PWGA12.CRBR
PWGA12.CTBR
PWGA13.CSDR
PWGA13.CRDR
PWGA13.CTDR
PWGA13.RDT
PWGA13.RSF
PWGA13.CNT
PWGA13.TCR
PWGA13.TCBR
PWGA13.CTL
PWGA13.CSBR
PWGA13.CRBR
PWGA13.CTBR
PWGA14.CSDR
PWGA14.CRDR
PWGA14.CTDR
PWGA14.RDT
PWGA14.RSF
PWGA14.CNT
PWGA14.TCR
PWGA14.TCBR
PWGA14.CTL
PWGA14.CSBR
PWGA14.CRBR
PWGA14.CTBR
PWGA15.CSDR
PWGA15.CRDR
PWGA15.CTDR
PWGA15.RDT
PWGA15.RSF
PWGA15.CNT
PWGA15.TCR
PWGA15.TCBR
PWGA15.CTL
PWGA15.CSBR
PWGA15.CRBR
PWGA15.CTBR
PWGA16.CSDR
PWGA16.CRDR
PWGA16.CTDR
PWGA16.RDT
PWGA16.RSF
PWGA16.CNT
PWGA16.TCR
PWGA16.TCBR
PWGA16.CTL
PWGA16.CSBR
PWGA16.CRBR
PWGA16.CTBR
PWGA17.CSDR
PWGA17.CRDR
PWGA17.CTDR
PWGA17.RDT
PWGA17.RSF
PWGA17.CNT
PWGA17.TCR
PWGA17.TCBR
PWGA17.CTL
PWGA17.CSBR
PWGA17.CRBR
PWGA17.CTBR
PWGA18.CSDR
PWGA18.CRDR
PWGA18.CTDR
PWGA18.RDT
PWGA18.RSF
PWGA18.CNT
PWGA18.TCR
PWGA18.TCBR
PWGA18.CTL
PWGA18.CSBR
PWGA18.CRBR
PWGA18.CTBR
PWGA19.CSDR
PWGA19.CRDR
PWGA19.CTDR
PWGA19.RDT
PWGA19.RSF
PWGA19.CNT
PWGA19.TCR
PWGA19.TCBR
PWGA19.CTL
PWGA19.CSBR
PWGA19.CRBR
PWGA19.CTBR
PWGA20.CSDR
PWGA20.CRDR
PWGA20.CTDR
PWGA20.RDT
PWGA20.RSF
PWGA20.CNT
PWGA20.TCR
PWGA20.TCBR
PWGA20.CTL
PWGA20.CSBR
PWGA20.CRBR
PWGA20.CTBR
PWGA21.CSDR
PWGA21.CRDR
PWGA21.CTDR
PWGA21.RDT
PWGA21.RSF
PWGA21.CNT
PWGA21.TCR
PWGA21.TCBR
PWGA21.CTL
PWGA21.CSBR
PWGA21.CRBR
PWGA21.CTBR
PWGA22.CSDR
PWGA22.CRDR
PWGA22.CTDR
PWGA22.RDT
PWGA22.RSF
PWGA22.CNT
PWGA22.TCR
PWGA22.TCBR
PWGA22.CTL
PWGA22.CSBR
PWGA22.CRBR
PWGA22.CTBR
PWGA23.CSDR
PWGA23.CRDR
PWGA23.CTDR
PWGA23.RDT
PWGA23.RSF
PWGA23.CNT
PWGA23.TCR
PWGA23.TCBR
PWGA23.CTL
PWGA23.CSBR
PWGA23.CRBR
PWGA23.CTBR
PWBA0.BRS0 ... PWBA0.BRS3
PWBA0.TE
PWBA0.TS
PWBA0.TT
PWBA0.EMU
SLPWG.A0
SLPWG.PWGAPRD
SLPWG.PWGAPRDSL0
PWGA_INTF.PWGAINTF00
PWGA_INTF.PWGAINTMSK00
PWGA_INTF.PWGAINTFC00
RTCA0.CTL0.UINT8
RTCA0.CTL0.BIT.SLSB
RTCA0.CTL0.BIT.AMPM
RTCA0.CTL0.BIT.CEST
RTCA0.CTL0.BIT.CE
RTCA0.CTL1.UINT8
RTCA0.CTL1.BIT.CT0 ... RTCA0.CTL1.BIT.CT2
RTCA0.CTL1.BIT.EN1S
RTCA0.CTL1.BIT.ENALM
RTCA0.CTL1.BIT.EN1HZ
RTCA0.CTL2.UINT8
RTCA0.CTL2.BIT.WAIT
RTCA0.CTL2.BIT.WST
RTCA0.CTL2.BIT.RSUB
RTCA0.CTL2.BIT.RSST
RTCA0.CTL2.BIT.WSST
RTCA0.CTL2.BIT.WUST
RTCA0.SUBC
RTCA0.SRBU
RTCA0.SEC
RTCA0.MIN
RTCA0.HOUR
RTCA0.WEEK
RTCA0.DAY
RTCA0.MONTH
RTCA0.YEAR
RTCA0.TIME
RTCA0.CAL
RTCA0.SUBU
RTCA0.SCMP
RTCA0.ALM
RTCA0.ALH
RTCA0.ALW
RTCA0.SECC
RTCA0.MINC
RTCA0.HOURC
RTCA0.WEEKC
RTCA0.DAYC
RTCA0.MONC
RTCA0.YEARC
RTCA0.TIMEC
RTCA0.CALC
RTCA0.EMU.UINT8
RTCA0.EMU.BIT.SVSDIS
ENCA0.CCR0
ENCA0.CCR1
ENCA0.CNT
ENCA0.FLG
ENCA0.FGC
ENCA0.TE
ENCA0.TS
ENCA0.TT
ENCA0.IOC0
ENCA0.CTL
ENCA0.IOC1
ENCA0.EMU
TAPA0.FLG
TAPA0.ACWE
TAPA0.ACTS
TAPA0.ACTT
TAPA0.OPHS
TAPA0.OPHT
TAPA0.CTL0
TAPA0.CTL1
TAPA0.EMU
WDTA0.WDTE
WDTA0.EVAC
WDTA0.REF
WDTA0.MD
WDTA1.WDTE
WDTA1.EVAC
WDTA1.REF
WDTA1.MD
ADCA0.VCR00.UINT32
ADCA0.VCR00.UINT16[L]
ADCA0.VCR00.UINT8[LL/LH]
ADCA0.VCR01.UINT32
ADCA0.VCR01.UINT16[L]
ADCA0.VCR01.UINT8[LL/LH]
ADCA0.VCR02.UINT32
ADCA0.VCR02.UINT16[L]
ADCA0.VCR02.UINT8[LL/LH]
ADCA0.VCR03.UINT32
ADCA0.VCR03.UINT16[L]
ADCA0.VCR03.UINT8[LL/LH]
ADCA0.VCR04.UINT32
ADCA0.VCR04.UINT16[L]
ADCA0.VCR04.UINT8[LL/LH]
ADCA0.VCR05.UINT32
ADCA0.VCR05.UINT16[L]
ADCA0.VCR05.UINT8[LL/LH]
ADCA0.VCR06.UINT32
ADCA0.VCR06.UINT16[L]
ADCA0.VCR06.UINT8[LL/LH]
ADCA0.VCR07.UINT32
ADCA0.VCR07.UINT16[L]
ADCA0.VCR07.UINT8[LL/LH]
ADCA0.VCR08.UINT32
ADCA0.VCR08.UINT16[L]
ADCA0.VCR08.UINT8[LL/LH]
ADCA0.VCR09.UINT32
ADCA0.VCR09.UINT16[L]
ADCA0.VCR09.UINT8[LL/LH]
ADCA0.VCR10.UINT32
ADCA0.VCR10.UINT16[L]
ADCA0.VCR10.UINT8[LL/LH]
ADCA0.VCR11.UINT32
ADCA0.VCR11.UINT16[L]
ADCA0.VCR11.UINT8[LL/LH]
ADCA0.VCR12.UINT32
ADCA0.VCR12.UINT16[L]
ADCA0.VCR12.UINT8[LL/LH]
ADCA0.VCR13.UINT32
ADCA0.VCR13.UINT16[L]
ADCA0.VCR13.UINT8[LL/LH]
ADCA0.VCR14.UINT32
ADCA0.VCR14.UINT16[L]
ADCA0.VCR14.UINT8[LL/LH]
ADCA0.VCR15.UINT32
ADCA0.VCR15.UINT16[L]
ADCA0.VCR15.UINT8[LL/LH]
ADCA0.VCR16.UINT32
ADCA0.VCR16.UINT16[L]
ADCA0.VCR16.UINT8[LL/LH]
ADCA0.VCR17.UINT32
ADCA0.VCR17.UINT16[L]
ADCA0.VCR17.UINT8[LL/LH]
ADCA0.VCR18.UINT32
ADCA0.VCR18.UINT16[L]
ADCA0.VCR18.UINT8[LL/LH]
ADCA0.VCR19.UINT32
ADCA0.VCR19.UINT16[L]
ADCA0.VCR19.UINT8[LL/LH]
ADCA0.VCR20.UINT32
ADCA0.VCR20.UINT16[L]
ADCA0.VCR20.UINT8[LL/LH]
ADCA0.VCR21.UINT32
ADCA0.VCR21.UINT16[L]
ADCA0.VCR21.UINT8[LL/LH]
ADCA0.VCR22.UINT32
ADCA0.VCR22.UINT16[L]
ADCA0.VCR22.UINT8[LL/LH]
ADCA0.VCR23.UINT32
ADCA0.VCR23.UINT16[L]
ADCA0.VCR23.UINT8[LL/LH]
ADCA0.VCR24.UINT32
ADCA0.VCR24.UINT16[L]
ADCA0.VCR24.UINT8[LL/LH]
ADCA0.VCR25.UINT32
ADCA0.VCR25.UINT16[L]
ADCA0.VCR25.UINT8[LL/LH]
ADCA0.VCR26.UINT32
ADCA0.VCR26.UINT16[L]
ADCA0.VCR26.UINT8[LL/LH]
ADCA0.VCR27.UINT32
ADCA0.VCR27.UINT16[L]
ADCA0.VCR27.UINT8[LL/LH]
ADCA0.VCR28.UINT32
ADCA0.VCR28.UINT16[L]
ADCA0.VCR28.UINT8[LL/LH]
ADCA0.VCR33.UINT32
ADCA0.VCR33.UINT16[L]
ADCA0.VCR33.UINT8[LL/LH]
ADCA0.VCR34.UINT32
ADCA0.VCR34.UINT16[L]
ADCA0.VCR34.UINT8[LL/LH]
ADCA0.VCR35.UINT32
ADCA0.VCR35.UINT16[L]
ADCA0.VCR35.UINT8[LL/LH]
ADCA0.PWDVCR.UINT32
ADCA0.PWDVCR.UINT16[L]
ADCA0.PWDVCR.UINT8[LL/LH]
ADCA0.DR00.UINT32
ADCA0.DR00.UINT16[L/H]
ADCA0.DR02.UINT32
ADCA0.DR02.UINT16[L/H]
ADCA0.DR04.UINT32
ADCA0.DR04.UINT16[L/H]
ADCA0.DR06.UINT32
ADCA0.DR06.UINT16[L/H]
ADCA0.DR08.UINT32
ADCA0.DR08.UINT16[L/H]
ADCA0.DR10.UINT32
ADCA0.DR10.UINT16[L/H]
ADCA0.DR12.UINT32
ADCA0.DR12.UINT16[L/H]
ADCA0.DR14.UINT32
ADCA0.DR14.UINT16[L/H]
ADCA0.DR16.UINT32
ADCA0.DR16.UINT16[L/H]
ADCA0.DR18.UINT32
ADCA0.DR18.UINT16[L/H]
ADCA0.DR20.UINT32
ADCA0.DR20.UINT16[L/H]
ADCA0.DR22.UINT32
ADCA0.DR22.UINT16[L/H]
ADCA0.DR24.UINT32
ADCA0.DR24.UINT16[L/H]
ADCA0.DR26.UINT32
ADCA0.DR26.UINT16[L/H]
ADCA0.DR28.UINT32
ADCA0.DR28.UINT16[L]
ADCA0.DR32.UINT32
ADCA0.DR32.UINT16[H]
ADCA0.DR34.UINT32
ADCA0.DR34.UINT16[L/H]
ADCA0.PWDTSNDR.UINT32
ADCA0.PWDTSNDR.UINT16[H]
ADCA0.DIR00 ... ADCA0.DIR28
ADCA0.DIR33 ... ADCA0.DIR35
ADCA0.PWDDIR
ADCA0.ADHALTR.UINT32
ADCA0.ADHALTR.UINT16[L]
ADCA0.ADHALTR.UINT8[LL]
ADCA0.ADCR.UINT32
ADCA0.ADCR.UINT16[L]
ADCA0.ADCR.UINT8[LL]
ADCA0.SGSTR.UINT32
ADCA0.SGSTR.UINT16[L]
ADCA0.MPXCURR.UINT32
ADCA0.MPXCURR.UINT16[L]
ADCA0.MPXCURR.UINT8[LL]
ADCA0.THSMPSTCR.UINT32
ADCA0.THSMPSTCR.UINT16[L]
ADCA0.THSMPSTCR.UINT8[LL]
ADCA0.THCR.UINT32
ADCA0.THCR.UINT16[L]
ADCA0.THCR.UINT8[LL]
ADCA0.THAHLDSTCR.UINT32
ADCA0.THAHLDSTCR.UINT16[L]
ADCA0.THAHLDSTCR.UINT8[LL]
ADCA0.THBHLDSTCR.UINT32
ADCA0.THBHLDSTCR.UINT16[L]
ADCA0.THBHLDSTCR.UINT8[LL]
ADCA0.THACR.UINT32
ADCA0.THACR.UINT16[L]
ADCA0.THACR.UINT8[LL]
ADCA0.THBCR.UINT32
ADCA0.THBCR.UINT16[L]
ADCA0.THBCR.UINT8[LL]
ADCA0.THER.UINT32
ADCA0.THER.UINT16[L]
ADCA0.THER.UINT8[LL]
ADCA0.THGSR.UINT32
ADCA0.THGSR.UINT16[L]
ADCA0.THGSR.UINT8[LL]
ADCA0.SFTCR.UINT32
ADCA0.SFTCR.UINT16[L]
ADCA0.SFTCR.UINT8[LL]
ADCA0.ULLMTBR0.UINT32
ADCA0.ULLMTBR0.UINT16[L/H]
ADCA0.ULLMTBR1.UINT32
ADCA0.ULLMTBR1.UINT16[L/H]
ADCA0.ULLMTBR2.UINT32
ADCA0.ULLMTBR2.UINT16[L/H]
ADCA0.ECR.UINT32
ADCA0.ECR.UINT16[L]
ADCA0.ECR.UINT8[LL]
ADCA0.ULER.UINT32
ADCA0.ULER.UINT16[L]
ADCA0.ULER.UINT8[LL/LH]
ADCA0.OWER.UINT32
ADCA0.OWER.UINT16[L]
ADCA0.OWER.UINT8[LL]
ADCA0.DGCTL0.UINT32
ADCA0.DGCTL0.UINT16[L]
ADCA0.DGCTL0.UINT8[LL]
ADCA0.DGCTL1.UINT32
ADCA0.DGCTL1.UINT16[L]
ADCA0.PDCTL1.UINT32
ADCA0.PDCTL1.UINT16[L]
ADCA0.PDCTL2.UINT32
ADCA0.PDCTL2.UINT16[L]
ADCA0.PDCTL2.UINT8[LL/LH]
ADCA0.SMPCR.UINT32
ADCA0.SMPCR.UINT16[L]
ADCA0.SMPCR.UINT8[LL]
ADCA0.EMU
ADCA0.SGSTCR1.UINT32
ADCA0.SGSTCR1.UINT16[L]
ADCA0.SGSTCR1.UINT8[LL]
ADCA0.SGSTPCR1.UINT32
ADCA0.SGSTPCR1.UINT16[L]
ADCA0.SGSTPCR1.UINT8[LL]
ADCA0.SGCR1.UINT32
ADCA0.SGCR1.UINT16[L]
ADCA0.SGCR1.UINT8[LL]
ADCA0.SGVCSP1.UINT32
ADCA0.SGVCSP1.UINT16[L]
ADCA0.SGVCSP1.UINT8[LL]
ADCA0.SGVCEP1.UINT32
ADCA0.SGVCEP1.UINT16[L]
ADCA0.SGVCEP1.UINT8[LL]
ADCA0.SGMCYCR1.UINT32
ADCA0.SGMCYCR1.UINT16[L]
ADCA0.SGMCYCR1.UINT8[LL]
ADCA0.SGSEFCR1.UINT32
ADCA0.SGSEFCR1.UINT16[L]
ADCA0.SGSEFCR1.UINT8[LL]
ADCA0.SGTSEL1.UINT32
ADCA0.SGTSEL1.UINT16[L]
ADCA0.SGSTCR2.UINT32
ADCA0.SGSTCR2.UINT16[L]
ADCA0.SGSTCR2.UINT8[LL]
ADCA0.SGSTPCR2.UINT32
ADCA0.SGSTPCR2.UINT16[L]
ADCA0.SGSTPCR2.UINT8[LL]
ADCA0.SGCR2.UINT32
ADCA0.SGCR2.UINT16[L]
ADCA0.SGCR2.UINT8[LL]
ADCA0.SGVCSP2.UINT32
ADCA0.SGVCSP2.UINT16[L]
ADCA0.SGVCSP2.UINT8[LL]
ADCA0.SGVCEP2.UINT32
ADCA0.SGVCEP2.UINT16[L]
ADCA0.SGVCEP2.UINT8[LL]
ADCA0.SGMCYCR2.UINT32
ADCA0.SGMCYCR2.UINT16[L]
ADCA0.SGMCYCR2.UINT8[LL]
ADCA0.SGSEFCR2.UINT32
ADCA0.SGSEFCR2.UINT16[L]
ADCA0.SGSEFCR2.UINT8[LL]
ADCA0.SGTSEL2.UINT32
ADCA0.SGTSEL2.UINT16[L]
ADCA0.SGSTCR3.UINT32
ADCA0.SGSTCR3.UINT16[L]
ADCA0.SGSTCR3.UINT8[LL]
ADCA0.SGSTPCR3.UINT32
ADCA0.SGSTPCR3.UINT16[L]
ADCA0.SGSTPCR3.UINT8[LL]
ADCA0.SGCR3.UINT32
ADCA0.SGCR3.UINT16[L]
ADCA0.SGCR3.UINT8[LL]
ADCA0.SGVCSP3.UINT32
ADCA0.SGVCSP3.UINT16[L]
ADCA0.SGVCSP3.UINT8[LL]
ADCA0.SGVCEP3.UINT32
ADCA0.SGVCEP3.UINT16[L]
ADCA0.SGVCEP3.UINT8[LL]
ADCA0.SGMCYCR3.UINT32
ADCA0.SGMCYCR3.UINT16[L]
ADCA0.SGMCYCR3.UINT8[LL]
ADCA0.SGSEFCR3.UINT32
ADCA0.SGSEFCR3.UINT16[L]
ADCA0.SGSEFCR3.UINT8[LL]
ADCA0.SGTSEL3.UINT32
ADCA0.SGTSEL3.UINT16[L]
ADCA0.PWDSGSTPCR.UINT32
ADCA0.PWDSGSTPCR.UINT16[L]
ADCA0.PWDSGSTPCR.UINT8[LL]
ADCA0.PWDSGCR.UINT32
ADCA0.PWDSGCR.UINT16[L]
ADCA0.PWDSGCR.UINT8[LL]
ADCA0.PWDSGSEFCR.UINT32
ADCA0.PWDSGSEFCR.UINT16[L]
ADCA0.PWDSGSEFCR.UINT8[LL]
ADCA0.ULEVCFR0
ADCA0.ULEVCFR1
ADCA0.ULLMTBR3.UINT32
ADCA0.ULLMTBR3.UINT16[L/H]
ADCA0.ULLMTBR4.UINT32
ADCA0.ULLMTBR4.UINT16[L/H]
ADCA0.ULLMTBR5.UINT32
ADCA0.ULLMTBR5.UINT16[L/H]
ADCA0.ULLMTBR6.UINT32
ADCA0.ULLMTBR6.UINT16[L/H]
ADCA0.ULLMTBR7.UINT32
ADCA0.ULLMTBR7.UINT16[L/H]
ADCA0.MPXSTBTSELR0.UINT32
ADCA0.MPXSTBTSELR0.UINT16[L/H]
ADCA0.MPXSTBTSELR1.UINT32
ADCA0.MPXSTBTSELR1.UINT16[L]
ADCA0.MPXSTBTSELR2.UINT32
ADCA0.MPXSTBTSELR2.UINT16[L/H]
ADCA0.MPXSTBTSELR3.UINT32
ADCA0.MPXSTBTSELR3.UINT16[L]
ADCA0.MPXSTBTR0.UINT32
ADCA0.MPXSTBTR0.UINT16[L]
ADCA0.MPXSTBTR1.UINT32
ADCA0.MPXSTBTR1.UINT16[L]
ADCA0.MPXSTBTR2.UINT32
ADCA0.MPXSTBTR2.UINT16[L]
ADCA0.MPXSTBTR3.UINT32
ADCA0.MPXSTBTR3.UINT16[L]
ADCA0.MPXSTBTR4.UINT32
ADCA0.MPXSTBTR4.UINT16[L]
ADCA0.MPXSTBTR5.UINT32
ADCA0.MPXSTBTR5.UINT16[L]
ADCA0.MPXSTBTR6.UINT32
ADCA0.MPXSTBTR6.UINT16[L]
ADCA0.MPXSTBTR7.UINT32
ADCA0.MPXSTBTR7.UINT16[L]
DCRA0.CIN
DCRA0.COUT
DCRA0.CTL
KR0.KRM.UINT8
KR0.KRM.BIT.KRM0 ... KR0.KRM.BIT.KRM7
WPROTR.PROTCMD0
WPROTR.PROTS0
WPROTR.PROTCMD1
WPROTR.PROTS1
STBC0.PSC
STBC0.STPT
STBC_WUF0.WUF0
STBC_WUF0.WUFMSK0
STBC_WUF0.WUFC0
STBC_WUF1.WUF1
STBC_WUF1.WUFMSK1
STBC_WUF1.WUFC1
STBC_WUF20.WUF20
STBC_WUF20.WUFMSK20
STBC_WUF20.WUFC20
RESCTL.RESF
RESCTL.RESFC
RESCTL.RESFR
RESCTL.RESFCR
RESCTL.SWRESA
RESCTL.CYCRBASE
SVM.VLVF
SVM.VLVFC
SVM.LVICNT
SVM.CVMF
SVM.CVMDE
SVM.CVMDIAG
SVM.PROTCMDCVM
SVM.PROTSCVM
STBC_IOHOLD.IOHOLD
CLKCTL.ROSCE
CLKCTL.ROSCS
CLKCTL.ROSCSTPM
CLKCTL.ROSCUT
CLKCTL.MOSCE
CLKCTL.MOSCS
CLKCTL.MOSCC
CLKCTL.MOSCST
CLKCTL.MOSCSTPM
CLKCTL.MOSCM
CLKCTL.CKSC_AWDTAD_CTL
CLKCTL.CKSC_AWDTAD_ACT
CLKCTL.CKSC_AWDTAD_STPM
CLKCTL.CKSC_ATAUJS_CTL
CLKCTL.CKSC_ATAUJS_ACT
CLKCTL.CKSC_ATAUJD_CTL
CLKCTL.CKSC_ATAUJD_ACT
CLKCTL.CKSC_ATAUJD_STPM
CLKCTL.CKSC_ARTCAS_CTL
CLKCTL.CKSC_ARTCAS_ACT
CLKCTL.CKSC_ARTCAD_CTL
CLKCTL.CKSC_ARTCAD_ACT
CLKCTL.CKSC_ARTCAD_STPM
CLKCTL.CKSC_AADCAS_CTL
CLKCTL.CKSC_AADCAS_ACT
CLKCTL.CKSC_AADCAD_CTL
CLKCTL.CKSC_AADCAD_ACT
CLKCTL.CKSC_AADCAD_STPM
CLKCTL.CKSC_AFOUTS_CTL
CLKCTL.CKSC_AFOUTS_ACT
CLKCTL.CKSC_AFOUTS_STPM
CLKCTL.FOUTDIV
CLKCTL.FOUTSTAT
CLKCTL.PLL1E
CLKCTL.PLL1S
CLKCTL.PLL1C
CLKCTL.CKSC_CPUCLKS_CTL
CLKCTL.CKSC_CPUCLKS_ACT
CLKCTL.CKSC_PPLLCLKS_CTL
CLKCTL.CKSC_PPLLCLKS_ACT
CLKCTL.CKSC_CPUCLKD_CTL
CLKCTL.CKSC_CPUCLKD_ACT
CLKCTL.CKSC_IPERI1S_CTL
CLKCTL.CKSC_IPERI1S_ACT
CLKCTL.CKSC_IPERI2S_CTL
CLKCTL.CKSC_IPERI2S_ACT
CLKCTL.CKSC_ILINS_CTL
CLKCTL.CKSC_ILINS_ACT
CLKCTL.CKSC_PLL1IS_CTL
CLKCTL.CKSC_PLL1IS_ACT
CLKCTL.CKSC_ILIND_CTL
CLKCTL.CKSC_ILIND_ACT
CLKCTL.CKSC_ILIND_STPM
CLKCTL.CKSC_ICANS_CTL
CLKCTL.CKSC_ICANS_ACT
CLKCTL.CKSC_ICANS_STPM
CLKCTL.CKSC_ICANOSCD_CTL
CLKCTL.CKSC_ICANOSCD_ACT
CLKCTL.CKSC_ICANOSCD_STPM
CLKCTL.CKSC_ICSIS_CTL
CLKCTL.CKSC_ICSIS_ACT
CLKCTL.CKSC_IIICS_CTL
CLKCTL.CKSC_IIICS_ACT
LPS0.SCTLR
LPS0.EVFR
LPS0.DPSELR0
LPS0.DPSELRM.UINT32
LPS0.DPSELRM.UINT16[L/H]
LPS0.DPSELRM.UINT8[LL/LH/HL/HH]
LPS0.DPSELRH.UINT32
LPS0.DPSELRH.UINT16[L/H]
LPS0.DPSELRH.UINT8[LL/LH/HL]
LPS0.DPDSR0
LPS0.DPDSRM.UINT32
LPS0.DPDSRM.UINT16[L/H]
LPS0.DPDSRM.UINT8[LL/LH/HL/HH]
LPS0.DPDSRH.UINT32
LPS0.DPDSRH.UINT16[L/H]
LPS0.DPDSRH.UINT8[LL/LH/HL]
LPS0.DPDIMR0 ... LPS0.DPDIMR7
LPS0.CNTVAL
LPS0.SOSTR
STBC_WUFISO.WUF_ISO0
STBC_WUFISO.WUFMSK_ISO0
STBC_WUFISO.WUFC_ISO0
CLMA0.CTL0
CLMA0.CMPL
CLMA0.CMPH
CLMA0.PCMD
CLMA0.PS
CLMA0.EMU0
CLMA.TEST
CLMA.TESTS
CLMA.PROTCMDCLMA
CLMA.PROTSCLMA
CLMA1.CTL0
CLMA1.CMPL
CLMA1.CMPH
CLMA1.PCMD
CLMA1.PS
CLMA1.EMU0
CLMA3.CTL0
CLMA3.CMPL
CLMA3.CMPH
CLMA3.PCMD
CLMA3.PS
CLMA3.EMU0
PBG50.FSGD06PROT0.UINT32
PBG50.FSGD06PROT0.UINT16[L/H]
PBG50.FSGD06PROT0.UINT8[LL/HL/HH]
PBG50.FSGD06PROT1.UINT32
PBG50.FSGD06PROT1.UINT16[L/H]
PBG50.FSGD06PROT1.UINT8[LL/HL/HH]
PBG50.FSGD06PROT4.UINT32
PBG50.FSGD06PROT4.UINT16[L/H]
PBG50.FSGD06PROT4.UINT8[LL/HL/HH]
PBG50.FSGD06PROT5.UINT32
PBG50.FSGD06PROT5.UINT16[L/H]
PBG50.FSGD06PROT5.UINT8[LL/HL/HH]
PBG50.FSGD06PROT6.UINT32
PBG50.FSGD06PROT6.UINT16[L/H]
PBG50.FSGD06PROT6.UINT8[LL/HL/HH]
PBG50.FSGD06PROT7.UINT32
PBG50.FSGD06PROT7.UINT16[L/H]
PBG50.FSGD06PROT7.UINT8[LL/HL/HH]
PBG50.FSGD06PROT8.UINT32
PBG50.FSGD06PROT8.UINT16[L/H]
PBG50.FSGD06PROT8.UINT8[LL/HL/HH]
PBG50.ERRSLV06CTL.UINT32
PBG50.ERRSLV06CTL.UINT16[L]
PBG50.ERRSLV06CTL.UINT8[LL]
PBG50.ERRSLV06STAT.UINT32
PBG50.ERRSLV06STAT.UINT16[L]
PBG50.ERRSLV06STAT.UINT8[LL]
PBG50.ERRSLV06ADDR
PBG50.ERRSLV06TYPE.UINT32
PBG50.ERRSLV06TYPE.UINT16[L]
PBG30.FSGD03PROT0.UINT32
PBG30.FSGD03PROT0.UINT16[L/H]
PBG30.FSGD03PROT0.UINT8[LL/HL/HH]
PBG30.FSGD03PROT1.UINT32
PBG30.FSGD03PROT1.UINT16[L/H]
PBG30.FSGD03PROT1.UINT8[LL/HL/HH]
PBG30.FSGD03PROT2.UINT32
PBG30.FSGD03PROT2.UINT16[L/H]
PBG30.FSGD03PROT2.UINT8[LL/HL/HH]
PBG30.FSGD03PROT8.UINT32
PBG30.FSGD03PROT8.UINT16[L/H]
PBG30.FSGD03PROT8.UINT8[LL/HL/HH]
PBG30.ERRSLV03CTL.UINT32
PBG30.ERRSLV03CTL.UINT16[L]
PBG30.ERRSLV03CTL.UINT8[LL]
PBG30.ERRSLV03STAT.UINT32
PBG30.ERRSLV03STAT.UINT16[L]
PBG30.ERRSLV03STAT.UINT8[LL]
PBG30.ERRSLV03ADDR
PBG30.ERRSLV03TYPE.UINT32
PBG30.ERRSLV03TYPE.UINT16[L]
PBG31.FSGD04PROT0.UINT32
PBG31.FSGD04PROT0.UINT16[L/H]
PBG31.FSGD04PROT0.UINT8[LL/HL/HH]
PBG31.FSGD04PROT4.UINT32
PBG31.FSGD04PROT4.UINT16[L/H]
PBG31.FSGD04PROT4.UINT8[LL/HL/HH]
PBG31.FSGD04PROT8.UINT32
PBG31.FSGD04PROT8.UINT16[L/H]
PBG31.FSGD04PROT8.UINT8[LL/HL/HH]
PBG31.FSGD04PROT9.UINT32
PBG31.FSGD04PROT9.UINT16[L/H]
PBG31.FSGD04PROT9.UINT8[LL/HL/HH]
PBG31.FSGD04PROT10.UINT32
PBG31.FSGD04PROT10.UINT16[L/H]
PBG31.FSGD04PROT10.UINT8[LL/HL/HH]
PBG31.ERRSLV04CTL.UINT32
PBG31.ERRSLV04CTL.UINT16[L]
PBG31.ERRSLV04CTL.UINT8[LL]
PBG31.ERRSLV04STAT.UINT32
PBG31.ERRSLV04STAT.UINT16[L]
PBG31.ERRSLV04STAT.UINT8[LL]
PBG31.ERRSLV04ADDR
PBG31.ERRSLV04TYPE.UINT32
PBG31.ERRSLV04TYPE.UINT16[L]
PBG32.FSGD05PROT0.UINT32
PBG32.FSGD05PROT0.UINT16[L/H]
PBG32.FSGD05PROT0.UINT8[LL/HL/HH]
PBG32.FSGD05PROT1.UINT32
PBG32.FSGD05PROT1.UINT16[L/H]
PBG32.FSGD05PROT1.UINT8[LL/HL/HH]
PBG32.FSGD05PROT8.UINT32
PBG32.FSGD05PROT8.UINT16[L/H]
PBG32.FSGD05PROT8.UINT8[LL/HL/HH]
PBG32.FSGD05PROT9.UINT32
PBG32.FSGD05PROT9.UINT16[L/H]
PBG32.FSGD05PROT9.UINT8[LL/HL/HH]
PBG32.ERRSLV05CTL.UINT32
PBG32.ERRSLV05CTL.UINT16[L]
PBG32.ERRSLV05CTL.UINT8[LL]
PBG32.ERRSLV05STAT.UINT32
PBG32.ERRSLV05STAT.UINT16[L]
PBG32.ERRSLV05STAT.UINT8[LL]
PBG32.ERRSLV05ADDR
PBG32.ERRSLV05TYPE.UINT32
PBG32.ERRSLV05TYPE.UINT16[L]
IPG.ECRUM.UINT16
IPG.ECRUM.UINT8[L]
IPG.ADRUM.UINT32
IPG.ADRUM.UINT16[L/H]
IPG.ADRUM.UINT8[LL/LH/HL/HH]
IPG.ENUM
IPG.PMTUM0
IPG.PMTUM2 ... IPG.PMTUM4
PEG.SP.UINT32
PEG.SP.UINT16[L]
PEG.SP.UINT8[LL]
PEG.G0MK.UINT32
PEG.G0MK.UINT16[L/H]
PEG.G0MK.UINT8[LH/HL/HH]
PEG.G0BA.UINT32
PEG.G0BA.UINT16[L/H]
PEG.G0BA.UINT8[LL/LH/HL/HH]
PEG.G1MK.UINT32
PEG.G1MK.UINT16[L/H]
PEG.G1MK.UINT8[LH/HL/HH]
PEG.G1BA.UINT32
PEG.G1BA.UINT16[L/H]
PEG.G1BA.UINT8[LL/LH/HL/HH]
PEG.G2MK.UINT32
PEG.G2MK.UINT16[L/H]
PEG.G2MK.UINT8[LH/HL/HH]
PEG.G2BA.UINT32
PEG.G2BA.UINT16[L/H]
PEG.G2BA.UINT8[LL/LH/HL/HH]
PEG.G3MK.UINT32
PEG.G3MK.UINT16[L/H]
PEG.G3MK.UINT8[LH/HL/HH]
PEG.G3BA.UINT32
PEG.G3BA.UINT16[L/H]
PEG.G3BA.UINT8[LL/LH/HL/HH]
SEG.CONT
SEG.FLAG
SEG.ADDR
INTC1.ICTAUD0I0.UINT16
INTC1.ICTAUD0I0.UINT8[L/H]
INTC1.ICTAUD0I0.BIT.P0TAUD0I0
INTC1.ICTAUD0I0.BIT.P1TAUD0I0
INTC1.ICTAUD0I0.BIT.P2TAUD0I0
INTC1.ICTAUD0I0.BIT.P3TAUD0I0
INTC1.ICTAUD0I0.BIT.TBTAUD0I0
INTC1.ICTAUD0I0.BIT.MKTAUD0I0
INTC1.ICTAUD0I0.BIT.RFTAUD0I0
INTC1.ICTAUD0I0.BIT.CTTAUD0I0
INTC1.ICTAUD0I2.UINT16
INTC1.ICTAUD0I2.UINT8[L/H]
INTC1.ICTAUD0I2.BIT.P0TAUD0I2
INTC1.ICTAUD0I2.BIT.P1TAUD0I2
INTC1.ICTAUD0I2.BIT.P2TAUD0I2
INTC1.ICTAUD0I2.BIT.P3TAUD0I2
INTC1.ICTAUD0I2.BIT.TBTAUD0I2
INTC1.ICTAUD0I2.BIT.MKTAUD0I2
INTC1.ICTAUD0I2.BIT.RFTAUD0I2
INTC1.ICTAUD0I2.BIT.CTTAUD0I2
INTC1.ICTAUD0I4.UINT16
INTC1.ICTAUD0I4.UINT8[L/H]
INTC1.ICTAUD0I4.BIT.P0TAUD0I4
INTC1.ICTAUD0I4.BIT.P1TAUD0I4
INTC1.ICTAUD0I4.BIT.P2TAUD0I4
INTC1.ICTAUD0I4.BIT.P3TAUD0I4
INTC1.ICTAUD0I4.BIT.TBTAUD0I4
INTC1.ICTAUD0I4.BIT.MKTAUD0I4
INTC1.ICTAUD0I4.BIT.RFTAUD0I4
INTC1.ICTAUD0I4.BIT.CTTAUD0I4
INTC1.ICTAUD0I6.UINT16
INTC1.ICTAUD0I6.UINT8[L/H]
INTC1.ICTAUD0I6.BIT.P0TAUD0I6
INTC1.ICTAUD0I6.BIT.P1TAUD0I6
INTC1.ICTAUD0I6.BIT.P2TAUD0I6
INTC1.ICTAUD0I6.BIT.P3TAUD0I6
INTC1.ICTAUD0I6.BIT.TBTAUD0I6
INTC1.ICTAUD0I6.BIT.MKTAUD0I6
INTC1.ICTAUD0I6.BIT.RFTAUD0I6
INTC1.ICTAUD0I6.BIT.CTTAUD0I6
INTC1.ICTAUD0I8.UINT16
INTC1.ICTAUD0I8.UINT8[L/H]
INTC1.ICTAUD0I8.BIT.P0TAUD0I8
INTC1.ICTAUD0I8.BIT.P1TAUD0I8
INTC1.ICTAUD0I8.BIT.P2TAUD0I8
INTC1.ICTAUD0I8.BIT.P3TAUD0I8
INTC1.ICTAUD0I8.BIT.TBTAUD0I8
INTC1.ICTAUD0I8.BIT.MKTAUD0I8
INTC1.ICTAUD0I8.BIT.RFTAUD0I8
INTC1.ICTAUD0I8.BIT.CTTAUD0I8
INTC1.ICTAUD0I10.UINT16
INTC1.ICTAUD0I10.UINT8[L/H]
INTC1.ICTAUD0I10.BIT.P0TAUD0I10
INTC1.ICTAUD0I10.BIT.P1TAUD0I10
INTC1.ICTAUD0I10.BIT.P2TAUD0I10
INTC1.ICTAUD0I10.BIT.P3TAUD0I10
INTC1.ICTAUD0I10.BIT.TBTAUD0I10
INTC1.ICTAUD0I10.BIT.MKTAUD0I10
INTC1.ICTAUD0I10.BIT.RFTAUD0I10
INTC1.ICTAUD0I10.BIT.CTTAUD0I10
INTC1.ICTAUD0I12.UINT16
INTC1.ICTAUD0I12.UINT8[L/H]
INTC1.ICTAUD0I12.BIT.P0TAUD0I12
INTC1.ICTAUD0I12.BIT.P1TAUD0I12
INTC1.ICTAUD0I12.BIT.P2TAUD0I12
INTC1.ICTAUD0I12.BIT.P3TAUD0I12
INTC1.ICTAUD0I12.BIT.TBTAUD0I12
INTC1.ICTAUD0I12.BIT.MKTAUD0I12
INTC1.ICTAUD0I12.BIT.RFTAUD0I12
INTC1.ICTAUD0I12.BIT.CTTAUD0I12
INTC1.ICTAUD0I14.UINT16
INTC1.ICTAUD0I14.UINT8[L/H]
INTC1.ICTAUD0I14.BIT.P0TAUD0I14
INTC1.ICTAUD0I14.BIT.P1TAUD0I14
INTC1.ICTAUD0I14.BIT.P2TAUD0I14
INTC1.ICTAUD0I14.BIT.P3TAUD0I14
INTC1.ICTAUD0I14.BIT.TBTAUD0I14
INTC1.ICTAUD0I14.BIT.MKTAUD0I14
INTC1.ICTAUD0I14.BIT.RFTAUD0I14
INTC1.ICTAUD0I14.BIT.CTTAUD0I14
INTC1.ICTAPA0IPEK0.UINT16
INTC1.ICTAPA0IPEK0.UINT8[L/H]
INTC1.ICTAPA0IPEK0.BIT.P0TAPA0IPEK0
INTC1.ICTAPA0IPEK0.BIT.P1TAPA0IPEK0
INTC1.ICTAPA0IPEK0.BIT.P2TAPA0IPEK0
INTC1.ICTAPA0IPEK0.BIT.P3TAPA0IPEK0
INTC1.ICTAPA0IPEK0.BIT.TBTAPA0IPEK0
INTC1.ICTAPA0IPEK0.BIT.MKTAPA0IPEK0
INTC1.ICTAPA0IPEK0.BIT.RFTAPA0IPEK0
INTC1.ICTAPA0IPEK0.BIT.CTTAPA0IPEK0
INTC1.ICTAPA0IVLY0.UINT16
INTC1.ICTAPA0IVLY0.UINT8[L/H]
INTC1.ICTAPA0IVLY0.BIT.P0TAPA0IVLY0
INTC1.ICTAPA0IVLY0.BIT.P1TAPA0IVLY0
INTC1.ICTAPA0IVLY0.BIT.P2TAPA0IVLY0
INTC1.ICTAPA0IVLY0.BIT.P3TAPA0IVLY0
INTC1.ICTAPA0IVLY0.BIT.TBTAPA0IVLY0
INTC1.ICTAPA0IVLY0.BIT.MKTAPA0IVLY0
INTC1.ICTAPA0IVLY0.BIT.RFTAPA0IVLY0
INTC1.ICTAPA0IVLY0.BIT.CTTAPA0IVLY0
INTC1.ICADCA0I0.UINT16
INTC1.ICADCA0I0.UINT8[L/H]
INTC1.ICADCA0I0.BIT.P0ADCA0I0
INTC1.ICADCA0I0.BIT.P1ADCA0I0
INTC1.ICADCA0I0.BIT.P2ADCA0I0
INTC1.ICADCA0I0.BIT.P3ADCA0I0
INTC1.ICADCA0I0.BIT.TBADCA0I0
INTC1.ICADCA0I0.BIT.MKADCA0I0
INTC1.ICADCA0I0.BIT.RFADCA0I0
INTC1.ICADCA0I0.BIT.CTADCA0I0
INTC1.ICADCA0I1.UINT16
INTC1.ICADCA0I1.UINT8[L/H]
INTC1.ICADCA0I1.BIT.P0ADCA0I1
INTC1.ICADCA0I1.BIT.P1ADCA0I1
INTC1.ICADCA0I1.BIT.P2ADCA0I1
INTC1.ICADCA0I1.BIT.P3ADCA0I1
INTC1.ICADCA0I1.BIT.TBADCA0I1
INTC1.ICADCA0I1.BIT.MKADCA0I1
INTC1.ICADCA0I1.BIT.RFADCA0I1
INTC1.ICADCA0I1.BIT.CTADCA0I1
INTC1.ICADCA0I2.UINT16
INTC1.ICADCA0I2.UINT16
INTC1.ICADCA0I2.UINT8[L/H]
INTC1.ICADCA0I2.BIT.P0ADCA0I2
INTC1.ICADCA0I2.BIT.P0CSIH0IJC_1
INTC1.ICADCA0I2.BIT.P1ADCA0I2
INTC1.ICADCA0I2.BIT.P1CSIH0IJC_1
INTC1.ICADCA0I2.BIT.P2ADCA0I2
INTC1.ICADCA0I2.BIT.P2CSIH0IJC_1
INTC1.ICADCA0I2.BIT.P3ADCA0I2
INTC1.ICADCA0I2.BIT.P3CSIH0IJC_1
INTC1.ICADCA0I2.BIT.TBADCA0I2
INTC1.ICADCA0I2.BIT.TBCSIH0IJC_1
INTC1.ICADCA0I2.BIT.MKADCA0I2
INTC1.ICADCA0I2.BIT.MKCSIH0IJC_1
INTC1.ICADCA0I2.BIT.RFADCA0I2
INTC1.ICADCA0I2.BIT.RFCSIH0IJC_1
INTC1.ICADCA0I2.BIT.CTADCA0I2
INTC1.ICADCA0I2.BIT.CTCSIH0IJC_1
INTC1.ICDCUTDI.UINT16
INTC1.ICDCUTDI.UINT8[L/H]
INTC1.ICDCUTDI.BIT.P0DCUTDI
INTC1.ICDCUTDI.BIT.P1DCUTDI
INTC1.ICDCUTDI.BIT.P2DCUTDI
INTC1.ICDCUTDI.BIT.P3DCUTDI
INTC1.ICDCUTDI.BIT.TBDCUTDI
INTC1.ICDCUTDI.BIT.MKDCUTDI
INTC1.ICDCUTDI.BIT.RFDCUTDI
INTC1.ICDCUTDI.BIT.CTDCUTDI
INTC1.ICRCANGERR0.UINT16
INTC1.ICRCANGERR0.UINT8[L/H]
INTC1.ICRCANGERR0.BIT.P0RCANGERR0
INTC1.ICRCANGERR0.BIT.P1RCANGERR0
INTC1.ICRCANGERR0.BIT.P2RCANGERR0
INTC1.ICRCANGERR0.BIT.P3RCANGERR0
INTC1.ICRCANGERR0.BIT.TBRCANGERR0
INTC1.ICRCANGERR0.BIT.MKRCANGERR0
INTC1.ICRCANGERR0.BIT.RFRCANGERR0
INTC1.ICRCANGERR0.BIT.CTRCANGERR0
INTC1.ICRCANGRECC0.UINT16
INTC1.ICRCANGRECC0.UINT8[L/H]
INTC1.ICRCANGRECC0.BIT.P0RCANGRECC0
INTC1.ICRCANGRECC0.BIT.P1RCANGRECC0
INTC1.ICRCANGRECC0.BIT.P2RCANGRECC0
INTC1.ICRCANGRECC0.BIT.P3RCANGRECC0
INTC1.ICRCANGRECC0.BIT.TBRCANGRECC0
INTC1.ICRCANGRECC0.BIT.MKRCANGRECC0
INTC1.ICRCANGRECC0.BIT.RFRCANGRECC0
INTC1.ICRCANGRECC0.BIT.CTRCANGRECC0
INTC1.ICRCAN0ERR.UINT16
INTC1.ICRCAN0ERR.UINT8[L/H]
INTC1.ICRCAN0ERR.BIT.P0RCAN0ERR
INTC1.ICRCAN0ERR.BIT.P1RCAN0ERR
INTC1.ICRCAN0ERR.BIT.P2RCAN0ERR
INTC1.ICRCAN0ERR.BIT.P3RCAN0ERR
INTC1.ICRCAN0ERR.BIT.TBRCAN0ERR
INTC1.ICRCAN0ERR.BIT.MKRCAN0ERR
INTC1.ICRCAN0ERR.BIT.RFRCAN0ERR
INTC1.ICRCAN0ERR.BIT.CTRCAN0ERR
INTC1.ICRCAN0REC.UINT16
INTC1.ICRCAN0REC.UINT8[L/H]
INTC1.ICRCAN0REC.BIT.P0RCAN0REC
INTC1.ICRCAN0REC.BIT.P1RCAN0REC
INTC1.ICRCAN0REC.BIT.P2RCAN0REC
INTC1.ICRCAN0REC.BIT.P3RCAN0REC
INTC1.ICRCAN0REC.BIT.TBRCAN0REC
INTC1.ICRCAN0REC.BIT.MKRCAN0REC
INTC1.ICRCAN0REC.BIT.RFRCAN0REC
INTC1.ICRCAN0REC.BIT.CTRCAN0REC
INTC1.ICRCAN0TRX.UINT16
INTC1.ICRCAN0TRX.UINT8[L/H]
INTC1.ICRCAN0TRX.BIT.P0RCAN0TRX
INTC1.ICRCAN0TRX.BIT.P1RCAN0TRX
INTC1.ICRCAN0TRX.BIT.P2RCAN0TRX
INTC1.ICRCAN0TRX.BIT.P3RCAN0TRX
INTC1.ICRCAN0TRX.BIT.TBRCAN0TRX
INTC1.ICRCAN0TRX.BIT.MKRCAN0TRX
INTC1.ICRCAN0TRX.BIT.RFRCAN0TRX
INTC1.ICRCAN0TRX.BIT.CTRCAN0TRX
INTC1.ICCSIG0IC.UINT16
INTC1.ICCSIG0IC.UINT8[L/H]
INTC1.ICCSIG0IC.BIT.P0CSIG0IC
INTC1.ICCSIG0IC.BIT.P1CSIG0IC
INTC1.ICCSIG0IC.BIT.P2CSIG0IC
INTC1.ICCSIG0IC.BIT.P3CSIG0IC
INTC1.ICCSIG0IC.BIT.TBCSIG0IC
INTC1.ICCSIG0IC.BIT.MKCSIG0IC
INTC1.ICCSIG0IC.BIT.RFCSIG0IC
INTC1.ICCSIG0IC.BIT.CTCSIG0IC
INTC1.ICCSIG0IR.UINT16
INTC1.ICCSIG0IR.UINT8[L/H]
INTC1.ICCSIG0IR.BIT.P0CSIG0IR
INTC1.ICCSIG0IR.BIT.P1CSIG0IR
INTC1.ICCSIG0IR.BIT.P2CSIG0IR
INTC1.ICCSIG0IR.BIT.P3CSIG0IR
INTC1.ICCSIG0IR.BIT.TBCSIG0IR
INTC1.ICCSIG0IR.BIT.MKCSIG0IR
INTC1.ICCSIG0IR.BIT.RFCSIG0IR
INTC1.ICCSIG0IR.BIT.CTCSIG0IR
INTC1.ICCSIH0IC.UINT16
INTC1.ICCSIH0IC.UINT8[L/H]
INTC1.ICCSIH0IC.BIT.P0CSIH0IC
INTC1.ICCSIH0IC.BIT.P1CSIH0IC
INTC1.ICCSIH0IC.BIT.P2CSIH0IC
INTC1.ICCSIH0IC.BIT.P3CSIH0IC
INTC1.ICCSIH0IC.BIT.TBCSIH0IC
INTC1.ICCSIH0IC.BIT.MKCSIH0IC
INTC1.ICCSIH0IC.BIT.RFCSIH0IC
INTC1.ICCSIH0IC.BIT.CTCSIH0IC
INTC1.ICCSIH0IR.UINT16
INTC1.ICCSIH0IR.UINT8[L/H]
INTC1.ICCSIH0IR.BIT.P0CSIH0IR
INTC1.ICCSIH0IR.BIT.P1CSIH0IR
INTC1.ICCSIH0IR.BIT.P2CSIH0IR
INTC1.ICCSIH0IR.BIT.P3CSIH0IR
INTC1.ICCSIH0IR.BIT.TBCSIH0IR
INTC1.ICCSIH0IR.BIT.MKCSIH0IR
INTC1.ICCSIH0IR.BIT.RFCSIH0IR
INTC1.ICCSIH0IR.BIT.CTCSIH0IR
INTC1.ICCSIH0IRE.UINT16
INTC1.ICCSIH0IRE.UINT8[L/H]
INTC1.ICCSIH0IRE.BIT.P0CSIH0IRE
INTC1.ICCSIH0IRE.BIT.P1CSIH0IRE
INTC1.ICCSIH0IRE.BIT.P2CSIH0IRE
INTC1.ICCSIH0IRE.BIT.P3CSIH0IRE
INTC1.ICCSIH0IRE.BIT.TBCSIH0IRE
INTC1.ICCSIH0IRE.BIT.MKCSIH0IRE
INTC1.ICCSIH0IRE.BIT.RFCSIH0IRE
INTC1.ICCSIH0IRE.BIT.CTCSIH0IRE
INTC1.FNC.UINT16
INTC1.FNC.UINT8[H]
INTC1.FNC.BIT.FNRF
INTC1.FIC.UINT16
INTC1.FIC.UINT8[H]
INTC1.FIC.BIT.FIRF
INTC1.IMR0.UINT32
INTC1.IMR0.UINT16[L/H]
INTC1.IMR0.UINT8[LH/HL/HH]
INTC1.IMR0.BIT.IMR0EIMK8 ... INTC1.IMR0.BIT.IMR0EIMK31
PDMA0.DMACTL
PDMA0.DMACER
PDMA0.DM0CMV
PDMA0.DM1CMV
PDMA0.CMVC
PDMA0.DM00CM
PDMA0.DM01CM
PDMA0.DM02CM
PDMA0.DM03CM
PDMA0.DM04CM
PDMA0.DM05CM
PDMA0.DM06CM
PDMA0.DM07CM
PDMA0.DM10CM
PDMA0.DM11CM
PDMA0.DM12CM
PDMA0.DM13CM
PDMA0.DM14CM
PDMA0.DM15CM
PDMA0.DM16CM
PDMA0.DM17CM
PDMA0.DSA0
PDMA0.DDA0
PDMA0.DTC0
PDMA0.DTCT0
PDMA0.DRSA0
PDMA0.DRDA0
PDMA0.DRTC0
PDMA0.DCEN0
PDMA0.DCST0
PDMA0.DCSTS0
PDMA0.DCSTC0
PDMA0.DTFR0
PDMA0.DTFRRQ0
PDMA0.DTFRRQC0
PDMA0.DSA1
PDMA0.DDA1
PDMA0.DTC1
PDMA0.DTCT1
PDMA0.DRSA1
PDMA0.DRDA1
PDMA0.DRTC1
PDMA0.DCEN1
PDMA0.DCST1
PDMA0.DCSTS1
PDMA0.DCSTC1
PDMA0.DTFR1
PDMA0.DTFRRQ1
PDMA0.DTFRRQC1
PDMA0.DSA2
PDMA0.DDA2
PDMA0.DTC2
PDMA0.DTCT2
PDMA0.DRSA2
PDMA0.DRDA2
PDMA0.DRTC2
PDMA0.DCEN2
PDMA0.DCST2
PDMA0.DCSTS2
PDMA0.DCSTC2
PDMA0.DTFR2
PDMA0.DTFRRQ2
PDMA0.DTFRRQC2
PDMA0.DSA3
PDMA0.DDA3
PDMA0.DTC3
PDMA0.DTCT3
PDMA0.DRSA3
PDMA0.DRDA3
PDMA0.DRTC3
PDMA0.DCEN3
PDMA0.DCST3
PDMA0.DCSTS3
PDMA0.DCSTC3
PDMA0.DTFR3
PDMA0.DTFRRQ3
PDMA0.DTFRRQC3
PDMA0.DSA4
PDMA0.DDA4
PDMA0.DTC4
PDMA0.DTCT4
PDMA0.DRSA4
PDMA0.DRDA4
PDMA0.DRTC4
PDMA0.DCEN4
PDMA0.DCST4
PDMA0.DCSTS4
PDMA0.DCSTC4
PDMA0.DTFR4
PDMA0.DTFRRQ4
PDMA0.DTFRRQC4
PDMA0.DSA5
PDMA0.DDA5
PDMA0.DTC5
PDMA0.DTCT5
PDMA0.DRSA5
PDMA0.DRDA5
PDMA0.DRTC5
PDMA0.DCEN5
PDMA0.DCST5
PDMA0.DCSTS5
PDMA0.DCSTC5
PDMA0.DTFR5
PDMA0.DTFRRQ5
PDMA0.DTFRRQC5
PDMA0.DSA6
PDMA0.DDA6
PDMA0.DTC6
PDMA0.DTCT6
PDMA0.DRSA6
PDMA0.DRDA6
PDMA0.DRTC6
PDMA0.DCEN6
PDMA0.DCST6
PDMA0.DCSTS6
PDMA0.DCSTC6
PDMA0.DTFR6
PDMA0.DTFRRQ6
PDMA0.DTFRRQC6
PDMA0.DSA7
PDMA0.DDA7
PDMA0.DTC7
PDMA0.DTCT7
PDMA0.DRSA7
PDMA0.DRDA7
PDMA0.DRTC7
PDMA0.DCEN7
PDMA0.DCST7
PDMA0.DCSTS7
PDMA0.DCSTC7
PDMA0.DTFR7
PDMA0.DTFRRQ7
PDMA0.DTFRRQC7
PDMA0.DSA8
PDMA0.DDA8
PDMA0.DTC8
PDMA0.DTCT8
PDMA0.DRSA8
PDMA0.DRDA8
PDMA0.DRTC8
PDMA0.DCEN8
PDMA0.DCST8
PDMA0.DCSTS8
PDMA0.DCSTC8
PDMA0.DTFR8
PDMA0.DTFRRQ8
PDMA0.DTFRRQC8
PDMA0.DSA9
PDMA0.DDA9
PDMA0.DTC9
PDMA0.DTCT9
PDMA0.DRSA9
PDMA0.DRDA9
PDMA0.DRTC9
PDMA0.DCEN9
PDMA0.DCST9
PDMA0.DCSTS9
PDMA0.DCSTC9
PDMA0.DTFR9
PDMA0.DTFRRQ9
PDMA0.DTFRRQC9
PDMA0.DSA10
PDMA0.DDA10
PDMA0.DTC10
PDMA0.DTCT10
PDMA0.DRSA10
PDMA0.DRDA10
PDMA0.DRTC10
PDMA0.DCEN10
PDMA0.DCST10
PDMA0.DCSTS10
PDMA0.DCSTC10
PDMA0.DTFR10
PDMA0.DTFRRQ10
PDMA0.DTFRRQC10
PDMA0.DSA11
PDMA0.DDA11
PDMA0.DTC11
PDMA0.DTCT11
PDMA0.DRSA11
PDMA0.DRDA11
PDMA0.DRTC11
PDMA0.DCEN11
PDMA0.DCST11
PDMA0.DCSTS11
PDMA0.DCSTC11
PDMA0.DTFR11
PDMA0.DTFRRQ11
PDMA0.DTFRRQC11
PDMA0.DSA12
PDMA0.DDA12
PDMA0.DTC12
PDMA0.DTCT12
PDMA0.DRSA12
PDMA0.DRDA12
PDMA0.DRTC12
PDMA0.DCEN12
PDMA0.DCST12
PDMA0.DCSTS12
PDMA0.DCSTC12
PDMA0.DTFR12
PDMA0.DTFRRQ12
PDMA0.DTFRRQC12
PDMA0.DSA13
PDMA0.DDA13
PDMA0.DTC13
PDMA0.DTCT13
PDMA0.DRSA13
PDMA0.DRDA13
PDMA0.DRTC13
PDMA0.DCEN13
PDMA0.DCST13
PDMA0.DCSTS13
PDMA0.DCSTC13
PDMA0.DTFR13
PDMA0.DTFRRQ13
PDMA0.DTFRRQC13
PDMA0.DSA14
PDMA0.DDA14
PDMA0.DTC14
PDMA0.DTCT14
PDMA0.DRSA14
PDMA0.DRDA14
PDMA0.DRTC14
PDMA0.DCEN14
PDMA0.DCST14
PDMA0.DCSTS14
PDMA0.DCSTC14
PDMA0.DTFR14
PDMA0.DTFRRQ14
PDMA0.DTFRRQC14
PDMA0.DSA15
PDMA0.DDA15
PDMA0.DTC15
PDMA0.DTCT15
PDMA0.DRSA15
PDMA0.DRDA15
PDMA0.DRTC15
PDMA0.DCEN15
PDMA0.DCST15
PDMA0.DCSTS15
PDMA0.DCSTC15
PDMA0.DTFR15
PDMA0.DTFRRQ15
PDMA0.DTFRRQC15
INTC2.ICADCA0I2_2.UINT16
INTC2.ICADCA0I2_2.UINT16
INTC2.ICADCA0I2_2.UINT8[L/H]
INTC2.ICADCA0I2_2.BIT.P0ADCA0I2_2
INTC2.ICADCA0I2_2.BIT.P0CSIH0IJC
INTC2.ICADCA0I2_2.BIT.P1ADCA0I2_2
INTC2.ICADCA0I2_2.BIT.P1CSIH0IJC
INTC2.ICADCA0I2_2.BIT.P2ADCA0I2_2
INTC2.ICADCA0I2_2.BIT.P2CSIH0IJC
INTC2.ICADCA0I2_2.BIT.P3ADCA0I2_2
INTC2.ICADCA0I2_2.BIT.P3CSIH0IJC
INTC2.ICADCA0I2_2.BIT.TBADCA0I2_2
INTC2.ICADCA0I2_2.BIT.TBCSIH0IJC
INTC2.ICADCA0I2_2.BIT.MKADCA0I2_2
INTC2.ICADCA0I2_2.BIT.MKCSIH0IJC
INTC2.ICADCA0I2_2.BIT.RFADCA0I2_2
INTC2.ICADCA0I2_2.BIT.RFCSIH0IJC
INTC2.ICADCA0I2_2.BIT.CTADCA0I2_2
INTC2.ICADCA0I2_2.BIT.CTCSIH0IJC
INTC2.ICRLIN30.UINT16
INTC2.ICRLIN30.UINT8[L/H]
INTC2.ICRLIN30.BIT.P0RLIN30
INTC2.ICRLIN30.BIT.P1RLIN30
INTC2.ICRLIN30.BIT.P2RLIN30
INTC2.ICRLIN30.BIT.P3RLIN30
INTC2.ICRLIN30.BIT.TBRLIN30
INTC2.ICRLIN30.BIT.MKRLIN30
INTC2.ICRLIN30.BIT.RFRLIN30
INTC2.ICRLIN30.BIT.CTRLIN30
INTC2.ICRLIN30UR0.UINT16
INTC2.ICRLIN30UR0.UINT8[L/H]
INTC2.ICRLIN30UR0.BIT.P0RLIN30UR0
INTC2.ICRLIN30UR0.BIT.P1RLIN30UR0
INTC2.ICRLIN30UR0.BIT.P2RLIN30UR0
INTC2.ICRLIN30UR0.BIT.P3RLIN30UR0
INTC2.ICRLIN30UR0.BIT.TBRLIN30UR0
INTC2.ICRLIN30UR0.BIT.MKRLIN30UR0
INTC2.ICRLIN30UR0.BIT.RFRLIN30UR0
INTC2.ICRLIN30UR0.BIT.CTRLIN30UR0
INTC2.ICRLIN30UR1.UINT16
INTC2.ICRLIN30UR1.UINT8[L/H]
INTC2.ICRLIN30UR1.BIT.P0RLIN30UR1
INTC2.ICRLIN30UR1.BIT.P1RLIN30UR1
INTC2.ICRLIN30UR1.BIT.P2RLIN30UR1
INTC2.ICRLIN30UR1.BIT.P3RLIN30UR1
INTC2.ICRLIN30UR1.BIT.TBRLIN30UR1
INTC2.ICRLIN30UR1.BIT.MKRLIN30UR1
INTC2.ICRLIN30UR1.BIT.RFRLIN30UR1
INTC2.ICRLIN30UR1.BIT.CTRLIN30UR1
INTC2.ICRLIN30UR2.UINT16
INTC2.ICRLIN30UR2.UINT8[L/H]
INTC2.ICRLIN30UR2.BIT.P0RLIN30UR2
INTC2.ICRLIN30UR2.BIT.P1RLIN30UR2
INTC2.ICRLIN30UR2.BIT.P2RLIN30UR2
INTC2.ICRLIN30UR2.BIT.P3RLIN30UR2
INTC2.ICRLIN30UR2.BIT.TBRLIN30UR2
INTC2.ICRLIN30UR2.BIT.MKRLIN30UR2
INTC2.ICRLIN30UR2.BIT.RFRLIN30UR2
INTC2.ICRLIN30UR2.BIT.CTRLIN30UR2
INTC2.ICP0.UINT16
INTC2.ICP0.UINT8[L/H]
INTC2.ICP0.BIT.P0P0
INTC2.ICP0.BIT.P1P0
INTC2.ICP0.BIT.P2P0
INTC2.ICP0.BIT.P3P0
INTC2.ICP0.BIT.TBP0
INTC2.ICP0.BIT.MKP0
INTC2.ICP0.BIT.RFP0
INTC2.ICP0.BIT.CTP0
INTC2.ICP1.UINT16
INTC2.ICP1.UINT8[L/H]
INTC2.ICP1.BIT.P0P1
INTC2.ICP1.BIT.P1P1
INTC2.ICP1.BIT.P2P1
INTC2.ICP1.BIT.P3P1
INTC2.ICP1.BIT.TBP1
INTC2.ICP1.BIT.MKP1
INTC2.ICP1.BIT.RFP1
INTC2.ICP1.BIT.CTP1
INTC2.ICP2.UINT16
INTC2.ICP2.UINT8[L/H]
INTC2.ICP2.BIT.P0P2
INTC2.ICP2.BIT.P1P2
INTC2.ICP2.BIT.P2P2
INTC2.ICP2.BIT.P3P2
INTC2.ICP2.BIT.TBP2
INTC2.ICP2.BIT.MKP2
INTC2.ICP2.BIT.RFP2
INTC2.ICP2.BIT.CTP2
INTC2.ICWDTA0.UINT16
INTC2.ICWDTA0.UINT8[L/H]
INTC2.ICWDTA0.BIT.P0WDTA0
INTC2.ICWDTA0.BIT.P1WDTA0
INTC2.ICWDTA0.BIT.P2WDTA0
INTC2.ICWDTA0.BIT.P3WDTA0
INTC2.ICWDTA0.BIT.TBWDTA0
INTC2.ICWDTA0.BIT.MKWDTA0
INTC2.ICWDTA0.BIT.RFWDTA0
INTC2.ICWDTA0.BIT.CTWDTA0
INTC2.ICWDTA1.UINT16
INTC2.ICWDTA1.UINT8[L/H]
INTC2.ICWDTA1.BIT.P0WDTA1
INTC2.ICWDTA1.BIT.P1WDTA1
INTC2.ICWDTA1.BIT.P2WDTA1
INTC2.ICWDTA1.BIT.P3WDTA1
INTC2.ICWDTA1.BIT.TBWDTA1
INTC2.ICWDTA1.BIT.MKWDTA1
INTC2.ICWDTA1.BIT.RFWDTA1
INTC2.ICWDTA1.BIT.CTWDTA1
INTC2.ICP3.UINT16
INTC2.ICP3.UINT8[L/H]
INTC2.ICP3.BIT.P0P3
INTC2.ICP3.BIT.P1P3
INTC2.ICP3.BIT.P2P3
INTC2.ICP3.BIT.P3P3
INTC2.ICP3.BIT.TBP3
INTC2.ICP3.BIT.MKP3
INTC2.ICP3.BIT.RFP3
INTC2.ICP3.BIT.CTP3
INTC2.ICP4.UINT16
INTC2.ICP4.UINT8[L/H]
INTC2.ICP4.BIT.P0P4
INTC2.ICP4.BIT.P1P4
INTC2.ICP4.BIT.P2P4
INTC2.ICP4.BIT.P3P4
INTC2.ICP4.BIT.TBP4
INTC2.ICP4.BIT.MKP4
INTC2.ICP4.BIT.RFP4
INTC2.ICP4.BIT.CTP4
INTC2.ICP5.UINT16
INTC2.ICP5.UINT8[L/H]
INTC2.ICP5.BIT.P0P5
INTC2.ICP5.BIT.P1P5
INTC2.ICP5.BIT.P2P5
INTC2.ICP5.BIT.P3P5
INTC2.ICP5.BIT.TBP5
INTC2.ICP5.BIT.MKP5
INTC2.ICP5.BIT.RFP5
INTC2.ICP5.BIT.CTP5
INTC2.ICP10.UINT16
INTC2.ICP10.UINT8[L/H]
INTC2.ICP10.BIT.P0P10
INTC2.ICP10.BIT.P1P10
INTC2.ICP10.BIT.P2P10
INTC2.ICP10.BIT.P3P10
INTC2.ICP10.BIT.TBP10
INTC2.ICP10.BIT.MKP10
INTC2.ICP10.BIT.RFP10
INTC2.ICP10.BIT.CTP10
INTC2.ICP11.UINT16
INTC2.ICP11.UINT8[L/H]
INTC2.ICP11.BIT.P0P11
INTC2.ICP11.BIT.P1P11
INTC2.ICP11.BIT.P2P11
INTC2.ICP11.BIT.P3P11
INTC2.ICP11.BIT.TBP11
INTC2.ICP11.BIT.MKP11
INTC2.ICP11.BIT.RFP11
INTC2.ICP11.BIT.CTP11
INTC2.ICTAUD0I1.UINT16
INTC2.ICTAUD0I1.UINT8[L/H]
INTC2.ICTAUD0I1.BIT.P0TAUD0I1
INTC2.ICTAUD0I1.BIT.P1TAUD0I1
INTC2.ICTAUD0I1.BIT.P2TAUD0I1
INTC2.ICTAUD0I1.BIT.P3TAUD0I1
INTC2.ICTAUD0I1.BIT.TBTAUD0I1
INTC2.ICTAUD0I1.BIT.MKTAUD0I1
INTC2.ICTAUD0I1.BIT.RFTAUD0I1
INTC2.ICTAUD0I1.BIT.CTTAUD0I1
INTC2.ICTAUD0I3.UINT16
INTC2.ICTAUD0I3.UINT8[L/H]
INTC2.ICTAUD0I3.BIT.P0TAUD0I3
INTC2.ICTAUD0I3.BIT.P1TAUD0I3
INTC2.ICTAUD0I3.BIT.P2TAUD0I3
INTC2.ICTAUD0I3.BIT.P3TAUD0I3
INTC2.ICTAUD0I3.BIT.TBTAUD0I3
INTC2.ICTAUD0I3.BIT.MKTAUD0I3
INTC2.ICTAUD0I3.BIT.RFTAUD0I3
INTC2.ICTAUD0I3.BIT.CTTAUD0I3
INTC2.ICTAUD0I5.UINT16
INTC2.ICTAUD0I5.UINT8[L/H]
INTC2.ICTAUD0I5.BIT.P0TAUD0I5
INTC2.ICTAUD0I5.BIT.P1TAUD0I5
INTC2.ICTAUD0I5.BIT.P2TAUD0I5
INTC2.ICTAUD0I5.BIT.P3TAUD0I5
INTC2.ICTAUD0I5.BIT.TBTAUD0I5
INTC2.ICTAUD0I5.BIT.MKTAUD0I5
INTC2.ICTAUD0I5.BIT.RFTAUD0I5
INTC2.ICTAUD0I5.BIT.CTTAUD0I5
INTC2.ICTAUD0I7.UINT16
INTC2.ICTAUD0I7.UINT8[L/H]
INTC2.ICTAUD0I7.BIT.P0TAUD0I7
INTC2.ICTAUD0I7.BIT.P1TAUD0I7
INTC2.ICTAUD0I7.BIT.P2TAUD0I7
INTC2.ICTAUD0I7.BIT.P3TAUD0I7
INTC2.ICTAUD0I7.BIT.TBTAUD0I7
INTC2.ICTAUD0I7.BIT.MKTAUD0I7
INTC2.ICTAUD0I7.BIT.RFTAUD0I7
INTC2.ICTAUD0I7.BIT.CTTAUD0I7
INTC2.ICTAUD0I9.UINT16
INTC2.ICTAUD0I9.UINT8[L/H]
INTC2.ICTAUD0I9.BIT.P0TAUD0I9
INTC2.ICTAUD0I9.BIT.P1TAUD0I9
INTC2.ICTAUD0I9.BIT.P2TAUD0I9
INTC2.ICTAUD0I9.BIT.P3TAUD0I9
INTC2.ICTAUD0I9.BIT.TBTAUD0I9
INTC2.ICTAUD0I9.BIT.MKTAUD0I9
INTC2.ICTAUD0I9.BIT.RFTAUD0I9
INTC2.ICTAUD0I9.BIT.CTTAUD0I9
INTC2.ICTAUD0I11.UINT16
INTC2.ICTAUD0I11.UINT8[L/H]
INTC2.ICTAUD0I11.BIT.P0TAUD0I11
INTC2.ICTAUD0I11.BIT.P1TAUD0I11
INTC2.ICTAUD0I11.BIT.P2TAUD0I11
INTC2.ICTAUD0I11.BIT.P3TAUD0I11
INTC2.ICTAUD0I11.BIT.TBTAUD0I11
INTC2.ICTAUD0I11.BIT.MKTAUD0I11
INTC2.ICTAUD0I11.BIT.RFTAUD0I11
INTC2.ICTAUD0I11.BIT.CTTAUD0I11
INTC2.ICTAUD0I13.UINT16
INTC2.ICTAUD0I13.UINT8[L/H]
INTC2.ICTAUD0I13.BIT.P0TAUD0I13
INTC2.ICTAUD0I13.BIT.P1TAUD0I13
INTC2.ICTAUD0I13.BIT.P2TAUD0I13
INTC2.ICTAUD0I13.BIT.P3TAUD0I13
INTC2.ICTAUD0I13.BIT.TBTAUD0I13
INTC2.ICTAUD0I13.BIT.MKTAUD0I13
INTC2.ICTAUD0I13.BIT.RFTAUD0I13
INTC2.ICTAUD0I13.BIT.CTTAUD0I13
INTC2.ICTAUD0I15.UINT16
INTC2.ICTAUD0I15.UINT8[L/H]
INTC2.ICTAUD0I15.BIT.P0TAUD0I15
INTC2.ICTAUD0I15.BIT.P1TAUD0I15
INTC2.ICTAUD0I15.BIT.P2TAUD0I15
INTC2.ICTAUD0I15.BIT.P3TAUD0I15
INTC2.ICTAUD0I15.BIT.TBTAUD0I15
INTC2.ICTAUD0I15.BIT.MKTAUD0I15
INTC2.ICTAUD0I15.BIT.RFTAUD0I15
INTC2.ICTAUD0I15.BIT.CTTAUD0I15
INTC2.ICADCA0ERR.UINT16
INTC2.ICADCA0ERR.UINT8[L/H]
INTC2.ICADCA0ERR.BIT.P0ADCA0ERR
INTC2.ICADCA0ERR.BIT.P1ADCA0ERR
INTC2.ICADCA0ERR.BIT.P2ADCA0ERR
INTC2.ICADCA0ERR.BIT.P3ADCA0ERR
INTC2.ICADCA0ERR.BIT.TBADCA0ERR
INTC2.ICADCA0ERR.BIT.MKADCA0ERR
INTC2.ICADCA0ERR.BIT.RFADCA0ERR
INTC2.ICADCA0ERR.BIT.CTADCA0ERR
INTC2.ICCSIG0IRE.UINT16
INTC2.ICCSIG0IRE.UINT8[L/H]
INTC2.ICCSIG0IRE.BIT.P0CSIG0IRE
INTC2.ICCSIG0IRE.BIT.P1CSIG0IRE
INTC2.ICCSIG0IRE.BIT.P2CSIG0IRE
INTC2.ICCSIG0IRE.BIT.P3CSIG0IRE
INTC2.ICCSIG0IRE.BIT.TBCSIG0IRE
INTC2.ICCSIG0IRE.BIT.MKCSIG0IRE
INTC2.ICCSIG0IRE.BIT.RFCSIG0IRE
INTC2.ICCSIG0IRE.BIT.CTCSIG0IRE
INTC2.ICRLIN20.UINT16
INTC2.ICRLIN20.UINT8[L/H]
INTC2.ICRLIN20.BIT.P0RLIN20
INTC2.ICRLIN20.BIT.P1RLIN20
INTC2.ICRLIN20.BIT.P2RLIN20
INTC2.ICRLIN20.BIT.P3RLIN20
INTC2.ICRLIN20.BIT.TBRLIN20
INTC2.ICRLIN20.BIT.MKRLIN20
INTC2.ICRLIN20.BIT.RFRLIN20
INTC2.ICRLIN20.BIT.CTRLIN20
INTC2.ICRLIN21.UINT16
INTC2.ICRLIN21.UINT8[L/H]
INTC2.ICRLIN21.BIT.P0RLIN21
INTC2.ICRLIN21.BIT.P1RLIN21
INTC2.ICRLIN21.BIT.P2RLIN21
INTC2.ICRLIN21.BIT.P3RLIN21
INTC2.ICRLIN21.BIT.TBRLIN21
INTC2.ICRLIN21.BIT.MKRLIN21
INTC2.ICRLIN21.BIT.RFRLIN21
INTC2.ICRLIN21.BIT.CTRLIN21
INTC2.ICDMA0.UINT16
INTC2.ICDMA0.UINT8[L/H]
INTC2.ICDMA0.BIT.P0DMA0
INTC2.ICDMA0.BIT.P1DMA0
INTC2.ICDMA0.BIT.P2DMA0
INTC2.ICDMA0.BIT.P3DMA0
INTC2.ICDMA0.BIT.TBDMA0
INTC2.ICDMA0.BIT.MKDMA0
INTC2.ICDMA0.BIT.RFDMA0
INTC2.ICDMA0.BIT.CTDMA0
INTC2.ICDMA1.UINT16
INTC2.ICDMA1.UINT8[L/H]
INTC2.ICDMA1.BIT.P0DMA1
INTC2.ICDMA1.BIT.P1DMA1
INTC2.ICDMA1.BIT.P2DMA1
INTC2.ICDMA1.BIT.P3DMA1
INTC2.ICDMA1.BIT.TBDMA1
INTC2.ICDMA1.BIT.MKDMA1
INTC2.ICDMA1.BIT.RFDMA1
INTC2.ICDMA1.BIT.CTDMA1
INTC2.ICDMA2.UINT16
INTC2.ICDMA2.UINT8[L/H]
INTC2.ICDMA2.BIT.P0DMA2
INTC2.ICDMA2.BIT.P1DMA2
INTC2.ICDMA2.BIT.P2DMA2
INTC2.ICDMA2.BIT.P3DMA2
INTC2.ICDMA2.BIT.TBDMA2
INTC2.ICDMA2.BIT.MKDMA2
INTC2.ICDMA2.BIT.RFDMA2
INTC2.ICDMA2.BIT.CTDMA2
INTC2.ICDMA3.UINT16
INTC2.ICDMA3.UINT8[L/H]
INTC2.ICDMA3.BIT.P0DMA3
INTC2.ICDMA3.BIT.P1DMA3
INTC2.ICDMA3.BIT.P2DMA3
INTC2.ICDMA3.BIT.P3DMA3
INTC2.ICDMA3.BIT.TBDMA3
INTC2.ICDMA3.BIT.MKDMA3
INTC2.ICDMA3.BIT.RFDMA3
INTC2.ICDMA3.BIT.CTDMA3
INTC2.ICDMA4.UINT16
INTC2.ICDMA4.UINT8[L/H]
INTC2.ICDMA4.BIT.P0DMA4
INTC2.ICDMA4.BIT.P1DMA4
INTC2.ICDMA4.BIT.P2DMA4
INTC2.ICDMA4.BIT.P3DMA4
INTC2.ICDMA4.BIT.TBDMA4
INTC2.ICDMA4.BIT.MKDMA4
INTC2.ICDMA4.BIT.RFDMA4
INTC2.ICDMA4.BIT.CTDMA4
INTC2.ICDMA5.UINT16
INTC2.ICDMA5.UINT8[L/H]
INTC2.ICDMA5.BIT.P0DMA5
INTC2.ICDMA5.BIT.P1DMA5
INTC2.ICDMA5.BIT.P2DMA5
INTC2.ICDMA5.BIT.P3DMA5
INTC2.ICDMA5.BIT.TBDMA5
INTC2.ICDMA5.BIT.MKDMA5
INTC2.ICDMA5.BIT.RFDMA5
INTC2.ICDMA5.BIT.CTDMA5
INTC2.ICDMA6.UINT16
INTC2.ICDMA6.UINT8[L/H]
INTC2.ICDMA6.BIT.P0DMA6
INTC2.ICDMA6.BIT.P1DMA6
INTC2.ICDMA6.BIT.P2DMA6
INTC2.ICDMA6.BIT.P3DMA6
INTC2.ICDMA6.BIT.TBDMA6
INTC2.ICDMA6.BIT.MKDMA6
INTC2.ICDMA6.BIT.RFDMA6
INTC2.ICDMA6.BIT.CTDMA6
INTC2.ICDMA7.UINT16
INTC2.ICDMA7.UINT8[L/H]
INTC2.ICDMA7.BIT.P0DMA7
INTC2.ICDMA7.BIT.P1DMA7
INTC2.ICDMA7.BIT.P2DMA7
INTC2.ICDMA7.BIT.P3DMA7
INTC2.ICDMA7.BIT.TBDMA7
INTC2.ICDMA7.BIT.MKDMA7
INTC2.ICDMA7.BIT.RFDMA7
INTC2.ICDMA7.BIT.CTDMA7
INTC2.ICDMA8.UINT16
INTC2.ICDMA8.UINT8[L/H]
INTC2.ICDMA8.BIT.P0DMA8
INTC2.ICDMA8.BIT.P1DMA8
INTC2.ICDMA8.BIT.P2DMA8
INTC2.ICDMA8.BIT.P3DMA8
INTC2.ICDMA8.BIT.TBDMA8
INTC2.ICDMA8.BIT.MKDMA8
INTC2.ICDMA8.BIT.RFDMA8
INTC2.ICDMA8.BIT.CTDMA8
INTC2.ICDMA9.UINT16
INTC2.ICDMA9.UINT8[L/H]
INTC2.ICDMA9.BIT.P0DMA9
INTC2.ICDMA9.BIT.P1DMA9
INTC2.ICDMA9.BIT.P2DMA9
INTC2.ICDMA9.BIT.P3DMA9
INTC2.ICDMA9.BIT.TBDMA9
INTC2.ICDMA9.BIT.MKDMA9
INTC2.ICDMA9.BIT.RFDMA9
INTC2.ICDMA9.BIT.CTDMA9
INTC2.ICDMA10.UINT16
INTC2.ICDMA10.UINT8[L/H]
INTC2.ICDMA10.BIT.P0DMA10
INTC2.ICDMA10.BIT.P1DMA10
INTC2.ICDMA10.BIT.P2DMA10
INTC2.ICDMA10.BIT.P3DMA10
INTC2.ICDMA10.BIT.TBDMA10
INTC2.ICDMA10.BIT.MKDMA10
INTC2.ICDMA10.BIT.RFDMA10
INTC2.ICDMA10.BIT.CTDMA10
INTC2.ICDMA11.UINT16
INTC2.ICDMA11.UINT8[L/H]
INTC2.ICDMA11.BIT.P0DMA11
INTC2.ICDMA11.BIT.P1DMA11
INTC2.ICDMA11.BIT.P2DMA11
INTC2.ICDMA11.BIT.P3DMA11
INTC2.ICDMA11.BIT.TBDMA11
INTC2.ICDMA11.BIT.MKDMA11
INTC2.ICDMA11.BIT.RFDMA11
INTC2.ICDMA11.BIT.CTDMA11
INTC2.ICDMA12.UINT16
INTC2.ICDMA12.UINT8[L/H]
INTC2.ICDMA12.BIT.P0DMA12
INTC2.ICDMA12.BIT.P1DMA12
INTC2.ICDMA12.BIT.P2DMA12
INTC2.ICDMA12.BIT.P3DMA12
INTC2.ICDMA12.BIT.TBDMA12
INTC2.ICDMA12.BIT.MKDMA12
INTC2.ICDMA12.BIT.RFDMA12
INTC2.ICDMA12.BIT.CTDMA12
INTC2.ICDMA13.UINT16
INTC2.ICDMA13.UINT8[L/H]
INTC2.ICDMA13.BIT.P0DMA13
INTC2.ICDMA13.BIT.P1DMA13
INTC2.ICDMA13.BIT.P2DMA13
INTC2.ICDMA13.BIT.P3DMA13
INTC2.ICDMA13.BIT.TBDMA13
INTC2.ICDMA13.BIT.MKDMA13
INTC2.ICDMA13.BIT.RFDMA13
INTC2.ICDMA13.BIT.CTDMA13
INTC2.ICDMA14.UINT16
INTC2.ICDMA14.UINT8[L/H]
INTC2.ICDMA14.BIT.P0DMA14
INTC2.ICDMA14.BIT.P1DMA14
INTC2.ICDMA14.BIT.P2DMA14
INTC2.ICDMA14.BIT.P3DMA14
INTC2.ICDMA14.BIT.TBDMA14
INTC2.ICDMA14.BIT.MKDMA14
INTC2.ICDMA14.BIT.RFDMA14
INTC2.ICDMA14.BIT.CTDMA14
INTC2.ICDMA15.UINT16
INTC2.ICDMA15.UINT8[L/H]
INTC2.ICDMA15.BIT.P0DMA15
INTC2.ICDMA15.BIT.P1DMA15
INTC2.ICDMA15.BIT.P2DMA15
INTC2.ICDMA15.BIT.P3DMA15
INTC2.ICDMA15.BIT.TBDMA15
INTC2.ICDMA15.BIT.MKDMA15
INTC2.ICDMA15.BIT.RFDMA15
INTC2.ICDMA15.BIT.CTDMA15
INTC2.ICRIIC0TI.UINT16
INTC2.ICRIIC0TI.UINT8[L/H]
INTC2.ICRIIC0TI.BIT.P0RIIC0TI
INTC2.ICRIIC0TI.BIT.P1RIIC0TI
INTC2.ICRIIC0TI.BIT.P2RIIC0TI
INTC2.ICRIIC0TI.BIT.P3RIIC0TI
INTC2.ICRIIC0TI.BIT.TBRIIC0TI
INTC2.ICRIIC0TI.BIT.MKRIIC0TI
INTC2.ICRIIC0TI.BIT.RFRIIC0TI
INTC2.ICRIIC0TI.BIT.CTRIIC0TI
INTC2.ICRIIC0EE.UINT16
INTC2.ICRIIC0EE.UINT8[L/H]
INTC2.ICRIIC0EE.BIT.P0RIIC0EE
INTC2.ICRIIC0EE.BIT.P1RIIC0EE
INTC2.ICRIIC0EE.BIT.P2RIIC0EE
INTC2.ICRIIC0EE.BIT.P3RIIC0EE
INTC2.ICRIIC0EE.BIT.TBRIIC0EE
INTC2.ICRIIC0EE.BIT.MKRIIC0EE
INTC2.ICRIIC0EE.BIT.RFRIIC0EE
INTC2.ICRIIC0EE.BIT.CTRIIC0EE
INTC2.ICRIIC0RI.UINT16
INTC2.ICRIIC0RI.UINT8[L/H]
INTC2.ICRIIC0RI.BIT.P0RIIC0RI
INTC2.ICRIIC0RI.BIT.P1RIIC0RI
INTC2.ICRIIC0RI.BIT.P2RIIC0RI
INTC2.ICRIIC0RI.BIT.P3RIIC0RI
INTC2.ICRIIC0RI.BIT.TBRIIC0RI
INTC2.ICRIIC0RI.BIT.MKRIIC0RI
INTC2.ICRIIC0RI.BIT.RFRIIC0RI
INTC2.ICRIIC0RI.BIT.CTRIIC0RI
INTC2.ICRIIC0TEI.UINT16
INTC2.ICRIIC0TEI.UINT8[L/H]
INTC2.ICRIIC0TEI.BIT.P0RIIC0TEI
INTC2.ICRIIC0TEI.BIT.P1RIIC0TEI
INTC2.ICRIIC0TEI.BIT.P2RIIC0TEI
INTC2.ICRIIC0TEI.BIT.P3RIIC0TEI
INTC2.ICRIIC0TEI.BIT.TBRIIC0TEI
INTC2.ICRIIC0TEI.BIT.MKRIIC0TEI
INTC2.ICRIIC0TEI.BIT.RFRIIC0TEI
INTC2.ICRIIC0TEI.BIT.CTRIIC0TEI
INTC2.ICTAUJ0I0.UINT16
INTC2.ICTAUJ0I0.UINT8[L/H]
INTC2.ICTAUJ0I0.BIT.P0TAUJ0I0
INTC2.ICTAUJ0I0.BIT.P1TAUJ0I0
INTC2.ICTAUJ0I0.BIT.P2TAUJ0I0
INTC2.ICTAUJ0I0.BIT.P3TAUJ0I0
INTC2.ICTAUJ0I0.BIT.TBTAUJ0I0
INTC2.ICTAUJ0I0.BIT.MKTAUJ0I0
INTC2.ICTAUJ0I0.BIT.RFTAUJ0I0
INTC2.ICTAUJ0I0.BIT.CTTAUJ0I0
INTC2.ICTAUJ0I1.UINT16
INTC2.ICTAUJ0I1.UINT8[L/H]
INTC2.ICTAUJ0I1.BIT.P0TAUJ0I1
INTC2.ICTAUJ0I1.BIT.P1TAUJ0I1
INTC2.ICTAUJ0I1.BIT.P2TAUJ0I1
INTC2.ICTAUJ0I1.BIT.P3TAUJ0I1
INTC2.ICTAUJ0I1.BIT.TBTAUJ0I1
INTC2.ICTAUJ0I1.BIT.MKTAUJ0I1
INTC2.ICTAUJ0I1.BIT.RFTAUJ0I1
INTC2.ICTAUJ0I1.BIT.CTTAUJ0I1
INTC2.ICTAUJ0I2.UINT16
INTC2.ICTAUJ0I2.UINT8[L/H]
INTC2.ICTAUJ0I2.BIT.P0TAUJ0I2
INTC2.ICTAUJ0I2.BIT.P1TAUJ0I2
INTC2.ICTAUJ0I2.BIT.P2TAUJ0I2
INTC2.ICTAUJ0I2.BIT.P3TAUJ0I2
INTC2.ICTAUJ0I2.BIT.TBTAUJ0I2
INTC2.ICTAUJ0I2.BIT.MKTAUJ0I2
INTC2.ICTAUJ0I2.BIT.RFTAUJ0I2
INTC2.ICTAUJ0I2.BIT.CTTAUJ0I2
INTC2.ICTAUJ0I3.UINT16
INTC2.ICTAUJ0I3.UINT8[L/H]
INTC2.ICTAUJ0I3.BIT.P0TAUJ0I3
INTC2.ICTAUJ0I3.BIT.P1TAUJ0I3
INTC2.ICTAUJ0I3.BIT.P2TAUJ0I3
INTC2.ICTAUJ0I3.BIT.P3TAUJ0I3
INTC2.ICTAUJ0I3.BIT.TBTAUJ0I3
INTC2.ICTAUJ0I3.BIT.MKTAUJ0I3
INTC2.ICTAUJ0I3.BIT.RFTAUJ0I3
INTC2.ICTAUJ0I3.BIT.CTTAUJ0I3
INTC2.ICOSTM0.UINT16
INTC2.ICOSTM0.UINT8[L/H]
INTC2.ICOSTM0.BIT.P0OSTM0
INTC2.ICOSTM0.BIT.P1OSTM0
INTC2.ICOSTM0.BIT.P2OSTM0
INTC2.ICOSTM0.BIT.P3OSTM0
INTC2.ICOSTM0.BIT.TBOSTM0
INTC2.ICOSTM0.BIT.MKOSTM0
INTC2.ICOSTM0.BIT.RFOSTM0
INTC2.ICOSTM0.BIT.CTOSTM0
INTC2.ICENCA0IOV.UINT16
INTC2.ICENCA0IOV.UINT8[L/H]
INTC2.ICENCA0IOV.BIT.P0ENCA0IOV
INTC2.ICENCA0IOV.BIT.P1ENCA0IOV
INTC2.ICENCA0IOV.BIT.P2ENCA0IOV
INTC2.ICENCA0IOV.BIT.P3ENCA0IOV
INTC2.ICENCA0IOV.BIT.TBENCA0IOV
INTC2.ICENCA0IOV.BIT.MKENCA0IOV
INTC2.ICENCA0IOV.BIT.RFENCA0IOV
INTC2.ICENCA0IOV.BIT.CTENCA0IOV
INTC2.ICENCA0IUD.UINT16
INTC2.ICENCA0IUD.UINT8[L/H]
INTC2.ICENCA0IUD.BIT.P0ENCA0IUD
INTC2.ICENCA0IUD.BIT.P1ENCA0IUD
INTC2.ICENCA0IUD.BIT.P2ENCA0IUD
INTC2.ICENCA0IUD.BIT.P3ENCA0IUD
INTC2.ICENCA0IUD.BIT.TBENCA0IUD
INTC2.ICENCA0IUD.BIT.MKENCA0IUD
INTC2.ICENCA0IUD.BIT.RFENCA0IUD
INTC2.ICENCA0IUD.BIT.CTENCA0IUD
INTC2.ICENCA0I0.UINT16
INTC2.ICENCA0I0.UINT8[L/H]
INTC2.ICENCA0I0.BIT.P0ENCA0I0
INTC2.ICENCA0I0.BIT.P1ENCA0I0
INTC2.ICENCA0I0.BIT.P2ENCA0I0
INTC2.ICENCA0I0.BIT.P3ENCA0I0
INTC2.ICENCA0I0.BIT.TBENCA0I0
INTC2.ICENCA0I0.BIT.MKENCA0I0
INTC2.ICENCA0I0.BIT.RFENCA0I0
INTC2.ICENCA0I0.BIT.CTENCA0I0
INTC2.ICENCA0I1.UINT16
INTC2.ICENCA0I1.UINT8[L/H]
INTC2.ICENCA0I1.BIT.P0ENCA0I1
INTC2.ICENCA0I1.BIT.P1ENCA0I1
INTC2.ICENCA0I1.BIT.P2ENCA0I1
INTC2.ICENCA0I1.BIT.P3ENCA0I1
INTC2.ICENCA0I1.BIT.TBENCA0I1
INTC2.ICENCA0I1.BIT.MKENCA0I1
INTC2.ICENCA0I1.BIT.RFENCA0I1
INTC2.ICENCA0I1.BIT.CTENCA0I1
INTC2.ICENCA0IEC.UINT16
INTC2.ICENCA0IEC.UINT8[L/H]
INTC2.ICENCA0IEC.BIT.P0ENCA0IEC
INTC2.ICENCA0IEC.BIT.P1ENCA0IEC
INTC2.ICENCA0IEC.BIT.P2ENCA0IEC
INTC2.ICENCA0IEC.BIT.P3ENCA0IEC
INTC2.ICENCA0IEC.BIT.TBENCA0IEC
INTC2.ICENCA0IEC.BIT.MKENCA0IEC
INTC2.ICENCA0IEC.BIT.RFENCA0IEC
INTC2.ICENCA0IEC.BIT.CTENCA0IEC
INTC2.ICKR0.UINT16
INTC2.ICKR0.UINT8[L/H]
INTC2.ICKR0.BIT.P0KR0
INTC2.ICKR0.BIT.P1KR0
INTC2.ICKR0.BIT.P2KR0
INTC2.ICKR0.BIT.P3KR0
INTC2.ICKR0.BIT.TBKR0
INTC2.ICKR0.BIT.MKKR0
INTC2.ICKR0.BIT.RFKR0
INTC2.ICKR0.BIT.CTKR0
INTC2.ICQFULL.UINT16
INTC2.ICQFULL.UINT8[L/H]
INTC2.ICQFULL.BIT.P0QFULL
INTC2.ICQFULL.BIT.P1QFULL
INTC2.ICQFULL.BIT.P2QFULL
INTC2.ICQFULL.BIT.P3QFULL
INTC2.ICQFULL.BIT.TBQFULL
INTC2.ICQFULL.BIT.MKQFULL
INTC2.ICQFULL.BIT.RFQFULL
INTC2.ICQFULL.BIT.CTQFULL
INTC2.ICPWGAG00.UINT16
INTC2.ICPWGAG00.UINT8[L/H]
INTC2.ICPWGAG00.BIT.P0PWGAG00
INTC2.ICPWGAG00.BIT.P1PWGAG00
INTC2.ICPWGAG00.BIT.P2PWGAG00
INTC2.ICPWGAG00.BIT.P3PWGAG00
INTC2.ICPWGAG00.BIT.TBPWGAG00
INTC2.ICPWGAG00.BIT.MKPWGAG00
INTC2.ICPWGAG00.BIT.RFPWGAG00
INTC2.ICPWGAG00.BIT.CTPWGAG00
INTC2.ICFLERR.UINT16
INTC2.ICFLERR.UINT8[L/H]
INTC2.ICFLERR.BIT.P0FLERR
INTC2.ICFLERR.BIT.P1FLERR
INTC2.ICFLERR.BIT.P2FLERR
INTC2.ICFLERR.BIT.P3FLERR
INTC2.ICFLERR.BIT.TBFLERR
INTC2.ICFLERR.BIT.MKFLERR
INTC2.ICFLERR.BIT.RFFLERR
INTC2.ICFLERR.BIT.CTFLERR
INTC2.ICFLENDNM.UINT16
INTC2.ICFLENDNM.UINT8[L/H]
INTC2.ICFLENDNM.BIT.P0FLENDNM
INTC2.ICFLENDNM.BIT.P1FLENDNM
INTC2.ICFLENDNM.BIT.P2FLENDNM
INTC2.ICFLENDNM.BIT.P3FLENDNM
INTC2.ICFLENDNM.BIT.TBFLENDNM
INTC2.ICFLENDNM.BIT.MKFLENDNM
INTC2.ICFLENDNM.BIT.RFFLENDNM
INTC2.ICFLENDNM.BIT.CTFLENDNM
INTC2.ICCWEND.UINT16
INTC2.ICCWEND.UINT8[L/H]
INTC2.ICCWEND.BIT.P0CWEND
INTC2.ICCWEND.BIT.P1CWEND
INTC2.ICCWEND.BIT.P2CWEND
INTC2.ICCWEND.BIT.P3CWEND
INTC2.ICCWEND.BIT.TBCWEND
INTC2.ICCWEND.BIT.MKCWEND
INTC2.ICCWEND.BIT.RFCWEND
INTC2.ICCWEND.BIT.CTCWEND
INTC2.ICRCAN1ERR.UINT16
INTC2.ICRCAN1ERR.UINT8[L/H]
INTC2.ICRCAN1ERR.BIT.P0RCAN1ERR
INTC2.ICRCAN1ERR.BIT.P1RCAN1ERR
INTC2.ICRCAN1ERR.BIT.P2RCAN1ERR
INTC2.ICRCAN1ERR.BIT.P3RCAN1ERR
INTC2.ICRCAN1ERR.BIT.TBRCAN1ERR
INTC2.ICRCAN1ERR.BIT.MKRCAN1ERR
INTC2.ICRCAN1ERR.BIT.RFRCAN1ERR
INTC2.ICRCAN1ERR.BIT.CTRCAN1ERR
INTC2.ICRCAN1REC.UINT16
INTC2.ICRCAN1REC.UINT8[L/H]
INTC2.ICRCAN1REC.BIT.P0RCAN1REC
INTC2.ICRCAN1REC.BIT.P1RCAN1REC
INTC2.ICRCAN1REC.BIT.P2RCAN1REC
INTC2.ICRCAN1REC.BIT.P3RCAN1REC
INTC2.ICRCAN1REC.BIT.TBRCAN1REC
INTC2.ICRCAN1REC.BIT.MKRCAN1REC
INTC2.ICRCAN1REC.BIT.RFRCAN1REC
INTC2.ICRCAN1REC.BIT.CTRCAN1REC
INTC2.ICRCAN1TRX.UINT16
INTC2.ICRCAN1TRX.UINT8[L/H]
INTC2.ICRCAN1TRX.BIT.P0RCAN1TRX
INTC2.ICRCAN1TRX.BIT.P1RCAN1TRX
INTC2.ICRCAN1TRX.BIT.P2RCAN1TRX
INTC2.ICRCAN1TRX.BIT.P3RCAN1TRX
INTC2.ICRCAN1TRX.BIT.TBRCAN1TRX
INTC2.ICRCAN1TRX.BIT.MKRCAN1TRX
INTC2.ICRCAN1TRX.BIT.RFRCAN1TRX
INTC2.ICRCAN1TRX.BIT.CTRCAN1TRX
INTC2.ICTAPA0IPEK0_2.UINT16
INTC2.ICTAPA0IPEK0_2.UINT8[L/H]
INTC2.ICTAPA0IPEK0_2.BIT.P0TAPA0IPEK0_2
INTC2.ICTAPA0IPEK0_2.BIT.P1TAPA0IPEK0_2
INTC2.ICTAPA0IPEK0_2.BIT.P2TAPA0IPEK0_2
INTC2.ICTAPA0IPEK0_2.BIT.P3TAPA0IPEK0_2
INTC2.ICTAPA0IPEK0_2.BIT.TBTAPA0IPEK0_2
INTC2.ICTAPA0IPEK0_2.BIT.MKTAPA0IPEK0_2
INTC2.ICTAPA0IPEK0_2.BIT.RFTAPA0IPEK0_2
INTC2.ICTAPA0IPEK0_2.BIT.CTTAPA0IPEK0_2
INTC2.ICTAPA0IVLY0_2.UINT16
INTC2.ICTAPA0IVLY0_2.UINT8[L/H]
INTC2.ICTAPA0IVLY0_2.BIT.P0TAPA0IVLY0_2
INTC2.ICTAPA0IVLY0_2.BIT.P1TAPA0IVLY0_2
INTC2.ICTAPA0IVLY0_2.BIT.P2TAPA0IVLY0_2
INTC2.ICTAPA0IVLY0_2.BIT.P3TAPA0IVLY0_2
INTC2.ICTAPA0IVLY0_2.BIT.TBTAPA0IVLY0_2
INTC2.ICTAPA0IVLY0_2.BIT.MKTAPA0IVLY0_2
INTC2.ICTAPA0IVLY0_2.BIT.RFTAPA0IVLY0_2
INTC2.ICTAPA0IVLY0_2.BIT.CTTAPA0IVLY0_2
INTC2.ICCSIG0IC_2.UINT16
INTC2.ICCSIG0IC_2.UINT8[L/H]
INTC2.ICCSIG0IC_2.BIT.P0CSIG0IC_2
INTC2.ICCSIG0IC_2.BIT.P1CSIG0IC_2
INTC2.ICCSIG0IC_2.BIT.P2CSIG0IC_2
INTC2.ICCSIG0IC_2.BIT.P3CSIG0IC_2
INTC2.ICCSIG0IC_2.BIT.TBCSIG0IC_2
INTC2.ICCSIG0IC_2.BIT.MKCSIG0IC_2
INTC2.ICCSIG0IC_2.BIT.RFCSIG0IC_2
INTC2.ICCSIG0IC_2.BIT.CTCSIG0IC_2
INTC2.ICCSIG0IR_2.UINT16
INTC2.ICCSIG0IR_2.UINT8[L/H]
INTC2.ICCSIG0IR_2.BIT.P0CSIG0IR_2
INTC2.ICCSIG0IR_2.BIT.P1CSIG0IR_2
INTC2.ICCSIG0IR_2.BIT.P2CSIG0IR_2
INTC2.ICCSIG0IR_2.BIT.P3CSIG0IR_2
INTC2.ICCSIG0IR_2.BIT.TBCSIG0IR_2
INTC2.ICCSIG0IR_2.BIT.MKCSIG0IR_2
INTC2.ICCSIG0IR_2.BIT.RFCSIG0IR_2
INTC2.ICCSIG0IR_2.BIT.CTCSIG0IR_2
INTC2.ICRLIN31.UINT16
INTC2.ICRLIN31.UINT8[L/H]
INTC2.ICRLIN31.BIT.P0RLIN31
INTC2.ICRLIN31.BIT.P1RLIN31
INTC2.ICRLIN31.BIT.P2RLIN31
INTC2.ICRLIN31.BIT.P3RLIN31
INTC2.ICRLIN31.BIT.TBRLIN31
INTC2.ICRLIN31.BIT.MKRLIN31
INTC2.ICRLIN31.BIT.RFRLIN31
INTC2.ICRLIN31.BIT.CTRLIN31
INTC2.ICRLIN31UR0.UINT16
INTC2.ICRLIN31UR0.UINT8[L/H]
INTC2.ICRLIN31UR0.BIT.P0RLIN31UR0
INTC2.ICRLIN31UR0.BIT.P1RLIN31UR0
INTC2.ICRLIN31UR0.BIT.P2RLIN31UR0
INTC2.ICRLIN31UR0.BIT.P3RLIN31UR0
INTC2.ICRLIN31UR0.BIT.TBRLIN31UR0
INTC2.ICRLIN31UR0.BIT.MKRLIN31UR0
INTC2.ICRLIN31UR0.BIT.RFRLIN31UR0
INTC2.ICRLIN31UR0.BIT.CTRLIN31UR0
INTC2.ICRLIN31UR1.UINT16
INTC2.ICRLIN31UR1.UINT8[L/H]
INTC2.ICRLIN31UR1.BIT.P0RLIN31UR1
INTC2.ICRLIN31UR1.BIT.P1RLIN31UR1
INTC2.ICRLIN31UR1.BIT.P2RLIN31UR1
INTC2.ICRLIN31UR1.BIT.P3RLIN31UR1
INTC2.ICRLIN31UR1.BIT.TBRLIN31UR1
INTC2.ICRLIN31UR1.BIT.MKRLIN31UR1
INTC2.ICRLIN31UR1.BIT.RFRLIN31UR1
INTC2.ICRLIN31UR1.BIT.CTRLIN31UR1
INTC2.ICRLIN31UR2.UINT16
INTC2.ICRLIN31UR2.UINT8[L/H]
INTC2.ICRLIN31UR2.BIT.P0RLIN31UR2
INTC2.ICRLIN31UR2.BIT.P1RLIN31UR2
INTC2.ICRLIN31UR2.BIT.P2RLIN31UR2
INTC2.ICRLIN31UR2.BIT.P3RLIN31UR2
INTC2.ICRLIN31UR2.BIT.TBRLIN31UR2
INTC2.ICRLIN31UR2.BIT.MKRLIN31UR2
INTC2.ICRLIN31UR2.BIT.RFRLIN31UR2
INTC2.ICRLIN31UR2.BIT.CTRLIN31UR2
INTC2.ICTAUD0I0_2.UINT16
INTC2.ICTAUD0I0_2.UINT8[L/H]
INTC2.ICTAUD0I0_2.BIT.P0TAUD0I0_2
INTC2.ICTAUD0I0_2.BIT.P1TAUD0I0_2
INTC2.ICTAUD0I0_2.BIT.P2TAUD0I0_2
INTC2.ICTAUD0I0_2.BIT.P3TAUD0I0_2
INTC2.ICTAUD0I0_2.BIT.TBTAUD0I0_2
INTC2.ICTAUD0I0_2.BIT.MKTAUD0I0_2
INTC2.ICTAUD0I0_2.BIT.RFTAUD0I0_2
INTC2.ICTAUD0I0_2.BIT.CTTAUD0I0_2
INTC2.ICTAUD0I4_2.UINT16
INTC2.ICTAUD0I4_2.UINT8[L/H]
INTC2.ICTAUD0I4_2.BIT.P0TAUD0I4_2
INTC2.ICTAUD0I4_2.BIT.P1TAUD0I4_2
INTC2.ICTAUD0I4_2.BIT.P2TAUD0I4_2
INTC2.ICTAUD0I4_2.BIT.P3TAUD0I4_2
INTC2.ICTAUD0I4_2.BIT.TBTAUD0I4_2
INTC2.ICTAUD0I4_2.BIT.MKTAUD0I4_2
INTC2.ICTAUD0I4_2.BIT.RFTAUD0I4_2
INTC2.ICTAUD0I4_2.BIT.CTTAUD0I4_2
INTC2.ICTAUD0I6_2.UINT16
INTC2.ICTAUD0I6_2.UINT8[L/H]
INTC2.ICTAUD0I6_2.BIT.P0TAUD0I6_2
INTC2.ICTAUD0I6_2.BIT.P1TAUD0I6_2
INTC2.ICTAUD0I6_2.BIT.P2TAUD0I6_2
INTC2.ICTAUD0I6_2.BIT.P3TAUD0I6_2
INTC2.ICTAUD0I6_2.BIT.TBTAUD0I6_2
INTC2.ICTAUD0I6_2.BIT.MKTAUD0I6_2
INTC2.ICTAUD0I6_2.BIT.RFTAUD0I6_2
INTC2.ICTAUD0I6_2.BIT.CTTAUD0I6_2
INTC2.ICTAUD0I8_2.UINT16
INTC2.ICTAUD0I8_2.UINT8[L/H]
INTC2.ICTAUD0I8_2.BIT.P0TAUD0I8_2
INTC2.ICTAUD0I8_2.BIT.P1TAUD0I8_2
INTC2.ICTAUD0I8_2.BIT.P2TAUD0I8_2
INTC2.ICTAUD0I8_2.BIT.P3TAUD0I8_2
INTC2.ICTAUD0I8_2.BIT.TBTAUD0I8_2
INTC2.ICTAUD0I8_2.BIT.MKTAUD0I8_2
INTC2.ICTAUD0I8_2.BIT.RFTAUD0I8_2
INTC2.ICTAUD0I8_2.BIT.CTTAUD0I8_2
INTC2.ICTAUD0I2_2.UINT16
INTC2.ICTAUD0I2_2.UINT8[L/H]
INTC2.ICTAUD0I2_2.BIT.P0TAUD0I2_2
INTC2.ICTAUD0I2_2.BIT.P1TAUD0I2_2
INTC2.ICTAUD0I2_2.BIT.P2TAUD0I2_2
INTC2.ICTAUD0I2_2.BIT.P3TAUD0I2_2
INTC2.ICTAUD0I2_2.BIT.TBTAUD0I2_2
INTC2.ICTAUD0I2_2.BIT.MKTAUD0I2_2
INTC2.ICTAUD0I2_2.BIT.RFTAUD0I2_2
INTC2.ICTAUD0I2_2.BIT.CTTAUD0I2_2
INTC2.ICTAUD0I10_2.UINT16
INTC2.ICTAUD0I10_2.UINT8[L/H]
INTC2.ICTAUD0I10_2.BIT.P0TAUD0I10_2
INTC2.ICTAUD0I10_2.BIT.P1TAUD0I10_2
INTC2.ICTAUD0I10_2.BIT.P2TAUD0I10_2
INTC2.ICTAUD0I10_2.BIT.P3TAUD0I10_2
INTC2.ICTAUD0I10_2.BIT.TBTAUD0I10_2
INTC2.ICTAUD0I10_2.BIT.MKTAUD0I10_2
INTC2.ICTAUD0I10_2.BIT.RFTAUD0I10_2
INTC2.ICTAUD0I10_2.BIT.CTTAUD0I10_2
INTC2.ICTAUD0I12_2.UINT16
INTC2.ICTAUD0I12_2.UINT8[L/H]
INTC2.ICTAUD0I12_2.BIT.P0TAUD0I12_2
INTC2.ICTAUD0I12_2.BIT.P1TAUD0I12_2
INTC2.ICTAUD0I12_2.BIT.P2TAUD0I12_2
INTC2.ICTAUD0I12_2.BIT.P3TAUD0I12_2
INTC2.ICTAUD0I12_2.BIT.TBTAUD0I12_2
INTC2.ICTAUD0I12_2.BIT.MKTAUD0I12_2
INTC2.ICTAUD0I12_2.BIT.RFTAUD0I12_2
INTC2.ICTAUD0I12_2.BIT.CTTAUD0I12_2
INTC2.ICTAUD0I14_2.UINT16
INTC2.ICTAUD0I14_2.UINT8[L/H]
INTC2.ICTAUD0I14_2.BIT.P0TAUD0I14_2
INTC2.ICTAUD0I14_2.BIT.P1TAUD0I14_2
INTC2.ICTAUD0I14_2.BIT.P2TAUD0I14_2
INTC2.ICTAUD0I14_2.BIT.P3TAUD0I14_2
INTC2.ICTAUD0I14_2.BIT.TBTAUD0I14_2
INTC2.ICTAUD0I14_2.BIT.MKTAUD0I14_2
INTC2.ICTAUD0I14_2.BIT.RFTAUD0I14_2
INTC2.ICTAUD0I14_2.BIT.CTTAUD0I14_2
INTC2.ICTAUJ1I0.UINT16
INTC2.ICTAUJ1I0.UINT8[L/H]
INTC2.ICTAUJ1I0.BIT.P0TAUJ1I0
INTC2.ICTAUJ1I0.BIT.P1TAUJ1I0
INTC2.ICTAUJ1I0.BIT.P2TAUJ1I0
INTC2.ICTAUJ1I0.BIT.P3TAUJ1I0
INTC2.ICTAUJ1I0.BIT.TBTAUJ1I0
INTC2.ICTAUJ1I0.BIT.MKTAUJ1I0
INTC2.ICTAUJ1I0.BIT.RFTAUJ1I0
INTC2.ICTAUJ1I0.BIT.CTTAUJ1I0
INTC2.ICTAUJ1I1.UINT16
INTC2.ICTAUJ1I1.UINT8[L/H]
INTC2.ICTAUJ1I1.BIT.P0TAUJ1I1
INTC2.ICTAUJ1I1.BIT.P1TAUJ1I1
INTC2.ICTAUJ1I1.BIT.P2TAUJ1I1
INTC2.ICTAUJ1I1.BIT.P3TAUJ1I1
INTC2.ICTAUJ1I1.BIT.TBTAUJ1I1
INTC2.ICTAUJ1I1.BIT.MKTAUJ1I1
INTC2.ICTAUJ1I1.BIT.RFTAUJ1I1
INTC2.ICTAUJ1I1.BIT.CTTAUJ1I1
INTC2.ICTAUJ1I2.UINT16
INTC2.ICTAUJ1I2.UINT8[L/H]
INTC2.ICTAUJ1I2.BIT.P0TAUJ1I2
INTC2.ICTAUJ1I2.BIT.P1TAUJ1I2
INTC2.ICTAUJ1I2.BIT.P2TAUJ1I2
INTC2.ICTAUJ1I2.BIT.P3TAUJ1I2
INTC2.ICTAUJ1I2.BIT.TBTAUJ1I2
INTC2.ICTAUJ1I2.BIT.MKTAUJ1I2
INTC2.ICTAUJ1I2.BIT.RFTAUJ1I2
INTC2.ICTAUJ1I2.BIT.CTTAUJ1I2
INTC2.ICTAUJ1I3.UINT16
INTC2.ICTAUJ1I3.UINT8[L/H]
INTC2.ICTAUJ1I3.BIT.P0TAUJ1I3
INTC2.ICTAUJ1I3.BIT.P1TAUJ1I3
INTC2.ICTAUJ1I3.BIT.P2TAUJ1I3
INTC2.ICTAUJ1I3.BIT.P3TAUJ1I3
INTC2.ICTAUJ1I3.BIT.TBTAUJ1I3
INTC2.ICTAUJ1I3.BIT.MKTAUJ1I3
INTC2.ICTAUJ1I3.BIT.RFTAUJ1I3
INTC2.ICTAUJ1I3.BIT.CTTAUJ1I3
INTC2.ICRTCA01S.UINT16
INTC2.ICRTCA01S.UINT8[L/H]
INTC2.ICRTCA01S.BIT.P0RTCA01S
INTC2.ICRTCA01S.BIT.P1RTCA01S
INTC2.ICRTCA01S.BIT.P2RTCA01S
INTC2.ICRTCA01S.BIT.P3RTCA01S
INTC2.ICRTCA01S.BIT.TBRTCA01S
INTC2.ICRTCA01S.BIT.MKRTCA01S
INTC2.ICRTCA01S.BIT.RFRTCA01S
INTC2.ICRTCA01S.BIT.CTRTCA01S
INTC2.ICRTCA0AL.UINT16
INTC2.ICRTCA0AL.UINT8[L/H]
INTC2.ICRTCA0AL.BIT.P0RTCA0AL
INTC2.ICRTCA0AL.BIT.P1RTCA0AL
INTC2.ICRTCA0AL.BIT.P2RTCA0AL
INTC2.ICRTCA0AL.BIT.P3RTCA0AL
INTC2.ICRTCA0AL.BIT.TBRTCA0AL
INTC2.ICRTCA0AL.BIT.MKRTCA0AL
INTC2.ICRTCA0AL.BIT.RFRTCA0AL
INTC2.ICRTCA0AL.BIT.CTRTCA0AL
INTC2.ICRTCA0R.UINT16
INTC2.ICRTCA0R.UINT8[L/H]
INTC2.ICRTCA0R.BIT.P0RTCA0R
INTC2.ICRTCA0R.BIT.P1RTCA0R
INTC2.ICRTCA0R.BIT.P2RTCA0R
INTC2.ICRTCA0R.BIT.P3RTCA0R
INTC2.ICRTCA0R.BIT.TBRTCA0R
INTC2.ICRTCA0R.BIT.MKRTCA0R
INTC2.ICRTCA0R.BIT.RFRTCA0R
INTC2.ICRTCA0R.BIT.CTRTCA0R
INTC2.ICRCAN2ERR.UINT16
INTC2.ICRCAN2ERR.UINT8[L/H]
INTC2.ICRCAN2ERR.BIT.P0RCAN2ERR
INTC2.ICRCAN2ERR.BIT.P1RCAN2ERR
INTC2.ICRCAN2ERR.BIT.P2RCAN2ERR
INTC2.ICRCAN2ERR.BIT.P3RCAN2ERR
INTC2.ICRCAN2ERR.BIT.TBRCAN2ERR
INTC2.ICRCAN2ERR.BIT.MKRCAN2ERR
INTC2.ICRCAN2ERR.BIT.RFRCAN2ERR
INTC2.ICRCAN2ERR.BIT.CTRCAN2ERR
INTC2.ICRCAN2REC.UINT16
INTC2.ICRCAN2REC.UINT8[L/H]
INTC2.ICRCAN2REC.BIT.P0RCAN2REC
INTC2.ICRCAN2REC.BIT.P1RCAN2REC
INTC2.ICRCAN2REC.BIT.P2RCAN2REC
INTC2.ICRCAN2REC.BIT.P3RCAN2REC
INTC2.ICRCAN2REC.BIT.TBRCAN2REC
INTC2.ICRCAN2REC.BIT.MKRCAN2REC
INTC2.ICRCAN2REC.BIT.RFRCAN2REC
INTC2.ICRCAN2REC.BIT.CTRCAN2REC
INTC2.ICRCAN2TRX.UINT16
INTC2.ICRCAN2TRX.UINT8[L/H]
INTC2.ICRCAN2TRX.BIT.P0RCAN2TRX
INTC2.ICRCAN2TRX.BIT.P1RCAN2TRX
INTC2.ICRCAN2TRX.BIT.P2RCAN2TRX
INTC2.ICRCAN2TRX.BIT.P3RCAN2TRX
INTC2.ICRCAN2TRX.BIT.TBRCAN2TRX
INTC2.ICRCAN2TRX.BIT.MKRCAN2TRX
INTC2.ICRCAN2TRX.BIT.RFRCAN2TRX
INTC2.ICRCAN2TRX.BIT.CTRCAN2TRX
INTC2.ICRIIC1TI.UINT16
INTC2.ICRIIC1TI.UINT8[L/H]
INTC2.ICRIIC1TI.BIT.P0RIIC1TI
INTC2.ICRIIC1TI.BIT.P1RIIC1TI
INTC2.ICRIIC1TI.BIT.P2RIIC1TI
INTC2.ICRIIC1TI.BIT.P3RIIC1TI
INTC2.ICRIIC1TI.BIT.TBRIIC1TI
INTC2.ICRIIC1TI.BIT.MKRIIC1TI
INTC2.ICRIIC1TI.BIT.RFRIIC1TI
INTC2.ICRIIC1TI.BIT.CTRIIC1TI
INTC2.ICRIIC1EE.UINT16
INTC2.ICRIIC1EE.UINT8[L/H]
INTC2.ICRIIC1EE.BIT.P0RIIC1EE
INTC2.ICRIIC1EE.BIT.P1RIIC1EE
INTC2.ICRIIC1EE.BIT.P2RIIC1EE
INTC2.ICRIIC1EE.BIT.P3RIIC1EE
INTC2.ICRIIC1EE.BIT.TBRIIC1EE
INTC2.ICRIIC1EE.BIT.MKRIIC1EE
INTC2.ICRIIC1EE.BIT.RFRIIC1EE
INTC2.ICRIIC1EE.BIT.CTRIIC1EE
INTC2.ICRIIC1RI.UINT16
INTC2.ICRIIC1RI.UINT8[L/H]
INTC2.ICRIIC1RI.BIT.P0RIIC1RI
INTC2.ICRIIC1RI.BIT.P1RIIC1RI
INTC2.ICRIIC1RI.BIT.P2RIIC1RI
INTC2.ICRIIC1RI.BIT.P3RIIC1RI
INTC2.ICRIIC1RI.BIT.TBRIIC1RI
INTC2.ICRIIC1RI.BIT.MKRIIC1RI
INTC2.ICRIIC1RI.BIT.RFRIIC1RI
INTC2.ICRIIC1RI.BIT.CTRIIC1RI
INTC2.ICRIIC1TEI.UINT16
INTC2.ICRIIC1TEI.UINT8[L/H]
INTC2.ICRIIC1TEI.BIT.P0RIIC1TEI
INTC2.ICRIIC1TEI.BIT.P1RIIC1TEI
INTC2.ICRIIC1TEI.BIT.P2RIIC1TEI
INTC2.ICRIIC1TEI.BIT.P3RIIC1TEI
INTC2.ICRIIC1TEI.BIT.TBRIIC1TEI
INTC2.ICRIIC1TEI.BIT.MKRIIC1TEI
INTC2.ICRIIC1TEI.BIT.RFRIIC1TEI
INTC2.ICRIIC1TEI.BIT.CTRIIC1TEI
INTC2.ICTAUJ2I0.UINT16
INTC2.ICTAUJ2I0.UINT8[L/H]
INTC2.ICTAUJ2I0.BIT.P0TAUJ2I0
INTC2.ICTAUJ2I0.BIT.P1TAUJ2I0
INTC2.ICTAUJ2I0.BIT.P2TAUJ2I0
INTC2.ICTAUJ2I0.BIT.P3TAUJ2I0
INTC2.ICTAUJ2I0.BIT.TBTAUJ2I0
INTC2.ICTAUJ2I0.BIT.MKTAUJ2I0
INTC2.ICTAUJ2I0.BIT.RFTAUJ2I0
INTC2.ICTAUJ2I0.BIT.CTTAUJ2I0
INTC2.ICTAUJ2I1.UINT16
INTC2.ICTAUJ2I1.UINT8[L/H]
INTC2.ICTAUJ2I1.BIT.P0TAUJ2I1
INTC2.ICTAUJ2I1.BIT.P1TAUJ2I1
INTC2.ICTAUJ2I1.BIT.P2TAUJ2I1
INTC2.ICTAUJ2I1.BIT.P3TAUJ2I1
INTC2.ICTAUJ2I1.BIT.TBTAUJ2I1
INTC2.ICTAUJ2I1.BIT.MKTAUJ2I1
INTC2.ICTAUJ2I1.BIT.RFTAUJ2I1
INTC2.ICTAUJ2I1.BIT.CTTAUJ2I1
INTC2.ICTAUJ2I2.UINT16
INTC2.ICTAUJ2I2.UINT8[L/H]
INTC2.ICTAUJ2I2.BIT.P0TAUJ2I2
INTC2.ICTAUJ2I2.BIT.P1TAUJ2I2
INTC2.ICTAUJ2I2.BIT.P2TAUJ2I2
INTC2.ICTAUJ2I2.BIT.P3TAUJ2I2
INTC2.ICTAUJ2I2.BIT.TBTAUJ2I2
INTC2.ICTAUJ2I2.BIT.MKTAUJ2I2
INTC2.ICTAUJ2I2.BIT.RFTAUJ2I2
INTC2.ICTAUJ2I2.BIT.CTTAUJ2I2
INTC2.ICTAUJ2I3.UINT16
INTC2.ICTAUJ2I3.UINT8[L/H]
INTC2.ICTAUJ2I3.BIT.P0TAUJ2I3
INTC2.ICTAUJ2I3.BIT.P1TAUJ2I3
INTC2.ICTAUJ2I3.BIT.P2TAUJ2I3
INTC2.ICTAUJ2I3.BIT.P3TAUJ2I3
INTC2.ICTAUJ2I3.BIT.TBTAUJ2I3
INTC2.ICTAUJ2I3.BIT.MKTAUJ2I3
INTC2.ICTAUJ2I3.BIT.RFTAUJ2I3
INTC2.ICTAUJ2I3.BIT.CTTAUJ2I3
INTC2.ICTAUJ3I0.UINT16
INTC2.ICTAUJ3I0.UINT8[L/H]
INTC2.ICTAUJ3I0.BIT.P0TAUJ3I0
INTC2.ICTAUJ3I0.BIT.P1TAUJ3I0
INTC2.ICTAUJ3I0.BIT.P2TAUJ3I0
INTC2.ICTAUJ3I0.BIT.P3TAUJ3I0
INTC2.ICTAUJ3I0.BIT.TBTAUJ3I0
INTC2.ICTAUJ3I0.BIT.MKTAUJ3I0
INTC2.ICTAUJ3I0.BIT.RFTAUJ3I0
INTC2.ICTAUJ3I0.BIT.CTTAUJ3I0
INTC2.ICTAUJ3I1.UINT16
INTC2.ICTAUJ3I1.UINT8[L/H]
INTC2.ICTAUJ3I1.BIT.P0TAUJ3I1
INTC2.ICTAUJ3I1.BIT.P1TAUJ3I1
INTC2.ICTAUJ3I1.BIT.P2TAUJ3I1
INTC2.ICTAUJ3I1.BIT.P3TAUJ3I1
INTC2.ICTAUJ3I1.BIT.TBTAUJ3I1
INTC2.ICTAUJ3I1.BIT.MKTAUJ3I1
INTC2.ICTAUJ3I1.BIT.RFTAUJ3I1
INTC2.ICTAUJ3I1.BIT.CTTAUJ3I1
INTC2.ICTAUJ3I2.UINT16
INTC2.ICTAUJ3I2.UINT8[L/H]
INTC2.ICTAUJ3I2.BIT.P0TAUJ3I2
INTC2.ICTAUJ3I2.BIT.P1TAUJ3I2
INTC2.ICTAUJ3I2.BIT.P2TAUJ3I2
INTC2.ICTAUJ3I2.BIT.P3TAUJ3I2
INTC2.ICTAUJ3I2.BIT.TBTAUJ3I2
INTC2.ICTAUJ3I2.BIT.MKTAUJ3I2
INTC2.ICTAUJ3I2.BIT.RFTAUJ3I2
INTC2.ICTAUJ3I2.BIT.CTTAUJ3I2
INTC2.ICTAUJ3I3.UINT16
INTC2.ICTAUJ3I3.UINT8[L/H]
INTC2.ICTAUJ3I3.BIT.P0TAUJ3I3
INTC2.ICTAUJ3I3.BIT.P1TAUJ3I3
INTC2.ICTAUJ3I3.BIT.P2TAUJ3I3
INTC2.ICTAUJ3I3.BIT.P3TAUJ3I3
INTC2.ICTAUJ3I3.BIT.TBTAUJ3I3
INTC2.ICTAUJ3I3.BIT.MKTAUJ3I3
INTC2.ICTAUJ3I3.BIT.RFTAUJ3I3
INTC2.ICTAUJ3I3.BIT.CTTAUJ3I3
INTC2.ICSENT0SI.UINT16
INTC2.ICSENT0SI.UINT8[L/H]
INTC2.ICSENT0SI.BIT.P0SENT0SI
INTC2.ICSENT0SI.BIT.P1SENT0SI
INTC2.ICSENT0SI.BIT.P2SENT0SI
INTC2.ICSENT0SI.BIT.P3SENT0SI
INTC2.ICSENT0SI.BIT.TBSENT0SI
INTC2.ICSENT0SI.BIT.MKSENT0SI
INTC2.ICSENT0SI.BIT.RFSENT0SI
INTC2.ICSENT0SI.BIT.CTSENT0SI
INTC2.ICSENT0RI.UINT16
INTC2.ICSENT0RI.UINT8[L/H]
INTC2.ICSENT0RI.BIT.P0SENT0RI
INTC2.ICSENT0RI.BIT.P1SENT0RI
INTC2.ICSENT0RI.BIT.P2SENT0RI
INTC2.ICSENT0RI.BIT.P3SENT0RI
INTC2.ICSENT0RI.BIT.TBSENT0RI
INTC2.ICSENT0RI.BIT.MKSENT0RI
INTC2.ICSENT0RI.BIT.RFSENT0RI
INTC2.ICSENT0RI.BIT.CTSENT0RI
INTC2.ICSENT1SI.UINT16
INTC2.ICSENT1SI.UINT8[L/H]
INTC2.ICSENT1SI.BIT.P0SENT1SI
INTC2.ICSENT1SI.BIT.P1SENT1SI
INTC2.ICSENT1SI.BIT.P2SENT1SI
INTC2.ICSENT1SI.BIT.P3SENT1SI
INTC2.ICSENT1SI.BIT.TBSENT1SI
INTC2.ICSENT1SI.BIT.MKSENT1SI
INTC2.ICSENT1SI.BIT.RFSENT1SI
INTC2.ICSENT1SI.BIT.CTSENT1SI
INTC2.ICSENT1RI.UINT16
INTC2.ICSENT1RI.UINT8[L/H]
INTC2.ICSENT1RI.BIT.P0SENT1RI
INTC2.ICSENT1RI.BIT.P1SENT1RI
INTC2.ICSENT1RI.BIT.P2SENT1RI
INTC2.ICSENT1RI.BIT.P3SENT1RI
INTC2.ICSENT1RI.BIT.TBSENT1RI
INTC2.ICSENT1RI.BIT.MKSENT1RI
INTC2.ICSENT1RI.BIT.RFSENT1RI
INTC2.ICSENT1RI.BIT.CTSENT1RI
INTC2.ICDPE.UINT16
INTC2.ICDPE.UINT8[L/H]
INTC2.ICDPE.BIT.P0DPE
INTC2.ICDPE.BIT.P1DPE
INTC2.ICDPE.BIT.P2DPE
INTC2.ICDPE.BIT.P3DPE
INTC2.ICDPE.BIT.TBDPE
INTC2.ICDPE.BIT.MKDPE
INTC2.ICDPE.BIT.RFDPE
INTC2.ICDPE.BIT.CTDPE
INTC2.ICAPE.UINT16
INTC2.ICAPE.UINT8[L/H]
INTC2.ICAPE.BIT.P0APE
INTC2.ICAPE.BIT.P1APE
INTC2.ICAPE.BIT.P2APE
INTC2.ICAPE.BIT.P3APE
INTC2.ICAPE.BIT.TBAPE
INTC2.ICAPE.BIT.MKAPE
INTC2.ICAPE.BIT.RFAPE
INTC2.ICAPE.BIT.CTAPE
INTC2.IMR1.UINT32
INTC2.IMR1.UINT16[L/H]
INTC2.IMR1.UINT8[LL/LH/HL/HH]
INTC2.IMR1.BIT.IMR1EIMK32 ... INTC2.IMR1.BIT.IMR1EIMK41
INTC2.IMR1.BIT.IMR1EIMK43 ... INTC2.IMR1.BIT.IMR1EIMK63
INTC2.IMR2.UINT32
INTC2.IMR2.UINT16[L/H]
INTC2.IMR2.UINT8[LL/LH/HL/HH]
INTC2.IMR2.BIT.IMR2EIMK64 ... INTC2.IMR2.BIT.IMR2EIMK92
INTC2.IMR3.UINT32
INTC2.IMR3.UINT16[L/H]
INTC2.IMR3.UINT8[LH/HL/HH]
INTC2.IMR3.BIT.IMR3EIMK110 ... INTC2.IMR3.BIT.IMR3EIMK123
INTC2.IMR4.UINT32
INTC2.IMR4.UINT16[L/H]
INTC2.IMR4.UINT8[LL/HH]
INTC2.IMR4.BIT.IMR4EIMK132 ... INTC2.IMR4.BIT.IMR4EIMK135
INTC2.IMR4.BIT.IMR4EIMK158
INTC2.IMR4.BIT.IMR4EIMK159
INTC2.IMR5.UINT32
INTC2.IMR5.UINT16[L]
INTC2.IMR5.UINT8[LL/LH]
INTC2.IMR5.BIT.IMR5EIMK160
INTC2.IMR5.BIT.IMR5EIMK161
INTC2.IMR5.BIT.IMR5EIMK168 ... INTC2.IMR5.BIT.IMR5EIMK171
INTC2.IMR6.UINT32
INTC2.IMR6.UINT16[H]
INTC2.IMR6.UINT8[HL/HH]
INTC2.IMR6.BIT.IMR6EIMK209 ... INTC2.IMR6.BIT.IMR6EIMK211
INTC2.IMR6.BIT.IMR6EIMK217 ... INTC2.IMR6.BIT.IMR6EIMK219
INTC2.IMR7.UINT32
INTC2.IMR7.UINT16[H]
INTC2.IMR7.UINT8[HL]
INTC2.IMR7.BIT.IMR7EIMK240 ... INTC2.IMR7.BIT.IMR7EIMK243
INTC2.IMR8.UINT32
INTC2.IMR8.UINT16[H]
INTC2.IMR8.UINT8[HL/HH]
INTC2.IMR8.BIT.IMR8EIMK277 ... INTC2.IMR8.BIT.IMR8EIMK284
INTC2.IMR10.UINT32
INTC2.IMR10.UINT16[H]
INTC2.IMR10.UINT8[HH]
INTC2.IMR10.BIT.IMR10EIMK347 ... INTC2.IMR10.BIT.IMR10EIMK350
INTC2.IMR11.UINT32
INTC2.IMR11.UINT16[L]
INTC2.IMR11.UINT8[LL]
INTC2.IMR11.BIT.IMR11EIMK356
INTC2.IMR11.BIT.IMR11EIMK357
*/
#endif
